/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the X86 target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 150;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(X86InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(X86InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static X86InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static X86InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s1,
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s80,
  GILLT_s128,
  GILLT_v2s1,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s16,
  GILLT_v8s32,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
  GILLT_v16s16,
  GILLT_v16s32,
  GILLT_v32s1,
  GILLT_v32s8,
  GILLT_v32s16,
  GILLT_v64s1,
  GILLT_v64s8,
};
const static size_t NumTypeObjects = 25;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(80),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 32),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getFixed(16), 16),
  LLT::vector(ElementCount::getFixed(16), 32),
  LLT::vector(ElementCount::getFixed(32), 1),
  LLT::vector(ElementCount::getFixed(32), 8),
  LLT::vector(ElementCount::getFixed(32), 16),
  LLT::vector(ElementCount::getFixed(64), 1),
  LLT::vector(ElementCount::getFixed(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_TruePredicateBit = 61,
  Feature_HasEGPRBit = 5,
  Feature_NoEGPRBit = 4,
  Feature_HasNDDBit = 6,
  Feature_NoNDDBit = 27,
  Feature_HasZUBit = 149,
  Feature_HasCFBit = 30,
  Feature_HasCMOVBit = 29,
  Feature_NoCMOVBit = 135,
  Feature_HasMMXBit = 107,
  Feature_HasSSE1Bit = 47,
  Feature_UseSSE1Bit = 54,
  Feature_HasSSE2Bit = 46,
  Feature_UseSSE2Bit = 55,
  Feature_HasSSE3Bit = 38,
  Feature_UseSSE3Bit = 64,
  Feature_HasSSSE3Bit = 108,
  Feature_UseSSSE3Bit = 65,
  Feature_UseSSE41Bit = 62,
  Feature_UseSSE42Bit = 69,
  Feature_HasSSE4ABit = 79,
  Feature_NoAVXBit = 75,
  Feature_HasAVXBit = 56,
  Feature_HasAVX2Bit = 50,
  Feature_HasAVX1OnlyBit = 48,
  Feature_HasEVEX512Bit = 142,
  Feature_HasAVX10_2Bit = 106,
  Feature_HasAVX10_2_512Bit = 105,
  Feature_NoAVX10_2Bit = 68,
  Feature_HasAVX512Bit = 92,
  Feature_UseAVXBit = 52,
  Feature_NoAVX512Bit = 43,
  Feature_HasCDIBit = 96,
  Feature_HasVPOPCNTDQBit = 100,
  Feature_HasDQIBit = 94,
  Feature_NoDQIBit = 66,
  Feature_HasBWIBit = 95,
  Feature_NoBWIBit = 63,
  Feature_HasVLXBit = 93,
  Feature_NoVLXBit = 42,
  Feature_NoVLX_Or_NoBWIBit = 60,
  Feature_HasVNNIBit = 102,
  Feature_HasVP2INTERSECTBit = 104,
  Feature_HasFP16Bit = 98,
  Feature_HasAVXVNNIINT16Bit = 91,
  Feature_HasAVXVNNIINT8Bit = 86,
  Feature_HasAVXVNNIBit = 80,
  Feature_NoVLX_Or_NoVNNIBit = 81,
  Feature_HasBITALGBit = 103,
  Feature_HasPOPCNTBit = 67,
  Feature_HasAESBit = 72,
  Feature_HasVAESBit = 74,
  Feature_NoVLX_Or_NoVAESBit = 73,
  Feature_HasFXSRBit = 39,
  Feature_HasX87Bit = 37,
  Feature_HasXSAVEBit = 124,
  Feature_HasXSAVEOPTBit = 125,
  Feature_HasXSAVECBit = 126,
  Feature_HasXSAVESBit = 127,
  Feature_HasPCLMULBit = 76,
  Feature_NoVLX_Or_NoVPCLMULQDQBit = 77,
  Feature_HasVPCLMULQDQBit = 78,
  Feature_HasGFNIBit = 83,
  Feature_HasFMABit = 40,
  Feature_HasFMA4Bit = 44,
  Feature_NoFMA4Bit = 41,
  Feature_HasXOPBit = 45,
  Feature_HasTBMBit = 26,
  Feature_NoTBMBit = 140,
  Feature_HasLWPBit = 12,
  Feature_HasMOVBEBit = 3,
  Feature_NoNDD_Or_NoMOVBEBit = 2,
  Feature_HasRDRANDBit = 7,
  Feature_HasF16CBit = 82,
  Feature_HasFSGSBaseBit = 128,
  Feature_HasLZCNTBit = 9,
  Feature_HasBMIBit = 10,
  Feature_HasBMI2Bit = 11,
  Feature_NoBMI2Bit = 139,
  Feature_HasVBMIBit = 97,
  Feature_HasVBMI2Bit = 101,
  Feature_HasIFMABit = 99,
  Feature_HasAVXIFMABit = 84,
  Feature_NoVLX_Or_NoIFMABit = 85,
  Feature_HasRTMBit = 110,
  Feature_HasSHABit = 71,
  Feature_HasSHA512Bit = 88,
  Feature_HasSM3Bit = 89,
  Feature_HasRDSEEDBit = 8,
  Feature_HasSSEPrefetchBit = 57,
  Feature_HasPREFETCHIBit = 20,
  Feature_HasPrefetchWBit = 109,
  Feature_HasMWAITXBit = 138,
  Feature_HasCLDEMOTEBit = 24,
  Feature_HasMOVDIRIBit = 14,
  Feature_HasMOVDIR64BBit = 15,
  Feature_HasMOVRSBit = 25,
  Feature_HasPTWRITEBit = 131,
  Feature_FPStackf32Bit = 35,
  Feature_FPStackf64Bit = 36,
  Feature_HasSM4Bit = 90,
  Feature_HasCLFLUSHBit = 58,
  Feature_HasCLFLUSHOPTBit = 22,
  Feature_HasCLWBBit = 23,
  Feature_HasWBNOINVDBit = 123,
  Feature_HasRDPIDBit = 130,
  Feature_HasWAITPKGBit = 13,
  Feature_HasINVPCIDBit = 129,
  Feature_HasCX8Bit = 136,
  Feature_HasCX16Bit = 137,
  Feature_HasENQCMDBit = 16,
  Feature_HasAMXFP16Bit = 115,
  Feature_HasCMPCCXADDBit = 21,
  Feature_HasAVXNECONVERTBit = 87,
  Feature_HasKLBit = 111,
  Feature_HasRAOINTBit = 121,
  Feature_HasSERIALIZEBit = 17,
  Feature_HasTSXLDTRKBit = 18,
  Feature_HasAMXTILEBit = 112,
  Feature_HasAMXBF16Bit = 114,
  Feature_HasAMXINT8Bit = 113,
  Feature_HasAMXCOMPLEXBit = 116,
  Feature_HasAMXFP8Bit = 117,
  Feature_HasAMXTRANSPOSEBit = 118,
  Feature_HasAMXAVX512Bit = 119,
  Feature_HasAMXTF32Bit = 120,
  Feature_HasUINTRBit = 19,
  Feature_HasUSERMSRBit = 122,
  Feature_HasCRC32Bit = 70,
  Feature_Not64BitModeBit = 0,
  Feature_In64BitModeBit = 1,
  Feature_IsLP64Bit = 133,
  Feature_NotLP64Bit = 132,
  Feature_NotWin64WithoutFPBit = 134,
  Feature_IsPSBit = 144,
  Feature_NotPSBit = 143,
  Feature_KernelCodeBit = 145,
  Feature_NearDataBit = 147,
  Feature_IsNotPICBit = 146,
  Feature_OptForSizeBit = 51,
  Feature_OptForMinSizeBit = 49,
  Feature_OptForSpeedBit = 141,
  Feature_UseIncDecBit = 28,
  Feature_NoSSE41_Or_OptForSizeBit = 53,
  Feature_CallImmAddrBit = 148,
  Feature_FavorMemIndirectCallBit = 31,
  Feature_HasFastSHLDRotateBit = 34,
  Feature_HasMFenceBit = 59,
  Feature_UseIndirectThunkCallsBit = 33,
  Feature_NotUseIndirectThunkCallsBit = 32,
};

PredicateBitset X86InstructionSelector::
computeAvailableModuleFeatures(const X86Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (true)
    Features.set(Feature_TruePredicateBit);
  if (Subtarget->hasEGPR())
    Features.set(Feature_HasEGPRBit);
  if (!Subtarget->hasEGPR())
    Features.set(Feature_NoEGPRBit);
  if (Subtarget->hasNDD())
    Features.set(Feature_HasNDDBit);
  if (!Subtarget->hasNDD())
    Features.set(Feature_NoNDDBit);
  if (Subtarget->hasZU())
    Features.set(Feature_HasZUBit);
  if (Subtarget->hasCF())
    Features.set(Feature_HasCFBit);
  if (Subtarget->canUseCMOV())
    Features.set(Feature_HasCMOVBit);
  if (!Subtarget->canUseCMOV())
    Features.set(Feature_NoCMOVBit);
  if (Subtarget->hasMMX())
    Features.set(Feature_HasMMXBit);
  if (Subtarget->hasSSE1())
    Features.set(Feature_HasSSE1Bit);
  if (Subtarget->hasSSE1() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE1Bit);
  if (Subtarget->hasSSE2())
    Features.set(Feature_HasSSE2Bit);
  if (Subtarget->hasSSE2() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE2Bit);
  if (Subtarget->hasSSE3())
    Features.set(Feature_HasSSE3Bit);
  if (Subtarget->hasSSE3() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE3Bit);
  if (Subtarget->hasSSSE3())
    Features.set(Feature_HasSSSE3Bit);
  if (Subtarget->hasSSSE3() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSSE3Bit);
  if (Subtarget->hasSSE41() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE41Bit);
  if (Subtarget->hasSSE42() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE42Bit);
  if (Subtarget->hasSSE4A())
    Features.set(Feature_HasSSE4ABit);
  if (!Subtarget->hasAVX())
    Features.set(Feature_NoAVXBit);
  if (Subtarget->hasAVX())
    Features.set(Feature_HasAVXBit);
  if (Subtarget->hasAVX2())
    Features.set(Feature_HasAVX2Bit);
  if (Subtarget->hasAVX() && !Subtarget->hasAVX2())
    Features.set(Feature_HasAVX1OnlyBit);
  if (Subtarget->hasEVEX512())
    Features.set(Feature_HasEVEX512Bit);
  if (Subtarget->hasAVX10_2())
    Features.set(Feature_HasAVX10_2Bit);
  if (Subtarget->hasAVX10_2_512())
    Features.set(Feature_HasAVX10_2_512Bit);
  if (!Subtarget->hasAVX10_2())
    Features.set(Feature_NoAVX10_2Bit);
  if (Subtarget->hasAVX512())
    Features.set(Feature_HasAVX512Bit);
  if (Subtarget->hasAVX() && !Subtarget->hasAVX512())
    Features.set(Feature_UseAVXBit);
  if (!Subtarget->hasAVX512())
    Features.set(Feature_NoAVX512Bit);
  if (Subtarget->hasCDI())
    Features.set(Feature_HasCDIBit);
  if (Subtarget->hasVPOPCNTDQ())
    Features.set(Feature_HasVPOPCNTDQBit);
  if (Subtarget->hasDQI())
    Features.set(Feature_HasDQIBit);
  if (!Subtarget->hasDQI())
    Features.set(Feature_NoDQIBit);
  if (Subtarget->hasBWI())
    Features.set(Feature_HasBWIBit);
  if (!Subtarget->hasBWI())
    Features.set(Feature_NoBWIBit);
  if (Subtarget->hasVLX())
    Features.set(Feature_HasVLXBit);
  if (!Subtarget->hasVLX())
    Features.set(Feature_NoVLXBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasBWI())
    Features.set(Feature_NoVLX_Or_NoBWIBit);
  if (Subtarget->hasVNNI())
    Features.set(Feature_HasVNNIBit);
  if (Subtarget->hasVP2INTERSECT())
    Features.set(Feature_HasVP2INTERSECTBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasAVXVNNIINT16())
    Features.set(Feature_HasAVXVNNIINT16Bit);
  if (Subtarget->hasAVXVNNIINT8())
    Features.set(Feature_HasAVXVNNIINT8Bit);
  if (Subtarget->hasAVXVNNI())
    Features.set(Feature_HasAVXVNNIBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVNNI())
    Features.set(Feature_NoVLX_Or_NoVNNIBit);
  if (Subtarget->hasBITALG())
    Features.set(Feature_HasBITALGBit);
  if (Subtarget->hasPOPCNT())
    Features.set(Feature_HasPOPCNTBit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasVAES())
    Features.set(Feature_HasVAESBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVAES())
    Features.set(Feature_NoVLX_Or_NoVAESBit);
  if (Subtarget->hasFXSR())
    Features.set(Feature_HasFXSRBit);
  if (Subtarget->hasX87())
    Features.set(Feature_HasX87Bit);
  if (Subtarget->hasXSAVE())
    Features.set(Feature_HasXSAVEBit);
  if (Subtarget->hasXSAVEOPT())
    Features.set(Feature_HasXSAVEOPTBit);
  if (Subtarget->hasXSAVEC())
    Features.set(Feature_HasXSAVECBit);
  if (Subtarget->hasXSAVES())
    Features.set(Feature_HasXSAVESBit);
  if (Subtarget->hasPCLMUL())
    Features.set(Feature_HasPCLMULBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVPCLMULQDQ())
    Features.set(Feature_NoVLX_Or_NoVPCLMULQDQBit);
  if (Subtarget->hasVPCLMULQDQ())
    Features.set(Feature_HasVPCLMULQDQBit);
  if (Subtarget->hasGFNI())
    Features.set(Feature_HasGFNIBit);
  if (Subtarget->hasFMA())
    Features.set(Feature_HasFMABit);
  if (Subtarget->hasFMA4())
    Features.set(Feature_HasFMA4Bit);
  if (!Subtarget->hasFMA4())
    Features.set(Feature_NoFMA4Bit);
  if (Subtarget->hasXOP())
    Features.set(Feature_HasXOPBit);
  if (Subtarget->hasTBM())
    Features.set(Feature_HasTBMBit);
  if (!Subtarget->hasTBM())
    Features.set(Feature_NoTBMBit);
  if (Subtarget->hasLWP())
    Features.set(Feature_HasLWPBit);
  if (Subtarget->hasMOVBE())
    Features.set(Feature_HasMOVBEBit);
  if (!Subtarget->hasNDD() || !Subtarget->hasMOVBE())
    Features.set(Feature_NoNDD_Or_NoMOVBEBit);
  if (Subtarget->hasRDRAND())
    Features.set(Feature_HasRDRANDBit);
  if (Subtarget->hasF16C())
    Features.set(Feature_HasF16CBit);
  if (Subtarget->hasFSGSBase())
    Features.set(Feature_HasFSGSBaseBit);
  if (Subtarget->hasLZCNT())
    Features.set(Feature_HasLZCNTBit);
  if (Subtarget->hasBMI())
    Features.set(Feature_HasBMIBit);
  if (Subtarget->hasBMI2())
    Features.set(Feature_HasBMI2Bit);
  if (!Subtarget->hasBMI2())
    Features.set(Feature_NoBMI2Bit);
  if (Subtarget->hasVBMI())
    Features.set(Feature_HasVBMIBit);
  if (Subtarget->hasVBMI2())
    Features.set(Feature_HasVBMI2Bit);
  if (Subtarget->hasIFMA())
    Features.set(Feature_HasIFMABit);
  if (Subtarget->hasAVXIFMA())
    Features.set(Feature_HasAVXIFMABit);
  if (!Subtarget->hasVLX() || !Subtarget->hasIFMA())
    Features.set(Feature_NoVLX_Or_NoIFMABit);
  if (Subtarget->hasRTM())
    Features.set(Feature_HasRTMBit);
  if (Subtarget->hasSHA())
    Features.set(Feature_HasSHABit);
  if (Subtarget->hasSHA512())
    Features.set(Feature_HasSHA512Bit);
  if (Subtarget->hasSM3())
    Features.set(Feature_HasSM3Bit);
  if (Subtarget->hasRDSEED())
    Features.set(Feature_HasRDSEEDBit);
  if (Subtarget->hasSSEPrefetch())
    Features.set(Feature_HasSSEPrefetchBit);
  if (Subtarget->hasPREFETCHI())
    Features.set(Feature_HasPREFETCHIBit);
  if (Subtarget->hasPrefetchW())
    Features.set(Feature_HasPrefetchWBit);
  if (Subtarget->hasMWAITX())
    Features.set(Feature_HasMWAITXBit);
  if (Subtarget->hasCLDEMOTE())
    Features.set(Feature_HasCLDEMOTEBit);
  if (Subtarget->hasMOVDIRI())
    Features.set(Feature_HasMOVDIRIBit);
  if (Subtarget->hasMOVDIR64B())
    Features.set(Feature_HasMOVDIR64BBit);
  if (Subtarget->hasMOVRS())
    Features.set(Feature_HasMOVRSBit);
  if (Subtarget->hasPTWRITE())
    Features.set(Feature_HasPTWRITEBit);
  if (!Subtarget->hasSSE1())
    Features.set(Feature_FPStackf32Bit);
  if (!Subtarget->hasSSE2())
    Features.set(Feature_FPStackf64Bit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasCLFLUSH())
    Features.set(Feature_HasCLFLUSHBit);
  if (Subtarget->hasCLFLUSHOPT())
    Features.set(Feature_HasCLFLUSHOPTBit);
  if (Subtarget->hasCLWB())
    Features.set(Feature_HasCLWBBit);
  if (Subtarget->hasWBNOINVD())
    Features.set(Feature_HasWBNOINVDBit);
  if (Subtarget->hasRDPID())
    Features.set(Feature_HasRDPIDBit);
  if (Subtarget->hasWAITPKG())
    Features.set(Feature_HasWAITPKGBit);
  if (Subtarget->hasINVPCID())
    Features.set(Feature_HasINVPCIDBit);
  if (Subtarget->hasCX8())
    Features.set(Feature_HasCX8Bit);
  if (Subtarget->hasCX16())
    Features.set(Feature_HasCX16Bit);
  if (Subtarget->hasENQCMD())
    Features.set(Feature_HasENQCMDBit);
  if (Subtarget->hasAMXFP16())
    Features.set(Feature_HasAMXFP16Bit);
  if (Subtarget->hasCMPCCXADD())
    Features.set(Feature_HasCMPCCXADDBit);
  if (Subtarget->hasAVXNECONVERT())
    Features.set(Feature_HasAVXNECONVERTBit);
  if (Subtarget->hasKL())
    Features.set(Feature_HasKLBit);
  if (Subtarget->hasRAOINT())
    Features.set(Feature_HasRAOINTBit);
  if (Subtarget->hasSERIALIZE())
    Features.set(Feature_HasSERIALIZEBit);
  if (Subtarget->hasTSXLDTRK())
    Features.set(Feature_HasTSXLDTRKBit);
  if (Subtarget->hasAMXTILE())
    Features.set(Feature_HasAMXTILEBit);
  if (Subtarget->hasAMXBF16())
    Features.set(Feature_HasAMXBF16Bit);
  if (Subtarget->hasAMXINT8())
    Features.set(Feature_HasAMXINT8Bit);
  if (Subtarget->hasAMXCOMPLEX())
    Features.set(Feature_HasAMXCOMPLEXBit);
  if (Subtarget->hasAMXFP8())
    Features.set(Feature_HasAMXFP8Bit);
  if (Subtarget->hasAMXTRANSPOSE())
    Features.set(Feature_HasAMXTRANSPOSEBit);
  if (Subtarget->hasAMXAVX512())
    Features.set(Feature_HasAMXAVX512Bit);
  if (Subtarget->hasAMXTF32())
    Features.set(Feature_HasAMXTF32Bit);
  if (Subtarget->hasUINTR())
    Features.set(Feature_HasUINTRBit);
  if (Subtarget->hasUSERMSR())
    Features.set(Feature_HasUSERMSRBit);
  if (Subtarget->hasCRC32())
    Features.set(Feature_HasCRC32Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_Not64BitModeBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_In64BitModeBit);
  if (Subtarget->isTarget64BitLP64())
    Features.set(Feature_IsLP64Bit);
  if (!Subtarget->isTarget64BitLP64())
    Features.set(Feature_NotLP64Bit);
  if (Subtarget->isTargetPS())
    Features.set(Feature_IsPSBit);
  if (!Subtarget->isTargetPS())
    Features.set(Feature_NotPSBit);
  if (TM.getCodeModel() == CodeModel::Kernel)
    Features.set(Feature_KernelCodeBit);
  if (TM.getCodeModel() == CodeModel::Small ||TM.getCodeModel() == CodeModel::Kernel)
    Features.set(Feature_NearDataBit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_IsNotPICBit);
  if (Subtarget->isLegalToCallImmediateAddr())
    Features.set(Feature_CallImmAddrBit);
  if (!Subtarget->slowTwoMemOps())
    Features.set(Feature_FavorMemIndirectCallBit);
  if (Subtarget->hasFastSHLDRotate())
    Features.set(Feature_HasFastSHLDRotateBit);
  if (Subtarget->hasMFence())
    Features.set(Feature_HasMFenceBit);
  if (Subtarget->useIndirectThunkCalls())
    Features.set(Feature_UseIndirectThunkCallsBit);
  if (!Subtarget->useIndirectThunkCalls())
    Features.set(Feature_NotUseIndirectThunkCallsBit);
  return Features;
}

void X86InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const X86Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset X86InstructionSelector::
computeAvailableFunctionFeatures(const X86Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!Subtarget->isTargetWin64() ||Subtarget->getFrameLowering()->hasFP(*MF))
    Features.set(Feature_NotWin64WithoutFPBit);
  if (shouldOptForSize(MF))
    Features.set(Feature_OptForSizeBit);
  if (MF->getFunction().hasMinSize())
    Features.set(Feature_OptForMinSizeBit);
  if (!shouldOptForSize(MF))
    Features.set(Feature_OptForSpeedBit);
  if (!Subtarget->slowIncDec() || shouldOptForSize(MF))
    Features.set(Feature_UseIncDecBit);
  if (shouldOptForSize(MF) || !Subtarget->hasSSE41())
    Features.set(Feature_NoSSE41_Or_OptForSizeBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_FPStackf32,
  GIFBS_FPStackf64,
  GIFBS_HasAVX,
  GIFBS_HasAVX1Only,
  GIFBS_HasAVX2,
  GIFBS_HasAVX512,
  GIFBS_HasBITALG,
  GIFBS_HasBMI,
  GIFBS_HasBWI,
  GIFBS_HasCDI,
  GIFBS_HasDQI,
  GIFBS_HasFP16,
  GIFBS_HasFastSHLDRotate,
  GIFBS_HasKL,
  GIFBS_HasLWP,
  GIFBS_HasLZCNT,
  GIFBS_HasMFence,
  GIFBS_HasMMX,
  GIFBS_HasMOVBE,
  GIFBS_HasMWAITX,
  GIFBS_HasNDD,
  GIFBS_HasPOPCNT,
  GIFBS_HasPTWRITE,
  GIFBS_HasRTM,
  GIFBS_HasSERIALIZE,
  GIFBS_HasSHA,
  GIFBS_HasSHA512,
  GIFBS_HasSM3,
  GIFBS_HasSM4,
  GIFBS_HasSSE1,
  GIFBS_HasSSE2,
  GIFBS_HasSSE3,
  GIFBS_HasSSE4A,
  GIFBS_HasTBM,
  GIFBS_HasTSXLDTRK,
  GIFBS_HasVBMI2,
  GIFBS_HasVLX,
  GIFBS_HasVPOPCNTDQ,
  GIFBS_HasWAITPKG,
  GIFBS_HasWBNOINVD,
  GIFBS_HasX87,
  GIFBS_HasXOP,
  GIFBS_HasZU,
  GIFBS_In64BitMode,
  GIFBS_IsPS,
  GIFBS_NoDQI,
  GIFBS_NoNDD,
  GIFBS_NoNDD_Or_NoMOVBE,
  GIFBS_Not64BitMode,
  GIFBS_NotPS,
  GIFBS_UseAVX,
  GIFBS_UseSSE1,
  GIFBS_UseSSE2,
  GIFBS_UseSSE41,
  GIFBS_UseSSSE3,
  GIFBS_HasAES_HasAVX,
  GIFBS_HasAES_NoAVX,
  GIFBS_HasAMXBF16_In64BitMode,
  GIFBS_HasAMXCOMPLEX_In64BitMode,
  GIFBS_HasAMXFP16_In64BitMode,
  GIFBS_HasAMXFP8_In64BitMode,
  GIFBS_HasAMXINT8_In64BitMode,
  GIFBS_HasAMXTF32_In64BitMode,
  GIFBS_HasAMXTILE_In64BitMode,
  GIFBS_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAVX_In64BitMode,
  GIFBS_HasAVX_NoAVX10_2,
  GIFBS_HasAVX_NoBWI,
  GIFBS_HasAVX_NoVLX,
  GIFBS_HasAVX_NoVLX_Or_NoBWI,
  GIFBS_HasAVX10_2_HasSM4,
  GIFBS_HasAVX10_2_512_HasSM4,
  GIFBS_HasAVX2_NoVLX,
  GIFBS_HasAVX2_NoVLX_Or_NoBWI,
  GIFBS_HasAVX512_HasVAES,
  GIFBS_HasAVX512_HasVLX,
  GIFBS_HasAVX512_HasVPCLMULQDQ,
  GIFBS_HasAVX512_NoBWI,
  GIFBS_HasAVX512_NoDQI,
  GIFBS_HasBITALG_HasVLX,
  GIFBS_HasBMI_HasEGPR,
  GIFBS_HasBMI_NoEGPR,
  GIFBS_HasBMI2_HasEGPR,
  GIFBS_HasBMI2_NoEGPR,
  GIFBS_HasBWI_HasVLX,
  GIFBS_HasCDI_HasVLX,
  GIFBS_HasCRC32_NoEGPR,
  GIFBS_HasDQI_HasVLX,
  GIFBS_HasDQI_NoBWI,
  GIFBS_HasEVEX512_NoVLX,
  GIFBS_HasFMA4_NoAVX512,
  GIFBS_HasFMA4_NoVLX,
  GIFBS_HasFP16_HasVLX,
  GIFBS_HasFSGSBase_In64BitMode,
  GIFBS_HasNDD_In64BitMode,
  GIFBS_HasNDD_UseIncDec,
  GIFBS_HasPCLMUL_NoAVX,
  GIFBS_HasPTWRITE_In64BitMode,
  GIFBS_HasRDPID_In64BitMode,
  GIFBS_HasRDPID_Not64BitMode,
  GIFBS_HasUINTR_In64BitMode,
  GIFBS_HasUSERMSR_NoEGPR,
  GIFBS_HasVAES_HasVLX,
  GIFBS_HasVAES_NoVLX,
  GIFBS_HasVBMI2_HasVLX,
  GIFBS_HasVLX_HasVPCLMULQDQ,
  GIFBS_HasVLX_HasVPOPCNTDQ,
  GIFBS_HasVPCLMULQDQ_NoVLX,
  GIFBS_HasWAITPKG_In64BitMode,
  GIFBS_HasWAITPKG_Not64BitMode,
  GIFBS_In64BitMode_UseSSE2,
  GIFBS_NoNDD_UseIncDec,
  GIFBS_Not64BitMode_OptForSize,
  GIFBS_NotWin64WithoutFP_OptForMinSize,
  GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES,
  GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode,
  GIFBS_HasAMXBF16_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXFP16_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXTF32_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ,
  GIFBS_HasAVX512_HasEVEX512_NoVLX,
  GIFBS_HasBITALG_HasEVEX512_NoVLX,
  GIFBS_HasBWI_HasEVEX512_NoVLX,
  GIFBS_HasCDI_HasEVEX512_NoVLX,
  GIFBS_HasCRC32_HasEGPR_In64BitMode,
  GIFBS_HasDQI_HasEVEX512_NoVLX,
  GIFBS_HasDQI_HasVLX_NoBWI,
  GIFBS_HasEGPR_HasUSERMSR_In64BitMode,
  GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX,
  GIFBS_HasFMA_NoAVX512_NoFMA4,
  GIFBS_HasFMA_NoFMA4_NoVLX,
  GIFBS_HasMOVBE_HasNDD_In64BitMode,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_FPStackf32Bit, },
  {Feature_FPStackf64Bit, },
  {Feature_HasAVXBit, },
  {Feature_HasAVX1OnlyBit, },
  {Feature_HasAVX2Bit, },
  {Feature_HasAVX512Bit, },
  {Feature_HasBITALGBit, },
  {Feature_HasBMIBit, },
  {Feature_HasBWIBit, },
  {Feature_HasCDIBit, },
  {Feature_HasDQIBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFastSHLDRotateBit, },
  {Feature_HasKLBit, },
  {Feature_HasLWPBit, },
  {Feature_HasLZCNTBit, },
  {Feature_HasMFenceBit, },
  {Feature_HasMMXBit, },
  {Feature_HasMOVBEBit, },
  {Feature_HasMWAITXBit, },
  {Feature_HasNDDBit, },
  {Feature_HasPOPCNTBit, },
  {Feature_HasPTWRITEBit, },
  {Feature_HasRTMBit, },
  {Feature_HasSERIALIZEBit, },
  {Feature_HasSHABit, },
  {Feature_HasSHA512Bit, },
  {Feature_HasSM3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSSE1Bit, },
  {Feature_HasSSE2Bit, },
  {Feature_HasSSE3Bit, },
  {Feature_HasSSE4ABit, },
  {Feature_HasTBMBit, },
  {Feature_HasTSXLDTRKBit, },
  {Feature_HasVBMI2Bit, },
  {Feature_HasVLXBit, },
  {Feature_HasVPOPCNTDQBit, },
  {Feature_HasWAITPKGBit, },
  {Feature_HasWBNOINVDBit, },
  {Feature_HasX87Bit, },
  {Feature_HasXOPBit, },
  {Feature_HasZUBit, },
  {Feature_In64BitModeBit, },
  {Feature_IsPSBit, },
  {Feature_NoDQIBit, },
  {Feature_NoNDDBit, },
  {Feature_NoNDD_Or_NoMOVBEBit, },
  {Feature_Not64BitModeBit, },
  {Feature_NotPSBit, },
  {Feature_UseAVXBit, },
  {Feature_UseSSE1Bit, },
  {Feature_UseSSE2Bit, },
  {Feature_UseSSE41Bit, },
  {Feature_UseSSSE3Bit, },
  {Feature_HasAESBit, Feature_HasAVXBit, },
  {Feature_HasAESBit, Feature_NoAVXBit, },
  {Feature_HasAMXBF16Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXCOMPLEXBit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP16Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP8Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXINT8Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXTF32Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_NoAVX10_2Bit, },
  {Feature_HasAVXBit, Feature_NoBWIBit, },
  {Feature_HasAVXBit, Feature_NoVLXBit, },
  {Feature_HasAVXBit, Feature_NoVLX_Or_NoBWIBit, },
  {Feature_HasAVX10_2Bit, Feature_HasSM4Bit, },
  {Feature_HasAVX10_2_512Bit, Feature_HasSM4Bit, },
  {Feature_HasAVX2Bit, Feature_NoVLXBit, },
  {Feature_HasAVX2Bit, Feature_NoVLX_Or_NoBWIBit, },
  {Feature_HasAVX512Bit, Feature_HasVAESBit, },
  {Feature_HasAVX512Bit, Feature_HasVLXBit, },
  {Feature_HasAVX512Bit, Feature_HasVPCLMULQDQBit, },
  {Feature_HasAVX512Bit, Feature_NoBWIBit, },
  {Feature_HasAVX512Bit, Feature_NoDQIBit, },
  {Feature_HasBITALGBit, Feature_HasVLXBit, },
  {Feature_HasBMIBit, Feature_HasEGPRBit, },
  {Feature_HasBMIBit, Feature_NoEGPRBit, },
  {Feature_HasBMI2Bit, Feature_HasEGPRBit, },
  {Feature_HasBMI2Bit, Feature_NoEGPRBit, },
  {Feature_HasBWIBit, Feature_HasVLXBit, },
  {Feature_HasCDIBit, Feature_HasVLXBit, },
  {Feature_HasCRC32Bit, Feature_NoEGPRBit, },
  {Feature_HasDQIBit, Feature_HasVLXBit, },
  {Feature_HasDQIBit, Feature_NoBWIBit, },
  {Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasFMA4Bit, Feature_NoAVX512Bit, },
  {Feature_HasFMA4Bit, Feature_NoVLXBit, },
  {Feature_HasFP16Bit, Feature_HasVLXBit, },
  {Feature_HasFSGSBaseBit, Feature_In64BitModeBit, },
  {Feature_HasNDDBit, Feature_In64BitModeBit, },
  {Feature_HasNDDBit, Feature_UseIncDecBit, },
  {Feature_HasPCLMULBit, Feature_NoAVXBit, },
  {Feature_HasPTWRITEBit, Feature_In64BitModeBit, },
  {Feature_HasRDPIDBit, Feature_In64BitModeBit, },
  {Feature_HasRDPIDBit, Feature_Not64BitModeBit, },
  {Feature_HasUINTRBit, Feature_In64BitModeBit, },
  {Feature_HasUSERMSRBit, Feature_NoEGPRBit, },
  {Feature_HasVAESBit, Feature_HasVLXBit, },
  {Feature_HasVAESBit, Feature_NoVLXBit, },
  {Feature_HasVBMI2Bit, Feature_HasVLXBit, },
  {Feature_HasVLXBit, Feature_HasVPCLMULQDQBit, },
  {Feature_HasVLXBit, Feature_HasVPOPCNTDQBit, },
  {Feature_HasVPCLMULQDQBit, Feature_NoVLXBit, },
  {Feature_HasWAITPKGBit, Feature_In64BitModeBit, },
  {Feature_HasWAITPKGBit, Feature_Not64BitModeBit, },
  {Feature_In64BitModeBit, Feature_UseSSE2Bit, },
  {Feature_NoNDDBit, Feature_UseIncDecBit, },
  {Feature_Not64BitModeBit, Feature_OptForSizeBit, },
  {Feature_NotWin64WithoutFPBit, Feature_OptForMinSizeBit, },
  {Feature_HasAESBit, Feature_HasAVXBit, Feature_NoVLX_Or_NoVAESBit, },
  {Feature_HasAMXAVX512Bit, Feature_HasAVX10_2_512Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXBF16Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXCOMPLEXBit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP16Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTF32Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_HasPCLMULBit, Feature_NoVLX_Or_NoVPCLMULQDQBit, },
  {Feature_HasAVX512Bit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasBITALGBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasBWIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasCDIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasCRC32Bit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasDQIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasDQIBit, Feature_HasVLXBit, Feature_NoBWIBit, },
  {Feature_HasEGPRBit, Feature_HasUSERMSRBit, Feature_In64BitModeBit, },
  {Feature_HasEVEX512Bit, Feature_HasVPOPCNTDQBit, Feature_NoVLXBit, },
  {Feature_HasFMABit, Feature_NoAVX512Bit, Feature_NoFMA4Bit, },
  {Feature_HasFMABit, Feature_NoFMA4Bit, Feature_NoVLXBit, },
  {Feature_HasMOVBEBit, Feature_HasNDDBit, Feature_In64BitModeBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

X86InstructionSelector::ComplexMatcherMemFn
X86InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool X86InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AndMask64 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BTCBTSMask64,
  GICXXPred_I64_Predicate_BTRMask64,
  GICXXPred_I64_Predicate_i16immSExt8,
  GICXXPred_I64_Predicate_i32immSExt8,
  GICXXPred_I64_Predicate_i64immSExt8,
  GICXXPred_I64_Predicate_i64immSExt32,
  GICXXPred_I64_Predicate_i64immZExt32,
  GICXXPred_I64_Predicate_i64immZExt32SExt8,
  GICXXPred_I64_Predicate_i64timmSExt32,
  GICXXPred_I64_Predicate_immff00_ffff,
};
bool X86InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AndMask64: {
    
      return isMask_64(Imm) && !isUInt<32>(Imm);
    
  }
  case GICXXPred_I64_Predicate_BTCBTSMask64: {
    
      return !isInt<32>(Imm) && isPowerOf2_64(Imm);
    
  }
  case GICXXPred_I64_Predicate_BTRMask64: {
    
      return !isUInt<32>(Imm) && !isInt<32>(Imm) && isPowerOf2_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_i16immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i32immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immSExt32: {
     return isInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immZExt32: {
     return isUInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immZExt32SExt8: {
    
      return isUInt<32>(Imm) && isInt<8>(static_cast<int32_t>(Imm));
    
  }
  case GICXXPred_I64_Predicate_i64timmSExt32: {
     return isInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_immff00_ffff: {
    
      return Imm >= 0xff00 && Imm <= 0xffff;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm1,
  GICXXPred_APFloat_Predicate_fpimmneg0,
  GICXXPred_APFloat_Predicate_fpimmneg1,
};
bool X86InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm1: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmneg0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmneg1: {
    
      return Imm.isExactlyValue(-1.0);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool X86InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool X86InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("X86InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
X86InstructionSelector::CustomRendererFn
X86InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool X86InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool X86InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("X86InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *X86InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*     0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(287), /*)*//*default:*//*Label 70*/ GIMT_Encode4(90083),
     /*    10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(946),
     /*    14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(3304),
     /*    18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(5120), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    46 */ /*TargetOpcode::G_AND*//*Label 3*/ GIMT_Encode4(6345),
     /*    50 */ /*TargetOpcode::G_OR*//*Label 4*/ GIMT_Encode4(12189),
     /*    54 */ /*TargetOpcode::G_XOR*//*Label 5*/ GIMT_Encode4(16581), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 6*/ GIMT_Encode4(25028), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   126 */ /*TargetOpcode::G_BITCAST*//*Label 7*/ GIMT_Encode4(25195), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 8*/ GIMT_Encode4(26952),
     /*   154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 9*/ GIMT_Encode4(27814), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   306 */ /*TargetOpcode::G_INTRINSIC*//*Label 10*/ GIMT_Encode4(28208),
     /*   310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 11*/ GIMT_Encode4(33806), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   322 */ /*TargetOpcode::G_ANYEXT*//*Label 12*/ GIMT_Encode4(37450),
     /*   326 */ /*TargetOpcode::G_TRUNC*//*Label 13*/ GIMT_Encode4(37885),
     /*   330 */ /*TargetOpcode::G_CONSTANT*//*Label 14*/ GIMT_Encode4(38898),
     /*   334 */ /*TargetOpcode::G_FCONSTANT*//*Label 15*/ GIMT_Encode4(39504), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   346 */ /*TargetOpcode::G_SEXT*//*Label 16*/ GIMT_Encode4(39957),
     /*   350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 17*/ GIMT_Encode4(40980),
     /*   354 */ /*TargetOpcode::G_ZEXT*//*Label 18*/ GIMT_Encode4(41222),
     /*   358 */ /*TargetOpcode::G_SHL*//*Label 19*/ GIMT_Encode4(42330),
     /*   362 */ /*TargetOpcode::G_LSHR*//*Label 20*/ GIMT_Encode4(43518),
     /*   366 */ /*TargetOpcode::G_ASHR*//*Label 21*/ GIMT_Encode4(44498),
     /*   370 */ /*TargetOpcode::G_FSHL*//*Label 22*/ GIMT_Encode4(45478),
     /*   374 */ /*TargetOpcode::G_FSHR*//*Label 23*/ GIMT_Encode4(45854),
     /*   378 */ /*TargetOpcode::G_ROTR*//*Label 24*/ GIMT_Encode4(46230),
     /*   382 */ /*TargetOpcode::G_ROTL*//*Label 25*/ GIMT_Encode4(48212),
     /*   386 */ /*TargetOpcode::G_ICMP*//*Label 26*/ GIMT_Encode4(50196), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   402 */ /*TargetOpcode::G_SELECT*//*Label 27*/ GIMT_Encode4(51853), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   446 */ /*TargetOpcode::G_UMULH*//*Label 28*/ GIMT_Encode4(58661),
     /*   450 */ /*TargetOpcode::G_SMULH*//*Label 29*/ GIMT_Encode4(58908),
     /*   454 */ /*TargetOpcode::G_UADDSAT*//*Label 30*/ GIMT_Encode4(59155),
     /*   458 */ /*TargetOpcode::G_SADDSAT*//*Label 31*/ GIMT_Encode4(59605),
     /*   462 */ /*TargetOpcode::G_USUBSAT*//*Label 32*/ GIMT_Encode4(60055),
     /*   466 */ /*TargetOpcode::G_SSUBSAT*//*Label 33*/ GIMT_Encode4(60505), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   510 */ /*TargetOpcode::G_FADD*//*Label 34*/ GIMT_Encode4(60955),
     /*   514 */ /*TargetOpcode::G_FSUB*//*Label 35*/ GIMT_Encode4(61971),
     /*   518 */ /*TargetOpcode::G_FMUL*//*Label 36*/ GIMT_Encode4(62987),
     /*   522 */ /*TargetOpcode::G_FMA*//*Label 37*/ GIMT_Encode4(64003), GIMT_Encode4(0),
     /*   530 */ /*TargetOpcode::G_FDIV*//*Label 38*/ GIMT_Encode4(65131), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   578 */ /*TargetOpcode::G_FNEG*//*Label 39*/ GIMT_Encode4(66147),
     /*   582 */ /*TargetOpcode::G_FPEXT*//*Label 40*/ GIMT_Encode4(66270),
     /*   586 */ /*TargetOpcode::G_FPTRUNC*//*Label 41*/ GIMT_Encode4(66840),
     /*   590 */ /*TargetOpcode::G_FPTOSI*//*Label 42*/ GIMT_Encode4(67167),
     /*   594 */ /*TargetOpcode::G_FPTOUI*//*Label 43*/ GIMT_Encode4(67664),
     /*   598 */ /*TargetOpcode::G_SITOFP*//*Label 44*/ GIMT_Encode4(67866),
     /*   602 */ /*TargetOpcode::G_UITOFP*//*Label 45*/ GIMT_Encode4(69128), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   614 */ /*TargetOpcode::G_FABS*//*Label 46*/ GIMT_Encode4(69978), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   686 */ /*TargetOpcode::G_SMIN*//*Label 47*/ GIMT_Encode4(70101),
     /*   690 */ /*TargetOpcode::G_SMAX*//*Label 48*/ GIMT_Encode4(71198),
     /*   694 */ /*TargetOpcode::G_UMIN*//*Label 49*/ GIMT_Encode4(72295),
     /*   698 */ /*TargetOpcode::G_UMAX*//*Label 50*/ GIMT_Encode4(73392),
     /*   702 */ /*TargetOpcode::G_ABS*//*Label 51*/ GIMT_Encode4(74489), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   714 */ /*TargetOpcode::G_BR*//*Label 52*/ GIMT_Encode4(75354), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   730 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 53*/ GIMT_Encode4(75370), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   754 */ /*TargetOpcode::G_VECTOR_COMPRESS*//*Label 54*/ GIMT_Encode4(78299),
     /*   758 */ /*TargetOpcode::G_CTTZ*//*Label 55*/ GIMT_Encode4(80281),
     /*   762 */ /*TargetOpcode::G_CTTZ_ZERO_UNDEF*//*Label 56*/ GIMT_Encode4(80404),
     /*   766 */ /*TargetOpcode::G_CTLZ*//*Label 57*/ GIMT_Encode4(80566), GIMT_Encode4(0),
     /*   774 */ /*TargetOpcode::G_CTPOP*//*Label 58*/ GIMT_Encode4(81347),
     /*   778 */ /*TargetOpcode::G_BSWAP*//*Label 59*/ GIMT_Encode4(82746), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   834 */ /*TargetOpcode::G_FSQRT*//*Label 60*/ GIMT_Encode4(82922), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 61*/ GIMT_Encode4(83874),
     /*   878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 62*/ GIMT_Encode4(84890),
     /*   882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 63*/ GIMT_Encode4(85906),
     /*   886 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 64*/ GIMT_Encode4(86922), GIMT_Encode4(0),
     /*   894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 65*/ GIMT_Encode4(87938),
     /*   898 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 66*/ GIMT_Encode4(89066), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   934 */ /*TargetOpcode::G_TRAP*//*Label 67*/ GIMT_Encode4(90018),
     /*   938 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 68*/ GIMT_Encode4(90031),
     /*   942 */ /*TargetOpcode::G_UBSANTRAP*//*Label 69*/ GIMT_Encode4(90067),
     /*   946 */ // Label 0: @946
     /*   946 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 87*/ GIMT_Encode4(3303),
     /*   957 */ /*GILLT_s8*//*Label 71*/ GIMT_Encode4(1053),
     /*   961 */ /*GILLT_s16*//*Label 72*/ GIMT_Encode4(1286),
     /*   965 */ /*GILLT_s32*//*Label 73*/ GIMT_Encode4(1587),
     /*   969 */ /*GILLT_s64*//*Label 74*/ GIMT_Encode4(1888), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   985 */ /*GILLT_v2s64*//*Label 75*/ GIMT_Encode4(2279), GIMT_Encode4(0),
     /*   993 */ /*GILLT_v4s32*//*Label 76*/ GIMT_Encode4(2373),
     /*   997 */ /*GILLT_v4s64*//*Label 77*/ GIMT_Encode4(2589), GIMT_Encode4(0),
     /*  1005 */ /*GILLT_v8s16*//*Label 78*/ GIMT_Encode4(2656),
     /*  1009 */ /*GILLT_v8s32*//*Label 79*/ GIMT_Encode4(2872),
     /*  1013 */ /*GILLT_v8s64*//*Label 80*/ GIMT_Encode4(2939), GIMT_Encode4(0),
     /*  1021 */ /*GILLT_v16s8*//*Label 81*/ GIMT_Encode4(2973),
     /*  1025 */ /*GILLT_v16s16*//*Label 82*/ GIMT_Encode4(3067),
     /*  1029 */ /*GILLT_v16s32*//*Label 83*/ GIMT_Encode4(3134), GIMT_Encode4(0),
     /*  1037 */ /*GILLT_v32s8*//*Label 84*/ GIMT_Encode4(3168),
     /*  1041 */ /*GILLT_v32s16*//*Label 85*/ GIMT_Encode4(3235), GIMT_Encode4(0),
     /*  1049 */ /*GILLT_v64s8*//*Label 86*/ GIMT_Encode4(3269),
     /*  1053 */ // Label 71: @1053
     /*  1053 */ GIM_Try, /*On fail goto*//*Label 88*/ GIMT_Encode4(1285),
     /*  1058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  1061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  1064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  1068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  1072 */   GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1096), // Rule ID 23286 //
     /*  1077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*  1080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  1084 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, 1:{ *:[i8] })  =>  (INC8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*  1084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8r),
     /*  1087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1089 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1094 */     GIR_RootConstrainSelectedInstOperands,
     /*  1095 */     // GIR_Coverage, 23286,
     /*  1095 */     GIR_EraseRootFromParent_Done,
     /*  1096 */   // Label 89: @1096
     /*  1096 */   GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1120), // Rule ID 23290 //
     /*  1101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*  1104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  1108 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (DEC8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*  1108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8r),
     /*  1111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1113 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1118 */     GIR_RootConstrainSelectedInstOperands,
     /*  1119 */     // GIR_Coverage, 23290,
     /*  1119 */     GIR_EraseRootFromParent_Done,
     /*  1120 */   // Label 90: @1120
     /*  1120 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1144), // Rule ID 23376 //
     /*  1125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*  1128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  1132 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, 1:{ *:[i8] })  =>  (INC8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*  1132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8r_ND),
     /*  1135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1137 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1142 */     GIR_RootConstrainSelectedInstOperands,
     /*  1143 */     // GIR_Coverage, 23376,
     /*  1143 */     GIR_EraseRootFromParent_Done,
     /*  1144 */   // Label 91: @1144
     /*  1144 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1168), // Rule ID 23380 //
     /*  1149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*  1152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  1156 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (DEC8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*  1156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8r_ND),
     /*  1159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1161 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1166 */     GIR_RootConstrainSelectedInstOperands,
     /*  1167 */     // GIR_Coverage, 23380,
     /*  1167 */     GIR_EraseRootFromParent_Done,
     /*  1168 */   // Label 92: @1168
     /*  1168 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1201), // Rule ID 23224 //
     /*  1173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1184 */     // MIs[1] Operand 1
     /*  1184 */     // No operand predicates
     /*  1184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1186 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ADD8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  1186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri),
     /*  1189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1191 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  1196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1199 */     GIR_RootConstrainSelectedInstOperands,
     /*  1200 */     // GIR_Coverage, 23224,
     /*  1200 */     GIR_EraseRootFromParent_Done,
     /*  1201 */   // Label 93: @1201
     /*  1201 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1234), // Rule ID 23314 //
     /*  1206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1217 */     // MIs[1] Operand 1
     /*  1217 */     // No operand predicates
     /*  1217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1219 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ADD8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  1219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri_ND),
     /*  1222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1224 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  1229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1232 */     GIR_RootConstrainSelectedInstOperands,
     /*  1233 */     // GIR_Coverage, 23314,
     /*  1233 */     GIR_EraseRootFromParent_Done,
     /*  1234 */   // Label 94: @1234
     /*  1234 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1259), // Rule ID 23216 //
     /*  1239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  1246 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (ADD8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  1246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD8rr),
     /*  1251 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  1257 */     GIR_RootConstrainSelectedInstOperands,
     /*  1258 */     // GIR_Coverage, 23216,
     /*  1258 */     GIR_Done,
     /*  1259 */   // Label 95: @1259
     /*  1259 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1284), // Rule ID 23306 //
     /*  1264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  1271 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (ADD8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  1271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD8rr_ND),
     /*  1276 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  1282 */     GIR_RootConstrainSelectedInstOperands,
     /*  1283 */     // GIR_Coverage, 23306,
     /*  1283 */     GIR_Done,
     /*  1284 */   // Label 96: @1284
     /*  1284 */   GIM_Reject,
     /*  1285 */ // Label 88: @1285
     /*  1285 */ GIM_Reject,
     /*  1286 */ // Label 72: @1286
     /*  1286 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1586),
     /*  1291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  1294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  1297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  1301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  1305 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1339), // Rule ID 23026 //
     /*  1310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1313 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*  1324 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, 128:{ *:[i16] })  =>  (SUB16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -128:{ *:[i16] })
     /*  1324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri),
     /*  1327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1329 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  1334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1337 */     GIR_RootConstrainSelectedInstOperands,
     /*  1338 */     // GIR_Coverage, 23026,
     /*  1338 */     GIR_EraseRootFromParent_Done,
     /*  1339 */   // Label 98: @1339
     /*  1339 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1373), // Rule ID 23032 //
     /*  1344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1347 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*  1358 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, 128:{ *:[i16] })  =>  (SUB16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -128:{ *:[i16] })
     /*  1358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri_ND),
     /*  1361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  1368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1371 */     GIR_RootConstrainSelectedInstOperands,
     /*  1372 */     // GIR_Coverage, 23032,
     /*  1372 */     GIR_EraseRootFromParent_Done,
     /*  1373 */   // Label 99: @1373
     /*  1373 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1397), // Rule ID 23287 //
     /*  1378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*  1381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  1385 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, 1:{ *:[i16] })  =>  (INC16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*  1385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16r),
     /*  1388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1390 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1395 */     GIR_RootConstrainSelectedInstOperands,
     /*  1396 */     // GIR_Coverage, 23287,
     /*  1396 */     GIR_EraseRootFromParent_Done,
     /*  1397 */   // Label 100: @1397
     /*  1397 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1421), // Rule ID 23291 //
     /*  1402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*  1405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  1409 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (DEC16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*  1409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16r),
     /*  1412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1414 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1419 */     GIR_RootConstrainSelectedInstOperands,
     /*  1420 */     // GIR_Coverage, 23291,
     /*  1420 */     GIR_EraseRootFromParent_Done,
     /*  1421 */   // Label 101: @1421
     /*  1421 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1445), // Rule ID 23377 //
     /*  1426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*  1429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  1433 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, 1:{ *:[i16] })  =>  (INC16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*  1433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16r_ND),
     /*  1436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1438 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1443 */     GIR_RootConstrainSelectedInstOperands,
     /*  1444 */     // GIR_Coverage, 23377,
     /*  1444 */     GIR_EraseRootFromParent_Done,
     /*  1445 */   // Label 102: @1445
     /*  1445 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1469), // Rule ID 23381 //
     /*  1450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*  1453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  1457 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (DEC16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*  1457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16r_ND),
     /*  1460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1462 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1467 */     GIR_RootConstrainSelectedInstOperands,
     /*  1468 */     // GIR_Coverage, 23381,
     /*  1468 */     GIR_EraseRootFromParent_Done,
     /*  1469 */   // Label 103: @1469
     /*  1469 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1502), // Rule ID 23225 //
     /*  1474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1485 */     // MIs[1] Operand 1
     /*  1485 */     // No operand predicates
     /*  1485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1487 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (ADD16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  1487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri),
     /*  1490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1492 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  1497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1500 */     GIR_RootConstrainSelectedInstOperands,
     /*  1501 */     // GIR_Coverage, 23225,
     /*  1501 */     GIR_EraseRootFromParent_Done,
     /*  1502 */   // Label 104: @1502
     /*  1502 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1535), // Rule ID 23315 //
     /*  1507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1518 */     // MIs[1] Operand 1
     /*  1518 */     // No operand predicates
     /*  1518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1520 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (ADD16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  1520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri_ND),
     /*  1523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1525 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  1530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1533 */     GIR_RootConstrainSelectedInstOperands,
     /*  1534 */     // GIR_Coverage, 23315,
     /*  1534 */     GIR_EraseRootFromParent_Done,
     /*  1535 */   // Label 105: @1535
     /*  1535 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1560), // Rule ID 23217 //
     /*  1540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  1547 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (ADD16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  1547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD16rr),
     /*  1552 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  1558 */     GIR_RootConstrainSelectedInstOperands,
     /*  1559 */     // GIR_Coverage, 23217,
     /*  1559 */     GIR_Done,
     /*  1560 */   // Label 106: @1560
     /*  1560 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1585), // Rule ID 23307 //
     /*  1565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  1572 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (ADD16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  1572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD16rr_ND),
     /*  1577 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  1583 */     GIR_RootConstrainSelectedInstOperands,
     /*  1584 */     // GIR_Coverage, 23307,
     /*  1584 */     GIR_Done,
     /*  1585 */   // Label 107: @1585
     /*  1585 */   GIM_Reject,
     /*  1586 */ // Label 97: @1586
     /*  1586 */ GIM_Reject,
     /*  1587 */ // Label 73: @1587
     /*  1587 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1887),
     /*  1592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  1595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  1598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  1602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  1606 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1640), // Rule ID 23027 //
     /*  1611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1614 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*  1625 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, 128:{ *:[i32] })  =>  (SUB32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -128:{ *:[i32] })
     /*  1625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri),
     /*  1628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1630 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  1635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1638 */     GIR_RootConstrainSelectedInstOperands,
     /*  1639 */     // GIR_Coverage, 23027,
     /*  1639 */     GIR_EraseRootFromParent_Done,
     /*  1640 */   // Label 109: @1640
     /*  1640 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1674), // Rule ID 23033 //
     /*  1645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1648 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*  1659 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, 128:{ *:[i32] })  =>  (SUB32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -128:{ *:[i32] })
     /*  1659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri_ND),
     /*  1662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1664 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  1669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1672 */     GIR_RootConstrainSelectedInstOperands,
     /*  1673 */     // GIR_Coverage, 23033,
     /*  1673 */     GIR_EraseRootFromParent_Done,
     /*  1674 */   // Label 110: @1674
     /*  1674 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1698), // Rule ID 23288 //
     /*  1679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*  1682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  1686 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (INC32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  1686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32r),
     /*  1689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1691 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1696 */     GIR_RootConstrainSelectedInstOperands,
     /*  1697 */     // GIR_Coverage, 23288,
     /*  1697 */     GIR_EraseRootFromParent_Done,
     /*  1698 */   // Label 111: @1698
     /*  1698 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1722), // Rule ID 23292 //
     /*  1703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*  1706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  1710 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (DEC32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  1710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32r),
     /*  1713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1720 */     GIR_RootConstrainSelectedInstOperands,
     /*  1721 */     // GIR_Coverage, 23292,
     /*  1721 */     GIR_EraseRootFromParent_Done,
     /*  1722 */   // Label 112: @1722
     /*  1722 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1746), // Rule ID 23378 //
     /*  1727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*  1730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  1734 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (INC32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  1734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32r_ND),
     /*  1737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1739 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1744 */     GIR_RootConstrainSelectedInstOperands,
     /*  1745 */     // GIR_Coverage, 23378,
     /*  1745 */     GIR_EraseRootFromParent_Done,
     /*  1746 */   // Label 113: @1746
     /*  1746 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1770), // Rule ID 23382 //
     /*  1751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*  1754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  1758 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (DEC32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  1758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32r_ND),
     /*  1761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1763 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1768 */     GIR_RootConstrainSelectedInstOperands,
     /*  1769 */     // GIR_Coverage, 23382,
     /*  1769 */     GIR_EraseRootFromParent_Done,
     /*  1770 */   // Label 114: @1770
     /*  1770 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1803), // Rule ID 23226 //
     /*  1775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1786 */     // MIs[1] Operand 1
     /*  1786 */     // No operand predicates
     /*  1786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1788 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (ADD32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  1788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri),
     /*  1791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1793 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  1798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1801 */     GIR_RootConstrainSelectedInstOperands,
     /*  1802 */     // GIR_Coverage, 23226,
     /*  1802 */     GIR_EraseRootFromParent_Done,
     /*  1803 */   // Label 115: @1803
     /*  1803 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1836), // Rule ID 23316 //
     /*  1808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1819 */     // MIs[1] Operand 1
     /*  1819 */     // No operand predicates
     /*  1819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1821 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (ADD32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  1821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri_ND),
     /*  1824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1826 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  1831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1834 */     GIR_RootConstrainSelectedInstOperands,
     /*  1835 */     // GIR_Coverage, 23316,
     /*  1835 */     GIR_EraseRootFromParent_Done,
     /*  1836 */   // Label 116: @1836
     /*  1836 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1861), // Rule ID 23218 //
     /*  1841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  1848 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (ADD32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  1848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD32rr),
     /*  1853 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  1859 */     GIR_RootConstrainSelectedInstOperands,
     /*  1860 */     // GIR_Coverage, 23218,
     /*  1860 */     GIR_Done,
     /*  1861 */   // Label 117: @1861
     /*  1861 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1886), // Rule ID 23308 //
     /*  1866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  1873 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (ADD32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  1873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD32rr_ND),
     /*  1878 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  1884 */     GIR_RootConstrainSelectedInstOperands,
     /*  1885 */     // GIR_Coverage, 23308,
     /*  1885 */     GIR_Done,
     /*  1886 */   // Label 118: @1886
     /*  1886 */   GIM_Reject,
     /*  1887 */ // Label 108: @1887
     /*  1887 */ GIM_Reject,
     /*  1888 */ // Label 74: @1888
     /*  1888 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(2278),
     /*  1893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  1896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  1899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  1903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  1907 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1941), // Rule ID 23028 //
     /*  1912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1915 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*  1926 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 128:{ *:[i64] })  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -128:{ *:[i64] })
     /*  1926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*  1929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1931 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  1936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1939 */     GIR_RootConstrainSelectedInstOperands,
     /*  1940 */     // GIR_Coverage, 23028,
     /*  1940 */     GIR_EraseRootFromParent_Done,
     /*  1941 */   // Label 120: @1941
     /*  1941 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1975), // Rule ID 23034 //
     /*  1946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1949 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*  1960 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 128:{ *:[i64] })  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -128:{ *:[i64] })
     /*  1960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*  1963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1965 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  1970 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1973 */     GIR_RootConstrainSelectedInstOperands,
     /*  1974 */     // GIR_Coverage, 23034,
     /*  1974 */     GIR_EraseRootFromParent_Done,
     /*  1975 */   // Label 121: @1975
     /*  1975 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(2016), // Rule ID 23044 //
     /*  1980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1983 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*  1994 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 2147483648:{ *:[i64] })  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -2147483648:{ *:[i64] })
     /*  1994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*  1997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  2001 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*  2011 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  2014 */     GIR_RootConstrainSelectedInstOperands,
     /*  2015 */     // GIR_Coverage, 23044,
     /*  2015 */     GIR_EraseRootFromParent_Done,
     /*  2016 */   // Label 122: @2016
     /*  2016 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(2057), // Rule ID 23046 //
     /*  2021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  2024 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*  2035 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 2147483648:{ *:[i64] })  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -2147483648:{ *:[i64] })
     /*  2035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*  2038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2040 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  2042 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*  2052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  2055 */     GIR_RootConstrainSelectedInstOperands,
     /*  2056 */     // GIR_Coverage, 23046,
     /*  2056 */     GIR_EraseRootFromParent_Done,
     /*  2057 */   // Label 123: @2057
     /*  2057 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(2081), // Rule ID 23289 //
     /*  2062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*  2065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  2069 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] })  =>  (INC64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  2069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64r),
     /*  2072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2074 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  2076 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  2079 */     GIR_RootConstrainSelectedInstOperands,
     /*  2080 */     // GIR_Coverage, 23289,
     /*  2080 */     GIR_EraseRootFromParent_Done,
     /*  2081 */   // Label 124: @2081
     /*  2081 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(2105), // Rule ID 23293 //
     /*  2086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*  2089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  2093 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] })  =>  (DEC64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  2093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64r),
     /*  2096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2098 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  2100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  2103 */     GIR_RootConstrainSelectedInstOperands,
     /*  2104 */     // GIR_Coverage, 23293,
     /*  2104 */     GIR_EraseRootFromParent_Done,
     /*  2105 */   // Label 125: @2105
     /*  2105 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(2129), // Rule ID 23379 //
     /*  2110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*  2113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  2117 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] })  =>  (INC64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  2117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64r_ND),
     /*  2120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2122 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  2124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  2127 */     GIR_RootConstrainSelectedInstOperands,
     /*  2128 */     // GIR_Coverage, 23379,
     /*  2128 */     GIR_EraseRootFromParent_Done,
     /*  2129 */   // Label 126: @2129
     /*  2129 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(2153), // Rule ID 23383 //
     /*  2134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*  2137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  2141 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] })  =>  (DEC64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  2141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64r_ND),
     /*  2144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2146 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  2148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  2151 */     GIR_RootConstrainSelectedInstOperands,
     /*  2152 */     // GIR_Coverage, 23383,
     /*  2152 */     GIR_EraseRootFromParent_Done,
     /*  2153 */   // Label 127: @2153
     /*  2153 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(2190), // Rule ID 23227 //
     /*  2158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  2161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  2169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  2173 */     // MIs[1] Operand 1
     /*  2173 */     // No operand predicates
     /*  2173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2175 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (ADD64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  2175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64ri32),
     /*  2178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2180 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  2182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  2185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  2188 */     GIR_RootConstrainSelectedInstOperands,
     /*  2189 */     // GIR_Coverage, 23227,
     /*  2189 */     GIR_EraseRootFromParent_Done,
     /*  2190 */   // Label 128: @2190
     /*  2190 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(2227), // Rule ID 23317 //
     /*  2195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  2198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  2206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  2210 */     // MIs[1] Operand 1
     /*  2210 */     // No operand predicates
     /*  2210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2212 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (ADD64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  2212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64ri32_ND),
     /*  2215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2217 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  2219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  2222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  2225 */     GIR_RootConstrainSelectedInstOperands,
     /*  2226 */     // GIR_Coverage, 23317,
     /*  2226 */     GIR_EraseRootFromParent_Done,
     /*  2227 */   // Label 129: @2227
     /*  2227 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(2252), // Rule ID 23219 //
     /*  2232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  2235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  2239 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (ADD64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  2239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD64rr),
     /*  2244 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  2250 */     GIR_RootConstrainSelectedInstOperands,
     /*  2251 */     // GIR_Coverage, 23219,
     /*  2251 */     GIR_Done,
     /*  2252 */   // Label 130: @2252
     /*  2252 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(2277), // Rule ID 23309 //
     /*  2257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  2260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  2264 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (ADD64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  2264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD64rr_ND),
     /*  2269 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  2275 */     GIR_RootConstrainSelectedInstOperands,
     /*  2276 */     // GIR_Coverage, 23309,
     /*  2276 */     GIR_Done,
     /*  2277 */   // Label 131: @2277
     /*  2277 */   GIM_Reject,
     /*  2278 */ // Label 119: @2278
     /*  2278 */ GIM_Reject,
     /*  2279 */ // Label 75: @2279
     /*  2279 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2372),
     /*  2284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  2287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  2290 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2317), // Rule ID 2537 //
     /*  2295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  2298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2310 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPADDQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  2310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQrr),
     /*  2315 */     GIR_RootConstrainSelectedInstOperands,
     /*  2316 */     // GIR_Coverage, 2537,
     /*  2316 */     GIR_Done,
     /*  2317 */   // Label 133: @2317
     /*  2317 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2344), // Rule ID 2539 //
     /*  2322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  2325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2337 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PADDQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  2337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDQrr),
     /*  2342 */     GIR_RootConstrainSelectedInstOperands,
     /*  2343 */     // GIR_Coverage, 2539,
     /*  2343 */     GIR_Done,
     /*  2344 */   // Label 134: @2344
     /*  2344 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2371), // Rule ID 4648 //
     /*  2349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  2352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2364 */     // (add:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPADDQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  2364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rr),
     /*  2369 */     GIR_RootConstrainSelectedInstOperands,
     /*  2370 */     // GIR_Coverage, 4648,
     /*  2370 */     GIR_Done,
     /*  2371 */   // Label 135: @2371
     /*  2371 */   GIM_Reject,
     /*  2372 */ // Label 132: @2372
     /*  2372 */ GIM_Reject,
     /*  2373 */ // Label 76: @2373
     /*  2373 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2588),
     /*  2378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  2381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  2384 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2445), // Rule ID 18314 //
     /*  2389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  2392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  2400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  2408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  2412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2428 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2), VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  2428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*  2431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  2437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  2441 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*  2443 */     GIR_RootConstrainSelectedInstOperands,
     /*  2444 */     // GIR_Coverage, 18314,
     /*  2444 */     GIR_EraseRootFromParent_Done,
     /*  2445 */   // Label 137: @2445
     /*  2445 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2506), // Rule ID 25614 //
     /*  2450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  2453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  2473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  2477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2489 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src3, (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2))  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  2489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*  2492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  2498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  2502 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*  2504 */     GIR_RootConstrainSelectedInstOperands,
     /*  2505 */     // GIR_Coverage, 25614,
     /*  2505 */     GIR_EraseRootFromParent_Done,
     /*  2506 */   // Label 138: @2506
     /*  2506 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2533), // Rule ID 2531 //
     /*  2511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  2514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2526 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPADDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  2526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDrr),
     /*  2531 */     GIR_RootConstrainSelectedInstOperands,
     /*  2532 */     // GIR_Coverage, 2531,
     /*  2532 */     GIR_Done,
     /*  2533 */   // Label 139: @2533
     /*  2533 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2560), // Rule ID 2533 //
     /*  2538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  2541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2553 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PADDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  2553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDDrr),
     /*  2558 */     GIR_RootConstrainSelectedInstOperands,
     /*  2559 */     // GIR_Coverage, 2533,
     /*  2559 */     GIR_Done,
     /*  2560 */   // Label 140: @2560
     /*  2560 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2587), // Rule ID 4675 //
     /*  2565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  2568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2580 */     // (add:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPADDDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  2580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rr),
     /*  2585 */     GIR_RootConstrainSelectedInstOperands,
     /*  2586 */     // GIR_Coverage, 4675,
     /*  2586 */     GIR_Done,
     /*  2587 */   // Label 141: @2587
     /*  2587 */   GIM_Reject,
     /*  2588 */ // Label 136: @2588
     /*  2588 */ GIM_Reject,
     /*  2589 */ // Label 77: @2589
     /*  2589 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2655),
     /*  2594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  2597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  2600 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2627), // Rule ID 2541 //
     /*  2605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  2608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  2612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  2616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  2620 */     // (add:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPADDQYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  2620 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQYrr),
     /*  2625 */     GIR_RootConstrainSelectedInstOperands,
     /*  2626 */     // GIR_Coverage, 2541,
     /*  2626 */     GIR_Done,
     /*  2627 */   // Label 143: @2627
     /*  2627 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2654), // Rule ID 4639 //
     /*  2632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  2635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  2639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  2643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  2647 */     // (add:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPADDQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  2647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rr),
     /*  2652 */     GIR_RootConstrainSelectedInstOperands,
     /*  2653 */     // GIR_Coverage, 4639,
     /*  2653 */     GIR_Done,
     /*  2654 */   // Label 144: @2654
     /*  2654 */   GIM_Reject,
     /*  2655 */ // Label 142: @2655
     /*  2655 */ GIM_Reject,
     /*  2656 */ // Label 78: @2656
     /*  2656 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2871),
     /*  2661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2667 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2728), // Rule ID 18313 //
     /*  2672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  2675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  2683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2711 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2), VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  2711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*  2714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  2720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  2724 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*  2726 */     GIR_RootConstrainSelectedInstOperands,
     /*  2727 */     // GIR_Coverage, 18313,
     /*  2727 */     GIR_EraseRootFromParent_Done,
     /*  2728 */   // Label 146: @2728
     /*  2728 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2789), // Rule ID 25613 //
     /*  2733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  2736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2772 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src3, (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2))  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  2772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*  2775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  2781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  2785 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*  2787 */     GIR_RootConstrainSelectedInstOperands,
     /*  2788 */     // GIR_Coverage, 25613,
     /*  2788 */     GIR_EraseRootFromParent_Done,
     /*  2789 */   // Label 147: @2789
     /*  2789 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2816), // Rule ID 2525 //
     /*  2794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  2797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2809 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  2809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWrr),
     /*  2814 */     GIR_RootConstrainSelectedInstOperands,
     /*  2815 */     // GIR_Coverage, 2525,
     /*  2815 */     GIR_Done,
     /*  2816 */   // Label 148: @2816
     /*  2816 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2843), // Rule ID 2527 //
     /*  2821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  2824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2836 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  2836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDWrr),
     /*  2841 */     GIR_RootConstrainSelectedInstOperands,
     /*  2842 */     // GIR_Coverage, 2527,
     /*  2842 */     GIR_Done,
     /*  2843 */   // Label 149: @2843
     /*  2843 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2870), // Rule ID 4696 //
     /*  2848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  2851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2863 */     // (add:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  2863 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rr),
     /*  2868 */     GIR_RootConstrainSelectedInstOperands,
     /*  2869 */     // GIR_Coverage, 4696,
     /*  2869 */     GIR_Done,
     /*  2870 */   // Label 150: @2870
     /*  2870 */   GIM_Reject,
     /*  2871 */ // Label 145: @2871
     /*  2871 */ GIM_Reject,
     /*  2872 */ // Label 79: @2872
     /*  2872 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2938),
     /*  2877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  2880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  2883 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2910), // Rule ID 2535 //
     /*  2888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  2891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  2895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  2899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  2903 */     // (add:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPADDDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  2903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDYrr),
     /*  2908 */     GIR_RootConstrainSelectedInstOperands,
     /*  2909 */     // GIR_Coverage, 2535,
     /*  2909 */     GIR_Done,
     /*  2910 */   // Label 152: @2910
     /*  2910 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2937), // Rule ID 4666 //
     /*  2915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  2918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  2922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  2926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  2930 */     // (add:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPADDDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  2930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rr),
     /*  2935 */     GIR_RootConstrainSelectedInstOperands,
     /*  2936 */     // GIR_Coverage, 4666,
     /*  2936 */     GIR_Done,
     /*  2937 */   // Label 153: @2937
     /*  2937 */   GIM_Reject,
     /*  2938 */ // Label 151: @2938
     /*  2938 */ GIM_Reject,
     /*  2939 */ // Label 80: @2939
     /*  2939 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2972), // Rule ID 4630 //
     /*  2944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  2947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  2950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  2953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  2957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  2961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  2965 */   // (add:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPADDQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  2965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZrr),
     /*  2970 */   GIR_RootConstrainSelectedInstOperands,
     /*  2971 */   // GIR_Coverage, 4630,
     /*  2971 */   GIR_Done,
     /*  2972 */ // Label 154: @2972
     /*  2972 */ GIM_Reject,
     /*  2973 */ // Label 81: @2973
     /*  2973 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(3066),
     /*  2978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2984 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(3011), // Rule ID 2519 //
     /*  2989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  2992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  3000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  3004 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  3004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBrr),
     /*  3009 */     GIR_RootConstrainSelectedInstOperands,
     /*  3010 */     // GIR_Coverage, 2519,
     /*  3010 */     GIR_Done,
     /*  3011 */   // Label 156: @3011
     /*  3011 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(3038), // Rule ID 2521 //
     /*  3016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  3019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  3023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  3027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  3031 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  3031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDBrr),
     /*  3036 */     GIR_RootConstrainSelectedInstOperands,
     /*  3037 */     // GIR_Coverage, 2521,
     /*  3037 */     GIR_Done,
     /*  3038 */   // Label 157: @3038
     /*  3038 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(3065), // Rule ID 4714 //
     /*  3043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  3046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  3050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  3054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  3058 */     // (add:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  3058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rr),
     /*  3063 */     GIR_RootConstrainSelectedInstOperands,
     /*  3064 */     // GIR_Coverage, 4714,
     /*  3064 */     GIR_Done,
     /*  3065 */   // Label 158: @3065
     /*  3065 */   GIM_Reject,
     /*  3066 */ // Label 155: @3066
     /*  3066 */ GIM_Reject,
     /*  3067 */ // Label 82: @3067
     /*  3067 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(3133),
     /*  3072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  3075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  3078 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(3105), // Rule ID 2529 //
     /*  3083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  3086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  3090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  3094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  3098 */     // (add:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  3098 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWYrr),
     /*  3103 */     GIR_RootConstrainSelectedInstOperands,
     /*  3104 */     // GIR_Coverage, 2529,
     /*  3104 */     GIR_Done,
     /*  3105 */   // Label 160: @3105
     /*  3105 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(3132), // Rule ID 4690 //
     /*  3110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  3113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  3117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  3121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  3125 */     // (add:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  3125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rr),
     /*  3130 */     GIR_RootConstrainSelectedInstOperands,
     /*  3131 */     // GIR_Coverage, 4690,
     /*  3131 */     GIR_Done,
     /*  3132 */   // Label 161: @3132
     /*  3132 */   GIM_Reject,
     /*  3133 */ // Label 159: @3133
     /*  3133 */ GIM_Reject,
     /*  3134 */ // Label 83: @3134
     /*  3134 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(3167), // Rule ID 4657 //
     /*  3139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  3142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  3145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  3148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3160 */   // (add:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPADDDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  3160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZrr),
     /*  3165 */   GIR_RootConstrainSelectedInstOperands,
     /*  3166 */   // GIR_Coverage, 4657,
     /*  3166 */   GIR_Done,
     /*  3167 */ // Label 162: @3167
     /*  3167 */ GIM_Reject,
     /*  3168 */ // Label 84: @3168
     /*  3168 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(3234),
     /*  3173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  3176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  3179 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(3206), // Rule ID 2523 //
     /*  3184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  3187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  3191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  3195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  3199 */     // (add:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  3199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBYrr),
     /*  3204 */     GIR_RootConstrainSelectedInstOperands,
     /*  3205 */     // GIR_Coverage, 2523,
     /*  3205 */     GIR_Done,
     /*  3206 */   // Label 164: @3206
     /*  3206 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(3233), // Rule ID 4708 //
     /*  3211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  3214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  3218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  3222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  3226 */     // (add:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  3226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rr),
     /*  3231 */     GIR_RootConstrainSelectedInstOperands,
     /*  3232 */     // GIR_Coverage, 4708,
     /*  3232 */     GIR_Done,
     /*  3233 */   // Label 165: @3233
     /*  3233 */   GIM_Reject,
     /*  3234 */ // Label 163: @3234
     /*  3234 */ GIM_Reject,
     /*  3235 */ // Label 85: @3235
     /*  3235 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(3268), // Rule ID 4684 //
     /*  3240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  3243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  3246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  3249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3257 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3261 */   // (add:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  3261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZrr),
     /*  3266 */   GIR_RootConstrainSelectedInstOperands,
     /*  3267 */   // GIR_Coverage, 4684,
     /*  3267 */   GIR_Done,
     /*  3268 */ // Label 166: @3268
     /*  3268 */ GIM_Reject,
     /*  3269 */ // Label 86: @3269
     /*  3269 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(3302), // Rule ID 4702 //
     /*  3274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  3277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  3280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  3283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3295 */   // (add:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  3295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZrr),
     /*  3300 */   GIR_RootConstrainSelectedInstOperands,
     /*  3301 */   // GIR_Coverage, 4702,
     /*  3301 */   GIR_Done,
     /*  3302 */ // Label 167: @3302
     /*  3302 */ GIM_Reject,
     /*  3303 */ // Label 87: @3303
     /*  3303 */ GIM_Reject,
     /*  3304 */ // Label 1: @3304
     /*  3304 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 184*/ GIMT_Encode4(5119),
     /*  3315 */ /*GILLT_s8*//*Label 168*/ GIMT_Encode4(3411),
     /*  3319 */ /*GILLT_s16*//*Label 169*/ GIMT_Encode4(3641),
     /*  3323 */ /*GILLT_s32*//*Label 170*/ GIMT_Encode4(3871),
     /*  3327 */ /*GILLT_s64*//*Label 171*/ GIMT_Encode4(4101), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  3343 */ /*GILLT_v2s64*//*Label 172*/ GIMT_Encode4(4339), GIMT_Encode4(0),
     /*  3351 */ /*GILLT_v4s32*//*Label 173*/ GIMT_Encode4(4433),
     /*  3355 */ /*GILLT_v4s64*//*Label 174*/ GIMT_Encode4(4527), GIMT_Encode4(0),
     /*  3363 */ /*GILLT_v8s16*//*Label 175*/ GIMT_Encode4(4594),
     /*  3367 */ /*GILLT_v8s32*//*Label 176*/ GIMT_Encode4(4688),
     /*  3371 */ /*GILLT_v8s64*//*Label 177*/ GIMT_Encode4(4755), GIMT_Encode4(0),
     /*  3379 */ /*GILLT_v16s8*//*Label 178*/ GIMT_Encode4(4789),
     /*  3383 */ /*GILLT_v16s16*//*Label 179*/ GIMT_Encode4(4883),
     /*  3387 */ /*GILLT_v16s32*//*Label 180*/ GIMT_Encode4(4950), GIMT_Encode4(0),
     /*  3395 */ /*GILLT_v32s8*//*Label 181*/ GIMT_Encode4(4984),
     /*  3399 */ /*GILLT_v32s16*//*Label 182*/ GIMT_Encode4(5051), GIMT_Encode4(0),
     /*  3407 */ /*GILLT_v64s8*//*Label 183*/ GIMT_Encode4(5085),
     /*  3411 */ // Label 168: @3411
     /*  3411 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(3640),
     /*  3416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  3419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  3422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3426 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(3454), // Rule ID 239 //
     /*  3431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  3434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3442 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /*  3442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r),
     /*  3445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3447 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3452 */     GIR_RootConstrainSelectedInstOperands,
     /*  3453 */     // GIR_Coverage, 239,
     /*  3453 */     GIR_EraseRootFromParent_Done,
     /*  3454 */   // Label 186: @3454
     /*  3454 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(3482), // Rule ID 247 //
     /*  3459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  3462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3470 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /*  3470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r_ND),
     /*  3473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3475 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3480 */     GIR_RootConstrainSelectedInstOperands,
     /*  3481 */     // GIR_Coverage, 247,
     /*  3481 */     GIR_EraseRootFromParent_Done,
     /*  3482 */   // Label 187: @3482
     /*  3482 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(3507), // Rule ID 255 //
     /*  3487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  3490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3498 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r_NF_ND:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*  3498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r_NF_ND),
     /*  3501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3503 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3505 */     GIR_RootConstrainSelectedInstOperands,
     /*  3506 */     // GIR_Coverage, 255,
     /*  3506 */     GIR_EraseRootFromParent_Done,
     /*  3507 */   // Label 188: @3507
     /*  3507 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(3544), // Rule ID 23236 //
     /*  3512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  3515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  3523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  3527 */     // MIs[1] Operand 1
     /*  3527 */     // No operand predicates
     /*  3527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  3529 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SUB8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  3529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8ri),
     /*  3532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3534 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  3536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  3539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3542 */     GIR_RootConstrainSelectedInstOperands,
     /*  3543 */     // GIR_Coverage, 23236,
     /*  3543 */     GIR_EraseRootFromParent_Done,
     /*  3544 */   // Label 189: @3544
     /*  3544 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(3581), // Rule ID 23326 //
     /*  3549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  3552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  3560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  3564 */     // MIs[1] Operand 1
     /*  3564 */     // No operand predicates
     /*  3564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  3566 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SUB8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  3566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8ri_ND),
     /*  3569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3571 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  3573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  3576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3579 */     GIR_RootConstrainSelectedInstOperands,
     /*  3580 */     // GIR_Coverage, 23326,
     /*  3580 */     GIR_EraseRootFromParent_Done,
     /*  3581 */   // Label 190: @3581
     /*  3581 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(3610), // Rule ID 23228 //
     /*  3586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  3589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3597 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SUB8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  3597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB8rr),
     /*  3602 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  3608 */     GIR_RootConstrainSelectedInstOperands,
     /*  3609 */     // GIR_Coverage, 23228,
     /*  3609 */     GIR_Done,
     /*  3610 */   // Label 191: @3610
     /*  3610 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(3639), // Rule ID 23318 //
     /*  3615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  3618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3626 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SUB8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  3626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB8rr_ND),
     /*  3631 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  3637 */     GIR_RootConstrainSelectedInstOperands,
     /*  3638 */     // GIR_Coverage, 23318,
     /*  3638 */     GIR_Done,
     /*  3639 */   // Label 192: @3639
     /*  3639 */   GIM_Reject,
     /*  3640 */ // Label 185: @3640
     /*  3640 */ GIM_Reject,
     /*  3641 */ // Label 169: @3641
     /*  3641 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(3870),
     /*  3646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  3649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  3652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3656 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(3684), // Rule ID 240 //
     /*  3661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  3664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3672 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /*  3672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r),
     /*  3675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3677 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3682 */     GIR_RootConstrainSelectedInstOperands,
     /*  3683 */     // GIR_Coverage, 240,
     /*  3683 */     GIR_EraseRootFromParent_Done,
     /*  3684 */   // Label 194: @3684
     /*  3684 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(3712), // Rule ID 248 //
     /*  3689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  3692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3700 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /*  3700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r_ND),
     /*  3703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3705 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3710 */     GIR_RootConstrainSelectedInstOperands,
     /*  3711 */     // GIR_Coverage, 248,
     /*  3711 */     GIR_EraseRootFromParent_Done,
     /*  3712 */   // Label 195: @3712
     /*  3712 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(3737), // Rule ID 256 //
     /*  3717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  3720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3728 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r_NF_ND:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*  3728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r_NF_ND),
     /*  3731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3733 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3735 */     GIR_RootConstrainSelectedInstOperands,
     /*  3736 */     // GIR_Coverage, 256,
     /*  3736 */     GIR_EraseRootFromParent_Done,
     /*  3737 */   // Label 196: @3737
     /*  3737 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(3774), // Rule ID 23237 //
     /*  3742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  3745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  3753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  3757 */     // MIs[1] Operand 1
     /*  3757 */     // No operand predicates
     /*  3757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  3759 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (SUB16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  3759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri),
     /*  3762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3764 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  3766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  3769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3772 */     GIR_RootConstrainSelectedInstOperands,
     /*  3773 */     // GIR_Coverage, 23237,
     /*  3773 */     GIR_EraseRootFromParent_Done,
     /*  3774 */   // Label 197: @3774
     /*  3774 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(3811), // Rule ID 23327 //
     /*  3779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  3782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  3790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  3794 */     // MIs[1] Operand 1
     /*  3794 */     // No operand predicates
     /*  3794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  3796 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (SUB16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  3796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri_ND),
     /*  3799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3801 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  3803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  3806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3809 */     GIR_RootConstrainSelectedInstOperands,
     /*  3810 */     // GIR_Coverage, 23327,
     /*  3810 */     GIR_EraseRootFromParent_Done,
     /*  3811 */   // Label 198: @3811
     /*  3811 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(3840), // Rule ID 23229 //
     /*  3816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  3819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3827 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (SUB16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  3827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB16rr),
     /*  3832 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  3838 */     GIR_RootConstrainSelectedInstOperands,
     /*  3839 */     // GIR_Coverage, 23229,
     /*  3839 */     GIR_Done,
     /*  3840 */   // Label 199: @3840
     /*  3840 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(3869), // Rule ID 23319 //
     /*  3845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  3848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3856 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (SUB16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  3856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB16rr_ND),
     /*  3861 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  3867 */     GIR_RootConstrainSelectedInstOperands,
     /*  3868 */     // GIR_Coverage, 23319,
     /*  3868 */     GIR_Done,
     /*  3869 */   // Label 200: @3869
     /*  3869 */   GIM_Reject,
     /*  3870 */ // Label 193: @3870
     /*  3870 */ GIM_Reject,
     /*  3871 */ // Label 170: @3871
     /*  3871 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(4100),
     /*  3876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  3879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  3882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  3886 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3914), // Rule ID 241 //
     /*  3891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  3894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  3902 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  3902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r),
     /*  3905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3907 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3912 */     GIR_RootConstrainSelectedInstOperands,
     /*  3913 */     // GIR_Coverage, 241,
     /*  3913 */     GIR_EraseRootFromParent_Done,
     /*  3914 */   // Label 202: @3914
     /*  3914 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(3942), // Rule ID 249 //
     /*  3919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  3922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  3930 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  3930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r_ND),
     /*  3933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3935 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3940 */     GIR_RootConstrainSelectedInstOperands,
     /*  3941 */     // GIR_Coverage, 249,
     /*  3941 */     GIR_EraseRootFromParent_Done,
     /*  3942 */   // Label 203: @3942
     /*  3942 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(3967), // Rule ID 257 //
     /*  3947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  3950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  3958 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r_NF_ND:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  3958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r_NF_ND),
     /*  3961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3963 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3965 */     GIR_RootConstrainSelectedInstOperands,
     /*  3966 */     // GIR_Coverage, 257,
     /*  3966 */     GIR_EraseRootFromParent_Done,
     /*  3967 */   // Label 204: @3967
     /*  3967 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(4004), // Rule ID 23238 //
     /*  3972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  3975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  3979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  3983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  3987 */     // MIs[1] Operand 1
     /*  3987 */     // No operand predicates
     /*  3987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  3989 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (SUB32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  3989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri),
     /*  3992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3994 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  3996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  3999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  4002 */     GIR_RootConstrainSelectedInstOperands,
     /*  4003 */     // GIR_Coverage, 23238,
     /*  4003 */     GIR_EraseRootFromParent_Done,
     /*  4004 */   // Label 205: @4004
     /*  4004 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(4041), // Rule ID 23328 //
     /*  4009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  4012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  4016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4024 */     // MIs[1] Operand 1
     /*  4024 */     // No operand predicates
     /*  4024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4026 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (SUB32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  4026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri_ND),
     /*  4029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  4031 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  4033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  4036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  4039 */     GIR_RootConstrainSelectedInstOperands,
     /*  4040 */     // GIR_Coverage, 23328,
     /*  4040 */     GIR_EraseRootFromParent_Done,
     /*  4041 */   // Label 206: @4041
     /*  4041 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(4070), // Rule ID 23230 //
     /*  4046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  4049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  4053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  4057 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (SUB32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  4057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB32rr),
     /*  4062 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  4068 */     GIR_RootConstrainSelectedInstOperands,
     /*  4069 */     // GIR_Coverage, 23230,
     /*  4069 */     GIR_Done,
     /*  4070 */   // Label 207: @4070
     /*  4070 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(4099), // Rule ID 23320 //
     /*  4075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  4078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  4082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  4086 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (SUB32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  4086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB32rr_ND),
     /*  4091 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  4097 */     GIR_RootConstrainSelectedInstOperands,
     /*  4098 */     // GIR_Coverage, 23320,
     /*  4098 */     GIR_Done,
     /*  4099 */   // Label 208: @4099
     /*  4099 */   GIM_Reject,
     /*  4100 */ // Label 201: @4100
     /*  4100 */ GIM_Reject,
     /*  4101 */ // Label 171: @4101
     /*  4101 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(4338),
     /*  4106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  4109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  4112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4116 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(4144), // Rule ID 242 //
     /*  4121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  4124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  4128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4132 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /*  4132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r),
     /*  4135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  4137 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  4139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  4142 */     GIR_RootConstrainSelectedInstOperands,
     /*  4143 */     // GIR_Coverage, 242,
     /*  4143 */     GIR_EraseRootFromParent_Done,
     /*  4144 */   // Label 210: @4144
     /*  4144 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(4172), // Rule ID 250 //
     /*  4149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  4152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  4156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4160 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /*  4160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r_ND),
     /*  4163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  4165 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  4167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  4170 */     GIR_RootConstrainSelectedInstOperands,
     /*  4171 */     // GIR_Coverage, 250,
     /*  4171 */     GIR_EraseRootFromParent_Done,
     /*  4172 */   // Label 211: @4172
     /*  4172 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(4197), // Rule ID 258 //
     /*  4177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  4180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  4184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4188 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r_NF_ND:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*  4188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r_NF_ND),
     /*  4191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  4193 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  4195 */     GIR_RootConstrainSelectedInstOperands,
     /*  4196 */     // GIR_Coverage, 258,
     /*  4196 */     GIR_EraseRootFromParent_Done,
     /*  4197 */   // Label 212: @4197
     /*  4197 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(4238), // Rule ID 23239 //
     /*  4202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  4205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  4221 */     // MIs[1] Operand 1
     /*  4221 */     // No operand predicates
     /*  4221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4223 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  4223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*  4226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  4228 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  4230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  4233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  4236 */     GIR_RootConstrainSelectedInstOperands,
     /*  4237 */     // GIR_Coverage, 23239,
     /*  4237 */     GIR_EraseRootFromParent_Done,
     /*  4238 */   // Label 213: @4238
     /*  4238 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(4279), // Rule ID 23329 //
     /*  4243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  4246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  4262 */     // MIs[1] Operand 1
     /*  4262 */     // No operand predicates
     /*  4262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4264 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  4264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*  4267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  4269 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  4271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  4274 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  4277 */     GIR_RootConstrainSelectedInstOperands,
     /*  4278 */     // GIR_Coverage, 23329,
     /*  4278 */     GIR_EraseRootFromParent_Done,
     /*  4279 */   // Label 214: @4279
     /*  4279 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(4308), // Rule ID 23231 //
     /*  4284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  4287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4295 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (SUB64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  4295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB64rr),
     /*  4300 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  4306 */     GIR_RootConstrainSelectedInstOperands,
     /*  4307 */     // GIR_Coverage, 23231,
     /*  4307 */     GIR_Done,
     /*  4308 */   // Label 215: @4308
     /*  4308 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(4337), // Rule ID 23321 //
     /*  4313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  4316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4324 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (SUB64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  4324 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB64rr_ND),
     /*  4329 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  4335 */     GIR_RootConstrainSelectedInstOperands,
     /*  4336 */     // GIR_Coverage, 23321,
     /*  4336 */     GIR_Done,
     /*  4337 */   // Label 216: @4337
     /*  4337 */   GIM_Reject,
     /*  4338 */ // Label 209: @4338
     /*  4338 */ GIM_Reject,
     /*  4339 */ // Label 172: @4339
     /*  4339 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(4432),
     /*  4344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  4347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  4350 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(4377), // Rule ID 2603 //
     /*  4355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  4358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4370 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPSUBQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  4370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQrr),
     /*  4375 */     GIR_RootConstrainSelectedInstOperands,
     /*  4376 */     // GIR_Coverage, 2603,
     /*  4376 */     GIR_Done,
     /*  4377 */   // Label 218: @4377
     /*  4377 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(4404), // Rule ID 2605 //
     /*  4382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  4385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4397 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PSUBQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  4397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBQrr),
     /*  4402 */     GIR_RootConstrainSelectedInstOperands,
     /*  4403 */     // GIR_Coverage, 2605,
     /*  4403 */     GIR_Done,
     /*  4404 */   // Label 219: @4404
     /*  4404 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(4431), // Rule ID 4738 //
     /*  4409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  4412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4424 */     // (sub:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPSUBQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  4424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ128rr),
     /*  4429 */     GIR_RootConstrainSelectedInstOperands,
     /*  4430 */     // GIR_Coverage, 4738,
     /*  4430 */     GIR_Done,
     /*  4431 */   // Label 220: @4431
     /*  4431 */   GIM_Reject,
     /*  4432 */ // Label 217: @4432
     /*  4432 */ GIM_Reject,
     /*  4433 */ // Label 173: @4433
     /*  4433 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(4526),
     /*  4438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  4441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  4444 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(4471), // Rule ID 2597 //
     /*  4449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  4452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4464 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPSUBDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  4464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDrr),
     /*  4469 */     GIR_RootConstrainSelectedInstOperands,
     /*  4470 */     // GIR_Coverage, 2597,
     /*  4470 */     GIR_Done,
     /*  4471 */   // Label 222: @4471
     /*  4471 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(4498), // Rule ID 2599 //
     /*  4476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  4479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4491 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PSUBDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  4491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBDrr),
     /*  4496 */     GIR_RootConstrainSelectedInstOperands,
     /*  4497 */     // GIR_Coverage, 2599,
     /*  4497 */     GIR_Done,
     /*  4498 */   // Label 223: @4498
     /*  4498 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(4525), // Rule ID 4765 //
     /*  4503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  4506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4518 */     // (sub:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPSUBDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  4518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ128rr),
     /*  4523 */     GIR_RootConstrainSelectedInstOperands,
     /*  4524 */     // GIR_Coverage, 4765,
     /*  4524 */     GIR_Done,
     /*  4525 */   // Label 224: @4525
     /*  4525 */   GIM_Reject,
     /*  4526 */ // Label 221: @4526
     /*  4526 */ GIM_Reject,
     /*  4527 */ // Label 174: @4527
     /*  4527 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(4593),
     /*  4532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  4535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  4538 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(4565), // Rule ID 2607 //
     /*  4543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  4546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4558 */     // (sub:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPSUBQYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  4558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQYrr),
     /*  4563 */     GIR_RootConstrainSelectedInstOperands,
     /*  4564 */     // GIR_Coverage, 2607,
     /*  4564 */     GIR_Done,
     /*  4565 */   // Label 226: @4565
     /*  4565 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(4592), // Rule ID 4729 //
     /*  4570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  4573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4585 */     // (sub:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPSUBQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  4585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ256rr),
     /*  4590 */     GIR_RootConstrainSelectedInstOperands,
     /*  4591 */     // GIR_Coverage, 4729,
     /*  4591 */     GIR_Done,
     /*  4592 */   // Label 227: @4592
     /*  4592 */   GIM_Reject,
     /*  4593 */ // Label 225: @4593
     /*  4593 */ GIM_Reject,
     /*  4594 */ // Label 175: @4594
     /*  4594 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(4687),
     /*  4599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  4602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  4605 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(4632), // Rule ID 2591 //
     /*  4610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  4613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4625 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  4625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWrr),
     /*  4630 */     GIR_RootConstrainSelectedInstOperands,
     /*  4631 */     // GIR_Coverage, 2591,
     /*  4631 */     GIR_Done,
     /*  4632 */   // Label 229: @4632
     /*  4632 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(4659), // Rule ID 2593 //
     /*  4637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  4640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4652 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  4652 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBWrr),
     /*  4657 */     GIR_RootConstrainSelectedInstOperands,
     /*  4658 */     // GIR_Coverage, 2593,
     /*  4658 */     GIR_Done,
     /*  4659 */   // Label 230: @4659
     /*  4659 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(4686), // Rule ID 4786 //
     /*  4664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  4667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4679 */     // (sub:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  4679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ128rr),
     /*  4684 */     GIR_RootConstrainSelectedInstOperands,
     /*  4685 */     // GIR_Coverage, 4786,
     /*  4685 */     GIR_Done,
     /*  4686 */   // Label 231: @4686
     /*  4686 */   GIM_Reject,
     /*  4687 */ // Label 228: @4687
     /*  4687 */ GIM_Reject,
     /*  4688 */ // Label 176: @4688
     /*  4688 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(4754),
     /*  4693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  4696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  4699 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(4726), // Rule ID 2601 //
     /*  4704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  4707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4719 */     // (sub:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPSUBDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  4719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDYrr),
     /*  4724 */     GIR_RootConstrainSelectedInstOperands,
     /*  4725 */     // GIR_Coverage, 2601,
     /*  4725 */     GIR_Done,
     /*  4726 */   // Label 233: @4726
     /*  4726 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(4753), // Rule ID 4756 //
     /*  4731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  4734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4746 */     // (sub:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPSUBDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  4746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ256rr),
     /*  4751 */     GIR_RootConstrainSelectedInstOperands,
     /*  4752 */     // GIR_Coverage, 4756,
     /*  4752 */     GIR_Done,
     /*  4753 */   // Label 234: @4753
     /*  4753 */   GIM_Reject,
     /*  4754 */ // Label 232: @4754
     /*  4754 */ GIM_Reject,
     /*  4755 */ // Label 177: @4755
     /*  4755 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(4788), // Rule ID 4720 //
     /*  4760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  4763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  4766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  4769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  4773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  4777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  4781 */   // (sub:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPSUBQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  4781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZrr),
     /*  4786 */   GIR_RootConstrainSelectedInstOperands,
     /*  4787 */   // GIR_Coverage, 4720,
     /*  4787 */   GIR_Done,
     /*  4788 */ // Label 235: @4788
     /*  4788 */ GIM_Reject,
     /*  4789 */ // Label 178: @4789
     /*  4789 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(4882),
     /*  4794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  4797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  4800 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(4827), // Rule ID 2585 //
     /*  4805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  4808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4820 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  4820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBrr),
     /*  4825 */     GIR_RootConstrainSelectedInstOperands,
     /*  4826 */     // GIR_Coverage, 2585,
     /*  4826 */     GIR_Done,
     /*  4827 */   // Label 237: @4827
     /*  4827 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(4854), // Rule ID 2587 //
     /*  4832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  4835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4847 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  4847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBBrr),
     /*  4852 */     GIR_RootConstrainSelectedInstOperands,
     /*  4853 */     // GIR_Coverage, 2587,
     /*  4853 */     GIR_Done,
     /*  4854 */   // Label 238: @4854
     /*  4854 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(4881), // Rule ID 4804 //
     /*  4859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  4862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4874 */     // (sub:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  4874 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ128rr),
     /*  4879 */     GIR_RootConstrainSelectedInstOperands,
     /*  4880 */     // GIR_Coverage, 4804,
     /*  4880 */     GIR_Done,
     /*  4881 */   // Label 239: @4881
     /*  4881 */   GIM_Reject,
     /*  4882 */ // Label 236: @4882
     /*  4882 */ GIM_Reject,
     /*  4883 */ // Label 179: @4883
     /*  4883 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(4949),
     /*  4888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  4891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  4894 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(4921), // Rule ID 2595 //
     /*  4899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  4902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4914 */     // (sub:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  4914 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWYrr),
     /*  4919 */     GIR_RootConstrainSelectedInstOperands,
     /*  4920 */     // GIR_Coverage, 2595,
     /*  4920 */     GIR_Done,
     /*  4921 */   // Label 241: @4921
     /*  4921 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(4948), // Rule ID 4780 //
     /*  4926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  4929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4941 */     // (sub:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  4941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ256rr),
     /*  4946 */     GIR_RootConstrainSelectedInstOperands,
     /*  4947 */     // GIR_Coverage, 4780,
     /*  4947 */     GIR_Done,
     /*  4948 */   // Label 242: @4948
     /*  4948 */   GIM_Reject,
     /*  4949 */ // Label 240: @4949
     /*  4949 */ GIM_Reject,
     /*  4950 */ // Label 180: @4950
     /*  4950 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(4983), // Rule ID 4747 //
     /*  4955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  4958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  4961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  4964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  4968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  4972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  4976 */   // (sub:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPSUBDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  4976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZrr),
     /*  4981 */   GIR_RootConstrainSelectedInstOperands,
     /*  4982 */   // GIR_Coverage, 4747,
     /*  4982 */   GIR_Done,
     /*  4983 */ // Label 243: @4983
     /*  4983 */ GIM_Reject,
     /*  4984 */ // Label 181: @4984
     /*  4984 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(5050),
     /*  4989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  4992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  4995 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(5022), // Rule ID 2589 //
     /*  5000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  5003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  5007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  5011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  5015 */     // (sub:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  5015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBYrr),
     /*  5020 */     GIR_RootConstrainSelectedInstOperands,
     /*  5021 */     // GIR_Coverage, 2589,
     /*  5021 */     GIR_Done,
     /*  5022 */   // Label 245: @5022
     /*  5022 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(5049), // Rule ID 4798 //
     /*  5027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  5030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  5034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  5038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  5042 */     // (sub:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  5042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ256rr),
     /*  5047 */     GIR_RootConstrainSelectedInstOperands,
     /*  5048 */     // GIR_Coverage, 4798,
     /*  5048 */     GIR_Done,
     /*  5049 */   // Label 246: @5049
     /*  5049 */   GIM_Reject,
     /*  5050 */ // Label 244: @5050
     /*  5050 */ GIM_Reject,
     /*  5051 */ // Label 182: @5051
     /*  5051 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(5084), // Rule ID 4774 //
     /*  5056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  5059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  5062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  5065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  5069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  5073 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  5077 */   // (sub:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  5077 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZrr),
     /*  5082 */   GIR_RootConstrainSelectedInstOperands,
     /*  5083 */   // GIR_Coverage, 4774,
     /*  5083 */   GIR_Done,
     /*  5084 */ // Label 247: @5084
     /*  5084 */ GIM_Reject,
     /*  5085 */ // Label 183: @5085
     /*  5085 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(5118), // Rule ID 4792 //
     /*  5090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  5093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  5096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  5099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  5103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  5107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  5111 */   // (sub:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  5111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZrr),
     /*  5116 */   GIR_RootConstrainSelectedInstOperands,
     /*  5117 */   // GIR_Coverage, 4792,
     /*  5117 */   GIR_Done,
     /*  5118 */ // Label 248: @5118
     /*  5118 */ GIM_Reject,
     /*  5119 */ // Label 184: @5119
     /*  5119 */ GIM_Reject,
     /*  5120 */ // Label 2: @5120
     /*  5120 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 261*/ GIMT_Encode4(6344),
     /*  5131 */ /*GILLT_s16*//*Label 249*/ GIMT_Encode4(5215),
     /*  5135 */ /*GILLT_s32*//*Label 250*/ GIMT_Encode4(5316),
     /*  5139 */ /*GILLT_s64*//*Label 251*/ GIMT_Encode4(5417), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  5155 */ /*GILLT_v2s64*//*Label 252*/ GIMT_Encode4(5522), GIMT_Encode4(0),
     /*  5163 */ /*GILLT_v4s32*//*Label 253*/ GIMT_Encode4(5727),
     /*  5167 */ /*GILLT_v4s64*//*Label 254*/ GIMT_Encode4(5821), GIMT_Encode4(0),
     /*  5175 */ /*GILLT_v8s16*//*Label 255*/ GIMT_Encode4(6014),
     /*  5179 */ /*GILLT_v8s32*//*Label 256*/ GIMT_Encode4(6108),
     /*  5183 */ /*GILLT_v8s64*//*Label 257*/ GIMT_Encode4(6175), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  5195 */ /*GILLT_v16s16*//*Label 258*/ GIMT_Encode4(6209),
     /*  5199 */ /*GILLT_v16s32*//*Label 259*/ GIMT_Encode4(6276), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  5211 */ /*GILLT_v32s16*//*Label 260*/ GIMT_Encode4(6310),
     /*  5215 */ // Label 249: @5215
     /*  5215 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(5315),
     /*  5220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  5223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  5226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  5230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  5234 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(5264), // Rule ID 23400 //
     /*  5239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  5243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  5247 */     // MIs[1] Operand 1
     /*  5247 */     // No operand predicates
     /*  5247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5249 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (IMUL16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  5249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rri),
     /*  5252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  5254 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  5256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  5259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  5262 */     GIR_RootConstrainSelectedInstOperands,
     /*  5263 */     // GIR_Coverage, 23400,
     /*  5263 */     GIR_EraseRootFromParent_Done,
     /*  5264 */   // Label 263: @5264
     /*  5264 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(5289), // Rule ID 23244 //
     /*  5269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  5272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  5276 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (IMUL16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  5276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL16rr),
     /*  5281 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  5287 */     GIR_RootConstrainSelectedInstOperands,
     /*  5288 */     // GIR_Coverage, 23244,
     /*  5288 */     GIR_Done,
     /*  5289 */   // Label 264: @5289
     /*  5289 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(5314), // Rule ID 23334 //
     /*  5294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  5297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  5301 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (IMUL16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  5301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL16rr_ND),
     /*  5306 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  5312 */     GIR_RootConstrainSelectedInstOperands,
     /*  5313 */     // GIR_Coverage, 23334,
     /*  5313 */     GIR_Done,
     /*  5314 */   // Label 265: @5314
     /*  5314 */   GIM_Reject,
     /*  5315 */ // Label 262: @5315
     /*  5315 */ GIM_Reject,
     /*  5316 */ // Label 250: @5316
     /*  5316 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(5416),
     /*  5321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  5324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  5327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  5331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  5335 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(5365), // Rule ID 23401 //
     /*  5340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  5344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  5348 */     // MIs[1] Operand 1
     /*  5348 */     // No operand predicates
     /*  5348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5350 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (IMUL32rri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  5350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rri),
     /*  5353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  5355 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  5357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  5360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  5363 */     GIR_RootConstrainSelectedInstOperands,
     /*  5364 */     // GIR_Coverage, 23401,
     /*  5364 */     GIR_EraseRootFromParent_Done,
     /*  5365 */   // Label 267: @5365
     /*  5365 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(5390), // Rule ID 23245 //
     /*  5370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  5373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  5377 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (IMUL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  5377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL32rr),
     /*  5382 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  5388 */     GIR_RootConstrainSelectedInstOperands,
     /*  5389 */     // GIR_Coverage, 23245,
     /*  5389 */     GIR_Done,
     /*  5390 */   // Label 268: @5390
     /*  5390 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(5415), // Rule ID 23335 //
     /*  5395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  5398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  5402 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (IMUL32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  5402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL32rr_ND),
     /*  5407 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  5413 */     GIR_RootConstrainSelectedInstOperands,
     /*  5414 */     // GIR_Coverage, 23335,
     /*  5414 */     GIR_Done,
     /*  5415 */   // Label 269: @5415
     /*  5415 */   GIM_Reject,
     /*  5416 */ // Label 266: @5416
     /*  5416 */ GIM_Reject,
     /*  5417 */ // Label 251: @5417
     /*  5417 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(5521),
     /*  5422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  5425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  5428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  5432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  5436 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(5470), // Rule ID 23402 //
     /*  5441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  5445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  5449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  5453 */     // MIs[1] Operand 1
     /*  5453 */     // No operand predicates
     /*  5453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5455 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (IMUL64rri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  5455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rri32),
     /*  5458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  5460 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  5462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  5465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  5468 */     GIR_RootConstrainSelectedInstOperands,
     /*  5469 */     // GIR_Coverage, 23402,
     /*  5469 */     GIR_EraseRootFromParent_Done,
     /*  5470 */   // Label 271: @5470
     /*  5470 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(5495), // Rule ID 23246 //
     /*  5475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  5478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  5482 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (IMUL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  5482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL64rr),
     /*  5487 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  5493 */     GIR_RootConstrainSelectedInstOperands,
     /*  5494 */     // GIR_Coverage, 23246,
     /*  5494 */     GIR_Done,
     /*  5495 */   // Label 272: @5495
     /*  5495 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(5520), // Rule ID 23336 //
     /*  5500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  5503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  5507 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (IMUL64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  5507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL64rr_ND),
     /*  5512 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  5518 */     GIR_RootConstrainSelectedInstOperands,
     /*  5519 */     // GIR_Coverage, 23336,
     /*  5519 */     GIR_Done,
     /*  5520 */   // Label 273: @5520
     /*  5520 */   GIM_Reject,
     /*  5521 */ // Label 270: @5521
     /*  5521 */ GIM_Reject,
     /*  5522 */ // Label 252: @5522
     /*  5522 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(5726),
     /*  5527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  5530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  5533 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(5560), // Rule ID 5017 //
     /*  5538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  5541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  5545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  5549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  5553 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMULLQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  5553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rr),
     /*  5558 */     GIR_RootConstrainSelectedInstOperands,
     /*  5559 */     // GIR_Coverage, 5017,
     /*  5559 */     GIR_Done,
     /*  5560 */   // Label 275: @5560
     /*  5560 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(5725), // Rule ID 20445 //
     /*  5565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /*  5568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  5572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  5576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  5580 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMULLQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /*  5580 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  5583 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  5587 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  5594 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  5597 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  5601 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5606 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  5609 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  5613 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  5616 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  5621 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  5626 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  5631 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  5634 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  5638 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  5645 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  5648 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  5652 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5657 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  5660 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  5664 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  5667 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  5672 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  5677 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  5682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  5685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  5689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5694 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  5697 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  5700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  5702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  5705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  5707 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  5714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  5719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  5724 */     // GIR_Coverage, 20445,
     /*  5724 */     GIR_EraseRootFromParent_Done,
     /*  5725 */   // Label 276: @5725
     /*  5725 */   GIM_Reject,
     /*  5726 */ // Label 274: @5726
     /*  5726 */ GIM_Reject,
     /*  5727 */ // Label 253: @5727
     /*  5727 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(5820),
     /*  5732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  5735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  5738 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(5765), // Rule ID 3236 //
     /*  5743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  5746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  5750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  5754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  5758 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMULLDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  5758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDrr),
     /*  5763 */     GIR_RootConstrainSelectedInstOperands,
     /*  5764 */     // GIR_Coverage, 3236,
     /*  5764 */     GIR_Done,
     /*  5765 */   // Label 278: @5765
     /*  5765 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(5792), // Rule ID 3244 //
     /*  5770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  5773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  5777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  5781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  5785 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMULLDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  5785 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULLDrr),
     /*  5790 */     GIR_RootConstrainSelectedInstOperands,
     /*  5791 */     // GIR_Coverage, 3244,
     /*  5791 */     GIR_Done,
     /*  5792 */   // Label 279: @5792
     /*  5792 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(5819), // Rule ID 4972 //
     /*  5797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  5800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  5804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  5808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  5812 */     // (mul:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMULLDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  5812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rr),
     /*  5817 */     GIR_RootConstrainSelectedInstOperands,
     /*  5818 */     // GIR_Coverage, 4972,
     /*  5818 */     GIR_Done,
     /*  5819 */   // Label 280: @5819
     /*  5819 */   GIM_Reject,
     /*  5820 */ // Label 277: @5820
     /*  5820 */ GIM_Reject,
     /*  5821 */ // Label 254: @5821
     /*  5821 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(6013),
     /*  5826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  5829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  5832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  5836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  5840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  5844 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(5859), // Rule ID 5008 //
     /*  5849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  5852 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMULLQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  5852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rr),
     /*  5857 */     GIR_RootConstrainSelectedInstOperands,
     /*  5858 */     // GIR_Coverage, 5008,
     /*  5858 */     GIR_Done,
     /*  5859 */   // Label 282: @5859
     /*  5859 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(6012), // Rule ID 20443 //
     /*  5864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /*  5867 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMULLQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /*  5867 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  5870 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  5874 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  5881 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  5884 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  5888 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5893 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  5896 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  5900 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  5903 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  5908 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  5913 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  5918 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  5921 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  5925 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  5932 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  5935 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  5939 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5944 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  5947 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  5951 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  5954 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  5959 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  5964 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  5969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  5972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  5976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5981 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  5984 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  5987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  5989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  5992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  5994 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  6001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  6006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  6011 */     // GIR_Coverage, 20443,
     /*  6011 */     GIR_EraseRootFromParent_Done,
     /*  6012 */   // Label 283: @6012
     /*  6012 */   GIM_Reject,
     /*  6013 */ // Label 281: @6013
     /*  6013 */ GIM_Reject,
     /*  6014 */ // Label 255: @6014
     /*  6014 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(6107),
     /*  6019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  6022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  6025 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(6052), // Rule ID 2567 //
     /*  6030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  6033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  6037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  6041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  6045 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULLWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  6045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWrr),
     /*  6050 */     GIR_RootConstrainSelectedInstOperands,
     /*  6051 */     // GIR_Coverage, 2567,
     /*  6051 */     GIR_Done,
     /*  6052 */   // Label 285: @6052
     /*  6052 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(6079), // Rule ID 2569 //
     /*  6057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  6060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  6064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  6068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  6072 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULLWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  6072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULLWrr),
     /*  6077 */     GIR_RootConstrainSelectedInstOperands,
     /*  6078 */     // GIR_Coverage, 2569,
     /*  6078 */     GIR_Done,
     /*  6079 */   // Label 286: @6079
     /*  6079 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(6106), // Rule ID 4993 //
     /*  6084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  6087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  6091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  6095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  6099 */     // (mul:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULLWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  6099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rr),
     /*  6104 */     GIR_RootConstrainSelectedInstOperands,
     /*  6105 */     // GIR_Coverage, 4993,
     /*  6105 */     GIR_Done,
     /*  6106 */   // Label 287: @6106
     /*  6106 */   GIM_Reject,
     /*  6107 */ // Label 284: @6107
     /*  6107 */ GIM_Reject,
     /*  6108 */ // Label 256: @6108
     /*  6108 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(6174),
     /*  6113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  6116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  6119 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(6146), // Rule ID 3240 //
     /*  6124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  6127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  6131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  6135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  6139 */     // (mul:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMULLDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  6139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrr),
     /*  6144 */     GIR_RootConstrainSelectedInstOperands,
     /*  6145 */     // GIR_Coverage, 3240,
     /*  6145 */     GIR_Done,
     /*  6146 */   // Label 289: @6146
     /*  6146 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(6173), // Rule ID 4963 //
     /*  6151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  6154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  6158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  6162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  6166 */     // (mul:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMULLDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  6166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rr),
     /*  6171 */     GIR_RootConstrainSelectedInstOperands,
     /*  6172 */     // GIR_Coverage, 4963,
     /*  6172 */     GIR_Done,
     /*  6173 */   // Label 290: @6173
     /*  6173 */   GIM_Reject,
     /*  6174 */ // Label 288: @6174
     /*  6174 */ GIM_Reject,
     /*  6175 */ // Label 257: @6175
     /*  6175 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(6208), // Rule ID 4999 //
     /*  6180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  6183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  6186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  6189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6201 */   // (mul:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMULLQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  6201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  6206 */   GIR_RootConstrainSelectedInstOperands,
     /*  6207 */   // GIR_Coverage, 4999,
     /*  6207 */   GIR_Done,
     /*  6208 */ // Label 291: @6208
     /*  6208 */ GIM_Reject,
     /*  6209 */ // Label 258: @6209
     /*  6209 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(6275),
     /*  6214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  6217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  6220 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(6247), // Rule ID 2571 //
     /*  6225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  6228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  6232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  6236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  6240 */     // (mul:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULLWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  6240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrr),
     /*  6245 */     GIR_RootConstrainSelectedInstOperands,
     /*  6246 */     // GIR_Coverage, 2571,
     /*  6246 */     GIR_Done,
     /*  6247 */   // Label 293: @6247
     /*  6247 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(6274), // Rule ID 4987 //
     /*  6252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  6255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  6259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  6263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  6267 */     // (mul:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULLWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  6267 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rr),
     /*  6272 */     GIR_RootConstrainSelectedInstOperands,
     /*  6273 */     // GIR_Coverage, 4987,
     /*  6273 */     GIR_Done,
     /*  6274 */   // Label 294: @6274
     /*  6274 */   GIM_Reject,
     /*  6275 */ // Label 292: @6275
     /*  6275 */ GIM_Reject,
     /*  6276 */ // Label 259: @6276
     /*  6276 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(6309), // Rule ID 4954 //
     /*  6281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  6284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  6287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  6290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6302 */   // (mul:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMULLDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  6302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrr),
     /*  6307 */   GIR_RootConstrainSelectedInstOperands,
     /*  6308 */   // GIR_Coverage, 4954,
     /*  6308 */   GIR_Done,
     /*  6309 */ // Label 295: @6309
     /*  6309 */ GIM_Reject,
     /*  6310 */ // Label 260: @6310
     /*  6310 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(6343), // Rule ID 4981 //
     /*  6315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  6318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  6321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  6324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6336 */   // (mul:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULLWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  6336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrr),
     /*  6341 */   GIR_RootConstrainSelectedInstOperands,
     /*  6342 */   // GIR_Coverage, 4981,
     /*  6342 */   GIR_Done,
     /*  6343 */ // Label 296: @6343
     /*  6343 */ GIM_Reject,
     /*  6344 */ // Label 261: @6344
     /*  6344 */ GIM_Reject,
     /*  6345 */ // Label 3: @6345
     /*  6345 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 320*/ GIMT_Encode4(12188),
     /*  6356 */ /*GILLT_s1*//*Label 297*/ GIMT_Encode4(6456),
     /*  6360 */ /*GILLT_s8*//*Label 298*/ GIMT_Encode4(6802),
     /*  6364 */ /*GILLT_s16*//*Label 299*/ GIMT_Encode4(6939),
     /*  6368 */ /*GILLT_s32*//*Label 300*/ GIMT_Encode4(7380),
     /*  6372 */ /*GILLT_s64*//*Label 301*/ GIMT_Encode4(8566), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  6384 */ /*GILLT_v2s1*//*Label 302*/ GIMT_Encode4(9630),
     /*  6388 */ /*GILLT_v2s64*//*Label 303*/ GIMT_Encode4(9976),
     /*  6392 */ /*GILLT_v4s1*//*Label 304*/ GIMT_Encode4(10070),
     /*  6396 */ /*GILLT_v4s32*//*Label 305*/ GIMT_Encode4(10416),
     /*  6400 */ /*GILLT_v4s64*//*Label 306*/ GIMT_Encode4(10510),
     /*  6404 */ /*GILLT_v8s1*//*Label 307*/ GIMT_Encode4(10604),
     /*  6408 */ /*GILLT_v8s16*//*Label 308*/ GIMT_Encode4(11102),
     /*  6412 */ /*GILLT_v8s32*//*Label 309*/ GIMT_Encode4(11196),
     /*  6416 */ /*GILLT_v8s64*//*Label 310*/ GIMT_Encode4(11290),
     /*  6420 */ /*GILLT_v16s1*//*Label 311*/ GIMT_Encode4(11324),
     /*  6424 */ /*GILLT_v16s8*//*Label 312*/ GIMT_Encode4(11484),
     /*  6428 */ /*GILLT_v16s16*//*Label 313*/ GIMT_Encode4(11578),
     /*  6432 */ /*GILLT_v16s32*//*Label 314*/ GIMT_Encode4(11672),
     /*  6436 */ /*GILLT_v32s1*//*Label 315*/ GIMT_Encode4(11706),
     /*  6440 */ /*GILLT_v32s8*//*Label 316*/ GIMT_Encode4(11866),
     /*  6444 */ /*GILLT_v32s16*//*Label 317*/ GIMT_Encode4(11960),
     /*  6448 */ /*GILLT_v64s1*//*Label 318*/ GIMT_Encode4(11994),
     /*  6452 */ /*GILLT_v64s8*//*Label 319*/ GIMT_Encode4(12154),
     /*  6456 */ // Label 297: @6456
     /*  6456 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(6801),
     /*  6461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  6464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  6467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  6471 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(6591), // Rule ID 19935 //
     /*  6476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  6480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  6484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  6488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  6492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  6497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  6501 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  6507 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  6509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  6513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  6515 */     // (and:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }), VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  6515 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  6518 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6522 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6527 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  6531 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  6536 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  6539 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6543 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6548 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  6552 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  6557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  6560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  6564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6569 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  6572 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  6575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  6577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  6582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  6585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  6590 */     // GIR_Coverage, 19935,
     /*  6590 */     GIR_EraseRootFromParent_Done,
     /*  6591 */   // Label 322: @6591
     /*  6591 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(6711), // Rule ID 25791 //
     /*  6596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  6600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  6604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  6608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  6612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  6616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  6621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  6625 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  6631 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  6633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  6635 */     // (and:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src2, (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  6635 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  6638 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6642 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6647 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  6651 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  6656 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  6659 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6663 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6668 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  6672 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  6677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  6680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  6684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6689 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  6692 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  6695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  6697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  6702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  6705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  6710 */     // GIR_Coverage, 25791,
     /*  6710 */     GIR_EraseRootFromParent_Done,
     /*  6711 */   // Label 323: @6711
     /*  6711 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(6800), // Rule ID 19931 //
     /*  6716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  6720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  6724 */     // (and:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  6724 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  6727 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6731 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6736 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  6740 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  6745 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  6748 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6752 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6757 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  6761 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  6766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  6769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  6773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6778 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  6781 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  6784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  6786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  6791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  6794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  6799 */     // GIR_Coverage, 19931,
     /*  6799 */     GIR_EraseRootFromParent_Done,
     /*  6800 */   // Label 324: @6800
     /*  6800 */   GIM_Reject,
     /*  6801 */ // Label 321: @6801
     /*  6801 */ GIM_Reject,
     /*  6802 */ // Label 298: @6802
     /*  6802 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(6938),
     /*  6807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  6810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  6813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  6817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  6821 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(6854), // Rule ID 23282 //
     /*  6826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  6829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  6833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  6837 */     // MIs[1] Operand 1
     /*  6837 */     // No operand predicates
     /*  6837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  6839 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (AND8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  6839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8ri),
     /*  6842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  6844 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  6846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  6849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  6852 */     GIR_RootConstrainSelectedInstOperands,
     /*  6853 */     // GIR_Coverage, 23282,
     /*  6853 */     GIR_EraseRootFromParent_Done,
     /*  6854 */   // Label 326: @6854
     /*  6854 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(6887), // Rule ID 23372 //
     /*  6859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  6862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  6866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  6870 */     // MIs[1] Operand 1
     /*  6870 */     // No operand predicates
     /*  6870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  6872 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (AND8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  6872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8ri_ND),
     /*  6875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  6877 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  6879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  6882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  6885 */     GIR_RootConstrainSelectedInstOperands,
     /*  6886 */     // GIR_Coverage, 23372,
     /*  6886 */     GIR_EraseRootFromParent_Done,
     /*  6887 */   // Label 327: @6887
     /*  6887 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(6912), // Rule ID 23274 //
     /*  6892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  6895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  6899 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (AND8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  6899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND8rr),
     /*  6904 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  6910 */     GIR_RootConstrainSelectedInstOperands,
     /*  6911 */     // GIR_Coverage, 23274,
     /*  6911 */     GIR_Done,
     /*  6912 */   // Label 328: @6912
     /*  6912 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(6937), // Rule ID 23364 //
     /*  6917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  6920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  6924 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (AND8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  6924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND8rr_ND),
     /*  6929 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  6935 */     GIR_RootConstrainSelectedInstOperands,
     /*  6936 */     // GIR_Coverage, 23364,
     /*  6936 */     GIR_Done,
     /*  6937 */   // Label 329: @6937
     /*  6937 */   GIM_Reject,
     /*  6938 */ // Label 325: @6938
     /*  6938 */ GIM_Reject,
     /*  6939 */ // Label 299: @6939
     /*  6939 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(7379),
     /*  6944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  6947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  6950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  6954 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(7056), // Rule ID 26460 //
     /*  6959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  6963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  6967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  6971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  6975 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  6979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  6984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  6988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  6990 */     // (and:{ *:[i16] } (rotl:{ *:[i16] } -2:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  6990 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  6993 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  6997 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  7004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  7007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  7011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7016 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7019 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  7023 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  7026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  7031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  7036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  7041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR16rr),
     /*  7044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7046 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  7048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7054 */     GIR_RootConstrainSelectedInstOperands,
     /*  7055 */     // GIR_Coverage, 26460,
     /*  7055 */     GIR_EraseRootFromParent_Done,
     /*  7056 */   // Label 331: @7056
     /*  7056 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(7158), // Rule ID 23198 //
     /*  7061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  7065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  7069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  7073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  7077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  7081 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  7085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  7090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  7092 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (rotl:{ *:[i16] } -2:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  7092 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  7095 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  7099 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  7106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  7109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  7113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7118 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  7125 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  7128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  7133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  7138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  7143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR16rr),
     /*  7146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7148 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  7150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7156 */     GIR_RootConstrainSelectedInstOperands,
     /*  7157 */     // GIR_Coverage, 23198,
     /*  7157 */     GIR_EraseRootFromParent_Done,
     /*  7158 */   // Label 332: @7158
     /*  7158 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(7246), // Rule ID 23058 //
     /*  7163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  7167 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  7178 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, 255:{ *:[i16] })  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src1, sub_8bit:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /*  7178 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /*  7181 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7185 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7190 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src1
     /*  7196 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  7201 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  7206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  7209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /*  7213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7218 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7228 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  7235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  7240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  7245 */     // GIR_Coverage, 23058,
     /*  7245 */     GIR_EraseRootFromParent_Done,
     /*  7246 */   // Label 333: @7246
     /*  7246 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(7283), // Rule ID 23283 //
     /*  7251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  7254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  7258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  7262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  7266 */     // MIs[1] Operand 1
     /*  7266 */     // No operand predicates
     /*  7266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  7268 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (AND16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  7268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16ri),
     /*  7271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7273 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  7275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  7278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7281 */     GIR_RootConstrainSelectedInstOperands,
     /*  7282 */     // GIR_Coverage, 23283,
     /*  7282 */     GIR_EraseRootFromParent_Done,
     /*  7283 */   // Label 334: @7283
     /*  7283 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(7320), // Rule ID 23373 //
     /*  7288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  7291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  7295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  7299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  7303 */     // MIs[1] Operand 1
     /*  7303 */     // No operand predicates
     /*  7303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  7305 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (AND16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  7305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16ri_ND),
     /*  7308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7310 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  7312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  7315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7318 */     GIR_RootConstrainSelectedInstOperands,
     /*  7319 */     // GIR_Coverage, 23373,
     /*  7319 */     GIR_EraseRootFromParent_Done,
     /*  7320 */   // Label 335: @7320
     /*  7320 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(7349), // Rule ID 23275 //
     /*  7325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  7328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  7332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  7336 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (AND16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  7336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND16rr),
     /*  7341 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  7347 */     GIR_RootConstrainSelectedInstOperands,
     /*  7348 */     // GIR_Coverage, 23275,
     /*  7348 */     GIR_Done,
     /*  7349 */   // Label 336: @7349
     /*  7349 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(7378), // Rule ID 23365 //
     /*  7354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  7357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  7361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  7365 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (AND16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  7365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND16rr_ND),
     /*  7370 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  7376 */     GIR_RootConstrainSelectedInstOperands,
     /*  7377 */     // GIR_Coverage, 23365,
     /*  7377 */     GIR_Done,
     /*  7378 */   // Label 337: @7378
     /*  7378 */   GIM_Reject,
     /*  7379 */ // Label 330: @7379
     /*  7379 */ GIM_Reject,
     /*  7380 */ // Label 300: @7380
     /*  7380 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(8565),
     /*  7385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  7388 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(7465), // Rule ID 25419 //
     /*  7393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  7396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  7399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  7407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  7411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  7415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  7419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7424 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  7428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  7432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  7436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  7440 */     // MIs[2] src
     /*  7440 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  7445 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  7449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  7451 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLCIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  7451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC32rr),
     /*  7454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  7460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7463 */     GIR_RootConstrainSelectedInstOperands,
     /*  7464 */     // GIR_Coverage, 25419,
     /*  7464 */     GIR_EraseRootFromParent_Done,
     /*  7465 */   // Label 339: @7465
     /*  7465 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(7542), // Rule ID 25431 //
     /*  7470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  7473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  7476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  7484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  7488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  7492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  7496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7501 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  7505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  7509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  7513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  7517 */     // MIs[2] src
     /*  7517 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  7522 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  7526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  7528 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (TZMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  7528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK32rr),
     /*  7531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  7537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7540 */     GIR_RootConstrainSelectedInstOperands,
     /*  7541 */     // GIR_Coverage, 25431,
     /*  7541 */     GIR_EraseRootFromParent_Done,
     /*  7542 */   // Label 340: @7542
     /*  7542 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(7619), // Rule ID 17803 //
     /*  7547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  7550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  7553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  7561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  7565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  7569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  7573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7578 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  7582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  7586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  7590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  7594 */     // MIs[2] src
     /*  7594 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  7599 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  7603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  7605 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  7605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC32rr),
     /*  7608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  7614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7617 */     GIR_RootConstrainSelectedInstOperands,
     /*  7618 */     // GIR_Coverage, 17803,
     /*  7618 */     GIR_EraseRootFromParent_Done,
     /*  7619 */   // Label 341: @7619
     /*  7619 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(7696), // Rule ID 17815 //
     /*  7624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  7627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  7630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  7638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  7642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  7646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  7650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7655 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  7659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  7663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  7667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  7671 */     // MIs[2] src
     /*  7671 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  7676 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  7680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  7682 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (TZMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  7682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK32rr),
     /*  7685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  7691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7694 */     GIR_RootConstrainSelectedInstOperands,
     /*  7695 */     // GIR_Coverage, 17815,
     /*  7695 */     GIR_EraseRootFromParent_Done,
     /*  7696 */   // Label 342: @7696
     /*  7696 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(7754), // Rule ID 25413 //
     /*  7701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  7704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  7712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  7716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  7720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  7724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7729 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  7733 */     // MIs[0] src
     /*  7733 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  7738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  7740 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  7740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL32rr),
     /*  7743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  7749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7752 */     GIR_RootConstrainSelectedInstOperands,
     /*  7753 */     // GIR_Coverage, 25413,
     /*  7753 */     GIR_EraseRootFromParent_Done,
     /*  7754 */   // Label 343: @7754
     /*  7754 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(7863), // Rule ID 26466 //
     /*  7759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  7762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  7770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  7774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  7778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  7782 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  7786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  7791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  7797 */     // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  7797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  7800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  7804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  7811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  7814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  7818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7823 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  7830 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  7833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  7838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  7843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  7848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR32rr),
     /*  7851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7853 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  7855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7861 */     GIR_RootConstrainSelectedInstOperands,
     /*  7862 */     // GIR_Coverage, 26466,
     /*  7862 */     GIR_EraseRootFromParent_Done,
     /*  7863 */   // Label 344: @7863
     /*  7863 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(7917), // Rule ID 17797 //
     /*  7868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  7871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  7874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  7886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  7890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  7894 */     // MIs[1] src
     /*  7894 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  7899 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  7903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  7905 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  7905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL32rr),
     /*  7908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7910 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  7912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7915 */     GIR_RootConstrainSelectedInstOperands,
     /*  7916 */     // GIR_Coverage, 17797,
     /*  7916 */     GIR_EraseRootFromParent_Done,
     /*  7917 */   // Label 345: @7917
     /*  7917 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(8026), // Rule ID 23204 //
     /*  7922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  7925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  7937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  7941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  7945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  7949 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  7953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  7958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  7960 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  7960 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  7963 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  7967 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  7974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  7977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  7981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7986 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  7993 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  7996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  8001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  8006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  8011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR32rr),
     /*  8014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8016 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  8018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8024 */     GIR_RootConstrainSelectedInstOperands,
     /*  8025 */     // GIR_Coverage, 23204,
     /*  8025 */     GIR_EraseRootFromParent_Done,
     /*  8026 */   // Label 346: @8026
     /*  8026 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(8091), // Rule ID 23056 //
     /*  8031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8042 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  8053 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, 65535:{ *:[i32] })  =>  (MOVZX32rr16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src1, sub_16bit:{ *:[i32] }))
     /*  8053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  8056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8065 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src1
     /*  8071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  8076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  8081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /*  8084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8089 */     GIR_RootConstrainSelectedInstOperands,
     /*  8090 */     // GIR_Coverage, 23056,
     /*  8090 */     GIR_EraseRootFromParent_Done,
     /*  8091 */   // Label 347: @8091
     /*  8091 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(8156), // Rule ID 23057 //
     /*  8096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8107 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  8118 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, 255:{ *:[i32] })  =>  (MOVZX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src1, sub_8bit:{ *:[i32] }))
     /*  8118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /*  8121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8130 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src1
     /*  8136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  8141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  8146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /*  8149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8154 */     GIR_RootConstrainSelectedInstOperands,
     /*  8155 */     // GIR_Coverage, 23057,
     /*  8155 */     GIR_EraseRootFromParent_Done,
     /*  8156 */   // Label 348: @8156
     /*  8156 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(8200), // Rule ID 23284 //
     /*  8161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  8164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  8179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  8183 */     // MIs[1] Operand 1
     /*  8183 */     // No operand predicates
     /*  8183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  8185 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (AND32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  8185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32ri),
     /*  8188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8190 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  8192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  8195 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8198 */     GIR_RootConstrainSelectedInstOperands,
     /*  8199 */     // GIR_Coverage, 23284,
     /*  8199 */     GIR_EraseRootFromParent_Done,
     /*  8200 */   // Label 349: @8200
     /*  8200 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(8244), // Rule ID 23374 //
     /*  8205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  8208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  8223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  8227 */     // MIs[1] Operand 1
     /*  8227 */     // No operand predicates
     /*  8227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  8229 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (AND32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  8229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32ri_ND),
     /*  8232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8234 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  8236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  8239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8242 */     GIR_RootConstrainSelectedInstOperands,
     /*  8243 */     // GIR_Coverage, 23374,
     /*  8243 */     GIR_EraseRootFromParent_Done,
     /*  8244 */   // Label 350: @8244
     /*  8244 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(8306), // Rule ID 17991 //
     /*  8249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  8252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  8263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  8267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  8271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  8275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8280 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  8284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  8290 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src2)  =>  (ANDN32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  8290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr),
     /*  8293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  8299 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  8301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8304 */     GIR_RootConstrainSelectedInstOperands,
     /*  8305 */     // GIR_Coverage, 17991,
     /*  8305 */     GIR_EraseRootFromParent_Done,
     /*  8306 */   // Label 351: @8306
     /*  8306 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(8368), // Rule ID 17995 //
     /*  8311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  8314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  8325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  8329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  8333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  8337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8342 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  8346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  8352 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src2)  =>  (ANDN32rr_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  8352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr_EVEX),
     /*  8355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  8361 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  8363 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8366 */     GIR_RootConstrainSelectedInstOperands,
     /*  8367 */     // GIR_Coverage, 17995,
     /*  8367 */     GIR_EraseRootFromParent_Done,
     /*  8368 */   // Label 352: @8368
     /*  8368 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(8430), // Rule ID 25525 //
     /*  8373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  8376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  8391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  8395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  8399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  8403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8408 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  8412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  8414 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  8414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr),
     /*  8417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  8423 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  8425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8428 */     GIR_RootConstrainSelectedInstOperands,
     /*  8429 */     // GIR_Coverage, 25525,
     /*  8429 */     GIR_EraseRootFromParent_Done,
     /*  8430 */   // Label 353: @8430
     /*  8430 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(8492), // Rule ID 25529 //
     /*  8435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  8438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  8453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  8457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  8461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  8465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8470 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  8474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  8476 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rr_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  8476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr_EVEX),
     /*  8479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  8485 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  8487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8490 */     GIR_RootConstrainSelectedInstOperands,
     /*  8491 */     // GIR_Coverage, 25529,
     /*  8491 */     GIR_EraseRootFromParent_Done,
     /*  8492 */   // Label 354: @8492
     /*  8492 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(8528), // Rule ID 23276 //
     /*  8497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  8500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8515 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (AND32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  8515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND32rr),
     /*  8520 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  8526 */     GIR_RootConstrainSelectedInstOperands,
     /*  8527 */     // GIR_Coverage, 23276,
     /*  8527 */     GIR_Done,
     /*  8528 */   // Label 355: @8528
     /*  8528 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(8564), // Rule ID 23366 //
     /*  8533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  8536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8551 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (AND32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  8551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND32rr_ND),
     /*  8556 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  8562 */     GIR_RootConstrainSelectedInstOperands,
     /*  8563 */     // GIR_Coverage, 23366,
     /*  8563 */     GIR_Done,
     /*  8564 */   // Label 356: @8564
     /*  8564 */   GIM_Reject,
     /*  8565 */ // Label 338: @8565
     /*  8565 */ GIM_Reject,
     /*  8566 */ // Label 301: @8566
     /*  8566 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(9629),
     /*  8571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  8574 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(8651), // Rule ID 25420 //
     /*  8579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  8582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  8585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  8593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  8597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  8601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  8605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8610 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  8614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  8618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  8622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  8626 */     // MIs[2] src
     /*  8626 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  8631 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  8635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  8637 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLCIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  8637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC64rr),
     /*  8640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  8646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8649 */     GIR_RootConstrainSelectedInstOperands,
     /*  8650 */     // GIR_Coverage, 25420,
     /*  8650 */     GIR_EraseRootFromParent_Done,
     /*  8651 */   // Label 358: @8651
     /*  8651 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(8728), // Rule ID 25432 //
     /*  8656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  8659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  8662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  8670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  8674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  8678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  8682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8687 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  8691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  8695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  8699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  8703 */     // MIs[2] src
     /*  8703 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  8708 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  8712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  8714 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (TZMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  8714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK64rr),
     /*  8717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  8723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8726 */     GIR_RootConstrainSelectedInstOperands,
     /*  8727 */     // GIR_Coverage, 25432,
     /*  8727 */     GIR_EraseRootFromParent_Done,
     /*  8728 */   // Label 359: @8728
     /*  8728 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(8805), // Rule ID 17804 //
     /*  8733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  8736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  8739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  8747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  8751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  8755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  8759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8764 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  8768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  8772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  8776 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  8780 */     // MIs[2] src
     /*  8780 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  8785 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  8789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  8791 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  8791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC64rr),
     /*  8794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  8800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8803 */     GIR_RootConstrainSelectedInstOperands,
     /*  8804 */     // GIR_Coverage, 17804,
     /*  8804 */     GIR_EraseRootFromParent_Done,
     /*  8805 */   // Label 360: @8805
     /*  8805 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(8882), // Rule ID 17816 //
     /*  8810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  8813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  8816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  8824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  8828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  8832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  8836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8841 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  8845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  8849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  8853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  8857 */     // MIs[2] src
     /*  8857 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  8862 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  8866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  8868 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (TZMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  8868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK64rr),
     /*  8871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  8877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8880 */     GIR_RootConstrainSelectedInstOperands,
     /*  8881 */     // GIR_Coverage, 17816,
     /*  8881 */     GIR_EraseRootFromParent_Done,
     /*  8882 */   // Label 361: @8882
     /*  8882 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(8940), // Rule ID 25414 //
     /*  8887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  8890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  8898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  8902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  8906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  8910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8915 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  8919 */     // MIs[0] src
     /*  8919 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  8924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  8926 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  8926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL64rr),
     /*  8929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  8935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8938 */     GIR_RootConstrainSelectedInstOperands,
     /*  8939 */     // GIR_Coverage, 25414,
     /*  8939 */     GIR_EraseRootFromParent_Done,
     /*  8940 */   // Label 362: @8940
     /*  8940 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(9049), // Rule ID 26472 //
     /*  8945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  8948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  8956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  8960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  8964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  8968 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  8972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  8977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  8983 */     // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  8983 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  8986 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  8990 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  8997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  9000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  9004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9009 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9012 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  9016 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  9019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  9024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  9029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  9034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR64rr),
     /*  9037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9039 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  9041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9047 */     GIR_RootConstrainSelectedInstOperands,
     /*  9048 */     // GIR_Coverage, 26472,
     /*  9048 */     GIR_EraseRootFromParent_Done,
     /*  9049 */   // Label 363: @9049
     /*  9049 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(9103), // Rule ID 17798 //
     /*  9054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  9057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  9072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  9076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  9080 */     // MIs[1] src
     /*  9080 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  9085 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  9089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  9091 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  9091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL64rr),
     /*  9094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9096 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  9098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9101 */     GIR_RootConstrainSelectedInstOperands,
     /*  9102 */     // GIR_Coverage, 17798,
     /*  9102 */     GIR_EraseRootFromParent_Done,
     /*  9103 */   // Label 364: @9103
     /*  9103 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(9212), // Rule ID 23210 //
     /*  9108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  9123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  9127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  9131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  9135 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  9139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  9144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  9146 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  9146 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  9149 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  9153 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  9160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  9163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  9167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9172 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9175 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  9179 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  9182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  9187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  9192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  9197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR64rr),
     /*  9200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9202 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  9204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9210 */     GIR_RootConstrainSelectedInstOperands,
     /*  9211 */     // GIR_Coverage, 23210,
     /*  9211 */     GIR_EraseRootFromParent_Done,
     /*  9212 */   // Label 365: @9212
     /*  9212 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(9260), // Rule ID 23285 //
     /*  9217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  9220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  9235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  9239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  9243 */     // MIs[1] Operand 1
     /*  9243 */     // No operand predicates
     /*  9243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  9245 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (AND64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  9245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64ri32),
     /*  9248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9250 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  9252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  9255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9258 */     GIR_RootConstrainSelectedInstOperands,
     /*  9259 */     // GIR_Coverage, 23285,
     /*  9259 */     GIR_EraseRootFromParent_Done,
     /*  9260 */   // Label 366: @9260
     /*  9260 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(9308), // Rule ID 23375 //
     /*  9265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  9268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  9283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  9287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  9291 */     // MIs[1] Operand 1
     /*  9291 */     // No operand predicates
     /*  9291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  9293 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (AND64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  9293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64ri32_ND),
     /*  9296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9298 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  9300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  9303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9306 */     GIR_RootConstrainSelectedInstOperands,
     /*  9307 */     // GIR_Coverage, 23375,
     /*  9307 */     GIR_EraseRootFromParent_Done,
     /*  9308 */   // Label 367: @9308
     /*  9308 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(9370), // Rule ID 17992 //
     /*  9313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  9316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  9327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  9331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  9335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  9339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9344 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  9348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  9354 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src2)  =>  (ANDN64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  9354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr),
     /*  9357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  9363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  9365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9368 */     GIR_RootConstrainSelectedInstOperands,
     /*  9369 */     // GIR_Coverage, 17992,
     /*  9369 */     GIR_EraseRootFromParent_Done,
     /*  9370 */   // Label 368: @9370
     /*  9370 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(9432), // Rule ID 17996 //
     /*  9375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  9378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  9389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  9393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  9397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  9401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9406 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  9410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  9416 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src2)  =>  (ANDN64rr_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  9416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr_EVEX),
     /*  9419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  9425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  9427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9430 */     GIR_RootConstrainSelectedInstOperands,
     /*  9431 */     // GIR_Coverage, 17996,
     /*  9431 */     GIR_EraseRootFromParent_Done,
     /*  9432 */   // Label 369: @9432
     /*  9432 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(9494), // Rule ID 25526 //
     /*  9437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  9440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  9455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  9459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  9463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  9467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9472 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  9476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  9478 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  9478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr),
     /*  9481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  9487 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  9489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9492 */     GIR_RootConstrainSelectedInstOperands,
     /*  9493 */     // GIR_Coverage, 25526,
     /*  9493 */     GIR_EraseRootFromParent_Done,
     /*  9494 */   // Label 370: @9494
     /*  9494 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(9556), // Rule ID 25530 //
     /*  9499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  9502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  9517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  9521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  9525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  9529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9534 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  9538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  9540 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rr_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  9540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr_EVEX),
     /*  9543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  9549 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  9551 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9554 */     GIR_RootConstrainSelectedInstOperands,
     /*  9555 */     // GIR_Coverage, 25530,
     /*  9555 */     GIR_EraseRootFromParent_Done,
     /*  9556 */   // Label 371: @9556
     /*  9556 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(9592), // Rule ID 23277 //
     /*  9561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  9564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9579 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (AND64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  9579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND64rr),
     /*  9584 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  9590 */     GIR_RootConstrainSelectedInstOperands,
     /*  9591 */     // GIR_Coverage, 23277,
     /*  9591 */     GIR_Done,
     /*  9592 */   // Label 372: @9592
     /*  9592 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(9628), // Rule ID 23367 //
     /*  9597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  9600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9615 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (AND64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  9615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND64rr_ND),
     /*  9620 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  9626 */     GIR_RootConstrainSelectedInstOperands,
     /*  9627 */     // GIR_Coverage, 23367,
     /*  9627 */     GIR_Done,
     /*  9628 */   // Label 373: @9628
     /*  9628 */   GIM_Reject,
     /*  9629 */ // Label 357: @9629
     /*  9629 */ GIM_Reject,
     /*  9630 */ // Label 302: @9630
     /*  9630 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(9975),
     /*  9635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  9638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  9641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  9645 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(9765), // Rule ID 19936 //
     /*  9650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  9654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  9658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  9662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  9666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  9671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  9675 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  9681 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  9683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  9687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  9689 */     // (and:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }), VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  9689 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  9692 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9696 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9701 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  9705 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  9710 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  9713 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9717 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9722 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  9726 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  9731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  9734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  9738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9743 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9746 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  9749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  9764 */     // GIR_Coverage, 19936,
     /*  9764 */     GIR_EraseRootFromParent_Done,
     /*  9765 */   // Label 375: @9765
     /*  9765 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(9885), // Rule ID 25792 //
     /*  9770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  9774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  9778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  9782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  9786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  9790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  9795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  9799 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  9805 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  9807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  9809 */     // (and:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src2, (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  9809 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  9812 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9816 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9821 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  9825 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  9830 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  9833 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9837 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9842 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  9846 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  9851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  9854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  9858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9863 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9866 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  9869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  9884 */     // GIR_Coverage, 25792,
     /*  9884 */     GIR_EraseRootFromParent_Done,
     /*  9885 */   // Label 376: @9885
     /*  9885 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(9974), // Rule ID 19932 //
     /*  9890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  9894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  9898 */     // (and:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  9898 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  9901 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9905 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9910 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  9914 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  9919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  9922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9931 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  9935 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  9940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  9943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  9947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9952 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9955 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  9958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  9973 */     // GIR_Coverage, 19932,
     /*  9973 */     GIR_EraseRootFromParent_Done,
     /*  9974 */   // Label 377: @9974
     /*  9974 */   GIM_Reject,
     /*  9975 */ // Label 374: @9975
     /*  9975 */ GIM_Reject,
     /*  9976 */ // Label 303: @9976
     /*  9976 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(10069),
     /*  9981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  9987 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(10014), // Rule ID 2107 //
     /*  9992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  9995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  9999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10007 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPANDrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 10007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /* 10012 */     GIR_RootConstrainSelectedInstOperands,
     /* 10013 */     // GIR_Coverage, 2107,
     /* 10013 */     GIR_Done,
     /* 10014 */   // Label 379: @10014
     /* 10014 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(10041), // Rule ID 2109 //
     /* 10019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 10022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10034 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PANDrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 10034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /* 10039 */     GIR_RootConstrainSelectedInstOperands,
     /* 10040 */     // GIR_Coverage, 2109,
     /* 10040 */     GIR_Done,
     /* 10041 */   // Label 380: @10041
     /* 10041 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(10068), // Rule ID 5701 //
     /* 10046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 10049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 10053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 10057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 10061 */     // (and:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPANDQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 10061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /* 10066 */     GIR_RootConstrainSelectedInstOperands,
     /* 10067 */     // GIR_Coverage, 5701,
     /* 10067 */     GIR_Done,
     /* 10068 */   // Label 381: @10068
     /* 10068 */   GIM_Reject,
     /* 10069 */ // Label 378: @10069
     /* 10069 */ GIM_Reject,
     /* 10070 */ // Label 304: @10070
     /* 10070 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(10415),
     /* 10075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 10078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 10081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 10085 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(10205), // Rule ID 19937 //
     /* 10090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 10094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 10098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 10102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 10106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 10111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 10115 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 10121 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 10123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 10127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 10129 */     // (and:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }), VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 10129 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 10132 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10136 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10141 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 10145 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10150 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 10153 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10157 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10162 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 10166 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 10174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /* 10178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10183 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10186 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 10189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 10204 */     // GIR_Coverage, 19937,
     /* 10204 */     GIR_EraseRootFromParent_Done,
     /* 10205 */   // Label 383: @10205
     /* 10205 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(10325), // Rule ID 25793 //
     /* 10210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 10214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 10218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 10222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 10226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 10230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 10235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 10239 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 10245 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 10247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 10249 */     // (and:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src2, (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 10249 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 10252 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10256 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10261 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /* 10265 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10270 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 10273 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10277 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10282 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 10286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 10294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /* 10298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10303 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10306 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 10309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 10324 */     // GIR_Coverage, 25793,
     /* 10324 */     GIR_EraseRootFromParent_Done,
     /* 10325 */   // Label 384: @10325
     /* 10325 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(10414), // Rule ID 19933 //
     /* 10330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 10334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 10338 */     // (and:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 10338 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 10341 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10345 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10350 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 10354 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 10362 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10366 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10371 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 10375 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 10383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /* 10387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10392 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10395 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 10398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 10413 */     // GIR_Coverage, 19933,
     /* 10413 */     GIR_EraseRootFromParent_Done,
     /* 10414 */   // Label 385: @10414
     /* 10414 */   GIM_Reject,
     /* 10415 */ // Label 382: @10415
     /* 10415 */ GIM_Reject,
     /* 10416 */ // Label 305: @10416
     /* 10416 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(10509),
     /* 10421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 10427 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(10454), // Rule ID 5728 //
     /* 10432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 10435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 10439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 10443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 10447 */     // (and:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPANDDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 10447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rr),
     /* 10452 */     GIR_RootConstrainSelectedInstOperands,
     /* 10453 */     // GIR_Coverage, 5728,
     /* 10453 */     GIR_Done,
     /* 10454 */   // Label 387: @10454
     /* 10454 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(10481), // Rule ID 18595 //
     /* 10459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 10462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10474 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPANDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 10474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /* 10479 */     GIR_RootConstrainSelectedInstOperands,
     /* 10480 */     // GIR_Coverage, 18595,
     /* 10480 */     GIR_Done,
     /* 10481 */   // Label 388: @10481
     /* 10481 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(10508), // Rule ID 18619 //
     /* 10486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 10489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10501 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PANDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 10501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /* 10506 */     GIR_RootConstrainSelectedInstOperands,
     /* 10507 */     // GIR_Coverage, 18619,
     /* 10507 */     GIR_Done,
     /* 10508 */   // Label 389: @10508
     /* 10508 */   GIM_Reject,
     /* 10509 */ // Label 386: @10509
     /* 10509 */ GIM_Reject,
     /* 10510 */ // Label 306: @10510
     /* 10510 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(10603),
     /* 10515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 10518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 10521 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(10548), // Rule ID 2111 //
     /* 10526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 10529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 10533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 10537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 10541 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPANDYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 10541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /* 10546 */     GIR_RootConstrainSelectedInstOperands,
     /* 10547 */     // GIR_Coverage, 2111,
     /* 10547 */     GIR_Done,
     /* 10548 */   // Label 391: @10548
     /* 10548 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(10575), // Rule ID 5692 //
     /* 10553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 10556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 10560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 10564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 10568 */     // (and:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPANDQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 10568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /* 10573 */     GIR_RootConstrainSelectedInstOperands,
     /* 10574 */     // GIR_Coverage, 5692,
     /* 10574 */     GIR_Done,
     /* 10575 */   // Label 392: @10575
     /* 10575 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(10602), // Rule ID 18564 //
     /* 10580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 10583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 10587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 10591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 10595 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VANDPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 10595 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /* 10600 */     GIR_RootConstrainSelectedInstOperands,
     /* 10601 */     // GIR_Coverage, 18564,
     /* 10601 */     GIR_Done,
     /* 10602 */   // Label 393: @10602
     /* 10602 */   GIM_Reject,
     /* 10603 */ // Label 390: @10603
     /* 10603 */ GIM_Reject,
     /* 10604 */ // Label 307: @10604
     /* 10604 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(11101),
     /* 10609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 10612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 10615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10619 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(10679), // Rule ID 4428 //
     /* 10624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 10627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 10631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 10635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 10639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 10643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 10652 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 10658 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 10660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 10666 */     // (and:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (KANDNBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /* 10666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNBkk),
     /* 10669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 10675 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 10677 */     GIR_RootConstrainSelectedInstOperands,
     /* 10678 */     // GIR_Coverage, 4428,
     /* 10678 */     GIR_EraseRootFromParent_Done,
     /* 10679 */   // Label 395: @10679
     /* 10679 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(10802), // Rule ID 19934 //
     /* 10684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /* 10687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 10691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 10695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 10699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 10703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 10712 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 10718 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 10720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 10726 */     // (and:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 10726 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 10729 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10733 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10738 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 10742 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10747 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 10750 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10754 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10759 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 10763 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 10771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /* 10775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10780 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10783 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 10786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 10801 */     // GIR_Coverage, 19934,
     /* 10801 */     GIR_EraseRootFromParent_Done,
     /* 10802 */   // Label 396: @10802
     /* 10802 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(10862), // Rule ID 24116 //
     /* 10807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 10810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 10818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 10822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 10826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 10830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 10839 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 10845 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 10847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 10849 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (KANDNBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /* 10849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNBkk),
     /* 10852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 10858 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 10860 */     GIR_RootConstrainSelectedInstOperands,
     /* 10861 */     // GIR_Coverage, 24116,
     /* 10861 */     GIR_EraseRootFromParent_Done,
     /* 10862 */   // Label 397: @10862
     /* 10862 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(10985), // Rule ID 25790 //
     /* 10867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /* 10870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 10878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 10882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 10886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 10890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 10899 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 10905 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 10907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 10909 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 10909 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 10912 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10916 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10921 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /* 10925 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10930 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 10933 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10937 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10942 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 10946 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 10954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /* 10958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10963 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10966 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 10969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 10984 */     // GIR_Coverage, 25790,
     /* 10984 */     GIR_EraseRootFromParent_Done,
     /* 10985 */   // Label 398: @10985
     /* 10985 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(11008), // Rule ID 4412 //
     /* 10990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 10993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 11001 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KANDBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /* 11001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDBkk),
     /* 11006 */     GIR_RootConstrainSelectedInstOperands,
     /* 11007 */     // GIR_Coverage, 4412,
     /* 11007 */     GIR_Done,
     /* 11008 */   // Label 399: @11008
     /* 11008 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(11100), // Rule ID 19930 //
     /* 11013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /* 11016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 11020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 11024 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 11024 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 11027 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 11031 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 11036 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 11040 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 11045 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 11048 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 11052 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 11057 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 11061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 11066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 11069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /* 11073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 11078 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 11081 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 11084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 11086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 11089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 11091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 11094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 11099 */     // GIR_Coverage, 19930,
     /* 11099 */     GIR_EraseRootFromParent_Done,
     /* 11100 */   // Label 400: @11100
     /* 11100 */   GIM_Reject,
     /* 11101 */ // Label 394: @11101
     /* 11101 */ GIM_Reject,
     /* 11102 */ // Label 308: @11102
     /* 11102 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(11195),
     /* 11107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 11110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 11113 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(11140), // Rule ID 18594 //
     /* 11118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 11121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11133 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPANDrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 11133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /* 11138 */     GIR_RootConstrainSelectedInstOperands,
     /* 11139 */     // GIR_Coverage, 18594,
     /* 11139 */     GIR_Done,
     /* 11140 */   // Label 402: @11140
     /* 11140 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(11167), // Rule ID 18618 //
     /* 11145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 11148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11160 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PANDrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 11160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /* 11165 */     GIR_RootConstrainSelectedInstOperands,
     /* 11166 */     // GIR_Coverage, 18618,
     /* 11166 */     GIR_Done,
     /* 11167 */   // Label 403: @11167
     /* 11167 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(11194), // Rule ID 20464 //
     /* 11172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 11175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 11179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 11183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 11187 */     // (and:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPANDQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 11187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /* 11192 */     GIR_RootConstrainSelectedInstOperands,
     /* 11193 */     // GIR_Coverage, 20464,
     /* 11193 */     GIR_Done,
     /* 11194 */   // Label 404: @11194
     /* 11194 */   GIM_Reject,
     /* 11195 */ // Label 401: @11195
     /* 11195 */ GIM_Reject,
     /* 11196 */ // Label 309: @11196
     /* 11196 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(11289),
     /* 11201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 11204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 11207 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(11234), // Rule ID 5719 //
     /* 11212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 11215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11227 */     // (and:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPANDDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 11227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rr),
     /* 11232 */     GIR_RootConstrainSelectedInstOperands,
     /* 11233 */     // GIR_Coverage, 5719,
     /* 11233 */     GIR_Done,
     /* 11234 */   // Label 406: @11234
     /* 11234 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(11261), // Rule ID 18539 //
     /* 11239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 11242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11254 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPANDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 11254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /* 11259 */     GIR_RootConstrainSelectedInstOperands,
     /* 11260 */     // GIR_Coverage, 18539,
     /* 11260 */     GIR_Done,
     /* 11261 */   // Label 407: @11261
     /* 11261 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(11288), // Rule ID 18563 //
     /* 11266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 11269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11281 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VANDPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 11281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /* 11286 */     GIR_RootConstrainSelectedInstOperands,
     /* 11287 */     // GIR_Coverage, 18563,
     /* 11287 */     GIR_Done,
     /* 11288 */   // Label 408: @11288
     /* 11288 */   GIM_Reject,
     /* 11289 */ // Label 405: @11289
     /* 11289 */ GIM_Reject,
     /* 11290 */ // Label 310: @11290
     /* 11290 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(11323), // Rule ID 5683 //
     /* 11295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 11298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 11301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 11304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11312 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11316 */   // (and:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPANDQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 11316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /* 11321 */   GIR_RootConstrainSelectedInstOperands,
     /* 11322 */   // GIR_Coverage, 5683,
     /* 11322 */   GIR_Done,
     /* 11323 */ // Label 409: @11323
     /* 11323 */ GIM_Reject,
     /* 11324 */ // Label 311: @11324
     /* 11324 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(11483),
     /* 11329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 11332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 11335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 11339 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(11399), // Rule ID 4429 //
     /* 11344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 11347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 11351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 11355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 11359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 11363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 11368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 11372 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 11378 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 11380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 11384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 11386 */     // (and:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }), VK16:{ *:[v16i1] }:$src2)  =>  (KANDNWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /* 11386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /* 11389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 11391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 11395 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 11397 */     GIR_RootConstrainSelectedInstOperands,
     /* 11398 */     // GIR_Coverage, 4429,
     /* 11398 */     GIR_EraseRootFromParent_Done,
     /* 11399 */   // Label 411: @11399
     /* 11399 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(11459), // Rule ID 24117 //
     /* 11404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 11407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 11411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 11415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 11419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 11423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 11427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 11432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 11436 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 11442 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 11444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 11446 */     // (and:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src2, (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }))  =>  (KANDNWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /* 11446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /* 11449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 11451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 11455 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 11457 */     GIR_RootConstrainSelectedInstOperands,
     /* 11458 */     // GIR_Coverage, 24117,
     /* 11458 */     GIR_EraseRootFromParent_Done,
     /* 11459 */   // Label 412: @11459
     /* 11459 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(11482), // Rule ID 4413 //
     /* 11464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 11467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 11471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 11475 */     // (and:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KANDWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /* 11475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /* 11480 */     GIR_RootConstrainSelectedInstOperands,
     /* 11481 */     // GIR_Coverage, 4413,
     /* 11481 */     GIR_Done,
     /* 11482 */   // Label 413: @11482
     /* 11482 */   GIM_Reject,
     /* 11483 */ // Label 410: @11483
     /* 11483 */ GIM_Reject,
     /* 11484 */ // Label 312: @11484
     /* 11484 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(11577),
     /* 11489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 11492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 11495 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(11522), // Rule ID 18593 //
     /* 11500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 11503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11515 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPANDrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 11515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /* 11520 */     GIR_RootConstrainSelectedInstOperands,
     /* 11521 */     // GIR_Coverage, 18593,
     /* 11521 */     GIR_Done,
     /* 11522 */   // Label 415: @11522
     /* 11522 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(11549), // Rule ID 18617 //
     /* 11527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 11530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11542 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PANDrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 11542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /* 11547 */     GIR_RootConstrainSelectedInstOperands,
     /* 11548 */     // GIR_Coverage, 18617,
     /* 11548 */     GIR_Done,
     /* 11549 */   // Label 416: @11549
     /* 11549 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(11576), // Rule ID 20463 //
     /* 11554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 11557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 11561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 11565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 11569 */     // (and:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPANDQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 11569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /* 11574 */     GIR_RootConstrainSelectedInstOperands,
     /* 11575 */     // GIR_Coverage, 20463,
     /* 11575 */     GIR_Done,
     /* 11576 */   // Label 417: @11576
     /* 11576 */   GIM_Reject,
     /* 11577 */ // Label 414: @11577
     /* 11577 */ GIM_Reject,
     /* 11578 */ // Label 313: @11578
     /* 11578 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(11671),
     /* 11583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 11586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 11589 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(11616), // Rule ID 18538 //
     /* 11594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 11597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11609 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPANDYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 11609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /* 11614 */     GIR_RootConstrainSelectedInstOperands,
     /* 11615 */     // GIR_Coverage, 18538,
     /* 11615 */     GIR_Done,
     /* 11616 */   // Label 419: @11616
     /* 11616 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(11643), // Rule ID 18562 //
     /* 11621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 11624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11636 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VANDPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 11636 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /* 11641 */     GIR_RootConstrainSelectedInstOperands,
     /* 11642 */     // GIR_Coverage, 18562,
     /* 11642 */     GIR_Done,
     /* 11643 */   // Label 420: @11643
     /* 11643 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(11670), // Rule ID 20480 //
     /* 11648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 11651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11663 */     // (and:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPANDQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 11663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /* 11668 */     GIR_RootConstrainSelectedInstOperands,
     /* 11669 */     // GIR_Coverage, 20480,
     /* 11669 */     GIR_Done,
     /* 11670 */   // Label 421: @11670
     /* 11670 */   GIM_Reject,
     /* 11671 */ // Label 418: @11671
     /* 11671 */ GIM_Reject,
     /* 11672 */ // Label 314: @11672
     /* 11672 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(11705), // Rule ID 5710 //
     /* 11677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 11680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 11683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 11686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11698 */   // (and:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPANDDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 11698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZrr),
     /* 11703 */   GIR_RootConstrainSelectedInstOperands,
     /* 11704 */   // GIR_Coverage, 5710,
     /* 11704 */   GIR_Done,
     /* 11705 */ // Label 422: @11705
     /* 11705 */ GIM_Reject,
     /* 11706 */ // Label 315: @11706
     /* 11706 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(11865),
     /* 11711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 11714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 11717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 11721 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(11781), // Rule ID 4430 //
     /* 11726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 11729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 11733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 11737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 11741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 11745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 11750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 11754 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 11760 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 11762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 11766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 11768 */     // (and:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }), VK32:{ *:[v32i1] }:$src2)  =>  (KANDNDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /* 11768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNDkk),
     /* 11771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 11773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 11777 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 11779 */     GIR_RootConstrainSelectedInstOperands,
     /* 11780 */     // GIR_Coverage, 4430,
     /* 11780 */     GIR_EraseRootFromParent_Done,
     /* 11781 */   // Label 424: @11781
     /* 11781 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(11841), // Rule ID 24118 //
     /* 11786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 11789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 11793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 11797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 11801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 11805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 11809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 11814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 11818 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 11824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 11826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 11828 */     // (and:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src2, (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }))  =>  (KANDNDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /* 11828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNDkk),
     /* 11831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 11833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 11837 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 11839 */     GIR_RootConstrainSelectedInstOperands,
     /* 11840 */     // GIR_Coverage, 24118,
     /* 11840 */     GIR_EraseRootFromParent_Done,
     /* 11841 */   // Label 425: @11841
     /* 11841 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(11864), // Rule ID 4414 //
     /* 11846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 11849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 11853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 11857 */     // (and:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KANDDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /* 11857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDDkk),
     /* 11862 */     GIR_RootConstrainSelectedInstOperands,
     /* 11863 */     // GIR_Coverage, 4414,
     /* 11863 */     GIR_Done,
     /* 11864 */   // Label 426: @11864
     /* 11864 */   GIM_Reject,
     /* 11865 */ // Label 423: @11865
     /* 11865 */ GIM_Reject,
     /* 11866 */ // Label 316: @11866
     /* 11866 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(11959),
     /* 11871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 11874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 11877 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(11904), // Rule ID 18537 //
     /* 11882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 11885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11897 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPANDYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 11897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /* 11902 */     GIR_RootConstrainSelectedInstOperands,
     /* 11903 */     // GIR_Coverage, 18537,
     /* 11903 */     GIR_Done,
     /* 11904 */   // Label 428: @11904
     /* 11904 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(11931), // Rule ID 18561 //
     /* 11909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 11912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11924 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VANDPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 11924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /* 11929 */     GIR_RootConstrainSelectedInstOperands,
     /* 11930 */     // GIR_Coverage, 18561,
     /* 11930 */     GIR_Done,
     /* 11931 */   // Label 429: @11931
     /* 11931 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(11958), // Rule ID 20479 //
     /* 11936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 11939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11951 */     // (and:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPANDQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 11951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /* 11956 */     GIR_RootConstrainSelectedInstOperands,
     /* 11957 */     // GIR_Coverage, 20479,
     /* 11957 */     GIR_Done,
     /* 11958 */   // Label 430: @11958
     /* 11958 */   GIM_Reject,
     /* 11959 */ // Label 427: @11959
     /* 11959 */ GIM_Reject,
     /* 11960 */ // Label 317: @11960
     /* 11960 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(11993), // Rule ID 20496 //
     /* 11965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 11968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 11971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 11974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11986 */   // (and:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPANDQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 11986 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /* 11991 */   GIR_RootConstrainSelectedInstOperands,
     /* 11992 */   // GIR_Coverage, 20496,
     /* 11992 */   GIR_Done,
     /* 11993 */ // Label 431: @11993
     /* 11993 */ GIM_Reject,
     /* 11994 */ // Label 318: @11994
     /* 11994 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(12153),
     /* 11999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 12002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 12005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 12009 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(12069), // Rule ID 4431 //
     /* 12014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 12017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 12021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 12025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 12029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 12033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 12038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 12042 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 12048 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 12050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 12054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 12056 */     // (and:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }), VK64:{ *:[v64i1] }:$src2)  =>  (KANDNQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /* 12056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNQkk),
     /* 12059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 12065 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 12067 */     GIR_RootConstrainSelectedInstOperands,
     /* 12068 */     // GIR_Coverage, 4431,
     /* 12068 */     GIR_EraseRootFromParent_Done,
     /* 12069 */   // Label 433: @12069
     /* 12069 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(12129), // Rule ID 24119 //
     /* 12074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 12077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 12081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 12085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 12089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 12093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 12097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 12102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 12106 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 12112 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 12114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 12116 */     // (and:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src2, (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }))  =>  (KANDNQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /* 12116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNQkk),
     /* 12119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 12125 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 12127 */     GIR_RootConstrainSelectedInstOperands,
     /* 12128 */     // GIR_Coverage, 24119,
     /* 12128 */     GIR_EraseRootFromParent_Done,
     /* 12129 */   // Label 434: @12129
     /* 12129 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(12152), // Rule ID 4415 //
     /* 12134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 12137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 12141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 12145 */     // (and:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KANDQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /* 12145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDQkk),
     /* 12150 */     GIR_RootConstrainSelectedInstOperands,
     /* 12151 */     // GIR_Coverage, 4415,
     /* 12151 */     GIR_Done,
     /* 12152 */   // Label 435: @12152
     /* 12152 */   GIM_Reject,
     /* 12153 */ // Label 432: @12153
     /* 12153 */ GIM_Reject,
     /* 12154 */ // Label 319: @12154
     /* 12154 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(12187), // Rule ID 20495 //
     /* 12159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 12162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 12165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 12168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 12172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 12176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 12180 */   // (and:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPANDQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 12180 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /* 12185 */   GIR_RootConstrainSelectedInstOperands,
     /* 12186 */   // GIR_Coverage, 20495,
     /* 12186 */   GIR_Done,
     /* 12187 */ // Label 436: @12187
     /* 12187 */ GIM_Reject,
     /* 12188 */ // Label 320: @12188
     /* 12188 */ GIM_Reject,
     /* 12189 */ // Label 4: @12189
     /* 12189 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 460*/ GIMT_Encode4(16580),
     /* 12200 */ /*GILLT_s1*//*Label 437*/ GIMT_Encode4(12300),
     /* 12204 */ /*GILLT_s8*//*Label 438*/ GIMT_Encode4(12400),
     /* 12208 */ /*GILLT_s16*//*Label 439*/ GIMT_Encode4(12537),
     /* 12212 */ /*GILLT_s32*//*Label 440*/ GIMT_Encode4(12890),
     /* 12216 */ /*GILLT_s64*//*Label 441*/ GIMT_Encode4(14074), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 12228 */ /*GILLT_v2s1*//*Label 442*/ GIMT_Encode4(15266),
     /* 12232 */ /*GILLT_v2s64*//*Label 443*/ GIMT_Encode4(15366),
     /* 12236 */ /*GILLT_v4s1*//*Label 444*/ GIMT_Encode4(15460),
     /* 12240 */ /*GILLT_v4s32*//*Label 445*/ GIMT_Encode4(15560),
     /* 12244 */ /*GILLT_v4s64*//*Label 446*/ GIMT_Encode4(15654),
     /* 12248 */ /*GILLT_v8s1*//*Label 447*/ GIMT_Encode4(15748),
     /* 12252 */ /*GILLT_v8s16*//*Label 448*/ GIMT_Encode4(15872),
     /* 12256 */ /*GILLT_v8s32*//*Label 449*/ GIMT_Encode4(15966),
     /* 12260 */ /*GILLT_v8s64*//*Label 450*/ GIMT_Encode4(16060),
     /* 12264 */ /*GILLT_v16s1*//*Label 451*/ GIMT_Encode4(16094),
     /* 12268 */ /*GILLT_v16s8*//*Label 452*/ GIMT_Encode4(16128),
     /* 12272 */ /*GILLT_v16s16*//*Label 453*/ GIMT_Encode4(16222),
     /* 12276 */ /*GILLT_v16s32*//*Label 454*/ GIMT_Encode4(16316),
     /* 12280 */ /*GILLT_v32s1*//*Label 455*/ GIMT_Encode4(16350),
     /* 12284 */ /*GILLT_v32s8*//*Label 456*/ GIMT_Encode4(16384),
     /* 12288 */ /*GILLT_v32s16*//*Label 457*/ GIMT_Encode4(16478),
     /* 12292 */ /*GILLT_v64s1*//*Label 458*/ GIMT_Encode4(16512),
     /* 12296 */ /*GILLT_v64s8*//*Label 459*/ GIMT_Encode4(16546),
     /* 12300 */ // Label 437: @12300
     /* 12300 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(12399), // Rule ID 19939 //
     /* 12305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 12308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /* 12311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 12315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 12319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 12323 */   // (or:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /* 12323 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 12326 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 12330 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 12335 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 12339 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 12344 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 12347 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 12351 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 12356 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 12360 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 12365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 12368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /* 12372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 12377 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 12380 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 12383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 12385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 12388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12390 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 12393 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 12398 */   // GIR_Coverage, 19939,
     /* 12398 */   GIR_EraseRootFromParent_Done,
     /* 12399 */ // Label 461: @12399
     /* 12399 */ GIM_Reject,
     /* 12400 */ // Label 438: @12400
     /* 12400 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(12536),
     /* 12405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 12408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 12411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 12415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 12419 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(12452), // Rule ID 23258 //
     /* 12424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 12427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 12431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 12435 */     // MIs[1] Operand 1
     /* 12435 */     // No operand predicates
     /* 12435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 12437 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (OR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 12437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8ri),
     /* 12440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12442 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 12444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 12447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 12450 */     GIR_RootConstrainSelectedInstOperands,
     /* 12451 */     // GIR_Coverage, 23258,
     /* 12451 */     GIR_EraseRootFromParent_Done,
     /* 12452 */   // Label 463: @12452
     /* 12452 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(12485), // Rule ID 23348 //
     /* 12457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 12460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 12464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 12468 */     // MIs[1] Operand 1
     /* 12468 */     // No operand predicates
     /* 12468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 12470 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (OR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 12470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8ri_ND),
     /* 12473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12475 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 12477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 12480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 12483 */     GIR_RootConstrainSelectedInstOperands,
     /* 12484 */     // GIR_Coverage, 23348,
     /* 12484 */     GIR_EraseRootFromParent_Done,
     /* 12485 */   // Label 464: @12485
     /* 12485 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(12510), // Rule ID 23250 //
     /* 12490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 12493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 12497 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (OR8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /* 12497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR8rr),
     /* 12502 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 12508 */     GIR_RootConstrainSelectedInstOperands,
     /* 12509 */     // GIR_Coverage, 23250,
     /* 12509 */     GIR_Done,
     /* 12510 */   // Label 465: @12510
     /* 12510 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(12535), // Rule ID 23340 //
     /* 12515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 12518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 12522 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (OR8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /* 12522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR8rr_ND),
     /* 12527 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 12533 */     GIR_RootConstrainSelectedInstOperands,
     /* 12534 */     // GIR_Coverage, 23340,
     /* 12534 */     GIR_Done,
     /* 12535 */   // Label 466: @12535
     /* 12535 */   GIM_Reject,
     /* 12536 */ // Label 462: @12536
     /* 12536 */ GIM_Reject,
     /* 12537 */ // Label 439: @12537
     /* 12537 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(12889),
     /* 12542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 12545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 12548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12552 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(12654), // Rule ID 26461 //
     /* 12557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 12561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 12565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 12569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 12573 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 12577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 12582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 12588 */     // (or:{ *:[i16] } (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTS16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 12588 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 12591 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 12595 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 12600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 12602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 12605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 12609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 12614 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 12617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 12621 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 12624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 12629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 12634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 12639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS16rr),
     /* 12642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12644 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 12646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 12649 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 12652 */     GIR_RootConstrainSelectedInstOperands,
     /* 12653 */     // GIR_Coverage, 26461,
     /* 12653 */     GIR_EraseRootFromParent_Done,
     /* 12654 */   // Label 468: @12654
     /* 12654 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(12756), // Rule ID 23199 //
     /* 12659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 12667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 12671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 12675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 12679 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 12683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 12688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 12690 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTS16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 12690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 12693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 12697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 12702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 12704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 12707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 12711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 12716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 12719 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 12723 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 12726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 12731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 12736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 12741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS16rr),
     /* 12744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12746 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 12748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 12751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 12754 */     GIR_RootConstrainSelectedInstOperands,
     /* 12755 */     // GIR_Coverage, 23199,
     /* 12755 */     GIR_EraseRootFromParent_Done,
     /* 12756 */   // Label 469: @12756
     /* 12756 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(12793), // Rule ID 23259 //
     /* 12761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 12764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 12772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 12776 */     // MIs[1] Operand 1
     /* 12776 */     // No operand predicates
     /* 12776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 12778 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (OR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /* 12778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16ri),
     /* 12781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12783 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 12785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 12788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 12791 */     GIR_RootConstrainSelectedInstOperands,
     /* 12792 */     // GIR_Coverage, 23259,
     /* 12792 */     GIR_EraseRootFromParent_Done,
     /* 12793 */   // Label 470: @12793
     /* 12793 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(12830), // Rule ID 23349 //
     /* 12798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 12801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 12809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 12813 */     // MIs[1] Operand 1
     /* 12813 */     // No operand predicates
     /* 12813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 12815 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (OR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /* 12815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16ri_ND),
     /* 12818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12820 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 12822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 12825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 12828 */     GIR_RootConstrainSelectedInstOperands,
     /* 12829 */     // GIR_Coverage, 23349,
     /* 12829 */     GIR_EraseRootFromParent_Done,
     /* 12830 */   // Label 471: @12830
     /* 12830 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(12859), // Rule ID 23251 //
     /* 12835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 12838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12846 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (OR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /* 12846 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR16rr),
     /* 12851 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 12857 */     GIR_RootConstrainSelectedInstOperands,
     /* 12858 */     // GIR_Coverage, 23251,
     /* 12858 */     GIR_Done,
     /* 12859 */   // Label 472: @12859
     /* 12859 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(12888), // Rule ID 23341 //
     /* 12864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 12867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12875 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (OR16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /* 12875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR16rr_ND),
     /* 12880 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 12886 */     GIR_RootConstrainSelectedInstOperands,
     /* 12887 */     // GIR_Coverage, 23341,
     /* 12887 */     GIR_Done,
     /* 12888 */   // Label 473: @12888
     /* 12888 */   GIM_Reject,
     /* 12889 */ // Label 467: @12889
     /* 12889 */ GIM_Reject,
     /* 12890 */ // Label 440: @12890
     /* 12890 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(14073),
     /* 12895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 12898 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(12975), // Rule ID 25427 //
     /* 12903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 12906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 12913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 12917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 12921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 12925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 12929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 12934 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 12938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 12942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 12946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 12950 */     // MIs[2] src
     /* 12950 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 12955 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /* 12959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 12961 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 12961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC32rr),
     /* 12964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 12970 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 12973 */     GIR_RootConstrainSelectedInstOperands,
     /* 12974 */     // GIR_Coverage, 25427,
     /* 12974 */     GIR_EraseRootFromParent_Done,
     /* 12975 */   // Label 475: @12975
     /* 12975 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(13052), // Rule ID 25429 //
     /* 12980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 12983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 12990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 12994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 12998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13011 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 13015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 13019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 13023 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 13027 */     // MIs[2] src
     /* 13027 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 13032 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /* 13036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 13038 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (T1MSKC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC32rr),
     /* 13041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 13047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13050 */     GIR_RootConstrainSelectedInstOperands,
     /* 13051 */     // GIR_Coverage, 25429,
     /* 13051 */     GIR_EraseRootFromParent_Done,
     /* 13052 */   // Label 476: @13052
     /* 13052 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(13130), // Rule ID 25415 //
     /* 13057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 13068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 13072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 13084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 13088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 13092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 13096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13101 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 13105 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 13109 */     // MIs[0] src
     /* 13109 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 13114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 13116 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), -1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /* 13119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /* 13125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13128 */     GIR_RootConstrainSelectedInstOperands,
     /* 13129 */     // GIR_Coverage, 25415,
     /* 13129 */     GIR_EraseRootFromParent_Done,
     /* 13130 */   // Label 477: @13130
     /* 13130 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(13207), // Rule ID 17811 //
     /* 13135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 13149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 13153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13166 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 13170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 13174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 13178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 13182 */     // MIs[2] src
     /* 13182 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 13187 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /* 13191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 13193 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC32rr),
     /* 13196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 13202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13205 */     GIR_RootConstrainSelectedInstOperands,
     /* 13206 */     // GIR_Coverage, 17811,
     /* 13206 */     GIR_EraseRootFromParent_Done,
     /* 13207 */   // Label 478: @13207
     /* 13207 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(13284), // Rule ID 17813 //
     /* 13212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 13226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 13230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13243 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 13247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 13251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 13255 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 13259 */     // MIs[2] src
     /* 13259 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 13264 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 13268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 13270 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (T1MSKC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC32rr),
     /* 13273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 13279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13282 */     GIR_RootConstrainSelectedInstOperands,
     /* 13283 */     // GIR_Coverage, 17813,
     /* 13283 */     GIR_EraseRootFromParent_Done,
     /* 13284 */   // Label 479: @13284
     /* 13284 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(13358), // Rule ID 17799 //
     /* 13289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 13307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 13311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 13323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 13327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 13331 */     // MIs[2] src
     /* 13331 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 13336 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 13340 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 13344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 13346 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), -1:{ *:[i32] }))  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /* 13349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13351 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 13353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13356 */     GIR_RootConstrainSelectedInstOperands,
     /* 13357 */     // GIR_Coverage, 17799,
     /* 13357 */     GIR_EraseRootFromParent_Done,
     /* 13358 */   // Label 480: @13358
     /* 13358 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(13416), // Rule ID 25423 //
     /* 13363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 13374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 13378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13391 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 13395 */     // MIs[0] src
     /* 13395 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 13400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13402 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS32rr),
     /* 13405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 13411 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13414 */     GIR_RootConstrainSelectedInstOperands,
     /* 13415 */     // GIR_Coverage, 25423,
     /* 13415 */     GIR_EraseRootFromParent_Done,
     /* 13416 */   // Label 481: @13416
     /* 13416 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(13474), // Rule ID 25425 //
     /* 13421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 13432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 13436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13449 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 13453 */     // MIs[0] src
     /* 13453 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 13458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13460 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLSFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL32rr),
     /* 13463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 13469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13472 */     GIR_RootConstrainSelectedInstOperands,
     /* 13473 */     // GIR_Coverage, 25425,
     /* 13473 */     GIR_EraseRootFromParent_Done,
     /* 13474 */   // Label 482: @13474
     /* 13474 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(13583), // Rule ID 26467 //
     /* 13479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 13490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 13502 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 13506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 13511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13517 */     // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 13517 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 13520 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 13524 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 13529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 13531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 13534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 13538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 13543 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 13546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 13550 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 13553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 13558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 13563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 13568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS32rr),
     /* 13571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13573 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 13575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 13578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13581 */     GIR_RootConstrainSelectedInstOperands,
     /* 13582 */     // GIR_Coverage, 26467,
     /* 13582 */     GIR_EraseRootFromParent_Done,
     /* 13583 */   // Label 483: @13583
     /* 13583 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(13641), // Rule ID 25417 //
     /* 13588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 13599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 13603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13611 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /* 13615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13620 */     // MIs[0] src
     /* 13620 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 13625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13627 */     // (or:{ *:[i32] } (sub:{ *:[i32] } -2:{ *:[i32] }, GR32:{ *:[i32] }:$src), GR32:{ *:[i32] }:$src)  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /* 13630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /* 13636 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13639 */     GIR_RootConstrainSelectedInstOperands,
     /* 13640 */     // GIR_Coverage, 25417,
     /* 13640 */     GIR_EraseRootFromParent_Done,
     /* 13641 */   // Label 484: @13641
     /* 13641 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(13695), // Rule ID 17807 //
     /* 13646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 13664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 13668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13672 */     // MIs[1] src
     /* 13672 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 13677 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 13681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13683 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS32rr),
     /* 13686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13688 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 13690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13693 */     GIR_RootConstrainSelectedInstOperands,
     /* 13694 */     // GIR_Coverage, 17807,
     /* 13694 */     GIR_EraseRootFromParent_Done,
     /* 13695 */   // Label 485: @13695
     /* 13695 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(13749), // Rule ID 17809 //
     /* 13700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 13718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 13722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13726 */     // MIs[1] src
     /* 13726 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 13731 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 13735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13737 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL32rr),
     /* 13740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13742 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 13744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13747 */     GIR_RootConstrainSelectedInstOperands,
     /* 13748 */     // GIR_Coverage, 17809,
     /* 13748 */     GIR_EraseRootFromParent_Done,
     /* 13749 */   // Label 486: @13749
     /* 13749 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(13858), // Rule ID 23205 //
     /* 13754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 13769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 13781 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 13785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 13790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13792 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 13792 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 13795 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 13799 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 13804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 13806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 13809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 13813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 13818 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 13821 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 13825 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 13828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 13833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 13838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 13843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS32rr),
     /* 13846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13848 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 13850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 13853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13856 */     GIR_RootConstrainSelectedInstOperands,
     /* 13857 */     // GIR_Coverage, 23205,
     /* 13857 */     GIR_EraseRootFromParent_Done,
     /* 13858 */   // Label 487: @13858
     /* 13858 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(13912), // Rule ID 17801 //
     /* 13863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 13881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 13885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13889 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /* 13893 */     // MIs[1] src
     /* 13893 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 13898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13900 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (sub:{ *:[i32] } -2:{ *:[i32] }, GR32:{ *:[i32] }:$src))  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /* 13903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13905 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 13907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13910 */     GIR_RootConstrainSelectedInstOperands,
     /* 13911 */     // GIR_Coverage, 17801,
     /* 13911 */     GIR_EraseRootFromParent_Done,
     /* 13912 */   // Label 488: @13912
     /* 13912 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(13956), // Rule ID 23260 //
     /* 13917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 13920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 13935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13939 */     // MIs[1] Operand 1
     /* 13939 */     // No operand predicates
     /* 13939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13941 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (OR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /* 13941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32ri),
     /* 13944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13946 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 13948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 13951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13954 */     GIR_RootConstrainSelectedInstOperands,
     /* 13955 */     // GIR_Coverage, 23260,
     /* 13955 */     GIR_EraseRootFromParent_Done,
     /* 13956 */   // Label 489: @13956
     /* 13956 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(14000), // Rule ID 23350 //
     /* 13961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 13964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 13979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13983 */     // MIs[1] Operand 1
     /* 13983 */     // No operand predicates
     /* 13983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13985 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (OR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /* 13985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32ri_ND),
     /* 13988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13990 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 13992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 13995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13998 */     GIR_RootConstrainSelectedInstOperands,
     /* 13999 */     // GIR_Coverage, 23350,
     /* 13999 */     GIR_EraseRootFromParent_Done,
     /* 14000 */   // Label 490: @14000
     /* 14000 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(14036), // Rule ID 23252 //
     /* 14005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 14008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 14011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 14015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 14019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 14023 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (OR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 14023 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR32rr),
     /* 14028 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 14034 */     GIR_RootConstrainSelectedInstOperands,
     /* 14035 */     // GIR_Coverage, 23252,
     /* 14035 */     GIR_Done,
     /* 14036 */   // Label 491: @14036
     /* 14036 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(14072), // Rule ID 23342 //
     /* 14041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 14044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 14047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 14051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 14055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 14059 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (OR32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 14059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR32rr_ND),
     /* 14064 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 14070 */     GIR_RootConstrainSelectedInstOperands,
     /* 14071 */     // GIR_Coverage, 23342,
     /* 14071 */     GIR_Done,
     /* 14072 */   // Label 492: @14072
     /* 14072 */   GIM_Reject,
     /* 14073 */ // Label 474: @14073
     /* 14073 */ GIM_Reject,
     /* 14074 */ // Label 441: @14074
     /* 14074 */ GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(15265),
     /* 14079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 14082 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(14159), // Rule ID 25428 //
     /* 14087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14118 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 14122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 14126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 14130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14134 */     // MIs[2] src
     /* 14134 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 14139 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /* 14143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 14145 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC64rr),
     /* 14148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 14154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14157 */     GIR_RootConstrainSelectedInstOperands,
     /* 14158 */     // GIR_Coverage, 25428,
     /* 14158 */     GIR_EraseRootFromParent_Done,
     /* 14159 */   // Label 494: @14159
     /* 14159 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(14236), // Rule ID 25430 //
     /* 14164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14195 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 14199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 14203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 14207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14211 */     // MIs[2] src
     /* 14211 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 14216 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /* 14220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 14222 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (T1MSKC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC64rr),
     /* 14225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 14231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14234 */     GIR_RootConstrainSelectedInstOperands,
     /* 14235 */     // GIR_Coverage, 25430,
     /* 14235 */     GIR_EraseRootFromParent_Done,
     /* 14236 */   // Label 495: @14236
     /* 14236 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(14314), // Rule ID 25416 //
     /* 14241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 14256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 14268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 14276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14285 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 14289 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 14293 */     // MIs[0] src
     /* 14293 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 14298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 14300 */     // (or:{ *:[i64] } (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), -1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /* 14303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /* 14309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14312 */     GIR_RootConstrainSelectedInstOperands,
     /* 14313 */     // GIR_Coverage, 25416,
     /* 14313 */     GIR_EraseRootFromParent_Done,
     /* 14314 */   // Label 496: @14314
     /* 14314 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(14391), // Rule ID 17812 //
     /* 14319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 14337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14350 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 14354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 14358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14366 */     // MIs[2] src
     /* 14366 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 14371 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /* 14375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 14377 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC64rr),
     /* 14380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 14386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14389 */     GIR_RootConstrainSelectedInstOperands,
     /* 14390 */     // GIR_Coverage, 17812,
     /* 14390 */     GIR_EraseRootFromParent_Done,
     /* 14391 */   // Label 497: @14391
     /* 14391 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(14468), // Rule ID 17814 //
     /* 14396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 14414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14427 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 14431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 14435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14443 */     // MIs[2] src
     /* 14443 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 14448 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 14452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 14454 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (T1MSKC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC64rr),
     /* 14457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 14463 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14466 */     GIR_RootConstrainSelectedInstOperands,
     /* 14467 */     // GIR_Coverage, 17814,
     /* 14467 */     GIR_EraseRootFromParent_Done,
     /* 14468 */   // Label 498: @14468
     /* 14468 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(14542), // Rule ID 17800 //
     /* 14473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 14491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 14495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 14507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14511 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14515 */     // MIs[2] src
     /* 14515 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 14520 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 14524 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 14528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 14530 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), -1:{ *:[i64] }))  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /* 14533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 14537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14540 */     GIR_RootConstrainSelectedInstOperands,
     /* 14541 */     // GIR_Coverage, 17800,
     /* 14541 */     GIR_EraseRootFromParent_Done,
     /* 14542 */   // Label 499: @14542
     /* 14542 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(14600), // Rule ID 25424 //
     /* 14547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14575 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 14579 */     // MIs[0] src
     /* 14579 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 14584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14586 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS64rr),
     /* 14589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 14595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14598 */     GIR_RootConstrainSelectedInstOperands,
     /* 14599 */     // GIR_Coverage, 25424,
     /* 14599 */     GIR_EraseRootFromParent_Done,
     /* 14600 */   // Label 500: @14600
     /* 14600 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(14658), // Rule ID 25426 //
     /* 14605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14633 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 14637 */     // MIs[0] src
     /* 14637 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 14642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14644 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLSFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL64rr),
     /* 14647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 14653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14656 */     GIR_RootConstrainSelectedInstOperands,
     /* 14657 */     // GIR_Coverage, 25426,
     /* 14657 */     GIR_EraseRootFromParent_Done,
     /* 14658 */   // Label 501: @14658
     /* 14658 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(14767), // Rule ID 26473 //
     /* 14663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 14678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 14686 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 14690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 14695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14701 */     // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 14701 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 14704 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 14708 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 14713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 14715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 14718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 14722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 14727 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 14730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 14734 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 14737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 14742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 14747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 14752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS64rr),
     /* 14755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 14759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 14762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14765 */     GIR_RootConstrainSelectedInstOperands,
     /* 14766 */     // GIR_Coverage, 26473,
     /* 14766 */     GIR_EraseRootFromParent_Done,
     /* 14767 */   // Label 502: @14767
     /* 14767 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(14825), // Rule ID 25418 //
     /* 14772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 14787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14795 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /* 14799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14804 */     // MIs[0] src
     /* 14804 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 14809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14811 */     // (or:{ *:[i64] } (sub:{ *:[i64] } -2:{ *:[i64] }, GR64:{ *:[i64] }:$src), GR64:{ *:[i64] }:$src)  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /* 14814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /* 14820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14823 */     GIR_RootConstrainSelectedInstOperands,
     /* 14824 */     // GIR_Coverage, 25418,
     /* 14824 */     GIR_EraseRootFromParent_Done,
     /* 14825 */   // Label 503: @14825
     /* 14825 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(14879), // Rule ID 17808 //
     /* 14830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 14848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14856 */     // MIs[1] src
     /* 14856 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 14861 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 14865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14867 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS64rr),
     /* 14870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14872 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 14874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14877 */     GIR_RootConstrainSelectedInstOperands,
     /* 14878 */     // GIR_Coverage, 17808,
     /* 14878 */     GIR_EraseRootFromParent_Done,
     /* 14879 */   // Label 504: @14879
     /* 14879 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(14933), // Rule ID 17810 //
     /* 14884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 14902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14910 */     // MIs[1] src
     /* 14910 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 14915 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 14919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14921 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL64rr),
     /* 14924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14926 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 14928 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14931 */     GIR_RootConstrainSelectedInstOperands,
     /* 14932 */     // GIR_Coverage, 17810,
     /* 14932 */     GIR_EraseRootFromParent_Done,
     /* 14933 */   // Label 505: @14933
     /* 14933 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(15042), // Rule ID 23211 //
     /* 14938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 14953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 14957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 14965 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 14969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 14974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14976 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 14976 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 14979 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 14983 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 14988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 14990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 14993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 14997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15002 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 15005 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 15009 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 15012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 15017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 15022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 15027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS64rr),
     /* 15030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 15032 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 15034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 15037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 15040 */     GIR_RootConstrainSelectedInstOperands,
     /* 15041 */     // GIR_Coverage, 23211,
     /* 15041 */     GIR_EraseRootFromParent_Done,
     /* 15042 */   // Label 506: @15042
     /* 15042 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(15096), // Rule ID 17802 //
     /* 15047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 15050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 15053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 15073 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /* 15077 */     // MIs[1] src
     /* 15077 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 15082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15084 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (sub:{ *:[i64] } -2:{ *:[i64] }, GR64:{ *:[i64] }:$src))  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 15084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /* 15087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 15089 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 15091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 15094 */     GIR_RootConstrainSelectedInstOperands,
     /* 15095 */     // GIR_Coverage, 17802,
     /* 15095 */     GIR_EraseRootFromParent_Done,
     /* 15096 */   // Label 507: @15096
     /* 15096 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(15144), // Rule ID 23261 //
     /* 15101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 15104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 15107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /* 15127 */     // MIs[1] Operand 1
     /* 15127 */     // No operand predicates
     /* 15127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15129 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (OR64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /* 15129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64ri32),
     /* 15132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 15134 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 15136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 15139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 15142 */     GIR_RootConstrainSelectedInstOperands,
     /* 15143 */     // GIR_Coverage, 23261,
     /* 15143 */     GIR_EraseRootFromParent_Done,
     /* 15144 */   // Label 508: @15144
     /* 15144 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(15192), // Rule ID 23351 //
     /* 15149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 15152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 15155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /* 15175 */     // MIs[1] Operand 1
     /* 15175 */     // No operand predicates
     /* 15175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15177 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (OR64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /* 15177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64ri32_ND),
     /* 15180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 15182 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 15184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 15187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 15190 */     GIR_RootConstrainSelectedInstOperands,
     /* 15191 */     // GIR_Coverage, 23351,
     /* 15191 */     GIR_EraseRootFromParent_Done,
     /* 15192 */   // Label 509: @15192
     /* 15192 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(15228), // Rule ID 23253 //
     /* 15197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 15200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 15203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15215 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (OR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 15215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR64rr),
     /* 15220 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 15226 */     GIR_RootConstrainSelectedInstOperands,
     /* 15227 */     // GIR_Coverage, 23253,
     /* 15227 */     GIR_Done,
     /* 15228 */   // Label 510: @15228
     /* 15228 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(15264), // Rule ID 23343 //
     /* 15233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 15236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 15239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15251 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (OR64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 15251 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR64rr_ND),
     /* 15256 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 15262 */     GIR_RootConstrainSelectedInstOperands,
     /* 15263 */     // GIR_Coverage, 23343,
     /* 15263 */     GIR_Done,
     /* 15264 */   // Label 511: @15264
     /* 15264 */   GIM_Reject,
     /* 15265 */ // Label 493: @15265
     /* 15265 */ GIM_Reject,
     /* 15266 */ // Label 442: @15266
     /* 15266 */ GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(15365), // Rule ID 19940 //
     /* 15271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 15274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 15277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 15281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 15285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 15289 */   // (or:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /* 15289 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 15292 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15296 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15301 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 15305 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 15310 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 15313 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15317 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15322 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 15326 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 15331 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 15334 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /* 15338 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15343 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 15346 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 15349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 15351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 15356 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 15359 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 15364 */   // GIR_Coverage, 19940,
     /* 15364 */   GIR_EraseRootFromParent_Done,
     /* 15365 */ // Label 512: @15365
     /* 15365 */ GIM_Reject,
     /* 15366 */ // Label 443: @15366
     /* 15366 */ GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(15459),
     /* 15371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 15374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 15377 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(15404), // Rule ID 2113 //
     /* 15382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 15385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15397 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 15397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /* 15402 */     GIR_RootConstrainSelectedInstOperands,
     /* 15403 */     // GIR_Coverage, 2113,
     /* 15403 */     GIR_Done,
     /* 15404 */   // Label 514: @15404
     /* 15404 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(15431), // Rule ID 2115 //
     /* 15409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 15412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15424 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 15424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /* 15429 */     GIR_RootConstrainSelectedInstOperands,
     /* 15430 */     // GIR_Coverage, 2115,
     /* 15430 */     GIR_Done,
     /* 15431 */   // Label 515: @15431
     /* 15431 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(15458), // Rule ID 5755 //
     /* 15436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 15439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15451 */     // (or:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPORQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 15451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /* 15456 */     GIR_RootConstrainSelectedInstOperands,
     /* 15457 */     // GIR_Coverage, 5755,
     /* 15457 */     GIR_Done,
     /* 15458 */   // Label 516: @15458
     /* 15458 */   GIM_Reject,
     /* 15459 */ // Label 513: @15459
     /* 15459 */ GIM_Reject,
     /* 15460 */ // Label 444: @15460
     /* 15460 */ GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(15559), // Rule ID 19941 //
     /* 15465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 15468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 15471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 15475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 15479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 15483 */   // (or:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 15483 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 15486 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15490 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15495 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 15499 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 15504 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 15507 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15511 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15516 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 15520 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 15525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 15528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /* 15532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15537 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 15540 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 15543 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 15545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 15550 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 15553 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 15558 */   // GIR_Coverage, 19941,
     /* 15558 */   GIR_EraseRootFromParent_Done,
     /* 15559 */ // Label 517: @15559
     /* 15559 */ GIM_Reject,
     /* 15560 */ // Label 445: @15560
     /* 15560 */ GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(15653),
     /* 15565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 15568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 15571 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(15598), // Rule ID 5782 //
     /* 15576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 15579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15591 */     // (or:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPORDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 15591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rr),
     /* 15596 */     GIR_RootConstrainSelectedInstOperands,
     /* 15597 */     // GIR_Coverage, 5782,
     /* 15597 */     GIR_Done,
     /* 15598 */   // Label 519: @15598
     /* 15598 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(15625), // Rule ID 18598 //
     /* 15603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 15606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15618 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 15618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /* 15623 */     GIR_RootConstrainSelectedInstOperands,
     /* 15624 */     // GIR_Coverage, 18598,
     /* 15624 */     GIR_Done,
     /* 15625 */   // Label 520: @15625
     /* 15625 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(15652), // Rule ID 18622 //
     /* 15630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 15633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15645 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 15645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /* 15650 */     GIR_RootConstrainSelectedInstOperands,
     /* 15651 */     // GIR_Coverage, 18622,
     /* 15651 */     GIR_Done,
     /* 15652 */   // Label 521: @15652
     /* 15652 */   GIM_Reject,
     /* 15653 */ // Label 518: @15653
     /* 15653 */ GIM_Reject,
     /* 15654 */ // Label 446: @15654
     /* 15654 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(15747),
     /* 15659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 15662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 15665 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(15692), // Rule ID 2117 //
     /* 15670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 15673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 15677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 15681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 15685 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPORYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 15685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /* 15690 */     GIR_RootConstrainSelectedInstOperands,
     /* 15691 */     // GIR_Coverage, 2117,
     /* 15691 */     GIR_Done,
     /* 15692 */   // Label 523: @15692
     /* 15692 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(15719), // Rule ID 5746 //
     /* 15697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 15700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 15704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 15708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 15712 */     // (or:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPORQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 15712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /* 15717 */     GIR_RootConstrainSelectedInstOperands,
     /* 15718 */     // GIR_Coverage, 5746,
     /* 15718 */     GIR_Done,
     /* 15719 */   // Label 524: @15719
     /* 15719 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(15746), // Rule ID 18568 //
     /* 15724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 15727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 15731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 15735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 15739 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VORPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 15739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /* 15744 */     GIR_RootConstrainSelectedInstOperands,
     /* 15745 */     // GIR_Coverage, 18568,
     /* 15745 */     GIR_Done,
     /* 15746 */   // Label 525: @15746
     /* 15746 */   GIM_Reject,
     /* 15747 */ // Label 522: @15747
     /* 15747 */ GIM_Reject,
     /* 15748 */ // Label 447: @15748
     /* 15748 */ GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(15871),
     /* 15753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 15756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 15759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 15763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 15767 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 15771 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(15786), // Rule ID 4416 //
     /* 15776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 15779 */     // (or:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /* 15779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORBkk),
     /* 15784 */     GIR_RootConstrainSelectedInstOperands,
     /* 15785 */     // GIR_Coverage, 4416,
     /* 15785 */     GIR_Done,
     /* 15786 */   // Label 527: @15786
     /* 15786 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(15870), // Rule ID 19938 //
     /* 15791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /* 15794 */     // (or:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 15794 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 15797 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15801 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15806 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 15810 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 15815 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 15818 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15822 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15827 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 15831 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 15836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 15839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /* 15843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15848 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 15851 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 15854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 15856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 15861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 15864 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 15869 */     // GIR_Coverage, 19938,
     /* 15869 */     GIR_EraseRootFromParent_Done,
     /* 15870 */   // Label 528: @15870
     /* 15870 */   GIM_Reject,
     /* 15871 */ // Label 526: @15871
     /* 15871 */ GIM_Reject,
     /* 15872 */ // Label 448: @15872
     /* 15872 */ GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(15965),
     /* 15877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 15880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 15883 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(15910), // Rule ID 18597 //
     /* 15888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 15891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15903 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 15903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /* 15908 */     GIR_RootConstrainSelectedInstOperands,
     /* 15909 */     // GIR_Coverage, 18597,
     /* 15909 */     GIR_Done,
     /* 15910 */   // Label 530: @15910
     /* 15910 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(15937), // Rule ID 18621 //
     /* 15915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 15918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15930 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 15930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /* 15935 */     GIR_RootConstrainSelectedInstOperands,
     /* 15936 */     // GIR_Coverage, 18621,
     /* 15936 */     GIR_Done,
     /* 15937 */   // Label 531: @15937
     /* 15937 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(15964), // Rule ID 20466 //
     /* 15942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 15945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15957 */     // (or:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPORQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 15957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /* 15962 */     GIR_RootConstrainSelectedInstOperands,
     /* 15963 */     // GIR_Coverage, 20466,
     /* 15963 */     GIR_Done,
     /* 15964 */   // Label 532: @15964
     /* 15964 */   GIM_Reject,
     /* 15965 */ // Label 529: @15965
     /* 15965 */ GIM_Reject,
     /* 15966 */ // Label 449: @15966
     /* 15966 */ GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(16059),
     /* 15971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 15974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 15977 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(16004), // Rule ID 5773 //
     /* 15982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 15985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 15989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 15993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 15997 */     // (or:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPORDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 15997 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rr),
     /* 16002 */     GIR_RootConstrainSelectedInstOperands,
     /* 16003 */     // GIR_Coverage, 5773,
     /* 16003 */     GIR_Done,
     /* 16004 */   // Label 534: @16004
     /* 16004 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(16031), // Rule ID 18542 //
     /* 16009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 16012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16024 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPORYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 16024 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /* 16029 */     GIR_RootConstrainSelectedInstOperands,
     /* 16030 */     // GIR_Coverage, 18542,
     /* 16030 */     GIR_Done,
     /* 16031 */   // Label 535: @16031
     /* 16031 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(16058), // Rule ID 18567 //
     /* 16036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 16039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16051 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VORPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 16051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /* 16056 */     GIR_RootConstrainSelectedInstOperands,
     /* 16057 */     // GIR_Coverage, 18567,
     /* 16057 */     GIR_Done,
     /* 16058 */   // Label 536: @16058
     /* 16058 */   GIM_Reject,
     /* 16059 */ // Label 533: @16059
     /* 16059 */ GIM_Reject,
     /* 16060 */ // Label 450: @16060
     /* 16060 */ GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(16093), // Rule ID 5737 //
     /* 16065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 16068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 16071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 16074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16082 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16086 */   // (or:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPORQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 16086 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /* 16091 */   GIR_RootConstrainSelectedInstOperands,
     /* 16092 */   // GIR_Coverage, 5737,
     /* 16092 */   GIR_Done,
     /* 16093 */ // Label 537: @16093
     /* 16093 */ GIM_Reject,
     /* 16094 */ // Label 451: @16094
     /* 16094 */ GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(16127), // Rule ID 4417 //
     /* 16099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 16102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 16105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 16108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 16112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 16116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 16120 */   // (or:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /* 16120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /* 16125 */   GIR_RootConstrainSelectedInstOperands,
     /* 16126 */   // GIR_Coverage, 4417,
     /* 16126 */   GIR_Done,
     /* 16127 */ // Label 538: @16127
     /* 16127 */ GIM_Reject,
     /* 16128 */ // Label 452: @16128
     /* 16128 */ GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(16221),
     /* 16133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 16136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 16139 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(16166), // Rule ID 18596 //
     /* 16144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 16147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 16151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 16155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 16159 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 16159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /* 16164 */     GIR_RootConstrainSelectedInstOperands,
     /* 16165 */     // GIR_Coverage, 18596,
     /* 16165 */     GIR_Done,
     /* 16166 */   // Label 540: @16166
     /* 16166 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(16193), // Rule ID 18620 //
     /* 16171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 16174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 16178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 16182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 16186 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 16186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /* 16191 */     GIR_RootConstrainSelectedInstOperands,
     /* 16192 */     // GIR_Coverage, 18620,
     /* 16192 */     GIR_Done,
     /* 16193 */   // Label 541: @16193
     /* 16193 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(16220), // Rule ID 20465 //
     /* 16198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 16201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 16205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 16209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 16213 */     // (or:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPORQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 16213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /* 16218 */     GIR_RootConstrainSelectedInstOperands,
     /* 16219 */     // GIR_Coverage, 20465,
     /* 16219 */     GIR_Done,
     /* 16220 */   // Label 542: @16220
     /* 16220 */   GIM_Reject,
     /* 16221 */ // Label 539: @16221
     /* 16221 */ GIM_Reject,
     /* 16222 */ // Label 453: @16222
     /* 16222 */ GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(16315),
     /* 16227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 16230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 16233 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(16260), // Rule ID 18541 //
     /* 16238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 16241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16253 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPORYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 16253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /* 16258 */     GIR_RootConstrainSelectedInstOperands,
     /* 16259 */     // GIR_Coverage, 18541,
     /* 16259 */     GIR_Done,
     /* 16260 */   // Label 544: @16260
     /* 16260 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(16287), // Rule ID 18566 //
     /* 16265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 16268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16280 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VORPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 16280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /* 16285 */     GIR_RootConstrainSelectedInstOperands,
     /* 16286 */     // GIR_Coverage, 18566,
     /* 16286 */     GIR_Done,
     /* 16287 */   // Label 545: @16287
     /* 16287 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(16314), // Rule ID 20482 //
     /* 16292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 16295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 16299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 16303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 16307 */     // (or:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPORQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 16307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /* 16312 */     GIR_RootConstrainSelectedInstOperands,
     /* 16313 */     // GIR_Coverage, 20482,
     /* 16313 */     GIR_Done,
     /* 16314 */   // Label 546: @16314
     /* 16314 */   GIM_Reject,
     /* 16315 */ // Label 543: @16315
     /* 16315 */ GIM_Reject,
     /* 16316 */ // Label 454: @16316
     /* 16316 */ GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(16349), // Rule ID 5764 //
     /* 16321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 16324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 16327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 16330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16342 */   // (or:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPORDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 16342 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZrr),
     /* 16347 */   GIR_RootConstrainSelectedInstOperands,
     /* 16348 */   // GIR_Coverage, 5764,
     /* 16348 */   GIR_Done,
     /* 16349 */ // Label 547: @16349
     /* 16349 */ GIM_Reject,
     /* 16350 */ // Label 455: @16350
     /* 16350 */ GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(16383), // Rule ID 4418 //
     /* 16355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 16358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 16361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 16364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 16368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 16372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 16376 */   // (or:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /* 16376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORDkk),
     /* 16381 */   GIR_RootConstrainSelectedInstOperands,
     /* 16382 */   // GIR_Coverage, 4418,
     /* 16382 */   GIR_Done,
     /* 16383 */ // Label 548: @16383
     /* 16383 */ GIM_Reject,
     /* 16384 */ // Label 456: @16384
     /* 16384 */ GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(16477),
     /* 16389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 16392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 16395 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(16422), // Rule ID 18540 //
     /* 16400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 16403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16415 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPORYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 16415 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /* 16420 */     GIR_RootConstrainSelectedInstOperands,
     /* 16421 */     // GIR_Coverage, 18540,
     /* 16421 */     GIR_Done,
     /* 16422 */   // Label 550: @16422
     /* 16422 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(16449), // Rule ID 18565 //
     /* 16427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 16430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16442 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VORPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 16442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /* 16447 */     GIR_RootConstrainSelectedInstOperands,
     /* 16448 */     // GIR_Coverage, 18565,
     /* 16448 */     GIR_Done,
     /* 16449 */   // Label 551: @16449
     /* 16449 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(16476), // Rule ID 20481 //
     /* 16454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 16457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 16461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 16465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 16469 */     // (or:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPORQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 16469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /* 16474 */     GIR_RootConstrainSelectedInstOperands,
     /* 16475 */     // GIR_Coverage, 20481,
     /* 16475 */     GIR_Done,
     /* 16476 */   // Label 552: @16476
     /* 16476 */   GIM_Reject,
     /* 16477 */ // Label 549: @16477
     /* 16477 */ GIM_Reject,
     /* 16478 */ // Label 457: @16478
     /* 16478 */ GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(16511), // Rule ID 20498 //
     /* 16483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 16486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 16489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 16492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16504 */   // (or:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPORQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 16504 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /* 16509 */   GIR_RootConstrainSelectedInstOperands,
     /* 16510 */   // GIR_Coverage, 20498,
     /* 16510 */   GIR_Done,
     /* 16511 */ // Label 553: @16511
     /* 16511 */ GIM_Reject,
     /* 16512 */ // Label 458: @16512
     /* 16512 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(16545), // Rule ID 4419 //
     /* 16517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 16520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 16523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 16526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 16530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 16534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 16538 */   // (or:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /* 16538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORQkk),
     /* 16543 */   GIR_RootConstrainSelectedInstOperands,
     /* 16544 */   // GIR_Coverage, 4419,
     /* 16544 */   GIR_Done,
     /* 16545 */ // Label 554: @16545
     /* 16545 */ GIM_Reject,
     /* 16546 */ // Label 459: @16546
     /* 16546 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(16579), // Rule ID 20497 //
     /* 16551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 16554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 16557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 16560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16572 */   // (or:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPORQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 16572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /* 16577 */   GIR_RootConstrainSelectedInstOperands,
     /* 16578 */   // GIR_Coverage, 20497,
     /* 16578 */   GIR_Done,
     /* 16579 */ // Label 555: @16579
     /* 16579 */ GIM_Reject,
     /* 16580 */ // Label 460: @16580
     /* 16580 */ GIM_Reject,
     /* 16581 */ // Label 5: @16581
     /* 16581 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 579*/ GIMT_Encode4(25027),
     /* 16592 */ /*GILLT_s1*//*Label 556*/ GIMT_Encode4(16692),
     /* 16596 */ /*GILLT_s8*//*Label 557*/ GIMT_Encode4(17250),
     /* 16600 */ /*GILLT_s16*//*Label 558*/ GIMT_Encode4(17453),
     /* 16604 */ /*GILLT_s32*//*Label 559*/ GIMT_Encode4(17898),
     /* 16608 */ /*GILLT_s64*//*Label 560*/ GIMT_Encode4(18511), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 16620 */ /*GILLT_v2s1*//*Label 561*/ GIMT_Encode4(19083),
     /* 16624 */ /*GILLT_v2s64*//*Label 562*/ GIMT_Encode4(19625),
     /* 16628 */ /*GILLT_v4s1*//*Label 563*/ GIMT_Encode4(19997),
     /* 16632 */ /*GILLT_v4s32*//*Label 564*/ GIMT_Encode4(20539),
     /* 16636 */ /*GILLT_v4s64*//*Label 565*/ GIMT_Encode4(20911),
     /* 16640 */ /*GILLT_v8s1*//*Label 566*/ GIMT_Encode4(21283),
     /* 16644 */ /*GILLT_v8s16*//*Label 567*/ GIMT_Encode4(22081),
     /* 16648 */ /*GILLT_v8s32*//*Label 568*/ GIMT_Encode4(22453),
     /* 16652 */ /*GILLT_v8s64*//*Label 569*/ GIMT_Encode4(22825),
     /* 16656 */ /*GILLT_v16s1*//*Label 570*/ GIMT_Encode4(22903),
     /* 16660 */ /*GILLT_v16s8*//*Label 571*/ GIMT_Encode4(23161),
     /* 16664 */ /*GILLT_v16s16*//*Label 572*/ GIMT_Encode4(23533),
     /* 16668 */ /*GILLT_v16s32*//*Label 573*/ GIMT_Encode4(23905),
     /* 16672 */ /*GILLT_v32s1*//*Label 574*/ GIMT_Encode4(23983),
     /* 16676 */ /*GILLT_v32s8*//*Label 575*/ GIMT_Encode4(24241),
     /* 16680 */ /*GILLT_v32s16*//*Label 576*/ GIMT_Encode4(24613),
     /* 16684 */ /*GILLT_v64s1*//*Label 577*/ GIMT_Encode4(24691),
     /* 16688 */ /*GILLT_v64s8*//*Label 578*/ GIMT_Encode4(24949),
     /* 16692 */ // Label 556: @16692
     /* 16692 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(17249),
     /* 16697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 16700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /* 16703 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(16827), // Rule ID 25796 //
     /* 16708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 16720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /* 16724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /* 16728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 16737 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 16743 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 16745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 16751 */     // (xor:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }), VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /* 16751 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 16754 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 16758 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16763 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 16767 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 16772 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 16775 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 16779 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16784 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 16788 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 16793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 16796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 16800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16805 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 16808 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 16811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 16816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 16818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16821 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 16826 */     // GIR_Coverage, 25796,
     /* 16826 */     GIR_EraseRootFromParent_Done,
     /* 16827 */   // Label 581: @16827
     /* 16827 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(16952), // Rule ID 19943 //
     /* 16832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 16844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /* 16848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /* 16852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 16866 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 16872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 16874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 16876 */     // (xor:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2), immAllOnesV:{ *:[v1i1] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /* 16876 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 16879 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 16883 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16888 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 16892 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 16897 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 16900 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 16904 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16909 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 16913 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 16918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 16921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 16925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16930 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 16933 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 16936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 16941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 16943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 16951 */     // GIR_Coverage, 19943,
     /* 16951 */     GIR_EraseRootFromParent_Done,
     /* 16952 */   // Label 582: @16952
     /* 16952 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(17076), // Rule ID 25797 //
     /* 16957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 16969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 16973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /* 16977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /* 16981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 16990 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 16996 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 16998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17000 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src2, (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /* 17000 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 17003 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 17007 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17012 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /* 17016 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 17021 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 17024 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 17028 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17033 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 17037 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 17042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 17045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 17049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17054 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 17057 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 17060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 17065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 17075 */     // GIR_Coverage, 25797,
     /* 17075 */     GIR_EraseRootFromParent_Done,
     /* 17076 */   // Label 583: @17076
     /* 17076 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(17155), // Rule ID 19929 //
     /* 17081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 17085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 17089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 17093 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 17099 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 17101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17103 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src, immAllOnesV:{ *:[v1i1] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /* 17103 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 17106 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 17110 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17115 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 17119 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 17124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 17127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 17131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17136 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 17139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 17144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 17154 */     // GIR_Coverage, 19929,
     /* 17154 */     GIR_EraseRootFromParent_Done,
     /* 17155 */   // Label 584: @17155
     /* 17155 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(17248), // Rule ID 19947 //
     /* 17160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 17164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 17168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 17172 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /* 17172 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 17175 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 17179 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17184 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 17188 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 17193 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 17196 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 17200 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17205 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 17209 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 17214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 17217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /* 17221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17226 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 17229 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 17232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 17237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 17247 */     // GIR_Coverage, 19947,
     /* 17247 */     GIR_EraseRootFromParent_Done,
     /* 17248 */   // Label 585: @17248
     /* 17248 */   GIM_Reject,
     /* 17249 */ // Label 580: @17249
     /* 17249 */ GIM_Reject,
     /* 17250 */ // Label 557: @17250
     /* 17250 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(17452),
     /* 17255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 17258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 17261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 17265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 17269 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(17293), // Rule ID 23023 //
     /* 17274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-128),
     /* 17278 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -128:{ *:[i8] })  =>  (ADD8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, -128:{ *:[i8] })
     /* 17278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri),
     /* 17281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17283 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /* 17288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17291 */     GIR_RootConstrainSelectedInstOperands,
     /* 17292 */     // GIR_Coverage, 23023,
     /* 17292 */     GIR_EraseRootFromParent_Done,
     /* 17293 */   // Label 587: @17293
     /* 17293 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(17314), // Rule ID 243 //
     /* 17298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 17301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 17305 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -1:{ *:[i8] })  =>  (NOT8r:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /* 17305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8r),
     /* 17308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17310 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17312 */     GIR_RootConstrainSelectedInstOperands,
     /* 17313 */     // GIR_Coverage, 243,
     /* 17313 */     GIR_EraseRootFromParent_Done,
     /* 17314 */   // Label 588: @17314
     /* 17314 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(17335), // Rule ID 251 //
     /* 17319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 17322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 17326 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -1:{ *:[i8] })  =>  (NOT8r_ND:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /* 17326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8r_ND),
     /* 17329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17331 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17333 */     GIR_RootConstrainSelectedInstOperands,
     /* 17334 */     // GIR_Coverage, 251,
     /* 17334 */     GIR_EraseRootFromParent_Done,
     /* 17335 */   // Label 589: @17335
     /* 17335 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(17368), // Rule ID 23270 //
     /* 17340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 17343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 17347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17351 */     // MIs[1] Operand 1
     /* 17351 */     // No operand predicates
     /* 17351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17353 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (XOR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 17353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8ri),
     /* 17356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17358 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 17363 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17366 */     GIR_RootConstrainSelectedInstOperands,
     /* 17367 */     // GIR_Coverage, 23270,
     /* 17367 */     GIR_EraseRootFromParent_Done,
     /* 17368 */   // Label 590: @17368
     /* 17368 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(17401), // Rule ID 23360 //
     /* 17373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 17376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 17380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17384 */     // MIs[1] Operand 1
     /* 17384 */     // No operand predicates
     /* 17384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17386 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (XOR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 17386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8ri_ND),
     /* 17389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17391 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 17396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17399 */     GIR_RootConstrainSelectedInstOperands,
     /* 17400 */     // GIR_Coverage, 23360,
     /* 17400 */     GIR_EraseRootFromParent_Done,
     /* 17401 */   // Label 591: @17401
     /* 17401 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(17426), // Rule ID 23262 //
     /* 17406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 17409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 17413 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (XOR8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /* 17413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR8rr),
     /* 17418 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 17424 */     GIR_RootConstrainSelectedInstOperands,
     /* 17425 */     // GIR_Coverage, 23262,
     /* 17425 */     GIR_Done,
     /* 17426 */   // Label 592: @17426
     /* 17426 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(17451), // Rule ID 23352 //
     /* 17431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 17434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 17438 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (XOR8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /* 17438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR8rr_ND),
     /* 17443 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 17449 */     GIR_RootConstrainSelectedInstOperands,
     /* 17450 */     // GIR_Coverage, 23352,
     /* 17450 */     GIR_Done,
     /* 17451 */   // Label 593: @17451
     /* 17451 */   GIM_Reject,
     /* 17452 */ // Label 586: @17452
     /* 17452 */ GIM_Reject,
     /* 17453 */ // Label 558: @17453
     /* 17453 */ GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(17897),
     /* 17458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 17461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 17464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17468 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(17510), // Rule ID 23024 //
     /* 17473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17477 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(-32768),
     /* 17488 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -32768:{ *:[i16] })  =>  (ADD16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -32768:{ *:[i16] })
     /* 17488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri),
     /* 17491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17493 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17495 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-32768),
     /* 17505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17508 */     GIR_RootConstrainSelectedInstOperands,
     /* 17509 */     // GIR_Coverage, 23024,
     /* 17509 */     GIR_EraseRootFromParent_Done,
     /* 17510 */   // Label 595: @17510
     /* 17510 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(17612), // Rule ID 26462 //
     /* 17515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 17523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 17527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 17531 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 17535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 17540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17546 */     // (xor:{ *:[i16] } (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTC16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 17546 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 17549 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 17553 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 17560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 17563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 17567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17572 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 17575 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 17579 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 17582 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 17587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 17592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 17597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC16rr),
     /* 17600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17602 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 17604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17610 */     GIR_RootConstrainSelectedInstOperands,
     /* 17611 */     // GIR_Coverage, 26462,
     /* 17611 */     GIR_EraseRootFromParent_Done,
     /* 17612 */   // Label 596: @17612
     /* 17612 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(17714), // Rule ID 23200 //
     /* 17617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 17625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 17629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 17633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 17637 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 17641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 17646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17648 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTC16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 17648 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 17651 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 17655 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 17662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 17665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 17669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17674 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 17677 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 17681 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 17684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 17689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 17694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 17699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC16rr),
     /* 17702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17704 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17712 */     GIR_RootConstrainSelectedInstOperands,
     /* 17713 */     // GIR_Coverage, 23200,
     /* 17713 */     GIR_EraseRootFromParent_Done,
     /* 17714 */   // Label 597: @17714
     /* 17714 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(17739), // Rule ID 244 //
     /* 17719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 17722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 17730 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -1:{ *:[i16] })  =>  (NOT16r:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /* 17730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16r),
     /* 17733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17735 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17737 */     GIR_RootConstrainSelectedInstOperands,
     /* 17738 */     // GIR_Coverage, 244,
     /* 17738 */     GIR_EraseRootFromParent_Done,
     /* 17739 */   // Label 598: @17739
     /* 17739 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(17764), // Rule ID 252 //
     /* 17744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 17747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 17755 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -1:{ *:[i16] })  =>  (NOT16r_ND:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /* 17755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16r_ND),
     /* 17758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17760 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17762 */     GIR_RootConstrainSelectedInstOperands,
     /* 17763 */     // GIR_Coverage, 252,
     /* 17763 */     GIR_EraseRootFromParent_Done,
     /* 17764 */   // Label 599: @17764
     /* 17764 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(17801), // Rule ID 23271 //
     /* 17769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 17772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 17780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17784 */     // MIs[1] Operand 1
     /* 17784 */     // No operand predicates
     /* 17784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17786 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (XOR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /* 17786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16ri),
     /* 17789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17791 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 17796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17799 */     GIR_RootConstrainSelectedInstOperands,
     /* 17800 */     // GIR_Coverage, 23271,
     /* 17800 */     GIR_EraseRootFromParent_Done,
     /* 17801 */   // Label 600: @17801
     /* 17801 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(17838), // Rule ID 23361 //
     /* 17806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 17809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 17817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17821 */     // MIs[1] Operand 1
     /* 17821 */     // No operand predicates
     /* 17821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17823 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (XOR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /* 17823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16ri_ND),
     /* 17826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17828 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 17833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17836 */     GIR_RootConstrainSelectedInstOperands,
     /* 17837 */     // GIR_Coverage, 23361,
     /* 17837 */     GIR_EraseRootFromParent_Done,
     /* 17838 */   // Label 601: @17838
     /* 17838 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(17867), // Rule ID 23263 //
     /* 17843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 17846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17854 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (XOR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /* 17854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR16rr),
     /* 17859 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 17865 */     GIR_RootConstrainSelectedInstOperands,
     /* 17866 */     // GIR_Coverage, 23263,
     /* 17866 */     GIR_Done,
     /* 17867 */   // Label 602: @17867
     /* 17867 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(17896), // Rule ID 23353 //
     /* 17872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 17875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17883 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (XOR16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /* 17883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR16rr_ND),
     /* 17888 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 17894 */     GIR_RootConstrainSelectedInstOperands,
     /* 17895 */     // GIR_Coverage, 23353,
     /* 17895 */     GIR_Done,
     /* 17896 */   // Label 603: @17896
     /* 17896 */   GIM_Reject,
     /* 17897 */ // Label 594: @17897
     /* 17897 */ GIM_Reject,
     /* 17898 */ // Label 559: @17898
     /* 17898 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(18510),
     /* 17903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 17906 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(17955), // Rule ID 23025 //
     /* 17911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 17914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 17918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 17922 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(-2147483648),
     /* 17933 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -2147483648:{ *:[i32] })  =>  (ADD32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -2147483648:{ *:[i32] })
     /* 17933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri),
     /* 17936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17938 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17940 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /* 17950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17953 */     GIR_RootConstrainSelectedInstOperands,
     /* 17954 */     // GIR_Coverage, 23025,
     /* 17954 */     GIR_EraseRootFromParent_Done,
     /* 17955 */   // Label 605: @17955
     /* 17955 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(18013), // Rule ID 25421 //
     /* 17960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 17963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 17967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 17975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 17979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 17988 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 17992 */     // MIs[0] src
     /* 17992 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 17997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17999 */     // (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 17999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK32rr),
     /* 18002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 18008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18011 */     GIR_RootConstrainSelectedInstOperands,
     /* 18012 */     // GIR_Coverage, 25421,
     /* 18012 */     GIR_EraseRootFromParent_Done,
     /* 18013 */   // Label 606: @18013
     /* 18013 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(18122), // Rule ID 26468 //
     /* 18018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 18033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 18037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 18041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 18045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 18050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18056 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 18056 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 18059 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 18063 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 18068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 18070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 18073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 18077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 18082 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 18085 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 18089 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 18092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 18097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 18102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 18107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC32rr),
     /* 18110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18112 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 18114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 18117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18120 */     GIR_RootConstrainSelectedInstOperands,
     /* 18121 */     // GIR_Coverage, 26468,
     /* 18121 */     GIR_EraseRootFromParent_Done,
     /* 18122 */   // Label 607: @18122
     /* 18122 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(18176), // Rule ID 17805 //
     /* 18127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 18130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 18149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 18153 */     // MIs[1] src
     /* 18153 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 18158 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 18162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18164 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 18164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK32rr),
     /* 18167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18169 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 18171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18174 */     GIR_RootConstrainSelectedInstOperands,
     /* 18175 */     // GIR_Coverage, 17805,
     /* 18175 */     GIR_EraseRootFromParent_Done,
     /* 18176 */   // Label 608: @18176
     /* 18176 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(18285), // Rule ID 23206 //
     /* 18181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 18200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 18204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 18208 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 18212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 18217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18219 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 18219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 18222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 18226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 18231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 18233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 18236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 18240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 18245 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 18248 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 18252 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 18255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 18260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 18265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 18270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC32rr),
     /* 18273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18275 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 18280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18283 */     GIR_RootConstrainSelectedInstOperands,
     /* 18284 */     // GIR_Coverage, 23206,
     /* 18284 */     GIR_EraseRootFromParent_Done,
     /* 18285 */   // Label 609: @18285
     /* 18285 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(18317), // Rule ID 245 //
     /* 18290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 18293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 18308 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] })  =>  (NOT32r:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 18308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32r),
     /* 18311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18313 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18315 */     GIR_RootConstrainSelectedInstOperands,
     /* 18316 */     // GIR_Coverage, 245,
     /* 18316 */     GIR_EraseRootFromParent_Done,
     /* 18317 */   // Label 610: @18317
     /* 18317 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(18349), // Rule ID 253 //
     /* 18322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 18325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 18340 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] })  =>  (NOT32r_ND:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 18340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32r_ND),
     /* 18343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18345 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18347 */     GIR_RootConstrainSelectedInstOperands,
     /* 18348 */     // GIR_Coverage, 253,
     /* 18348 */     GIR_EraseRootFromParent_Done,
     /* 18349 */   // Label 611: @18349
     /* 18349 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(18393), // Rule ID 23272 //
     /* 18354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 18357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18376 */     // MIs[1] Operand 1
     /* 18376 */     // No operand predicates
     /* 18376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18378 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (XOR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /* 18378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32ri),
     /* 18381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18383 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 18388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18391 */     GIR_RootConstrainSelectedInstOperands,
     /* 18392 */     // GIR_Coverage, 23272,
     /* 18392 */     GIR_EraseRootFromParent_Done,
     /* 18393 */   // Label 612: @18393
     /* 18393 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(18437), // Rule ID 23362 //
     /* 18398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 18401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18420 */     // MIs[1] Operand 1
     /* 18420 */     // No operand predicates
     /* 18420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18422 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (XOR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /* 18422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32ri_ND),
     /* 18425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18427 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 18432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18435 */     GIR_RootConstrainSelectedInstOperands,
     /* 18436 */     // GIR_Coverage, 23362,
     /* 18436 */     GIR_EraseRootFromParent_Done,
     /* 18437 */   // Label 613: @18437
     /* 18437 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(18473), // Rule ID 23264 //
     /* 18442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 18445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18460 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (XOR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 18460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR32rr),
     /* 18465 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 18471 */     GIR_RootConstrainSelectedInstOperands,
     /* 18472 */     // GIR_Coverage, 23264,
     /* 18472 */     GIR_Done,
     /* 18473 */   // Label 614: @18473
     /* 18473 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(18509), // Rule ID 23354 //
     /* 18478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 18481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18496 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (XOR32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 18496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR32rr_ND),
     /* 18501 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 18507 */     GIR_RootConstrainSelectedInstOperands,
     /* 18508 */     // GIR_Coverage, 23354,
     /* 18508 */     GIR_Done,
     /* 18509 */   // Label 615: @18509
     /* 18509 */   GIM_Reject,
     /* 18510 */ // Label 604: @18510
     /* 18510 */ GIM_Reject,
     /* 18511 */ // Label 560: @18511
     /* 18511 */ GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(19082),
     /* 18516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 18519 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(18577), // Rule ID 25422 //
     /* 18524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 18527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 18539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 18543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 18547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18552 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 18556 */     // MIs[0] src
     /* 18556 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 18561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18563 */     // (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 18563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK64rr),
     /* 18566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 18572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18575 */     GIR_RootConstrainSelectedInstOperands,
     /* 18576 */     // GIR_Coverage, 25422,
     /* 18576 */     GIR_EraseRootFromParent_Done,
     /* 18577 */   // Label 617: @18577
     /* 18577 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(18686), // Rule ID 26474 //
     /* 18582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 18585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 18597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 18601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 18605 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 18609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 18614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18620 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 18620 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 18623 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 18627 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 18632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 18634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 18637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 18641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 18646 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 18649 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 18653 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 18656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 18661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 18666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 18671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC64rr),
     /* 18674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18676 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 18678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 18681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18684 */     GIR_RootConstrainSelectedInstOperands,
     /* 18685 */     // GIR_Coverage, 26474,
     /* 18685 */     GIR_EraseRootFromParent_Done,
     /* 18686 */   // Label 618: @18686
     /* 18686 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(18740), // Rule ID 17806 //
     /* 18691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 18694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 18697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 18713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 18717 */     // MIs[1] src
     /* 18717 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 18722 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 18726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18728 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 18728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK64rr),
     /* 18731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18733 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 18735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18738 */     GIR_RootConstrainSelectedInstOperands,
     /* 18739 */     // GIR_Coverage, 17806,
     /* 18739 */     GIR_EraseRootFromParent_Done,
     /* 18740 */   // Label 619: @18740
     /* 18740 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(18849), // Rule ID 23212 //
     /* 18745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 18748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 18764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 18768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 18772 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 18776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 18781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18783 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 18783 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 18786 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 18790 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 18795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 18797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 18800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 18804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 18809 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 18812 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 18816 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 18819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 18824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 18829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 18834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC64rr),
     /* 18837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18839 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 18844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18847 */     GIR_RootConstrainSelectedInstOperands,
     /* 18848 */     // GIR_Coverage, 23212,
     /* 18848 */     GIR_EraseRootFromParent_Done,
     /* 18849 */   // Label 620: @18849
     /* 18849 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(18881), // Rule ID 246 //
     /* 18854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 18857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 18860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 18872 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] })  =>  (NOT64r:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /* 18872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64r),
     /* 18875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18877 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18879 */     GIR_RootConstrainSelectedInstOperands,
     /* 18880 */     // GIR_Coverage, 246,
     /* 18880 */     GIR_EraseRootFromParent_Done,
     /* 18881 */   // Label 621: @18881
     /* 18881 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(18913), // Rule ID 254 //
     /* 18886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 18889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 18892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 18904 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] })  =>  (NOT64r_ND:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /* 18904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64r_ND),
     /* 18907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18909 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18911 */     GIR_RootConstrainSelectedInstOperands,
     /* 18912 */     // GIR_Coverage, 254,
     /* 18912 */     GIR_EraseRootFromParent_Done,
     /* 18913 */   // Label 622: @18913
     /* 18913 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(18961), // Rule ID 23273 //
     /* 18918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 18921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 18924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /* 18944 */     // MIs[1] Operand 1
     /* 18944 */     // No operand predicates
     /* 18944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18946 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (XOR64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /* 18946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64ri32),
     /* 18949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18951 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 18956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18959 */     GIR_RootConstrainSelectedInstOperands,
     /* 18960 */     // GIR_Coverage, 23273,
     /* 18960 */     GIR_EraseRootFromParent_Done,
     /* 18961 */   // Label 623: @18961
     /* 18961 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(19009), // Rule ID 23363 //
     /* 18966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 18969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 18972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /* 18992 */     // MIs[1] Operand 1
     /* 18992 */     // No operand predicates
     /* 18992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18994 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (XOR64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /* 18994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64ri32_ND),
     /* 18997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 19001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 19004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 19007 */     GIR_RootConstrainSelectedInstOperands,
     /* 19008 */     // GIR_Coverage, 23363,
     /* 19008 */     GIR_EraseRootFromParent_Done,
     /* 19009 */   // Label 624: @19009
     /* 19009 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(19045), // Rule ID 23265 //
     /* 19014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 19017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 19020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 19024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 19028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 19032 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (XOR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 19032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR64rr),
     /* 19037 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 19043 */     GIR_RootConstrainSelectedInstOperands,
     /* 19044 */     // GIR_Coverage, 23265,
     /* 19044 */     GIR_Done,
     /* 19045 */   // Label 625: @19045
     /* 19045 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(19081), // Rule ID 23355 //
     /* 19050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 19053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 19056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 19060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 19064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 19068 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (XOR64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 19068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR64rr_ND),
     /* 19073 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 19079 */     GIR_RootConstrainSelectedInstOperands,
     /* 19080 */     // GIR_Coverage, 23355,
     /* 19080 */     GIR_Done,
     /* 19081 */   // Label 626: @19081
     /* 19081 */   GIM_Reject,
     /* 19082 */ // Label 616: @19082
     /* 19082 */ GIM_Reject,
     /* 19083 */ // Label 561: @19083
     /* 19083 */ GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(19624),
     /* 19088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 19091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 19094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19098 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(19218), // Rule ID 25798 //
     /* 19103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 19111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 19115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 19119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 19128 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 19134 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 19136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 19142 */     // (xor:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }), VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /* 19142 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 19145 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19149 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19154 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 19158 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19163 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 19166 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19170 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19175 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 19179 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 19187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 19191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19196 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 19199 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 19202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 19204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 19209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 19212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 19217 */     // GIR_Coverage, 25798,
     /* 19217 */     GIR_EraseRootFromParent_Done,
     /* 19218 */   // Label 628: @19218
     /* 19218 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(19339), // Rule ID 19944 //
     /* 19223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 19231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 19235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 19239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 19253 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 19259 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 19261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 19263 */     // (xor:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2), immAllOnesV:{ *:[v2i1] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /* 19263 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 19266 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19270 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19275 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 19279 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19284 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 19287 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19291 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19296 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 19300 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 19308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 19312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19317 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 19320 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 19323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 19325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 19330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 19333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 19338 */     // GIR_Coverage, 19944,
     /* 19338 */     GIR_EraseRootFromParent_Done,
     /* 19339 */   // Label 629: @19339
     /* 19339 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(19459), // Rule ID 25799 //
     /* 19344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 19356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 19360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 19364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 19373 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 19379 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 19381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 19383 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src2, (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /* 19383 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 19386 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19390 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19395 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /* 19399 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19404 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 19407 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19411 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19416 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 19420 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 19428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 19432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19437 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 19440 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 19443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 19445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 19450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 19453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 19458 */     // GIR_Coverage, 25799,
     /* 19458 */     GIR_EraseRootFromParent_Done,
     /* 19459 */   // Label 630: @19459
     /* 19459 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(19534), // Rule ID 19928 //
     /* 19464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19472 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 19478 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 19480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19482 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src, immAllOnesV:{ *:[v2i1] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /* 19482 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 19485 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19489 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19494 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 19498 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 19506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 19510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19515 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 19518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 19520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 19525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 19528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 19533 */     // GIR_Coverage, 19928,
     /* 19533 */     GIR_EraseRootFromParent_Done,
     /* 19534 */   // Label 631: @19534
     /* 19534 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(19623), // Rule ID 19948 //
     /* 19539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19547 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /* 19547 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 19550 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19554 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19559 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 19563 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19568 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 19571 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19575 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19580 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 19584 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 19592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /* 19596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19601 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 19604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 19607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 19609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 19614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 19617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 19622 */     // GIR_Coverage, 19948,
     /* 19622 */     GIR_EraseRootFromParent_Done,
     /* 19623 */   // Label 632: @19623
     /* 19623 */   GIM_Reject,
     /* 19624 */ // Label 627: @19624
     /* 19624 */ GIM_Reject,
     /* 19625 */ // Label 562: @19625
     /* 19625 */ GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(19996),
     /* 19630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 19633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19636 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(19868), // Rule ID 22393 //
     /* 19641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 19644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 19648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 19652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19656 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 19662 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 19664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19666 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, immAllOnesV:{ *:[v2i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /* 19666 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /* 19669 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 19673 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 19680 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 19683 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 19687 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19692 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 19695 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 19699 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /* 19702 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 19707 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 19712 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 19717 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 19720 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 19724 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 19731 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 19734 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 19738 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19743 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 19746 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 19750 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 19753 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 19758 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 19763 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 19768 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 19771 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 19775 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 19782 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 19785 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 19789 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19794 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 19797 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 19801 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 19804 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 19809 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 19814 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 19819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 19822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 19826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19831 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 19834 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 19837 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 19840 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 19843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 19845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 19850 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 19857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 19862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 19867 */     // GIR_Coverage, 22393,
     /* 19867 */     GIR_EraseRootFromParent_Done,
     /* 19868 */   // Label 634: @19868
     /* 19868 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(19914), // Rule ID 22401 //
     /* 19873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 19876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 19880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 19884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19888 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 19894 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 19896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19898 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, immAllOnesV:{ *:[v2i64] })  =>  (VPTERNLOGQZ128rri:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VR128X:{ *:[v2i64] }:$src, VR128X:{ *:[v2i64] }:$src, 15:{ *:[i8] })
     /* 19898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /* 19901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 19903 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 19905 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 19907 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 19909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 19912 */     GIR_RootConstrainSelectedInstOperands,
     /* 19913 */     // GIR_Coverage, 22401,
     /* 19913 */     GIR_EraseRootFromParent_Done,
     /* 19914 */   // Label 635: @19914
     /* 19914 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(19941), // Rule ID 2119 //
     /* 19919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 19922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 19926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 19930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 19934 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPXORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 19934 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /* 19939 */     GIR_RootConstrainSelectedInstOperands,
     /* 19940 */     // GIR_Coverage, 2119,
     /* 19940 */     GIR_Done,
     /* 19941 */   // Label 636: @19941
     /* 19941 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(19968), // Rule ID 2121 //
     /* 19946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 19949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 19953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 19957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 19961 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PXORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 19961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /* 19966 */     GIR_RootConstrainSelectedInstOperands,
     /* 19967 */     // GIR_Coverage, 2121,
     /* 19967 */     GIR_Done,
     /* 19968 */   // Label 637: @19968
     /* 19968 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(19995), // Rule ID 5809 //
     /* 19973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 19976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 19980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 19984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 19988 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPXORQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 19988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /* 19993 */     GIR_RootConstrainSelectedInstOperands,
     /* 19994 */     // GIR_Coverage, 5809,
     /* 19994 */     GIR_Done,
     /* 19995 */   // Label 638: @19995
     /* 19995 */   GIM_Reject,
     /* 19996 */ // Label 633: @19996
     /* 19996 */ GIM_Reject,
     /* 19997 */ // Label 563: @19997
     /* 19997 */ GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(20538),
     /* 20002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 20005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 20008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20012 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(20132), // Rule ID 25800 //
     /* 20017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 20025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 20029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 20033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 20042 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20048 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 20050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 20056 */     // (xor:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }), VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 20056 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 20059 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20063 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20068 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 20072 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 20080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20089 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 20093 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 20101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 20105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20110 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 20113 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 20116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 20118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 20123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 20126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 20131 */     // GIR_Coverage, 25800,
     /* 20131 */     GIR_EraseRootFromParent_Done,
     /* 20132 */   // Label 640: @20132
     /* 20132 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(20253), // Rule ID 19945 //
     /* 20137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 20145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 20149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 20153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 20167 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 20175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 20177 */     // (xor:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2), immAllOnesV:{ *:[v4i1] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 20177 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 20180 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20184 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20189 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 20193 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20198 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 20201 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20205 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20210 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 20214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 20222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 20226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20231 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 20234 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 20237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 20239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 20244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 20247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 20252 */     // GIR_Coverage, 19945,
     /* 20252 */     GIR_EraseRootFromParent_Done,
     /* 20253 */   // Label 641: @20253
     /* 20253 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(20373), // Rule ID 25801 //
     /* 20258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 20270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 20274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 20278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 20287 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20293 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 20295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 20297 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src2, (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 20297 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 20300 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20304 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20309 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /* 20313 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20318 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 20321 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20325 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20330 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 20334 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 20342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 20346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20351 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 20354 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 20357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 20359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 20364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 20367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 20372 */     // GIR_Coverage, 25801,
     /* 20372 */     GIR_EraseRootFromParent_Done,
     /* 20373 */   // Label 642: @20373
     /* 20373 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(20448), // Rule ID 19927 //
     /* 20378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20386 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20392 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 20394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20396 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src, immAllOnesV:{ *:[v4i1] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 20396 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 20399 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20403 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20408 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 20412 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 20420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 20424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20429 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 20432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 20434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 20439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 20442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 20447 */     // GIR_Coverage, 19927,
     /* 20447 */     GIR_EraseRootFromParent_Done,
     /* 20448 */   // Label 643: @20448
     /* 20448 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(20537), // Rule ID 19949 //
     /* 20453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20461 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 20461 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 20464 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20468 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20473 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 20477 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20482 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 20485 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20489 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20494 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 20498 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 20506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /* 20510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20515 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 20518 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 20521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 20523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 20528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 20531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 20536 */     // GIR_Coverage, 19949,
     /* 20536 */     GIR_EraseRootFromParent_Done,
     /* 20537 */   // Label 644: @20537
     /* 20537 */   GIM_Reject,
     /* 20538 */ // Label 639: @20538
     /* 20538 */ GIM_Reject,
     /* 20539 */ // Label 564: @20539
     /* 20539 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(20910),
     /* 20544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 20547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20550 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(20782), // Rule ID 22392 //
     /* 20555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 20558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 20562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 20566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20570 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20576 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 20578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20580 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, immAllOnesV:{ *:[v4i32] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /* 20580 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /* 20583 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 20587 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 20594 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 20597 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 20601 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20606 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 20609 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 20613 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /* 20616 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 20621 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 20626 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 20631 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 20634 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 20638 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 20645 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 20648 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 20652 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20657 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 20660 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 20664 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 20667 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 20672 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 20677 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 20682 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 20685 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 20689 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 20696 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 20699 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 20703 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20708 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 20711 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 20715 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 20718 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 20723 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 20728 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 20733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 20736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 20740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20745 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 20748 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 20751 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 20754 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 20757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 20759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 20764 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 20771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 20776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 20781 */     // GIR_Coverage, 22392,
     /* 20781 */     GIR_EraseRootFromParent_Done,
     /* 20782 */   // Label 646: @20782
     /* 20782 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(20828), // Rule ID 22400 //
     /* 20787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 20790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 20794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 20798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20802 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 20810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20812 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, immAllOnesV:{ *:[v4i32] })  =>  (VPTERNLOGQZ128rri:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VR128X:{ *:[v4i32] }:$src, VR128X:{ *:[v4i32] }:$src, 15:{ *:[i8] })
     /* 20812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /* 20815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 20817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 20819 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 20821 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 20823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 20826 */     GIR_RootConstrainSelectedInstOperands,
     /* 20827 */     // GIR_Coverage, 22400,
     /* 20827 */     GIR_EraseRootFromParent_Done,
     /* 20828 */   // Label 647: @20828
     /* 20828 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(20855), // Rule ID 5836 //
     /* 20833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 20836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 20840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 20844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 20848 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPXORDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 20848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rr),
     /* 20853 */     GIR_RootConstrainSelectedInstOperands,
     /* 20854 */     // GIR_Coverage, 5836,
     /* 20854 */     GIR_Done,
     /* 20855 */   // Label 648: @20855
     /* 20855 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(20882), // Rule ID 18601 //
     /* 20860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 20863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 20867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 20871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 20875 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPXORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 20875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /* 20880 */     GIR_RootConstrainSelectedInstOperands,
     /* 20881 */     // GIR_Coverage, 18601,
     /* 20881 */     GIR_Done,
     /* 20882 */   // Label 649: @20882
     /* 20882 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(20909), // Rule ID 18625 //
     /* 20887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 20890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 20894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 20898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 20902 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PXORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 20902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /* 20907 */     GIR_RootConstrainSelectedInstOperands,
     /* 20908 */     // GIR_Coverage, 18625,
     /* 20908 */     GIR_Done,
     /* 20909 */   // Label 650: @20909
     /* 20909 */   GIM_Reject,
     /* 20910 */ // Label 645: @20910
     /* 20910 */ GIM_Reject,
     /* 20911 */ // Label 565: @20911
     /* 20911 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(21282),
     /* 20916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 20919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 20922 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(21154), // Rule ID 22397 //
     /* 20927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 20930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 20934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 20938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20942 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 20950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20952 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, immAllOnesV:{ *:[v4i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /* 20952 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /* 20955 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 20959 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 20966 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 20969 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 20973 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20978 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 20981 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 20985 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /* 20988 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 20993 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 20998 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 21003 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 21006 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 21010 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 21017 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 21020 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 21024 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21029 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 21032 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 21036 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 21039 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 21044 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 21049 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 21054 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 21057 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 21061 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 21068 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 21071 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 21075 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21080 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 21083 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 21087 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 21090 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 21095 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 21100 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 21105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 21108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 21112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21117 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 21120 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 21123 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 21126 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 21129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 21131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21136 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 21143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 21148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 21153 */     // GIR_Coverage, 22397,
     /* 21153 */     GIR_EraseRootFromParent_Done,
     /* 21154 */   // Label 652: @21154
     /* 21154 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(21200), // Rule ID 22405 //
     /* 21159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 21162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 21166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 21170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 21174 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21180 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 21182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21184 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, immAllOnesV:{ *:[v4i64] })  =>  (VPTERNLOGQZ256rri:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VR256X:{ *:[v4i64] }:$src, VR256X:{ *:[v4i64] }:$src, 15:{ *:[i8] })
     /* 21184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /* 21187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21189 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 21191 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 21193 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 21195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 21198 */     GIR_RootConstrainSelectedInstOperands,
     /* 21199 */     // GIR_Coverage, 22405,
     /* 21199 */     GIR_EraseRootFromParent_Done,
     /* 21200 */   // Label 653: @21200
     /* 21200 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(21227), // Rule ID 2123 //
     /* 21205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 21208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 21212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 21216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 21220 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPXORYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 21220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /* 21225 */     GIR_RootConstrainSelectedInstOperands,
     /* 21226 */     // GIR_Coverage, 2123,
     /* 21226 */     GIR_Done,
     /* 21227 */   // Label 654: @21227
     /* 21227 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(21254), // Rule ID 5800 //
     /* 21232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 21235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 21239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 21243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 21247 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPXORQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 21247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /* 21252 */     GIR_RootConstrainSelectedInstOperands,
     /* 21253 */     // GIR_Coverage, 5800,
     /* 21253 */     GIR_Done,
     /* 21254 */   // Label 655: @21254
     /* 21254 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(21281), // Rule ID 18572 //
     /* 21259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 21262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 21266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 21270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 21274 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VXORPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 21274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /* 21279 */     GIR_RootConstrainSelectedInstOperands,
     /* 21280 */     // GIR_Coverage, 18572,
     /* 21280 */     GIR_Done,
     /* 21281 */   // Label 656: @21281
     /* 21281 */   GIM_Reject,
     /* 21282 */ // Label 651: @21282
     /* 21282 */ GIM_Reject,
     /* 21283 */ // Label 566: @21283
     /* 21283 */ GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(22080),
     /* 21288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 21291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 21294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21298 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(21358), // Rule ID 24108 //
     /* 21303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 21306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 21310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 21314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 21318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 21322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 21331 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21337 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 21339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 21345 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /* 21345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /* 21348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 21354 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 21356 */     GIR_RootConstrainSelectedInstOperands,
     /* 21357 */     // GIR_Coverage, 24108,
     /* 21357 */     GIR_EraseRootFromParent_Done,
     /* 21358 */   // Label 658: @21358
     /* 21358 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(21481), // Rule ID 25794 //
     /* 21363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /* 21366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 21370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 21374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 21378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 21382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 21391 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21397 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 21399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 21405 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 21405 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 21408 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21412 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21417 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 21421 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 21426 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 21429 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21433 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21438 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 21442 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 21447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 21450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 21454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21459 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 21462 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 21465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 21467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 21475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 21480 */     // GIR_Coverage, 25794,
     /* 21480 */     GIR_EraseRootFromParent_Done,
     /* 21481 */   // Label 659: @21481
     /* 21481 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(21544), // Rule ID 4420 //
     /* 21486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 21489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 21493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 21497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 21501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 21505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 21519 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21525 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 21527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 21529 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2), immAllOnesV:{ *:[v8i1] })  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /* 21529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /* 21532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 21538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 21542 */     GIR_RootConstrainSelectedInstOperands,
     /* 21543 */     // GIR_Coverage, 4420,
     /* 21543 */     GIR_EraseRootFromParent_Done,
     /* 21544 */   // Label 660: @21544
     /* 21544 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(21668), // Rule ID 19942 //
     /* 21549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /* 21552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 21556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 21560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 21564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 21568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 21582 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21588 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 21590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 21592 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2), immAllOnesV:{ *:[v8i1] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 21592 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 21595 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21599 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21604 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 21608 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 21613 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 21616 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21620 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21625 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 21629 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 21634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 21637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 21641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21646 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 21649 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 21652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 21654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 21662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 21667 */     // GIR_Coverage, 19942,
     /* 21667 */     GIR_EraseRootFromParent_Done,
     /* 21668 */   // Label 661: @21668
     /* 21668 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(21728), // Rule ID 24109 //
     /* 21673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 21676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 21684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 21688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 21692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 21696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 21705 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21711 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 21713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 21715 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /* 21715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /* 21718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 21724 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 21726 */     GIR_RootConstrainSelectedInstOperands,
     /* 21727 */     // GIR_Coverage, 24109,
     /* 21727 */     GIR_EraseRootFromParent_Done,
     /* 21728 */   // Label 662: @21728
     /* 21728 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(21851), // Rule ID 25795 //
     /* 21733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /* 21736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 21744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 21748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 21752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 21756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 21765 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21771 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 21773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 21775 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 21775 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 21778 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21782 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21787 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /* 21791 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 21796 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 21799 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21803 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21808 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 21812 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 21817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 21820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 21824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21829 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 21832 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 21835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 21837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 21845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 21850 */     // GIR_Coverage, 25795,
     /* 21850 */     GIR_EraseRootFromParent_Done,
     /* 21851 */   // Label 663: @21851
     /* 21851 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(21886), // Rule ID 4408 //
     /* 21856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 21859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 21867 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21873 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 21875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21877 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src, immAllOnesV:{ *:[v8i1] })  =>  (KNOTBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src)
     /* 21877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTBkk),
     /* 21880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21882 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 21884 */     GIR_RootConstrainSelectedInstOperands,
     /* 21885 */     // GIR_Coverage, 4408,
     /* 21885 */     GIR_EraseRootFromParent_Done,
     /* 21886 */   // Label 664: @21886
     /* 21886 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(21964), // Rule ID 19926 //
     /* 21891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoDQI),
     /* 21894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 21902 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21908 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 21910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21912 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src, immAllOnesV:{ *:[v8i1] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 21912 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 21915 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21919 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21924 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 21928 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 21933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 21936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 21940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21945 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 21948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 21950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 21958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 21963 */     // GIR_Coverage, 19926,
     /* 21963 */     GIR_EraseRootFromParent_Done,
     /* 21964 */   // Label 665: @21964
     /* 21964 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(21987), // Rule ID 4424 //
     /* 21969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 21972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21980 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KXORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /* 21980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORBkk),
     /* 21985 */     GIR_RootConstrainSelectedInstOperands,
     /* 21986 */     // GIR_Coverage, 4424,
     /* 21986 */     GIR_Done,
     /* 21987 */   // Label 666: @21987
     /* 21987 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(22079), // Rule ID 19946 //
     /* 21992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /* 21995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 22003 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 22003 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 22006 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 22010 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22015 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 22019 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 22024 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 22027 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 22031 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22036 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 22040 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 22045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 22048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /* 22052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22057 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 22060 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 22063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 22065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 22068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 22070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 22073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 22078 */     // GIR_Coverage, 19946,
     /* 22078 */     GIR_EraseRootFromParent_Done,
     /* 22079 */   // Label 667: @22079
     /* 22079 */   GIM_Reject,
     /* 22080 */ // Label 657: @22080
     /* 22080 */ GIM_Reject,
     /* 22081 */ // Label 567: @22081
     /* 22081 */ GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(22452),
     /* 22086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 22089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 22092 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(22324), // Rule ID 22391 //
     /* 22097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 22100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 22104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 22108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 22112 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 22118 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 22120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 22122 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, immAllOnesV:{ *:[v8i16] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /* 22122 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /* 22125 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 22129 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 22136 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 22139 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 22143 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22148 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 22151 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 22155 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /* 22158 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 22163 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 22168 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 22173 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 22176 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 22180 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 22187 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 22190 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 22194 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22199 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 22202 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 22206 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 22209 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 22214 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 22219 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 22224 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 22227 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 22231 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 22238 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 22241 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 22245 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22250 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 22253 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 22257 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 22260 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 22265 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 22270 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 22275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 22278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 22282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22287 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 22290 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 22293 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 22296 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 22299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 22301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 22304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 22306 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 22313 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 22318 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 22323 */     // GIR_Coverage, 22391,
     /* 22323 */     GIR_EraseRootFromParent_Done,
     /* 22324 */   // Label 669: @22324
     /* 22324 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(22370), // Rule ID 22399 //
     /* 22329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 22332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 22336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 22340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 22344 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 22350 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 22352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 22354 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, immAllOnesV:{ *:[v8i16] })  =>  (VPTERNLOGQZ128rri:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VR128X:{ *:[v8i16] }:$src, VR128X:{ *:[v8i16] }:$src, 15:{ *:[i8] })
     /* 22354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /* 22357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 22359 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22361 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 22368 */     GIR_RootConstrainSelectedInstOperands,
     /* 22369 */     // GIR_Coverage, 22399,
     /* 22369 */     GIR_EraseRootFromParent_Done,
     /* 22370 */   // Label 670: @22370
     /* 22370 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(22397), // Rule ID 18600 //
     /* 22375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 22378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 22382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 22386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 22390 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPXORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 22390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /* 22395 */     GIR_RootConstrainSelectedInstOperands,
     /* 22396 */     // GIR_Coverage, 18600,
     /* 22396 */     GIR_Done,
     /* 22397 */   // Label 671: @22397
     /* 22397 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(22424), // Rule ID 18624 //
     /* 22402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 22405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 22409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 22413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 22417 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PXORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 22417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /* 22422 */     GIR_RootConstrainSelectedInstOperands,
     /* 22423 */     // GIR_Coverage, 18624,
     /* 22423 */     GIR_Done,
     /* 22424 */   // Label 672: @22424
     /* 22424 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(22451), // Rule ID 20468 //
     /* 22429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 22432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 22436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 22440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 22444 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPXORQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 22444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /* 22449 */     GIR_RootConstrainSelectedInstOperands,
     /* 22450 */     // GIR_Coverage, 20468,
     /* 22450 */     GIR_Done,
     /* 22451 */   // Label 673: @22451
     /* 22451 */   GIM_Reject,
     /* 22452 */ // Label 668: @22452
     /* 22452 */ GIM_Reject,
     /* 22453 */ // Label 568: @22453
     /* 22453 */ GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(22824),
     /* 22458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 22461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 22464 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(22696), // Rule ID 22396 //
     /* 22469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 22472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 22476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 22480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 22484 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 22490 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 22492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 22494 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, immAllOnesV:{ *:[v8i32] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /* 22494 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /* 22497 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 22501 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 22508 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 22511 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 22515 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22520 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 22523 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 22527 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /* 22530 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 22535 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 22540 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 22545 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 22548 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 22552 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 22559 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 22562 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 22566 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22571 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 22574 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 22578 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 22581 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 22586 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 22591 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 22596 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 22599 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 22603 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 22610 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 22613 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 22617 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22622 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 22625 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 22629 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 22632 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 22637 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 22642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 22647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 22650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 22654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22659 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 22662 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 22665 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 22668 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 22671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 22673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 22676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 22678 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 22685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 22690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 22695 */     // GIR_Coverage, 22396,
     /* 22695 */     GIR_EraseRootFromParent_Done,
     /* 22696 */   // Label 675: @22696
     /* 22696 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(22742), // Rule ID 22404 //
     /* 22701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 22704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 22708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 22712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 22716 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 22722 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 22724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 22726 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, immAllOnesV:{ *:[v8i32] })  =>  (VPTERNLOGQZ256rri:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VR256X:{ *:[v8i32] }:$src, VR256X:{ *:[v8i32] }:$src, 15:{ *:[i8] })
     /* 22726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /* 22729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 22731 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22733 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22735 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 22740 */     GIR_RootConstrainSelectedInstOperands,
     /* 22741 */     // GIR_Coverage, 22404,
     /* 22741 */     GIR_EraseRootFromParent_Done,
     /* 22742 */   // Label 676: @22742
     /* 22742 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(22769), // Rule ID 5827 //
     /* 22747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 22750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 22754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 22758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 22762 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPXORDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 22762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rr),
     /* 22767 */     GIR_RootConstrainSelectedInstOperands,
     /* 22768 */     // GIR_Coverage, 5827,
     /* 22768 */     GIR_Done,
     /* 22769 */   // Label 677: @22769
     /* 22769 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(22796), // Rule ID 18545 //
     /* 22774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 22777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 22781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 22785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 22789 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPXORYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 22789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /* 22794 */     GIR_RootConstrainSelectedInstOperands,
     /* 22795 */     // GIR_Coverage, 18545,
     /* 22795 */     GIR_Done,
     /* 22796 */   // Label 678: @22796
     /* 22796 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(22823), // Rule ID 18571 //
     /* 22801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 22804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 22808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 22812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 22816 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VXORPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 22816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /* 22821 */     GIR_RootConstrainSelectedInstOperands,
     /* 22822 */     // GIR_Coverage, 18571,
     /* 22822 */     GIR_Done,
     /* 22823 */   // Label 679: @22823
     /* 22823 */   GIM_Reject,
     /* 22824 */ // Label 674: @22824
     /* 22824 */ GIM_Reject,
     /* 22825 */ // Label 569: @22825
     /* 22825 */ GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(22902),
     /* 22830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 22833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 22836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 22840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 22844 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(22882), // Rule ID 22389 //
     /* 22849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 22852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 22856 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 22862 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 22864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 22866 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, immAllOnesV:{ *:[v8i64] })  =>  (VPTERNLOGQZrri:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VR512:{ *:[v8i64] }:$src, VR512:{ *:[v8i64] }:$src, 15:{ *:[i8] })
     /* 22866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 22869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 22871 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22873 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22875 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 22880 */     GIR_RootConstrainSelectedInstOperands,
     /* 22881 */     // GIR_Coverage, 22389,
     /* 22881 */     GIR_EraseRootFromParent_Done,
     /* 22882 */   // Label 681: @22882
     /* 22882 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(22901), // Rule ID 5791 //
     /* 22887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 22890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 22894 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPXORQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 22894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /* 22899 */     GIR_RootConstrainSelectedInstOperands,
     /* 22900 */     // GIR_Coverage, 5791,
     /* 22900 */     GIR_Done,
     /* 22901 */   // Label 682: @22901
     /* 22901 */   GIM_Reject,
     /* 22902 */ // Label 680: @22902
     /* 22902 */ GIM_Reject,
     /* 22903 */ // Label 570: @22903
     /* 22903 */ GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(23160),
     /* 22908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 22911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 22914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 22918 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(22978), // Rule ID 24110 //
     /* 22923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 22926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 22930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 22934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 22938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 22942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 22947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 22951 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 22957 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 22959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 22963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 22965 */     // (xor:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }), VK16:{ *:[v16i1] }:$src2)  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /* 22965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 22968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 22970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 22974 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 22976 */     GIR_RootConstrainSelectedInstOperands,
     /* 22977 */     // GIR_Coverage, 24110,
     /* 22977 */     GIR_EraseRootFromParent_Done,
     /* 22978 */   // Label 684: @22978
     /* 22978 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(23041), // Rule ID 4421 //
     /* 22983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 22986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 22990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 22994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 22998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 23002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 23007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 23012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 23016 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 23022 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 23024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 23026 */     // (xor:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2), immAllOnesV:{ *:[v16i1] })  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /* 23026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 23029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 23031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 23035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 23039 */     GIR_RootConstrainSelectedInstOperands,
     /* 23040 */     // GIR_Coverage, 4421,
     /* 23040 */     GIR_EraseRootFromParent_Done,
     /* 23041 */   // Label 685: @23041
     /* 23041 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(23101), // Rule ID 24111 //
     /* 23046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 23049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 23053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 23057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 23061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 23065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 23069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 23074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 23078 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 23084 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 23086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 23088 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src2, (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }))  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /* 23088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 23091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 23093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 23097 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 23099 */     GIR_RootConstrainSelectedInstOperands,
     /* 23100 */     // GIR_Coverage, 24111,
     /* 23100 */     GIR_EraseRootFromParent_Done,
     /* 23101 */   // Label 686: @23101
     /* 23101 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(23136), // Rule ID 4409 //
     /* 23106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 23109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 23113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 23117 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 23123 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 23125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 23127 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src, immAllOnesV:{ *:[v16i1] })  =>  (KNOTWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src)
     /* 23127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 23130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 23132 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23134 */     GIR_RootConstrainSelectedInstOperands,
     /* 23135 */     // GIR_Coverage, 4409,
     /* 23135 */     GIR_EraseRootFromParent_Done,
     /* 23136 */   // Label 687: @23136
     /* 23136 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(23159), // Rule ID 4425 //
     /* 23141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 23144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 23148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 23152 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KXORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /* 23152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /* 23157 */     GIR_RootConstrainSelectedInstOperands,
     /* 23158 */     // GIR_Coverage, 4425,
     /* 23158 */     GIR_Done,
     /* 23159 */   // Label 688: @23159
     /* 23159 */   GIM_Reject,
     /* 23160 */ // Label 683: @23160
     /* 23160 */ GIM_Reject,
     /* 23161 */ // Label 571: @23161
     /* 23161 */ GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(23532),
     /* 23166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 23169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23172 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(23404), // Rule ID 22390 //
     /* 23177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 23180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 23184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 23188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 23192 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 23198 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 23200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 23202 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, immAllOnesV:{ *:[v16i8] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /* 23202 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /* 23205 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 23209 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 23216 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 23219 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 23223 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23228 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 23231 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 23235 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /* 23238 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 23243 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 23248 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 23253 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 23256 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 23260 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 23267 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 23270 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 23274 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23279 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 23282 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 23286 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 23289 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 23294 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 23299 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 23304 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 23307 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 23311 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 23318 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 23321 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 23325 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23330 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 23333 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 23337 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 23340 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 23345 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 23350 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 23355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 23358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 23362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 23370 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 23373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 23376 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 23379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 23381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 23384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 23386 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 23393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 23398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 23403 */     // GIR_Coverage, 22390,
     /* 23403 */     GIR_EraseRootFromParent_Done,
     /* 23404 */   // Label 690: @23404
     /* 23404 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(23450), // Rule ID 22398 //
     /* 23409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 23412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 23416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 23420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 23424 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 23430 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 23432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 23434 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, immAllOnesV:{ *:[v16i8] })  =>  (VPTERNLOGQZ128rri:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VR128X:{ *:[v16i8] }:$src, VR128X:{ *:[v16i8] }:$src, 15:{ *:[i8] })
     /* 23434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /* 23437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 23439 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23441 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23443 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 23448 */     GIR_RootConstrainSelectedInstOperands,
     /* 23449 */     // GIR_Coverage, 22398,
     /* 23449 */     GIR_EraseRootFromParent_Done,
     /* 23450 */   // Label 691: @23450
     /* 23450 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(23477), // Rule ID 18599 //
     /* 23455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 23458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 23462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 23466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 23470 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPXORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 23470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /* 23475 */     GIR_RootConstrainSelectedInstOperands,
     /* 23476 */     // GIR_Coverage, 18599,
     /* 23476 */     GIR_Done,
     /* 23477 */   // Label 692: @23477
     /* 23477 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(23504), // Rule ID 18623 //
     /* 23482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 23485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 23489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 23493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 23497 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PXORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 23497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /* 23502 */     GIR_RootConstrainSelectedInstOperands,
     /* 23503 */     // GIR_Coverage, 18623,
     /* 23503 */     GIR_Done,
     /* 23504 */   // Label 693: @23504
     /* 23504 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(23531), // Rule ID 20467 //
     /* 23509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 23512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 23516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 23520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 23524 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPXORQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 23524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /* 23529 */     GIR_RootConstrainSelectedInstOperands,
     /* 23530 */     // GIR_Coverage, 20467,
     /* 23530 */     GIR_Done,
     /* 23531 */   // Label 694: @23531
     /* 23531 */   GIM_Reject,
     /* 23532 */ // Label 689: @23532
     /* 23532 */ GIM_Reject,
     /* 23533 */ // Label 572: @23533
     /* 23533 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(23904),
     /* 23538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 23541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 23544 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(23776), // Rule ID 22395 //
     /* 23549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 23552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 23556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 23560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 23564 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 23570 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 23572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 23574 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, immAllOnesV:{ *:[v16i16] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /* 23574 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /* 23577 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 23581 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 23588 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 23591 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 23595 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23600 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 23603 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 23607 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /* 23610 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 23615 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 23620 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 23625 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 23628 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 23632 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 23639 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 23642 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 23646 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23651 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 23654 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 23658 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 23661 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 23666 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 23671 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 23676 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 23679 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 23683 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 23690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 23693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 23697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23702 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 23705 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 23709 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 23712 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 23717 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 23722 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 23727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 23730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 23734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23739 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 23742 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 23745 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 23748 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 23751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 23753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 23756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 23758 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 23765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 23770 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 23775 */     // GIR_Coverage, 22395,
     /* 23775 */     GIR_EraseRootFromParent_Done,
     /* 23776 */   // Label 696: @23776
     /* 23776 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(23822), // Rule ID 22403 //
     /* 23781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 23784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 23788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 23792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 23796 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 23802 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 23804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 23806 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, immAllOnesV:{ *:[v16i16] })  =>  (VPTERNLOGQZ256rri:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VR256X:{ *:[v16i16] }:$src, VR256X:{ *:[v16i16] }:$src, 15:{ *:[i8] })
     /* 23806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /* 23809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 23811 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23813 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23815 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 23820 */     GIR_RootConstrainSelectedInstOperands,
     /* 23821 */     // GIR_Coverage, 22403,
     /* 23821 */     GIR_EraseRootFromParent_Done,
     /* 23822 */   // Label 697: @23822
     /* 23822 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(23849), // Rule ID 18544 //
     /* 23827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 23830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 23834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 23838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 23842 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPXORYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 23842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /* 23847 */     GIR_RootConstrainSelectedInstOperands,
     /* 23848 */     // GIR_Coverage, 18544,
     /* 23848 */     GIR_Done,
     /* 23849 */   // Label 698: @23849
     /* 23849 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(23876), // Rule ID 18570 //
     /* 23854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 23857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 23861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 23865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 23869 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VXORPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 23869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /* 23874 */     GIR_RootConstrainSelectedInstOperands,
     /* 23875 */     // GIR_Coverage, 18570,
     /* 23875 */     GIR_Done,
     /* 23876 */   // Label 699: @23876
     /* 23876 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(23903), // Rule ID 20484 //
     /* 23881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 23884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 23888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 23892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 23896 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPXORQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 23896 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /* 23901 */     GIR_RootConstrainSelectedInstOperands,
     /* 23902 */     // GIR_Coverage, 20484,
     /* 23902 */     GIR_Done,
     /* 23903 */   // Label 700: @23903
     /* 23903 */   GIM_Reject,
     /* 23904 */ // Label 695: @23904
     /* 23904 */ GIM_Reject,
     /* 23905 */ // Label 573: @23905
     /* 23905 */ GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(23982),
     /* 23910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 23913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 23916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 23920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 23924 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(23962), // Rule ID 22388 //
     /* 23929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 23932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 23936 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 23942 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 23944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 23946 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, immAllOnesV:{ *:[v16i32] })  =>  (VPTERNLOGQZrri:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VR512:{ *:[v16i32] }:$src, VR512:{ *:[v16i32] }:$src, 15:{ *:[i8] })
     /* 23946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 23949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 23951 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23953 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23955 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 23960 */     GIR_RootConstrainSelectedInstOperands,
     /* 23961 */     // GIR_Coverage, 22388,
     /* 23961 */     GIR_EraseRootFromParent_Done,
     /* 23962 */   // Label 702: @23962
     /* 23962 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(23981), // Rule ID 5818 //
     /* 23967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 23970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 23974 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPXORDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 23974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZrr),
     /* 23979 */     GIR_RootConstrainSelectedInstOperands,
     /* 23980 */     // GIR_Coverage, 5818,
     /* 23980 */     GIR_Done,
     /* 23981 */   // Label 703: @23981
     /* 23981 */   GIM_Reject,
     /* 23982 */ // Label 701: @23982
     /* 23982 */ GIM_Reject,
     /* 23983 */ // Label 574: @23983
     /* 23983 */ GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(24240),
     /* 23988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 23991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 23994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 23998 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(24058), // Rule ID 24112 //
     /* 24003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 24010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 24014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 24018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 24022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 24031 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24037 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 24039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 24045 */     // (xor:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }), VK32:{ *:[v32i1] }:$src2)  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /* 24045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /* 24048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 24054 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 24056 */     GIR_RootConstrainSelectedInstOperands,
     /* 24057 */     // GIR_Coverage, 24112,
     /* 24057 */     GIR_EraseRootFromParent_Done,
     /* 24058 */   // Label 705: @24058
     /* 24058 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(24121), // Rule ID 4422 //
     /* 24063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 24070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 24074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 24078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 24082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 24096 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24102 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 24104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 24106 */     // (xor:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2), immAllOnesV:{ *:[v32i1] })  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /* 24106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /* 24109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 24115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 24119 */     GIR_RootConstrainSelectedInstOperands,
     /* 24120 */     // GIR_Coverage, 4422,
     /* 24120 */     GIR_EraseRootFromParent_Done,
     /* 24121 */   // Label 706: @24121
     /* 24121 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(24181), // Rule ID 24113 //
     /* 24126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 24137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 24141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 24145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 24149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 24158 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24164 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 24166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 24168 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src2, (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }))  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /* 24168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /* 24171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 24177 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 24179 */     GIR_RootConstrainSelectedInstOperands,
     /* 24180 */     // GIR_Coverage, 24113,
     /* 24180 */     GIR_EraseRootFromParent_Done,
     /* 24181 */   // Label 707: @24181
     /* 24181 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(24216), // Rule ID 4410 //
     /* 24186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 24197 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24203 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 24205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 24207 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src, immAllOnesV:{ *:[v32i1] })  =>  (KNOTDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src)
     /* 24207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTDkk),
     /* 24210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24212 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24214 */     GIR_RootConstrainSelectedInstOperands,
     /* 24215 */     // GIR_Coverage, 4410,
     /* 24215 */     GIR_EraseRootFromParent_Done,
     /* 24216 */   // Label 708: @24216
     /* 24216 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(24239), // Rule ID 4426 //
     /* 24221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24232 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KXORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /* 24232 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORDkk),
     /* 24237 */     GIR_RootConstrainSelectedInstOperands,
     /* 24238 */     // GIR_Coverage, 4426,
     /* 24238 */     GIR_Done,
     /* 24239 */   // Label 709: @24239
     /* 24239 */   GIM_Reject,
     /* 24240 */ // Label 704: @24240
     /* 24240 */ GIM_Reject,
     /* 24241 */ // Label 575: @24241
     /* 24241 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(24612),
     /* 24246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 24249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 24252 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(24484), // Rule ID 22394 //
     /* 24257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 24260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 24264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 24268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 24272 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24278 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 24280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 24282 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, immAllOnesV:{ *:[v32i8] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /* 24282 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /* 24285 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 24289 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 24294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 24296 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 24299 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 24303 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 24308 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 24311 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 24315 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /* 24318 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 24323 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 24328 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 24333 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 24336 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 24340 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 24345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 24347 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 24350 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 24354 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 24359 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 24362 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 24366 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 24369 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 24374 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 24379 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 24384 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 24387 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 24391 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 24396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 24398 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 24401 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 24405 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 24410 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 24413 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 24417 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 24420 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 24425 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 24430 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 24435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 24438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 24442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 24447 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 24450 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 24453 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 24456 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 24459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 24461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 24464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24466 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 24473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 24478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 24483 */     // GIR_Coverage, 22394,
     /* 24483 */     GIR_EraseRootFromParent_Done,
     /* 24484 */   // Label 711: @24484
     /* 24484 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(24530), // Rule ID 22402 //
     /* 24489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 24492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 24496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 24500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 24504 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24510 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 24512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 24514 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, immAllOnesV:{ *:[v32i8] })  =>  (VPTERNLOGQZ256rri:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VR256X:{ *:[v32i8] }:$src, VR256X:{ *:[v32i8] }:$src, 15:{ *:[i8] })
     /* 24514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /* 24517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24521 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24523 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 24528 */     GIR_RootConstrainSelectedInstOperands,
     /* 24529 */     // GIR_Coverage, 22402,
     /* 24529 */     GIR_EraseRootFromParent_Done,
     /* 24530 */   // Label 712: @24530
     /* 24530 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(24557), // Rule ID 18543 //
     /* 24535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 24538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 24542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 24546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 24550 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPXORYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 24550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /* 24555 */     GIR_RootConstrainSelectedInstOperands,
     /* 24556 */     // GIR_Coverage, 18543,
     /* 24556 */     GIR_Done,
     /* 24557 */   // Label 713: @24557
     /* 24557 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(24584), // Rule ID 18569 //
     /* 24562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 24565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 24569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 24573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 24577 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VXORPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 24577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /* 24582 */     GIR_RootConstrainSelectedInstOperands,
     /* 24583 */     // GIR_Coverage, 18569,
     /* 24583 */     GIR_Done,
     /* 24584 */   // Label 714: @24584
     /* 24584 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(24611), // Rule ID 20483 //
     /* 24589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 24592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 24596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 24600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 24604 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPXORQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 24604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /* 24609 */     GIR_RootConstrainSelectedInstOperands,
     /* 24610 */     // GIR_Coverage, 20483,
     /* 24610 */     GIR_Done,
     /* 24611 */   // Label 715: @24611
     /* 24611 */   GIM_Reject,
     /* 24612 */ // Label 710: @24612
     /* 24612 */ GIM_Reject,
     /* 24613 */ // Label 576: @24613
     /* 24613 */ GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(24690),
     /* 24618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 24621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 24624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 24628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 24632 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(24670), // Rule ID 22387 //
     /* 24637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 24640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 24644 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24650 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 24652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 24654 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, immAllOnesV:{ *:[v32i16] })  =>  (VPTERNLOGQZrri:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VR512:{ *:[v32i16] }:$src, VR512:{ *:[v32i16] }:$src, 15:{ *:[i8] })
     /* 24654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 24657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24659 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24663 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 24668 */     GIR_RootConstrainSelectedInstOperands,
     /* 24669 */     // GIR_Coverage, 22387,
     /* 24669 */     GIR_EraseRootFromParent_Done,
     /* 24670 */   // Label 717: @24670
     /* 24670 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(24689), // Rule ID 20500 //
     /* 24675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 24678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 24682 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPXORQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 24682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /* 24687 */     GIR_RootConstrainSelectedInstOperands,
     /* 24688 */     // GIR_Coverage, 20500,
     /* 24688 */     GIR_Done,
     /* 24689 */   // Label 718: @24689
     /* 24689 */   GIM_Reject,
     /* 24690 */ // Label 716: @24690
     /* 24690 */ GIM_Reject,
     /* 24691 */ // Label 577: @24691
     /* 24691 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(24948),
     /* 24696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 24699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 24702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24706 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(24766), // Rule ID 24114 //
     /* 24711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 24718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 24722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 24726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 24730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 24739 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24745 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 24747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 24753 */     // (xor:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }), VK64:{ *:[v64i1] }:$src2)  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /* 24753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /* 24756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 24762 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 24764 */     GIR_RootConstrainSelectedInstOperands,
     /* 24765 */     // GIR_Coverage, 24114,
     /* 24765 */     GIR_EraseRootFromParent_Done,
     /* 24766 */   // Label 720: @24766
     /* 24766 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(24829), // Rule ID 4423 //
     /* 24771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 24778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 24782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 24786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 24790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 24804 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24810 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 24812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 24814 */     // (xor:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2), immAllOnesV:{ *:[v64i1] })  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /* 24814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /* 24817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 24823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 24827 */     GIR_RootConstrainSelectedInstOperands,
     /* 24828 */     // GIR_Coverage, 4423,
     /* 24828 */     GIR_EraseRootFromParent_Done,
     /* 24829 */   // Label 721: @24829
     /* 24829 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(24889), // Rule ID 24115 //
     /* 24834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 24845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 24849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 24853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 24857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 24866 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 24874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 24876 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src2, (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }))  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /* 24876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /* 24879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 24885 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 24887 */     GIR_RootConstrainSelectedInstOperands,
     /* 24888 */     // GIR_Coverage, 24115,
     /* 24888 */     GIR_EraseRootFromParent_Done,
     /* 24889 */   // Label 722: @24889
     /* 24889 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(24924), // Rule ID 4411 //
     /* 24894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 24905 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24911 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 24913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 24915 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src, immAllOnesV:{ *:[v64i1] })  =>  (KNOTQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src)
     /* 24915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTQkk),
     /* 24918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24920 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24922 */     GIR_RootConstrainSelectedInstOperands,
     /* 24923 */     // GIR_Coverage, 4411,
     /* 24923 */     GIR_EraseRootFromParent_Done,
     /* 24924 */   // Label 723: @24924
     /* 24924 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(24947), // Rule ID 4427 //
     /* 24929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24940 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KXORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /* 24940 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORQkk),
     /* 24945 */     GIR_RootConstrainSelectedInstOperands,
     /* 24946 */     // GIR_Coverage, 4427,
     /* 24946 */     GIR_Done,
     /* 24947 */   // Label 724: @24947
     /* 24947 */   GIM_Reject,
     /* 24948 */ // Label 719: @24948
     /* 24948 */ GIM_Reject,
     /* 24949 */ // Label 578: @24949
     /* 24949 */ GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(25026),
     /* 24954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 24957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 24960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 24964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 24968 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(25006), // Rule ID 22386 //
     /* 24973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 24976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 24980 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24986 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 24988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 24990 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, immAllOnesV:{ *:[v64i8] })  =>  (VPTERNLOGQZrri:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VR512:{ *:[v64i8] }:$src, VR512:{ *:[v64i8] }:$src, 15:{ *:[i8] })
     /* 24990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 24993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24995 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24997 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 25001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 25004 */     GIR_RootConstrainSelectedInstOperands,
     /* 25005 */     // GIR_Coverage, 22386,
     /* 25005 */     GIR_EraseRootFromParent_Done,
     /* 25006 */   // Label 726: @25006
     /* 25006 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(25025), // Rule ID 20499 //
     /* 25011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 25014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 25018 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPXORQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 25018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /* 25023 */     GIR_RootConstrainSelectedInstOperands,
     /* 25024 */     // GIR_Coverage, 20499,
     /* 25024 */     GIR_Done,
     /* 25025 */   // Label 727: @25025
     /* 25025 */   GIM_Reject,
     /* 25026 */ // Label 725: @25026
     /* 25026 */ GIM_Reject,
     /* 25027 */ // Label 579: @25027
     /* 25027 */ GIM_Reject,
     /* 25028 */ // Label 6: @25028
     /* 25028 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(25194),
     /* 25033 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 25036 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(16), GIMT_Encode2(24), /*)*//*default:*//*Label 732*/ GIMT_Encode4(25193),
     /* 25047 */   /*GILLT_v16s1*//*Label 729*/ GIMT_Encode4(25079), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 25063 */   /*GILLT_v32s1*//*Label 730*/ GIMT_Encode4(25117), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 25075 */   /*GILLT_v64s1*//*Label 731*/ GIMT_Encode4(25155),
     /* 25079 */   // Label 729: @25079
     /* 25079 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(25116), // Rule ID 19950 //
     /* 25084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 25087 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 25090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 25093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 25097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 25101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 25105 */     // (concat_vectors:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KUNPCKBWkk:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK8:{ *:[v8i1] }:$src1)
     /* 25105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKBWkk),
     /* 25108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25110 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 25112 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 25114 */     GIR_RootConstrainSelectedInstOperands,
     /* 25115 */     // GIR_Coverage, 19950,
     /* 25115 */     GIR_EraseRootFromParent_Done,
     /* 25116 */   // Label 733: @25116
     /* 25116 */   GIM_Reject,
     /* 25117 */   // Label 730: @25117
     /* 25117 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(25154), // Rule ID 19951 //
     /* 25122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 25125 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 25128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 25131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 25135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 25139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 25143 */     // (concat_vectors:{ *:[v32i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KUNPCKWDkk:{ *:[v32i1] } VK16:{ *:[v16i1] }:$src2, VK16:{ *:[v16i1] }:$src1)
     /* 25143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKWDkk),
     /* 25146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25148 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 25150 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 25152 */     GIR_RootConstrainSelectedInstOperands,
     /* 25153 */     // GIR_Coverage, 19951,
     /* 25153 */     GIR_EraseRootFromParent_Done,
     /* 25154 */   // Label 734: @25154
     /* 25154 */   GIM_Reject,
     /* 25155 */   // Label 731: @25155
     /* 25155 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(25192), // Rule ID 19952 //
     /* 25160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 25163 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 25166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 25169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 25173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 25177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 25181 */     // (concat_vectors:{ *:[v64i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KUNPCKDQkk:{ *:[v64i1] } VK32:{ *:[v32i1] }:$src2, VK32:{ *:[v32i1] }:$src1)
     /* 25181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKDQkk),
     /* 25184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25186 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 25188 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 25190 */     GIR_RootConstrainSelectedInstOperands,
     /* 25191 */     // GIR_Coverage, 19952,
     /* 25191 */     GIR_EraseRootFromParent_Done,
     /* 25192 */   // Label 735: @25192
     /* 25192 */   GIM_Reject,
     /* 25193 */   // Label 732: @25193
     /* 25193 */   GIM_Reject,
     /* 25194 */ // Label 728: @25194
     /* 25194 */ GIM_Reject,
     /* 25195 */ // Label 7: @25195
     /* 25195 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(24), /*)*//*default:*//*Label 744*/ GIMT_Encode4(26951),
     /* 25206 */ /*GILLT_s8*//*Label 736*/ GIMT_Encode4(25298),
     /* 25210 */ /*GILLT_s16*//*Label 737*/ GIMT_Encode4(25359),
     /* 25214 */ /*GILLT_s32*//*Label 738*/ GIMT_Encode4(26189),
     /* 25218 */ /*GILLT_s64*//*Label 739*/ GIMT_Encode4(26417), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 25250 */ /*GILLT_v8s1*//*Label 740*/ GIMT_Encode4(26645), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 25266 */ /*GILLT_v16s1*//*Label 741*/ GIMT_Encode4(26727), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 25282 */ /*GILLT_v32s1*//*Label 742*/ GIMT_Encode4(26809), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 25294 */ /*GILLT_v64s1*//*Label 743*/ GIMT_Encode4(26880),
     /* 25298 */ // Label 736: @25298
     /* 25298 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(25358), // Rule ID 19881 //
     /* 25303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 25306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 25310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 25314 */   // (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } VK8:{ *:[v8i1] }:$src, GR32:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 25314 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 25317 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25321 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25326 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 25330 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 25335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25340 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 25347 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 25352 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 25357 */   // GIR_Coverage, 19881,
     /* 25357 */   GIR_EraseRootFromParent_Done,
     /* 25358 */ // Label 745: @25358
     /* 25358 */ GIM_Reject,
     /* 25359 */ // Label 737: @25359
     /* 25359 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(25419), // Rule ID 19878 //
     /* 25364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 25367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 25371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 25375 */   // (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 25375 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 25378 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25382 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25387 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 25391 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 25396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25401 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 25408 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 25413 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 25418 */   // GIR_Coverage, 19878,
     /* 25418 */   GIR_EraseRootFromParent_Done,
     /* 25419 */ // Label 746: @25419
     /* 25419 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(25520), // Rule ID 22587 //
     /* 25424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 25427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 25430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 25434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 25438 */   // (bitconvert:{ *:[f16] } GR16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VMOVW2SHrr:{ *:[f128] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] })), FR16X:{ *:[i32] })
     /* 25438 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 25441 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 25445 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 25452 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 25455 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 25459 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25464 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 25467 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 25471 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/4,
     /* 25474 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 25479 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 25484 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 25489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 25492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVW2SHrr),
     /* 25496 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25501 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 25504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 25506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25511 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 25514 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 25519 */   // GIR_Coverage, 22587,
     /* 25519 */   GIR_EraseRootFromParent_Done,
     /* 25520 */ // Label 747: @25520
     /* 25520 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(25600), // Rule ID 22600 //
     /* 25525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 25528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 25531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 25535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 25539 */   // (bitconvert:{ *:[i16] } FR16X:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VMOVSH2Wrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f128] } FR16X:{ *:[f16] }:$src, VR128X:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /* 25539 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 25542 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25546 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25551 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 25555 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128XRegClassID),
     /* 25560 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 25563 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSH2Wrr),
     /* 25567 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25572 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 25575 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 25577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25582 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 25589 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 25594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 25599 */   // GIR_Coverage, 22600,
     /* 25599 */   GIR_EraseRootFromParent_Done,
     /* 25600 */ // Label 748: @25600
     /* 25600 */ GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(25679), // Rule ID 18787 //
     /* 25605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /* 25608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 25611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 25615 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VPEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /* 25615 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 25618 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25622 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25627 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 25631 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /* 25636 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 25639 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPEXTRWrri),
     /* 25643 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25648 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 25651 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 25654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 25656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25661 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 25668 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 25673 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 25678 */   // GIR_Coverage, 18787,
     /* 25678 */   GIR_EraseRootFromParent_Done,
     /* 25679 */ // Label 749: @25679
     /* 25679 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(25796), // Rule ID 18788 //
     /* 25684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /* 25687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 25690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 25694 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16:{ *:[i32] })
     /* 25694 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 25697 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 25701 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25706 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 25708 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 25711 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 25715 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25720 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 25723 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 25727 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /* 25730 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 25735 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 25740 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 25745 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 25748 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 25752 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 25759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 25762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWrri),
     /* 25766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25771 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 25774 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 25777 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 25780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 25782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 25790 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 25795 */   // GIR_Coverage, 18788,
     /* 25795 */   GIR_EraseRootFromParent_Done,
     /* 25796 */ // Label 750: @25796
     /* 25796 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(25875), // Rule ID 18784 //
     /* 25801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 25804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 25807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 25811 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (PEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /* 25811 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 25814 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25818 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25823 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 25827 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /* 25832 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 25835 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PEXTRWrri),
     /* 25839 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25844 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 25847 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 25850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 25852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25857 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 25864 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 25869 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 25874 */   // GIR_Coverage, 18784,
     /* 25874 */   GIR_EraseRootFromParent_Done,
     /* 25875 */ // Label 751: @25875
     /* 25875 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(25992), // Rule ID 18785 //
     /* 25880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 25883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 25886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 25890 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (PINSRWrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16:{ *:[i32] })
     /* 25890 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 25893 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 25897 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 25904 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 25907 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 25911 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25916 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 25919 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 25923 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /* 25926 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 25931 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 25936 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 25941 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 25944 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 25948 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 25955 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 25958 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PINSRWrri),
     /* 25962 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25967 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 25970 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 25973 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 25976 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 25978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 25986 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 25991 */   // GIR_Coverage, 18785,
     /* 25991 */   GIR_EraseRootFromParent_Done,
     /* 25992 */ // Label 752: @25992
     /* 25992 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(26071), // Rule ID 22288 //
     /* 25997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 26000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 26003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 26007 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VPEXTRWZrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16X:{ *:[f16] }:$src, VR128X:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /* 26007 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 26010 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26014 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26019 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 26023 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128XRegClassID),
     /* 26028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 26031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPEXTRWZrri),
     /* 26035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26040 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 26043 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 26046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 26048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 26053 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 26060 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 26065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 26070 */   // GIR_Coverage, 22288,
     /* 26070 */   GIR_EraseRootFromParent_Done,
     /* 26071 */ // Label 753: @26071
     /* 26071 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(26188), // Rule ID 22289 //
     /* 26076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 26079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 26082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 26086 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWZrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16X:{ *:[i32] })
     /* 26086 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 26089 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 26093 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 26100 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 26103 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 26107 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26112 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 26115 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 26119 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /* 26122 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 26127 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 26132 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 26137 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 26140 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 26144 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 26151 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 26154 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWZrri),
     /* 26158 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26163 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 26166 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 26169 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 26172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 26174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 26179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 26182 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 26187 */   // GIR_Coverage, 22289,
     /* 26187 */   GIR_EraseRootFromParent_Done,
     /* 26188 */ // Label 754: @26188
     /* 26188 */ GIM_Reject,
     /* 26189 */ // Label 738: @26189
     /* 26189 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(26215), // Rule ID 2912 //
     /* 26194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 26197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 26200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 26204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 26208 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VMOVDI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /* 26208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSrr),
     /* 26213 */   GIR_RootConstrainSelectedInstOperands,
     /* 26214 */   // GIR_Coverage, 2912,
     /* 26214 */   GIR_Done,
     /* 26215 */ // Label 755: @26215
     /* 26215 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(26241), // Rule ID 2913 //
     /* 26220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 26223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 26226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 26230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 26234 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (MOVDI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /* 26234 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVDI2SSrr),
     /* 26239 */   GIR_RootConstrainSelectedInstOperands,
     /* 26240 */   // GIR_Coverage, 2913,
     /* 26240 */   GIR_Done,
     /* 26241 */ // Label 756: @26241
     /* 26241 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(26267), // Rule ID 2922 //
     /* 26246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 26249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 26252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 26256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 26260 */   // (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VMOVSS2DIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 26260 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIrr),
     /* 26265 */   GIR_RootConstrainSelectedInstOperands,
     /* 26266 */   // GIR_Coverage, 2922,
     /* 26266 */   GIR_Done,
     /* 26267 */ // Label 757: @26267
     /* 26267 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(26293), // Rule ID 2923 //
     /* 26272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 26275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 26278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 26282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 26286 */   // (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (MOVSS2DIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 26286 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSS2DIrr),
     /* 26291 */   GIR_RootConstrainSelectedInstOperands,
     /* 26292 */   // GIR_Coverage, 2923,
     /* 26292 */   GIR_Done,
     /* 26293 */ // Label 758: @26293
     /* 26293 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(26319), // Rule ID 4595 //
     /* 26298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 26301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 26304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 26308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 26312 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VMOVDI2SSZrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /* 26312 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSZrr),
     /* 26317 */   GIR_RootConstrainSelectedInstOperands,
     /* 26318 */   // GIR_Coverage, 4595,
     /* 26318 */   GIR_Done,
     /* 26319 */ // Label 759: @26319
     /* 26319 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(26345), // Rule ID 4600 //
     /* 26324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 26327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 26330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 26334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 26338 */   // (bitconvert:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VMOVSS2DIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 26338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIZrr),
     /* 26343 */   GIR_RootConstrainSelectedInstOperands,
     /* 26344 */   // GIR_Coverage, 4600,
     /* 26344 */   GIR_Done,
     /* 26345 */ // Label 760: @26345
     /* 26345 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(26372), // Rule ID 19889 //
     /* 26350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 26353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 26357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 26361 */   // (bitconvert:{ *:[i32] } VK32:{ *:[v32i1] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK32:{ *:[v32i1] }:$src, GR32:{ *:[i32] })
     /* 26361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 26371 */   // GIR_Coverage, 19889,
     /* 26371 */   GIR_Done,
     /* 26372 */ // Label 761: @26372
     /* 26372 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(26416), // Rule ID 20323 //
     /* 26377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 26380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 26384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 26388 */   // (bitconvert:{ *:[f32] } VK32:{ *:[v32i1] }:$src)  =>  (VMOVDI2SSZrr:{ *:[f32] } (KMOVDrk:{ *:[i32] } VK32:{ *:[v32i1] }:$src))
     /* 26388 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 26391 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVDrk),
     /* 26395 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26400 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 26404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 26406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSZrr),
     /* 26409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 26411 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 26414 */   GIR_RootConstrainSelectedInstOperands,
     /* 26415 */   // GIR_Coverage, 20323,
     /* 26415 */   GIR_EraseRootFromParent_Done,
     /* 26416 */ // Label 762: @26416
     /* 26416 */ GIM_Reject,
     /* 26417 */ // Label 739: @26417
     /* 26417 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(26443), // Rule ID 2907 //
     /* 26422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 26425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 26428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 26432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 26436 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VMOV64toSDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /* 26436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDrr),
     /* 26441 */   GIR_RootConstrainSelectedInstOperands,
     /* 26442 */   // GIR_Coverage, 2907,
     /* 26442 */   GIR_Done,
     /* 26443 */ // Label 763: @26443
     /* 26443 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(26469), // Rule ID 2911 //
     /* 26448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 26451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 26454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 26458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 26462 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (MOV64toSDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /* 26462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOV64toSDrr),
     /* 26467 */   GIR_RootConstrainSelectedInstOperands,
     /* 26468 */   // GIR_Coverage, 2911,
     /* 26468 */   GIR_Done,
     /* 26469 */ // Label 764: @26469
     /* 26469 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(26495), // Rule ID 2920 //
     /* 26474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 26477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 26480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 26484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 26488 */   // (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VMOVSDto64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 26488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64rr),
     /* 26493 */   GIR_RootConstrainSelectedInstOperands,
     /* 26494 */   // GIR_Coverage, 2920,
     /* 26494 */   GIR_Done,
     /* 26495 */ // Label 765: @26495
     /* 26495 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(26521), // Rule ID 2921 //
     /* 26500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 26503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 26506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 26510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 26514 */   // (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (MOVSDto64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 26514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSDto64rr),
     /* 26519 */   GIR_RootConstrainSelectedInstOperands,
     /* 26520 */   // GIR_Coverage, 2921,
     /* 26520 */   GIR_Done,
     /* 26521 */ // Label 766: @26521
     /* 26521 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(26547), // Rule ID 4593 //
     /* 26526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 26529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 26532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 26536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 26540 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VMOV64toSDZrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /* 26540 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDZrr),
     /* 26545 */   GIR_RootConstrainSelectedInstOperands,
     /* 26546 */   // GIR_Coverage, 4593,
     /* 26546 */   GIR_Done,
     /* 26547 */ // Label 767: @26547
     /* 26547 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(26573), // Rule ID 4594 //
     /* 26552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 26555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 26558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 26562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 26566 */   // (bitconvert:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VMOVSDto64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 26566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64Zrr),
     /* 26571 */   GIR_RootConstrainSelectedInstOperands,
     /* 26572 */   // GIR_Coverage, 4594,
     /* 26572 */   GIR_Done,
     /* 26573 */ // Label 768: @26573
     /* 26573 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(26600), // Rule ID 19891 //
     /* 26578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 26581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 26585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 26589 */   // (bitconvert:{ *:[i64] } VK64:{ *:[v64i1] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i64] } VK64:{ *:[v64i1] }:$src, GR64:{ *:[i32] })
     /* 26589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 26599 */   // GIR_Coverage, 19891,
     /* 26599 */   GIR_Done,
     /* 26600 */ // Label 769: @26600
     /* 26600 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(26644), // Rule ID 20325 //
     /* 26605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 26608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 26612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 26616 */   // (bitconvert:{ *:[f64] } VK64:{ *:[v64i1] }:$src)  =>  (VMOV64toSDZrr:{ *:[f64] } (KMOVQrk:{ *:[i64] } VK64:{ *:[v64i1] }:$src))
     /* 26616 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 26619 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVQrk),
     /* 26623 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26628 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 26632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 26634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDZrr),
     /* 26637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 26639 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 26642 */   GIR_RootConstrainSelectedInstOperands,
     /* 26643 */   // GIR_Coverage, 20325,
     /* 26643 */   GIR_EraseRootFromParent_Done,
     /* 26644 */ // Label 770: @26644
     /* 26644 */ GIM_Reject,
     /* 26645 */ // Label 740: @26645
     /* 26645 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(26726), // Rule ID 19880 //
     /* 26650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 26653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 26657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 26661 */   // (bitconvert:{ *:[v8i1] } GR8:{ *:[i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src, sub_8bit:{ *:[i32] }), VK8:{ *:[i32] })
     /* 26661 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 26664 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 26668 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 26675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 26678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 26682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26687 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 26690 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 26694 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 26697 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 26702 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 26707 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 26712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 26717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 26720 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 26725 */   // GIR_Coverage, 19880,
     /* 26725 */   GIR_EraseRootFromParent_Done,
     /* 26726 */ // Label 771: @26726
     /* 26726 */ GIM_Reject,
     /* 26727 */ // Label 741: @26727
     /* 26727 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(26808), // Rule ID 19877 //
     /* 26732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 26735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 26739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 26743 */   // (bitconvert:{ *:[v16i1] } GR16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), VK16:{ *:[i32] })
     /* 26743 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 26746 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 26750 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 26757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 26760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 26764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26769 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 26772 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 26776 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/4,
     /* 26779 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 26784 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 26789 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 26794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 26799 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 26802 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 26807 */   // GIR_Coverage, 19877,
     /* 26807 */   GIR_EraseRootFromParent_Done,
     /* 26808 */ // Label 772: @26808
     /* 26808 */ GIM_Reject,
     /* 26809 */ // Label 742: @26809
     /* 26809 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(26879),
     /* 26814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 26817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 26821 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(26841), // Rule ID 19888 //
     /* 26826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 26830 */     // (bitconvert:{ *:[v32i1] } GR32:{ *:[i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } GR32:{ *:[i32] }:$src, VK32:{ *:[i32] })
     /* 26830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 26840 */     // GIR_Coverage, 19888,
     /* 26840 */     GIR_Done,
     /* 26841 */   // Label 774: @26841
     /* 26841 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(26878), // Rule ID 20322 //
     /* 26846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 26850 */     // (bitconvert:{ *:[v32i1] } FR32X:{ *:[f32] }:$src)  =>  (KMOVDkr:{ *:[v32i1] } (VMOVSS2DIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src))
     /* 26850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 26853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIZrr),
     /* 26857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 26866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 26868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkr),
     /* 26871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 26873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 26876 */     GIR_RootConstrainSelectedInstOperands,
     /* 26877 */     // GIR_Coverage, 20322,
     /* 26877 */     GIR_EraseRootFromParent_Done,
     /* 26878 */   // Label 775: @26878
     /* 26878 */   GIM_Reject,
     /* 26879 */ // Label 773: @26879
     /* 26879 */ GIM_Reject,
     /* 26880 */ // Label 743: @26880
     /* 26880 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(26950),
     /* 26885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 26888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 26892 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(26912), // Rule ID 19890 //
     /* 26897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 26901 */     // (bitconvert:{ *:[v64i1] } GR64:{ *:[i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v64i1] } GR64:{ *:[i64] }:$src, VK64:{ *:[i32] })
     /* 26901 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK64RegClassID),
     /* 26911 */     // GIR_Coverage, 19890,
     /* 26911 */     GIR_Done,
     /* 26912 */   // Label 777: @26912
     /* 26912 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(26949), // Rule ID 20324 //
     /* 26917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 26921 */     // (bitconvert:{ *:[v64i1] } FR64X:{ *:[f64] }:$src)  =>  (KMOVQkr:{ *:[v64i1] } (VMOVSDto64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src))
     /* 26921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 26924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64Zrr),
     /* 26928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26933 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 26937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 26939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkr),
     /* 26942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 26944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 26947 */     GIR_RootConstrainSelectedInstOperands,
     /* 26948 */     // GIR_Coverage, 20324,
     /* 26948 */     GIR_EraseRootFromParent_Done,
     /* 26949 */   // Label 778: @26949
     /* 26949 */   GIM_Reject,
     /* 26950 */ // Label 776: @26950
     /* 26950 */ GIM_Reject,
     /* 26951 */ // Label 744: @26951
     /* 26951 */ GIM_Reject,
     /* 26952 */ // Label 8: @26952
     /* 26952 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(20), /*)*//*default:*//*Label 787*/ GIMT_Encode4(27813),
     /* 26963 */ /*GILLT_s32*//*Label 779*/ GIMT_Encode4(27031),
     /* 26967 */ /*GILLT_s64*//*Label 780*/ GIMT_Encode4(27212), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 26983 */ /*GILLT_v2s64*//*Label 781*/ GIMT_Encode4(27393), GIMT_Encode4(0),
     /* 26991 */ /*GILLT_v4s32*//*Label 782*/ GIMT_Encode4(27424),
     /* 26995 */ /*GILLT_v4s64*//*Label 783*/ GIMT_Encode4(27575), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 27007 */ /*GILLT_v8s32*//*Label 784*/ GIMT_Encode4(27636),
     /* 27011 */ /*GILLT_v8s64*//*Label 785*/ GIMT_Encode4(27724), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 27027 */ /*GILLT_v16s32*//*Label 786*/ GIMT_Encode4(27785),
     /* 27031 */ // Label 779: @27031
     /* 27031 */ GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(27061), // Rule ID 1752 //
     /* 27036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 27039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 27042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 27046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 27050 */   // (lrint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 27050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIrr),
     /* 27055 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27059 */   GIR_RootConstrainSelectedInstOperands,
     /* 27060 */   // GIR_Coverage, 1752,
     /* 27060 */   GIR_Done,
     /* 27061 */ // Label 788: @27061
     /* 27061 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(27091), // Rule ID 1756 //
     /* 27066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 27069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 27072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 27076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 27080 */   // (lrint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 27080 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIrr),
     /* 27085 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27089 */   GIR_RootConstrainSelectedInstOperands,
     /* 27090 */   // GIR_Coverage, 1756,
     /* 27090 */   GIR_Done,
     /* 27091 */ // Label 789: @27091
     /* 27091 */ GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(27121), // Rule ID 1776 //
     /* 27096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 27099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 27102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 27106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 27110 */   // (lrint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 27110 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SIrr),
     /* 27115 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27119 */   GIR_RootConstrainSelectedInstOperands,
     /* 27120 */   // GIR_Coverage, 1776,
     /* 27120 */   GIR_Done,
     /* 27121 */ // Label 790: @27121
     /* 27121 */ GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(27151), // Rule ID 1780 //
     /* 27126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 27129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 27132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 27136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 27140 */   // (lrint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 27140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SIrr),
     /* 27145 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27149 */   GIR_RootConstrainSelectedInstOperands,
     /* 27150 */   // GIR_Coverage, 1780,
     /* 27150 */   GIR_Done,
     /* 27151 */ // Label 791: @27151
     /* 27151 */ GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(27181), // Rule ID 10349 //
     /* 27156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 27159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 27162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 27166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 27170 */   // (lrint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 27170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIZrr),
     /* 27175 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27179 */   GIR_RootConstrainSelectedInstOperands,
     /* 27180 */   // GIR_Coverage, 10349,
     /* 27180 */   GIR_Done,
     /* 27181 */ // Label 792: @27181
     /* 27181 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(27211), // Rule ID 10353 //
     /* 27186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 27189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 27192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 27196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 27200 */   // (lrint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 27200 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIZrr),
     /* 27205 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27209 */   GIR_RootConstrainSelectedInstOperands,
     /* 27210 */   // GIR_Coverage, 10353,
     /* 27210 */   GIR_Done,
     /* 27211 */ // Label 793: @27211
     /* 27211 */ GIM_Reject,
     /* 27212 */ // Label 780: @27212
     /* 27212 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(27242), // Rule ID 18436 //
     /* 27217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 27220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 27223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 27231 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 27231 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rr),
     /* 27236 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27240 */   GIR_RootConstrainSelectedInstOperands,
     /* 27241 */   // GIR_Coverage, 18436,
     /* 27241 */   GIR_Done,
     /* 27242 */ // Label 794: @27242
     /* 27242 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(27272), // Rule ID 18438 //
     /* 27247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 27250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 27253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 27261 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 27261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rr),
     /* 27266 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27270 */   GIR_RootConstrainSelectedInstOperands,
     /* 27271 */   // GIR_Coverage, 18438,
     /* 27271 */   GIR_Done,
     /* 27272 */ // Label 795: @27272
     /* 27272 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(27302), // Rule ID 18440 //
     /* 27277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 27280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 27283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 27291 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 27291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rr),
     /* 27296 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27300 */   GIR_RootConstrainSelectedInstOperands,
     /* 27301 */   // GIR_Coverage, 18440,
     /* 27301 */   GIR_Done,
     /* 27302 */ // Label 796: @27302
     /* 27302 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(27332), // Rule ID 18442 //
     /* 27307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 27310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 27313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 27321 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 27321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rr),
     /* 27326 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27330 */   GIR_RootConstrainSelectedInstOperands,
     /* 27331 */   // GIR_Coverage, 18442,
     /* 27331 */   GIR_Done,
     /* 27332 */ // Label 797: @27332
     /* 27332 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(27362), // Rule ID 21606 //
     /* 27337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 27340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 27343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 27351 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64Zrr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 27351 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrr),
     /* 27356 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27360 */   GIR_RootConstrainSelectedInstOperands,
     /* 27361 */   // GIR_Coverage, 21606,
     /* 27361 */   GIR_Done,
     /* 27362 */ // Label 798: @27362
     /* 27362 */ GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(27392), // Rule ID 21608 //
     /* 27367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 27370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 27373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 27381 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64Zrr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 27381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrr),
     /* 27386 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27390 */   GIR_RootConstrainSelectedInstOperands,
     /* 27391 */   // GIR_Coverage, 21608,
     /* 27391 */   GIR_Done,
     /* 27392 */ // Label 799: @27392
     /* 27392 */ GIM_Reject,
     /* 27393 */ // Label 781: @27393
     /* 27393 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(27423), // Rule ID 21831 //
     /* 27398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 27401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 27404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 27408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 27412 */   // (lrint:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)  =>  (VCVTPD2QQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)
     /* 27412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rr),
     /* 27417 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27421 */   GIR_RootConstrainSelectedInstOperands,
     /* 27422 */   // GIR_Coverage, 21831,
     /* 27422 */   GIR_Done,
     /* 27423 */ // Label 800: @27423
     /* 27423 */ GIM_Reject,
     /* 27424 */ // Label 782: @27424
     /* 27424 */ GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(27454), // Rule ID 18490 //
     /* 27429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 27432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 27435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 27439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 27443 */   // (lrint:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)  =>  (VCVTPS2DQrr:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)
     /* 27443 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQrr),
     /* 27448 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27452 */   GIR_RootConstrainSelectedInstOperands,
     /* 27453 */   // GIR_Coverage, 18490,
     /* 27453 */   GIR_Done,
     /* 27454 */ // Label 801: @27454
     /* 27454 */ GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(27484), // Rule ID 18494 //
     /* 27459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 27462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 27465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 27469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 27473 */   // (lrint:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)  =>  (VCVTPD2DQYrr:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)
     /* 27473 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQYrr),
     /* 27478 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27482 */   GIR_RootConstrainSelectedInstOperands,
     /* 27483 */   // GIR_Coverage, 18494,
     /* 27483 */   GIR_Done,
     /* 27484 */ // Label 802: @27484
     /* 27484 */ GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(27514), // Rule ID 18496 //
     /* 27489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 27492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 27495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 27499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 27503 */   // (lrint:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)  =>  (CVTPS2DQrr:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)
     /* 27503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTPS2DQrr),
     /* 27508 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27512 */   GIR_RootConstrainSelectedInstOperands,
     /* 27513 */   // GIR_Coverage, 18496,
     /* 27513 */   GIR_Done,
     /* 27514 */ // Label 803: @27514
     /* 27514 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(27544), // Rule ID 21803 //
     /* 27519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 27522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 27525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 27529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 27533 */   // (lrint:{ *:[v4i32] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2DQZ128rr:{ *:[v4i32] } VR128X:{ *:[v4f32] }:$src)
     /* 27533 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ128rr),
     /* 27538 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27542 */   GIR_RootConstrainSelectedInstOperands,
     /* 27543 */   // GIR_Coverage, 21803,
     /* 27543 */   GIR_Done,
     /* 27544 */ // Label 804: @27544
     /* 27544 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(27574), // Rule ID 21807 //
     /* 27549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 27552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 27555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 27559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27563 */   // (lrint:{ *:[v4i32] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2DQZ256rr:{ *:[v4i32] } VR256X:{ *:[v4f64] }:$src)
     /* 27563 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZ256rr),
     /* 27568 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27572 */   GIR_RootConstrainSelectedInstOperands,
     /* 27573 */   // GIR_Coverage, 21807,
     /* 27573 */   GIR_Done,
     /* 27574 */ // Label 805: @27574
     /* 27574 */ GIM_Reject,
     /* 27575 */ // Label 783: @27575
     /* 27575 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(27605), // Rule ID 21827 //
     /* 27580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 27583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 27586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 27594 */   // (lrint:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2QQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)
     /* 27594 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rr),
     /* 27599 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27603 */   GIR_RootConstrainSelectedInstOperands,
     /* 27604 */   // GIR_Coverage, 21827,
     /* 27604 */   GIR_Done,
     /* 27605 */ // Label 806: @27605
     /* 27605 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(27635), // Rule ID 21833 //
     /* 27610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 27613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 27616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27624 */   // (lrint:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2QQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)
     /* 27624 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rr),
     /* 27629 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27633 */   GIR_RootConstrainSelectedInstOperands,
     /* 27634 */   // GIR_Coverage, 21833,
     /* 27634 */   GIR_Done,
     /* 27635 */ // Label 807: @27635
     /* 27635 */ GIM_Reject,
     /* 27636 */ // Label 784: @27636
     /* 27636 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(27666), // Rule ID 18492 //
     /* 27641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 27644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 27647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 27651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 27655 */   // (lrint:{ *:[v8i32] } VR256:{ *:[v8f32] }:$src)  =>  (VCVTPS2DQYrr:{ *:[v8i32] } VR256:{ *:[v8f32] }:$src)
     /* 27655 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQYrr),
     /* 27660 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27664 */   GIR_RootConstrainSelectedInstOperands,
     /* 27665 */   // GIR_Coverage, 18492,
     /* 27665 */   GIR_Done,
     /* 27666 */ // Label 808: @27666
     /* 27666 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(27696), // Rule ID 21805 //
     /* 27671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 27674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 27677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27685 */   // (lrint:{ *:[v8i32] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2DQZ256rr:{ *:[v8i32] } VR256X:{ *:[v8f32] }:$src)
     /* 27685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ256rr),
     /* 27690 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27694 */   GIR_RootConstrainSelectedInstOperands,
     /* 27695 */   // GIR_Coverage, 21805,
     /* 27695 */   GIR_Done,
     /* 27696 */ // Label 809: @27696
     /* 27696 */ GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(27723), // Rule ID 21811 //
     /* 27701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 27704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 27712 */   // (lrint:{ *:[v8i32] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2DQZrr:{ *:[v8i32] } VR512:{ *:[v8f64] }:$src)
     /* 27712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZrr),
     /* 27717 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27721 */   GIR_RootConstrainSelectedInstOperands,
     /* 27722 */   // GIR_Coverage, 21811,
     /* 27722 */   GIR_Done,
     /* 27723 */ // Label 810: @27723
     /* 27723 */ GIM_Reject,
     /* 27724 */ // Label 785: @27724
     /* 27724 */ GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(27754), // Rule ID 21839 //
     /* 27729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 27732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 27735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 27739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27743 */   // (lrint:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2QQZrr:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)
     /* 27743 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrr),
     /* 27748 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27752 */   GIR_RootConstrainSelectedInstOperands,
     /* 27753 */   // GIR_Coverage, 21839,
     /* 27753 */   GIR_Done,
     /* 27754 */ // Label 811: @27754
     /* 27754 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(27784), // Rule ID 21843 //
     /* 27759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 27762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 27765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 27769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 27773 */   // (lrint:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2QQZrr:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)
     /* 27773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrr),
     /* 27778 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27782 */   GIR_RootConstrainSelectedInstOperands,
     /* 27783 */   // GIR_Coverage, 21843,
     /* 27783 */   GIR_Done,
     /* 27784 */ // Label 812: @27784
     /* 27784 */ GIM_Reject,
     /* 27785 */ // Label 786: @27785
     /* 27785 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(27812), // Rule ID 21809 //
     /* 27790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 27793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 27797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 27801 */   // (lrint:{ *:[v16i32] } VR512:{ *:[v16f32] }:$src)  =>  (VCVTPS2DQZrr:{ *:[v16i32] } VR512:{ *:[v16f32] }:$src)
     /* 27801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZrr),
     /* 27806 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27810 */   GIR_RootConstrainSelectedInstOperands,
     /* 27811 */   // GIR_Coverage, 21809,
     /* 27811 */   GIR_Done,
     /* 27812 */ // Label 813: @27812
     /* 27812 */ GIM_Reject,
     /* 27813 */ // Label 787: @27813
     /* 27813 */ GIM_Reject,
     /* 27814 */ // Label 9: @27814
     /* 27814 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 818*/ GIMT_Encode4(28207),
     /* 27825 */ /*GILLT_s64*//*Label 814*/ GIMT_Encode4(27873), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 27841 */ /*GILLT_v2s64*//*Label 815*/ GIMT_Encode4(28054), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 27853 */ /*GILLT_v4s64*//*Label 816*/ GIMT_Encode4(28085), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 27869 */ /*GILLT_v8s64*//*Label 817*/ GIMT_Encode4(28146),
     /* 27873 */ // Label 814: @27873
     /* 27873 */ GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(27903), // Rule ID 1754 //
     /* 27878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 27881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 27884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 27892 */   // (llrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 27892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rr),
     /* 27897 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27901 */   GIR_RootConstrainSelectedInstOperands,
     /* 27902 */   // GIR_Coverage, 1754,
     /* 27902 */   GIR_Done,
     /* 27903 */ // Label 819: @27903
     /* 27903 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(27933), // Rule ID 1758 //
     /* 27908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 27911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 27914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 27922 */   // (llrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 27922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rr),
     /* 27927 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27931 */   GIR_RootConstrainSelectedInstOperands,
     /* 27932 */   // GIR_Coverage, 1758,
     /* 27932 */   GIR_Done,
     /* 27933 */ // Label 820: @27933
     /* 27933 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(27963), // Rule ID 1778 //
     /* 27938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 27941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 27944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 27952 */   // (llrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 27952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rr),
     /* 27957 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27961 */   GIR_RootConstrainSelectedInstOperands,
     /* 27962 */   // GIR_Coverage, 1778,
     /* 27962 */   GIR_Done,
     /* 27963 */ // Label 821: @27963
     /* 27963 */ GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(27993), // Rule ID 1782 //
     /* 27968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 27971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 27974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 27982 */   // (llrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 27982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rr),
     /* 27987 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27991 */   GIR_RootConstrainSelectedInstOperands,
     /* 27992 */   // GIR_Coverage, 1782,
     /* 27992 */   GIR_Done,
     /* 27993 */ // Label 822: @27993
     /* 27993 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(28023), // Rule ID 10351 //
     /* 27998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 28001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 28004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 28008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 28012 */   // (llrint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 28012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrr),
     /* 28017 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28021 */   GIR_RootConstrainSelectedInstOperands,
     /* 28022 */   // GIR_Coverage, 10351,
     /* 28022 */   GIR_Done,
     /* 28023 */ // Label 823: @28023
     /* 28023 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(28053), // Rule ID 10355 //
     /* 28028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 28031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 28034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 28038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 28042 */   // (llrint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 28042 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrr),
     /* 28047 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28051 */   GIR_RootConstrainSelectedInstOperands,
     /* 28052 */   // GIR_Coverage, 10355,
     /* 28052 */   GIR_Done,
     /* 28053 */ // Label 824: @28053
     /* 28053 */ GIM_Reject,
     /* 28054 */ // Label 815: @28054
     /* 28054 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(28084), // Rule ID 21835 //
     /* 28059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 28062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 28065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 28069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 28073 */   // (llrint:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)  =>  (VCVTPD2QQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)
     /* 28073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rr),
     /* 28078 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28082 */   GIR_RootConstrainSelectedInstOperands,
     /* 28083 */   // GIR_Coverage, 21835,
     /* 28083 */   GIR_Done,
     /* 28084 */ // Label 825: @28084
     /* 28084 */ GIM_Reject,
     /* 28085 */ // Label 816: @28085
     /* 28085 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(28115), // Rule ID 21829 //
     /* 28090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 28093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 28096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 28100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 28104 */   // (llrint:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2QQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)
     /* 28104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rr),
     /* 28109 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28113 */   GIR_RootConstrainSelectedInstOperands,
     /* 28114 */   // GIR_Coverage, 21829,
     /* 28114 */   GIR_Done,
     /* 28115 */ // Label 826: @28115
     /* 28115 */ GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(28145), // Rule ID 21837 //
     /* 28120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 28123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 28126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 28130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 28134 */   // (llrint:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2QQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)
     /* 28134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rr),
     /* 28139 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28143 */   GIR_RootConstrainSelectedInstOperands,
     /* 28144 */   // GIR_Coverage, 21837,
     /* 28144 */   GIR_Done,
     /* 28145 */ // Label 827: @28145
     /* 28145 */ GIM_Reject,
     /* 28146 */ // Label 817: @28146
     /* 28146 */ GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(28176), // Rule ID 21841 //
     /* 28151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 28154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 28157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 28161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 28165 */   // (llrint:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2QQZrr:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)
     /* 28165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrr),
     /* 28170 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28174 */   GIR_RootConstrainSelectedInstOperands,
     /* 28175 */   // GIR_Coverage, 21841,
     /* 28175 */   GIR_Done,
     /* 28176 */ // Label 828: @28176
     /* 28176 */ GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(28206), // Rule ID 21845 //
     /* 28181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 28184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 28187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 28191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 28195 */   // (llrint:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2QQZrr:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)
     /* 28195 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrr),
     /* 28200 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28204 */   GIR_RootConstrainSelectedInstOperands,
     /* 28205 */   // GIR_Coverage, 21845,
     /* 28205 */   GIR_Done,
     /* 28206 */ // Label 829: @28206
     /* 28206 */ GIM_Reject,
     /* 28207 */ // Label 818: @28207
     /* 28207 */ GIM_Reject,
     /* 28208 */ // Label 10: @28208
     /* 28208 */ GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(29197),
     /* 28213 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 28216 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(28252), // Rule ID 1526 //
     /* 28221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubwd),
     /* 28229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28243 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14766:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHSUBWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /* 28243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBWDrr),
     /* 28246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28248 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28250 */     GIR_RootConstrainSelectedInstOperands,
     /* 28251 */     // GIR_Coverage, 1526,
     /* 28251 */     GIR_EraseRootFromParent_Done,
     /* 28252 */   // Label 831: @28252
     /* 28252 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(28288), // Rule ID 1528 //
     /* 28257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubdq),
     /* 28265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 28271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28279 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14765:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHSUBDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /* 28279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBDQrr),
     /* 28282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28284 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28286 */     GIR_RootConstrainSelectedInstOperands,
     /* 28287 */     // GIR_Coverage, 1528,
     /* 28287 */     GIR_EraseRootFromParent_Done,
     /* 28288 */   // Label 832: @28288
     /* 28288 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(28324), // Rule ID 1530 //
     /* 28293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubbw),
     /* 28301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 28304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28315 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14764:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHSUBBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /* 28315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBBWrr),
     /* 28318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28320 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28322 */     GIR_RootConstrainSelectedInstOperands,
     /* 28323 */     // GIR_Coverage, 1530,
     /* 28323 */     GIR_EraseRootFromParent_Done,
     /* 28324 */   // Label 833: @28324
     /* 28324 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(28360), // Rule ID 1532 //
     /* 28329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwq),
     /* 28337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28351 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14763:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDWQrr:{ *:[v2i64] } VR128:{ *:[v8i16] }:$src)
     /* 28351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWQrr),
     /* 28354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28356 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28358 */     GIR_RootConstrainSelectedInstOperands,
     /* 28359 */     // GIR_Coverage, 1532,
     /* 28359 */     GIR_EraseRootFromParent_Done,
     /* 28360 */   // Label 834: @28360
     /* 28360 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(28396), // Rule ID 1534 //
     /* 28365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwd),
     /* 28373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28387 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14762:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /* 28387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWDrr),
     /* 28390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28392 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28394 */     GIR_RootConstrainSelectedInstOperands,
     /* 28395 */     // GIR_Coverage, 1534,
     /* 28395 */     GIR_EraseRootFromParent_Done,
     /* 28396 */   // Label 835: @28396
     /* 28396 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(28432), // Rule ID 1536 //
     /* 28401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwq),
     /* 28409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28423 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14761:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDUWQrr:{ *:[v2i64] } VR128:{ *:[v8i16] }:$src)
     /* 28423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWQrr),
     /* 28426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28428 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28430 */     GIR_RootConstrainSelectedInstOperands,
     /* 28431 */     // GIR_Coverage, 1536,
     /* 28431 */     GIR_EraseRootFromParent_Done,
     /* 28432 */   // Label 836: @28432
     /* 28432 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(28468), // Rule ID 1538 //
     /* 28437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwd),
     /* 28445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28459 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14760:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDUWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /* 28459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWDrr),
     /* 28462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28464 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28466 */     GIR_RootConstrainSelectedInstOperands,
     /* 28467 */     // GIR_Coverage, 1538,
     /* 28467 */     GIR_EraseRootFromParent_Done,
     /* 28468 */   // Label 837: @28468
     /* 28468 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(28504), // Rule ID 1540 //
     /* 28473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddudq),
     /* 28481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 28487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28495 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14759:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHADDUDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /* 28495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUDQrr),
     /* 28498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28500 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28502 */     GIR_RootConstrainSelectedInstOperands,
     /* 28503 */     // GIR_Coverage, 1540,
     /* 28503 */     GIR_EraseRootFromParent_Done,
     /* 28504 */   // Label 838: @28504
     /* 28504 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(28540), // Rule ID 1542 //
     /* 28509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubw),
     /* 28517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 28520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28531 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14758:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /* 28531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBWrr),
     /* 28534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28536 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28538 */     GIR_RootConstrainSelectedInstOperands,
     /* 28539 */     // GIR_Coverage, 1542,
     /* 28539 */     GIR_EraseRootFromParent_Done,
     /* 28540 */   // Label 839: @28540
     /* 28540 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(28576), // Rule ID 1544 //
     /* 28545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubq),
     /* 28553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28567 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14757:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBQrr:{ *:[v2i64] } VR128:{ *:[v16i8] }:$src)
     /* 28567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBQrr),
     /* 28570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28572 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28574 */     GIR_RootConstrainSelectedInstOperands,
     /* 28575 */     // GIR_Coverage, 1544,
     /* 28575 */     GIR_EraseRootFromParent_Done,
     /* 28576 */   // Label 840: @28576
     /* 28576 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(28612), // Rule ID 1546 //
     /* 28581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubd),
     /* 28589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28603 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14756:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBDrr:{ *:[v4i32] } VR128:{ *:[v16i8] }:$src)
     /* 28603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBDrr),
     /* 28606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28608 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28610 */     GIR_RootConstrainSelectedInstOperands,
     /* 28611 */     // GIR_Coverage, 1546,
     /* 28611 */     GIR_EraseRootFromParent_Done,
     /* 28612 */   // Label 841: @28612
     /* 28612 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(28648), // Rule ID 1548 //
     /* 28617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadddq),
     /* 28625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 28631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28639 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14755:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHADDDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /* 28639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDDQrr),
     /* 28642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28644 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28646 */     GIR_RootConstrainSelectedInstOperands,
     /* 28647 */     // GIR_Coverage, 1548,
     /* 28647 */     GIR_EraseRootFromParent_Done,
     /* 28648 */   // Label 842: @28648
     /* 28648 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(28684), // Rule ID 1550 //
     /* 28653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbw),
     /* 28661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 28664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28675 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14754:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /* 28675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBWrr),
     /* 28678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28680 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28682 */     GIR_RootConstrainSelectedInstOperands,
     /* 28683 */     // GIR_Coverage, 1550,
     /* 28683 */     GIR_EraseRootFromParent_Done,
     /* 28684 */   // Label 843: @28684
     /* 28684 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(28720), // Rule ID 1552 //
     /* 28689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbq),
     /* 28697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28711 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14753:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBQrr:{ *:[v2i64] } VR128:{ *:[v16i8] }:$src)
     /* 28711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBQrr),
     /* 28714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28716 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28718 */     GIR_RootConstrainSelectedInstOperands,
     /* 28719 */     // GIR_Coverage, 1552,
     /* 28719 */     GIR_EraseRootFromParent_Done,
     /* 28720 */   // Label 844: @28720
     /* 28720 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(28756), // Rule ID 1554 //
     /* 28725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbd),
     /* 28733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28747 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14752:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBDrr:{ *:[v4i32] } VR128:{ *:[v16i8] }:$src)
     /* 28747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBDrr),
     /* 28750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28752 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28754 */     GIR_RootConstrainSelectedInstOperands,
     /* 28755 */     // GIR_Coverage, 1554,
     /* 28755 */     GIR_EraseRootFromParent_Done,
     /* 28756 */   // Label 845: @28756
     /* 28756 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(28792), // Rule ID 1556 //
     /* 28761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ss),
     /* 28769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 28775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28783 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14747:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VFRCZSSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 28783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZSSrr),
     /* 28786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28788 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28790 */     GIR_RootConstrainSelectedInstOperands,
     /* 28791 */     // GIR_Coverage, 1556,
     /* 28791 */     GIR_EraseRootFromParent_Done,
     /* 28792 */   // Label 846: @28792
     /* 28792 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(28828), // Rule ID 1560 //
     /* 28797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps),
     /* 28805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 28811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28819 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14744:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VFRCZPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 28819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSrr),
     /* 28822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28824 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28826 */     GIR_RootConstrainSelectedInstOperands,
     /* 28827 */     // GIR_Coverage, 1560,
     /* 28827 */     GIR_EraseRootFromParent_Done,
     /* 28828 */   // Label 847: @28828
     /* 28828 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(28864), // Rule ID 1562 //
     /* 28833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps_256),
     /* 28841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 28844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 28847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 28851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 28855 */     // (intrinsic_wo_chain:{ *:[v8f32] } 14745:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src)  =>  (VFRCZPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 28855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSYrr),
     /* 28858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28860 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28862 */     GIR_RootConstrainSelectedInstOperands,
     /* 28863 */     // GIR_Coverage, 1562,
     /* 28863 */     GIR_EraseRootFromParent_Done,
     /* 28864 */   // Label 848: @28864
     /* 28864 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(28900), // Rule ID 1564 //
     /* 28869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_sd),
     /* 28877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 28883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28891 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14746:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src)  =>  (VFRCZSDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 28891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZSDrr),
     /* 28894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28896 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28898 */     GIR_RootConstrainSelectedInstOperands,
     /* 28899 */     // GIR_Coverage, 1564,
     /* 28899 */     GIR_EraseRootFromParent_Done,
     /* 28900 */   // Label 849: @28900
     /* 28900 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(28936), // Rule ID 1568 //
     /* 28905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd),
     /* 28913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 28919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28927 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14742:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src)  =>  (VFRCZPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 28927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDrr),
     /* 28930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28932 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28934 */     GIR_RootConstrainSelectedInstOperands,
     /* 28935 */     // GIR_Coverage, 1568,
     /* 28935 */     GIR_EraseRootFromParent_Done,
     /* 28936 */   // Label 850: @28936
     /* 28936 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(28972), // Rule ID 1570 //
     /* 28941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd_256),
     /* 28949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 28952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 28955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 28959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 28963 */     // (intrinsic_wo_chain:{ *:[v4f64] } 14743:{ *:[iPTR] }, VR256:{ *:[v4f64] }:$src)  =>  (VFRCZPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 28963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDYrr),
     /* 28966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28968 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28970 */     GIR_RootConstrainSelectedInstOperands,
     /* 28971 */     // GIR_Coverage, 1570,
     /* 28971 */     GIR_EraseRootFromParent_Done,
     /* 28972 */   // Label 851: @28972
     /* 28972 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(29008), // Rule ID 3360 //
     /* 28977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /* 28980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /* 28985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 28991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28999 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13028:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1)  =>  (VAESIMCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1)
     /* 28999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESIMCrr),
     /* 29002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29004 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29006 */     GIR_RootConstrainSelectedInstOperands,
     /* 29007 */     // GIR_Coverage, 3360,
     /* 29007 */     GIR_EraseRootFromParent_Done,
     /* 29008 */   // Label 852: @29008
     /* 29008 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(29044), // Rule ID 3362 //
     /* 29013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /* 29016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /* 29021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 29024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 29027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29035 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13028:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1)  =>  (AESIMCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1)
     /* 29035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESIMCrr),
     /* 29038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29040 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29042 */     GIR_RootConstrainSelectedInstOperands,
     /* 29043 */     // GIR_Coverage, 3362,
     /* 29043 */     GIR_EraseRootFromParent_Done,
     /* 29044 */   // Label 853: @29044
     /* 29044 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(29082), // Rule ID 18713 //
     /* 29049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 29052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rsqrt_ss),
     /* 29057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29071 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14452:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (RSQRTSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /* 29071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RSQRTSSr_Int),
     /* 29074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29076 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29078 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29080 */     GIR_RootConstrainSelectedInstOperands,
     /* 29081 */     // GIR_Coverage, 18713,
     /* 29081 */     GIR_EraseRootFromParent_Done,
     /* 29082 */   // Label 854: @29082
     /* 29082 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(29120), // Rule ID 18717 //
     /* 29087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 29090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rsqrt_ss),
     /* 29095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29109 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14452:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VRSQRTSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /* 29109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VRSQRTSSr_Int),
     /* 29112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29114 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29116 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29118 */     GIR_RootConstrainSelectedInstOperands,
     /* 29119 */     // GIR_Coverage, 18717,
     /* 29119 */     GIR_EraseRootFromParent_Done,
     /* 29120 */   // Label 855: @29120
     /* 29120 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(29158), // Rule ID 18733 //
     /* 29125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 29128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rcp_ss),
     /* 29133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29147 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14450:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (RCPSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /* 29147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RCPSSr_Int),
     /* 29150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29152 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29154 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29156 */     GIR_RootConstrainSelectedInstOperands,
     /* 29157 */     // GIR_Coverage, 18733,
     /* 29157 */     GIR_EraseRootFromParent_Done,
     /* 29158 */   // Label 856: @29158
     /* 29158 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(29196), // Rule ID 18737 //
     /* 29163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 29166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rcp_ss),
     /* 29171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29185 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14450:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VRCPSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /* 29185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VRCPSSr_Int),
     /* 29188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29190 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29192 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29194 */     GIR_RootConstrainSelectedInstOperands,
     /* 29195 */     // GIR_Coverage, 18737,
     /* 29195 */     GIR_EraseRootFromParent_Done,
     /* 29196 */   // Label 857: @29196
     /* 29196 */   GIM_Reject,
     /* 29197 */ // Label 830: @29197
     /* 29197 */ GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(32258),
     /* 29202 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 29205 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(29246), // Rule ID 3364 //
     /* 29210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /* 29213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /* 29218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 29221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 29224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29232 */     // MIs[0] src2
     /* 29232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 29235 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13029:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)  =>  (VAESKEYGENASSIST128rr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)
     /* 29235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESKEYGENASSIST128rr),
     /* 29238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29240 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29242 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29244 */     GIR_RootConstrainSelectedInstOperands,
     /* 29245 */     // GIR_Coverage, 3364,
     /* 29245 */     GIR_EraseRootFromParent_Done,
     /* 29246 */   // Label 859: @29246
     /* 29246 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(29287), // Rule ID 3366 //
     /* 29251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /* 29254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /* 29259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 29262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 29265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29273 */     // MIs[0] src2
     /* 29273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 29276 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13029:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)  =>  (AESKEYGENASSIST128rr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)
     /* 29276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESKEYGENASSIST128rr),
     /* 29279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29281 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29283 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29285 */     GIR_RootConstrainSelectedInstOperands,
     /* 29286 */     // GIR_Coverage, 3366,
     /* 29286 */     GIR_EraseRootFromParent_Done,
     /* 29287 */   // Label 860: @29287
     /* 29287 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(29332), // Rule ID 17236 //
     /* 29292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /* 29295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /* 29300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 29309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 29313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 29317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 29321 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14721:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VSM4KEY4Z128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 29321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z128rr),
     /* 29324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29326 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29328 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29330 */     GIR_RootConstrainSelectedInstOperands,
     /* 29331 */     // GIR_Coverage, 17236,
     /* 29331 */     GIR_EraseRootFromParent_Done,
     /* 29332 */   // Label 861: @29332
     /* 29332 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(29377), // Rule ID 17238 //
     /* 29337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /* 29340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /* 29345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 29348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 29351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 29354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 29358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 29362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 29366 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14722:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VSM4KEY4Z256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 29366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z256rr),
     /* 29369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29371 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29373 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29375 */     GIR_RootConstrainSelectedInstOperands,
     /* 29376 */     // GIR_Coverage, 17238,
     /* 29376 */     GIR_EraseRootFromParent_Done,
     /* 29377 */   // Label 862: @29377
     /* 29377 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(29422), // Rule ID 17242 //
     /* 29382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /* 29385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /* 29390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 29399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 29403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 29407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 29411 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14724:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VSM4RNDS4Z128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 29411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z128rr),
     /* 29414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29416 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29418 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29420 */     GIR_RootConstrainSelectedInstOperands,
     /* 29421 */     // GIR_Coverage, 17242,
     /* 29421 */     GIR_EraseRootFromParent_Done,
     /* 29422 */   // Label 863: @29422
     /* 29422 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(29467), // Rule ID 17244 //
     /* 29427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /* 29430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /* 29435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 29438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 29441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 29444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 29448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 29452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 29456 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14725:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VSM4RNDS4Z256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 29456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z256rr),
     /* 29459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29461 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29463 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29465 */     GIR_RootConstrainSelectedInstOperands,
     /* 29466 */     // GIR_Coverage, 17244,
     /* 29466 */     GIR_EraseRootFromParent_Done,
     /* 29467 */   // Label 864: @29467
     /* 29467 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(29512), // Rule ID 3019 //
     /* 29472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 29475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /* 29480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 29483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 29486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 29489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29501 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14590:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSIGNBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 29501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBrr),
     /* 29504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29506 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29508 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29510 */     GIR_RootConstrainSelectedInstOperands,
     /* 29511 */     // GIR_Coverage, 3019,
     /* 29511 */     GIR_EraseRootFromParent_Done,
     /* 29512 */   // Label 865: @29512
     /* 29512 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(29557), // Rule ID 3021 //
     /* 29517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 29520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /* 29525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 29528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 29531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 29534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29546 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14594:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSIGNWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 29546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWrr),
     /* 29549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29551 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29553 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29555 */     GIR_RootConstrainSelectedInstOperands,
     /* 29556 */     // GIR_Coverage, 3021,
     /* 29556 */     GIR_EraseRootFromParent_Done,
     /* 29557 */   // Label 866: @29557
     /* 29557 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(29602), // Rule ID 3023 //
     /* 29562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 29565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /* 29570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 29579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29591 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14592:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPSIGNDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 29591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDrr),
     /* 29594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29596 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29598 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29600 */     GIR_RootConstrainSelectedInstOperands,
     /* 29601 */     // GIR_Coverage, 3023,
     /* 29601 */     GIR_EraseRootFromParent_Done,
     /* 29602 */   // Label 867: @29602
     /* 29602 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(29647), // Rule ID 3025 //
     /* 29607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 29610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /* 29615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 29618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 29621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 29624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29636 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14574:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPHADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 29636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWrr),
     /* 29639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29641 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29643 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29645 */     GIR_RootConstrainSelectedInstOperands,
     /* 29646 */     // GIR_Coverage, 3025,
     /* 29646 */     GIR_EraseRootFromParent_Done,
     /* 29647 */   // Label 868: @29647
     /* 29647 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(29692), // Rule ID 3027 //
     /* 29652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 29655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /* 29660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 29663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 29666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 29669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29681 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14580:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPHSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 29681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWrr),
     /* 29684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29686 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29688 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29690 */     GIR_RootConstrainSelectedInstOperands,
     /* 29691 */     // GIR_Coverage, 3027,
     /* 29691 */     GIR_EraseRootFromParent_Done,
     /* 29692 */   // Label 869: @29692
     /* 29692 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(29737), // Rule ID 3043 //
     /* 29697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 29700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_b),
     /* 29705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /* 29708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 29711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 29714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29726 */     // (intrinsic_wo_chain:{ *:[v32i8] } 13481:{ *:[iPTR] }, VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSIGNBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 29726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBYrr),
     /* 29729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29731 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29733 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29735 */     GIR_RootConstrainSelectedInstOperands,
     /* 29736 */     // GIR_Coverage, 3043,
     /* 29736 */     GIR_EraseRootFromParent_Done,
     /* 29737 */   // Label 870: @29737
     /* 29737 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(29782), // Rule ID 3045 //
     /* 29742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 29745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_w),
     /* 29750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 29753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 29756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 29759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29771 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13483:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSIGNWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 29771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWYrr),
     /* 29774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29776 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29778 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29780 */     GIR_RootConstrainSelectedInstOperands,
     /* 29781 */     // GIR_Coverage, 3045,
     /* 29781 */     GIR_EraseRootFromParent_Done,
     /* 29782 */   // Label 871: @29782
     /* 29782 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(29827), // Rule ID 3047 //
     /* 29787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 29790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_d),
     /* 29795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 29798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 29801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 29804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29816 */     // (intrinsic_wo_chain:{ *:[v8i32] } 13482:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPSIGNDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 29816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDYrr),
     /* 29819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29821 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29823 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29825 */     GIR_RootConstrainSelectedInstOperands,
     /* 29826 */     // GIR_Coverage, 3047,
     /* 29826 */     GIR_EraseRootFromParent_Done,
     /* 29827 */   // Label 872: @29827
     /* 29827 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(29872), // Rule ID 3049 //
     /* 29832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 29835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phadd_sw),
     /* 29840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 29843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 29846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 29849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29861 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13468:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPHADDSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 29861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWYrr),
     /* 29864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29866 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29868 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29870 */     GIR_RootConstrainSelectedInstOperands,
     /* 29871 */     // GIR_Coverage, 3049,
     /* 29871 */     GIR_EraseRootFromParent_Done,
     /* 29872 */   // Label 873: @29872
     /* 29872 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(29917), // Rule ID 3051 //
     /* 29877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 29880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phsub_sw),
     /* 29885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 29888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 29891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 29894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29906 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13471:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPHSUBSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 29906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWYrr),
     /* 29909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29911 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29913 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29915 */     GIR_RootConstrainSelectedInstOperands,
     /* 29916 */     // GIR_Coverage, 3051,
     /* 29916 */     GIR_EraseRootFromParent_Done,
     /* 29917 */   // Label 874: @29917
     /* 29917 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(29962), // Rule ID 3061 //
     /* 29922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 29925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /* 29930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 29933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 29936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 29939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29951 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14590:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSIGNBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 29951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNBrr),
     /* 29954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29956 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29958 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29960 */     GIR_RootConstrainSelectedInstOperands,
     /* 29961 */     // GIR_Coverage, 3061,
     /* 29961 */     GIR_EraseRootFromParent_Done,
     /* 29962 */   // Label 875: @29962
     /* 29962 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(30007), // Rule ID 3063 //
     /* 29967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 29970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /* 29975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 29978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 29981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 29984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29996 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14594:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSIGNWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 29996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNWrr),
     /* 29999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30001 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30003 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30005 */     GIR_RootConstrainSelectedInstOperands,
     /* 30006 */     // GIR_Coverage, 3063,
     /* 30006 */     GIR_EraseRootFromParent_Done,
     /* 30007 */   // Label 876: @30007
     /* 30007 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(30052), // Rule ID 3065 //
     /* 30012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 30015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /* 30020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30041 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14592:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PSIGNDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 30041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNDrr),
     /* 30044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30046 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30048 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30050 */     GIR_RootConstrainSelectedInstOperands,
     /* 30051 */     // GIR_Coverage, 3065,
     /* 30051 */     GIR_EraseRootFromParent_Done,
     /* 30052 */   // Label 877: @30052
     /* 30052 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(30097), // Rule ID 3069 //
     /* 30057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 30060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /* 30065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30086 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14574:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PHADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 30086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PHADDSWrr),
     /* 30089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30091 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30093 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30095 */     GIR_RootConstrainSelectedInstOperands,
     /* 30096 */     // GIR_Coverage, 3069,
     /* 30096 */     GIR_EraseRootFromParent_Done,
     /* 30097 */   // Label 878: @30097
     /* 30097 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(30142), // Rule ID 3071 //
     /* 30102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 30105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /* 30110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30131 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14580:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PHSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 30131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PHSUBSWrr),
     /* 30134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30136 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30138 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30140 */     GIR_RootConstrainSelectedInstOperands,
     /* 30141 */     // GIR_Coverage, 3071,
     /* 30141 */     GIR_EraseRootFromParent_Done,
     /* 30142 */   // Label 879: @30142
     /* 30142 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(30187), // Rule ID 3306 //
     /* 30147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /* 30150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /* 30155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 30164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 30176 */     // (intrinsic_wo_chain:{ *:[i32] } 14548:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (CRC32r32r8:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)
     /* 30176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r8),
     /* 30179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30181 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30183 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30185 */     GIR_RootConstrainSelectedInstOperands,
     /* 30186 */     // GIR_Coverage, 3306,
     /* 30186 */     GIR_EraseRootFromParent_Done,
     /* 30187 */   // Label 880: @30187
     /* 30187 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(30232), // Rule ID 3308 //
     /* 30192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /* 30195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /* 30200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 30209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 30221 */     // (intrinsic_wo_chain:{ *:[i32] } 14546:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (CRC32r32r16:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)
     /* 30221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r16),
     /* 30224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30226 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30228 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30230 */     GIR_RootConstrainSelectedInstOperands,
     /* 30231 */     // GIR_Coverage, 3308,
     /* 30231 */     GIR_EraseRootFromParent_Done,
     /* 30232 */   // Label 881: @30232
     /* 30232 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(30277), // Rule ID 3310 //
     /* 30237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /* 30240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /* 30245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30266 */     // (intrinsic_wo_chain:{ *:[i32] } 14547:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (CRC32r32r32:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 30266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r32),
     /* 30269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30271 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30273 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30275 */     GIR_RootConstrainSelectedInstOperands,
     /* 30276 */     // GIR_Coverage, 3310,
     /* 30276 */     GIR_EraseRootFromParent_Done,
     /* 30277 */   // Label 882: @30277
     /* 30277 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(30322), // Rule ID 3312 //
     /* 30282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /* 30285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /* 30290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 30293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 30296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 30299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 30303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 30307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 30311 */     // (intrinsic_wo_chain:{ *:[i64] } 14549:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (CRC32r64r64:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 30311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64r64),
     /* 30314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30316 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30318 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30320 */     GIR_RootConstrainSelectedInstOperands,
     /* 30321 */     // GIR_Coverage, 3312,
     /* 30321 */     GIR_EraseRootFromParent_Done,
     /* 30322 */   // Label 883: @30322
     /* 30322 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(30367), // Rule ID 3314 //
     /* 30327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /* 30330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /* 30335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 30344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 30356 */     // (intrinsic_wo_chain:{ *:[i32] } 14548:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (CRC32r32r8_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)
     /* 30356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r8_EVEX),
     /* 30359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30361 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30363 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30365 */     GIR_RootConstrainSelectedInstOperands,
     /* 30366 */     // GIR_Coverage, 3314,
     /* 30366 */     GIR_EraseRootFromParent_Done,
     /* 30367 */   // Label 884: @30367
     /* 30367 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(30412), // Rule ID 3316 //
     /* 30372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /* 30375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /* 30380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 30389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 30401 */     // (intrinsic_wo_chain:{ *:[i32] } 14546:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (CRC32r32r16_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)
     /* 30401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r16_EVEX),
     /* 30404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30406 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30408 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30410 */     GIR_RootConstrainSelectedInstOperands,
     /* 30411 */     // GIR_Coverage, 3316,
     /* 30411 */     GIR_EraseRootFromParent_Done,
     /* 30412 */   // Label 885: @30412
     /* 30412 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(30457), // Rule ID 3318 //
     /* 30417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /* 30420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /* 30425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30446 */     // (intrinsic_wo_chain:{ *:[i32] } 14547:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (CRC32r32r32_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 30446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r32_EVEX),
     /* 30449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30453 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30455 */     GIR_RootConstrainSelectedInstOperands,
     /* 30456 */     // GIR_Coverage, 3318,
     /* 30456 */     GIR_EraseRootFromParent_Done,
     /* 30457 */   // Label 886: @30457
     /* 30457 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(30502), // Rule ID 3320 //
     /* 30462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /* 30465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /* 30470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 30473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 30476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 30479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 30483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 30487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 30491 */     // (intrinsic_wo_chain:{ *:[i64] } 14549:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (CRC32r64r64_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 30491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64r64_EVEX),
     /* 30494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30496 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30498 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30500 */     GIR_RootConstrainSelectedInstOperands,
     /* 30501 */     // GIR_Coverage, 3320,
     /* 30501 */     GIR_EraseRootFromParent_Done,
     /* 30502 */   // Label 887: @30502
     /* 30502 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(30547), // Rule ID 3324 //
     /* 30507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 30510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1nexte),
     /* 30515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30536 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14418:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1NEXTErr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 30536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1NEXTErr),
     /* 30539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30541 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30543 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30545 */     GIR_RootConstrainSelectedInstOperands,
     /* 30546 */     // GIR_Coverage, 3324,
     /* 30546 */     GIR_EraseRootFromParent_Done,
     /* 30547 */   // Label 888: @30547
     /* 30547 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(30592), // Rule ID 3326 //
     /* 30552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 30555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1msg1),
     /* 30560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30581 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14416:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 30581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1MSG1rr),
     /* 30584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30586 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30588 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30590 */     GIR_RootConstrainSelectedInstOperands,
     /* 30591 */     // GIR_Coverage, 3326,
     /* 30591 */     GIR_EraseRootFromParent_Done,
     /* 30592 */   // Label 889: @30592
     /* 30592 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(30637), // Rule ID 3328 //
     /* 30597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 30600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1msg2),
     /* 30605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30626 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14417:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 30626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1MSG2rr),
     /* 30629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30631 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30633 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30635 */     GIR_RootConstrainSelectedInstOperands,
     /* 30636 */     // GIR_Coverage, 3328,
     /* 30636 */     GIR_EraseRootFromParent_Done,
     /* 30637 */   // Label 890: @30637
     /* 30637 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(30682), // Rule ID 3332 //
     /* 30642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 30645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256msg1),
     /* 30650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30671 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14420:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA256MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 30671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256MSG1rr),
     /* 30674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30676 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30678 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30680 */     GIR_RootConstrainSelectedInstOperands,
     /* 30681 */     // GIR_Coverage, 3332,
     /* 30681 */     GIR_EraseRootFromParent_Done,
     /* 30682 */   // Label 891: @30682
     /* 30682 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(30727), // Rule ID 3334 //
     /* 30687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 30690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256msg2),
     /* 30695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30716 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14421:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA256MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 30716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256MSG2rr),
     /* 30719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30721 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30723 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30725 */     GIR_RootConstrainSelectedInstOperands,
     /* 30726 */     // GIR_Coverage, 3334,
     /* 30726 */     GIR_EraseRootFromParent_Done,
     /* 30727 */   // Label 892: @30727
     /* 30727 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(30772), // Rule ID 3336 //
     /* 30732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /* 30735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /* 30740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 30743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 30746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 30749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30761 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13022:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESENCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 30761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCrr),
     /* 30764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30766 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30768 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30770 */     GIR_RootConstrainSelectedInstOperands,
     /* 30771 */     // GIR_Coverage, 3336,
     /* 30771 */     GIR_EraseRootFromParent_Done,
     /* 30772 */   // Label 893: @30772
     /* 30772 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(30817), // Rule ID 3338 //
     /* 30777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /* 30780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /* 30785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 30788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 30791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 30794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30806 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13025:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESENCLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 30806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTrr),
     /* 30809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30811 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30813 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30815 */     GIR_RootConstrainSelectedInstOperands,
     /* 30816 */     // GIR_Coverage, 3338,
     /* 30816 */     GIR_EraseRootFromParent_Done,
     /* 30817 */   // Label 894: @30817
     /* 30817 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(30862), // Rule ID 3340 //
     /* 30822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /* 30825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /* 30830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 30833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 30836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 30839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30851 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13016:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESDECrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 30851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECrr),
     /* 30854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30856 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30858 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30860 */     GIR_RootConstrainSelectedInstOperands,
     /* 30861 */     // GIR_Coverage, 3340,
     /* 30861 */     GIR_EraseRootFromParent_Done,
     /* 30862 */   // Label 895: @30862
     /* 30862 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(30907), // Rule ID 3342 //
     /* 30867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /* 30870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /* 30875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 30878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 30881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 30884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30896 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13019:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESDECLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 30896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTrr),
     /* 30899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30901 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30903 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30905 */     GIR_RootConstrainSelectedInstOperands,
     /* 30906 */     // GIR_Coverage, 3342,
     /* 30906 */     GIR_EraseRootFromParent_Done,
     /* 30907 */   // Label 896: @30907
     /* 30907 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(30952), // Rule ID 3344 //
     /* 30912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /* 30915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /* 30920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 30923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 30926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 30929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30941 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13023:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESENCYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 30941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCYrr),
     /* 30944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30946 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30948 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30950 */     GIR_RootConstrainSelectedInstOperands,
     /* 30951 */     // GIR_Coverage, 3344,
     /* 30951 */     GIR_EraseRootFromParent_Done,
     /* 30952 */   // Label 897: @30952
     /* 30952 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(30997), // Rule ID 3346 //
     /* 30957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /* 30960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /* 30965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 30968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 30971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 30974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30986 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13026:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESENCLASTYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 30986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTYrr),
     /* 30989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30991 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30993 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30995 */     GIR_RootConstrainSelectedInstOperands,
     /* 30996 */     // GIR_Coverage, 3346,
     /* 30996 */     GIR_EraseRootFromParent_Done,
     /* 30997 */   // Label 898: @30997
     /* 30997 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(31042), // Rule ID 3348 //
     /* 31002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /* 31005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /* 31010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 31013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 31016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 31019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31031 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13017:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESDECYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 31031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECYrr),
     /* 31034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31036 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31038 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31040 */     GIR_RootConstrainSelectedInstOperands,
     /* 31041 */     // GIR_Coverage, 3348,
     /* 31041 */     GIR_EraseRootFromParent_Done,
     /* 31042 */   // Label 899: @31042
     /* 31042 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(31087), // Rule ID 3350 //
     /* 31047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /* 31050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /* 31055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 31058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 31061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 31064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31076 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13020:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESDECLASTYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 31076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTYrr),
     /* 31079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31081 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31083 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31085 */     GIR_RootConstrainSelectedInstOperands,
     /* 31086 */     // GIR_Coverage, 3350,
     /* 31086 */     GIR_EraseRootFromParent_Done,
     /* 31087 */   // Label 900: @31087
     /* 31087 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(31132), // Rule ID 3352 //
     /* 31092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /* 31095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /* 31100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31121 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13022:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESENCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 31121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESENCrr),
     /* 31124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31126 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31128 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31130 */     GIR_RootConstrainSelectedInstOperands,
     /* 31131 */     // GIR_Coverage, 3352,
     /* 31131 */     GIR_EraseRootFromParent_Done,
     /* 31132 */   // Label 901: @31132
     /* 31132 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(31177), // Rule ID 3354 //
     /* 31137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /* 31140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /* 31145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31166 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13025:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESENCLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 31166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESENCLASTrr),
     /* 31169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31171 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31173 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31175 */     GIR_RootConstrainSelectedInstOperands,
     /* 31176 */     // GIR_Coverage, 3354,
     /* 31176 */     GIR_EraseRootFromParent_Done,
     /* 31177 */   // Label 902: @31177
     /* 31177 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(31222), // Rule ID 3356 //
     /* 31182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /* 31185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /* 31190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31211 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13016:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESDECrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 31211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESDECrr),
     /* 31214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31216 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31218 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31220 */     GIR_RootConstrainSelectedInstOperands,
     /* 31221 */     // GIR_Coverage, 3356,
     /* 31221 */     GIR_EraseRootFromParent_Done,
     /* 31222 */   // Label 903: @31222
     /* 31222 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(31267), // Rule ID 3358 //
     /* 31227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /* 31230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /* 31235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31256 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13019:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESDECLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 31256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESDECLASTrr),
     /* 31259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31261 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31263 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31265 */     GIR_RootConstrainSelectedInstOperands,
     /* 31266 */     // GIR_Coverage, 3358,
     /* 31266 */     GIR_EraseRootFromParent_Done,
     /* 31267 */   // Label 904: @31267
     /* 31267 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(31312), // Rule ID 3375 //
     /* 31272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE4A),
     /* 31275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse4a_extrq),
     /* 31280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31301 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14564:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src, VR128:{ *:[v16i8] }:$mask)  =>  (EXTRQ:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 31301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::EXTRQ),
     /* 31304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31306 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 31308 */     GIR_RootToRootCopy, /*OpIdx*/3, // mask
     /* 31310 */     GIR_RootConstrainSelectedInstOperands,
     /* 31311 */     // GIR_Coverage, 3375,
     /* 31311 */     GIR_EraseRootFromParent_Done,
     /* 31312 */   // Label 905: @31312
     /* 31312 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(31357), // Rule ID 3377 //
     /* 31317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE4A),
     /* 31320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse4a_insertq),
     /* 31325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31346 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14566:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src, VR128:{ *:[v2i64] }:$mask)  =>  (INSERTQ:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src, VR128:{ *:[v2i64] }:$mask)
     /* 31346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INSERTQ),
     /* 31349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31351 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 31353 */     GIR_RootToRootCopy, /*OpIdx*/3, // mask
     /* 31355 */     GIR_RootConstrainSelectedInstOperands,
     /* 31356 */     // GIR_Coverage, 3377,
     /* 31356 */     GIR_EraseRootFromParent_Done,
     /* 31357 */   // Label 906: @31357
     /* 31357 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(31402), // Rule ID 3552 //
     /* 31362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /* 31365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512msg1),
     /* 31370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 31373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 31376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31391 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14715:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VSHA512MSG1rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 31391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512MSG1rr),
     /* 31394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31396 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31398 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31400 */     GIR_RootConstrainSelectedInstOperands,
     /* 31401 */     // GIR_Coverage, 3552,
     /* 31401 */     GIR_EraseRootFromParent_Done,
     /* 31402 */   // Label 907: @31402
     /* 31402 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(31447), // Rule ID 3553 //
     /* 31407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /* 31410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512msg2),
     /* 31415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 31418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 31421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 31424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31436 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14716:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VSHA512MSG2rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 31436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512MSG2rr),
     /* 31439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31441 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31443 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31445 */     GIR_RootConstrainSelectedInstOperands,
     /* 31446 */     // GIR_Coverage, 3553,
     /* 31446 */     GIR_EraseRootFromParent_Done,
     /* 31447 */   // Label 908: @31447
     /* 31447 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(31492), // Rule ID 3561 //
     /* 31452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 31455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /* 31460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31481 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14721:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VSM4KEY4rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 31481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4rr),
     /* 31484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31486 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31488 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31490 */     GIR_RootConstrainSelectedInstOperands,
     /* 31491 */     // GIR_Coverage, 3561,
     /* 31491 */     GIR_EraseRootFromParent_Done,
     /* 31492 */   // Label 909: @31492
     /* 31492 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(31537), // Rule ID 3563 //
     /* 31497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 31500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /* 31505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 31508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 31511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 31514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31526 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14722:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VSM4KEY4Yrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 31526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Yrr),
     /* 31529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31531 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31533 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31535 */     GIR_RootConstrainSelectedInstOperands,
     /* 31536 */     // GIR_Coverage, 3563,
     /* 31536 */     GIR_EraseRootFromParent_Done,
     /* 31537 */   // Label 910: @31537
     /* 31537 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(31582), // Rule ID 3565 //
     /* 31542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 31545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /* 31550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31571 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14724:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VSM4RNDS4rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 31571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4rr),
     /* 31574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31576 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31578 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31580 */     GIR_RootConstrainSelectedInstOperands,
     /* 31581 */     // GIR_Coverage, 3565,
     /* 31581 */     GIR_EraseRootFromParent_Done,
     /* 31582 */   // Label 911: @31582
     /* 31582 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(31627), // Rule ID 3567 //
     /* 31587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 31590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /* 31595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 31598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 31601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 31604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31616 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14725:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VSM4RNDS4Yrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 31616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Yrr),
     /* 31619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31621 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31623 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31625 */     GIR_RootConstrainSelectedInstOperands,
     /* 31626 */     // GIR_Coverage, 3567,
     /* 31626 */     GIR_EraseRootFromParent_Done,
     /* 31627 */   // Label 912: @31627
     /* 31627 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(31672), // Rule ID 14057 //
     /* 31632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /* 31635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /* 31640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 31653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 31657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 31661 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13022:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESENCZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 31661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ128rr),
     /* 31664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31666 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31668 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31670 */     GIR_RootConstrainSelectedInstOperands,
     /* 31671 */     // GIR_Coverage, 14057,
     /* 31671 */     GIR_EraseRootFromParent_Done,
     /* 31672 */   // Label 913: @31672
     /* 31672 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(31717), // Rule ID 14059 //
     /* 31677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /* 31680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /* 31685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 31688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 31691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 31694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 31698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 31702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 31706 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13023:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESENCZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 31706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ256rr),
     /* 31709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31711 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31713 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31715 */     GIR_RootConstrainSelectedInstOperands,
     /* 31716 */     // GIR_Coverage, 14059,
     /* 31716 */     GIR_EraseRootFromParent_Done,
     /* 31717 */   // Label 914: @31717
     /* 31717 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(31762), // Rule ID 14061 //
     /* 31722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /* 31725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_512),
     /* 31730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /* 31733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 31736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 31739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 31743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 31747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 31751 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13024:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESENCZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 31751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZrr),
     /* 31754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31756 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31758 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31760 */     GIR_RootConstrainSelectedInstOperands,
     /* 31761 */     // GIR_Coverage, 14061,
     /* 31761 */     GIR_EraseRootFromParent_Done,
     /* 31762 */   // Label 915: @31762
     /* 31762 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(31807), // Rule ID 14063 //
     /* 31767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /* 31770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /* 31775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 31788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 31792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 31796 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13025:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESENCLASTZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 31796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ128rr),
     /* 31799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31801 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31803 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31805 */     GIR_RootConstrainSelectedInstOperands,
     /* 31806 */     // GIR_Coverage, 14063,
     /* 31806 */     GIR_EraseRootFromParent_Done,
     /* 31807 */   // Label 916: @31807
     /* 31807 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(31852), // Rule ID 14065 //
     /* 31812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /* 31815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /* 31820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 31823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 31826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 31829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 31833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 31837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 31841 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13026:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESENCLASTZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 31841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ256rr),
     /* 31844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31846 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31848 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31850 */     GIR_RootConstrainSelectedInstOperands,
     /* 31851 */     // GIR_Coverage, 14065,
     /* 31851 */     GIR_EraseRootFromParent_Done,
     /* 31852 */   // Label 917: @31852
     /* 31852 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(31897), // Rule ID 14067 //
     /* 31857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /* 31860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_512),
     /* 31865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /* 31868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 31871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 31874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 31878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 31882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 31886 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13027:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESENCLASTZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 31886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZrr),
     /* 31889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31891 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31893 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31895 */     GIR_RootConstrainSelectedInstOperands,
     /* 31896 */     // GIR_Coverage, 14067,
     /* 31896 */     GIR_EraseRootFromParent_Done,
     /* 31897 */   // Label 918: @31897
     /* 31897 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(31942), // Rule ID 14069 //
     /* 31902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /* 31905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /* 31910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 31923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 31927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 31931 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13016:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESDECZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 31931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ128rr),
     /* 31934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31936 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31938 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31940 */     GIR_RootConstrainSelectedInstOperands,
     /* 31941 */     // GIR_Coverage, 14069,
     /* 31941 */     GIR_EraseRootFromParent_Done,
     /* 31942 */   // Label 919: @31942
     /* 31942 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(31987), // Rule ID 14071 //
     /* 31947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /* 31950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /* 31955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 31958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 31961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 31964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 31968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 31972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 31976 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13017:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESDECZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 31976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ256rr),
     /* 31979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31981 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31983 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31985 */     GIR_RootConstrainSelectedInstOperands,
     /* 31986 */     // GIR_Coverage, 14071,
     /* 31986 */     GIR_EraseRootFromParent_Done,
     /* 31987 */   // Label 920: @31987
     /* 31987 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(32032), // Rule ID 14073 //
     /* 31992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /* 31995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_512),
     /* 32000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /* 32003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 32006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 32009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32021 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13018:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESDECZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 32021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZrr),
     /* 32024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32026 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32028 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32030 */     GIR_RootConstrainSelectedInstOperands,
     /* 32031 */     // GIR_Coverage, 14073,
     /* 32031 */     GIR_EraseRootFromParent_Done,
     /* 32032 */   // Label 921: @32032
     /* 32032 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(32077), // Rule ID 14075 //
     /* 32037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /* 32040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /* 32045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32066 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13019:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESDECLASTZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 32066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ128rr),
     /* 32069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32071 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32073 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32075 */     GIR_RootConstrainSelectedInstOperands,
     /* 32076 */     // GIR_Coverage, 14075,
     /* 32076 */     GIR_EraseRootFromParent_Done,
     /* 32077 */   // Label 922: @32077
     /* 32077 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(32122), // Rule ID 14077 //
     /* 32082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /* 32085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /* 32090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 32093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 32096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 32099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32111 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13020:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESDECLASTZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 32111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ256rr),
     /* 32114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32116 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32118 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32120 */     GIR_RootConstrainSelectedInstOperands,
     /* 32121 */     // GIR_Coverage, 14077,
     /* 32121 */     GIR_EraseRootFromParent_Done,
     /* 32122 */   // Label 923: @32122
     /* 32122 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(32167), // Rule ID 14079 //
     /* 32127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /* 32130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_512),
     /* 32135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /* 32138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 32141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 32144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32156 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13021:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESDECLASTZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 32156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZrr),
     /* 32159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32161 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32163 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32165 */     GIR_RootConstrainSelectedInstOperands,
     /* 32166 */     // GIR_Coverage, 14079,
     /* 32166 */     GIR_EraseRootFromParent_Done,
     /* 32167 */   // Label 924: @32167
     /* 32167 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(32212), // Rule ID 17240 //
     /* 32172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /* 32175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4512),
     /* 32180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 32183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 32186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 32189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32201 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14723:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VSM4KEY4Zrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 32201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Zrr),
     /* 32204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32206 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32208 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32210 */     GIR_RootConstrainSelectedInstOperands,
     /* 32211 */     // GIR_Coverage, 17240,
     /* 32211 */     GIR_EraseRootFromParent_Done,
     /* 32212 */   // Label 925: @32212
     /* 32212 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(32257), // Rule ID 17246 //
     /* 32217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /* 32220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4512),
     /* 32225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 32228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 32231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 32234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32246 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14726:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VSM4RNDS4Zrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 32246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Zrr),
     /* 32249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32251 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32253 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32255 */     GIR_RootConstrainSelectedInstOperands,
     /* 32256 */     // GIR_Coverage, 17246,
     /* 32256 */     GIR_EraseRootFromParent_Done,
     /* 32257 */   // Label 926: @32257
     /* 32257 */   GIM_Reject,
     /* 32258 */ // Label 858: @32258
     /* 32258 */ GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(33743),
     /* 32263 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 32266 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(32316), // Rule ID 3250 //
     /* 32271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoAVX10_2),
     /* 32274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /* 32279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 32282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 32285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 32288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32300 */     // MIs[0] src3
     /* 32300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32303 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14533:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrri:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrri),
     /* 32306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32308 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32310 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32312 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32314 */     GIR_RootConstrainSelectedInstOperands,
     /* 32315 */     // GIR_Coverage, 3250,
     /* 32315 */     GIR_EraseRootFromParent_Done,
     /* 32316 */   // Label 928: @32316
     /* 32316 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(32366), // Rule ID 3252 //
     /* 32321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoAVX10_2),
     /* 32324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /* 32329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32350 */     // MIs[0] src3
     /* 32350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32353 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14532:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrri:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrri),
     /* 32356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32358 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32360 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32362 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32364 */     GIR_RootConstrainSelectedInstOperands,
     /* 32365 */     // GIR_Coverage, 3252,
     /* 32365 */     GIR_EraseRootFromParent_Done,
     /* 32366 */   // Label 929: @32366
     /* 32366 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(32416), // Rule ID 3254 //
     /* 32371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoAVX10_2),
     /* 32374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /* 32379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 32382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 32385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 32388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 32392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 32396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 32400 */     // MIs[0] src3
     /* 32400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32403 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13054:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrri:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrri),
     /* 32406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32408 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32410 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32412 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32414 */     GIR_RootConstrainSelectedInstOperands,
     /* 32415 */     // GIR_Coverage, 3254,
     /* 32415 */     GIR_EraseRootFromParent_Done,
     /* 32416 */   // Label 930: @32416
     /* 32416 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(32466), // Rule ID 3260 //
     /* 32421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 32424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /* 32429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 32432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 32435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 32438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32450 */     // MIs[0] src3
     /* 32450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32453 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14533:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (DPPSrri:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DPPSrri),
     /* 32456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32458 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32460 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32462 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32464 */     GIR_RootConstrainSelectedInstOperands,
     /* 32465 */     // GIR_Coverage, 3260,
     /* 32465 */     GIR_EraseRootFromParent_Done,
     /* 32466 */   // Label 931: @32466
     /* 32466 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(32516), // Rule ID 3262 //
     /* 32471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 32474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /* 32479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32500 */     // MIs[0] src3
     /* 32500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32503 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14532:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (DPPDrri:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DPPDrri),
     /* 32506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32510 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32512 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32514 */     GIR_RootConstrainSelectedInstOperands,
     /* 32515 */     // GIR_Coverage, 3262,
     /* 32515 */     GIR_EraseRootFromParent_Done,
     /* 32516 */   // Label 932: @32516
     /* 32516 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(32566), // Rule ID 3322 //
     /* 32521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 32524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1rnds4),
     /* 32529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 32532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 32535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 32538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32550 */     // MIs[0] src3
     /* 32550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32553 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14419:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (SHA1RNDS4rri:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1RNDS4rri),
     /* 32556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32558 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32560 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32562 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32564 */     GIR_RootConstrainSelectedInstOperands,
     /* 32565 */     // GIR_Coverage, 3322,
     /* 32565 */     GIR_EraseRootFromParent_Done,
     /* 32566 */   // Label 933: @32566
     /* 32566 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(32616), // Rule ID 3368 //
     /* 32571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPCLMUL_NoAVX),
     /* 32574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /* 32579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32600 */     // MIs[0] src3
     /* 32600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32603 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14384:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (PCLMULQDQrri:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PCLMULQDQrri),
     /* 32606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32608 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32610 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32612 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32614 */     GIR_RootConstrainSelectedInstOperands,
     /* 32615 */     // GIR_Coverage, 3368,
     /* 32615 */     GIR_EraseRootFromParent_Done,
     /* 32616 */   // Label 934: @32616
     /* 32616 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(32666), // Rule ID 3370 //
     /* 32621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ),
     /* 32624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /* 32629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32650 */     // MIs[0] src3
     /* 32650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32653 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14384:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQrri:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQrri),
     /* 32656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32658 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32660 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32662 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32664 */     GIR_RootConstrainSelectedInstOperands,
     /* 32665 */     // GIR_Coverage, 3370,
     /* 32665 */     GIR_EraseRootFromParent_Done,
     /* 32666 */   // Label 935: @32666
     /* 32666 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(32716), // Rule ID 3372 //
     /* 32671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPCLMULQDQ_NoVLX),
     /* 32674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /* 32679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 32682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 32685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 32688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 32692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 32696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 32700 */     // MIs[0] src3
     /* 32700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32703 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14385:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQYrri:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQYrri),
     /* 32706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32708 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32710 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32712 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32714 */     GIR_RootConstrainSelectedInstOperands,
     /* 32715 */     // GIR_Coverage, 3372,
     /* 32715 */     GIR_EraseRootFromParent_Done,
     /* 32716 */   // Label 936: @32716
     /* 32716 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(32766), // Rule ID 14081 //
     /* 32721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVPCLMULQDQ),
     /* 32724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_512),
     /* 32729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /* 32732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 32735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 32738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32750 */     // MIs[0] src3
     /* 32750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32753 */     // (intrinsic_wo_chain:{ *:[v8i64] } 14386:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZrri:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZrri),
     /* 32756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32758 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32760 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32762 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32764 */     GIR_RootConstrainSelectedInstOperands,
     /* 32765 */     // GIR_Coverage, 14081,
     /* 32765 */     GIR_EraseRootFromParent_Done,
     /* 32766 */   // Label 937: @32766
     /* 32766 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(32816), // Rule ID 14083 //
     /* 32771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /* 32774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /* 32779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32800 */     // MIs[0] src3
     /* 32800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32803 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14384:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ128rri:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ128rri),
     /* 32806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32808 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32810 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32812 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32814 */     GIR_RootConstrainSelectedInstOperands,
     /* 32815 */     // GIR_Coverage, 14083,
     /* 32815 */     GIR_EraseRootFromParent_Done,
     /* 32816 */   // Label 938: @32816
     /* 32816 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(32866), // Rule ID 14085 //
     /* 32821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /* 32824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /* 32829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 32832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 32835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 32838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32850 */     // MIs[0] src3
     /* 32850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32853 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14385:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ256rri:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ256rri),
     /* 32856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32858 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32860 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32862 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32864 */     GIR_RootConstrainSelectedInstOperands,
     /* 32865 */     // GIR_Coverage, 14085,
     /* 32865 */     GIR_EraseRootFromParent_Done,
     /* 32866 */   // Label 939: @32866
     /* 32866 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(32920), // Rule ID 1616 //
     /* 32871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 32874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /* 32879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 32882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 32885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 32888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 32891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32907 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14778:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 32907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrr),
     /* 32910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32912 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32914 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32916 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32918 */     GIR_RootConstrainSelectedInstOperands,
     /* 32919 */     // GIR_Coverage, 1616,
     /* 32919 */     GIR_EraseRootFromParent_Done,
     /* 32920 */   // Label 940: @32920
     /* 32920 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(32974), // Rule ID 1618 //
     /* 32925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 32928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /* 32933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 32936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 32939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 32942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 32945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32961 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14777:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 32961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrr),
     /* 32964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32966 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32968 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32970 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32972 */     GIR_RootConstrainSelectedInstOperands,
     /* 32973 */     // GIR_Coverage, 1618,
     /* 32973 */     GIR_EraseRootFromParent_Done,
     /* 32974 */   // Label 941: @32974
     /* 32974 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(33028), // Rule ID 1620 //
     /* 32979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 32982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /* 32987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 32990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 32993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 32996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 32999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33015 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14776:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /* 33015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /* 33018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33020 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33022 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33024 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33026 */     GIR_RootConstrainSelectedInstOperands,
     /* 33027 */     // GIR_Coverage, 1620,
     /* 33027 */     GIR_EraseRootFromParent_Done,
     /* 33028 */   // Label 942: @33028
     /* 33028 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(33082), // Rule ID 1622 //
     /* 33033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /* 33041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 33044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 33047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 33050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 33053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33069 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14775:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 33069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrr),
     /* 33072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33074 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33076 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33078 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33080 */     GIR_RootConstrainSelectedInstOperands,
     /* 33081 */     // GIR_Coverage, 1622,
     /* 33081 */     GIR_EraseRootFromParent_Done,
     /* 33082 */   // Label 943: @33082
     /* 33082 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(33136), // Rule ID 1624 //
     /* 33087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /* 33095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 33098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 33101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 33104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 33107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33123 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14774:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /* 33123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrr),
     /* 33126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33128 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33130 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33132 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33134 */     GIR_RootConstrainSelectedInstOperands,
     /* 33135 */     // GIR_Coverage, 1624,
     /* 33135 */     GIR_EraseRootFromParent_Done,
     /* 33136 */   // Label 944: @33136
     /* 33136 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(33190), // Rule ID 1626 //
     /* 33141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /* 33149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 33152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 33155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 33158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 33161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33177 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14773:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 33177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrr),
     /* 33180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33182 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33184 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33186 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33188 */     GIR_RootConstrainSelectedInstOperands,
     /* 33189 */     // GIR_Coverage, 1626,
     /* 33189 */     GIR_EraseRootFromParent_Done,
     /* 33190 */   // Label 945: @33190
     /* 33190 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(33244), // Rule ID 1628 //
     /* 33195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /* 33203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 33206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 33215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33231 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14772:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 33231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrr),
     /* 33234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33236 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33238 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33240 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33242 */     GIR_RootConstrainSelectedInstOperands,
     /* 33243 */     // GIR_Coverage, 1628,
     /* 33243 */     GIR_EraseRootFromParent_Done,
     /* 33244 */   // Label 946: @33244
     /* 33244 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(33298), // Rule ID 1630 //
     /* 33249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /* 33257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 33260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 33269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33285 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14771:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 33285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrr),
     /* 33288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33290 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33292 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33294 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33296 */     GIR_RootConstrainSelectedInstOperands,
     /* 33297 */     // GIR_Coverage, 1630,
     /* 33297 */     GIR_EraseRootFromParent_Done,
     /* 33298 */   // Label 947: @33298
     /* 33298 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(33352), // Rule ID 1632 //
     /* 33303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /* 33311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 33314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 33323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33339 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14770:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 33339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrr),
     /* 33342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33344 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33346 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33348 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33350 */     GIR_RootConstrainSelectedInstOperands,
     /* 33351 */     // GIR_Coverage, 1632,
     /* 33351 */     GIR_EraseRootFromParent_Done,
     /* 33352 */   // Label 948: @33352
     /* 33352 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(33406), // Rule ID 1634 //
     /* 33357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /* 33365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 33368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 33377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33393 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14769:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 33393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrr),
     /* 33396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33398 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33400 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33402 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33404 */     GIR_RootConstrainSelectedInstOperands,
     /* 33405 */     // GIR_Coverage, 1634,
     /* 33405 */     GIR_EraseRootFromParent_Done,
     /* 33406 */   // Label 949: @33406
     /* 33406 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(33460), // Rule ID 1636 //
     /* 33411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /* 33419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 33422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 33431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33447 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14768:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 33447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrr),
     /* 33450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33452 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33454 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33456 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33458 */     GIR_RootConstrainSelectedInstOperands,
     /* 33459 */     // GIR_Coverage, 1636,
     /* 33459 */     GIR_EraseRootFromParent_Done,
     /* 33460 */   // Label 950: @33460
     /* 33460 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(33514), // Rule ID 1638 //
     /* 33465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /* 33473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 33476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 33485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33501 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14767:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 33501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /* 33504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33506 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33508 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33510 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33512 */     GIR_RootConstrainSelectedInstOperands,
     /* 33513 */     // GIR_Coverage, 1638,
     /* 33513 */     GIR_EraseRootFromParent_Done,
     /* 33514 */   // Label 951: @33514
     /* 33514 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(33580), // Rule ID 3330 //
     /* 33519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 33522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256rnds2),
     /* 33527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 33530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 33539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33555 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14422:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, XMM0:{ *:[v4i32] })  =>  (SHA256RNDS2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 33555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 33559 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::XMM0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 33565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XMM0
     /* 33569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256RNDS2rr),
     /* 33572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33574 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33576 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33578 */     GIR_RootConstrainSelectedInstOperands,
     /* 33579 */     // GIR_Coverage, 3330,
     /* 33579 */     GIR_EraseRootFromParent_Done,
     /* 33580 */   // Label 952: @33580
     /* 33580 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(33634), // Rule ID 3554 //
     /* 33585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /* 33588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512rnds2),
     /* 33593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 33596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 33599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 33602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 33605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 33609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 33613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 33617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33621 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14717:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VSHA512RNDS2rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 33621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512RNDS2rr),
     /* 33624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33626 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33628 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33630 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33632 */     GIR_RootConstrainSelectedInstOperands,
     /* 33633 */     // GIR_Coverage, 3554,
     /* 33633 */     GIR_EraseRootFromParent_Done,
     /* 33634 */   // Label 953: @33634
     /* 33634 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(33688), // Rule ID 3555 //
     /* 33639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 33642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg1),
     /* 33647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 33650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 33659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33675 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14718:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VSM3MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 33675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG1rr),
     /* 33678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33680 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33682 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33684 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33686 */     GIR_RootConstrainSelectedInstOperands,
     /* 33687 */     // GIR_Coverage, 3555,
     /* 33687 */     GIR_EraseRootFromParent_Done,
     /* 33688 */   // Label 954: @33688
     /* 33688 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(33742), // Rule ID 3557 //
     /* 33693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 33696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg2),
     /* 33701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 33704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 33713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33729 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14719:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VSM3MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 33729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG2rr),
     /* 33732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33734 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33736 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33738 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33740 */     GIR_RootConstrainSelectedInstOperands,
     /* 33741 */     // GIR_Coverage, 3557,
     /* 33741 */     GIR_EraseRootFromParent_Done,
     /* 33742 */   // Label 955: @33742
     /* 33742 */   GIM_Reject,
     /* 33743 */ // Label 927: @33743
     /* 33743 */ GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(33805), // Rule ID 3559 //
     /* 33748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 33751 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 33754 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3rnds2),
     /* 33759 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 33762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33765 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33768 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 33771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33779 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33783 */   GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33787 */   // MIs[0] src4
     /* 33787 */   GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 33790 */   // (intrinsic_wo_chain:{ *:[v4i32] } 14720:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3, (timm:{ *:[i32] }):$src4)  =>  (VSM3RNDS2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3, (timm:{ *:[i32] }):$src4)
     /* 33790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3RNDS2rr),
     /* 33793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33795 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33797 */   GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33799 */   GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33801 */   GIR_RootToRootCopy, /*OpIdx*/5, // src4
     /* 33803 */   GIR_RootConstrainSelectedInstOperands,
     /* 33804 */   // GIR_Coverage, 3559,
     /* 33804 */   GIR_EraseRootFromParent_Done,
     /* 33805 */ // Label 956: @33805
     /* 33805 */ GIM_Reject,
     /* 33806 */ // Label 11: @33806
     /* 33806 */ GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(34365),
     /* 33811 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 33814 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(33836), // Rule ID 149 //
     /* 33819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSERIALIZE),
     /* 33822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_serialize),
     /* 33827 */     // (intrinsic_void 14414:{ *:[iPTR] })  =>  (SERIALIZE)
     /* 33827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SERIALIZE),
     /* 33830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33834 */     GIR_RootConstrainSelectedInstOperands,
     /* 33835 */     // GIR_Coverage, 149,
     /* 33835 */     GIR_EraseRootFromParent_Done,
     /* 33836 */   // Label 958: @33836
     /* 33836 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(33858), // Rule ID 150 //
     /* 33841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTSXLDTRK),
     /* 33844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsusldtrk),
     /* 33849 */     // (intrinsic_void 14802:{ *:[iPTR] })  =>  (XSUSLDTRK)
     /* 33849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSUSLDTRK),
     /* 33852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33856 */     GIR_RootConstrainSelectedInstOperands,
     /* 33857 */     // GIR_Coverage, 150,
     /* 33857 */     GIR_EraseRootFromParent_Done,
     /* 33858 */   // Label 959: @33858
     /* 33858 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(33880), // Rule ID 151 //
     /* 33863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTSXLDTRK),
     /* 33866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xresldtrk),
     /* 33871 */     // (intrinsic_void 14788:{ *:[iPTR] })  =>  (XRESLDTRK)
     /* 33871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRESLDTRK),
     /* 33874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33878 */     GIR_RootConstrainSelectedInstOperands,
     /* 33879 */     // GIR_Coverage, 151,
     /* 33879 */     GIR_EraseRootFromParent_Done,
     /* 33880 */   // Label 960: @33880
     /* 33880 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(33902), // Rule ID 152 //
     /* 33885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 33888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clui),
     /* 33893 */     // (intrinsic_void 14272:{ *:[iPTR] })  =>  (CLUI)
     /* 33893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLUI),
     /* 33896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33900 */     GIR_RootConstrainSelectedInstOperands,
     /* 33901 */     // GIR_Coverage, 152,
     /* 33901 */     GIR_EraseRootFromParent_Done,
     /* 33902 */   // Label 961: @33902
     /* 33902 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(33924), // Rule ID 153 //
     /* 33907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 33910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_stui),
     /* 33915 */     // (intrinsic_void 14596:{ *:[iPTR] })  =>  (STUI)
     /* 33915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STUI),
     /* 33918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33922 */     GIR_RootConstrainSelectedInstOperands,
     /* 33923 */     // GIR_Coverage, 153,
     /* 33923 */     GIR_EraseRootFromParent_Done,
     /* 33924 */   // Label 962: @33924
     /* 33924 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(33943), // Rule ID 2507 //
     /* 33929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_pause),
     /* 33934 */     // (intrinsic_void 14491:{ *:[iPTR] })  =>  (PAUSE)
     /* 33934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PAUSE),
     /* 33937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33941 */     GIR_RootConstrainSelectedInstOperands,
     /* 33942 */     // GIR_Coverage, 2507,
     /* 33942 */     GIR_EraseRootFromParent_Done,
     /* 33943 */   // Label 963: @33943
     /* 33943 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(33965), // Rule ID 2508 //
     /* 33948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE1),
     /* 33951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_sfence),
     /* 33956 */     // (intrinsic_void 14453:{ *:[iPTR] })  =>  (SFENCE)
     /* 33956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SFENCE),
     /* 33959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33963 */     GIR_RootConstrainSelectedInstOperands,
     /* 33964 */     // GIR_Coverage, 2508,
     /* 33964 */     GIR_EraseRootFromParent_Done,
     /* 33965 */   // Label 964: @33965
     /* 33965 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(33987), // Rule ID 2509 //
     /* 33970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE2),
     /* 33973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_lfence),
     /* 33978 */     // (intrinsic_void 14480:{ *:[iPTR] })  =>  (LFENCE)
     /* 33978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LFENCE),
     /* 33981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33985 */     GIR_RootConstrainSelectedInstOperands,
     /* 33986 */     // GIR_Coverage, 2509,
     /* 33986 */     GIR_EraseRootFromParent_Done,
     /* 33987 */   // Label 965: @33987
     /* 33987 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(34009), // Rule ID 2510 //
     /* 33992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMFence),
     /* 33995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_mfence),
     /* 34000 */     // (intrinsic_void 14484:{ *:[iPTR] })  =>  (MFENCE)
     /* 34000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MFENCE),
     /* 34003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34007 */     GIR_RootConstrainSelectedInstOperands,
     /* 34008 */     // GIR_Coverage, 2510,
     /* 34008 */     GIR_EraseRootFromParent_Done,
     /* 34009 */   // Label 966: @34009
     /* 34009 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(34075), // Rule ID 3424 //
     /* 34014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 34017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_vzeroall),
     /* 34022 */     // (intrinsic_void 13097:{ *:[iPTR] })  =>  (VZEROALL)
     /* 34022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VZEROALL),
     /* 34025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM0*/0,
     /* 34028 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM1*/1,
     /* 34031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM2*/2,
     /* 34034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM3*/3,
     /* 34037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM4*/4,
     /* 34040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM5*/5,
     /* 34043 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM6*/6,
     /* 34046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM7*/7,
     /* 34049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM8*/8,
     /* 34052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM9*/9,
     /* 34055 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM10*/10,
     /* 34058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM11*/11,
     /* 34061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM12*/12,
     /* 34064 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM13*/13,
     /* 34067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM14*/14,
     /* 34070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM15*/15,
     /* 34073 */     GIR_RootConstrainSelectedInstOperands,
     /* 34074 */     // GIR_Coverage, 3424,
     /* 34074 */     GIR_EraseRootFromParent_Done,
     /* 34075 */   // Label 967: @34075
     /* 34075 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(34141), // Rule ID 3425 //
     /* 34080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 34083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_vzeroupper),
     /* 34088 */     // (intrinsic_void 13098:{ *:[iPTR] })  =>  (VZEROUPPER)
     /* 34088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VZEROUPPER),
     /* 34091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM0*/0,
     /* 34094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM1*/1,
     /* 34097 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM2*/2,
     /* 34100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM3*/3,
     /* 34103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM4*/4,
     /* 34106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM5*/5,
     /* 34109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM6*/6,
     /* 34112 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM7*/7,
     /* 34115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM8*/8,
     /* 34118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM9*/9,
     /* 34121 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM10*/10,
     /* 34124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM11*/11,
     /* 34127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM12*/12,
     /* 34130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM13*/13,
     /* 34133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM14*/14,
     /* 34136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM15*/15,
     /* 34139 */     GIR_RootConstrainSelectedInstOperands,
     /* 34140 */     // GIR_Coverage, 3425,
     /* 34140 */     GIR_EraseRootFromParent_Done,
     /* 34141 */   // Label 968: @34141
     /* 34141 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(34211), // Rule ID 17249 //
     /* 34146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMMX),
     /* 34149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_mmx_emms),
     /* 34154 */     // (intrinsic_void 14307:{ *:[iPTR] })  =>  (MMX_EMMS:{ *:[x86mmx] })
     /* 34154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MMX_EMMS),
     /* 34157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM0*/0,
     /* 34160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM1*/1,
     /* 34163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM2*/2,
     /* 34166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM3*/3,
     /* 34169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM4*/4,
     /* 34172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM5*/5,
     /* 34175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM6*/6,
     /* 34178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM7*/7,
     /* 34181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST0*/8,
     /* 34184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST1*/9,
     /* 34187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST2*/10,
     /* 34190 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST3*/11,
     /* 34193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST4*/12,
     /* 34196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST5*/13,
     /* 34199 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST6*/14,
     /* 34202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST7*/15,
     /* 34205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34209 */     GIR_RootConstrainSelectedInstOperands,
     /* 34210 */     // GIR_Coverage, 17249,
     /* 34210 */     GIR_EraseRootFromParent_Done,
     /* 34211 */   // Label 969: @34211
     /* 34211 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(34233), // Rule ID 17432 //
     /* 34216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 34219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xend),
     /* 34224 */     // (intrinsic_void 14740:{ *:[iPTR] })  =>  (XEND)
     /* 34224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XEND),
     /* 34227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34231 */     GIR_RootConstrainSelectedInstOperands,
     /* 34232 */     // GIR_Coverage, 17432,
     /* 34232 */     GIR_EraseRootFromParent_Done,
     /* 34233 */   // Label 970: @34233
     /* 34233 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(34279), // Rule ID 17444 //
     /* 34238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode),
     /* 34241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tilerelease),
     /* 34246 */     // (intrinsic_void 14666:{ *:[iPTR] })  =>  (TILERELEASE:{ *:[x86amx] })
     /* 34246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TILERELEASE),
     /* 34249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 34252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 34255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 34258 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 34261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 34264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 34267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 34270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 34273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34277 */     GIR_RootConstrainSelectedInstOperands,
     /* 34278 */     // GIR_Coverage, 17444,
     /* 34278 */     GIR_EraseRootFromParent_Done,
     /* 34279 */   // Label 971: @34279
     /* 34279 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(34298), // Rule ID 17533 //
     /* 34284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wbinvd),
     /* 34289 */     // (intrinsic_void 14727:{ *:[iPTR] })  =>  (WBINVD)
     /* 34289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WBINVD),
     /* 34292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34296 */     GIR_RootConstrainSelectedInstOperands,
     /* 34297 */     // GIR_Coverage, 17533,
     /* 34297 */     GIR_EraseRootFromParent_Done,
     /* 34298 */   // Label 972: @34298
     /* 34298 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(34320), // Rule ID 17534 //
     /* 34303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWBNOINVD),
     /* 34306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wbnoinvd),
     /* 34311 */     // (intrinsic_void 14728:{ *:[iPTR] })  =>  (WBNOINVD)
     /* 34311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WBNOINVD),
     /* 34314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34318 */     GIR_RootConstrainSelectedInstOperands,
     /* 34319 */     // GIR_Coverage, 17534,
     /* 34319 */     GIR_EraseRootFromParent_Done,
     /* 34320 */   // Label 973: @34320
     /* 34320 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(34342), // Rule ID 17539 //
     /* 34325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_saveprevssp),
     /* 34330 */     // (intrinsic_void 14409:{ *:[iPTR] })  =>  (SAVEPREVSSP)
     /* 34330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAVEPREVSSP),
     /* 34333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 34336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34340 */     GIR_RootConstrainSelectedInstOperands,
     /* 34341 */     // GIR_Coverage, 17539,
     /* 34341 */     GIR_EraseRootFromParent_Done,
     /* 34342 */   // Label 974: @34342
     /* 34342 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(34364), // Rule ID 17549 //
     /* 34347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_setssbsy),
     /* 34352 */     // (intrinsic_void 14415:{ *:[iPTR] })  =>  (SETSSBSY)
     /* 34352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SETSSBSY),
     /* 34355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 34358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34362 */     GIR_RootConstrainSelectedInstOperands,
     /* 34363 */     // GIR_Coverage, 17549,
     /* 34363 */     GIR_EraseRootFromParent_Done,
     /* 34364 */   // Label 975: @34364
     /* 34364 */   GIM_Reject,
     /* 34365 */ // Label 957: @34365
     /* 34365 */ GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(35374),
     /* 34370 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 34373 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(34403), // Rule ID 17522 //
     /* 34378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_int),
     /* 34383 */     // MIs[0] Operand 1
     /* 34383 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(3),
     /* 34394 */     // (intrinsic_void 14297:{ *:[iPTR] }, 3:{ *:[i8] })  =>  (INT3)
     /* 34394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT3),
     /* 34397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34401 */     GIR_RootConstrainSelectedInstOperands,
     /* 34402 */     // GIR_Coverage, 17522,
     /* 34402 */     GIR_EraseRootFromParent_Done,
     /* 34403 */   // Label 977: @34403
     /* 34403 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(34430), // Rule ID 17434 //
     /* 34408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 34411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xabort),
     /* 34416 */     // MIs[0] imm
     /* 34416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 34419 */     // (intrinsic_void 14738:{ *:[iPTR] }, (timm:{ *:[i8] }):$imm)  =>  (XABORT (timm:{ *:[i8] }):$imm)
     /* 34419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XABORT),
     /* 34422 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 34424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34428 */     GIR_RootConstrainSelectedInstOperands,
     /* 34429 */     // GIR_Coverage, 17434,
     /* 34429 */     GIR_EraseRootFromParent_Done,
     /* 34430 */   // Label 978: @34430
     /* 34430 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(34457), // Rule ID 17446 //
     /* 34435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode),
     /* 34438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tilezero),
     /* 34443 */     // MIs[0] src
     /* 34443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 34446 */     // (intrinsic_void 14669:{ *:[iPTR] }, (timm:{ *:[i8] }):$src)  =>  (PTILEZERO (timm:{ *:[i8] }):$src)
     /* 34446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEZERO),
     /* 34449 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 34451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34455 */     GIR_RootConstrainSelectedInstOperands,
     /* 34456 */     // GIR_Coverage, 17446,
     /* 34456 */     GIR_EraseRootFromParent_Done,
     /* 34457 */   // Label 979: @34457
     /* 34457 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(34481), // Rule ID 17524 //
     /* 34462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_int),
     /* 34467 */     // MIs[0] trap
     /* 34467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 34470 */     // (intrinsic_void 14297:{ *:[iPTR] }, (timm:{ *:[i8] }):$trap)  =>  (INT (timm:{ *:[i8] }):$trap)
     /* 34470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT),
     /* 34473 */     GIR_RootToRootCopy, /*OpIdx*/1, // trap
     /* 34475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34479 */     GIR_RootConstrainSelectedInstOperands,
     /* 34480 */     // GIR_Coverage, 17524,
     /* 34480 */     GIR_EraseRootFromParent_Done,
     /* 34481 */   // Label 980: @34481
     /* 34481 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(34515), // Rule ID 1 //
     /* 34486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 34489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_flags_read_u32),
     /* 34494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 34501 */     // (intrinsic_w_chain:{ *:[i32] } 14283:{ *:[iPTR] })  =>  (RDFLAGS32:{ *:[i32] }:{ *:[i32] })
     /* 34501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFLAGS32),
     /* 34504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 34509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34513 */     GIR_RootConstrainSelectedInstOperands,
     /* 34514 */     // GIR_Coverage, 1,
     /* 34514 */     GIR_EraseRootFromParent_Done,
     /* 34515 */   // Label 981: @34515
     /* 34515 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(34549), // Rule ID 2 //
     /* 34520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 34523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_flags_read_u64),
     /* 34528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 34531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 34535 */     // (intrinsic_w_chain:{ *:[i64] } 14284:{ *:[iPTR] })  =>  (RDFLAGS64:{ *:[i64] }:{ *:[i32] })
     /* 34535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFLAGS64),
     /* 34538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 34543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34547 */     GIR_RootConstrainSelectedInstOperands,
     /* 34548 */     // GIR_Coverage, 2,
     /* 34548 */     GIR_EraseRootFromParent_Done,
     /* 34549 */   // Label 982: @34549
     /* 34549 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(34580), // Rule ID 115 //
     /* 34554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 34557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_slwpcb),
     /* 34562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 34569 */     // (intrinsic_w_chain:{ *:[i32] } 14423:{ *:[iPTR] })  =>  (SLWPCB:{ *:[i32] })
     /* 34569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SLWPCB),
     /* 34572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34578 */     GIR_RootConstrainSelectedInstOperands,
     /* 34579 */     // GIR_Coverage, 115,
     /* 34579 */     GIR_EraseRootFromParent_Done,
     /* 34580 */   // Label 983: @34580
     /* 34580 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(34611), // Rule ID 117 //
     /* 34585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 34588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_slwpcb),
     /* 34593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 34596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 34600 */     // (intrinsic_w_chain:{ *:[i64] } 14423:{ *:[iPTR] })  =>  (SLWPCB64:{ *:[i64] })
     /* 34600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SLWPCB64),
     /* 34603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34609 */     GIR_RootConstrainSelectedInstOperands,
     /* 34610 */     // GIR_Coverage, 117,
     /* 34610 */     GIR_EraseRootFromParent_Done,
     /* 34611 */   // Label 984: @34611
     /* 34611 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(34642), // Rule ID 17431 //
     /* 34616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 34619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xbegin),
     /* 34624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 34631 */     // (intrinsic_w_chain:{ *:[i32] } 14739:{ *:[iPTR] })  =>  (XBEGIN:{ *:[i32] })
     /* 34631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XBEGIN),
     /* 34634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34640 */     GIR_RootConstrainSelectedInstOperands,
     /* 34641 */     // GIR_Coverage, 17431,
     /* 34641 */     GIR_EraseRootFromParent_Done,
     /* 34642 */   // Label 985: @34642
     /* 34642 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(34673), // Rule ID 17566 //
     /* 34647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 34650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdfsbase_32),
     /* 34655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 34662 */     // (intrinsic_w_chain:{ *:[i32] } 14390:{ *:[iPTR] })  =>  (RDFSBASE:{ *:[i32] })
     /* 34662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFSBASE),
     /* 34665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34671 */     GIR_RootConstrainSelectedInstOperands,
     /* 34672 */     // GIR_Coverage, 17566,
     /* 34672 */     GIR_EraseRootFromParent_Done,
     /* 34673 */   // Label 986: @34673
     /* 34673 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(34704), // Rule ID 17567 //
     /* 34678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 34681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdfsbase_64),
     /* 34686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 34689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 34693 */     // (intrinsic_w_chain:{ *:[i64] } 14391:{ *:[iPTR] })  =>  (RDFSBASE64:{ *:[i64] })
     /* 34693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFSBASE64),
     /* 34696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34702 */     GIR_RootConstrainSelectedInstOperands,
     /* 34703 */     // GIR_Coverage, 17567,
     /* 34703 */     GIR_EraseRootFromParent_Done,
     /* 34704 */   // Label 987: @34704
     /* 34704 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(34735), // Rule ID 17568 //
     /* 34709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 34712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdgsbase_32),
     /* 34717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 34724 */     // (intrinsic_w_chain:{ *:[i32] } 14392:{ *:[iPTR] })  =>  (RDGSBASE:{ *:[i32] })
     /* 34724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDGSBASE),
     /* 34727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34733 */     GIR_RootConstrainSelectedInstOperands,
     /* 34734 */     // GIR_Coverage, 17568,
     /* 34734 */     GIR_EraseRootFromParent_Done,
     /* 34735 */   // Label 988: @34735
     /* 34735 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(34766), // Rule ID 17569 //
     /* 34740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 34743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdgsbase_64),
     /* 34748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 34751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 34755 */     // (intrinsic_w_chain:{ *:[i64] } 14393:{ *:[iPTR] })  =>  (RDGSBASE64:{ *:[i64] })
     /* 34755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDGSBASE64),
     /* 34758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34764 */     GIR_RootConstrainSelectedInstOperands,
     /* 34765 */     // GIR_Coverage, 17569,
     /* 34765 */     GIR_EraseRootFromParent_Done,
     /* 34766 */   // Label 989: @34766
     /* 34766 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(34797), // Rule ID 17575 //
     /* 34771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDPID_Not64BitMode),
     /* 34774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdpid),
     /* 34779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 34786 */     // (intrinsic_w_chain:{ *:[i32] } 14394:{ *:[iPTR] })  =>  (RDPID32:{ *:[i32] })
     /* 34786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDPID32),
     /* 34789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34795 */     GIR_RootConstrainSelectedInstOperands,
     /* 34796 */     // GIR_Coverage, 17575,
     /* 34796 */     GIR_EraseRootFromParent_Done,
     /* 34797 */   // Label 990: @34797
     /* 34797 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(34854), // Rule ID 22807 //
     /* 34802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDPID_In64BitMode),
     /* 34805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdpid),
     /* 34810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 34817 */     // (intrinsic_w_chain:{ *:[i32] } 14394:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (RDPID64:{ *:[i64] }), sub_32bit:{ *:[i32] })
     /* 34817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 34820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::RDPID64),
     /* 34824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 34829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 34831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 34834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34836 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_32bit),
     /* 34843 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 34848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 34853 */     // GIR_Coverage, 22807,
     /* 34853 */     GIR_EraseRootFromParent_Done,
     /* 34854 */   // Label 991: @34854
     /* 34854 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(34894), // Rule ID 3 //
     /* 34859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 34862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_flags_write_u32),
     /* 34867 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 34870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 34874 */     // (intrinsic_void 14285:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRFLAGS32:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 34874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFLAGS32),
     /* 34877 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 34879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 34882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/1,
     /* 34885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::DF*/2,
     /* 34888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34892 */     GIR_RootConstrainSelectedInstOperands,
     /* 34893 */     // GIR_Coverage, 3,
     /* 34893 */     GIR_EraseRootFromParent_Done,
     /* 34894 */   // Label 992: @34894
     /* 34894 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(34934), // Rule ID 4 //
     /* 34899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 34902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_flags_write_u64),
     /* 34907 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 34910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 34914 */     // (intrinsic_void 14286:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRFLAGS64:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 34914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFLAGS64),
     /* 34917 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 34919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::RSP*/0,
     /* 34922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/1,
     /* 34925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::DF*/2,
     /* 34928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34932 */     GIR_RootConstrainSelectedInstOperands,
     /* 34933 */     // GIR_Coverage, 4,
     /* 34933 */     GIR_EraseRootFromParent_Done,
     /* 34934 */   // Label 993: @34934
     /* 34934 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(34965), // Rule ID 154 //
     /* 34939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 34942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_senduipi),
     /* 34947 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 34950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 34954 */     // (intrinsic_void 14413:{ *:[iPTR] }, GR64:{ *:[i64] }:$arg)  =>  (SENDUIPI GR64:{ *:[i64] }:$arg)
     /* 34954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SENDUIPI),
     /* 34957 */     GIR_RootToRootCopy, /*OpIdx*/1, // arg
     /* 34959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34963 */     GIR_RootConstrainSelectedInstOperands,
     /* 34964 */     // GIR_Coverage, 154,
     /* 34964 */     GIR_EraseRootFromParent_Done,
     /* 34965 */   // Label 994: @34965
     /* 34965 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(34996), // Rule ID 17535 //
     /* 34970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_incsspd),
     /* 34975 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 34978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 34982 */     // (intrinsic_void 14295:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (INCSSPD GR32:{ *:[i32] }:$src)
     /* 34982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INCSSPD),
     /* 34985 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 34987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 34990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34994 */     GIR_RootConstrainSelectedInstOperands,
     /* 34995 */     // GIR_Coverage, 17535,
     /* 34995 */     GIR_EraseRootFromParent_Done,
     /* 34996 */   // Label 995: @34996
     /* 34996 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(35027), // Rule ID 17536 //
     /* 35001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_incsspq),
     /* 35006 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 35009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35013 */     // (intrinsic_void 14296:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (INCSSPQ GR64:{ *:[i64] }:$src)
     /* 35013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INCSSPQ),
     /* 35016 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 35021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35025 */     GIR_RootConstrainSelectedInstOperands,
     /* 35026 */     // GIR_Coverage, 17536,
     /* 35026 */     GIR_EraseRootFromParent_Done,
     /* 35027 */   // Label 996: @35027
     /* 35027 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(35058), // Rule ID 17570 //
     /* 35032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 35035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrfsbase_32),
     /* 35040 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 35043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35047 */     // (intrinsic_void 14729:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRFSBASE GR32:{ *:[i32] }:$src)
     /* 35047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFSBASE),
     /* 35050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35056 */     GIR_RootConstrainSelectedInstOperands,
     /* 35057 */     // GIR_Coverage, 17570,
     /* 35057 */     GIR_EraseRootFromParent_Done,
     /* 35058 */   // Label 997: @35058
     /* 35058 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(35089), // Rule ID 17571 //
     /* 35063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 35066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrfsbase_64),
     /* 35071 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 35074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35078 */     // (intrinsic_void 14730:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRFSBASE64 GR64:{ *:[i64] }:$src)
     /* 35078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFSBASE64),
     /* 35081 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35087 */     GIR_RootConstrainSelectedInstOperands,
     /* 35088 */     // GIR_Coverage, 17571,
     /* 35088 */     GIR_EraseRootFromParent_Done,
     /* 35089 */   // Label 998: @35089
     /* 35089 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(35120), // Rule ID 17572 //
     /* 35094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 35097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrgsbase_32),
     /* 35102 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 35105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35109 */     // (intrinsic_void 14731:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRGSBASE GR32:{ *:[i32] }:$src)
     /* 35109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRGSBASE),
     /* 35112 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35118 */     GIR_RootConstrainSelectedInstOperands,
     /* 35119 */     // GIR_Coverage, 17572,
     /* 35119 */     GIR_EraseRootFromParent_Done,
     /* 35120 */   // Label 999: @35120
     /* 35120 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(35151), // Rule ID 17573 //
     /* 35125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 35128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrgsbase_64),
     /* 35133 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 35136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35140 */     // (intrinsic_void 14732:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRGSBASE64 GR64:{ *:[i64] }:$src)
     /* 35140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRGSBASE64),
     /* 35143 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35149 */     GIR_RootConstrainSelectedInstOperands,
     /* 35150 */     // GIR_Coverage, 17573,
     /* 35150 */     GIR_EraseRootFromParent_Done,
     /* 35151 */   // Label 1000: @35151
     /* 35151 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(35182), // Rule ID 17578 //
     /* 35156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE),
     /* 35159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite32),
     /* 35164 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 35167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35171 */     // (intrinsic_void 14388:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst)  =>  (PTWRITEr GR32:{ *:[i32] }:$dst)
     /* 35171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITEr),
     /* 35174 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 35176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35180 */     GIR_RootConstrainSelectedInstOperands,
     /* 35181 */     // GIR_Coverage, 17578,
     /* 35181 */     GIR_EraseRootFromParent_Done,
     /* 35182 */   // Label 1001: @35182
     /* 35182 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(35213), // Rule ID 17579 //
     /* 35187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE_In64BitMode),
     /* 35190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite64),
     /* 35195 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 35198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35202 */     // (intrinsic_void 14389:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst)  =>  (PTWRITE64r GR64:{ *:[i64] }:$dst)
     /* 35202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITE64r),
     /* 35205 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 35207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35211 */     GIR_RootConstrainSelectedInstOperands,
     /* 35212 */     // GIR_Coverage, 17579,
     /* 35212 */     GIR_EraseRootFromParent_Done,
     /* 35213 */   // Label 1002: @35213
     /* 35213 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(35245), // Rule ID 114 //
     /* 35218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 35221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_llwpcb),
     /* 35226 */     // MIs[0] src
     /* 35226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 35230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35234 */     // (intrinsic_void 14301:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (LLWPCB GR32:{ *:[i32] }:$src)
     /* 35234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LLWPCB),
     /* 35237 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35243 */     GIR_RootConstrainSelectedInstOperands,
     /* 35244 */     // GIR_Coverage, 114,
     /* 35244 */     GIR_EraseRootFromParent_Done,
     /* 35245 */   // Label 1003: @35245
     /* 35245 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(35277), // Rule ID 116 //
     /* 35250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 35253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_llwpcb),
     /* 35258 */     // MIs[0] src
     /* 35258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 35262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35266 */     // (intrinsic_void 14301:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (LLWPCB64 GR64:{ *:[i64] }:$src)
     /* 35266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LLWPCB64),
     /* 35269 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35275 */     GIR_RootConstrainSelectedInstOperands,
     /* 35276 */     // GIR_Coverage, 116,
     /* 35276 */     GIR_EraseRootFromParent_Done,
     /* 35277 */   // Label 1004: @35277
     /* 35277 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(35309), // Rule ID 126 //
     /* 35282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG_Not64BitMode),
     /* 35285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 35290 */     // MIs[0] src
     /* 35290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/16,
     /* 35294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 35298 */     // (intrinsic_void 14686:{ *:[iPTR] }, GR16:{ *:[i16] }:$src)  =>  (UMONITOR16 GR16:{ *:[i16] }:$src)
     /* 35298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR16),
     /* 35301 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35307 */     GIR_RootConstrainSelectedInstOperands,
     /* 35308 */     // GIR_Coverage, 126,
     /* 35308 */     GIR_EraseRootFromParent_Done,
     /* 35309 */   // Label 1005: @35309
     /* 35309 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(35341), // Rule ID 127 //
     /* 35314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG),
     /* 35317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 35322 */     // MIs[0] src
     /* 35322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 35326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35330 */     // (intrinsic_void 14686:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (UMONITOR32 GR32:{ *:[i32] }:$src)
     /* 35330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR32),
     /* 35333 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35339 */     GIR_RootConstrainSelectedInstOperands,
     /* 35340 */     // GIR_Coverage, 127,
     /* 35340 */     GIR_EraseRootFromParent_Done,
     /* 35341 */   // Label 1006: @35341
     /* 35341 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(35373), // Rule ID 128 //
     /* 35346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG_In64BitMode),
     /* 35349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 35354 */     // MIs[0] src
     /* 35354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 35358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35362 */     // (intrinsic_void 14686:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (UMONITOR64 GR64:{ *:[i64] }:$src)
     /* 35362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR64),
     /* 35365 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35371 */     GIR_RootConstrainSelectedInstOperands,
     /* 35372 */     // GIR_Coverage, 128,
     /* 35372 */     GIR_EraseRootFromParent_Done,
     /* 35373 */   // Label 1007: @35373
     /* 35373 */   GIM_Reject,
     /* 35374 */ // Label 976: @35374
     /* 35374 */ GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(35788),
     /* 35379 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 35382 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(35414), // Rule ID 17472 //
     /* 35387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTRANSPOSE_In64BitMode),
     /* 35390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttransposed),
     /* 35395 */     // MIs[0] dst
     /* 35395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 35398 */     // MIs[0] src
     /* 35398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 35401 */     // (intrinsic_void 14684:{ *:[iPTR] }, (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)  =>  (PTTRANSPOSED (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)
     /* 35401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTRANSPOSED),
     /* 35404 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 35406 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 35408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35412 */     GIR_RootConstrainSelectedInstOperands,
     /* 35413 */     // GIR_Coverage, 17472,
     /* 35413 */     GIR_EraseRootFromParent_Done,
     /* 35414 */   // Label 1009: @35414
     /* 35414 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(35446), // Rule ID 17484 //
     /* 35419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 35422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tconjtfp16),
     /* 35427 */     // MIs[0] dst
     /* 35427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 35430 */     // MIs[0] src
     /* 35430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 35433 */     // (intrinsic_void 14623:{ *:[iPTR] }, (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)  =>  (PTCONJTFP16 (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)
     /* 35433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCONJTFP16),
     /* 35436 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 35438 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 35440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35444 */     GIR_RootConstrainSelectedInstOperands,
     /* 35445 */     // GIR_Coverage, 17484,
     /* 35445 */     GIR_EraseRootFromParent_Done,
     /* 35446 */   // Label 1010: @35446
     /* 35446 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(35489), // Rule ID 17599 //
     /* 35451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::asan_check_memaccess),
     /* 35456 */     // MIs[0] addr
     /* 35456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 35460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64PLTSafeRegClassID),
     /* 35464 */     // MIs[0] accessinfo
     /* 35464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 35467 */     // (intrinsic_void 9:{ *:[iPTR] }, GR64PLTSafe:{ *:[i64] }:$addr, (timm:{ *:[i32] }):$accessinfo)  =>  (ASAN_CHECK_MEMACCESS:{ *:[i64] } GR64PLTSafe:{ *:[i64] }:$addr, (timm:{ *:[i32] }):$accessinfo)
     /* 35467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ASAN_CHECK_MEMACCESS),
     /* 35470 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 35472 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 35474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::R10*/0,
     /* 35477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::R11*/1,
     /* 35480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/2,
     /* 35483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35487 */     GIR_RootConstrainSelectedInstOperands,
     /* 35488 */     // GIR_Coverage, 17599,
     /* 35488 */     GIR_EraseRootFromParent_Done,
     /* 35489 */   // Label 1011: @35489
     /* 35489 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(35529), // Rule ID 17525 //
     /* 35494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUSERMSR_NoEGPR),
     /* 35497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_urdmsr),
     /* 35502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 35505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 35508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35516 */     // (intrinsic_w_chain:{ *:[i64] } 14688:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (URDMSRrr:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 35516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::URDMSRrr),
     /* 35519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 35521 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 35523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35527 */     GIR_RootConstrainSelectedInstOperands,
     /* 35528 */     // GIR_Coverage, 17525,
     /* 35528 */     GIR_EraseRootFromParent_Done,
     /* 35529 */   // Label 1012: @35529
     /* 35529 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(35569), // Rule ID 17529 //
     /* 35534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasUSERMSR_In64BitMode),
     /* 35537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_urdmsr),
     /* 35542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 35545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 35548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35556 */     // (intrinsic_w_chain:{ *:[i64] } 14688:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (URDMSRrr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 35556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::URDMSRrr_EVEX),
     /* 35559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 35561 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 35563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35567 */     GIR_RootConstrainSelectedInstOperands,
     /* 35568 */     // GIR_Coverage, 17529,
     /* 35568 */     GIR_EraseRootFromParent_Done,
     /* 35569 */   // Label 1013: @35569
     /* 35569 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(35606), // Rule ID 17537 //
     /* 35574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdsspd),
     /* 35579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35593 */     // (intrinsic_w_chain:{ *:[i32] } 14404:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (RDSSPD:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 35593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDSSPD),
     /* 35596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 35598 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 35600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35604 */     GIR_RootConstrainSelectedInstOperands,
     /* 35605 */     // GIR_Coverage, 17537,
     /* 35605 */     GIR_EraseRootFromParent_Done,
     /* 35606 */   // Label 1014: @35606
     /* 35606 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(35643), // Rule ID 17538 //
     /* 35611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdsspq),
     /* 35616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 35619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 35622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35630 */     // (intrinsic_w_chain:{ *:[i64] } 14405:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (RDSSPQ:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 35630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDSSPQ),
     /* 35633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 35635 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 35637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35641 */     GIR_RootConstrainSelectedInstOperands,
     /* 35642 */     // GIR_Coverage, 17538,
     /* 35642 */     GIR_EraseRootFromParent_Done,
     /* 35643 */   // Label 1015: @35643
     /* 35643 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(35707), // Rule ID 3083 //
     /* 35648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 35651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse3_mwait),
     /* 35656 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 35659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32_ArgRef_and_GR32_CBRegClassID),
     /* 35666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 35670 */     // (intrinsic_void 14529:{ *:[iPTR] }, ECX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (MWAITrr)
     /* 35670 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 35674 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 35680 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // EAX
     /* 35684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 35688 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::ECX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 35694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // ECX
     /* 35698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MWAITrr),
     /* 35701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35705 */     GIR_RootConstrainSelectedInstOperands,
     /* 35706 */     // GIR_Coverage, 3083,
     /* 35706 */     GIR_EraseRootFromParent_Done,
     /* 35707 */   // Label 1016: @35707
     /* 35707 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(35747), // Rule ID 17527 //
     /* 35712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUSERMSR_NoEGPR),
     /* 35715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_uwrmsr),
     /* 35720 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 35723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 35726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35734 */     // (intrinsic_void 14689:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (UWRMSRrr GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 35734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UWRMSRrr),
     /* 35737 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 35739 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 35741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35745 */     GIR_RootConstrainSelectedInstOperands,
     /* 35746 */     // GIR_Coverage, 17527,
     /* 35746 */     GIR_EraseRootFromParent_Done,
     /* 35747 */   // Label 1017: @35747
     /* 35747 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(35787), // Rule ID 17531 //
     /* 35752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasUSERMSR_In64BitMode),
     /* 35755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_uwrmsr),
     /* 35760 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 35763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 35766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35774 */     // (intrinsic_void 14689:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (UWRMSRrr_EVEX GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 35774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UWRMSRrr_EVEX),
     /* 35777 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 35779 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 35781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35785 */     GIR_RootConstrainSelectedInstOperands,
     /* 35786 */     // GIR_Coverage, 17531,
     /* 35786 */     GIR_EraseRootFromParent_Done,
     /* 35787 */   // Label 1018: @35787
     /* 35787 */   GIM_Reject,
     /* 35788 */ // Label 1008: @35788
     /* 35788 */ GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(37361),
     /* 35793 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 35796 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(35833), // Rule ID 17451 //
     /* 35801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 35804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbssd),
     /* 35809 */     // MIs[0] src1
     /* 35809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 35812 */     // MIs[0] src2
     /* 35812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 35815 */     // MIs[0] src3
     /* 35815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 35818 */     // (intrinsic_void 14641:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBSSD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 35818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBSSD),
     /* 35821 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 35823 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 35825 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 35827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35831 */     GIR_RootConstrainSelectedInstOperands,
     /* 35832 */     // GIR_Coverage, 17451,
     /* 35832 */     GIR_EraseRootFromParent_Done,
     /* 35833 */   // Label 1020: @35833
     /* 35833 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(35870), // Rule ID 17452 //
     /* 35838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 35841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbsud),
     /* 35846 */     // MIs[0] src1
     /* 35846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 35849 */     // MIs[0] src2
     /* 35849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 35852 */     // MIs[0] src3
     /* 35852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 35855 */     // (intrinsic_void 14643:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBSUD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 35855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBSUD),
     /* 35858 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 35860 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 35862 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 35864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35868 */     GIR_RootConstrainSelectedInstOperands,
     /* 35869 */     // GIR_Coverage, 17452,
     /* 35869 */     GIR_EraseRootFromParent_Done,
     /* 35870 */   // Label 1021: @35870
     /* 35870 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(35907), // Rule ID 17453 //
     /* 35875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 35878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbusd),
     /* 35883 */     // MIs[0] src1
     /* 35883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 35886 */     // MIs[0] src2
     /* 35886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 35889 */     // MIs[0] src3
     /* 35889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 35892 */     // (intrinsic_void 14645:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBUSD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 35892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBUSD),
     /* 35895 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 35897 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 35899 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 35901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35905 */     GIR_RootConstrainSelectedInstOperands,
     /* 35906 */     // GIR_Coverage, 17453,
     /* 35906 */     GIR_EraseRootFromParent_Done,
     /* 35907 */   // Label 1022: @35907
     /* 35907 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(35944), // Rule ID 17454 //
     /* 35912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 35915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbuud),
     /* 35920 */     // MIs[0] src1
     /* 35920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 35923 */     // MIs[0] src2
     /* 35923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 35926 */     // MIs[0] src3
     /* 35926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 35929 */     // (intrinsic_void 14647:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBUUD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 35929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBUUD),
     /* 35932 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 35934 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 35936 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 35938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35942 */     GIR_RootConstrainSelectedInstOperands,
     /* 35943 */     // GIR_Coverage, 17454,
     /* 35943 */     GIR_EraseRootFromParent_Done,
     /* 35944 */   // Label 1023: @35944
     /* 35944 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(35981), // Rule ID 17456 //
     /* 35949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXBF16_In64BitMode),
     /* 35952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbf16ps),
     /* 35957 */     // MIs[0] src1
     /* 35957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 35960 */     // MIs[0] src2
     /* 35960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 35963 */     // MIs[0] src3
     /* 35963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 35966 */     // (intrinsic_void 14635:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBF16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 35966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBF16PS),
     /* 35969 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 35971 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 35973 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 35975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35979 */     GIR_RootConstrainSelectedInstOperands,
     /* 35980 */     // GIR_Coverage, 17456,
     /* 35980 */     GIR_EraseRootFromParent_Done,
     /* 35981 */   // Label 1024: @35981
     /* 35981 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(36018), // Rule ID 17458 //
     /* 35986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP16_In64BitMode),
     /* 35989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpfp16ps),
     /* 35994 */     // MIs[0] src1
     /* 35994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 35997 */     // MIs[0] src2
     /* 35997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36000 */     // MIs[0] src3
     /* 36000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36003 */     // (intrinsic_void 14649:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPFP16PS),
     /* 36006 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36008 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36010 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36016 */     GIR_RootConstrainSelectedInstOperands,
     /* 36017 */     // GIR_Coverage, 17458,
     /* 36017 */     GIR_EraseRootFromParent_Done,
     /* 36018 */   // Label 1025: @36018
     /* 36018 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(36055), // Rule ID 17461 //
     /* 36023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_In64BitMode),
     /* 36026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tcmmimfp16ps),
     /* 36031 */     // MIs[0] src1
     /* 36031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36034 */     // MIs[0] src2
     /* 36034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36037 */     // MIs[0] src3
     /* 36037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36040 */     // (intrinsic_void 14617:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCMMIMFP16PS),
     /* 36043 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36045 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36047 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36053 */     GIR_RootConstrainSelectedInstOperands,
     /* 36054 */     // GIR_Coverage, 17461,
     /* 36054 */     GIR_EraseRootFromParent_Done,
     /* 36055 */   // Label 1026: @36055
     /* 36055 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(36092), // Rule ID 17462 //
     /* 36060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_In64BitMode),
     /* 36063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tcmmrlfp16ps),
     /* 36068 */     // MIs[0] src1
     /* 36068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36071 */     // MIs[0] src2
     /* 36071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36074 */     // MIs[0] src3
     /* 36074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36077 */     // (intrinsic_void 14619:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCMMRLFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCMMRLFP16PS),
     /* 36080 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36082 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36084 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36090 */     GIR_RootConstrainSelectedInstOperands,
     /* 36091 */     // GIR_Coverage, 17462,
     /* 36091 */     GIR_EraseRootFromParent_Done,
     /* 36092 */   // Label 1027: @36092
     /* 36092 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(36129), // Rule ID 17463 //
     /* 36097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 36100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbf8ps),
     /* 36105 */     // MIs[0] src1
     /* 36105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36108 */     // MIs[0] src2
     /* 36108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36111 */     // MIs[0] src3
     /* 36111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36114 */     // (intrinsic_void 14637:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBF8PS),
     /* 36117 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36119 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36121 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36127 */     GIR_RootConstrainSelectedInstOperands,
     /* 36128 */     // GIR_Coverage, 17463,
     /* 36128 */     GIR_EraseRootFromParent_Done,
     /* 36129 */   // Label 1028: @36129
     /* 36129 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(36166), // Rule ID 17464 //
     /* 36134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 36137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbhf8ps),
     /* 36142 */     // MIs[0] src1
     /* 36142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36145 */     // MIs[0] src2
     /* 36145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36148 */     // MIs[0] src3
     /* 36148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36151 */     // (intrinsic_void 14639:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBHF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBHF8PS),
     /* 36154 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36158 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36164 */     GIR_RootConstrainSelectedInstOperands,
     /* 36165 */     // GIR_Coverage, 17464,
     /* 36165 */     GIR_EraseRootFromParent_Done,
     /* 36166 */   // Label 1029: @36166
     /* 36166 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(36203), // Rule ID 17465 //
     /* 36171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 36174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdphbf8ps),
     /* 36179 */     // MIs[0] src1
     /* 36179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36182 */     // MIs[0] src2
     /* 36182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36185 */     // MIs[0] src3
     /* 36185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36188 */     // (intrinsic_void 14651:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPHBF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPHBF8PS),
     /* 36191 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36193 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36195 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36201 */     GIR_RootConstrainSelectedInstOperands,
     /* 36202 */     // GIR_Coverage, 17465,
     /* 36202 */     GIR_EraseRootFromParent_Done,
     /* 36203 */   // Label 1030: @36203
     /* 36203 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(36240), // Rule ID 17466 //
     /* 36208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 36211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdphf8ps),
     /* 36216 */     // MIs[0] src1
     /* 36216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36219 */     // MIs[0] src2
     /* 36219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36222 */     // MIs[0] src3
     /* 36222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36225 */     // (intrinsic_void 14653:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPHF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPHF8PS),
     /* 36228 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36230 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36232 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36238 */     GIR_RootConstrainSelectedInstOperands,
     /* 36239 */     // GIR_Coverage, 17466,
     /* 36239 */     GIR_EraseRootFromParent_Done,
     /* 36240 */   // Label 1031: @36240
     /* 36240 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(36277), // Rule ID 17474 //
     /* 36245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXBF16_HasAMXTRANSPOSE_In64BitMode),
     /* 36248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttdpbf16ps),
     /* 36253 */     // MIs[0] src1
     /* 36253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36256 */     // MIs[0] src2
     /* 36256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36259 */     // MIs[0] src3
     /* 36259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36262 */     // (intrinsic_void 14678:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTDPBF16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTDPBF16PS),
     /* 36265 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36267 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36269 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36275 */     GIR_RootConstrainSelectedInstOperands,
     /* 36276 */     // GIR_Coverage, 17474,
     /* 36276 */     GIR_EraseRootFromParent_Done,
     /* 36277 */   // Label 1032: @36277
     /* 36277 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(36314), // Rule ID 17476 //
     /* 36282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP16_HasAMXTRANSPOSE_In64BitMode),
     /* 36285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttdpfp16ps),
     /* 36290 */     // MIs[0] src1
     /* 36290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36293 */     // MIs[0] src2
     /* 36293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36296 */     // MIs[0] src3
     /* 36296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36299 */     // (intrinsic_void 14680:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTDPFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTDPFP16PS),
     /* 36302 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36304 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36306 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36312 */     GIR_RootConstrainSelectedInstOperands,
     /* 36313 */     // GIR_Coverage, 17476,
     /* 36313 */     GIR_EraseRootFromParent_Done,
     /* 36314 */   // Label 1033: @36314
     /* 36314 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(36351), // Rule ID 17481 //
     /* 36319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 36322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttcmmimfp16ps),
     /* 36327 */     // MIs[0] src1
     /* 36327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36330 */     // MIs[0] src2
     /* 36330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36333 */     // MIs[0] src3
     /* 36333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36336 */     // (intrinsic_void 14674:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTCMMIMFP16PS),
     /* 36339 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36341 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36343 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36349 */     GIR_RootConstrainSelectedInstOperands,
     /* 36350 */     // GIR_Coverage, 17481,
     /* 36350 */     GIR_EraseRootFromParent_Done,
     /* 36351 */   // Label 1034: @36351
     /* 36351 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(36388), // Rule ID 17482 //
     /* 36356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 36359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttcmmrlfp16ps),
     /* 36364 */     // MIs[0] src1
     /* 36364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36367 */     // MIs[0] src2
     /* 36367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36370 */     // MIs[0] src3
     /* 36370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36373 */     // (intrinsic_void 14676:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTCMMRLFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTCMMRLFP16PS),
     /* 36376 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36378 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36380 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36386 */     GIR_RootConstrainSelectedInstOperands,
     /* 36387 */     // GIR_Coverage, 17482,
     /* 36387 */     GIR_EraseRootFromParent_Done,
     /* 36388 */   // Label 1035: @36388
     /* 36388 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(36425), // Rule ID 17483 //
     /* 36393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 36396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tconjtcmmimfp16ps),
     /* 36401 */     // MIs[0] src1
     /* 36401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36404 */     // MIs[0] src2
     /* 36404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36407 */     // MIs[0] src3
     /* 36407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36410 */     // (intrinsic_void 14621:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCONJTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCONJTCMMIMFP16PS),
     /* 36413 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36415 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36417 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36423 */     GIR_RootConstrainSelectedInstOperands,
     /* 36424 */     // GIR_Coverage, 17483,
     /* 36424 */     GIR_EraseRootFromParent_Done,
     /* 36425 */   // Label 1036: @36425
     /* 36425 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(36462), // Rule ID 17502 //
     /* 36430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTF32_In64BitMode),
     /* 36433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tmmultf32ps),
     /* 36438 */     // MIs[0] src1
     /* 36438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36441 */     // MIs[0] src2
     /* 36441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36444 */     // MIs[0] src3
     /* 36444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36447 */     // (intrinsic_void 14671:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTMMULTF32PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTMMULTF32PS),
     /* 36450 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36452 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36454 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36460 */     GIR_RootConstrainSelectedInstOperands,
     /* 36461 */     // GIR_Coverage, 17502,
     /* 36461 */     GIR_EraseRootFromParent_Done,
     /* 36462 */   // Label 1037: @36462
     /* 36462 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(36499), // Rule ID 17504 //
     /* 36467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTF32_HasAMXTRANSPOSE_In64BitMode),
     /* 36470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttmmultf32ps),
     /* 36475 */     // MIs[0] src1
     /* 36475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36478 */     // MIs[0] src2
     /* 36478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36481 */     // MIs[0] src3
     /* 36481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36484 */     // (intrinsic_void 14682:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTMMULTF32PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTMMULTF32PS),
     /* 36487 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36489 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36491 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36497 */     GIR_RootConstrainSelectedInstOperands,
     /* 36498 */     // GIR_Coverage, 17504,
     /* 36498 */     GIR_EraseRootFromParent_Done,
     /* 36499 */   // Label 1038: @36499
     /* 36499 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(36552), // Rule ID 17485 //
     /* 36504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 36507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowd2ps),
     /* 36512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 36515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 36522 */     // MIs[0] src1
     /* 36522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 36529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 36533 */     // MIs[1] Operand 1
     /* 36533 */     // No operand predicates
     /* 36533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 36535 */     // (intrinsic_w_chain:{ *:[v16f32] } 14625:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWD2PSrri:{ *:[v16f32] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 36535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWD2PSrri),
     /* 36538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 36540 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 36542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 36545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 36550 */     GIR_RootConstrainSelectedInstOperands,
     /* 36551 */     // GIR_Coverage, 17485,
     /* 36551 */     GIR_EraseRootFromParent_Done,
     /* 36552 */   // Label 1039: @36552
     /* 36552 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(36605), // Rule ID 17494 //
     /* 36557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 36560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phh),
     /* 36565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 36568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 36575 */     // MIs[0] src1
     /* 36575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 36582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 36586 */     // MIs[1] Operand 1
     /* 36586 */     // No operand predicates
     /* 36586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 36588 */     // (intrinsic_w_chain:{ *:[v32f16] } 14631:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWPS2PHHrri:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 36588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHHrri),
     /* 36591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 36593 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 36595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 36598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 36603 */     GIR_RootConstrainSelectedInstOperands,
     /* 36604 */     // GIR_Coverage, 17494,
     /* 36604 */     GIR_EraseRootFromParent_Done,
     /* 36605 */   // Label 1040: @36605
     /* 36605 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(36658), // Rule ID 17496 //
     /* 36610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 36613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phl),
     /* 36618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 36621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 36628 */     // MIs[0] src1
     /* 36628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 36635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 36639 */     // MIs[1] Operand 1
     /* 36639 */     // No operand predicates
     /* 36639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 36641 */     // (intrinsic_w_chain:{ *:[v32f16] } 14633:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWPS2PHLrri:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 36641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHLrri),
     /* 36644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 36646 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 36648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 36651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 36656 */     GIR_RootConstrainSelectedInstOperands,
     /* 36657 */     // GIR_Coverage, 17496,
     /* 36657 */     GIR_EraseRootFromParent_Done,
     /* 36658 */   // Label 1041: @36658
     /* 36658 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(36711), // Rule ID 17497 //
     /* 36663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 36666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tilemovrow),
     /* 36671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 36674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 36681 */     // MIs[0] src1
     /* 36681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 36688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 36692 */     // MIs[1] Operand 1
     /* 36692 */     // No operand predicates
     /* 36692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 36694 */     // (intrinsic_w_chain:{ *:[v16i32] } 14664:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTILEMOVROWrri:{ *:[v16i32] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 36694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEMOVROWrri),
     /* 36697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 36699 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 36701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 36704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 36709 */     GIR_RootConstrainSelectedInstOperands,
     /* 36710 */     // GIR_Coverage, 17497,
     /* 36710 */     GIR_EraseRootFromParent_Done,
     /* 36711 */   // Label 1042: @36711
     /* 36711 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(36756), // Rule ID 17486 //
     /* 36716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 36719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowd2ps),
     /* 36724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 36727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 36734 */     // MIs[0] src1
     /* 36734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 36741 */     // (intrinsic_w_chain:{ *:[v16f32] } 14625:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWD2PSrre:{ *:[v16f32] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 36741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWD2PSrre),
     /* 36744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 36746 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 36748 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 36750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36754 */     GIR_RootConstrainSelectedInstOperands,
     /* 36755 */     // GIR_Coverage, 17486,
     /* 36755 */     GIR_EraseRootFromParent_Done,
     /* 36756 */   // Label 1043: @36756
     /* 36756 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(36801), // Rule ID 17493 //
     /* 36761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 36764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phh),
     /* 36769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 36772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 36779 */     // MIs[0] src1
     /* 36779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 36786 */     // (intrinsic_w_chain:{ *:[v32f16] } 14631:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWPS2PHHrre:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 36786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHHrre),
     /* 36789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 36791 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 36793 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 36795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36799 */     GIR_RootConstrainSelectedInstOperands,
     /* 36800 */     // GIR_Coverage, 17493,
     /* 36800 */     GIR_EraseRootFromParent_Done,
     /* 36801 */   // Label 1044: @36801
     /* 36801 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(36846), // Rule ID 17495 //
     /* 36806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 36809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phl),
     /* 36814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 36817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 36824 */     // MIs[0] src1
     /* 36824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 36831 */     // (intrinsic_w_chain:{ *:[v32f16] } 14633:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWPS2PHLrre:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 36831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHLrre),
     /* 36834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 36836 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 36838 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 36840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36844 */     GIR_RootConstrainSelectedInstOperands,
     /* 36845 */     // GIR_Coverage, 17495,
     /* 36845 */     GIR_EraseRootFromParent_Done,
     /* 36846 */   // Label 1045: @36846
     /* 36846 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(36891), // Rule ID 17498 //
     /* 36851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 36854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tilemovrow),
     /* 36859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 36862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 36869 */     // MIs[0] src1
     /* 36869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 36876 */     // (intrinsic_w_chain:{ *:[v16i32] } 14664:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTILEMOVROWrre:{ *:[v16i32] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 36876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEMOVROWrre),
     /* 36879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 36881 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 36883 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 36885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36889 */     GIR_RootConstrainSelectedInstOperands,
     /* 36890 */     // GIR_Coverage, 17498,
     /* 36890 */     GIR_EraseRootFromParent_Done,
     /* 36891 */   // Label 1046: @36891
     /* 36891 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(36936), // Rule ID 122 //
     /* 36896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 36899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval32),
     /* 36904 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 36907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 36914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 36918 */     // MIs[0] cntl
     /* 36918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36921 */     // (intrinsic_void 14305:{ *:[iPTR] }, GR32:{ *:[i32] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL32rri GR32:{ *:[i32] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 36921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL32rri),
     /* 36924 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 36926 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 36928 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 36930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36934 */     GIR_RootConstrainSelectedInstOperands,
     /* 36935 */     // GIR_Coverage, 122,
     /* 36935 */     GIR_EraseRootFromParent_Done,
     /* 36936 */   // Label 1047: @36936
     /* 36936 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(36981), // Rule ID 124 //
     /* 36941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 36944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval64),
     /* 36949 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 36952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 36959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 36963 */     // MIs[0] cntl
     /* 36963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36966 */     // (intrinsic_void 14306:{ *:[iPTR] }, GR64:{ *:[i64] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL64rri GR64:{ *:[i64] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 36966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL64rri),
     /* 36969 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 36971 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 36973 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 36975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36979 */     GIR_RootConstrainSelectedInstOperands,
     /* 36980 */     // GIR_Coverage, 124,
     /* 36980 */     GIR_EraseRootFromParent_Done,
     /* 36981 */   // Label 1048: @36981
     /* 36981 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(37063), // Rule ID 17551 //
     /* 36986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsetbv),
     /* 36991 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 36994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32_ArgRef_and_GR32_CBRegClassID),
     /* 37004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 37008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 37012 */     // (intrinsic_void 14801:{ *:[iPTR] }, ECX:{ *:[i32] }, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSETBV)
     /* 37012 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37016 */     GIR_AddRegister, /*InsnID*/3, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37022 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 37026 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37030 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37036 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 37040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37044 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::ECX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // ECX
     /* 37054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSETBV),
     /* 37057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37061 */     GIR_RootConstrainSelectedInstOperands,
     /* 37062 */     // GIR_Coverage, 17551,
     /* 37062 */     GIR_EraseRootFromParent_Done,
     /* 37063 */   // Label 1049: @37063
     /* 37063 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(37112), // Rule ID 17740 //
     /* 37068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMWAITX),
     /* 37071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_mwaitx),
     /* 37076 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 37079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 37082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37097 */     // (intrinsic_void 14383:{ *:[iPTR] }, GR32:{ *:[i32] }:$ecx, GR32:{ *:[i32] }:$eax, GR32:{ *:[i32] }:$ebx)  =>  (MWAITX GR32:{ *:[i32] }:$ecx, GR32:{ *:[i32] }:$eax, GR32:{ *:[i32] }:$ebx)
     /* 37097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MWAITX),
     /* 37100 */     GIR_RootToRootCopy, /*OpIdx*/1, // ecx
     /* 37102 */     GIR_RootToRootCopy, /*OpIdx*/2, // eax
     /* 37104 */     GIR_RootToRootCopy, /*OpIdx*/3, // ebx
     /* 37106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37110 */     GIR_RootConstrainSelectedInstOperands,
     /* 37111 */     // GIR_Coverage, 17740,
     /* 37111 */     GIR_EraseRootFromParent_Done,
     /* 37112 */   // Label 1050: @37112
     /* 37112 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(37174), // Rule ID 2900 //
     /* 37117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_In64BitMode),
     /* 37120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 37125 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 37128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 37131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37139 */     // MIs[0] Operand 3
     /* 37139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 37143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64_with_sub_32bit_in_GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 37147 */     // (intrinsic_void 14481:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, RDI:{ *:[i64] })  =>  (VMASKMOVDQU64 VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 37147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37151 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::RDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37157 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // RDI
     /* 37161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVDQU64),
     /* 37164 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 37166 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 37168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37172 */     GIR_RootConstrainSelectedInstOperands,
     /* 37173 */     // GIR_Coverage, 2900,
     /* 37173 */     GIR_EraseRootFromParent_Done,
     /* 37174 */   // Label 1051: @37174
     /* 37174 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(37236), // Rule ID 2901 //
     /* 37179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 37182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 37187 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 37190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 37193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37201 */     // MIs[0] Operand 3
     /* 37201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/32,
     /* 37205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 37209 */     // (intrinsic_void 14481:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, EDI:{ *:[i32] })  =>  (VMASKMOVDQU VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 37209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37213 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37219 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // EDI
     /* 37223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVDQU),
     /* 37226 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 37228 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 37230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37234 */     GIR_RootConstrainSelectedInstOperands,
     /* 37235 */     // GIR_Coverage, 2901,
     /* 37235 */     GIR_EraseRootFromParent_Done,
     /* 37236 */   // Label 1052: @37236
     /* 37236 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(37298), // Rule ID 2902 //
     /* 37241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseSSE2),
     /* 37244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 37249 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 37252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 37255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37263 */     // MIs[0] Operand 3
     /* 37263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 37267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64_with_sub_32bit_in_GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 37271 */     // (intrinsic_void 14481:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, RDI:{ *:[i64] })  =>  (MASKMOVDQU64 VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 37271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37275 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::RDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37281 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // RDI
     /* 37285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MASKMOVDQU64),
     /* 37288 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 37290 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 37292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37296 */     GIR_RootConstrainSelectedInstOperands,
     /* 37297 */     // GIR_Coverage, 2902,
     /* 37297 */     GIR_EraseRootFromParent_Done,
     /* 37298 */   // Label 1053: @37298
     /* 37298 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(37360), // Rule ID 2903 //
     /* 37303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 37306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 37311 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 37314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 37317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37325 */     // MIs[0] Operand 3
     /* 37325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/32,
     /* 37329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 37333 */     // (intrinsic_void 14481:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, EDI:{ *:[i32] })  =>  (MASKMOVDQU VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 37333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37337 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // EDI
     /* 37347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MASKMOVDQU),
     /* 37350 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 37352 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 37354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37358 */     GIR_RootConstrainSelectedInstOperands,
     /* 37359 */     // GIR_Coverage, 2903,
     /* 37359 */     GIR_EraseRootFromParent_Done,
     /* 37360 */   // Label 1054: @37360
     /* 37360 */   GIM_Reject,
     /* 37361 */ // Label 1019: @37361
     /* 37361 */ GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(37449), // Rule ID 17435 //
     /* 37366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasKL),
     /* 37369 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 37372 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_loadiwkey),
     /* 37377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 37380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 37383 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 37386 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 37389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37397 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37401 */   GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 37405 */   // (intrinsic_void 14302:{ *:[iPTR] }, XMM0:{ *:[v2i64] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, EAX:{ *:[i32] })  =>  (LOADIWKEY:{ *:[i32] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 37405 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37409 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37415 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // EAX
     /* 37419 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37423 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::XMM0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37429 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // XMM0
     /* 37433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LOADIWKEY),
     /* 37436 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 37438 */   GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 37440 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 37443 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37447 */   GIR_RootConstrainSelectedInstOperands,
     /* 37448 */   // GIR_Coverage, 17435,
     /* 37448 */   GIR_EraseRootFromParent_Done,
     /* 37449 */ // Label 1055: @37449
     /* 37449 */ GIM_Reject,
     /* 37450 */ // Label 12: @37450
     /* 37450 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1059*/ GIMT_Encode4(37884),
     /* 37461 */ /*GILLT_s16*//*Label 1056*/ GIMT_Encode4(37473),
     /* 37465 */ /*GILLT_s32*//*Label 1057*/ GIMT_Encode4(37531),
     /* 37469 */ /*GILLT_s64*//*Label 1058*/ GIMT_Encode4(37706),
     /* 37473 */ // Label 1056: @37473
     /* 37473 */ GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(37530), // Rule ID 23014 //
     /* 37478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 37481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 37485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 37489 */   // (anyext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 37489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 37492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 37496 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37501 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 37505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37512 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 37519 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 37524 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 37529 */   // GIR_Coverage, 23014,
     /* 37529 */   GIR_EraseRootFromParent_Done,
     /* 37530 */ // Label 1060: @37530
     /* 37530 */ GIM_Reject,
     /* 37531 */ // Label 1057: @37531
     /* 37531 */ GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(37577), // Rule ID 19884 //
     /* 37536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 37539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37543 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37547 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 37551 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 37555 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 37560 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 37562 */   // (anyext:{ *:[i32] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] })
     /* 37562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37567 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37571 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 37576 */   // GIR_Coverage, 19884,
     /* 37576 */   GIR_EraseRootFromParent_Done,
     /* 37577 */ // Label 1061: @37577
     /* 37577 */ GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(37623), // Rule ID 19887 //
     /* 37582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 37585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37589 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37593 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 37597 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 37601 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 37606 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 37608 */   // (anyext:{ *:[i32] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK8:{ *:[v8i1] }:$src, GR32:{ *:[i32] })
     /* 37608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37613 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37617 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 37622 */   // GIR_Coverage, 19887,
     /* 37622 */   GIR_EraseRootFromParent_Done,
     /* 37623 */ // Label 1062: @37623
     /* 37623 */ GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(37646), // Rule ID 23015 //
     /* 37628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 37631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 37639 */   // (anyext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 37639 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 37644 */   GIR_RootConstrainSelectedInstOperands,
     /* 37645 */   // GIR_Coverage, 23015,
     /* 37645 */   GIR_Done,
     /* 37646 */ // Label 1063: @37646
     /* 37646 */ GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(37705), // Rule ID 23016 //
     /* 37651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 37654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 37658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 37662 */   // (anyext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] })
     /* 37662 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 37665 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37669 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37681 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37684 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 37686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 37689 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 37694 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 37699 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 37704 */   // GIR_Coverage, 23016,
     /* 37704 */   GIR_EraseRootFromParent_Done,
     /* 37705 */ // Label 1064: @37705
     /* 37705 */ GIM_Reject,
     /* 37706 */ // Label 1058: @37706
     /* 37706 */ GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(37765), // Rule ID 23017 //
     /* 37711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 37714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 37718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 37722 */   // (anyext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_32bit:{ *:[i32] })
     /* 37722 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 37725 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 37729 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37734 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 37738 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 37743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 37748 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 37754 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 37759 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 37764 */   // GIR_Coverage, 23017,
     /* 37764 */   GIR_EraseRootFromParent_Done,
     /* 37765 */ // Label 1065: @37765
     /* 37765 */ GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(37824), // Rule ID 23018 //
     /* 37770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 37773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 37777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 37781 */   // (anyext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src), sub_32bit:{ *:[i32] })
     /* 37781 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 37784 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 37788 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37793 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 37797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 37802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 37807 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 37813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 37818 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 37823 */   // GIR_Coverage, 23018,
     /* 37823 */   GIR_EraseRootFromParent_Done,
     /* 37824 */ // Label 1066: @37824
     /* 37824 */ GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(37883), // Rule ID 23019 //
     /* 37829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 37832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 37836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37840 */   // (anyext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR32:{ *:[i32] }:$src, sub_32bit:{ *:[i32] })
     /* 37840 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37843 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37847 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37852 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37859 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37862 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 37864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 37867 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 37872 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR64RegClassID),
     /* 37877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 37882 */   // GIR_Coverage, 23019,
     /* 37882 */   GIR_EraseRootFromParent_Done,
     /* 37883 */ // Label 1067: @37883
     /* 37883 */ GIM_Reject,
     /* 37884 */ // Label 1059: @37884
     /* 37884 */ GIM_Reject,
     /* 37885 */ // Label 13: @37885
     /* 37885 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 1076*/ GIMT_Encode4(38897),
     /* 37896 */ /*GILLT_s8*//*Label 1068*/ GIMT_Encode4(37980),
     /* 37900 */ /*GILLT_s16*//*Label 1069*/ GIMT_Encode4(38264), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 37932 */ /*GILLT_v4s32*//*Label 1070*/ GIMT_Encode4(38303), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 37944 */ /*GILLT_v8s16*//*Label 1071*/ GIMT_Encode4(38443),
     /* 37948 */ /*GILLT_v8s32*//*Label 1072*/ GIMT_Encode4(38606), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 37960 */ /*GILLT_v16s8*//*Label 1073*/ GIMT_Encode4(38633),
     /* 37964 */ /*GILLT_v16s16*//*Label 1074*/ GIMT_Encode4(38843), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 37976 */ /*GILLT_v32s8*//*Label 1075*/ GIMT_Encode4(38870),
     /* 37980 */ // Label 1068: @37980
     /* 37980 */ GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(38055), // Rule ID 19879 //
     /* 37985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 37988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 37992 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37996 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 38000 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 38004 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 38009 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38011 */   // (trunc:{ *:[i8] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 38011 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 38014 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38018 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38023 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38027 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 38032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38037 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 38044 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 38049 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 38054 */   // GIR_Coverage, 19879,
     /* 38054 */   GIR_EraseRootFromParent_Done,
     /* 38055 */ // Label 1077: @38055
     /* 38055 */ GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(38118), // Rule ID 23076 //
     /* 38060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 38063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 38066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 38070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 38074 */   // (trunc:{ *:[i8] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } GR32:{ *:[i32] }:$src, GR32_ABCD:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 38074 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 38077 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38081 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38086 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 38090 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32_ABCDRegClassID),
     /* 38095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38100 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 38107 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 38112 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32_ABCDRegClassID),
     /* 38117 */   // GIR_Coverage, 23076,
     /* 38117 */   GIR_EraseRootFromParent_Done,
     /* 38118 */ // Label 1078: @38118
     /* 38118 */ GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(38181), // Rule ID 23077 //
     /* 38123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 38126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 38129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 38133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 38137 */   // (trunc:{ *:[i8] } GR16:{ *:[i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i16] } GR16:{ *:[i16] }:$src, GR16_ABCD:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 38137 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 38140 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38144 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38149 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 38153 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16_ABCDRegClassID),
     /* 38158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38163 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 38170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 38175 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR16_ABCDRegClassID),
     /* 38180 */   // GIR_Coverage, 23077,
     /* 38180 */   GIR_EraseRootFromParent_Done,
     /* 38181 */ // Label 1079: @38181
     /* 38181 */ GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(38222), // Rule ID 23081 //
     /* 38186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 38189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 38192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 38196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 38200 */   // (trunc:{ *:[i8] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src, sub_8bit:{ *:[i32] })
     /* 38200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38205 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 38211 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 38216 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 38221 */   // GIR_Coverage, 23081,
     /* 38221 */   GIR_EraseRootFromParent_Done,
     /* 38222 */ // Label 1080: @38222
     /* 38222 */ GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(38263), // Rule ID 23082 //
     /* 38227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 38230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 38233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 38237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 38241 */   // (trunc:{ *:[i8] } GR16:{ *:[i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src, sub_8bit:{ *:[i32] })
     /* 38241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38246 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 38252 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 38257 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 38262 */   // GIR_Coverage, 23082,
     /* 38262 */   GIR_EraseRootFromParent_Done,
     /* 38263 */ // Label 1081: @38263
     /* 38263 */ GIM_Reject,
     /* 38264 */ // Label 1069: @38264
     /* 38264 */ GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(38302), // Rule ID 23075 //
     /* 38269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 38272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 38276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 38280 */   // (trunc:{ *:[i16] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src, sub_16bit:{ *:[i32] })
     /* 38280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38285 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 38291 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 38296 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 38301 */   // GIR_Coverage, 23075,
     /* 38301 */   GIR_EraseRootFromParent_Done,
     /* 38302 */ // Label 1082: @38302
     /* 38302 */ GIM_Reject,
     /* 38303 */ // Label 1070: @38303
     /* 38303 */ GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(38442),
     /* 38308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 38311 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(38334), // Rule ID 12259 //
     /* 38316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 38319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 38323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 38327 */     // (trunc:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)  =>  (VPMOVQDZ256rr:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)
     /* 38327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZ256rr),
     /* 38332 */     GIR_RootConstrainSelectedInstOperands,
     /* 38333 */     // GIR_Coverage, 12259,
     /* 38333 */     GIR_Done,
     /* 38334 */   // Label 1084: @38334
     /* 38334 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(38441), // Rule ID 22004 //
     /* 38339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 38342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 38346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 38350 */     // (trunc:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPMOVQDZrr:{ *:[v8i32] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 38350 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 38353 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38357 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 38364 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 38367 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38371 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38376 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 38379 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 38383 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 38386 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 38391 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 38396 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 38401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 38404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZrr),
     /* 38408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38413 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 38416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38423 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 38430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 38435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 38440 */     // GIR_Coverage, 22004,
     /* 38440 */     GIR_EraseRootFromParent_Done,
     /* 38441 */   // Label 1085: @38441
     /* 38441 */   GIM_Reject,
     /* 38442 */ // Label 1083: @38442
     /* 38442 */ GIM_Reject,
     /* 38443 */ // Label 1071: @38443
     /* 38443 */ GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(38469), // Rule ID 12235 //
     /* 38448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 38451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 38454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 38458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 38462 */   // (trunc:{ *:[v8i16] } VR512:{ *:[v8i64] }:$src)  =>  (VPMOVQWZrr:{ *:[v8i16] } VR512:{ *:[v8i64] }:$src)
     /* 38462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQWZrr),
     /* 38467 */   GIR_RootConstrainSelectedInstOperands,
     /* 38468 */   // GIR_Coverage, 12235,
     /* 38468 */   GIR_Done,
     /* 38469 */ // Label 1086: @38469
     /* 38469 */ GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(38495), // Rule ID 12313 //
     /* 38474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 38477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 38480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 38484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 38488 */   // (trunc:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVDWZ256rr:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)
     /* 38488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZ256rr),
     /* 38493 */   GIR_RootConstrainSelectedInstOperands,
     /* 38494 */   // GIR_Coverage, 12313,
     /* 38494 */   GIR_Done,
     /* 38495 */ // Label 1087: @38495
     /* 38495 */ GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(38605), // Rule ID 22003 //
     /* 38500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 38503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 38506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 38510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 38514 */   // (trunc:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPMOVDWZrr:{ *:[v16i16] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 38514 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 38517 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38521 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 38528 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 38531 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38535 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38540 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 38543 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 38547 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 38550 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 38555 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 38560 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 38565 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 38568 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 38572 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38577 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 38580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38587 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 38594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 38599 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 38604 */   // GIR_Coverage, 22003,
     /* 38604 */   GIR_EraseRootFromParent_Done,
     /* 38605 */ // Label 1088: @38605
     /* 38605 */ GIM_Reject,
     /* 38606 */ // Label 1072: @38606
     /* 38606 */ GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(38632), // Rule ID 12262 //
     /* 38611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 38614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 38617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 38621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 38625 */   // (trunc:{ *:[v8i32] } VR512:{ *:[v8i64] }:$src)  =>  (VPMOVQDZrr:{ *:[v8i32] } VR512:{ *:[v8i64] }:$src)
     /* 38625 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZrr),
     /* 38630 */   GIR_RootConstrainSelectedInstOperands,
     /* 38631 */   // GIR_Coverage, 12262,
     /* 38631 */   GIR_Done,
     /* 38632 */ // Label 1089: @38632
     /* 38632 */ GIM_Reject,
     /* 38633 */ // Label 1073: @38633
     /* 38633 */ GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(38659), // Rule ID 12289 //
     /* 38638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 38641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 38644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 38648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 38652 */   // (trunc:{ *:[v16i8] } VR512:{ *:[v16i32] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } VR512:{ *:[v16i32] }:$src)
     /* 38652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 38657 */   GIR_RootConstrainSelectedInstOperands,
     /* 38658 */   // GIR_Coverage, 12289,
     /* 38658 */   GIR_Done,
     /* 38659 */ // Label 1090: @38659
     /* 38659 */ GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(38685), // Rule ID 12340 //
     /* 38664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 38667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 38670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 38674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 38678 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVWBZ256rr:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)
     /* 38678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZ256rr),
     /* 38683 */   GIR_RootConstrainSelectedInstOperands,
     /* 38684 */   // GIR_Coverage, 12340,
     /* 38684 */   GIR_Done,
     /* 38685 */ // Label 1091: @38685
     /* 38685 */ GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(38795), // Rule ID 22005 //
     /* 38690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 38693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 38696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 38700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 38704 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPMOVWBZrr:{ *:[v32i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 38704 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 38707 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38711 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 38718 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 38721 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38725 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38730 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 38733 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 38737 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 38740 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 38745 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 38750 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 38755 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 38758 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZrr),
     /* 38762 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38767 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 38770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38777 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 38784 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 38789 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 38794 */   // GIR_Coverage, 22005,
     /* 38794 */   GIR_EraseRootFromParent_Done,
     /* 38795 */ // Label 1092: @38795
     /* 38795 */ GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(38842), // Rule ID 22096 //
     /* 38800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoBWI),
     /* 38803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 38806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 38810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 38814 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVZXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src))
     /* 38814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 38817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrr),
     /* 38821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38826 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 38830 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 38835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38837 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38840 */   GIR_RootConstrainSelectedInstOperands,
     /* 38841 */   // GIR_Coverage, 22096,
     /* 38841 */   GIR_EraseRootFromParent_Done,
     /* 38842 */ // Label 1093: @38842
     /* 38842 */ GIM_Reject,
     /* 38843 */ // Label 1074: @38843
     /* 38843 */ GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(38869), // Rule ID 12316 //
     /* 38848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 38851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 38854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 38858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 38862 */   // (trunc:{ *:[v16i16] } VR512:{ *:[v16i32] }:$src)  =>  (VPMOVDWZrr:{ *:[v16i16] } VR512:{ *:[v16i32] }:$src)
     /* 38862 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 38867 */   GIR_RootConstrainSelectedInstOperands,
     /* 38868 */   // GIR_Coverage, 12316,
     /* 38868 */   GIR_Done,
     /* 38869 */ // Label 1094: @38869
     /* 38869 */ GIM_Reject,
     /* 38870 */ // Label 1075: @38870
     /* 38870 */ GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(38896), // Rule ID 12343 //
     /* 38875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 38878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 38881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 38885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 38889 */   // (trunc:{ *:[v32i8] } VR512:{ *:[v32i16] }:$src)  =>  (VPMOVWBZrr:{ *:[v32i8] } VR512:{ *:[v32i16] }:$src)
     /* 38889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZrr),
     /* 38894 */   GIR_RootConstrainSelectedInstOperands,
     /* 38895 */   // GIR_Coverage, 12343,
     /* 38895 */   GIR_Done,
     /* 38896 */ // Label 1095: @38896
     /* 38896 */ GIM_Reject,
     /* 38897 */ // Label 1076: @38897
     /* 38897 */ GIM_Reject,
     /* 38898 */ // Label 14: @38898
     /* 38898 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1100*/ GIMT_Encode4(39503),
     /* 38909 */ /*GILLT_s8*//*Label 1096*/ GIMT_Encode4(38925),
     /* 38913 */ /*GILLT_s16*//*Label 1097*/ GIMT_Encode4(39007),
     /* 38917 */ /*GILLT_s32*//*Label 1098*/ GIMT_Encode4(39207),
     /* 38921 */ /*GILLT_s64*//*Label 1099*/ GIMT_Encode4(39349),
     /* 38925 */ // Label 1096: @38925
     /* 38925 */ GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(39006),
     /* 38930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 38934 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(38990), // Rule ID 22810 //
     /* 38939 */     // MIs[0] Operand 1
     /* 38939 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 38950 */     // 0:{ *:[i8] }  =>  (EXTRACT_SUBREG:{ *:[i8] } (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 38950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 38953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 38957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38962 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 38965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38972 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 38979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 38984 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 38989 */     // GIR_Coverage, 22810,
     /* 38989 */     GIR_EraseRootFromParent_Done,
     /* 38990 */   // Label 1102: @38990
     /* 38990 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(39005), // Rule ID 19 //
     /* 38995 */     // MIs[0] Operand 1
     /* 38995 */     // No operand predicates
     /* 38995 */     // (imm:{ *:[i8] }):$src  =>  (MOV8ri:{ *:[i8] } (imm:{ *:[i8] }):$src)
     /* 38995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8ri),
     /* 38998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 39003 */     GIR_RootConstrainSelectedInstOperands,
     /* 39004 */     // GIR_Coverage, 19,
     /* 39004 */     GIR_EraseRootFromParent_Done,
     /* 39005 */   // Label 1103: @39005
     /* 39005 */   GIM_Reject,
     /* 39006 */ // Label 1101: @39006
     /* 39006 */ GIM_Reject,
     /* 39007 */ // Label 1097: @39007
     /* 39007 */ GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(39206),
     /* 39012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 39016 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(39072), // Rule ID 22811 //
     /* 39021 */     // MIs[0] Operand 1
     /* 39021 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 39032 */     // 0:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 39032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 39035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 39039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39044 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 39047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 39052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39054 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 39061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 39066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 39071 */     // GIR_Coverage, 22811,
     /* 39071 */     GIR_EraseRootFromParent_Done,
     /* 39072 */   // Label 1105: @39072
     /* 39072 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(39131), // Rule ID 22813 //
     /* 39077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 39080 */     // MIs[0] Operand 1
     /* 39080 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 39091 */     // 1:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r1:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 39091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 39094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r1),
     /* 39098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39103 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 39106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 39111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39113 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 39120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 39125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 39130 */     // GIR_Coverage, 22813,
     /* 39130 */     GIR_EraseRootFromParent_Done,
     /* 39131 */   // Label 1106: @39131
     /* 39131 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(39190), // Rule ID 22814 //
     /* 39136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 39139 */     // MIs[0] Operand 1
     /* 39139 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 39150 */     // -1:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r_1:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 39150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 39153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r_1),
     /* 39157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39162 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 39165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 39170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39172 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 39179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 39184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 39189 */     // GIR_Coverage, 22814,
     /* 39189 */     GIR_EraseRootFromParent_Done,
     /* 39190 */   // Label 1107: @39190
     /* 39190 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(39205), // Rule ID 20 //
     /* 39195 */     // MIs[0] Operand 1
     /* 39195 */     // No operand predicates
     /* 39195 */     // (imm:{ *:[i16] }):$src  =>  (MOV16ri:{ *:[i16] } (imm:{ *:[i16] }):$src)
     /* 39195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16ri),
     /* 39198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 39203 */     GIR_RootConstrainSelectedInstOperands,
     /* 39204 */     // GIR_Coverage, 20,
     /* 39204 */     GIR_EraseRootFromParent_Done,
     /* 39205 */   // Label 1108: @39205
     /* 39205 */   GIM_Reject,
     /* 39206 */ // Label 1104: @39206
     /* 39206 */ GIM_Reject,
     /* 39207 */ // Label 1098: @39207
     /* 39207 */ GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(39237), // Rule ID 17600 //
     /* 39212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 39216 */   // MIs[0] Operand 1
     /* 39216 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 39227 */   // 0:{ *:[i32] }  =>  (MOV32r0:{ *:[i32] }:{ *:[i32] })
     /* 39227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 39230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39232 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 39235 */   GIR_RootConstrainSelectedInstOperands,
     /* 39236 */   // GIR_Coverage, 17600,
     /* 39236 */   GIR_EraseRootFromParent_Done,
     /* 39237 */ // Label 1109: @39237
     /* 39237 */ GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(39270), // Rule ID 17601 //
     /* 39242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 39245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 39249 */   // MIs[0] Operand 1
     /* 39249 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 39260 */   // 1:{ *:[i32] }  =>  (MOV32r1:{ *:[i32] }:{ *:[i32] })
     /* 39260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r1),
     /* 39263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39265 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 39268 */   GIR_RootConstrainSelectedInstOperands,
     /* 39269 */   // GIR_Coverage, 17601,
     /* 39269 */   GIR_EraseRootFromParent_Done,
     /* 39270 */ // Label 1110: @39270
     /* 39270 */ GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(39303), // Rule ID 17602 //
     /* 39275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 39278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 39282 */   // MIs[0] Operand 1
     /* 39282 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 39293 */   // -1:{ *:[i32] }  =>  (MOV32r_1:{ *:[i32] }:{ *:[i32] })
     /* 39293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r_1),
     /* 39296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39298 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 39301 */   GIR_RootConstrainSelectedInstOperands,
     /* 39302 */   // GIR_Coverage, 17602,
     /* 39302 */   GIR_EraseRootFromParent_Done,
     /* 39303 */ // Label 1111: @39303
     /* 39303 */ GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(39329), // Rule ID 17603 //
     /* 39308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotWin64WithoutFP_OptForMinSize),
     /* 39311 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32immSExt8),
     /* 39315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 39319 */   // MIs[0] Operand 1
     /* 39319 */   // No operand predicates
     /* 39319 */   // (imm:{ *:[i32] })<<P:Predicate_i32immSExt8>>:$src  =>  (MOV32ImmSExti8:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 39319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ImmSExti8),
     /* 39322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39324 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 39327 */   GIR_RootConstrainSelectedInstOperands,
     /* 39328 */   // GIR_Coverage, 17603,
     /* 39328 */   GIR_EraseRootFromParent_Done,
     /* 39329 */ // Label 1112: @39329
     /* 39329 */ GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(39348), // Rule ID 21 //
     /* 39334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 39338 */   // MIs[0] Operand 1
     /* 39338 */   // No operand predicates
     /* 39338 */   // (imm:{ *:[i32] }):$src  =>  (MOV32ri:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 39338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ri),
     /* 39341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39343 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 39346 */   GIR_RootConstrainSelectedInstOperands,
     /* 39347 */   // GIR_Coverage, 21,
     /* 39347 */   GIR_EraseRootFromParent_Done,
     /* 39348 */ // Label 1113: @39348
     /* 39348 */ GIM_Reject,
     /* 39349 */ // Label 1099: @39349
     /* 39349 */ GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(39411), // Rule ID 22812 //
     /* 39354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 39358 */   // MIs[0] Operand 1
     /* 39358 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 39369 */   // 0:{ *:[i64] }  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_32bit:{ *:[i32] })
     /* 39369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 39372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 39376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39381 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 39384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 39389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 39394 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 39400 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 39405 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 39410 */   // GIR_Coverage, 22812,
     /* 39410 */   GIR_EraseRootFromParent_Done,
     /* 39411 */ // Label 1114: @39411
     /* 39411 */ GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(39437), // Rule ID 17604 //
     /* 39416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotWin64WithoutFP_OptForMinSize),
     /* 39419 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt8),
     /* 39423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 39427 */   // MIs[0] Operand 1
     /* 39427 */   // No operand predicates
     /* 39427 */   // (imm:{ *:[i64] })<<P:Predicate_i64immSExt8>>:$src  =>  (MOV64ImmSExti8:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 39427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ImmSExti8),
     /* 39430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39432 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 39435 */   GIR_RootConstrainSelectedInstOperands,
     /* 39436 */   // GIR_Coverage, 17604,
     /* 39436 */   GIR_EraseRootFromParent_Done,
     /* 39437 */ // Label 1115: @39437
     /* 39437 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(39460), // Rule ID 17605 //
     /* 39442 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immZExt32),
     /* 39446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 39450 */   // MIs[0] Operand 1
     /* 39450 */   // No operand predicates
     /* 39450 */   // (imm:{ *:[i64] })<<P:Predicate_i64immZExt32>>:$src  =>  (MOV32ri64:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 39450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ri64),
     /* 39453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39455 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 39458 */   GIR_RootConstrainSelectedInstOperands,
     /* 39459 */   // GIR_Coverage, 17605,
     /* 39459 */   GIR_EraseRootFromParent_Done,
     /* 39460 */ // Label 1116: @39460
     /* 39460 */ GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(39483), // Rule ID 22 //
     /* 39465 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /* 39469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 39473 */   // MIs[0] Operand 1
     /* 39473 */   // No operand predicates
     /* 39473 */   // (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src  =>  (MOV64ri32:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 39473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ri32),
     /* 39476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39478 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 39481 */   GIR_RootConstrainSelectedInstOperands,
     /* 39482 */   // GIR_Coverage, 22,
     /* 39482 */   GIR_EraseRootFromParent_Done,
     /* 39483 */ // Label 1117: @39483
     /* 39483 */ GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(39502), // Rule ID 23 //
     /* 39488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 39492 */   // MIs[0] Operand 1
     /* 39492 */   // No operand predicates
     /* 39492 */   // (imm:{ *:[i64] }):$src  =>  (MOV64ri:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 39492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ri),
     /* 39495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39497 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 39500 */   GIR_RootConstrainSelectedInstOperands,
     /* 39501 */   // GIR_Coverage, 23,
     /* 39501 */   GIR_EraseRootFromParent_Done,
     /* 39502 */ // Label 1118: @39502
     /* 39502 */ GIM_Reject,
     /* 39503 */ // Label 1100: @39503
     /* 39503 */ GIM_Reject,
     /* 39504 */ // Label 15: @39504
     /* 39504 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 1122*/ GIMT_Encode4(39956),
     /* 39515 */ /*GILLT_s32*//*Label 1119*/ GIMT_Encode4(39527),
     /* 39519 */ /*GILLT_s64*//*Label 1120*/ GIMT_Encode4(39672),
     /* 39523 */ /*GILLT_s80*//*Label 1121*/ GIMT_Encode4(39817),
     /* 39527 */ // Label 1119: @39527
     /* 39527 */ GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(39553), // Rule ID 1113 //
     /* 39532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 39535 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 39539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 39543 */   // MIs[0] Operand 1
     /* 39543 */   // No operand predicates
     /* 39543 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (LD_Fp032:{ *:[f32] }:{ *:[i16] })
     /* 39543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp032),
     /* 39546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39548 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 39551 */   GIR_RootConstrainSelectedInstOperands,
     /* 39552 */   // GIR_Coverage, 1113,
     /* 39552 */   GIR_EraseRootFromParent_Done,
     /* 39553 */ // Label 1123: @39553
     /* 39553 */ GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(39579), // Rule ID 1114 //
     /* 39558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 39561 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 39565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 39569 */   // MIs[0] Operand 1
     /* 39569 */   // No operand predicates
     /* 39569 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm1>>  =>  (LD_Fp132:{ *:[f32] }:{ *:[i16] })
     /* 39569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp132),
     /* 39572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39574 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 39577 */   GIR_RootConstrainSelectedInstOperands,
     /* 39578 */   // GIR_Coverage, 1114,
     /* 39578 */   GIR_EraseRootFromParent_Done,
     /* 39579 */ // Label 1124: @39579
     /* 39579 */ GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(39625), // Rule ID 18167 //
     /* 39584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 39587 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 39591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 39595 */   // MIs[0] Operand 1
     /* 39595 */   // No operand predicates
     /* 39595 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } (LD_Fp032:{ *:[f32] }:{ *:[i16] }))
     /* 39595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 39598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp032),
     /* 39602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39607 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 39610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 39615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39620 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 39623 */   GIR_RootConstrainSelectedInstOperands,
     /* 39624 */   // GIR_Coverage, 18167,
     /* 39624 */   GIR_EraseRootFromParent_Done,
     /* 39625 */ // Label 1125: @39625
     /* 39625 */ GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(39671), // Rule ID 18168 //
     /* 39630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 39633 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 39637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 39641 */   // MIs[0] Operand 1
     /* 39641 */   // No operand predicates
     /* 39641 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } (LD_Fp132:{ *:[f32] }:{ *:[i16] }))
     /* 39641 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 39644 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp132),
     /* 39648 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39653 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 39656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 39661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39666 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 39669 */   GIR_RootConstrainSelectedInstOperands,
     /* 39670 */   // GIR_Coverage, 18168,
     /* 39670 */   GIR_EraseRootFromParent_Done,
     /* 39671 */ // Label 1126: @39671
     /* 39671 */ GIM_Reject,
     /* 39672 */ // Label 1120: @39672
     /* 39672 */ GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(39698), // Rule ID 1115 //
     /* 39677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 39680 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 39684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 39688 */   // MIs[0] Operand 1
     /* 39688 */   // No operand predicates
     /* 39688 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (LD_Fp064:{ *:[f64] }:{ *:[i16] })
     /* 39688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp064),
     /* 39691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39693 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 39696 */   GIR_RootConstrainSelectedInstOperands,
     /* 39697 */   // GIR_Coverage, 1115,
     /* 39697 */   GIR_EraseRootFromParent_Done,
     /* 39698 */ // Label 1127: @39698
     /* 39698 */ GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(39724), // Rule ID 1116 //
     /* 39703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 39706 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 39710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 39714 */   // MIs[0] Operand 1
     /* 39714 */   // No operand predicates
     /* 39714 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm1>>  =>  (LD_Fp164:{ *:[f64] }:{ *:[i16] })
     /* 39714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp164),
     /* 39717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39719 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 39722 */   GIR_RootConstrainSelectedInstOperands,
     /* 39723 */   // GIR_Coverage, 1116,
     /* 39723 */   GIR_EraseRootFromParent_Done,
     /* 39724 */ // Label 1128: @39724
     /* 39724 */ GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(39770), // Rule ID 18169 //
     /* 39729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 39732 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 39736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 39740 */   // MIs[0] Operand 1
     /* 39740 */   // No operand predicates
     /* 39740 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } (LD_Fp064:{ *:[f64] }:{ *:[i16] }))
     /* 39740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 39743 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp064),
     /* 39747 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39752 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 39755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 39760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39762 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39765 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 39768 */   GIR_RootConstrainSelectedInstOperands,
     /* 39769 */   // GIR_Coverage, 18169,
     /* 39769 */   GIR_EraseRootFromParent_Done,
     /* 39770 */ // Label 1129: @39770
     /* 39770 */ GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(39816), // Rule ID 18170 //
     /* 39775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 39778 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 39782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 39786 */   // MIs[0] Operand 1
     /* 39786 */   // No operand predicates
     /* 39786 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } (LD_Fp164:{ *:[f64] }:{ *:[i16] }))
     /* 39786 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 39789 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp164),
     /* 39793 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39798 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 39801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 39806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39811 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 39814 */   GIR_RootConstrainSelectedInstOperands,
     /* 39815 */   // GIR_Coverage, 18170,
     /* 39815 */   GIR_EraseRootFromParent_Done,
     /* 39816 */ // Label 1130: @39816
     /* 39816 */ GIM_Reject,
     /* 39817 */ // Label 1121: @39817
     /* 39817 */ GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(39843), // Rule ID 1117 //
     /* 39822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 39825 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 39829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 39833 */   // MIs[0] Operand 1
     /* 39833 */   // No operand predicates
     /* 39833 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimm0>>  =>  (LD_Fp080:{ *:[f80] }:{ *:[i16] })
     /* 39833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp080),
     /* 39836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39838 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 39841 */   GIR_RootConstrainSelectedInstOperands,
     /* 39842 */   // GIR_Coverage, 1117,
     /* 39842 */   GIR_EraseRootFromParent_Done,
     /* 39843 */ // Label 1131: @39843
     /* 39843 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(39869), // Rule ID 1118 //
     /* 39848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 39851 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 39855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 39859 */   // MIs[0] Operand 1
     /* 39859 */   // No operand predicates
     /* 39859 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimm1>>  =>  (LD_Fp180:{ *:[f80] }:{ *:[i16] })
     /* 39859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp180),
     /* 39862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39864 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 39867 */   GIR_RootConstrainSelectedInstOperands,
     /* 39868 */   // GIR_Coverage, 1118,
     /* 39868 */   GIR_EraseRootFromParent_Done,
     /* 39869 */ // Label 1132: @39869
     /* 39869 */ GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(39912), // Rule ID 18171 //
     /* 39874 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 39878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 39882 */   // MIs[0] Operand 1
     /* 39882 */   // No operand predicates
     /* 39882 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } (LD_Fp080:{ *:[f80] }:{ *:[i16] }))
     /* 39882 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s80,
     /* 39885 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp080),
     /* 39889 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39894 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 39897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 39902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39904 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39907 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 39910 */   GIR_RootConstrainSelectedInstOperands,
     /* 39911 */   // GIR_Coverage, 18171,
     /* 39911 */   GIR_EraseRootFromParent_Done,
     /* 39912 */ // Label 1133: @39912
     /* 39912 */ GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(39955), // Rule ID 18172 //
     /* 39917 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 39921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 39925 */   // MIs[0] Operand 1
     /* 39925 */   // No operand predicates
     /* 39925 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } (LD_Fp180:{ *:[f80] }:{ *:[i16] }))
     /* 39925 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s80,
     /* 39928 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp180),
     /* 39932 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39937 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 39940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 39945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39950 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 39953 */   GIR_RootConstrainSelectedInstOperands,
     /* 39954 */   // GIR_Coverage, 18172,
     /* 39954 */   GIR_EraseRootFromParent_Done,
     /* 39955 */ // Label 1134: @39955
     /* 39955 */ GIM_Reject,
     /* 39956 */ // Label 1122: @39956
     /* 39956 */ GIM_Reject,
     /* 39957 */ // Label 16: @39957
     /* 39957 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(25), /*)*//*default:*//*Label 1150*/ GIMT_Encode4(40979),
     /* 39968 */ /*GILLT_s16*//*Label 1135*/ GIMT_Encode4(40060),
     /* 39972 */ /*GILLT_s32*//*Label 1136*/ GIMT_Encode4(40118),
     /* 39976 */ /*GILLT_s64*//*Label 1137*/ GIMT_Encode4(40165), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 39992 */ /*GILLT_v2s64*//*Label 1138*/ GIMT_Encode4(40238), GIMT_Encode4(0),
     /* 40000 */ /*GILLT_v4s32*//*Label 1139*/ GIMT_Encode4(40265),
     /* 40004 */ /*GILLT_v4s64*//*Label 1140*/ GIMT_Encode4(40292), GIMT_Encode4(0),
     /* 40012 */ /*GILLT_v8s16*//*Label 1141*/ GIMT_Encode4(40371),
     /* 40016 */ /*GILLT_v8s32*//*Label 1142*/ GIMT_Encode4(40440),
     /* 40020 */ /*GILLT_v8s64*//*Label 1143*/ GIMT_Encode4(40519), GIMT_Encode4(0),
     /* 40028 */ /*GILLT_v16s8*//*Label 1144*/ GIMT_Encode4(40598),
     /* 40032 */ /*GILLT_v16s16*//*Label 1145*/ GIMT_Encode4(40667),
     /* 40036 */ /*GILLT_v16s32*//*Label 1146*/ GIMT_Encode4(40793), GIMT_Encode4(0),
     /* 40044 */ /*GILLT_v32s8*//*Label 1147*/ GIMT_Encode4(40872),
     /* 40048 */ /*GILLT_v32s16*//*Label 1148*/ GIMT_Encode4(40899), GIMT_Encode4(0),
     /* 40056 */ /*GILLT_v64s8*//*Label 1149*/ GIMT_Encode4(40952),
     /* 40060 */ // Label 1135: @40060
     /* 40060 */ GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(40117), // Rule ID 23071 //
     /* 40065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 40068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 40072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 40076 */   // (sext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 40076 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 40079 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 40083 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 40088 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 40092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 40094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 40097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 40099 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 40106 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 40111 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 40116 */   // GIR_Coverage, 23071,
     /* 40116 */   GIR_EraseRootFromParent_Done,
     /* 40117 */ // Label 1151: @40117
     /* 40117 */ GIM_Reject,
     /* 40118 */ // Label 1136: @40118
     /* 40118 */ GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(40141), // Rule ID 612 //
     /* 40123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 40126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 40130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 40134 */   // (sext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVSX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 40134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 40139 */   GIR_RootConstrainSelectedInstOperands,
     /* 40140 */   // GIR_Coverage, 612,
     /* 40140 */   GIR_Done,
     /* 40141 */ // Label 1152: @40141
     /* 40141 */ GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(40164), // Rule ID 614 //
     /* 40146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 40149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 40153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 40157 */   // (sext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (MOVSX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /* 40157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr16),
     /* 40162 */   GIR_RootConstrainSelectedInstOperands,
     /* 40163 */   // GIR_Coverage, 614,
     /* 40163 */   GIR_Done,
     /* 40164 */ // Label 1153: @40164
     /* 40164 */ GIM_Reject,
     /* 40165 */ // Label 1137: @40165
     /* 40165 */ GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(40188), // Rule ID 620 //
     /* 40170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 40173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 40177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 40181 */   // (sext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (MOVSX64rr8:{ *:[i64] } GR8:{ *:[i8] }:$src)
     /* 40181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr8),
     /* 40186 */   GIR_RootConstrainSelectedInstOperands,
     /* 40187 */   // GIR_Coverage, 620,
     /* 40187 */   GIR_Done,
     /* 40188 */ // Label 1154: @40188
     /* 40188 */ GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(40211), // Rule ID 622 //
     /* 40193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 40196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 40200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 40204 */   // (sext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (MOVSX64rr16:{ *:[i64] } GR16:{ *:[i16] }:$src)
     /* 40204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr16),
     /* 40209 */   GIR_RootConstrainSelectedInstOperands,
     /* 40210 */   // GIR_Coverage, 622,
     /* 40210 */   GIR_Done,
     /* 40211 */ // Label 1155: @40211
     /* 40211 */ GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(40237), // Rule ID 624 //
     /* 40216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 40219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 40222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 40226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 40230 */   // (sext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (MOVSX64rr32:{ *:[i64] } GR32:{ *:[i32] }:$src)
     /* 40230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr32),
     /* 40235 */   GIR_RootConstrainSelectedInstOperands,
     /* 40236 */   // GIR_Coverage, 624,
     /* 40236 */   GIR_Done,
     /* 40237 */ // Label 1156: @40237
     /* 40237 */ GIM_Reject,
     /* 40238 */ // Label 1138: @40238
     /* 40238 */ GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(40264), // Rule ID 12591 //
     /* 40243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 40246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 40249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 40253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 40257 */   // (sext:{ *:[v2i64] } VK2:{ *:[v2i1] }:$src)  =>  (VPMOVM2QZ128rk:{ *:[v2i64] } VK2:{ *:[v2i1] }:$src)
     /* 40257 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZ128rk),
     /* 40262 */   GIR_RootConstrainSelectedInstOperands,
     /* 40263 */   // GIR_Coverage, 12591,
     /* 40263 */   GIR_Done,
     /* 40264 */ // Label 1157: @40264
     /* 40264 */ GIM_Reject,
     /* 40265 */ // Label 1139: @40265
     /* 40265 */ GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(40291), // Rule ID 12588 //
     /* 40270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 40273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 40276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 40280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 40284 */   // (sext:{ *:[v4i32] } VK4:{ *:[v4i1] }:$src)  =>  (VPMOVM2DZ128rk:{ *:[v4i32] } VK4:{ *:[v4i1] }:$src)
     /* 40284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ128rk),
     /* 40289 */   GIR_RootConstrainSelectedInstOperands,
     /* 40290 */   // GIR_Coverage, 12588,
     /* 40290 */   GIR_Done,
     /* 40291 */ // Label 1158: @40291
     /* 40291 */ GIM_Reject,
     /* 40292 */ // Label 1140: @40292
     /* 40292 */ GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(40318), // Rule ID 12568 //
     /* 40297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 40300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 40303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 40307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 40311 */   // (sext:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)  =>  (VPMOVSXDQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)
     /* 40311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZ256rr),
     /* 40316 */   GIR_RootConstrainSelectedInstOperands,
     /* 40317 */   // GIR_Coverage, 12568,
     /* 40317 */   GIR_Done,
     /* 40318 */ // Label 1159: @40318
     /* 40318 */ GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(40344), // Rule ID 12590 //
     /* 40323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 40326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 40329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 40333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 40337 */   // (sext:{ *:[v4i64] } VK4:{ *:[v4i1] }:$src)  =>  (VPMOVM2QZ256rk:{ *:[v4i64] } VK4:{ *:[v4i1] }:$src)
     /* 40337 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZ256rk),
     /* 40342 */   GIR_RootConstrainSelectedInstOperands,
     /* 40343 */   // GIR_Coverage, 12590,
     /* 40343 */   GIR_Done,
     /* 40344 */ // Label 1160: @40344
     /* 40344 */ GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(40370), // Rule ID 18825 //
     /* 40349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 40352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 40355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 40359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 40363 */   // (sext:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)  =>  (VPMOVSXDQYrr:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)
     /* 40363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQYrr),
     /* 40368 */   GIR_RootConstrainSelectedInstOperands,
     /* 40369 */   // GIR_Coverage, 18825,
     /* 40369 */   GIR_Done,
     /* 40370 */ // Label 1161: @40370
     /* 40370 */ GIM_Reject,
     /* 40371 */ // Label 1141: @40371
     /* 40371 */ GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(40439),
     /* 40376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 40379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 40383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 40387 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(40402), // Rule ID 12585 //
     /* 40392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 40395 */     // (sext:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2WZ128rk:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)
     /* 40395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZ128rk),
     /* 40400 */     GIR_RootConstrainSelectedInstOperands,
     /* 40401 */     // GIR_Coverage, 12585,
     /* 40401 */     GIR_Done,
     /* 40402 */   // Label 1163: @40402
     /* 40402 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(40438), // Rule ID 22108 //
     /* 40407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX_NoBWI),
     /* 40410 */     // (sext:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVDWZ256rr:{ *:[v8i16] } (VPMOVM2DZ256rk:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src))
     /* 40410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 40413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ256rk),
     /* 40417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 40422 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 40426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 40428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZ256rr),
     /* 40431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 40433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 40436 */     GIR_RootConstrainSelectedInstOperands,
     /* 40437 */     // GIR_Coverage, 22108,
     /* 40437 */     GIR_EraseRootFromParent_Done,
     /* 40438 */   // Label 1164: @40438
     /* 40438 */   GIM_Reject,
     /* 40439 */ // Label 1162: @40439
     /* 40439 */ GIM_Reject,
     /* 40440 */ // Label 1142: @40440
     /* 40440 */ GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(40466), // Rule ID 12532 //
     /* 40445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 40448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 40455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 40459 */   // (sext:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVSXWDZ256rr:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)
     /* 40459 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZ256rr),
     /* 40464 */   GIR_RootConstrainSelectedInstOperands,
     /* 40465 */   // GIR_Coverage, 12532,
     /* 40465 */   GIR_Done,
     /* 40466 */ // Label 1165: @40466
     /* 40466 */ GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(40492), // Rule ID 12587 //
     /* 40471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 40474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 40477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 40481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 40485 */   // (sext:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2DZ256rk:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src)
     /* 40485 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ256rk),
     /* 40490 */   GIR_RootConstrainSelectedInstOperands,
     /* 40491 */   // GIR_Coverage, 12587,
     /* 40491 */   GIR_Done,
     /* 40492 */ // Label 1166: @40492
     /* 40492 */ GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(40518), // Rule ID 18823 //
     /* 40497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 40500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 40507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 40511 */   // (sext:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)  =>  (VPMOVSXWDYrr:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)
     /* 40511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDYrr),
     /* 40516 */   GIR_RootConstrainSelectedInstOperands,
     /* 40517 */   // GIR_Coverage, 18823,
     /* 40517 */   GIR_Done,
     /* 40518 */ // Label 1167: @40518
     /* 40518 */ GIM_Reject,
     /* 40519 */ // Label 1143: @40519
     /* 40519 */ GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(40545), // Rule ID 12556 //
     /* 40524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 40527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 40534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 40538 */   // (sext:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVSXWQZrr:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)
     /* 40538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWQZrr),
     /* 40543 */   GIR_RootConstrainSelectedInstOperands,
     /* 40544 */   // GIR_Coverage, 12556,
     /* 40544 */   GIR_Done,
     /* 40545 */ // Label 1168: @40545
     /* 40545 */ GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(40571), // Rule ID 12574 //
     /* 40550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 40553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 40556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 40560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 40564 */   // (sext:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVSXDQZrr:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)
     /* 40564 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZrr),
     /* 40569 */   GIR_RootConstrainSelectedInstOperands,
     /* 40570 */   // GIR_Coverage, 12574,
     /* 40570 */   GIR_Done,
     /* 40571 */ // Label 1169: @40571
     /* 40571 */ GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(40597), // Rule ID 12589 //
     /* 40576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 40579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 40582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 40586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 40590 */   // (sext:{ *:[v8i64] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2QZrk:{ *:[v8i64] } VK8:{ *:[v8i1] }:$src)
     /* 40590 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZrk),
     /* 40595 */   GIR_RootConstrainSelectedInstOperands,
     /* 40596 */   // GIR_Coverage, 12589,
     /* 40596 */   GIR_Done,
     /* 40597 */ // Label 1170: @40597
     /* 40597 */ GIM_Reject,
     /* 40598 */ // Label 1144: @40598
     /* 40598 */ GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(40666),
     /* 40603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 40606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 40610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 40614 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(40629), // Rule ID 12582 //
     /* 40619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 40622 */     // (sext:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2BZ128rk:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)
     /* 40622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZ128rk),
     /* 40627 */     GIR_RootConstrainSelectedInstOperands,
     /* 40628 */     // GIR_Coverage, 12582,
     /* 40628 */     GIR_Done,
     /* 40629 */   // Label 1172: @40629
     /* 40629 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(40665), // Rule ID 22106 //
     /* 40634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoBWI),
     /* 40637 */     // (sext:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src))
     /* 40637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 40640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 40644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 40649 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 40653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 40655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 40658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 40660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 40663 */     GIR_RootConstrainSelectedInstOperands,
     /* 40664 */     // GIR_Coverage, 22106,
     /* 40664 */     GIR_EraseRootFromParent_Done,
     /* 40665 */   // Label 1173: @40665
     /* 40665 */   GIM_Reject,
     /* 40666 */ // Label 1171: @40666
     /* 40666 */ GIM_Reject,
     /* 40667 */ // Label 1145: @40667
     /* 40667 */ GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(40693), // Rule ID 12478 //
     /* 40672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 40675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 40678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 40682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 40686 */   // (sext:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVSXBWZ256rr:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)
     /* 40686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZ256rr),
     /* 40691 */   GIR_RootConstrainSelectedInstOperands,
     /* 40692 */   // GIR_Coverage, 12478,
     /* 40692 */   GIR_Done,
     /* 40693 */ // Label 1174: @40693
     /* 40693 */ GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(40719), // Rule ID 12584 //
     /* 40698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 40701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 40704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 40708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 40712 */   // (sext:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2WZ256rk:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)
     /* 40712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZ256rk),
     /* 40717 */   GIR_RootConstrainSelectedInstOperands,
     /* 40718 */   // GIR_Coverage, 12584,
     /* 40718 */   GIR_Done,
     /* 40719 */ // Label 1175: @40719
     /* 40719 */ GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(40745), // Rule ID 18820 //
     /* 40724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 40727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 40730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 40734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 40738 */   // (sext:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)  =>  (VPMOVSXBWYrr:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)
     /* 40738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWYrr),
     /* 40743 */   GIR_RootConstrainSelectedInstOperands,
     /* 40744 */   // GIR_Coverage, 18820,
     /* 40744 */   GIR_Done,
     /* 40745 */ // Label 1176: @40745
     /* 40745 */ GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(40792), // Rule ID 22107 //
     /* 40750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoBWI),
     /* 40753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 40756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 40760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 40764 */   // (sext:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVDWZrr:{ *:[v16i16] } (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src))
     /* 40764 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 40767 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 40771 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 40776 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 40780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 40782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 40785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 40787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 40790 */   GIR_RootConstrainSelectedInstOperands,
     /* 40791 */   // GIR_Coverage, 22107,
     /* 40791 */   GIR_EraseRootFromParent_Done,
     /* 40792 */ // Label 1177: @40792
     /* 40792 */ GIM_Reject,
     /* 40793 */ // Label 1146: @40793
     /* 40793 */ GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(40819), // Rule ID 12502 //
     /* 40798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 40801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 40804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 40808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 40812 */   // (sext:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVSXBDZrr:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)
     /* 40812 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBDZrr),
     /* 40817 */   GIR_RootConstrainSelectedInstOperands,
     /* 40818 */   // GIR_Coverage, 12502,
     /* 40818 */   GIR_Done,
     /* 40819 */ // Label 1178: @40819
     /* 40819 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(40845), // Rule ID 12538 //
     /* 40824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 40827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 40830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 40834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 40838 */   // (sext:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVSXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)
     /* 40838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZrr),
     /* 40843 */   GIR_RootConstrainSelectedInstOperands,
     /* 40844 */   // GIR_Coverage, 12538,
     /* 40844 */   GIR_Done,
     /* 40845 */ // Label 1179: @40845
     /* 40845 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(40871), // Rule ID 12586 //
     /* 40850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 40853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 40856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 40860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 40864 */   // (sext:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src)
     /* 40864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 40869 */   GIR_RootConstrainSelectedInstOperands,
     /* 40870 */   // GIR_Coverage, 12586,
     /* 40870 */   GIR_Done,
     /* 40871 */ // Label 1180: @40871
     /* 40871 */ GIM_Reject,
     /* 40872 */ // Label 1147: @40872
     /* 40872 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(40898), // Rule ID 12581 //
     /* 40877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 40880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 40883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 40887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 40891 */   // (sext:{ *:[v32i8] } VK32:{ *:[v32i1] }:$src)  =>  (VPMOVM2BZ256rk:{ *:[v32i8] } VK32:{ *:[v32i1] }:$src)
     /* 40891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZ256rk),
     /* 40896 */   GIR_RootConstrainSelectedInstOperands,
     /* 40897 */   // GIR_Coverage, 12581,
     /* 40897 */   GIR_Done,
     /* 40898 */ // Label 1181: @40898
     /* 40898 */ GIM_Reject,
     /* 40899 */ // Label 1148: @40899
     /* 40899 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(40925), // Rule ID 12484 //
     /* 40904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 40907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 40910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 40914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 40918 */   // (sext:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)  =>  (VPMOVSXBWZrr:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)
     /* 40918 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZrr),
     /* 40923 */   GIR_RootConstrainSelectedInstOperands,
     /* 40924 */   // GIR_Coverage, 12484,
     /* 40924 */   GIR_Done,
     /* 40925 */ // Label 1182: @40925
     /* 40925 */ GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(40951), // Rule ID 12583 //
     /* 40930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 40933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 40936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 40940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 40944 */   // (sext:{ *:[v32i16] } VK32:{ *:[v32i1] }:$src)  =>  (VPMOVM2WZrk:{ *:[v32i16] } VK32:{ *:[v32i1] }:$src)
     /* 40944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZrk),
     /* 40949 */   GIR_RootConstrainSelectedInstOperands,
     /* 40950 */   // GIR_Coverage, 12583,
     /* 40950 */   GIR_Done,
     /* 40951 */ // Label 1183: @40951
     /* 40951 */ GIM_Reject,
     /* 40952 */ // Label 1149: @40952
     /* 40952 */ GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(40978), // Rule ID 12580 //
     /* 40957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 40960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 40963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 40967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 40971 */   // (sext:{ *:[v64i8] } VK64:{ *:[v64i1] }:$src)  =>  (VPMOVM2BZrk:{ *:[v64i8] } VK64:{ *:[v64i1] }:$src)
     /* 40971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZrk),
     /* 40976 */   GIR_RootConstrainSelectedInstOperands,
     /* 40977 */   // GIR_Coverage, 12580,
     /* 40977 */   GIR_Done,
     /* 40978 */ // Label 1184: @40978
     /* 40978 */ GIM_Reject,
     /* 40979 */ // Label 1150: @40979
     /* 40979 */ GIM_Reject,
     /* 40980 */ // Label 17: @40980
     /* 40980 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1187*/ GIMT_Encode4(41221),
     /* 40991 */ /*GILLT_s16*//*Label 1185*/ GIMT_Encode4(40999),
     /* 40995 */ /*GILLT_s32*//*Label 1186*/ GIMT_Encode4(41095),
     /* 40999 */ // Label 1185: @40999
     /* 40999 */ GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(41094), // Rule ID 23067 //
     /* 41004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 41007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 41011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 41015 */   // MIs[0] Operand 2
     /* 41015 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 41026 */   // (sext_inreg:{ *:[i16] } GR16:{ *:[i16] }:$src, i8:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src, sub_8bit:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /* 41026 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 41029 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 41033 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41038 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 41044 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 41049 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 41054 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 41057 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 41061 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41066 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 41069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 41071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 41074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41076 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 41083 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 41088 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 41093 */   // GIR_Coverage, 23067,
     /* 41093 */   GIR_EraseRootFromParent_Done,
     /* 41094 */ // Label 1188: @41094
     /* 41094 */ GIM_Reject,
     /* 41095 */ // Label 1186: @41095
     /* 41095 */ GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(41220),
     /* 41100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 41103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 41107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 41111 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(41165), // Rule ID 23065 //
     /* 41116 */     // MIs[0] Operand 2
     /* 41116 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 41127 */     // (sext_inreg:{ *:[i32] } GR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (MOVSX32rr16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src, sub_16bit:{ *:[i32] }))
     /* 41127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 41130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 41134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41139 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 41145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 41150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 41155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr16),
     /* 41158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41163 */     GIR_RootConstrainSelectedInstOperands,
     /* 41164 */     // GIR_Coverage, 23065,
     /* 41164 */     GIR_EraseRootFromParent_Done,
     /* 41165 */   // Label 1190: @41165
     /* 41165 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(41219), // Rule ID 23066 //
     /* 41170 */     // MIs[0] Operand 2
     /* 41170 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 41181 */     // (sext_inreg:{ *:[i32] } GR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (MOVSX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src, sub_8bit:{ *:[i32] }))
     /* 41181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 41184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 41188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41193 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 41199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 41204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 41209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 41212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41217 */     GIR_RootConstrainSelectedInstOperands,
     /* 41218 */     // GIR_Coverage, 23066,
     /* 41218 */     GIR_EraseRootFromParent_Done,
     /* 41219 */   // Label 1191: @41219
     /* 41219 */   GIM_Reject,
     /* 41220 */ // Label 1189: @41220
     /* 41220 */ GIM_Reject,
     /* 41221 */ // Label 1187: @41221
     /* 41221 */ GIM_Reject,
     /* 41222 */ // Label 18: @41222
     /* 41222 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1201*/ GIMT_Encode4(42329),
     /* 41233 */ /*GILLT_s16*//*Label 1192*/ GIMT_Encode4(41317),
     /* 41237 */ /*GILLT_s32*//*Label 1193*/ GIMT_Encode4(41375),
     /* 41241 */ /*GILLT_s64*//*Label 1194*/ GIMT_Encode4(41604), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 41269 */ /*GILLT_v4s64*//*Label 1195*/ GIMT_Encode4(42028), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 41281 */ /*GILLT_v8s32*//*Label 1196*/ GIMT_Encode4(42084),
     /* 41285 */ /*GILLT_v8s64*//*Label 1197*/ GIMT_Encode4(42140), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 41297 */ /*GILLT_v16s16*//*Label 1198*/ GIMT_Encode4(42193),
     /* 41301 */ /*GILLT_v16s32*//*Label 1199*/ GIMT_Encode4(42249), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 41313 */ /*GILLT_v32s16*//*Label 1200*/ GIMT_Encode4(42302),
     /* 41317 */ // Label 1192: @41317
     /* 41317 */ GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(41374), // Rule ID 23073 //
     /* 41322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 41325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 41329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 41333 */   // (zext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 41333 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 41336 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 41340 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41345 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 41349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 41351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 41354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41356 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 41363 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 41368 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 41373 */   // GIR_Coverage, 23073,
     /* 41373 */   GIR_EraseRootFromParent_Done,
     /* 41374 */ // Label 1202: @41374
     /* 41374 */ GIM_Reject,
     /* 41375 */ // Label 1193: @41375
     /* 41375 */ GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(41470), // Rule ID 23396 //
     /* 41380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 41383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 41386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 41390 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 41394 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 41398 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 41402 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 41406 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 41411 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 41415 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41419 */   // MIs[2] Operand 1
     /* 41419 */   // No operand predicates
     /* 41419 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 41421 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i32] } 0:{ *:[i32] }, (IMULZU16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 41421 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 41424 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rri),
     /* 41428 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41433 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 41437 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // src2
     /* 41440 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 41443 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 41445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 41448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 41453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 41459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 41464 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 41469 */   // GIR_Coverage, 23396,
     /* 41469 */   GIR_EraseRootFromParent_Done,
     /* 41470 */ // Label 1203: @41470
     /* 41470 */ GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(41512), // Rule ID 19882 //
     /* 41475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 41478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 41482 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 41486 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 41490 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 41494 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 41499 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41501 */   // (zext:{ *:[i32] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (KMOVWrk:{ *:[i32] } VK16:{ *:[v16i1] }:$src)
     /* 41501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWrk),
     /* 41504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41506 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 41510 */   GIR_RootConstrainSelectedInstOperands,
     /* 41511 */   // GIR_Coverage, 19882,
     /* 41511 */   GIR_EraseRootFromParent_Done,
     /* 41512 */ // Label 1204: @41512
     /* 41512 */ GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(41557), // Rule ID 19885 //
     /* 41517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 41520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 41523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 41527 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 41531 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 41535 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 41539 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 41544 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41546 */   // (zext:{ *:[i32] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (KMOVBrk:{ *:[i32] } VK8:{ *:[v8i1] }:$src)
     /* 41546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBrk),
     /* 41549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41551 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 41555 */   GIR_RootConstrainSelectedInstOperands,
     /* 41556 */   // GIR_Coverage, 19885,
     /* 41556 */   GIR_EraseRootFromParent_Done,
     /* 41557 */ // Label 1205: @41557
     /* 41557 */ GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(41580), // Rule ID 616 //
     /* 41562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 41565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 41569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 41573 */   // (zext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 41573 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 41578 */   GIR_RootConstrainSelectedInstOperands,
     /* 41579 */   // GIR_Coverage, 616,
     /* 41579 */   GIR_Done,
     /* 41580 */ // Label 1206: @41580
     /* 41580 */ GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(41603), // Rule ID 618 //
     /* 41585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 41588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 41592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 41596 */   // (zext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /* 41596 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 41601 */   GIR_RootConstrainSelectedInstOperands,
     /* 41602 */   // GIR_Coverage, 618,
     /* 41602 */   GIR_Done,
     /* 41603 */ // Label 1207: @41603
     /* 41603 */ GIM_Reject,
     /* 41604 */ // Label 1194: @41604
     /* 41604 */ GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(41699), // Rule ID 23398 //
     /* 41609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 41612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 41615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 41619 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 41623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 41627 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 41631 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 41635 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 41640 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 41644 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41648 */   // MIs[2] Operand 1
     /* 41648 */   // No operand predicates
     /* 41648 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 41650 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (IMULZU16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 41650 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 41653 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rri),
     /* 41657 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41662 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 41666 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // src2
     /* 41669 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 41672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 41674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 41677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 41682 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 41688 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 41693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 41698 */   // GIR_Coverage, 23398,
     /* 41698 */   GIR_EraseRootFromParent_Done,
     /* 41699 */ // Label 1208: @41699
     /* 41699 */ GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(41773), // Rule ID 19883 //
     /* 41704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 41707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 41711 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 41715 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 41719 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 41723 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 41728 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41730 */   // (zext:{ *:[i64] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (KMOVWrk:{ *:[i32] } VK16:{ *:[v16i1] }:$src), sub_32bit:{ *:[i32] })
     /* 41730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 41733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVWrk),
     /* 41737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41742 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 41746 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 41748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 41751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 41756 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 41762 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 41767 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 41772 */   // GIR_Coverage, 19883,
     /* 41772 */   GIR_EraseRootFromParent_Done,
     /* 41773 */ // Label 1209: @41773
     /* 41773 */ GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(41850), // Rule ID 19886 //
     /* 41778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 41781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 41784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 41788 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 41792 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 41796 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 41800 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 41805 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41807 */   // (zext:{ *:[i64] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (KMOVBrk:{ *:[i32] } VK8:{ *:[v8i1] }:$src), sub_32bit:{ *:[i32] })
     /* 41807 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 41810 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBrk),
     /* 41814 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41819 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 41823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 41825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 41828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 41833 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 41839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 41844 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 41849 */   // GIR_Coverage, 19886,
     /* 41849 */   GIR_EraseRootFromParent_Done,
     /* 41850 */ // Label 1210: @41850
     /* 41850 */ GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(41909), // Rule ID 18037 //
     /* 41855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 41858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 41862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 41866 */   // (zext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_32bit:{ *:[i32] })
     /* 41866 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 41869 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 41873 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41878 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 41882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 41884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 41887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 41892 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 41898 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 41903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 41908 */   // GIR_Coverage, 18037,
     /* 41908 */   GIR_EraseRootFromParent_Done,
     /* 41909 */ // Label 1211: @41909
     /* 41909 */ GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(41968), // Rule ID 18039 //
     /* 41914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 41917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 41921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 41925 */   // (zext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src), sub_32bit:{ *:[i32] })
     /* 41925 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 41928 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 41932 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41937 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 41941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 41943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 41946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 41951 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 41957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 41962 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 41967 */   // GIR_Coverage, 18039,
     /* 41967 */   GIR_EraseRootFromParent_Done,
     /* 41968 */ // Label 1212: @41968
     /* 41968 */ GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(42027), // Rule ID 18041 //
     /* 41973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 41976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 41980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 41984 */   // (zext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src), sub_32bit:{ *:[i32] })
     /* 41984 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 41987 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 41991 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41996 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 42000 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 42002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 42005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 42010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 42013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 42016 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 42021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 42026 */   // GIR_Coverage, 18041,
     /* 42026 */   GIR_EraseRootFromParent_Done,
     /* 42027 */ // Label 1213: @42027
     /* 42027 */ GIM_Reject,
     /* 42028 */ // Label 1195: @42028
     /* 42028 */ GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(42083),
     /* 42033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 42036 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(42059), // Rule ID 12460 //
     /* 42041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 42044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 42048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 42052 */     // (zext:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)  =>  (VPMOVZXDQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)
     /* 42052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZ256rr),
     /* 42057 */     GIR_RootConstrainSelectedInstOperands,
     /* 42058 */     // GIR_Coverage, 12460,
     /* 42058 */     GIR_Done,
     /* 42059 */   // Label 1215: @42059
     /* 42059 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(42082), // Rule ID 18848 //
     /* 42064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 42067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 42071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 42075 */     // (zext:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)  =>  (VPMOVZXDQYrr:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)
     /* 42075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQYrr),
     /* 42080 */     GIR_RootConstrainSelectedInstOperands,
     /* 42081 */     // GIR_Coverage, 18848,
     /* 42081 */     GIR_Done,
     /* 42082 */   // Label 1216: @42082
     /* 42082 */   GIM_Reject,
     /* 42083 */ // Label 1214: @42083
     /* 42083 */ GIM_Reject,
     /* 42084 */ // Label 1196: @42084
     /* 42084 */ GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(42139),
     /* 42089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 42092 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(42115), // Rule ID 12424 //
     /* 42097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 42100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 42104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 42108 */     // (zext:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVZXWDZ256rr:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)
     /* 42108 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZ256rr),
     /* 42113 */     GIR_RootConstrainSelectedInstOperands,
     /* 42114 */     // GIR_Coverage, 12424,
     /* 42114 */     GIR_Done,
     /* 42115 */   // Label 1218: @42115
     /* 42115 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(42138), // Rule ID 18846 //
     /* 42120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 42123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 42127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 42131 */     // (zext:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)  =>  (VPMOVZXWDYrr:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)
     /* 42131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDYrr),
     /* 42136 */     GIR_RootConstrainSelectedInstOperands,
     /* 42137 */     // GIR_Coverage, 18846,
     /* 42137 */     GIR_Done,
     /* 42138 */   // Label 1219: @42138
     /* 42138 */   GIM_Reject,
     /* 42139 */ // Label 1217: @42139
     /* 42139 */ GIM_Reject,
     /* 42140 */ // Label 1197: @42140
     /* 42140 */ GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(42166), // Rule ID 12448 //
     /* 42145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 42148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 42151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 42155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 42159 */   // (zext:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVZXWQZrr:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)
     /* 42159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWQZrr),
     /* 42164 */   GIR_RootConstrainSelectedInstOperands,
     /* 42165 */   // GIR_Coverage, 12448,
     /* 42165 */   GIR_Done,
     /* 42166 */ // Label 1220: @42166
     /* 42166 */ GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(42192), // Rule ID 12466 //
     /* 42171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 42174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 42177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 42181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 42185 */   // (zext:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVZXDQZrr:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)
     /* 42185 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZrr),
     /* 42190 */   GIR_RootConstrainSelectedInstOperands,
     /* 42191 */   // GIR_Coverage, 12466,
     /* 42191 */   GIR_Done,
     /* 42192 */ // Label 1221: @42192
     /* 42192 */ GIM_Reject,
     /* 42193 */ // Label 1198: @42193
     /* 42193 */ GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(42248),
     /* 42198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 42201 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(42224), // Rule ID 12370 //
     /* 42206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 42209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 42213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 42217 */     // (zext:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVZXBWZ256rr:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)
     /* 42217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZ256rr),
     /* 42222 */     GIR_RootConstrainSelectedInstOperands,
     /* 42223 */     // GIR_Coverage, 12370,
     /* 42223 */     GIR_Done,
     /* 42224 */   // Label 1223: @42224
     /* 42224 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(42247), // Rule ID 18843 //
     /* 42229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 42232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 42236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 42240 */     // (zext:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)  =>  (VPMOVZXBWYrr:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)
     /* 42240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWYrr),
     /* 42245 */     GIR_RootConstrainSelectedInstOperands,
     /* 42246 */     // GIR_Coverage, 18843,
     /* 42246 */     GIR_Done,
     /* 42247 */   // Label 1224: @42247
     /* 42247 */   GIM_Reject,
     /* 42248 */ // Label 1222: @42248
     /* 42248 */ GIM_Reject,
     /* 42249 */ // Label 1199: @42249
     /* 42249 */ GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(42275), // Rule ID 12394 //
     /* 42254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 42257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 42260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 42264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 42268 */   // (zext:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVZXBDZrr:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)
     /* 42268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBDZrr),
     /* 42273 */   GIR_RootConstrainSelectedInstOperands,
     /* 42274 */   // GIR_Coverage, 12394,
     /* 42274 */   GIR_Done,
     /* 42275 */ // Label 1225: @42275
     /* 42275 */ GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(42301), // Rule ID 12430 //
     /* 42280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 42283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 42286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 42290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 42294 */   // (zext:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVZXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)
     /* 42294 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrr),
     /* 42299 */   GIR_RootConstrainSelectedInstOperands,
     /* 42300 */   // GIR_Coverage, 12430,
     /* 42300 */   GIR_Done,
     /* 42301 */ // Label 1226: @42301
     /* 42301 */ GIM_Reject,
     /* 42302 */ // Label 1200: @42302
     /* 42302 */ GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(42328), // Rule ID 12376 //
     /* 42307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 42310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 42313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 42317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 42321 */   // (zext:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)  =>  (VPMOVZXBWZrr:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)
     /* 42321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZrr),
     /* 42326 */   GIR_RootConstrainSelectedInstOperands,
     /* 42327 */   // GIR_Coverage, 12376,
     /* 42327 */   GIR_Done,
     /* 42328 */ // Label 1227: @42328
     /* 42328 */ GIM_Reject,
     /* 42329 */ // Label 1201: @42329
     /* 42329 */ GIM_Reject,
     /* 42330 */ // Label 19: @42330
     /* 42330 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1232*/ GIMT_Encode4(43517),
     /* 42341 */ /*GILLT_s8*//*Label 1228*/ GIMT_Encode4(42357),
     /* 42345 */ /*GILLT_s16*//*Label 1229*/ GIMT_Encode4(42572),
     /* 42349 */ /*GILLT_s32*//*Label 1230*/ GIMT_Encode4(42787),
     /* 42353 */ /*GILLT_s64*//*Label 1231*/ GIMT_Encode4(43152),
     /* 42357 */ // Label 1228: @42357
     /* 42357 */ GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(42571),
     /* 42362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 42365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 42368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 42372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 42376 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(42402), // Rule ID 23098 //
     /* 42381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 42384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 42388 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 1:{ *:[i8] })  =>  (ADD8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src1)
     /* 42388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rr),
     /* 42391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42393 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42395 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42397 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42400 */     GIR_RootConstrainSelectedInstOperands,
     /* 42401 */     // GIR_Coverage, 23098,
     /* 42401 */     GIR_EraseRootFromParent_Done,
     /* 42402 */   // Label 1234: @42402
     /* 42402 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(42428), // Rule ID 23102 //
     /* 42407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 42410 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 42414 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 1:{ *:[i8] })  =>  (ADD8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src1)
     /* 42414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rr_ND),
     /* 42417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42419 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42421 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42426 */     GIR_RootConstrainSelectedInstOperands,
     /* 42427 */     // GIR_Coverage, 23102,
     /* 42427 */     GIR_EraseRootFromParent_Done,
     /* 42428 */   // Label 1235: @42428
     /* 42428 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(42461), // Rule ID 658 //
     /* 42433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 42436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42444 */     // MIs[1] Operand 1
     /* 42444 */     // No operand predicates
     /* 42444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 42446 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 42446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8ri),
     /* 42449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42451 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 42456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42459 */     GIR_RootConstrainSelectedInstOperands,
     /* 42460 */     // GIR_Coverage, 658,
     /* 42460 */     GIR_EraseRootFromParent_Done,
     /* 42461 */   // Label 1236: @42461
     /* 42461 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(42494), // Rule ID 662 //
     /* 42466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 42469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42477 */     // MIs[1] Operand 1
     /* 42477 */     // No operand predicates
     /* 42477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 42479 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 42479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8ri_ND),
     /* 42482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42484 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 42489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42492 */     GIR_RootConstrainSelectedInstOperands,
     /* 42493 */     // GIR_Coverage, 662,
     /* 42493 */     GIR_EraseRootFromParent_Done,
     /* 42494 */   // Label 1237: @42494
     /* 42494 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(42532), // Rule ID 674 //
     /* 42499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 42502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 42506 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHL8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 42506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 42510 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 42516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 42520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8rCL),
     /* 42523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42525 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42530 */     GIR_RootConstrainSelectedInstOperands,
     /* 42531 */     // GIR_Coverage, 674,
     /* 42531 */     GIR_EraseRootFromParent_Done,
     /* 42532 */   // Label 1238: @42532
     /* 42532 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(42570), // Rule ID 678 //
     /* 42537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 42540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 42544 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHL8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 42544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 42548 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 42554 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 42558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8rCL_ND),
     /* 42561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42563 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42568 */     GIR_RootConstrainSelectedInstOperands,
     /* 42569 */     // GIR_Coverage, 678,
     /* 42569 */     GIR_EraseRootFromParent_Done,
     /* 42570 */   // Label 1239: @42570
     /* 42570 */   GIM_Reject,
     /* 42571 */ // Label 1233: @42571
     /* 42571 */ GIM_Reject,
     /* 42572 */ // Label 1229: @42572
     /* 42572 */ GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(42786),
     /* 42577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 42580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 42583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 42587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 42591 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(42617), // Rule ID 23099 //
     /* 42596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 42599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 42603 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 1:{ *:[i8] })  =>  (ADD16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src1)
     /* 42603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rr),
     /* 42606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42608 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42610 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42615 */     GIR_RootConstrainSelectedInstOperands,
     /* 42616 */     // GIR_Coverage, 23099,
     /* 42616 */     GIR_EraseRootFromParent_Done,
     /* 42617 */   // Label 1241: @42617
     /* 42617 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(42643), // Rule ID 23103 //
     /* 42622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 42625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 42629 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 1:{ *:[i8] })  =>  (ADD16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src1)
     /* 42629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rr_ND),
     /* 42632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42634 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42636 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42641 */     GIR_RootConstrainSelectedInstOperands,
     /* 42642 */     // GIR_Coverage, 23103,
     /* 42642 */     GIR_EraseRootFromParent_Done,
     /* 42643 */   // Label 1242: @42643
     /* 42643 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(42676), // Rule ID 659 //
     /* 42648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 42651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42659 */     // MIs[1] Operand 1
     /* 42659 */     // No operand predicates
     /* 42659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 42661 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 42661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16ri),
     /* 42664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42666 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 42671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42674 */     GIR_RootConstrainSelectedInstOperands,
     /* 42675 */     // GIR_Coverage, 659,
     /* 42675 */     GIR_EraseRootFromParent_Done,
     /* 42676 */   // Label 1243: @42676
     /* 42676 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(42709), // Rule ID 663 //
     /* 42681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 42684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42692 */     // MIs[1] Operand 1
     /* 42692 */     // No operand predicates
     /* 42692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 42694 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 42694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16ri_ND),
     /* 42697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42699 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 42704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42707 */     GIR_RootConstrainSelectedInstOperands,
     /* 42708 */     // GIR_Coverage, 663,
     /* 42708 */     GIR_EraseRootFromParent_Done,
     /* 42709 */   // Label 1244: @42709
     /* 42709 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(42747), // Rule ID 675 //
     /* 42714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 42717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 42721 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHL16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 42721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 42725 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 42731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 42735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16rCL),
     /* 42738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42740 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42745 */     GIR_RootConstrainSelectedInstOperands,
     /* 42746 */     // GIR_Coverage, 675,
     /* 42746 */     GIR_EraseRootFromParent_Done,
     /* 42747 */   // Label 1245: @42747
     /* 42747 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(42785), // Rule ID 679 //
     /* 42752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 42755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 42759 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHL16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 42759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 42763 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 42769 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 42773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16rCL_ND),
     /* 42776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42778 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42783 */     GIR_RootConstrainSelectedInstOperands,
     /* 42784 */     // GIR_Coverage, 679,
     /* 42784 */     GIR_EraseRootFromParent_Done,
     /* 42785 */   // Label 1246: @42785
     /* 42785 */   GIM_Reject,
     /* 42786 */ // Label 1240: @42786
     /* 42786 */ GIM_Reject,
     /* 42787 */ // Label 1230: @42787
     /* 42787 */ GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(43151),
     /* 42792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 42795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 42798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 42802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 42806 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(42832), // Rule ID 23100 //
     /* 42811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 42814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 42818 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 1:{ *:[i8] })  =>  (ADD32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src1)
     /* 42818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rr),
     /* 42821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42823 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42825 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42830 */     GIR_RootConstrainSelectedInstOperands,
     /* 42831 */     // GIR_Coverage, 23100,
     /* 42831 */     GIR_EraseRootFromParent_Done,
     /* 42832 */   // Label 1248: @42832
     /* 42832 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(42858), // Rule ID 23104 //
     /* 42837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 42840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 42844 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 1:{ *:[i8] })  =>  (ADD32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src1)
     /* 42844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rr_ND),
     /* 42847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42849 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42851 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42856 */     GIR_RootConstrainSelectedInstOperands,
     /* 42857 */     // GIR_Coverage, 23104,
     /* 42857 */     GIR_EraseRootFromParent_Done,
     /* 42858 */   // Label 1249: @42858
     /* 42858 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(42891), // Rule ID 660 //
     /* 42863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 42866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42874 */     // MIs[1] Operand 1
     /* 42874 */     // No operand predicates
     /* 42874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 42876 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 42876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32ri),
     /* 42879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42881 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 42886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42889 */     GIR_RootConstrainSelectedInstOperands,
     /* 42890 */     // GIR_Coverage, 660,
     /* 42890 */     GIR_EraseRootFromParent_Done,
     /* 42891 */   // Label 1250: @42891
     /* 42891 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(42924), // Rule ID 664 //
     /* 42896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 42899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42907 */     // MIs[1] Operand 1
     /* 42907 */     // No operand predicates
     /* 42907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 42909 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 42909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32ri_ND),
     /* 42912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42914 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 42919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42922 */     GIR_RootConstrainSelectedInstOperands,
     /* 42923 */     // GIR_Coverage, 664,
     /* 42923 */     GIR_EraseRootFromParent_Done,
     /* 42924 */   // Label 1251: @42924
     /* 42924 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(42999), // Rule ID 18115 //
     /* 42929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 42932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 42936 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 42936 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 42939 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 42943 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 42948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 42950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 42953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 42957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 42962 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 42965 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 42969 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 42972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 42977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 42982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 42987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rr),
     /* 42990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42992 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 42997 */     GIR_RootConstrainSelectedInstOperands,
     /* 42998 */     // GIR_Coverage, 18115,
     /* 42998 */     GIR_EraseRootFromParent_Done,
     /* 42999 */   // Label 1252: @42999
     /* 42999 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(43074), // Rule ID 18147 //
     /* 43004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 43007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 43011 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 43011 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 43014 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 43018 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 43025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 43028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 43032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43037 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 43040 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 43044 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 43047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 43052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 43057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 43062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rr_EVEX),
     /* 43065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43067 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 43072 */     GIR_RootConstrainSelectedInstOperands,
     /* 43073 */     // GIR_Coverage, 18147,
     /* 43073 */     GIR_EraseRootFromParent_Done,
     /* 43074 */   // Label 1253: @43074
     /* 43074 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(43112), // Rule ID 676 //
     /* 43079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 43086 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHL32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 43086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43090 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 43100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32rCL),
     /* 43103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43105 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43110 */     GIR_RootConstrainSelectedInstOperands,
     /* 43111 */     // GIR_Coverage, 676,
     /* 43111 */     GIR_EraseRootFromParent_Done,
     /* 43112 */   // Label 1254: @43112
     /* 43112 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(43150), // Rule ID 680 //
     /* 43117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 43120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 43124 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHL32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 43124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43128 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 43138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32rCL_ND),
     /* 43141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43143 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43148 */     GIR_RootConstrainSelectedInstOperands,
     /* 43149 */     // GIR_Coverage, 680,
     /* 43149 */     GIR_EraseRootFromParent_Done,
     /* 43150 */   // Label 1255: @43150
     /* 43150 */   GIM_Reject,
     /* 43151 */ // Label 1247: @43151
     /* 43151 */ GIM_Reject,
     /* 43152 */ // Label 1231: @43152
     /* 43152 */ GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(43516),
     /* 43157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 43160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 43163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 43167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 43171 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(43197), // Rule ID 23101 //
     /* 43176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 43183 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 1:{ *:[i8] })  =>  (ADD64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src1)
     /* 43183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rr),
     /* 43186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43188 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43190 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43195 */     GIR_RootConstrainSelectedInstOperands,
     /* 43196 */     // GIR_Coverage, 23101,
     /* 43196 */     GIR_EraseRootFromParent_Done,
     /* 43197 */   // Label 1257: @43197
     /* 43197 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(43223), // Rule ID 23105 //
     /* 43202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 43205 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 43209 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 1:{ *:[i8] })  =>  (ADD64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src1)
     /* 43209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rr_ND),
     /* 43212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43214 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43216 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43221 */     GIR_RootConstrainSelectedInstOperands,
     /* 43222 */     // GIR_Coverage, 23105,
     /* 43222 */     GIR_EraseRootFromParent_Done,
     /* 43223 */   // Label 1258: @43223
     /* 43223 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(43256), // Rule ID 661 //
     /* 43228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43239 */     // MIs[1] Operand 1
     /* 43239 */     // No operand predicates
     /* 43239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43241 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 43241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64ri),
     /* 43244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43246 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 43251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43254 */     GIR_RootConstrainSelectedInstOperands,
     /* 43255 */     // GIR_Coverage, 661,
     /* 43255 */     GIR_EraseRootFromParent_Done,
     /* 43256 */   // Label 1259: @43256
     /* 43256 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(43289), // Rule ID 665 //
     /* 43261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 43264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43272 */     // MIs[1] Operand 1
     /* 43272 */     // No operand predicates
     /* 43272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43274 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 43274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64ri_ND),
     /* 43277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43279 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 43284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43287 */     GIR_RootConstrainSelectedInstOperands,
     /* 43288 */     // GIR_Coverage, 665,
     /* 43288 */     GIR_EraseRootFromParent_Done,
     /* 43289 */   // Label 1260: @43289
     /* 43289 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(43364), // Rule ID 18116 //
     /* 43294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 43297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 43301 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 43301 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 43304 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 43308 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 43315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 43318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 43322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43327 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 43330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 43334 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 43337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 43342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 43347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 43352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rr),
     /* 43355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43357 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 43362 */     GIR_RootConstrainSelectedInstOperands,
     /* 43363 */     // GIR_Coverage, 18116,
     /* 43363 */     GIR_EraseRootFromParent_Done,
     /* 43364 */   // Label 1261: @43364
     /* 43364 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(43439), // Rule ID 18148 //
     /* 43369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 43372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 43376 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 43376 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 43379 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 43383 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 43390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 43393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 43397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43402 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 43405 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 43409 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 43412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 43417 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 43422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 43427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rr_EVEX),
     /* 43430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43432 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 43437 */     GIR_RootConstrainSelectedInstOperands,
     /* 43438 */     // GIR_Coverage, 18148,
     /* 43438 */     GIR_EraseRootFromParent_Done,
     /* 43439 */   // Label 1262: @43439
     /* 43439 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(43477), // Rule ID 677 //
     /* 43444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 43451 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHL64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 43451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43455 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43461 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 43465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64rCL),
     /* 43468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43470 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43475 */     GIR_RootConstrainSelectedInstOperands,
     /* 43476 */     // GIR_Coverage, 677,
     /* 43476 */     GIR_EraseRootFromParent_Done,
     /* 43477 */   // Label 1263: @43477
     /* 43477 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(43515), // Rule ID 681 //
     /* 43482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 43485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 43489 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHL64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 43489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43493 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43499 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 43503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64rCL_ND),
     /* 43506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43508 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43513 */     GIR_RootConstrainSelectedInstOperands,
     /* 43514 */     // GIR_Coverage, 681,
     /* 43514 */     GIR_EraseRootFromParent_Done,
     /* 43515 */   // Label 1264: @43515
     /* 43515 */   GIM_Reject,
     /* 43516 */ // Label 1256: @43516
     /* 43516 */ GIM_Reject,
     /* 43517 */ // Label 1232: @43517
     /* 43517 */ GIM_Reject,
     /* 43518 */ // Label 20: @43518
     /* 43518 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1269*/ GIMT_Encode4(44497),
     /* 43529 */ /*GILLT_s8*//*Label 1265*/ GIMT_Encode4(43545),
     /* 43533 */ /*GILLT_s16*//*Label 1266*/ GIMT_Encode4(43708),
     /* 43537 */ /*GILLT_s32*//*Label 1267*/ GIMT_Encode4(43871),
     /* 43541 */ /*GILLT_s64*//*Label 1268*/ GIMT_Encode4(44184),
     /* 43545 */ // Label 1265: @43545
     /* 43545 */ GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(43707),
     /* 43550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 43553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 43556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 43560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 43564 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(43597), // Rule ID 690 //
     /* 43569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43580 */     // MIs[1] Operand 1
     /* 43580 */     // No operand predicates
     /* 43580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43582 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 43582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8ri),
     /* 43585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43587 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 43592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43595 */     GIR_RootConstrainSelectedInstOperands,
     /* 43596 */     // GIR_Coverage, 690,
     /* 43596 */     GIR_EraseRootFromParent_Done,
     /* 43597 */   // Label 1271: @43597
     /* 43597 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(43630), // Rule ID 694 //
     /* 43602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 43605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43613 */     // MIs[1] Operand 1
     /* 43613 */     // No operand predicates
     /* 43613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43615 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 43615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8ri_ND),
     /* 43618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43620 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 43625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43628 */     GIR_RootConstrainSelectedInstOperands,
     /* 43629 */     // GIR_Coverage, 694,
     /* 43629 */     GIR_EraseRootFromParent_Done,
     /* 43630 */   // Label 1272: @43630
     /* 43630 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(43668), // Rule ID 706 //
     /* 43635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 43642 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 43642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43646 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 43656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8rCL),
     /* 43659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43666 */     GIR_RootConstrainSelectedInstOperands,
     /* 43667 */     // GIR_Coverage, 706,
     /* 43667 */     GIR_EraseRootFromParent_Done,
     /* 43668 */   // Label 1273: @43668
     /* 43668 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(43706), // Rule ID 710 //
     /* 43673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 43676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 43680 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 43680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43684 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 43694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8rCL_ND),
     /* 43697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43699 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43704 */     GIR_RootConstrainSelectedInstOperands,
     /* 43705 */     // GIR_Coverage, 710,
     /* 43705 */     GIR_EraseRootFromParent_Done,
     /* 43706 */   // Label 1274: @43706
     /* 43706 */   GIM_Reject,
     /* 43707 */ // Label 1270: @43707
     /* 43707 */ GIM_Reject,
     /* 43708 */ // Label 1266: @43708
     /* 43708 */ GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(43870),
     /* 43713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 43716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 43719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 43723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 43727 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(43760), // Rule ID 691 //
     /* 43732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43743 */     // MIs[1] Operand 1
     /* 43743 */     // No operand predicates
     /* 43743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43745 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 43745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16ri),
     /* 43748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43750 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 43755 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43758 */     GIR_RootConstrainSelectedInstOperands,
     /* 43759 */     // GIR_Coverage, 691,
     /* 43759 */     GIR_EraseRootFromParent_Done,
     /* 43760 */   // Label 1276: @43760
     /* 43760 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(43793), // Rule ID 695 //
     /* 43765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 43768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43776 */     // MIs[1] Operand 1
     /* 43776 */     // No operand predicates
     /* 43776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43778 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 43778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16ri_ND),
     /* 43781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43783 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 43788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43791 */     GIR_RootConstrainSelectedInstOperands,
     /* 43792 */     // GIR_Coverage, 695,
     /* 43792 */     GIR_EraseRootFromParent_Done,
     /* 43793 */   // Label 1277: @43793
     /* 43793 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(43831), // Rule ID 707 //
     /* 43798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 43805 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 43805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43809 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43815 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 43819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16rCL),
     /* 43822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43824 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43829 */     GIR_RootConstrainSelectedInstOperands,
     /* 43830 */     // GIR_Coverage, 707,
     /* 43830 */     GIR_EraseRootFromParent_Done,
     /* 43831 */   // Label 1278: @43831
     /* 43831 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(43869), // Rule ID 711 //
     /* 43836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 43839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 43843 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 43843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43847 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 43857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16rCL_ND),
     /* 43860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43862 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43864 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43867 */     GIR_RootConstrainSelectedInstOperands,
     /* 43868 */     // GIR_Coverage, 711,
     /* 43868 */     GIR_EraseRootFromParent_Done,
     /* 43869 */   // Label 1279: @43869
     /* 43869 */   GIM_Reject,
     /* 43870 */ // Label 1275: @43870
     /* 43870 */ GIM_Reject,
     /* 43871 */ // Label 1267: @43871
     /* 43871 */ GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(44183),
     /* 43876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 43879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 43882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 43886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 43890 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(43923), // Rule ID 692 //
     /* 43895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43906 */     // MIs[1] Operand 1
     /* 43906 */     // No operand predicates
     /* 43906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43908 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 43908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32ri),
     /* 43911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43913 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 43918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43921 */     GIR_RootConstrainSelectedInstOperands,
     /* 43922 */     // GIR_Coverage, 692,
     /* 43922 */     GIR_EraseRootFromParent_Done,
     /* 43923 */   // Label 1281: @43923
     /* 43923 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(43956), // Rule ID 696 //
     /* 43928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 43931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43939 */     // MIs[1] Operand 1
     /* 43939 */     // No operand predicates
     /* 43939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43941 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 43941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32ri_ND),
     /* 43944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43946 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 43951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43954 */     GIR_RootConstrainSelectedInstOperands,
     /* 43955 */     // GIR_Coverage, 696,
     /* 43955 */     GIR_EraseRootFromParent_Done,
     /* 43956 */   // Label 1282: @43956
     /* 43956 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(44031), // Rule ID 18107 //
     /* 43961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 43964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 43968 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 43968 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 43971 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 43975 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 43982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 43985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 43989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43994 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 43997 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 44001 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 44004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 44009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 44014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 44019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rr),
     /* 44022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44024 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 44029 */     GIR_RootConstrainSelectedInstOperands,
     /* 44030 */     // GIR_Coverage, 18107,
     /* 44030 */     GIR_EraseRootFromParent_Done,
     /* 44031 */   // Label 1283: @44031
     /* 44031 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(44106), // Rule ID 18139 //
     /* 44036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 44039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 44043 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 44043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 44046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 44050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 44057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 44060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 44064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44069 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 44072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 44076 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 44079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 44084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 44089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 44094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rr_EVEX),
     /* 44097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44099 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 44104 */     GIR_RootConstrainSelectedInstOperands,
     /* 44105 */     // GIR_Coverage, 18139,
     /* 44105 */     GIR_EraseRootFromParent_Done,
     /* 44106 */   // Label 1284: @44106
     /* 44106 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(44144), // Rule ID 708 //
     /* 44111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 44118 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 44118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 44122 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 44132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32rCL),
     /* 44135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44137 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44142 */     GIR_RootConstrainSelectedInstOperands,
     /* 44143 */     // GIR_Coverage, 708,
     /* 44143 */     GIR_EraseRootFromParent_Done,
     /* 44144 */   // Label 1285: @44144
     /* 44144 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(44182), // Rule ID 712 //
     /* 44149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 44152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 44156 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 44156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 44160 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44166 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 44170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32rCL_ND),
     /* 44173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44175 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44180 */     GIR_RootConstrainSelectedInstOperands,
     /* 44181 */     // GIR_Coverage, 712,
     /* 44181 */     GIR_EraseRootFromParent_Done,
     /* 44182 */   // Label 1286: @44182
     /* 44182 */   GIM_Reject,
     /* 44183 */ // Label 1280: @44183
     /* 44183 */ GIM_Reject,
     /* 44184 */ // Label 1268: @44184
     /* 44184 */ GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(44496),
     /* 44189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 44192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 44195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 44199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 44203 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(44236), // Rule ID 693 //
     /* 44208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44219 */     // MIs[1] Operand 1
     /* 44219 */     // No operand predicates
     /* 44219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 44221 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 44221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64ri),
     /* 44224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44226 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44234 */     GIR_RootConstrainSelectedInstOperands,
     /* 44235 */     // GIR_Coverage, 693,
     /* 44235 */     GIR_EraseRootFromParent_Done,
     /* 44236 */   // Label 1288: @44236
     /* 44236 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(44269), // Rule ID 697 //
     /* 44241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 44244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44252 */     // MIs[1] Operand 1
     /* 44252 */     // No operand predicates
     /* 44252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 44254 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 44254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64ri_ND),
     /* 44257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44259 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44267 */     GIR_RootConstrainSelectedInstOperands,
     /* 44268 */     // GIR_Coverage, 697,
     /* 44268 */     GIR_EraseRootFromParent_Done,
     /* 44269 */   // Label 1289: @44269
     /* 44269 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(44344), // Rule ID 18108 //
     /* 44274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 44277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 44281 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 44281 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 44284 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 44288 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 44295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 44298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 44302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44307 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 44310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 44314 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 44317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 44322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 44327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 44332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rr),
     /* 44335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44337 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 44342 */     GIR_RootConstrainSelectedInstOperands,
     /* 44343 */     // GIR_Coverage, 18108,
     /* 44343 */     GIR_EraseRootFromParent_Done,
     /* 44344 */   // Label 1290: @44344
     /* 44344 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(44419), // Rule ID 18140 //
     /* 44349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 44352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 44356 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 44356 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 44359 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 44363 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 44370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 44373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 44377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44382 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 44385 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 44389 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 44392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 44397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 44402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 44407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rr_EVEX),
     /* 44410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44412 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 44417 */     GIR_RootConstrainSelectedInstOperands,
     /* 44418 */     // GIR_Coverage, 18140,
     /* 44418 */     GIR_EraseRootFromParent_Done,
     /* 44419 */   // Label 1291: @44419
     /* 44419 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(44457), // Rule ID 709 //
     /* 44424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 44431 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 44431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 44435 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44441 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 44445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64rCL),
     /* 44448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44450 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44455 */     GIR_RootConstrainSelectedInstOperands,
     /* 44456 */     // GIR_Coverage, 709,
     /* 44456 */     GIR_EraseRootFromParent_Done,
     /* 44457 */   // Label 1292: @44457
     /* 44457 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(44495), // Rule ID 713 //
     /* 44462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 44465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 44469 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 44469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 44473 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44479 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 44483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64rCL_ND),
     /* 44486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44488 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44493 */     GIR_RootConstrainSelectedInstOperands,
     /* 44494 */     // GIR_Coverage, 713,
     /* 44494 */     GIR_EraseRootFromParent_Done,
     /* 44495 */   // Label 1293: @44495
     /* 44495 */   GIM_Reject,
     /* 44496 */ // Label 1287: @44496
     /* 44496 */ GIM_Reject,
     /* 44497 */ // Label 1269: @44497
     /* 44497 */ GIM_Reject,
     /* 44498 */ // Label 21: @44498
     /* 44498 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1298*/ GIMT_Encode4(45477),
     /* 44509 */ /*GILLT_s8*//*Label 1294*/ GIMT_Encode4(44525),
     /* 44513 */ /*GILLT_s16*//*Label 1295*/ GIMT_Encode4(44688),
     /* 44517 */ /*GILLT_s32*//*Label 1296*/ GIMT_Encode4(44851),
     /* 44521 */ /*GILLT_s64*//*Label 1297*/ GIMT_Encode4(45164),
     /* 44525 */ // Label 1294: @44525
     /* 44525 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(44687),
     /* 44530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 44533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 44536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 44540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 44544 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(44577), // Rule ID 722 //
     /* 44549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44560 */     // MIs[1] Operand 1
     /* 44560 */     // No operand predicates
     /* 44560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 44562 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 44562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8ri),
     /* 44565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44567 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44575 */     GIR_RootConstrainSelectedInstOperands,
     /* 44576 */     // GIR_Coverage, 722,
     /* 44576 */     GIR_EraseRootFromParent_Done,
     /* 44577 */   // Label 1300: @44577
     /* 44577 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(44610), // Rule ID 726 //
     /* 44582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 44585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44593 */     // MIs[1] Operand 1
     /* 44593 */     // No operand predicates
     /* 44593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 44595 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 44595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8ri_ND),
     /* 44598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44600 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44608 */     GIR_RootConstrainSelectedInstOperands,
     /* 44609 */     // GIR_Coverage, 726,
     /* 44609 */     GIR_EraseRootFromParent_Done,
     /* 44610 */   // Label 1301: @44610
     /* 44610 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(44648), // Rule ID 738 //
     /* 44615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 44622 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SAR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 44622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 44626 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 44636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8rCL),
     /* 44639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44641 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44646 */     GIR_RootConstrainSelectedInstOperands,
     /* 44647 */     // GIR_Coverage, 738,
     /* 44647 */     GIR_EraseRootFromParent_Done,
     /* 44648 */   // Label 1302: @44648
     /* 44648 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(44686), // Rule ID 742 //
     /* 44653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 44656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 44660 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SAR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 44660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 44664 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 44674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8rCL_ND),
     /* 44677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44679 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44684 */     GIR_RootConstrainSelectedInstOperands,
     /* 44685 */     // GIR_Coverage, 742,
     /* 44685 */     GIR_EraseRootFromParent_Done,
     /* 44686 */   // Label 1303: @44686
     /* 44686 */   GIM_Reject,
     /* 44687 */ // Label 1299: @44687
     /* 44687 */ GIM_Reject,
     /* 44688 */ // Label 1295: @44688
     /* 44688 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(44850),
     /* 44693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 44696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 44699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 44703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 44707 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(44740), // Rule ID 723 //
     /* 44712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44723 */     // MIs[1] Operand 1
     /* 44723 */     // No operand predicates
     /* 44723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 44725 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 44725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16ri),
     /* 44728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44730 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44738 */     GIR_RootConstrainSelectedInstOperands,
     /* 44739 */     // GIR_Coverage, 723,
     /* 44739 */     GIR_EraseRootFromParent_Done,
     /* 44740 */   // Label 1305: @44740
     /* 44740 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(44773), // Rule ID 727 //
     /* 44745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 44748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44756 */     // MIs[1] Operand 1
     /* 44756 */     // No operand predicates
     /* 44756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 44758 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 44758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16ri_ND),
     /* 44761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44763 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44771 */     GIR_RootConstrainSelectedInstOperands,
     /* 44772 */     // GIR_Coverage, 727,
     /* 44772 */     GIR_EraseRootFromParent_Done,
     /* 44773 */   // Label 1306: @44773
     /* 44773 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(44811), // Rule ID 739 //
     /* 44778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 44785 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SAR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 44785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 44789 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44795 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 44799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16rCL),
     /* 44802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44804 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44809 */     GIR_RootConstrainSelectedInstOperands,
     /* 44810 */     // GIR_Coverage, 739,
     /* 44810 */     GIR_EraseRootFromParent_Done,
     /* 44811 */   // Label 1307: @44811
     /* 44811 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(44849), // Rule ID 743 //
     /* 44816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 44819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 44823 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SAR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 44823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 44827 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 44837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16rCL_ND),
     /* 44840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44842 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44847 */     GIR_RootConstrainSelectedInstOperands,
     /* 44848 */     // GIR_Coverage, 743,
     /* 44848 */     GIR_EraseRootFromParent_Done,
     /* 44849 */   // Label 1308: @44849
     /* 44849 */   GIM_Reject,
     /* 44850 */ // Label 1304: @44850
     /* 44850 */ GIM_Reject,
     /* 44851 */ // Label 1296: @44851
     /* 44851 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(45163),
     /* 44856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 44859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 44862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 44866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 44870 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(44903), // Rule ID 724 //
     /* 44875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44886 */     // MIs[1] Operand 1
     /* 44886 */     // No operand predicates
     /* 44886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 44888 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 44888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32ri),
     /* 44891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44893 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44901 */     GIR_RootConstrainSelectedInstOperands,
     /* 44902 */     // GIR_Coverage, 724,
     /* 44902 */     GIR_EraseRootFromParent_Done,
     /* 44903 */   // Label 1310: @44903
     /* 44903 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(44936), // Rule ID 728 //
     /* 44908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 44911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44919 */     // MIs[1] Operand 1
     /* 44919 */     // No operand predicates
     /* 44919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 44921 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 44921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32ri_ND),
     /* 44924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44926 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44934 */     GIR_RootConstrainSelectedInstOperands,
     /* 44935 */     // GIR_Coverage, 728,
     /* 44935 */     GIR_EraseRootFromParent_Done,
     /* 44936 */   // Label 1311: @44936
     /* 44936 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(45011), // Rule ID 18099 //
     /* 44941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 44944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 44948 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 44948 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 44951 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 44955 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 44962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 44965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 44969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44974 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 44977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 44981 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 44984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 44989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 44994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 44999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rr),
     /* 45002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45004 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45009 */     GIR_RootConstrainSelectedInstOperands,
     /* 45010 */     // GIR_Coverage, 18099,
     /* 45010 */     GIR_EraseRootFromParent_Done,
     /* 45011 */   // Label 1312: @45011
     /* 45011 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(45086), // Rule ID 18131 //
     /* 45016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 45019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 45023 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 45023 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 45026 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 45030 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 45037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 45040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 45044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45049 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 45052 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 45056 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 45059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 45064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 45069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 45074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rr_EVEX),
     /* 45077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45079 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45084 */     GIR_RootConstrainSelectedInstOperands,
     /* 45085 */     // GIR_Coverage, 18131,
     /* 45085 */     GIR_EraseRootFromParent_Done,
     /* 45086 */   // Label 1313: @45086
     /* 45086 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(45124), // Rule ID 740 //
     /* 45091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45098 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SAR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 45098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45102 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45108 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 45112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32rCL),
     /* 45115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45117 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45122 */     GIR_RootConstrainSelectedInstOperands,
     /* 45123 */     // GIR_Coverage, 740,
     /* 45123 */     GIR_EraseRootFromParent_Done,
     /* 45124 */   // Label 1314: @45124
     /* 45124 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(45162), // Rule ID 744 //
     /* 45129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 45132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45136 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SAR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 45136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45140 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 45150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32rCL_ND),
     /* 45153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45155 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45160 */     GIR_RootConstrainSelectedInstOperands,
     /* 45161 */     // GIR_Coverage, 744,
     /* 45161 */     GIR_EraseRootFromParent_Done,
     /* 45162 */   // Label 1315: @45162
     /* 45162 */   GIM_Reject,
     /* 45163 */ // Label 1309: @45163
     /* 45163 */ GIM_Reject,
     /* 45164 */ // Label 1297: @45164
     /* 45164 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(45476),
     /* 45169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 45172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 45175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 45179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 45183 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(45216), // Rule ID 725 //
     /* 45188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45199 */     // MIs[1] Operand 1
     /* 45199 */     // No operand predicates
     /* 45199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45201 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 45201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64ri),
     /* 45204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45206 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 45211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45214 */     GIR_RootConstrainSelectedInstOperands,
     /* 45215 */     // GIR_Coverage, 725,
     /* 45215 */     GIR_EraseRootFromParent_Done,
     /* 45216 */   // Label 1317: @45216
     /* 45216 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(45249), // Rule ID 729 //
     /* 45221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 45224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45232 */     // MIs[1] Operand 1
     /* 45232 */     // No operand predicates
     /* 45232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45234 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 45234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64ri_ND),
     /* 45237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45239 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 45244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45247 */     GIR_RootConstrainSelectedInstOperands,
     /* 45248 */     // GIR_Coverage, 729,
     /* 45248 */     GIR_EraseRootFromParent_Done,
     /* 45249 */   // Label 1318: @45249
     /* 45249 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(45324), // Rule ID 18100 //
     /* 45254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 45257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 45261 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 45261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 45264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 45268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 45275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 45278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 45282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45287 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 45290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 45294 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 45297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 45302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 45307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 45312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rr),
     /* 45315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45317 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45322 */     GIR_RootConstrainSelectedInstOperands,
     /* 45323 */     // GIR_Coverage, 18100,
     /* 45323 */     GIR_EraseRootFromParent_Done,
     /* 45324 */   // Label 1319: @45324
     /* 45324 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(45399), // Rule ID 18132 //
     /* 45329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 45332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 45336 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 45336 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 45339 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 45343 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 45350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 45353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 45357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45362 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 45365 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 45369 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 45372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 45377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 45382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 45387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rr_EVEX),
     /* 45390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45392 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45397 */     GIR_RootConstrainSelectedInstOperands,
     /* 45398 */     // GIR_Coverage, 18132,
     /* 45398 */     GIR_EraseRootFromParent_Done,
     /* 45399 */   // Label 1320: @45399
     /* 45399 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(45437), // Rule ID 741 //
     /* 45404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45411 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SAR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 45411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45415 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45421 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 45425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64rCL),
     /* 45428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45430 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45435 */     GIR_RootConstrainSelectedInstOperands,
     /* 45436 */     // GIR_Coverage, 741,
     /* 45436 */     GIR_EraseRootFromParent_Done,
     /* 45437 */   // Label 1321: @45437
     /* 45437 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(45475), // Rule ID 745 //
     /* 45442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 45445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45449 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SAR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 45449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45453 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45459 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 45463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64rCL_ND),
     /* 45466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45468 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45473 */     GIR_RootConstrainSelectedInstOperands,
     /* 45474 */     // GIR_Coverage, 745,
     /* 45474 */     GIR_EraseRootFromParent_Done,
     /* 45475 */   // Label 1322: @45475
     /* 45475 */   GIM_Reject,
     /* 45476 */ // Label 1316: @45476
     /* 45476 */ GIM_Reject,
     /* 45477 */ // Label 1298: @45477
     /* 45477 */ GIM_Reject,
     /* 45478 */ // Label 22: @45478
     /* 45478 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 1325*/ GIMT_Encode4(45853),
     /* 45489 */ /*GILLT_s32*//*Label 1323*/ GIMT_Encode4(45497),
     /* 45493 */ /*GILLT_s64*//*Label 1324*/ GIMT_Encode4(45675),
     /* 45497 */ // Label 1323: @45497
     /* 45497 */ GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(45674),
     /* 45502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 45505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 45508 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 45511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 45515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 45519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 45523 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(45558), // Rule ID 819 //
     /* 45528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 45535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45539 */     // MIs[1] Operand 1
     /* 45539 */     // No operand predicates
     /* 45539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45541 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32rri8:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 45541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rri8),
     /* 45544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45546 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45548 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 45550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 45553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45556 */     GIR_RootConstrainSelectedInstOperands,
     /* 45557 */     // GIR_Coverage, 819,
     /* 45557 */     GIR_EraseRootFromParent_Done,
     /* 45558 */   // Label 1327: @45558
     /* 45558 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(45593), // Rule ID 825 //
     /* 45563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 45566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 45570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45574 */     // MIs[1] Operand 1
     /* 45574 */     // No operand predicates
     /* 45574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45576 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32rri8_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 45576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rri8_ND),
     /* 45579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45581 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45583 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 45585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 45588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45591 */     GIR_RootConstrainSelectedInstOperands,
     /* 45592 */     // GIR_Coverage, 825,
     /* 45592 */     GIR_EraseRootFromParent_Done,
     /* 45593 */   // Label 1328: @45593
     /* 45593 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(45633), // Rule ID 822 //
     /* 45598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45605 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32rrCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 45605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45609 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45615 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 45619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rrCL),
     /* 45622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45624 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45626 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 45628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45631 */     GIR_RootConstrainSelectedInstOperands,
     /* 45632 */     // GIR_Coverage, 822,
     /* 45632 */     GIR_EraseRootFromParent_Done,
     /* 45633 */   // Label 1329: @45633
     /* 45633 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(45673), // Rule ID 828 //
     /* 45638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 45641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45645 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32rrCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 45645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45649 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45655 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 45659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rrCL_ND),
     /* 45662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45664 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45666 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 45668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45671 */     GIR_RootConstrainSelectedInstOperands,
     /* 45672 */     // GIR_Coverage, 828,
     /* 45672 */     GIR_EraseRootFromParent_Done,
     /* 45673 */   // Label 1330: @45673
     /* 45673 */   GIM_Reject,
     /* 45674 */ // Label 1326: @45674
     /* 45674 */ GIM_Reject,
     /* 45675 */ // Label 1324: @45675
     /* 45675 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(45852),
     /* 45680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 45683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 45686 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 45689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 45693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 45697 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 45701 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(45736), // Rule ID 820 //
     /* 45706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 45713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45717 */     // MIs[1] Operand 1
     /* 45717 */     // No operand predicates
     /* 45717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45719 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64rri8:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 45719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rri8),
     /* 45722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45724 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45726 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 45728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 45731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45734 */     GIR_RootConstrainSelectedInstOperands,
     /* 45735 */     // GIR_Coverage, 820,
     /* 45735 */     GIR_EraseRootFromParent_Done,
     /* 45736 */   // Label 1332: @45736
     /* 45736 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(45771), // Rule ID 826 //
     /* 45741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 45744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 45748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45752 */     // MIs[1] Operand 1
     /* 45752 */     // No operand predicates
     /* 45752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45754 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64rri8_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 45754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rri8_ND),
     /* 45757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45759 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45761 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 45763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 45766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45769 */     GIR_RootConstrainSelectedInstOperands,
     /* 45770 */     // GIR_Coverage, 826,
     /* 45770 */     GIR_EraseRootFromParent_Done,
     /* 45771 */   // Label 1333: @45771
     /* 45771 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(45811), // Rule ID 823 //
     /* 45776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45783 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64rrCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 45783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45787 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45793 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 45797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rrCL),
     /* 45800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45802 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45804 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 45806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45809 */     GIR_RootConstrainSelectedInstOperands,
     /* 45810 */     // GIR_Coverage, 823,
     /* 45810 */     GIR_EraseRootFromParent_Done,
     /* 45811 */   // Label 1334: @45811
     /* 45811 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(45851), // Rule ID 829 //
     /* 45816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 45819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45823 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64rrCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 45823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45827 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 45837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rrCL_ND),
     /* 45840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45842 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45844 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 45846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45849 */     GIR_RootConstrainSelectedInstOperands,
     /* 45850 */     // GIR_Coverage, 829,
     /* 45850 */     GIR_EraseRootFromParent_Done,
     /* 45851 */   // Label 1335: @45851
     /* 45851 */   GIM_Reject,
     /* 45852 */ // Label 1331: @45852
     /* 45852 */ GIM_Reject,
     /* 45853 */ // Label 1325: @45853
     /* 45853 */ GIM_Reject,
     /* 45854 */ // Label 23: @45854
     /* 45854 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 1338*/ GIMT_Encode4(46229),
     /* 45865 */ /*GILLT_s32*//*Label 1336*/ GIMT_Encode4(45873),
     /* 45869 */ /*GILLT_s64*//*Label 1337*/ GIMT_Encode4(46051),
     /* 45873 */ // Label 1336: @45873
     /* 45873 */ GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(46050),
     /* 45878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 45881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 45884 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 45887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 45891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 45895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 45899 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(45934), // Rule ID 843 //
     /* 45904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 45911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45915 */     // MIs[1] Operand 1
     /* 45915 */     // No operand predicates
     /* 45915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45917 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD32rri8:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 45917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rri8),
     /* 45920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45922 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 45924 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 45926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 45929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45932 */     GIR_RootConstrainSelectedInstOperands,
     /* 45933 */     // GIR_Coverage, 843,
     /* 45933 */     GIR_EraseRootFromParent_Done,
     /* 45934 */   // Label 1340: @45934
     /* 45934 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(45969), // Rule ID 849 //
     /* 45939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 45942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 45946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45950 */     // MIs[1] Operand 1
     /* 45950 */     // No operand predicates
     /* 45950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45952 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD32rri8_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 45952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rri8_ND),
     /* 45955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45957 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 45959 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 45961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 45964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45967 */     GIR_RootConstrainSelectedInstOperands,
     /* 45968 */     // GIR_Coverage, 849,
     /* 45968 */     GIR_EraseRootFromParent_Done,
     /* 45969 */   // Label 1341: @45969
     /* 45969 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(46009), // Rule ID 846 //
     /* 45974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45981 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHRD32rrCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 45981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45985 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45991 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 45995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rrCL),
     /* 45998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46000 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 46002 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 46004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46007 */     GIR_RootConstrainSelectedInstOperands,
     /* 46008 */     // GIR_Coverage, 846,
     /* 46008 */     GIR_EraseRootFromParent_Done,
     /* 46009 */   // Label 1342: @46009
     /* 46009 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(46049), // Rule ID 852 //
     /* 46014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46021 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHRD32rrCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 46021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46025 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46031 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 46035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rrCL_ND),
     /* 46038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46040 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 46042 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 46044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46047 */     GIR_RootConstrainSelectedInstOperands,
     /* 46048 */     // GIR_Coverage, 852,
     /* 46048 */     GIR_EraseRootFromParent_Done,
     /* 46049 */   // Label 1343: @46049
     /* 46049 */   GIM_Reject,
     /* 46050 */ // Label 1339: @46050
     /* 46050 */ GIM_Reject,
     /* 46051 */ // Label 1337: @46051
     /* 46051 */ GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(46228),
     /* 46056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 46059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 46062 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 46065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 46069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 46073 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 46077 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(46112), // Rule ID 844 //
     /* 46082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 46089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46093 */     // MIs[1] Operand 1
     /* 46093 */     // No operand predicates
     /* 46093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46095 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD64rri8:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 46095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rri8),
     /* 46098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46100 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 46102 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 46104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 46107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46110 */     GIR_RootConstrainSelectedInstOperands,
     /* 46111 */     // GIR_Coverage, 844,
     /* 46111 */     GIR_EraseRootFromParent_Done,
     /* 46112 */   // Label 1345: @46112
     /* 46112 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(46147), // Rule ID 850 //
     /* 46117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 46124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46128 */     // MIs[1] Operand 1
     /* 46128 */     // No operand predicates
     /* 46128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46130 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD64rri8_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 46130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rri8_ND),
     /* 46133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46135 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 46137 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 46139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 46142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46145 */     GIR_RootConstrainSelectedInstOperands,
     /* 46146 */     // GIR_Coverage, 850,
     /* 46146 */     GIR_EraseRootFromParent_Done,
     /* 46147 */   // Label 1346: @46147
     /* 46147 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(46187), // Rule ID 847 //
     /* 46152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46159 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHRD64rrCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 46159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46163 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46169 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 46173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rrCL),
     /* 46176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46178 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 46180 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 46182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46185 */     GIR_RootConstrainSelectedInstOperands,
     /* 46186 */     // GIR_Coverage, 847,
     /* 46186 */     GIR_EraseRootFromParent_Done,
     /* 46187 */   // Label 1347: @46187
     /* 46187 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(46227), // Rule ID 853 //
     /* 46192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46199 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHRD64rrCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 46199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46203 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46209 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 46213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rrCL_ND),
     /* 46216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46218 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 46220 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 46222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46225 */     GIR_RootConstrainSelectedInstOperands,
     /* 46226 */     // GIR_Coverage, 853,
     /* 46226 */     GIR_EraseRootFromParent_Done,
     /* 46227 */   // Label 1348: @46227
     /* 46227 */   GIM_Reject,
     /* 46228 */ // Label 1344: @46228
     /* 46228 */ GIM_Reject,
     /* 46229 */ // Label 1338: @46229
     /* 46229 */ GIM_Reject,
     /* 46230 */ // Label 24: @46230
     /* 46230 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(20), /*)*//*default:*//*Label 1359*/ GIMT_Encode4(48211),
     /* 46241 */ /*GILLT_s8*//*Label 1349*/ GIMT_Encode4(46317),
     /* 46245 */ /*GILLT_s16*//*Label 1350*/ GIMT_Encode4(46528),
     /* 46249 */ /*GILLT_s32*//*Label 1351*/ GIMT_Encode4(46739),
     /* 46253 */ /*GILLT_s64*//*Label 1352*/ GIMT_Encode4(47043), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 46269 */ /*GILLT_v2s64*//*Label 1353*/ GIMT_Encode4(47347), GIMT_Encode4(0),
     /* 46277 */ /*GILLT_v4s32*//*Label 1354*/ GIMT_Encode4(47552),
     /* 46281 */ /*GILLT_v4s64*//*Label 1355*/ GIMT_Encode4(47757), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 46293 */ /*GILLT_v8s32*//*Label 1356*/ GIMT_Encode4(47950),
     /* 46297 */ /*GILLT_v8s64*//*Label 1357*/ GIMT_Encode4(48143), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 46313 */ /*GILLT_v16s32*//*Label 1358*/ GIMT_Encode4(48177),
     /* 46317 */ // Label 1349: @46317
     /* 46317 */ GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(46527),
     /* 46322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 46325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 46328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 46332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 46336 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(46360), // Rule ID 18047 //
     /* 46341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 46348 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROL8r1:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 46348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8r1),
     /* 46351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46358 */     GIR_RootConstrainSelectedInstOperands,
     /* 46359 */     // GIR_Coverage, 18047,
     /* 46359 */     GIR_EraseRootFromParent_Done,
     /* 46360 */   // Label 1361: @46360
     /* 46360 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(46384), // Rule ID 18055 //
     /* 46365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 46368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 46372 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROL8r1_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 46372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8r1_ND),
     /* 46375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46377 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46382 */     GIR_RootConstrainSelectedInstOperands,
     /* 46383 */     // GIR_Coverage, 18055,
     /* 46383 */     GIR_EraseRootFromParent_Done,
     /* 46384 */   // Label 1362: @46384
     /* 46384 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(46417), // Rule ID 786 //
     /* 46389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 46396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46400 */     // MIs[1] Operand 1
     /* 46400 */     // No operand predicates
     /* 46400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46402 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 46402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8ri),
     /* 46405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46407 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 46412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46415 */     GIR_RootConstrainSelectedInstOperands,
     /* 46416 */     // GIR_Coverage, 786,
     /* 46416 */     GIR_EraseRootFromParent_Done,
     /* 46417 */   // Label 1363: @46417
     /* 46417 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(46450), // Rule ID 790 //
     /* 46422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 46429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46433 */     // MIs[1] Operand 1
     /* 46433 */     // No operand predicates
     /* 46433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46435 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 46435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8ri_ND),
     /* 46438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46440 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 46445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46448 */     GIR_RootConstrainSelectedInstOperands,
     /* 46449 */     // GIR_Coverage, 790,
     /* 46449 */     GIR_EraseRootFromParent_Done,
     /* 46450 */   // Label 1364: @46450
     /* 46450 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(46488), // Rule ID 802 //
     /* 46455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46462 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 46462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46466 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46472 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 46476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8rCL),
     /* 46479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46481 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46486 */     GIR_RootConstrainSelectedInstOperands,
     /* 46487 */     // GIR_Coverage, 802,
     /* 46487 */     GIR_EraseRootFromParent_Done,
     /* 46488 */   // Label 1365: @46488
     /* 46488 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(46526), // Rule ID 806 //
     /* 46493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46500 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 46500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46504 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 46514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8rCL_ND),
     /* 46517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46521 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46524 */     GIR_RootConstrainSelectedInstOperands,
     /* 46525 */     // GIR_Coverage, 806,
     /* 46525 */     GIR_EraseRootFromParent_Done,
     /* 46526 */   // Label 1366: @46526
     /* 46526 */   GIM_Reject,
     /* 46527 */ // Label 1360: @46527
     /* 46527 */ GIM_Reject,
     /* 46528 */ // Label 1350: @46528
     /* 46528 */ GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(46738),
     /* 46533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 46536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 46539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 46543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 46547 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(46571), // Rule ID 18048 //
     /* 46552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 46559 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROL16r1:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 46559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16r1),
     /* 46562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46564 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46566 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46569 */     GIR_RootConstrainSelectedInstOperands,
     /* 46570 */     // GIR_Coverage, 18048,
     /* 46570 */     GIR_EraseRootFromParent_Done,
     /* 46571 */   // Label 1368: @46571
     /* 46571 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(46595), // Rule ID 18056 //
     /* 46576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 46579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 46583 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROL16r1_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 46583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16r1_ND),
     /* 46586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46588 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46593 */     GIR_RootConstrainSelectedInstOperands,
     /* 46594 */     // GIR_Coverage, 18056,
     /* 46594 */     GIR_EraseRootFromParent_Done,
     /* 46595 */   // Label 1369: @46595
     /* 46595 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(46628), // Rule ID 787 //
     /* 46600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 46607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46611 */     // MIs[1] Operand 1
     /* 46611 */     // No operand predicates
     /* 46611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46613 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 46613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16ri),
     /* 46616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46618 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 46623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46626 */     GIR_RootConstrainSelectedInstOperands,
     /* 46627 */     // GIR_Coverage, 787,
     /* 46627 */     GIR_EraseRootFromParent_Done,
     /* 46628 */   // Label 1370: @46628
     /* 46628 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(46661), // Rule ID 791 //
     /* 46633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 46640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46644 */     // MIs[1] Operand 1
     /* 46644 */     // No operand predicates
     /* 46644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46646 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 46646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16ri_ND),
     /* 46649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46651 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 46656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46659 */     GIR_RootConstrainSelectedInstOperands,
     /* 46660 */     // GIR_Coverage, 791,
     /* 46660 */     GIR_EraseRootFromParent_Done,
     /* 46661 */   // Label 1371: @46661
     /* 46661 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(46699), // Rule ID 803 //
     /* 46666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46673 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 46673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46677 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46683 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 46687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16rCL),
     /* 46690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46692 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46697 */     GIR_RootConstrainSelectedInstOperands,
     /* 46698 */     // GIR_Coverage, 803,
     /* 46698 */     GIR_EraseRootFromParent_Done,
     /* 46699 */   // Label 1372: @46699
     /* 46699 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(46737), // Rule ID 807 //
     /* 46704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46711 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 46711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46715 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 46725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16rCL_ND),
     /* 46728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46730 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46735 */     GIR_RootConstrainSelectedInstOperands,
     /* 46736 */     // GIR_Coverage, 807,
     /* 46736 */     GIR_EraseRootFromParent_Done,
     /* 46737 */   // Label 1373: @46737
     /* 46737 */   GIM_Reject,
     /* 46738 */ // Label 1367: @46738
     /* 46738 */ GIM_Reject,
     /* 46739 */ // Label 1351: @46739
     /* 46739 */ GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(47042),
     /* 46744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 46747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 46750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 46754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 46758 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(46788), // Rule ID 18091 //
     /* 46763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 46766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 46770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46774 */     // MIs[1] Operand 1
     /* 46774 */     // No operand predicates
     /* 46774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46776 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX32ri:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 46776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32ri),
     /* 46779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46781 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 46783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 46786 */     GIR_RootConstrainSelectedInstOperands,
     /* 46787 */     // GIR_Coverage, 18091,
     /* 46787 */     GIR_EraseRootFromParent_Done,
     /* 46788 */   // Label 1375: @46788
     /* 46788 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(46818), // Rule ID 18123 //
     /* 46793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 46796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 46800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46804 */     // MIs[1] Operand 1
     /* 46804 */     // No operand predicates
     /* 46804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46806 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX32ri_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 46806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32ri_EVEX),
     /* 46809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46811 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 46813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 46816 */     GIR_RootConstrainSelectedInstOperands,
     /* 46817 */     // GIR_Coverage, 18123,
     /* 46817 */     GIR_EraseRootFromParent_Done,
     /* 46818 */   // Label 1376: @46818
     /* 46818 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(46851), // Rule ID 868 //
     /* 46823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 46826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 46830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46834 */     // MIs[1] Operand 1
     /* 46834 */     // No operand predicates
     /* 46834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46836 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHRDROT32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 46836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRDROT32ri),
     /* 46839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46841 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 46846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46849 */     GIR_RootConstrainSelectedInstOperands,
     /* 46850 */     // GIR_Coverage, 868,
     /* 46850 */     GIR_EraseRootFromParent_Done,
     /* 46851 */   // Label 1377: @46851
     /* 46851 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(46875), // Rule ID 18049 //
     /* 46856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 46863 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROL32r1:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 46863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32r1),
     /* 46866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46868 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46870 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46873 */     GIR_RootConstrainSelectedInstOperands,
     /* 46874 */     // GIR_Coverage, 18049,
     /* 46874 */     GIR_EraseRootFromParent_Done,
     /* 46875 */   // Label 1378: @46875
     /* 46875 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(46899), // Rule ID 18057 //
     /* 46880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 46883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 46887 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROL32r1_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 46887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32r1_ND),
     /* 46890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46892 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46897 */     GIR_RootConstrainSelectedInstOperands,
     /* 46898 */     // GIR_Coverage, 18057,
     /* 46898 */     GIR_EraseRootFromParent_Done,
     /* 46899 */   // Label 1379: @46899
     /* 46899 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(46932), // Rule ID 788 //
     /* 46904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 46911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46915 */     // MIs[1] Operand 1
     /* 46915 */     // No operand predicates
     /* 46915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46917 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 46917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32ri),
     /* 46920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46922 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 46927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46930 */     GIR_RootConstrainSelectedInstOperands,
     /* 46931 */     // GIR_Coverage, 788,
     /* 46931 */     GIR_EraseRootFromParent_Done,
     /* 46932 */   // Label 1380: @46932
     /* 46932 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(46965), // Rule ID 792 //
     /* 46937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 46944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46948 */     // MIs[1] Operand 1
     /* 46948 */     // No operand predicates
     /* 46948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46950 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 46950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32ri_ND),
     /* 46953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46955 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 46960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46963 */     GIR_RootConstrainSelectedInstOperands,
     /* 46964 */     // GIR_Coverage, 792,
     /* 46964 */     GIR_EraseRootFromParent_Done,
     /* 46965 */   // Label 1381: @46965
     /* 46965 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(47003), // Rule ID 804 //
     /* 46970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46977 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 46977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46981 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46987 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 46991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32rCL),
     /* 46994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46996 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47001 */     GIR_RootConstrainSelectedInstOperands,
     /* 47002 */     // GIR_Coverage, 804,
     /* 47002 */     GIR_EraseRootFromParent_Done,
     /* 47003 */   // Label 1382: @47003
     /* 47003 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(47041), // Rule ID 808 //
     /* 47008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 47011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 47015 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 47015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 47019 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47025 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 47029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32rCL_ND),
     /* 47032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47034 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47039 */     GIR_RootConstrainSelectedInstOperands,
     /* 47040 */     // GIR_Coverage, 808,
     /* 47040 */     GIR_EraseRootFromParent_Done,
     /* 47041 */   // Label 1383: @47041
     /* 47041 */   GIM_Reject,
     /* 47042 */ // Label 1374: @47042
     /* 47042 */ GIM_Reject,
     /* 47043 */ // Label 1352: @47043
     /* 47043 */ GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(47346),
     /* 47048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 47051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 47054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 47058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 47062 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(47092), // Rule ID 18092 //
     /* 47067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 47070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 47074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 47078 */     // MIs[1] Operand 1
     /* 47078 */     // No operand predicates
     /* 47078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 47080 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX64ri:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 47080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64ri),
     /* 47083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47085 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 47087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 47090 */     GIR_RootConstrainSelectedInstOperands,
     /* 47091 */     // GIR_Coverage, 18092,
     /* 47091 */     GIR_EraseRootFromParent_Done,
     /* 47092 */   // Label 1385: @47092
     /* 47092 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(47122), // Rule ID 18124 //
     /* 47097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 47100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 47104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 47108 */     // MIs[1] Operand 1
     /* 47108 */     // No operand predicates
     /* 47108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 47110 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX64ri_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 47110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64ri_EVEX),
     /* 47113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47115 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 47117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 47120 */     GIR_RootConstrainSelectedInstOperands,
     /* 47121 */     // GIR_Coverage, 18124,
     /* 47121 */     GIR_EraseRootFromParent_Done,
     /* 47122 */   // Label 1386: @47122
     /* 47122 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(47155), // Rule ID 869 //
     /* 47127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 47130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 47134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 47138 */     // MIs[1] Operand 1
     /* 47138 */     // No operand predicates
     /* 47138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 47140 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHRDROT64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 47140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRDROT64ri),
     /* 47143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47145 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 47150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47153 */     GIR_RootConstrainSelectedInstOperands,
     /* 47154 */     // GIR_Coverage, 869,
     /* 47154 */     GIR_EraseRootFromParent_Done,
     /* 47155 */   // Label 1387: @47155
     /* 47155 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(47179), // Rule ID 18050 //
     /* 47160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 47163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 47167 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROL64r1:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 47167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64r1),
     /* 47170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47172 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47177 */     GIR_RootConstrainSelectedInstOperands,
     /* 47178 */     // GIR_Coverage, 18050,
     /* 47178 */     GIR_EraseRootFromParent_Done,
     /* 47179 */   // Label 1388: @47179
     /* 47179 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(47203), // Rule ID 18058 //
     /* 47184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 47187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 47191 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROL64r1_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 47191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64r1_ND),
     /* 47194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47196 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47201 */     GIR_RootConstrainSelectedInstOperands,
     /* 47202 */     // GIR_Coverage, 18058,
     /* 47202 */     GIR_EraseRootFromParent_Done,
     /* 47203 */   // Label 1389: @47203
     /* 47203 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(47236), // Rule ID 789 //
     /* 47208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 47211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 47215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 47219 */     // MIs[1] Operand 1
     /* 47219 */     // No operand predicates
     /* 47219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 47221 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 47221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64ri),
     /* 47224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47226 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 47231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47234 */     GIR_RootConstrainSelectedInstOperands,
     /* 47235 */     // GIR_Coverage, 789,
     /* 47235 */     GIR_EraseRootFromParent_Done,
     /* 47236 */   // Label 1390: @47236
     /* 47236 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(47269), // Rule ID 793 //
     /* 47241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 47244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 47248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 47252 */     // MIs[1] Operand 1
     /* 47252 */     // No operand predicates
     /* 47252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 47254 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 47254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64ri_ND),
     /* 47257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47259 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 47264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47267 */     GIR_RootConstrainSelectedInstOperands,
     /* 47268 */     // GIR_Coverage, 793,
     /* 47268 */     GIR_EraseRootFromParent_Done,
     /* 47269 */   // Label 1391: @47269
     /* 47269 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(47307), // Rule ID 805 //
     /* 47274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 47277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 47281 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 47281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 47285 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47291 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 47295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64rCL),
     /* 47298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47300 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47305 */     GIR_RootConstrainSelectedInstOperands,
     /* 47306 */     // GIR_Coverage, 805,
     /* 47306 */     GIR_EraseRootFromParent_Done,
     /* 47307 */   // Label 1392: @47307
     /* 47307 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(47345), // Rule ID 809 //
     /* 47312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 47315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 47319 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 47319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 47323 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 47333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64rCL_ND),
     /* 47336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47338 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47343 */     GIR_RootConstrainSelectedInstOperands,
     /* 47344 */     // GIR_Coverage, 809,
     /* 47344 */     GIR_EraseRootFromParent_Done,
     /* 47345 */   // Label 1393: @47345
     /* 47345 */   GIM_Reject,
     /* 47346 */ // Label 1384: @47346
     /* 47346 */ GIM_Reject,
     /* 47347 */ // Label 1353: @47347
     /* 47347 */ GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(47551),
     /* 47352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 47355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 47358 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(47385), // Rule ID 7999 //
     /* 47363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 47366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47378 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPRORVQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 47378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ128rr),
     /* 47383 */     GIR_RootConstrainSelectedInstOperands,
     /* 47384 */     // GIR_Coverage, 7999,
     /* 47384 */     GIR_Done,
     /* 47385 */   // Label 1395: @47385
     /* 47385 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(47550), // Rule ID 21251 //
     /* 47390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 47393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 47397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47405 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPRORVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 47405 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 47408 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 47412 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 47419 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 47422 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 47426 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47431 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 47434 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 47438 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 47441 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 47446 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 47451 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 47456 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 47459 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 47463 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 47470 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 47473 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 47477 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47482 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 47485 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 47489 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 47492 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 47497 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 47502 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 47507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 47510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 47514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47519 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 47522 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 47525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 47530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47532 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 47539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 47544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 47549 */     // GIR_Coverage, 21251,
     /* 47549 */     GIR_EraseRootFromParent_Done,
     /* 47550 */   // Label 1396: @47550
     /* 47550 */   GIM_Reject,
     /* 47551 */ // Label 1394: @47551
     /* 47551 */ GIM_Reject,
     /* 47552 */ // Label 1354: @47552
     /* 47552 */ GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(47756),
     /* 47557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 47560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 47563 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(47590), // Rule ID 7972 //
     /* 47568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 47571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47583 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPRORVDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 47583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ128rr),
     /* 47588 */     GIR_RootConstrainSelectedInstOperands,
     /* 47589 */     // GIR_Coverage, 7972,
     /* 47589 */     GIR_Done,
     /* 47590 */   // Label 1398: @47590
     /* 47590 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(47755), // Rule ID 21253 //
     /* 47595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 47598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 47602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47610 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPRORVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 47610 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 47613 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 47617 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 47624 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 47627 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 47631 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47636 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 47639 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 47643 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 47646 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 47651 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 47656 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 47661 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 47664 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 47668 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 47675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 47678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 47682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47687 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 47690 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 47694 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 47697 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 47702 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 47707 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 47712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 47715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 47719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47724 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 47727 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 47730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 47735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47737 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 47744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 47749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 47754 */     // GIR_Coverage, 21253,
     /* 47754 */     GIR_EraseRootFromParent_Done,
     /* 47755 */   // Label 1399: @47755
     /* 47755 */   GIM_Reject,
     /* 47756 */ // Label 1397: @47756
     /* 47756 */ GIM_Reject,
     /* 47757 */ // Label 1355: @47757
     /* 47757 */ GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(47949),
     /* 47762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 47765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 47768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 47772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 47776 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 47780 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(47795), // Rule ID 7990 //
     /* 47785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 47788 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPRORVQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 47788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ256rr),
     /* 47793 */     GIR_RootConstrainSelectedInstOperands,
     /* 47794 */     // GIR_Coverage, 7990,
     /* 47794 */     GIR_Done,
     /* 47795 */   // Label 1401: @47795
     /* 47795 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(47948), // Rule ID 21252 //
     /* 47800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 47803 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPRORVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 47803 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 47806 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 47810 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 47817 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 47820 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 47824 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47829 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 47832 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 47836 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 47839 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 47844 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 47849 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 47854 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 47857 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 47861 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 47868 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 47871 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 47875 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47880 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 47883 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 47887 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 47890 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 47895 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 47900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 47905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 47908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 47912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47917 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 47920 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 47923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 47928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47930 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 47937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 47942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 47947 */     // GIR_Coverage, 21252,
     /* 47947 */     GIR_EraseRootFromParent_Done,
     /* 47948 */   // Label 1402: @47948
     /* 47948 */   GIM_Reject,
     /* 47949 */ // Label 1400: @47949
     /* 47949 */ GIM_Reject,
     /* 47950 */ // Label 1356: @47950
     /* 47950 */ GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(48142),
     /* 47955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 47958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 47961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 47965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 47969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 47973 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(47988), // Rule ID 7963 //
     /* 47978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 47981 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPRORVDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 47981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ256rr),
     /* 47986 */     GIR_RootConstrainSelectedInstOperands,
     /* 47987 */     // GIR_Coverage, 7963,
     /* 47987 */     GIR_Done,
     /* 47988 */   // Label 1404: @47988
     /* 47988 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(48141), // Rule ID 21254 //
     /* 47993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 47996 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPRORVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 47996 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 47999 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 48003 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 48010 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 48013 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 48017 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48022 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 48025 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 48029 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 48032 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 48037 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 48042 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 48047 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 48050 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 48054 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 48061 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 48064 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 48068 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48073 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 48076 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 48080 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 48083 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 48088 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 48093 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 48098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 48101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 48105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48110 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 48113 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 48116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 48118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 48121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48123 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 48130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 48135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 48140 */     // GIR_Coverage, 21254,
     /* 48140 */     GIR_EraseRootFromParent_Done,
     /* 48141 */   // Label 1405: @48141
     /* 48141 */   GIM_Reject,
     /* 48142 */ // Label 1403: @48142
     /* 48142 */ GIM_Reject,
     /* 48143 */ // Label 1357: @48143
     /* 48143 */ GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(48176), // Rule ID 7981 //
     /* 48148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 48151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 48154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 48157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 48161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 48165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 48169 */   // (rotr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPRORVQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 48169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 48174 */   GIR_RootConstrainSelectedInstOperands,
     /* 48175 */   // GIR_Coverage, 7981,
     /* 48175 */   GIR_Done,
     /* 48176 */ // Label 1406: @48176
     /* 48176 */ GIM_Reject,
     /* 48177 */ // Label 1358: @48177
     /* 48177 */ GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(48210), // Rule ID 7954 //
     /* 48182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 48185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 48188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 48191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 48195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 48199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 48203 */   // (rotr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPRORVDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 48203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 48208 */   GIR_RootConstrainSelectedInstOperands,
     /* 48209 */   // GIR_Coverage, 7954,
     /* 48209 */   GIR_Done,
     /* 48210 */ // Label 1407: @48210
     /* 48210 */ GIM_Reject,
     /* 48211 */ // Label 1359: @48211
     /* 48211 */ GIM_Reject,
     /* 48212 */ // Label 25: @48212
     /* 48212 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(20), /*)*//*default:*//*Label 1420*/ GIMT_Encode4(50195),
     /* 48223 */ /*GILLT_s8*//*Label 1408*/ GIMT_Encode4(48299),
     /* 48227 */ /*GILLT_s16*//*Label 1409*/ GIMT_Encode4(48510),
     /* 48231 */ /*GILLT_s32*//*Label 1410*/ GIMT_Encode4(48721),
     /* 48235 */ /*GILLT_s64*//*Label 1411*/ GIMT_Encode4(48965), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 48251 */ /*GILLT_v2s64*//*Label 1412*/ GIMT_Encode4(49209), GIMT_Encode4(0),
     /* 48259 */ /*GILLT_v4s32*//*Label 1413*/ GIMT_Encode4(49441),
     /* 48263 */ /*GILLT_v4s64*//*Label 1414*/ GIMT_Encode4(49673), GIMT_Encode4(0),
     /* 48271 */ /*GILLT_v8s16*//*Label 1415*/ GIMT_Encode4(49866),
     /* 48275 */ /*GILLT_v8s32*//*Label 1416*/ GIMT_Encode4(49900),
     /* 48279 */ /*GILLT_v8s64*//*Label 1417*/ GIMT_Encode4(50093), GIMT_Encode4(0),
     /* 48287 */ /*GILLT_v16s8*//*Label 1418*/ GIMT_Encode4(50127), GIMT_Encode4(0),
     /* 48295 */ /*GILLT_v16s32*//*Label 1419*/ GIMT_Encode4(50161),
     /* 48299 */ // Label 1408: @48299
     /* 48299 */ GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(48509),
     /* 48304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 48307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 48310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 48314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 48318 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(48342), // Rule ID 18043 //
     /* 48323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 48326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 48330 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROR8r1:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 48330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8r1),
     /* 48333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48335 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48337 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48340 */     GIR_RootConstrainSelectedInstOperands,
     /* 48341 */     // GIR_Coverage, 18043,
     /* 48341 */     GIR_EraseRootFromParent_Done,
     /* 48342 */   // Label 1422: @48342
     /* 48342 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(48366), // Rule ID 18051 //
     /* 48347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 48350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 48354 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROR8r1_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 48354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8r1_ND),
     /* 48357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48359 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48364 */     GIR_RootConstrainSelectedInstOperands,
     /* 48365 */     // GIR_Coverage, 18051,
     /* 48365 */     GIR_EraseRootFromParent_Done,
     /* 48366 */   // Label 1423: @48366
     /* 48366 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(48399), // Rule ID 754 //
     /* 48371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 48374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 48378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 48382 */     // MIs[1] Operand 1
     /* 48382 */     // No operand predicates
     /* 48382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 48384 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 48384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8ri),
     /* 48387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48389 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 48394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48397 */     GIR_RootConstrainSelectedInstOperands,
     /* 48398 */     // GIR_Coverage, 754,
     /* 48398 */     GIR_EraseRootFromParent_Done,
     /* 48399 */   // Label 1424: @48399
     /* 48399 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(48432), // Rule ID 758 //
     /* 48404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 48407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 48411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 48415 */     // MIs[1] Operand 1
     /* 48415 */     // No operand predicates
     /* 48415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 48417 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 48417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8ri_ND),
     /* 48420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48422 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 48427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48430 */     GIR_RootConstrainSelectedInstOperands,
     /* 48431 */     // GIR_Coverage, 758,
     /* 48431 */     GIR_EraseRootFromParent_Done,
     /* 48432 */   // Label 1425: @48432
     /* 48432 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(48470), // Rule ID 770 //
     /* 48437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 48440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 48444 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROL8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 48444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 48448 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 48458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8rCL),
     /* 48461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48463 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48468 */     GIR_RootConstrainSelectedInstOperands,
     /* 48469 */     // GIR_Coverage, 770,
     /* 48469 */     GIR_EraseRootFromParent_Done,
     /* 48470 */   // Label 1426: @48470
     /* 48470 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(48508), // Rule ID 774 //
     /* 48475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 48478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 48482 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROL8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 48482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 48486 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48492 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 48496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8rCL_ND),
     /* 48499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48501 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48503 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48506 */     GIR_RootConstrainSelectedInstOperands,
     /* 48507 */     // GIR_Coverage, 774,
     /* 48507 */     GIR_EraseRootFromParent_Done,
     /* 48508 */   // Label 1427: @48508
     /* 48508 */   GIM_Reject,
     /* 48509 */ // Label 1421: @48509
     /* 48509 */ GIM_Reject,
     /* 48510 */ // Label 1409: @48510
     /* 48510 */ GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(48720),
     /* 48515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 48518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 48521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 48525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 48529 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(48553), // Rule ID 18044 //
     /* 48534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 48537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 48541 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROR16r1:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 48541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16r1),
     /* 48544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48546 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48551 */     GIR_RootConstrainSelectedInstOperands,
     /* 48552 */     // GIR_Coverage, 18044,
     /* 48552 */     GIR_EraseRootFromParent_Done,
     /* 48553 */   // Label 1429: @48553
     /* 48553 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(48577), // Rule ID 18052 //
     /* 48558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 48561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 48565 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROR16r1_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 48565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16r1_ND),
     /* 48568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48570 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48575 */     GIR_RootConstrainSelectedInstOperands,
     /* 48576 */     // GIR_Coverage, 18052,
     /* 48576 */     GIR_EraseRootFromParent_Done,
     /* 48577 */   // Label 1430: @48577
     /* 48577 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(48610), // Rule ID 755 //
     /* 48582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 48585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 48589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 48593 */     // MIs[1] Operand 1
     /* 48593 */     // No operand predicates
     /* 48593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 48595 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 48595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri),
     /* 48598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48600 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 48605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48608 */     GIR_RootConstrainSelectedInstOperands,
     /* 48609 */     // GIR_Coverage, 755,
     /* 48609 */     GIR_EraseRootFromParent_Done,
     /* 48610 */   // Label 1431: @48610
     /* 48610 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(48643), // Rule ID 759 //
     /* 48615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 48618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 48622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 48626 */     // MIs[1] Operand 1
     /* 48626 */     // No operand predicates
     /* 48626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 48628 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 48628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri_ND),
     /* 48631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48633 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 48638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48641 */     GIR_RootConstrainSelectedInstOperands,
     /* 48642 */     // GIR_Coverage, 759,
     /* 48642 */     GIR_EraseRootFromParent_Done,
     /* 48643 */   // Label 1432: @48643
     /* 48643 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(48681), // Rule ID 771 //
     /* 48648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 48651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 48655 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROL16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 48655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 48659 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48665 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 48669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16rCL),
     /* 48672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48674 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48679 */     GIR_RootConstrainSelectedInstOperands,
     /* 48680 */     // GIR_Coverage, 771,
     /* 48680 */     GIR_EraseRootFromParent_Done,
     /* 48681 */   // Label 1433: @48681
     /* 48681 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(48719), // Rule ID 775 //
     /* 48686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 48689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 48693 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROL16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 48693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 48697 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48703 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 48707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16rCL_ND),
     /* 48710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48712 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48717 */     GIR_RootConstrainSelectedInstOperands,
     /* 48718 */     // GIR_Coverage, 775,
     /* 48718 */     GIR_EraseRootFromParent_Done,
     /* 48719 */   // Label 1434: @48719
     /* 48719 */   GIM_Reject,
     /* 48720 */ // Label 1428: @48720
     /* 48720 */ GIM_Reject,
     /* 48721 */ // Label 1410: @48721
     /* 48721 */ GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(48964),
     /* 48726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 48729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 48732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 48736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 48740 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(48773), // Rule ID 866 //
     /* 48745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 48748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 48752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 48756 */     // MIs[1] Operand 1
     /* 48756 */     // No operand predicates
     /* 48756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 48758 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHLDROT32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 48758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLDROT32ri),
     /* 48761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48763 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 48768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48771 */     GIR_RootConstrainSelectedInstOperands,
     /* 48772 */     // GIR_Coverage, 866,
     /* 48772 */     GIR_EraseRootFromParent_Done,
     /* 48773 */   // Label 1436: @48773
     /* 48773 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(48797), // Rule ID 18045 //
     /* 48778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 48781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 48785 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROR32r1:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 48785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32r1),
     /* 48788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48790 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48795 */     GIR_RootConstrainSelectedInstOperands,
     /* 48796 */     // GIR_Coverage, 18045,
     /* 48796 */     GIR_EraseRootFromParent_Done,
     /* 48797 */   // Label 1437: @48797
     /* 48797 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(48821), // Rule ID 18053 //
     /* 48802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 48805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 48809 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROR32r1_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 48809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32r1_ND),
     /* 48812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48814 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48819 */     GIR_RootConstrainSelectedInstOperands,
     /* 48820 */     // GIR_Coverage, 18053,
     /* 48820 */     GIR_EraseRootFromParent_Done,
     /* 48821 */   // Label 1438: @48821
     /* 48821 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(48854), // Rule ID 756 //
     /* 48826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 48829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 48833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 48837 */     // MIs[1] Operand 1
     /* 48837 */     // No operand predicates
     /* 48837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 48839 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 48839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32ri),
     /* 48842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48844 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 48849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48852 */     GIR_RootConstrainSelectedInstOperands,
     /* 48853 */     // GIR_Coverage, 756,
     /* 48853 */     GIR_EraseRootFromParent_Done,
     /* 48854 */   // Label 1439: @48854
     /* 48854 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(48887), // Rule ID 760 //
     /* 48859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 48862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 48866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 48870 */     // MIs[1] Operand 1
     /* 48870 */     // No operand predicates
     /* 48870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 48872 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 48872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32ri_ND),
     /* 48875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48877 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 48882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48885 */     GIR_RootConstrainSelectedInstOperands,
     /* 48886 */     // GIR_Coverage, 760,
     /* 48886 */     GIR_EraseRootFromParent_Done,
     /* 48887 */   // Label 1440: @48887
     /* 48887 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(48925), // Rule ID 772 //
     /* 48892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 48895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 48899 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROL32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 48899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 48903 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48909 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 48913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32rCL),
     /* 48916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48918 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48923 */     GIR_RootConstrainSelectedInstOperands,
     /* 48924 */     // GIR_Coverage, 772,
     /* 48924 */     GIR_EraseRootFromParent_Done,
     /* 48925 */   // Label 1441: @48925
     /* 48925 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(48963), // Rule ID 776 //
     /* 48930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 48933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 48937 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROL32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 48937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 48941 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48947 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 48951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32rCL_ND),
     /* 48954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48956 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48961 */     GIR_RootConstrainSelectedInstOperands,
     /* 48962 */     // GIR_Coverage, 776,
     /* 48962 */     GIR_EraseRootFromParent_Done,
     /* 48963 */   // Label 1442: @48963
     /* 48963 */   GIM_Reject,
     /* 48964 */ // Label 1435: @48964
     /* 48964 */ GIM_Reject,
     /* 48965 */ // Label 1411: @48965
     /* 48965 */ GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(49208),
     /* 48970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 48973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 48976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 48980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 48984 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(49017), // Rule ID 867 //
     /* 48989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 48992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 48996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 49000 */     // MIs[1] Operand 1
     /* 49000 */     // No operand predicates
     /* 49000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49002 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHLDROT64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 49002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLDROT64ri),
     /* 49005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49007 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 49012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49015 */     GIR_RootConstrainSelectedInstOperands,
     /* 49016 */     // GIR_Coverage, 867,
     /* 49016 */     GIR_EraseRootFromParent_Done,
     /* 49017 */   // Label 1444: @49017
     /* 49017 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(49041), // Rule ID 18046 //
     /* 49022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 49025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 49029 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROR64r1:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 49029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64r1),
     /* 49032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49034 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49039 */     GIR_RootConstrainSelectedInstOperands,
     /* 49040 */     // GIR_Coverage, 18046,
     /* 49040 */     GIR_EraseRootFromParent_Done,
     /* 49041 */   // Label 1445: @49041
     /* 49041 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(49065), // Rule ID 18054 //
     /* 49046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 49049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 49053 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROR64r1_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 49053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64r1_ND),
     /* 49056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49058 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49060 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49063 */     GIR_RootConstrainSelectedInstOperands,
     /* 49064 */     // GIR_Coverage, 18054,
     /* 49064 */     GIR_EraseRootFromParent_Done,
     /* 49065 */   // Label 1446: @49065
     /* 49065 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(49098), // Rule ID 757 //
     /* 49070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 49073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 49077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 49081 */     // MIs[1] Operand 1
     /* 49081 */     // No operand predicates
     /* 49081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49083 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 49083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64ri),
     /* 49086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49088 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 49093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49096 */     GIR_RootConstrainSelectedInstOperands,
     /* 49097 */     // GIR_Coverage, 757,
     /* 49097 */     GIR_EraseRootFromParent_Done,
     /* 49098 */   // Label 1447: @49098
     /* 49098 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(49131), // Rule ID 761 //
     /* 49103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 49106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 49110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 49114 */     // MIs[1] Operand 1
     /* 49114 */     // No operand predicates
     /* 49114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49116 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 49116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64ri_ND),
     /* 49119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49121 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 49126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49129 */     GIR_RootConstrainSelectedInstOperands,
     /* 49130 */     // GIR_Coverage, 761,
     /* 49130 */     GIR_EraseRootFromParent_Done,
     /* 49131 */   // Label 1448: @49131
     /* 49131 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(49169), // Rule ID 773 //
     /* 49136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 49139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 49143 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROL64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 49143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 49147 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49153 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 49157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64rCL),
     /* 49160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49162 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49167 */     GIR_RootConstrainSelectedInstOperands,
     /* 49168 */     // GIR_Coverage, 773,
     /* 49168 */     GIR_EraseRootFromParent_Done,
     /* 49169 */   // Label 1449: @49169
     /* 49169 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(49207), // Rule ID 777 //
     /* 49174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 49177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 49181 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROL64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 49181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 49185 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49191 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 49195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64rCL_ND),
     /* 49198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49200 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49205 */     GIR_RootConstrainSelectedInstOperands,
     /* 49206 */     // GIR_Coverage, 777,
     /* 49206 */     GIR_EraseRootFromParent_Done,
     /* 49207 */   // Label 1450: @49207
     /* 49207 */   GIM_Reject,
     /* 49208 */ // Label 1443: @49208
     /* 49208 */ GIM_Reject,
     /* 49209 */ // Label 1412: @49209
     /* 49209 */ GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(49440),
     /* 49214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 49217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 49220 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(49247), // Rule ID 1578 //
     /* 49225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 49228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 49232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 49236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 49240 */     // (rotl:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPROTQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 49240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTQrr),
     /* 49245 */     GIR_RootConstrainSelectedInstOperands,
     /* 49246 */     // GIR_Coverage, 1578,
     /* 49246 */     GIR_Done,
     /* 49247 */   // Label 1452: @49247
     /* 49247 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(49274), // Rule ID 8053 //
     /* 49252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 49255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49267 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPROLVQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 49267 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ128rr),
     /* 49272 */     GIR_RootConstrainSelectedInstOperands,
     /* 49273 */     // GIR_Coverage, 8053,
     /* 49273 */     GIR_Done,
     /* 49274 */   // Label 1453: @49274
     /* 49274 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(49439), // Rule ID 21243 //
     /* 49279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 49282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 49286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49294 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPROLVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 49294 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 49297 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 49301 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 49308 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 49311 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 49315 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49320 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 49323 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 49327 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 49330 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 49335 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 49340 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 49345 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 49348 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 49352 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 49359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 49362 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 49366 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49371 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 49374 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 49378 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 49381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 49386 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 49391 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 49396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 49399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 49403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49408 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 49411 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 49414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 49419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49421 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 49428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 49433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 49438 */     // GIR_Coverage, 21243,
     /* 49438 */     GIR_EraseRootFromParent_Done,
     /* 49439 */   // Label 1454: @49439
     /* 49439 */   GIM_Reject,
     /* 49440 */ // Label 1451: @49440
     /* 49440 */ GIM_Reject,
     /* 49441 */ // Label 1413: @49441
     /* 49441 */ GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(49672),
     /* 49446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 49449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 49452 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(49479), // Rule ID 1575 //
     /* 49457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 49460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 49464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 49468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 49472 */     // (rotl:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPROTDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 49472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTDrr),
     /* 49477 */     GIR_RootConstrainSelectedInstOperands,
     /* 49478 */     // GIR_Coverage, 1575,
     /* 49478 */     GIR_Done,
     /* 49479 */   // Label 1456: @49479
     /* 49479 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(49506), // Rule ID 8026 //
     /* 49484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 49487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49499 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPROLVDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 49499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ128rr),
     /* 49504 */     GIR_RootConstrainSelectedInstOperands,
     /* 49505 */     // GIR_Coverage, 8026,
     /* 49505 */     GIR_Done,
     /* 49506 */   // Label 1457: @49506
     /* 49506 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(49671), // Rule ID 21245 //
     /* 49511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 49514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 49518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49526 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPROLVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 49526 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 49529 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 49533 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 49540 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 49543 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 49547 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49552 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 49555 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 49559 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 49562 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 49567 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 49572 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 49577 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 49580 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 49584 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 49591 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 49594 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 49598 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49603 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 49606 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 49610 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 49613 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 49618 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 49623 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 49628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 49631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 49635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49640 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 49643 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 49646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 49651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49653 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 49660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 49665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 49670 */     // GIR_Coverage, 21245,
     /* 49670 */     GIR_EraseRootFromParent_Done,
     /* 49671 */   // Label 1458: @49671
     /* 49671 */   GIM_Reject,
     /* 49672 */ // Label 1455: @49672
     /* 49672 */ GIM_Reject,
     /* 49673 */ // Label 1414: @49673
     /* 49673 */ GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(49865),
     /* 49678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 49681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 49684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 49688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 49692 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 49696 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(49711), // Rule ID 8044 //
     /* 49701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 49704 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPROLVQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 49704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ256rr),
     /* 49709 */     GIR_RootConstrainSelectedInstOperands,
     /* 49710 */     // GIR_Coverage, 8044,
     /* 49710 */     GIR_Done,
     /* 49711 */   // Label 1460: @49711
     /* 49711 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(49864), // Rule ID 21244 //
     /* 49716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 49719 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPROLVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 49719 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 49722 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 49726 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 49733 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 49736 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 49740 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49745 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 49748 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 49752 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 49755 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 49760 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 49765 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 49770 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 49773 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 49777 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 49784 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 49787 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 49791 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49796 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 49799 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 49803 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 49806 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 49811 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 49816 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 49821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 49824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 49828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49833 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 49836 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 49839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 49844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49846 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 49853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 49858 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 49863 */     // GIR_Coverage, 21244,
     /* 49863 */     GIR_EraseRootFromParent_Done,
     /* 49864 */   // Label 1461: @49864
     /* 49864 */   GIM_Reject,
     /* 49865 */ // Label 1459: @49865
     /* 49865 */ GIM_Reject,
     /* 49866 */ // Label 1415: @49866
     /* 49866 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(49899), // Rule ID 1581 //
     /* 49871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 49874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 49877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 49880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 49884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 49888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 49892 */   // (rotl:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPROTWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 49892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTWrr),
     /* 49897 */   GIR_RootConstrainSelectedInstOperands,
     /* 49898 */   // GIR_Coverage, 1581,
     /* 49898 */   GIR_Done,
     /* 49899 */ // Label 1462: @49899
     /* 49899 */ GIM_Reject,
     /* 49900 */ // Label 1416: @49900
     /* 49900 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(50092),
     /* 49905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 49908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 49911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 49915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 49919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 49923 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(49938), // Rule ID 8017 //
     /* 49928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 49931 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPROLVDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 49931 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ256rr),
     /* 49936 */     GIR_RootConstrainSelectedInstOperands,
     /* 49937 */     // GIR_Coverage, 8017,
     /* 49937 */     GIR_Done,
     /* 49938 */   // Label 1464: @49938
     /* 49938 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(50091), // Rule ID 21246 //
     /* 49943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 49946 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPROLVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 49946 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 49949 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 49953 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 49960 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 49963 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 49967 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49972 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 49975 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 49979 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 49982 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 49987 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 49992 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 49997 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 50000 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 50004 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 50011 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 50014 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 50018 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50023 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 50026 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 50030 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 50033 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 50038 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 50043 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 50048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 50051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 50055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50060 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 50063 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 50066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 50068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 50071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50073 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 50080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 50085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 50090 */     // GIR_Coverage, 21246,
     /* 50090 */     GIR_EraseRootFromParent_Done,
     /* 50091 */   // Label 1465: @50091
     /* 50091 */   GIM_Reject,
     /* 50092 */ // Label 1463: @50092
     /* 50092 */ GIM_Reject,
     /* 50093 */ // Label 1417: @50093
     /* 50093 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(50126), // Rule ID 8035 //
     /* 50098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 50101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 50104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 50107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 50111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 50115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 50119 */   // (rotl:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPROLVQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 50119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 50124 */   GIR_RootConstrainSelectedInstOperands,
     /* 50125 */   // GIR_Coverage, 8035,
     /* 50125 */   GIR_Done,
     /* 50126 */ // Label 1466: @50126
     /* 50126 */ GIM_Reject,
     /* 50127 */ // Label 1418: @50127
     /* 50127 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(50160), // Rule ID 1572 //
     /* 50132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 50135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 50138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 50141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 50145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 50149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 50153 */   // (rotl:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPROTBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 50153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTBrr),
     /* 50158 */   GIR_RootConstrainSelectedInstOperands,
     /* 50159 */   // GIR_Coverage, 1572,
     /* 50159 */   GIR_Done,
     /* 50160 */ // Label 1467: @50160
     /* 50160 */ GIM_Reject,
     /* 50161 */ // Label 1419: @50161
     /* 50161 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(50194), // Rule ID 8008 //
     /* 50166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 50169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 50172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 50175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 50179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 50183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 50187 */   // (rotl:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPROLVDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 50187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 50192 */   GIR_RootConstrainSelectedInstOperands,
     /* 50193 */   // GIR_Coverage, 8008,
     /* 50193 */   GIR_Done,
     /* 50194 */ // Label 1468: @50194
     /* 50194 */ GIM_Reject,
     /* 50195 */ // Label 1420: @50195
     /* 50195 */ GIM_Reject,
     /* 50196 */ // Label 26: @50196
     /* 50196 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(24), /*)*//*default:*//*Label 1475*/ GIMT_Encode4(51852),
     /* 50207 */ /*GILLT_v2s1*//*Label 1469*/ GIMT_Encode4(50275), GIMT_Encode4(0),
     /* 50215 */ /*GILLT_v4s1*//*Label 1470*/ GIMT_Encode4(50436), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 50227 */ /*GILLT_v8s1*//*Label 1471*/ GIMT_Encode4(50783), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 50243 */ /*GILLT_v16s1*//*Label 1472*/ GIMT_Encode4(51180), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 50259 */ /*GILLT_v32s1*//*Label 1473*/ GIMT_Encode4(51577), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 50271 */ /*GILLT_v64s1*//*Label 1474*/ GIMT_Encode4(51801),
     /* 50275 */ // Label 1469: @50275
     /* 50275 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(50435),
     /* 50280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 50283 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 50286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 50290 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 50295 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 50299 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(50330), // Rule ID 12603 //
     /* 50304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 50307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 50311 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 50317 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 50319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50321 */     // (setcc:{ *:[v2i1] } immAllZerosV:{ *:[v2i64] }, VR128X:{ *:[v2i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZ128kr:{ *:[v2i1] } VR128X:{ *:[v2i64] }:$src)
     /* 50321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZ128kr),
     /* 50324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50326 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 50328 */     GIR_RootConstrainSelectedInstOperands,
     /* 50329 */     // GIR_Coverage, 12603,
     /* 50329 */     GIR_EraseRootFromParent_Done,
     /* 50330 */   // Label 1477: @50330
     /* 50330 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(50434), // Rule ID 22105 //
     /* 50335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 50338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 50342 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 50348 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 50350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50352 */     // (setcc:{ *:[v2i1] } immAllZerosV:{ *:[v2i64] }, VR128X:{ *:[v2i64] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (VPMOVQ2MZkr:{ *:[v8i1] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] })), VK2:{ *:[i32] })
     /* 50352 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 50355 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 50359 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 50366 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 50369 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 50373 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50378 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 50381 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 50385 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 50388 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 50393 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 50398 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 50403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 50406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 50410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50415 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 50418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 50420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 50423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 50428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 50433 */     // GIR_Coverage, 22105,
     /* 50433 */     GIR_EraseRootFromParent_Done,
     /* 50434 */   // Label 1478: @50434
     /* 50434 */   GIM_Reject,
     /* 50435 */ // Label 1476: @50435
     /* 50435 */ GIM_Reject,
     /* 50436 */ // Label 1470: @50436
     /* 50436 */ GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(50486), // Rule ID 12600 //
     /* 50441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 50444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 50447 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 50450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 50454 */   // MIs[0] Operand 1
     /* 50454 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 50459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 50463 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 50469 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 50471 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 50475 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50477 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i32] }, VR128X:{ *:[v4i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZ128kr:{ *:[v4i1] } VR128X:{ *:[v4i32] }:$src)
     /* 50477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZ128kr),
     /* 50480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50482 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 50484 */   GIR_RootConstrainSelectedInstOperands,
     /* 50485 */   // GIR_Coverage, 12600,
     /* 50485 */   GIR_EraseRootFromParent_Done,
     /* 50486 */ // Label 1479: @50486
     /* 50486 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(50536), // Rule ID 12602 //
     /* 50491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 50494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 50497 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 50500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 50504 */   // MIs[0] Operand 1
     /* 50504 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 50509 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 50513 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 50519 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 50521 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 50525 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50527 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i64] }, VR256X:{ *:[v4i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZ256kr:{ *:[v4i1] } VR256X:{ *:[v4i64] }:$src)
     /* 50527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZ256kr),
     /* 50530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50532 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 50534 */   GIR_RootConstrainSelectedInstOperands,
     /* 50535 */   // GIR_Coverage, 12602,
     /* 50535 */   GIR_EraseRootFromParent_Done,
     /* 50536 */ // Label 1480: @50536
     /* 50536 */ GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(50659), // Rule ID 22103 //
     /* 50541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 50544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 50547 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 50550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 50554 */   // MIs[0] Operand 1
     /* 50554 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 50559 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 50563 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 50569 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 50571 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 50575 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50577 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i32] }, VR128X:{ *:[v4i32] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (VPMOVD2MZkr:{ *:[v16i1] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] })), VK4:{ *:[i32] })
     /* 50577 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 50580 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 50584 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 50591 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 50594 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 50598 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50603 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 50606 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 50610 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 50613 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 50618 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 50623 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 50628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 50631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 50635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50640 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 50643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 50645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 50648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50650 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 50653 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 50658 */   // GIR_Coverage, 22103,
     /* 50658 */   GIR_EraseRootFromParent_Done,
     /* 50659 */ // Label 1481: @50659
     /* 50659 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(50782), // Rule ID 22104 //
     /* 50664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 50667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 50670 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 50673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 50677 */   // MIs[0] Operand 1
     /* 50677 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 50682 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 50686 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 50692 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 50694 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 50698 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50700 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i64] }, VR256X:{ *:[v4i64] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (VPMOVQ2MZkr:{ *:[v8i1] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), VK4:{ *:[i32] })
     /* 50700 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 50703 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 50707 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50712 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 50714 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 50717 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 50721 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50726 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 50729 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 50733 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 50736 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 50741 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 50746 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 50751 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 50754 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 50758 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50763 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 50766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 50768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 50771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 50776 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 50781 */   // GIR_Coverage, 22104,
     /* 50781 */   GIR_EraseRootFromParent_Done,
     /* 50782 */ // Label 1482: @50782
     /* 50782 */ GIM_Reject,
     /* 50783 */ // Label 1471: @50783
     /* 50783 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(50833), // Rule ID 12597 //
     /* 50788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 50791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 50794 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 50797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 50801 */   // MIs[0] Operand 1
     /* 50801 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 50806 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 50810 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 50816 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 50818 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 50822 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50824 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i16] }, VR128X:{ *:[v8i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZ128kr:{ *:[v8i1] } VR128X:{ *:[v8i16] }:$src)
     /* 50824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZ128kr),
     /* 50827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50829 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 50831 */   GIR_RootConstrainSelectedInstOperands,
     /* 50832 */   // GIR_Coverage, 12597,
     /* 50832 */   GIR_EraseRootFromParent_Done,
     /* 50833 */ // Label 1483: @50833
     /* 50833 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(50883), // Rule ID 12599 //
     /* 50838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 50841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 50844 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 50847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 50851 */   // MIs[0] Operand 1
     /* 50851 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 50856 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 50860 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 50866 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 50868 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 50872 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50874 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i32] }, VR256X:{ *:[v8i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZ256kr:{ *:[v8i1] } VR256X:{ *:[v8i32] }:$src)
     /* 50874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZ256kr),
     /* 50877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50879 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 50881 */   GIR_RootConstrainSelectedInstOperands,
     /* 50882 */   // GIR_Coverage, 12599,
     /* 50882 */   GIR_EraseRootFromParent_Done,
     /* 50883 */ // Label 1484: @50883
     /* 50883 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(50933), // Rule ID 12601 //
     /* 50888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 50891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 50894 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 50897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 50901 */   // MIs[0] Operand 1
     /* 50901 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 50906 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 50910 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 50916 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 50918 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 50922 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50924 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZkr:{ *:[v8i1] } VR512:{ *:[v8i64] }:$src)
     /* 50924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 50927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50929 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 50931 */   GIR_RootConstrainSelectedInstOperands,
     /* 50932 */   // GIR_Coverage, 12601,
     /* 50932 */   GIR_EraseRootFromParent_Done,
     /* 50933 */ // Label 1485: @50933
     /* 50933 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(51056), // Rule ID 22101 //
     /* 50938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 50941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 50944 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 50947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 50951 */   // MIs[0] Operand 1
     /* 50951 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 50956 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 50960 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 50966 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 50968 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 50972 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50974 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i16] }, VR128X:{ *:[v8i16] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (VPMOVW2MZkr:{ *:[v32i1] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] })), VK8:{ *:[i32] })
     /* 50974 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 50977 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 50981 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 50988 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 50991 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 50995 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51000 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 51003 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 51007 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 51010 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 51015 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 51020 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 51025 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s1,
     /* 51028 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 51032 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51037 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 51040 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 51045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51050 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 51055 */   // GIR_Coverage, 22101,
     /* 51055 */   GIR_EraseRootFromParent_Done,
     /* 51056 */ // Label 1486: @51056
     /* 51056 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(51179), // Rule ID 22102 //
     /* 51061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 51064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 51067 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 51070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 51074 */   // MIs[0] Operand 1
     /* 51074 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51079 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51083 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51089 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51091 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 51095 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51097 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i32] }, VR256X:{ *:[v8i32] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (VPMOVD2MZkr:{ *:[v16i1] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] })), VK8:{ *:[i32] })
     /* 51097 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 51100 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 51104 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 51111 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 51114 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 51118 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51123 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 51126 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 51130 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 51133 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 51138 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 51143 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 51148 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 51151 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 51155 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51160 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 51163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 51168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51170 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 51178 */   // GIR_Coverage, 22102,
     /* 51178 */   GIR_EraseRootFromParent_Done,
     /* 51179 */ // Label 1487: @51179
     /* 51179 */ GIM_Reject,
     /* 51180 */ // Label 1472: @51180
     /* 51180 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(51230), // Rule ID 12594 //
     /* 51185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 51188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 51191 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 51194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 51198 */   // MIs[0] Operand 1
     /* 51198 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51203 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51207 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51213 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51215 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 51219 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51221 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i8] }, VR128X:{ *:[v16i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZ128kr:{ *:[v16i1] } VR128X:{ *:[v16i8] }:$src)
     /* 51221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZ128kr),
     /* 51224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51226 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 51228 */   GIR_RootConstrainSelectedInstOperands,
     /* 51229 */   // GIR_Coverage, 12594,
     /* 51229 */   GIR_EraseRootFromParent_Done,
     /* 51230 */ // Label 1488: @51230
     /* 51230 */ GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(51280), // Rule ID 12596 //
     /* 51235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 51238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 51241 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 51244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 51248 */   // MIs[0] Operand 1
     /* 51248 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51253 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51257 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51263 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51265 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 51269 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51271 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i16] }, VR256X:{ *:[v16i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZ256kr:{ *:[v16i1] } VR256X:{ *:[v16i16] }:$src)
     /* 51271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZ256kr),
     /* 51274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51276 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 51278 */   GIR_RootConstrainSelectedInstOperands,
     /* 51279 */   // GIR_Coverage, 12596,
     /* 51279 */   GIR_EraseRootFromParent_Done,
     /* 51280 */ // Label 1489: @51280
     /* 51280 */ GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(51330), // Rule ID 12598 //
     /* 51285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 51288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 51291 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 51294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 51298 */   // MIs[0] Operand 1
     /* 51298 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51303 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51307 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51313 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51315 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 51319 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51321 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZkr:{ *:[v16i1] } VR512:{ *:[v16i32] }:$src)
     /* 51321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 51324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51326 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 51328 */   GIR_RootConstrainSelectedInstOperands,
     /* 51329 */   // GIR_Coverage, 12598,
     /* 51329 */   GIR_EraseRootFromParent_Done,
     /* 51330 */ // Label 1490: @51330
     /* 51330 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(51453), // Rule ID 22099 //
     /* 51335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 51338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 51341 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 51344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 51348 */   // MIs[0] Operand 1
     /* 51348 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51353 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51357 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51363 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51365 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 51369 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51371 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i8] }, VR128X:{ *:[v16i8] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (VPMOVB2MZkr:{ *:[v64i1] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] })), VK16:{ *:[i32] })
     /* 51371 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 51374 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 51378 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 51385 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 51388 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 51392 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51397 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 51400 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 51404 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 51407 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 51412 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 51417 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 51422 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s1,
     /* 51425 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 51429 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51434 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 51437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 51442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51447 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 51452 */   // GIR_Coverage, 22099,
     /* 51452 */   GIR_EraseRootFromParent_Done,
     /* 51453 */ // Label 1491: @51453
     /* 51453 */ GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(51576), // Rule ID 22100 //
     /* 51458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 51461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 51464 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 51467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 51471 */   // MIs[0] Operand 1
     /* 51471 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51476 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51480 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51486 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51488 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 51492 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51494 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i16] }, VR256X:{ *:[v16i16] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (VPMOVW2MZkr:{ *:[v32i1] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] })), VK16:{ *:[i32] })
     /* 51494 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 51497 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 51501 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 51508 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 51511 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 51515 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51520 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 51523 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 51527 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 51530 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 51535 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 51540 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 51545 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s1,
     /* 51548 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 51552 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51557 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 51560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 51565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51567 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51570 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 51575 */   // GIR_Coverage, 22100,
     /* 51575 */   GIR_EraseRootFromParent_Done,
     /* 51576 */ // Label 1492: @51576
     /* 51576 */ GIM_Reject,
     /* 51577 */ // Label 1473: @51577
     /* 51577 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(51627), // Rule ID 12593 //
     /* 51582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 51585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 51588 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 51591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 51595 */   // MIs[0] Operand 1
     /* 51595 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51600 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51604 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51610 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51612 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 51616 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51618 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i8] }, VR256X:{ *:[v32i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZ256kr:{ *:[v32i1] } VR256X:{ *:[v32i8] }:$src)
     /* 51618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZ256kr),
     /* 51621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51623 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 51625 */   GIR_RootConstrainSelectedInstOperands,
     /* 51626 */   // GIR_Coverage, 12593,
     /* 51626 */   GIR_EraseRootFromParent_Done,
     /* 51627 */ // Label 1493: @51627
     /* 51627 */ GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(51677), // Rule ID 12595 //
     /* 51632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 51635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 51638 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 51641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 51645 */   // MIs[0] Operand 1
     /* 51645 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51650 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51654 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51660 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51662 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 51666 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51668 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i16] }, VR512:{ *:[v32i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZkr:{ *:[v32i1] } VR512:{ *:[v32i16] }:$src)
     /* 51668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 51671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51673 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 51675 */   GIR_RootConstrainSelectedInstOperands,
     /* 51676 */   // GIR_Coverage, 12595,
     /* 51676 */   GIR_EraseRootFromParent_Done,
     /* 51677 */ // Label 1494: @51677
     /* 51677 */ GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(51800), // Rule ID 22098 //
     /* 51682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 51685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 51688 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 51691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 51695 */   // MIs[0] Operand 1
     /* 51695 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51700 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51704 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51710 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51712 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 51716 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51718 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i8] }, VR256X:{ *:[v32i8] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } (VPMOVB2MZkr:{ *:[v64i1] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] })), VK32:{ *:[i32] })
     /* 51718 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 51721 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 51725 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 51732 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 51735 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 51739 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51744 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 51747 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 51751 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 51754 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 51759 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 51764 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 51769 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s1,
     /* 51772 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 51776 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51781 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 51784 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 51789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51791 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51794 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 51799 */   // GIR_Coverage, 22098,
     /* 51799 */   GIR_EraseRootFromParent_Done,
     /* 51800 */ // Label 1495: @51800
     /* 51800 */ GIM_Reject,
     /* 51801 */ // Label 1474: @51801
     /* 51801 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(51851), // Rule ID 12592 //
     /* 51806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 51809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 51812 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 51815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 51819 */   // MIs[0] Operand 1
     /* 51819 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51824 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51828 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51834 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51836 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 51840 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51842 */   // (setcc:{ *:[v64i1] } immAllZerosV:{ *:[v64i8] }, VR512:{ *:[v64i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZkr:{ *:[v64i1] } VR512:{ *:[v64i8] }:$src)
     /* 51842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 51845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51847 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 51849 */   GIR_RootConstrainSelectedInstOperands,
     /* 51850 */   // GIR_Coverage, 12592,
     /* 51850 */   GIR_EraseRootFromParent_Done,
     /* 51851 */ // Label 1496: @51851
     /* 51851 */ GIM_Reject,
     /* 51852 */ // Label 1475: @51852
     /* 51852 */ GIM_Reject,
     /* 51853 */ // Label 27: @51853
     /* 51853 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 1509*/ GIMT_Encode4(58660),
     /* 51864 */ /*GILLT_v2s64*//*Label 1497*/ GIMT_Encode4(51932), GIMT_Encode4(0),
     /* 51872 */ /*GILLT_v4s32*//*Label 1498*/ GIMT_Encode4(52796),
     /* 51876 */ /*GILLT_v4s64*//*Label 1499*/ GIMT_Encode4(53660), GIMT_Encode4(0),
     /* 51884 */ /*GILLT_v8s16*//*Label 1500*/ GIMT_Encode4(54440),
     /* 51888 */ /*GILLT_v8s32*//*Label 1501*/ GIMT_Encode4(55304),
     /* 51892 */ /*GILLT_v8s64*//*Label 1502*/ GIMT_Encode4(56084), GIMT_Encode4(0),
     /* 51900 */ /*GILLT_v16s8*//*Label 1503*/ GIMT_Encode4(56465),
     /* 51904 */ /*GILLT_v16s16*//*Label 1504*/ GIMT_Encode4(56905),
     /* 51908 */ /*GILLT_v16s32*//*Label 1505*/ GIMT_Encode4(57685), GIMT_Encode4(0),
     /* 51916 */ /*GILLT_v32s8*//*Label 1506*/ GIMT_Encode4(58026),
     /* 51920 */ /*GILLT_v32s16*//*Label 1507*/ GIMT_Encode4(58430), GIMT_Encode4(0),
     /* 51928 */ /*GILLT_v64s8*//*Label 1508*/ GIMT_Encode4(58574),
     /* 51932 */ // Label 1497: @51932
     /* 51932 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(52795),
     /* 51937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 51940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 51943 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 51946 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(51991), // Rule ID 4486 //
     /* 51951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 51954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 51958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 51962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 51966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 51970 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51976 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51980 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src, immAllZerosV:{ *:[v2f64] })  =>  (VMOVAPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 51980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rrkz),
     /* 51983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51985 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 51987 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 51989 */     GIR_RootConstrainSelectedInstOperands,
     /* 51990 */     // GIR_Coverage, 4486,
     /* 51990 */     GIR_EraseRootFromParent_Done,
     /* 51991 */   // Label 1511: @51991
     /* 51991 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(52036), // Rule ID 4540 //
     /* 51996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 51999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 52007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 52015 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 52021 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 52023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52025 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src, immAllZerosV:{ *:[v2i64] })  =>  (VMOVDQA64Z128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 52025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rrkz),
     /* 52028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52030 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 52032 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 52034 */     GIR_RootConstrainSelectedInstOperands,
     /* 52035 */     // GIR_Coverage, 4540,
     /* 52035 */     GIR_EraseRootFromParent_Done,
     /* 52036 */   // Label 1512: @52036
     /* 52036 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(52185), // Rule ID 20224 //
     /* 52041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 52044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 52048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 52052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 52060 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 52066 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 52068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52070 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, immAllZerosV:{ *:[v2f64] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } (VMOVAPDZrrkz:{ *:[v8f64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 52070 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 52073 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 52077 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 52084 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 52087 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 52091 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52096 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 52099 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 52103 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 52106 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 52111 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52116 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 52121 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 52124 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 52128 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52133 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 52137 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 52142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 52145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 52149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52154 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 52157 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 52160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 52165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52167 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 52174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 52179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52184 */     // GIR_Coverage, 20224,
     /* 52184 */     GIR_EraseRootFromParent_Done,
     /* 52185 */   // Label 1513: @52185
     /* 52185 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(52334), // Rule ID 20226 //
     /* 52190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 52193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 52197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 52201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 52209 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 52215 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 52217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52219 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, immAllZerosV:{ *:[v2i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 52219 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 52222 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 52226 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 52233 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 52236 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 52240 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52245 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 52248 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 52252 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 52255 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 52260 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52265 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 52270 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 52273 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 52277 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52282 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 52286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 52291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 52294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 52298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52303 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 52306 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 52309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 52314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52316 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 52323 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 52328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52333 */     // GIR_Coverage, 20226,
     /* 52333 */     GIR_EraseRootFromParent_Done,
     /* 52334 */   // Label 1514: @52334
     /* 52334 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(52371), // Rule ID 4488 //
     /* 52339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 52342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 52350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52358 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src0)  =>  (VMOVAPDZ128rrk:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src0, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1)
     /* 52358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rrk),
     /* 52361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52363 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 52365 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 52367 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 52369 */     GIR_RootConstrainSelectedInstOperands,
     /* 52370 */     // GIR_Coverage, 4488,
     /* 52370 */     GIR_EraseRootFromParent_Done,
     /* 52371 */   // Label 1515: @52371
     /* 52371 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(52408), // Rule ID 4542 //
     /* 52376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 52379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 52387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52395 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src0)  =>  (VMOVDQA64Z128rrk:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src0, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1)
     /* 52395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rrk),
     /* 52398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52400 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 52402 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 52404 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 52406 */     GIR_RootConstrainSelectedInstOperands,
     /* 52407 */     // GIR_Coverage, 4542,
     /* 52407 */     GIR_EraseRootFromParent_Done,
     /* 52408 */   // Label 1516: @52408
     /* 52408 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(52601), // Rule ID 20223 //
     /* 52413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 52416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 52420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 52424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52432 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v2f64] } (VMOVAPDZrrk:{ *:[v8f64] } (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 52432 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 52435 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 52439 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 52446 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 52449 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 52453 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52458 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 52461 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 52465 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 52468 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 52473 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52478 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 52483 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 52486 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 52490 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52495 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 52499 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 52504 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 52507 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 52511 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 52518 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 52521 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 52525 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52530 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 52533 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 52537 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 52540 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 52545 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52550 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 52555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 52558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 52562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52567 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 52570 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 52573 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 52576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 52581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52583 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 52590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 52595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52600 */     // GIR_Coverage, 20223,
     /* 52600 */     GIR_EraseRootFromParent_Done,
     /* 52601 */   // Label 1517: @52601
     /* 52601 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(52794), // Rule ID 20225 //
     /* 52606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 52609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 52613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 52617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52625 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VMOVDQA64Zrrk:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 52625 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 52628 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 52632 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 52639 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 52642 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 52646 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52651 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 52654 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 52658 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 52661 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 52666 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52671 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 52676 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 52679 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 52683 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52688 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 52692 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 52697 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 52700 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 52704 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 52711 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 52714 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 52718 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52723 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 52726 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 52730 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 52733 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 52738 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52743 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 52748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 52751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 52755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52760 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 52763 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 52766 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 52769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 52774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52776 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 52783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 52788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52793 */     // GIR_Coverage, 20225,
     /* 52793 */     GIR_EraseRootFromParent_Done,
     /* 52794 */   // Label 1518: @52794
     /* 52794 */   GIM_Reject,
     /* 52795 */ // Label 1510: @52795
     /* 52795 */ GIM_Reject,
     /* 52796 */ // Label 1498: @52796
     /* 52796 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(53659),
     /* 52801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 52804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 52807 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 52810 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(52855), // Rule ID 4468 //
     /* 52815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 52818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 52826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 52834 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 52840 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 52842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52844 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src, immAllZerosV:{ *:[v4f32] })  =>  (VMOVAPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 52844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rrkz),
     /* 52847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52849 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 52851 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 52853 */     GIR_RootConstrainSelectedInstOperands,
     /* 52854 */     // GIR_Coverage, 4468,
     /* 52854 */     GIR_EraseRootFromParent_Done,
     /* 52855 */   // Label 1520: @52855
     /* 52855 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(52900), // Rule ID 4526 //
     /* 52860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 52863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 52871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 52879 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 52885 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 52887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52889 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src, immAllZerosV:{ *:[v4i32] })  =>  (VMOVDQA32Z128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 52889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z128rrkz),
     /* 52892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52894 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 52896 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 52898 */     GIR_RootConstrainSelectedInstOperands,
     /* 52899 */     // GIR_Coverage, 4526,
     /* 52899 */     GIR_EraseRootFromParent_Done,
     /* 52900 */   // Label 1521: @52900
     /* 52900 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(53049), // Rule ID 20216 //
     /* 52905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 52908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 52912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 52916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 52924 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 52930 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 52932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52934 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, immAllZerosV:{ *:[v4f32] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } (VMOVAPSZrrkz:{ *:[v16f32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 52934 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 52937 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 52941 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 52948 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 52951 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 52955 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52960 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 52963 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 52967 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 52970 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 52975 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52980 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 52985 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 52988 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 52992 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52997 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 53001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 53006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 53009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 53013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53018 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 53021 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 53024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53031 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 53038 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 53043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53048 */     // GIR_Coverage, 20216,
     /* 53048 */     GIR_EraseRootFromParent_Done,
     /* 53049 */   // Label 1522: @53049
     /* 53049 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(53198), // Rule ID 20218 //
     /* 53054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 53057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 53061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 53065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 53073 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 53079 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 53081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53083 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, immAllZerosV:{ *:[v4i32] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VMOVDQA32Zrrkz:{ *:[v16i32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 53083 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 53086 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 53090 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 53097 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 53100 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 53104 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53109 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 53112 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 53116 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 53119 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 53124 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53129 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 53134 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 53137 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53141 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53146 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 53150 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 53155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 53158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 53162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53167 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 53170 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 53173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53180 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 53187 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 53192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53197 */     // GIR_Coverage, 20218,
     /* 53197 */     GIR_EraseRootFromParent_Done,
     /* 53198 */   // Label 1523: @53198
     /* 53198 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(53235), // Rule ID 4470 //
     /* 53203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 53206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 53214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53222 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src0)  =>  (VMOVAPSZ128rrk:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1)
     /* 53222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rrk),
     /* 53225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53227 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 53229 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 53231 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 53233 */     GIR_RootConstrainSelectedInstOperands,
     /* 53234 */     // GIR_Coverage, 4470,
     /* 53234 */     GIR_EraseRootFromParent_Done,
     /* 53235 */   // Label 1524: @53235
     /* 53235 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(53272), // Rule ID 4527 //
     /* 53240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 53243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 53251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53259 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src0)  =>  (VMOVDQA32Z128rrk:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1)
     /* 53259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z128rrk),
     /* 53262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53264 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 53266 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 53268 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 53270 */     GIR_RootConstrainSelectedInstOperands,
     /* 53271 */     // GIR_Coverage, 4527,
     /* 53271 */     GIR_EraseRootFromParent_Done,
     /* 53272 */   // Label 1525: @53272
     /* 53272 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(53465), // Rule ID 20215 //
     /* 53277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 53280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 53284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 53288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53296 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4f32] } (VMOVAPSZrrk:{ *:[v16f32] } (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 53296 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 53299 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 53303 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 53310 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 53313 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 53317 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53322 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 53325 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 53329 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 53332 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 53337 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53342 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 53347 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 53350 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53354 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53359 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 53363 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 53368 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 53371 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 53375 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 53382 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 53385 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 53389 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53394 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 53397 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 53401 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 53404 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 53409 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53414 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 53419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 53422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 53426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53431 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 53434 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 53437 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 53440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53447 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 53454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 53459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53464 */     // GIR_Coverage, 20215,
     /* 53464 */     GIR_EraseRootFromParent_Done,
     /* 53465 */   // Label 1526: @53465
     /* 53465 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(53658), // Rule ID 20217 //
     /* 53470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 53473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 53477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 53481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53489 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VMOVDQA32Zrrk:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 53489 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 53492 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 53496 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 53503 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 53506 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 53510 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53515 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 53518 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 53522 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 53525 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 53530 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53535 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 53540 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 53543 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53547 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53552 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 53556 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 53561 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 53564 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 53568 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 53575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 53578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 53582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53587 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 53590 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 53594 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 53597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 53602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 53612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 53615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 53619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53624 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 53627 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 53630 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 53633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53640 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 53647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 53652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53657 */     // GIR_Coverage, 20217,
     /* 53657 */     GIR_EraseRootFromParent_Done,
     /* 53658 */   // Label 1527: @53658
     /* 53658 */   GIM_Reject,
     /* 53659 */ // Label 1519: @53659
     /* 53659 */ GIM_Reject,
     /* 53660 */ // Label 1499: @53660
     /* 53660 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(54439),
     /* 53665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 53668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 53671 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 53674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 53678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 53682 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 53686 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(53719), // Rule ID 4481 //
     /* 53691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 53694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 53698 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 53704 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 53706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53708 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src, immAllZerosV:{ *:[v4f64] })  =>  (VMOVAPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 53708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rrkz),
     /* 53711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53713 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 53715 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 53717 */     GIR_RootConstrainSelectedInstOperands,
     /* 53718 */     // GIR_Coverage, 4481,
     /* 53718 */     GIR_EraseRootFromParent_Done,
     /* 53719 */   // Label 1529: @53719
     /* 53719 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(53752), // Rule ID 4535 //
     /* 53724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 53727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 53731 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 53737 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 53739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53741 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src, immAllZerosV:{ *:[v4i64] })  =>  (VMOVDQA64Z256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 53741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rrkz),
     /* 53744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53746 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 53748 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 53750 */     GIR_RootConstrainSelectedInstOperands,
     /* 53751 */     // GIR_Coverage, 4535,
     /* 53751 */     GIR_EraseRootFromParent_Done,
     /* 53752 */   // Label 1530: @53752
     /* 53752 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(53889), // Rule ID 20228 //
     /* 53757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 53760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 53764 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 53770 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 53772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53774 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, immAllZerosV:{ *:[v4f64] })  =>  (EXTRACT_SUBREG:{ *:[v4f64] } (VMOVAPDZrrkz:{ *:[v8f64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 53774 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 53777 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 53781 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 53788 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 53791 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 53795 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53800 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 53803 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 53807 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 53810 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 53815 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53820 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 53825 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 53828 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53832 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53837 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 53841 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 53846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 53849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 53853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53858 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 53861 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 53864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53871 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 53878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 53883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53888 */     // GIR_Coverage, 20228,
     /* 53888 */     GIR_EraseRootFromParent_Done,
     /* 53889 */   // Label 1531: @53889
     /* 53889 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(54026), // Rule ID 20230 //
     /* 53894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 53897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 53901 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 53907 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 53909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53911 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, immAllZerosV:{ *:[v4i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 53911 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 53914 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 53918 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 53925 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 53928 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 53932 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53937 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 53940 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 53944 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 53947 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 53952 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53957 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 53962 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 53965 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53969 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53974 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 53978 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 53983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 53986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 53990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53995 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 53998 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 54001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54008 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 54015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54025 */     // GIR_Coverage, 20230,
     /* 54025 */     GIR_EraseRootFromParent_Done,
     /* 54026 */   // Label 1532: @54026
     /* 54026 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(54051), // Rule ID 4483 //
     /* 54031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 54034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 54038 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src0)  =>  (VMOVAPDZ256rrk:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1)
     /* 54038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rrk),
     /* 54041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54043 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 54045 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 54047 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 54049 */     GIR_RootConstrainSelectedInstOperands,
     /* 54050 */     // GIR_Coverage, 4483,
     /* 54050 */     GIR_EraseRootFromParent_Done,
     /* 54051 */   // Label 1533: @54051
     /* 54051 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(54076), // Rule ID 4537 //
     /* 54056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 54059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 54063 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src0)  =>  (VMOVDQA64Z256rrk:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1)
     /* 54063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rrk),
     /* 54066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54068 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 54070 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 54072 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 54074 */     GIR_RootConstrainSelectedInstOperands,
     /* 54075 */     // GIR_Coverage, 4537,
     /* 54075 */     GIR_EraseRootFromParent_Done,
     /* 54076 */   // Label 1534: @54076
     /* 54076 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(54257), // Rule ID 20227 //
     /* 54081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 54084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 54088 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4f64] } (VMOVAPDZrrk:{ *:[v8f64] } (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 54088 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 54091 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 54095 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 54102 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 54105 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 54109 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54114 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 54117 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 54121 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 54124 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 54129 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54134 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54139 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 54142 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54146 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54151 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 54155 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 54160 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 54163 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 54167 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 54174 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 54177 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 54181 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54186 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 54189 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 54193 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 54196 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 54201 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54206 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 54214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 54218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54223 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 54226 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 54229 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 54232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54239 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 54246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54256 */     // GIR_Coverage, 20227,
     /* 54256 */     GIR_EraseRootFromParent_Done,
     /* 54257 */   // Label 1535: @54257
     /* 54257 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(54438), // Rule ID 20229 //
     /* 54262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 54265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 54269 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VMOVDQA64Zrrk:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 54269 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 54272 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 54276 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 54283 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 54286 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 54290 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54295 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 54298 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 54302 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 54305 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 54310 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54315 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54320 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 54323 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54327 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54332 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 54336 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 54341 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 54344 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 54348 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 54355 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 54358 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 54362 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54367 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 54370 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 54374 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 54377 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 54382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 54395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 54399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54404 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 54407 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 54410 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 54413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54420 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 54427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54437 */     // GIR_Coverage, 20229,
     /* 54437 */     GIR_EraseRootFromParent_Done,
     /* 54438 */   // Label 1536: @54438
     /* 54438 */   GIM_Reject,
     /* 54439 */ // Label 1528: @54439
     /* 54439 */ GIM_Reject,
     /* 54440 */ // Label 1500: @54440
     /* 54440 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(55303),
     /* 54445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 54448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 54451 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 54454 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(54499), // Rule ID 4568 //
     /* 54459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 54462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 54466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 54470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 54474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 54478 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 54484 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 54486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54488 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src, immAllZerosV:{ *:[v8i16] })  =>  (VMOVDQU16Z128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 54488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrkz),
     /* 54491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54493 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 54495 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 54497 */     GIR_RootConstrainSelectedInstOperands,
     /* 54498 */     // GIR_Coverage, 4568,
     /* 54498 */     GIR_EraseRootFromParent_Done,
     /* 54499 */   // Label 1538: @54499
     /* 54499 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(54648), // Rule ID 20236 //
     /* 54504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 54507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 54511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 54515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 54519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 54523 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 54529 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 54531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54533 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, immAllZerosV:{ *:[v8i16] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VMOVDQU16Zrrkz:{ *:[v32i16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 54533 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 54536 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 54540 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 54547 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 54550 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 54554 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54559 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 54562 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 54566 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 54569 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 54574 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54579 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 54584 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 54587 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54591 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54596 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 54600 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 54605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 54608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 54612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54617 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 54620 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 54623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54630 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 54637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 54642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54647 */     // GIR_Coverage, 20236,
     /* 54647 */     GIR_EraseRootFromParent_Done,
     /* 54648 */   // Label 1539: @54648
     /* 54648 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(54797), // Rule ID 20240 //
     /* 54653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 54656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 54660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 54664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 54668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 54672 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 54678 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 54680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54682 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, immAllZerosV:{ *:[v8f16] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } (VMOVDQU16Zrrkz:{ *:[v32f16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 54682 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 54685 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 54689 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 54696 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 54699 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 54703 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54708 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 54711 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 54715 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 54718 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 54723 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54728 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 54733 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 54736 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54740 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54745 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 54749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 54754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 54757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 54761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54766 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 54769 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 54772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54779 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 54786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 54791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54796 */     // GIR_Coverage, 20240,
     /* 54796 */     GIR_EraseRootFromParent_Done,
     /* 54797 */   // Label 1540: @54797
     /* 54797 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(54842), // Rule ID 20312 //
     /* 54802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 54805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 54809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 54813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 54817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 54821 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 54827 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 54829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54831 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rrkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1)
     /* 54831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrkz),
     /* 54834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54836 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 54838 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 54840 */     GIR_RootConstrainSelectedInstOperands,
     /* 54841 */     // GIR_Coverage, 20312,
     /* 54841 */     GIR_EraseRootFromParent_Done,
     /* 54842 */   // Label 1541: @54842
     /* 54842 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(54879), // Rule ID 4569 //
     /* 54847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 54850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 54854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 54858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 54862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 54866 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src0)  =>  (VMOVDQU16Z128rrk:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1)
     /* 54866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrk),
     /* 54869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54871 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 54873 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 54875 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 54877 */     GIR_RootConstrainSelectedInstOperands,
     /* 54878 */     // GIR_Coverage, 4569,
     /* 54878 */     GIR_EraseRootFromParent_Done,
     /* 54879 */   // Label 1542: @54879
     /* 54879 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(55072), // Rule ID 20235 //
     /* 54884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 54887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 54891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 54895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 54899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 54903 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VMOVDQU16Zrrk:{ *:[v32i16] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 54903 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 54906 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 54910 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 54917 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 54920 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 54924 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54929 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 54932 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 54936 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 54939 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 54944 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54949 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 54954 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 54957 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54961 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54966 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 54970 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 54975 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 54978 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 54982 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 54989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 54992 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 54996 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55001 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 55004 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 55008 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 55011 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 55016 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55021 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 55026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 55029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 55033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55038 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 55041 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 55044 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 55047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55054 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 55061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 55066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55071 */     // GIR_Coverage, 20235,
     /* 55071 */     GIR_EraseRootFromParent_Done,
     /* 55072 */   // Label 1543: @55072
     /* 55072 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(55265), // Rule ID 20239 //
     /* 55077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 55080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 55084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 55088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55096 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8f16] } (VMOVDQU16Zrrk:{ *:[v32f16] } (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 55096 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 55099 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 55103 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 55110 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 55113 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 55117 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55122 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 55125 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 55129 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 55132 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 55137 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55142 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 55147 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 55150 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55154 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55159 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 55163 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 55168 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 55171 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 55175 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 55182 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 55185 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 55189 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55194 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 55197 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 55201 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 55204 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 55209 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 55219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 55222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 55226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55231 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 55234 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 55237 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 55240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55247 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 55254 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 55259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55264 */     // GIR_Coverage, 20239,
     /* 55264 */     GIR_EraseRootFromParent_Done,
     /* 55265 */   // Label 1544: @55265
     /* 55265 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(55302), // Rule ID 20311 //
     /* 55270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 55273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 55281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55289 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rrk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1)
     /* 55289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrk),
     /* 55292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55294 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 55296 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 55298 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 55300 */     GIR_RootConstrainSelectedInstOperands,
     /* 55301 */     // GIR_Coverage, 20311,
     /* 55301 */     GIR_EraseRootFromParent_Done,
     /* 55302 */   // Label 1545: @55302
     /* 55302 */   GIM_Reject,
     /* 55303 */ // Label 1537: @55303
     /* 55303 */ GIM_Reject,
     /* 55304 */ // Label 1501: @55304
     /* 55304 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(56083),
     /* 55309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 55312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 55315 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 55318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 55322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 55326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 55330 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(55363), // Rule ID 4463 //
     /* 55335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 55338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 55342 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 55348 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 55350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55352 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src, immAllZerosV:{ *:[v8f32] })  =>  (VMOVAPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 55352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rrkz),
     /* 55355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55357 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 55359 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 55361 */     GIR_RootConstrainSelectedInstOperands,
     /* 55362 */     // GIR_Coverage, 4463,
     /* 55362 */     GIR_EraseRootFromParent_Done,
     /* 55363 */   // Label 1547: @55363
     /* 55363 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(55396), // Rule ID 4522 //
     /* 55368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 55371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 55375 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 55381 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 55383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55385 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src, immAllZerosV:{ *:[v8i32] })  =>  (VMOVDQA32Z256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 55385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z256rrkz),
     /* 55388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55390 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 55392 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 55394 */     GIR_RootConstrainSelectedInstOperands,
     /* 55395 */     // GIR_Coverage, 4522,
     /* 55395 */     GIR_EraseRootFromParent_Done,
     /* 55396 */   // Label 1548: @55396
     /* 55396 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(55533), // Rule ID 20220 //
     /* 55401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 55404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 55408 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 55414 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 55416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55418 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, immAllZerosV:{ *:[v8f32] })  =>  (EXTRACT_SUBREG:{ *:[v8f32] } (VMOVAPSZrrkz:{ *:[v16f32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 55418 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 55421 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 55425 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 55432 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 55435 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 55439 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55444 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 55447 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 55451 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 55454 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 55459 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55464 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 55469 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 55472 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55476 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55481 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 55485 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 55490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 55493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 55497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55502 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 55505 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 55508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55515 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 55522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 55527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55532 */     // GIR_Coverage, 20220,
     /* 55532 */     GIR_EraseRootFromParent_Done,
     /* 55533 */   // Label 1549: @55533
     /* 55533 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(55670), // Rule ID 20222 //
     /* 55538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 55541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 55545 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 55551 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 55553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55555 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, immAllZerosV:{ *:[v8i32] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VMOVDQA32Zrrkz:{ *:[v16i32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 55555 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 55558 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 55562 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 55569 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 55572 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 55576 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55581 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 55584 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 55588 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 55591 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 55596 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55601 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 55606 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 55609 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55613 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55618 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 55622 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 55627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 55630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 55634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55639 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 55642 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 55645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55652 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 55659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 55664 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55669 */     // GIR_Coverage, 20222,
     /* 55669 */     GIR_EraseRootFromParent_Done,
     /* 55670 */   // Label 1550: @55670
     /* 55670 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(55695), // Rule ID 4465 //
     /* 55675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 55678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 55682 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src0)  =>  (VMOVAPSZ256rrk:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1)
     /* 55682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rrk),
     /* 55685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55687 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 55689 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 55691 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 55693 */     GIR_RootConstrainSelectedInstOperands,
     /* 55694 */     // GIR_Coverage, 4465,
     /* 55694 */     GIR_EraseRootFromParent_Done,
     /* 55695 */   // Label 1551: @55695
     /* 55695 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(55720), // Rule ID 4523 //
     /* 55700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 55703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 55707 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src0)  =>  (VMOVDQA32Z256rrk:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1)
     /* 55707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z256rrk),
     /* 55710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55712 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 55714 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 55716 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 55718 */     GIR_RootConstrainSelectedInstOperands,
     /* 55719 */     // GIR_Coverage, 4523,
     /* 55719 */     GIR_EraseRootFromParent_Done,
     /* 55720 */   // Label 1552: @55720
     /* 55720 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(55901), // Rule ID 20219 //
     /* 55725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 55728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 55732 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8f32] } (VMOVAPSZrrk:{ *:[v16f32] } (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 55732 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 55735 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 55739 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 55746 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 55749 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 55753 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55758 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 55761 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 55765 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 55768 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 55773 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55778 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 55783 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 55786 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55790 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55795 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 55799 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 55804 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 55807 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 55811 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 55818 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 55821 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 55825 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55830 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 55833 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 55837 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 55840 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 55845 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55850 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 55855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 55858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 55862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55867 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 55870 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 55873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 55876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55883 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 55890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 55895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55900 */     // GIR_Coverage, 20219,
     /* 55900 */     GIR_EraseRootFromParent_Done,
     /* 55901 */   // Label 1553: @55901
     /* 55901 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(56082), // Rule ID 20221 //
     /* 55906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 55909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 55913 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VMOVDQA32Zrrk:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 55913 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 55916 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 55920 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 55927 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 55930 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 55934 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55939 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 55942 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 55946 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 55949 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 55954 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55959 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 55964 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 55967 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55971 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55976 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 55980 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 55985 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 55988 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 55992 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 55999 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 56002 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 56006 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56011 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 56014 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 56018 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 56021 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 56026 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 56031 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 56036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 56039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 56043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56048 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 56051 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 56054 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 56057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 56059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 56062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56064 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 56071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 56076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 56081 */     // GIR_Coverage, 20221,
     /* 56081 */     GIR_EraseRootFromParent_Done,
     /* 56082 */   // Label 1554: @56082
     /* 56082 */   GIM_Reject,
     /* 56083 */ // Label 1546: @56083
     /* 56083 */ GIM_Reject,
     /* 56084 */ // Label 1502: @56084
     /* 56084 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(56464),
     /* 56089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 56092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 56095 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 56098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56102 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(56171), // Rule ID 20213 //
     /* 56107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 56115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 56119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 56123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 56128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 56132 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56138 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 56140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 56144 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56150 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /* 56152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 56158 */     // (vselect:{ *:[v8i64] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$mask, immAllOnesV:{ *:[v8i1] }), immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src)  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } VK8:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 56158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 56161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // mask
     /* 56167 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 56169 */     GIR_RootConstrainSelectedInstOperands,
     /* 56170 */     // GIR_Coverage, 20213,
     /* 56170 */     GIR_EraseRootFromParent_Done,
     /* 56171 */   // Label 1556: @56171
     /* 56171 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(56218), // Rule ID 3596 //
     /* 56176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 56179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 56183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 56187 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56193 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 56195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 56199 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56205 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 56207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 56209 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, immAllOnesV:{ *:[v8i64] }, immAllZerosV:{ *:[v8i64] })  =>  (AVX512_512_SEXT_MASK_64:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask)
     /* 56209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AVX512_512_SEXT_MASK_64),
     /* 56212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56214 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 56216 */     GIR_RootConstrainSelectedInstOperands,
     /* 56217 */     // GIR_Coverage, 3596,
     /* 56217 */     GIR_EraseRootFromParent_Done,
     /* 56218 */   // Label 1557: @56218
     /* 56218 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(56315), // Rule ID 20211 //
     /* 56223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 56227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 56231 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56237 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 56239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56245 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src)  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$mask, VK16:{ *:[i32] })), VK8:{ *:[i32] }), VR512:{ *:[v8i64] }:$src)
     /* 56245 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 56248 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 56252 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56257 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 56261 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 56266 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 56269 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 56273 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56278 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 56281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 56283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 56286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 56290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56295 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 56298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 56303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 56306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 56311 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 56313 */     GIR_RootConstrainSelectedInstOperands,
     /* 56314 */     // GIR_Coverage, 20211,
     /* 56314 */     GIR_EraseRootFromParent_Done,
     /* 56315 */   // Label 1558: @56315
     /* 56315 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(56356), // Rule ID 4476 //
     /* 56320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 56323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 56327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 56335 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56341 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 56343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56345 */     // (vselect:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src, immAllZerosV:{ *:[v8f64] })  =>  (VMOVAPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 56345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 56348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56350 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 56352 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 56354 */     GIR_RootConstrainSelectedInstOperands,
     /* 56355 */     // GIR_Coverage, 4476,
     /* 56355 */     GIR_EraseRootFromParent_Done,
     /* 56356 */   // Label 1559: @56356
     /* 56356 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(56397), // Rule ID 4530 //
     /* 56361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 56364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 56368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 56376 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56382 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 56384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56386 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src, immAllZerosV:{ *:[v8i64] })  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 56386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 56389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56391 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 56393 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 56395 */     GIR_RootConstrainSelectedInstOperands,
     /* 56396 */     // GIR_Coverage, 4530,
     /* 56396 */     GIR_EraseRootFromParent_Done,
     /* 56397 */   // Label 1560: @56397
     /* 56397 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(56430), // Rule ID 4478 //
     /* 56402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 56405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 56409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56417 */     // (vselect:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src0)  =>  (VMOVAPDZrrk:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src1)
     /* 56417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 56420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56422 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 56424 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 56426 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 56428 */     GIR_RootConstrainSelectedInstOperands,
     /* 56429 */     // GIR_Coverage, 4478,
     /* 56429 */     GIR_EraseRootFromParent_Done,
     /* 56430 */   // Label 1561: @56430
     /* 56430 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(56463), // Rule ID 4532 //
     /* 56435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 56438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 56442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56450 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src0)  =>  (VMOVDQA64Zrrk:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src1)
     /* 56450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 56453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56455 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 56457 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 56459 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 56461 */     GIR_RootConstrainSelectedInstOperands,
     /* 56462 */     // GIR_Coverage, 4532,
     /* 56462 */     GIR_EraseRootFromParent_Done,
     /* 56463 */   // Label 1562: @56463
     /* 56463 */   GIM_Reject,
     /* 56464 */ // Label 1555: @56464
     /* 56464 */ GIM_Reject,
     /* 56465 */ // Label 1503: @56465
     /* 56465 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(56904),
     /* 56470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 56473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 56476 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 56479 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(56524), // Rule ID 4556 //
     /* 56484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 56487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 56491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 56495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 56499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 56503 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56509 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 56511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56513 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src, immAllZerosV:{ *:[v16i8] })  =>  (VMOVDQU8Z128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 56513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z128rrkz),
     /* 56516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56518 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 56520 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 56522 */     GIR_RootConstrainSelectedInstOperands,
     /* 56523 */     // GIR_Coverage, 4556,
     /* 56523 */     GIR_EraseRootFromParent_Done,
     /* 56524 */   // Label 1564: @56524
     /* 56524 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(56673), // Rule ID 20232 //
     /* 56529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 56532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 56536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 56540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 56544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 56548 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56554 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 56556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56558 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, immAllZerosV:{ *:[v16i8] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VMOVDQU8Zrrkz:{ *:[v64i8] } (COPY_TO_REGCLASS:{ *:[v64i1] } VK16WM:{ *:[v16i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 56558 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s8,
     /* 56561 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 56565 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 56572 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 56575 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 56579 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56584 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 56587 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 56591 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 56594 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 56599 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 56604 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 56609 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s1,
     /* 56612 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 56616 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56621 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 56625 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 56630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 56633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 56637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56642 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 56645 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 56648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 56650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 56653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56655 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 56662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 56667 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 56672 */     // GIR_Coverage, 20232,
     /* 56672 */     GIR_EraseRootFromParent_Done,
     /* 56673 */   // Label 1565: @56673
     /* 56673 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(56710), // Rule ID 4557 //
     /* 56678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 56681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 56685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 56689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 56693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 56697 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src0)  =>  (VMOVDQU8Z128rrk:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1)
     /* 56697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z128rrk),
     /* 56700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56702 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 56704 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 56706 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 56708 */     GIR_RootConstrainSelectedInstOperands,
     /* 56709 */     // GIR_Coverage, 4557,
     /* 56709 */     GIR_EraseRootFromParent_Done,
     /* 56710 */   // Label 1566: @56710
     /* 56710 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(56903), // Rule ID 20231 //
     /* 56715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 56718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 56722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 56726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 56730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 56734 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VMOVDQU8Zrrk:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v64i1] } VK16WM:{ *:[v16i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 56734 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v64s8,
     /* 56737 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 56741 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 56748 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v64s8,
     /* 56751 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 56755 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56760 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 56763 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 56767 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 56770 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 56775 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 56780 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 56785 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s1,
     /* 56788 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 56792 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56797 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 56801 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 56806 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 56809 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 56813 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 56820 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 56823 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 56827 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56832 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 56835 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 56839 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 56842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 56847 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 56852 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 56857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 56860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 56864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56869 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 56872 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 56875 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 56878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 56880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 56883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56885 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 56892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 56897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 56902 */     // GIR_Coverage, 20231,
     /* 56902 */     GIR_EraseRootFromParent_Done,
     /* 56903 */   // Label 1567: @56903
     /* 56903 */   GIM_Reject,
     /* 56904 */ // Label 1563: @56904
     /* 56904 */ GIM_Reject,
     /* 56905 */ // Label 1504: @56905
     /* 56905 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(57684),
     /* 56910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 56913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 56916 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 56919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 56923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 56927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 56931 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(56964), // Rule ID 4564 //
     /* 56936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 56939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 56943 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56949 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 56951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56953 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src, immAllZerosV:{ *:[v16i16] })  =>  (VMOVDQU16Z256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 56953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrkz),
     /* 56956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56958 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 56960 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 56962 */     GIR_RootConstrainSelectedInstOperands,
     /* 56963 */     // GIR_Coverage, 4564,
     /* 56963 */     GIR_EraseRootFromParent_Done,
     /* 56964 */   // Label 1569: @56964
     /* 56964 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(57101), // Rule ID 20238 //
     /* 56969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 56972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 56976 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56982 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 56984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56986 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, immAllZerosV:{ *:[v16i16] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VMOVDQU16Zrrkz:{ *:[v32i16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 56986 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 56989 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 56993 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 57000 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 57003 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 57007 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57012 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 57015 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 57019 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 57022 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 57027 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57032 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57037 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 57040 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57044 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57049 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 57053 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 57058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 57061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 57065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57070 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 57073 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 57076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57083 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 57090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57100 */     // GIR_Coverage, 20238,
     /* 57100 */     GIR_EraseRootFromParent_Done,
     /* 57101 */   // Label 1570: @57101
     /* 57101 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(57238), // Rule ID 20242 //
     /* 57106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 57109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 57113 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 57119 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 57121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57123 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, immAllZerosV:{ *:[v16f16] })  =>  (EXTRACT_SUBREG:{ *:[v16f16] } (VMOVDQU16Zrrkz:{ *:[v32f16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 57123 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 57126 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 57130 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 57137 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 57140 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 57144 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57149 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 57152 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 57156 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 57159 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 57164 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57169 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57174 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 57177 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57181 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57186 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 57190 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 57195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 57198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 57202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57207 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 57210 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 57213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57220 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 57227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57237 */     // GIR_Coverage, 20242,
     /* 57237 */     GIR_EraseRootFromParent_Done,
     /* 57238 */   // Label 1571: @57238
     /* 57238 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(57271), // Rule ID 20302 //
     /* 57243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 57246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 57250 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 57256 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 57258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57260 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rrkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1)
     /* 57260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrkz),
     /* 57263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57265 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 57267 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 57269 */     GIR_RootConstrainSelectedInstOperands,
     /* 57270 */     // GIR_Coverage, 20302,
     /* 57270 */     GIR_EraseRootFromParent_Done,
     /* 57271 */   // Label 1572: @57271
     /* 57271 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(57296), // Rule ID 4565 //
     /* 57276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 57279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 57283 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src0)  =>  (VMOVDQU16Z256rrk:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1)
     /* 57283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrk),
     /* 57286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57288 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 57290 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 57292 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 57294 */     GIR_RootConstrainSelectedInstOperands,
     /* 57295 */     // GIR_Coverage, 4565,
     /* 57295 */     GIR_EraseRootFromParent_Done,
     /* 57296 */   // Label 1573: @57296
     /* 57296 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(57477), // Rule ID 20237 //
     /* 57301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 57304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 57308 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VMOVDQU16Zrrk:{ *:[v32i16] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 57308 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 57311 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 57315 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 57322 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 57325 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 57329 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57334 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 57337 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 57341 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 57344 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 57349 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57354 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57359 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 57362 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57366 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57371 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 57375 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 57380 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 57383 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 57387 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 57394 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 57397 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 57401 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57406 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 57409 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 57413 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 57416 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 57421 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57426 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 57434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 57438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57443 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 57446 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 57449 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 57452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57459 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 57466 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57476 */     // GIR_Coverage, 20237,
     /* 57476 */     GIR_EraseRootFromParent_Done,
     /* 57477 */   // Label 1574: @57477
     /* 57477 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(57658), // Rule ID 20241 //
     /* 57482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 57485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 57489 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16f16] } (VMOVDQU16Zrrk:{ *:[v32f16] } (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 57489 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 57492 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 57496 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 57503 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 57506 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 57510 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57515 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 57518 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 57522 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 57525 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 57530 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57535 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57540 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 57543 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57547 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57552 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 57556 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 57561 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 57564 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 57568 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 57575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 57578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 57582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57587 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 57590 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 57594 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 57597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 57602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 57615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 57619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57624 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 57627 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 57630 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 57633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57640 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 57647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57657 */     // GIR_Coverage, 20241,
     /* 57657 */     GIR_EraseRootFromParent_Done,
     /* 57658 */   // Label 1575: @57658
     /* 57658 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(57683), // Rule ID 20301 //
     /* 57663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 57666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 57670 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rrk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1)
     /* 57670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrk),
     /* 57673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57675 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 57677 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 57679 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 57681 */     GIR_RootConstrainSelectedInstOperands,
     /* 57682 */     // GIR_Coverage, 20301,
     /* 57682 */     GIR_EraseRootFromParent_Done,
     /* 57683 */   // Label 1576: @57683
     /* 57683 */   GIM_Reject,
     /* 57684 */ // Label 1568: @57684
     /* 57684 */ GIM_Reject,
     /* 57685 */ // Label 1505: @57685
     /* 57685 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(58025),
     /* 57690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 57693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 57696 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 57699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 57703 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(57772), // Rule ID 20214 //
     /* 57708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 57716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 57720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 57724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 57729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 57733 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 57739 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 57741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 57745 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 57751 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /* 57753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 57757 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 57759 */     // (vselect:{ *:[v16i32] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$mask, immAllOnesV:{ *:[v16i1] }), immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src)  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 57759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 57762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // mask
     /* 57768 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 57770 */     GIR_RootConstrainSelectedInstOperands,
     /* 57771 */     // GIR_Coverage, 20214,
     /* 57771 */     GIR_EraseRootFromParent_Done,
     /* 57772 */   // Label 1578: @57772
     /* 57772 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(57819), // Rule ID 3595 //
     /* 57777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 57780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 57784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 57788 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 57794 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 57796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 57800 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 57806 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 57808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 57810 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, immAllOnesV:{ *:[v16i32] }, immAllZerosV:{ *:[v16i32] })  =>  (AVX512_512_SEXT_MASK_32:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask)
     /* 57810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AVX512_512_SEXT_MASK_32),
     /* 57813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57815 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 57817 */     GIR_RootConstrainSelectedInstOperands,
     /* 57818 */     // GIR_Coverage, 3595,
     /* 57818 */     GIR_EraseRootFromParent_Done,
     /* 57819 */   // Label 1579: @57819
     /* 57819 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(57876), // Rule ID 20212 //
     /* 57824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 57828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 57832 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 57838 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 57840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 57844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57846 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src)  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } (KNOTWkk:{ *:[v16i1] } VK16WM:{ *:[v16i1] }:$mask), VR512:{ *:[v16i32] }:$src)
     /* 57846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 57849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 57853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 57862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 57867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57872 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 57874 */     GIR_RootConstrainSelectedInstOperands,
     /* 57875 */     // GIR_Coverage, 20212,
     /* 57875 */     GIR_EraseRootFromParent_Done,
     /* 57876 */   // Label 1580: @57876
     /* 57876 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(57917), // Rule ID 4458 //
     /* 57881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 57884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 57888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 57892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 57896 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 57902 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 57904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57906 */     // (vselect:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src, immAllZerosV:{ *:[v16f32] })  =>  (VMOVAPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 57906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 57909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57911 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 57913 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 57915 */     GIR_RootConstrainSelectedInstOperands,
     /* 57916 */     // GIR_Coverage, 4458,
     /* 57916 */     GIR_EraseRootFromParent_Done,
     /* 57917 */   // Label 1581: @57917
     /* 57917 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(57958), // Rule ID 4518 //
     /* 57922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 57925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 57929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 57933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 57937 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 57943 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 57945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57947 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src, immAllZerosV:{ *:[v16i32] })  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 57947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 57950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57952 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 57954 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 57956 */     GIR_RootConstrainSelectedInstOperands,
     /* 57957 */     // GIR_Coverage, 4518,
     /* 57957 */     GIR_EraseRootFromParent_Done,
     /* 57958 */   // Label 1582: @57958
     /* 57958 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(57991), // Rule ID 4460 //
     /* 57963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 57966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 57970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 57974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 57978 */     // (vselect:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src0)  =>  (VMOVAPSZrrk:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src1)
     /* 57978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 57981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57983 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 57985 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 57987 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 57989 */     GIR_RootConstrainSelectedInstOperands,
     /* 57990 */     // GIR_Coverage, 4460,
     /* 57990 */     GIR_EraseRootFromParent_Done,
     /* 57991 */   // Label 1583: @57991
     /* 57991 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(58024), // Rule ID 4519 //
     /* 57996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 57999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 58003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58011 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src0)  =>  (VMOVDQA32Zrrk:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src1)
     /* 58011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 58014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58016 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 58018 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58020 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 58022 */     GIR_RootConstrainSelectedInstOperands,
     /* 58023 */     // GIR_Coverage, 4519,
     /* 58023 */     GIR_EraseRootFromParent_Done,
     /* 58024 */   // Label 1584: @58024
     /* 58024 */   GIM_Reject,
     /* 58025 */ // Label 1577: @58025
     /* 58025 */ GIM_Reject,
     /* 58026 */ // Label 1506: @58026
     /* 58026 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(58429),
     /* 58031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 58034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 58037 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 58040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 58044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 58048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 58052 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(58085), // Rule ID 4552 //
     /* 58057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 58060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 58064 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58070 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 58072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58074 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src, immAllZerosV:{ *:[v32i8] })  =>  (VMOVDQU8Z256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 58074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z256rrkz),
     /* 58077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58079 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58081 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 58083 */     GIR_RootConstrainSelectedInstOperands,
     /* 58084 */     // GIR_Coverage, 4552,
     /* 58084 */     GIR_EraseRootFromParent_Done,
     /* 58085 */   // Label 1586: @58085
     /* 58085 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(58222), // Rule ID 20234 //
     /* 58090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 58093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 58097 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58103 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 58105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58107 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, immAllZerosV:{ *:[v32i8] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VMOVDQU8Zrrkz:{ *:[v64i8] } (COPY_TO_REGCLASS:{ *:[v64i1] } VK32WM:{ *:[v32i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 58107 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s8,
     /* 58110 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 58114 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 58121 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 58124 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 58128 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58133 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 58136 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 58140 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 58143 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 58148 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 58153 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 58158 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s1,
     /* 58161 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 58165 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58170 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 58174 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 58179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 58182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 58186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58191 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 58194 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 58197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 58202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58204 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 58211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 58216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 58221 */     // GIR_Coverage, 20234,
     /* 58221 */     GIR_EraseRootFromParent_Done,
     /* 58222 */   // Label 1587: @58222
     /* 58222 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(58247), // Rule ID 4553 //
     /* 58227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 58230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 58234 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src0)  =>  (VMOVDQU8Z256rrk:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1)
     /* 58234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z256rrk),
     /* 58237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58239 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 58241 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58243 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 58245 */     GIR_RootConstrainSelectedInstOperands,
     /* 58246 */     // GIR_Coverage, 4553,
     /* 58246 */     GIR_EraseRootFromParent_Done,
     /* 58247 */   // Label 1588: @58247
     /* 58247 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(58428), // Rule ID 20233 //
     /* 58252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 58255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 58259 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VMOVDQU8Zrrk:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v64i1] } VK32WM:{ *:[v32i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 58259 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v64s8,
     /* 58262 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 58266 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 58273 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v64s8,
     /* 58276 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 58280 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58285 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 58288 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 58292 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 58295 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 58300 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 58305 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 58310 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s1,
     /* 58313 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 58317 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58322 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 58326 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 58331 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 58334 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 58338 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 58345 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 58348 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 58352 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58357 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 58360 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 58364 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 58367 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 58372 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 58377 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 58382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 58385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 58389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58394 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 58397 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 58400 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 58403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 58408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58410 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 58417 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 58422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 58427 */     // GIR_Coverage, 20233,
     /* 58427 */     GIR_EraseRootFromParent_Done,
     /* 58428 */   // Label 1589: @58428
     /* 58428 */   GIM_Reject,
     /* 58429 */ // Label 1585: @58429
     /* 58429 */ GIM_Reject,
     /* 58430 */ // Label 1507: @58430
     /* 58430 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(58573),
     /* 58435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 58438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 58441 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 58444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 58452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58456 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(58489), // Rule ID 4560 //
     /* 58461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 58464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 58468 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58474 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 58476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58478 */     // (vselect:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src, immAllZerosV:{ *:[v32i16] })  =>  (VMOVDQU16Zrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 58478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 58481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58483 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58485 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 58487 */     GIR_RootConstrainSelectedInstOperands,
     /* 58488 */     // GIR_Coverage, 4560,
     /* 58488 */     GIR_EraseRootFromParent_Done,
     /* 58489 */   // Label 1591: @58489
     /* 58489 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(58522), // Rule ID 20292 //
     /* 58494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 58497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 58501 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58507 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 58509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58511 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrrkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1)
     /* 58511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 58514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58516 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58518 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 58520 */     GIR_RootConstrainSelectedInstOperands,
     /* 58521 */     // GIR_Coverage, 20292,
     /* 58521 */     GIR_EraseRootFromParent_Done,
     /* 58522 */   // Label 1592: @58522
     /* 58522 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(58547), // Rule ID 4561 //
     /* 58527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 58530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58534 */     // (vselect:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src0)  =>  (VMOVDQU16Zrrk:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src1)
     /* 58534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 58537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58539 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 58541 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58543 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 58545 */     GIR_RootConstrainSelectedInstOperands,
     /* 58546 */     // GIR_Coverage, 4561,
     /* 58546 */     GIR_EraseRootFromParent_Done,
     /* 58547 */   // Label 1593: @58547
     /* 58547 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(58572), // Rule ID 20291 //
     /* 58552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 58555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58559 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrrk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1)
     /* 58559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 58562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58564 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 58566 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58568 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 58570 */     GIR_RootConstrainSelectedInstOperands,
     /* 58571 */     // GIR_Coverage, 20291,
     /* 58571 */     GIR_EraseRootFromParent_Done,
     /* 58572 */   // Label 1594: @58572
     /* 58572 */   GIM_Reject,
     /* 58573 */ // Label 1590: @58573
     /* 58573 */ GIM_Reject,
     /* 58574 */ // Label 1508: @58574
     /* 58574 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(58659),
     /* 58579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 58582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 58585 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 58588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64WMRegClassID),
     /* 58596 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58600 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(58633), // Rule ID 4548 //
     /* 58605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 58608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 58612 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58618 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 58620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58622 */     // (vselect:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src, immAllZerosV:{ *:[v64i8] })  =>  (VMOVDQU8Zrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 58622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 58625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58627 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58629 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 58631 */     GIR_RootConstrainSelectedInstOperands,
     /* 58632 */     // GIR_Coverage, 4548,
     /* 58632 */     GIR_EraseRootFromParent_Done,
     /* 58633 */   // Label 1596: @58633
     /* 58633 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(58658), // Rule ID 4549 //
     /* 58638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 58641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58645 */     // (vselect:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src0)  =>  (VMOVDQU8Zrrk:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src0, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src1)
     /* 58645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 58648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58650 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 58652 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58654 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 58656 */     GIR_RootConstrainSelectedInstOperands,
     /* 58657 */     // GIR_Coverage, 4549,
     /* 58657 */     GIR_EraseRootFromParent_Done,
     /* 58658 */   // Label 1597: @58658
     /* 58658 */   GIM_Reject,
     /* 58659 */ // Label 1595: @58659
     /* 58659 */ GIM_Reject,
     /* 58660 */ // Label 1509: @58660
     /* 58660 */ GIM_Reject,
     /* 58661 */ // Label 28: @58661
     /* 58661 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(23), /*)*//*default:*//*Label 1601*/ GIMT_Encode4(58907),
     /* 58672 */ /*GILLT_v8s16*//*Label 1598*/ GIMT_Encode4(58712), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 58692 */ /*GILLT_v16s16*//*Label 1599*/ GIMT_Encode4(58806), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 58708 */ /*GILLT_v32s16*//*Label 1600*/ GIMT_Encode4(58873),
     /* 58712 */ // Label 1598: @58712
     /* 58712 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(58805),
     /* 58717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 58720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 58723 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(58750), // Rule ID 2573 //
     /* 58728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 58731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 58735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 58739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 58743 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULHUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 58743 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrr),
     /* 58748 */     GIR_RootConstrainSelectedInstOperands,
     /* 58749 */     // GIR_Coverage, 2573,
     /* 58749 */     GIR_Done,
     /* 58750 */   // Label 1603: @58750
     /* 58750 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(58777), // Rule ID 2575 //
     /* 58755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 58758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 58762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 58766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 58770 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULHUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 58770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULHUWrr),
     /* 58775 */     GIR_RootConstrainSelectedInstOperands,
     /* 58776 */     // GIR_Coverage, 2575,
     /* 58776 */     GIR_Done,
     /* 58777 */   // Label 1604: @58777
     /* 58777 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(58804), // Rule ID 5056 //
     /* 58782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 58785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 58789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 58793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 58797 */     // (mulhu:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULHUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 58797 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rr),
     /* 58802 */     GIR_RootConstrainSelectedInstOperands,
     /* 58803 */     // GIR_Coverage, 5056,
     /* 58803 */     GIR_Done,
     /* 58804 */   // Label 1605: @58804
     /* 58804 */   GIM_Reject,
     /* 58805 */ // Label 1602: @58805
     /* 58805 */ GIM_Reject,
     /* 58806 */ // Label 1599: @58806
     /* 58806 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(58872),
     /* 58811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 58814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 58817 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(58844), // Rule ID 2577 //
     /* 58822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 58825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 58829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 58833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 58837 */     // (mulhu:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULHUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 58837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrr),
     /* 58842 */     GIR_RootConstrainSelectedInstOperands,
     /* 58843 */     // GIR_Coverage, 2577,
     /* 58843 */     GIR_Done,
     /* 58844 */   // Label 1607: @58844
     /* 58844 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(58871), // Rule ID 5050 //
     /* 58849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 58852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 58856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 58860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 58864 */     // (mulhu:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULHUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 58864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rr),
     /* 58869 */     GIR_RootConstrainSelectedInstOperands,
     /* 58870 */     // GIR_Coverage, 5050,
     /* 58870 */     GIR_Done,
     /* 58871 */   // Label 1608: @58871
     /* 58871 */   GIM_Reject,
     /* 58872 */ // Label 1606: @58872
     /* 58872 */ GIM_Reject,
     /* 58873 */ // Label 1600: @58873
     /* 58873 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(58906), // Rule ID 5044 //
     /* 58878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 58881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 58884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 58887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58899 */   // (mulhu:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULHUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 58899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrr),
     /* 58904 */   GIR_RootConstrainSelectedInstOperands,
     /* 58905 */   // GIR_Coverage, 5044,
     /* 58905 */   GIR_Done,
     /* 58906 */ // Label 1609: @58906
     /* 58906 */ GIM_Reject,
     /* 58907 */ // Label 1601: @58907
     /* 58907 */ GIM_Reject,
     /* 58908 */ // Label 29: @58908
     /* 58908 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(23), /*)*//*default:*//*Label 1613*/ GIMT_Encode4(59154),
     /* 58919 */ /*GILLT_v8s16*//*Label 1610*/ GIMT_Encode4(58959), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 58939 */ /*GILLT_v16s16*//*Label 1611*/ GIMT_Encode4(59053), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 58955 */ /*GILLT_v32s16*//*Label 1612*/ GIMT_Encode4(59120),
     /* 58959 */ // Label 1610: @58959
     /* 58959 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(59052),
     /* 58964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 58967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 58970 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(58997), // Rule ID 2579 //
     /* 58975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 58978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 58982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 58986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 58990 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULHWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 58990 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWrr),
     /* 58995 */     GIR_RootConstrainSelectedInstOperands,
     /* 58996 */     // GIR_Coverage, 2579,
     /* 58996 */     GIR_Done,
     /* 58997 */   // Label 1615: @58997
     /* 58997 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(59024), // Rule ID 2581 //
     /* 59002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 59005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59017 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULHWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 59017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULHWrr),
     /* 59022 */     GIR_RootConstrainSelectedInstOperands,
     /* 59023 */     // GIR_Coverage, 2581,
     /* 59023 */     GIR_Done,
     /* 59024 */   // Label 1616: @59024
     /* 59024 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(59051), // Rule ID 5038 //
     /* 59029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59044 */     // (mulhs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULHWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 59044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rr),
     /* 59049 */     GIR_RootConstrainSelectedInstOperands,
     /* 59050 */     // GIR_Coverage, 5038,
     /* 59050 */     GIR_Done,
     /* 59051 */   // Label 1617: @59051
     /* 59051 */   GIM_Reject,
     /* 59052 */ // Label 1614: @59052
     /* 59052 */ GIM_Reject,
     /* 59053 */ // Label 1611: @59053
     /* 59053 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(59119),
     /* 59058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 59061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 59064 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(59091), // Rule ID 2583 //
     /* 59069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 59072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59084 */     // (mulhs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULHWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 59084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrr),
     /* 59089 */     GIR_RootConstrainSelectedInstOperands,
     /* 59090 */     // GIR_Coverage, 2583,
     /* 59090 */     GIR_Done,
     /* 59091 */   // Label 1619: @59091
     /* 59091 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(59118), // Rule ID 5032 //
     /* 59096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59111 */     // (mulhs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULHWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 59111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rr),
     /* 59116 */     GIR_RootConstrainSelectedInstOperands,
     /* 59117 */     // GIR_Coverage, 5032,
     /* 59117 */     GIR_Done,
     /* 59118 */   // Label 1620: @59118
     /* 59118 */   GIM_Reject,
     /* 59119 */ // Label 1618: @59119
     /* 59119 */ GIM_Reject,
     /* 59120 */ // Label 1612: @59120
     /* 59120 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(59153), // Rule ID 5026 //
     /* 59125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 59128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 59131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 59134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59146 */   // (mulhs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULHWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 59146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrr),
     /* 59151 */   GIR_RootConstrainSelectedInstOperands,
     /* 59152 */   // GIR_Coverage, 5026,
     /* 59152 */   GIR_Done,
     /* 59153 */ // Label 1621: @59153
     /* 59153 */ GIM_Reject,
     /* 59154 */ // Label 1613: @59154
     /* 59154 */ GIM_Reject,
     /* 59155 */ // Label 30: @59155
     /* 59155 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 1628*/ GIMT_Encode4(59604),
     /* 59166 */ /*GILLT_v8s16*//*Label 1622*/ GIMT_Encode4(59214), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 59182 */ /*GILLT_v16s8*//*Label 1623*/ GIMT_Encode4(59308),
     /* 59186 */ /*GILLT_v16s16*//*Label 1624*/ GIMT_Encode4(59402), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 59198 */ /*GILLT_v32s8*//*Label 1625*/ GIMT_Encode4(59469),
     /* 59202 */ /*GILLT_v32s16*//*Label 1626*/ GIMT_Encode4(59536), GIMT_Encode4(0),
     /* 59210 */ /*GILLT_v64s8*//*Label 1627*/ GIMT_Encode4(59570),
     /* 59214 */ // Label 1622: @59214
     /* 59214 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(59307),
     /* 59219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 59222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 59225 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(59252), // Rule ID 2561 //
     /* 59230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 59233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59245 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 59245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrr),
     /* 59250 */     GIR_RootConstrainSelectedInstOperands,
     /* 59251 */     // GIR_Coverage, 2561,
     /* 59251 */     GIR_Done,
     /* 59252 */   // Label 1630: @59252
     /* 59252 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(59279), // Rule ID 2563 //
     /* 59257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 59260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59272 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 59272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDUSWrr),
     /* 59277 */     GIR_RootConstrainSelectedInstOperands,
     /* 59278 */     // GIR_Coverage, 2563,
     /* 59278 */     GIR_Done,
     /* 59279 */   // Label 1631: @59279
     /* 59279 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(59306), // Rule ID 4894 //
     /* 59284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59299 */     // (uaddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDUSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 59299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rr),
     /* 59304 */     GIR_RootConstrainSelectedInstOperands,
     /* 59305 */     // GIR_Coverage, 4894,
     /* 59305 */     GIR_Done,
     /* 59306 */   // Label 1632: @59306
     /* 59306 */   GIM_Reject,
     /* 59307 */ // Label 1629: @59307
     /* 59307 */ GIM_Reject,
     /* 59308 */ // Label 1623: @59308
     /* 59308 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(59401),
     /* 59313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 59316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 59319 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(59346), // Rule ID 2555 //
     /* 59324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 59327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59339 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 59339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrr),
     /* 59344 */     GIR_RootConstrainSelectedInstOperands,
     /* 59345 */     // GIR_Coverage, 2555,
     /* 59345 */     GIR_Done,
     /* 59346 */   // Label 1634: @59346
     /* 59346 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(59373), // Rule ID 2557 //
     /* 59351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 59354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59366 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 59366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDUSBrr),
     /* 59371 */     GIR_RootConstrainSelectedInstOperands,
     /* 59372 */     // GIR_Coverage, 2557,
     /* 59372 */     GIR_Done,
     /* 59373 */   // Label 1635: @59373
     /* 59373 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(59400), // Rule ID 4912 //
     /* 59378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59393 */     // (uaddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDUSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 59393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rr),
     /* 59398 */     GIR_RootConstrainSelectedInstOperands,
     /* 59399 */     // GIR_Coverage, 4912,
     /* 59399 */     GIR_Done,
     /* 59400 */   // Label 1636: @59400
     /* 59400 */   GIM_Reject,
     /* 59401 */ // Label 1633: @59401
     /* 59401 */ GIM_Reject,
     /* 59402 */ // Label 1624: @59402
     /* 59402 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(59468),
     /* 59407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 59410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 59413 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(59440), // Rule ID 2565 //
     /* 59418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 59421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59433 */     // (uaddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDUSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 59433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrr),
     /* 59438 */     GIR_RootConstrainSelectedInstOperands,
     /* 59439 */     // GIR_Coverage, 2565,
     /* 59439 */     GIR_Done,
     /* 59440 */   // Label 1638: @59440
     /* 59440 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(59467), // Rule ID 4888 //
     /* 59445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59460 */     // (uaddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDUSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 59460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rr),
     /* 59465 */     GIR_RootConstrainSelectedInstOperands,
     /* 59466 */     // GIR_Coverage, 4888,
     /* 59466 */     GIR_Done,
     /* 59467 */   // Label 1639: @59467
     /* 59467 */   GIM_Reject,
     /* 59468 */ // Label 1637: @59468
     /* 59468 */ GIM_Reject,
     /* 59469 */ // Label 1625: @59469
     /* 59469 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(59535),
     /* 59474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 59477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 59480 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(59507), // Rule ID 2559 //
     /* 59485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 59488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59500 */     // (uaddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDUSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 59500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrr),
     /* 59505 */     GIR_RootConstrainSelectedInstOperands,
     /* 59506 */     // GIR_Coverage, 2559,
     /* 59506 */     GIR_Done,
     /* 59507 */   // Label 1641: @59507
     /* 59507 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(59534), // Rule ID 4906 //
     /* 59512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59527 */     // (uaddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDUSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 59527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rr),
     /* 59532 */     GIR_RootConstrainSelectedInstOperands,
     /* 59533 */     // GIR_Coverage, 4906,
     /* 59533 */     GIR_Done,
     /* 59534 */   // Label 1642: @59534
     /* 59534 */   GIM_Reject,
     /* 59535 */ // Label 1640: @59535
     /* 59535 */ GIM_Reject,
     /* 59536 */ // Label 1626: @59536
     /* 59536 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(59569), // Rule ID 4882 //
     /* 59541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 59544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 59547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 59550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59562 */   // (uaddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDUSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 59562 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrr),
     /* 59567 */   GIR_RootConstrainSelectedInstOperands,
     /* 59568 */   // GIR_Coverage, 4882,
     /* 59568 */   GIR_Done,
     /* 59569 */ // Label 1643: @59569
     /* 59569 */ GIM_Reject,
     /* 59570 */ // Label 1627: @59570
     /* 59570 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(59603), // Rule ID 4900 //
     /* 59575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 59578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 59581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 59584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59596 */   // (uaddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDUSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 59596 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrr),
     /* 59601 */   GIR_RootConstrainSelectedInstOperands,
     /* 59602 */   // GIR_Coverage, 4900,
     /* 59602 */   GIR_Done,
     /* 59603 */ // Label 1644: @59603
     /* 59603 */ GIM_Reject,
     /* 59604 */ // Label 1628: @59604
     /* 59604 */ GIM_Reject,
     /* 59605 */ // Label 31: @59605
     /* 59605 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 1651*/ GIMT_Encode4(60054),
     /* 59616 */ /*GILLT_v8s16*//*Label 1645*/ GIMT_Encode4(59664), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 59632 */ /*GILLT_v16s8*//*Label 1646*/ GIMT_Encode4(59758),
     /* 59636 */ /*GILLT_v16s16*//*Label 1647*/ GIMT_Encode4(59852), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 59648 */ /*GILLT_v32s8*//*Label 1648*/ GIMT_Encode4(59919),
     /* 59652 */ /*GILLT_v32s16*//*Label 1649*/ GIMT_Encode4(59986), GIMT_Encode4(0),
     /* 59660 */ /*GILLT_v64s8*//*Label 1650*/ GIMT_Encode4(60020),
     /* 59664 */ // Label 1645: @59664
     /* 59664 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(59757),
     /* 59669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 59672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 59675 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(59702), // Rule ID 2549 //
     /* 59680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 59683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59695 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 59695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWrr),
     /* 59700 */     GIR_RootConstrainSelectedInstOperands,
     /* 59701 */     // GIR_Coverage, 2549,
     /* 59701 */     GIR_Done,
     /* 59702 */   // Label 1653: @59702
     /* 59702 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(59729), // Rule ID 2551 //
     /* 59707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 59710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59722 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 59722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDSWrr),
     /* 59727 */     GIR_RootConstrainSelectedInstOperands,
     /* 59728 */     // GIR_Coverage, 2551,
     /* 59728 */     GIR_Done,
     /* 59729 */   // Label 1654: @59729
     /* 59729 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(59756), // Rule ID 4822 //
     /* 59734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59749 */     // (saddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 59749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rr),
     /* 59754 */     GIR_RootConstrainSelectedInstOperands,
     /* 59755 */     // GIR_Coverage, 4822,
     /* 59755 */     GIR_Done,
     /* 59756 */   // Label 1655: @59756
     /* 59756 */   GIM_Reject,
     /* 59757 */ // Label 1652: @59757
     /* 59757 */ GIM_Reject,
     /* 59758 */ // Label 1646: @59758
     /* 59758 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(59851),
     /* 59763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 59766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 59769 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(59796), // Rule ID 2543 //
     /* 59774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 59777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59789 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 59789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBrr),
     /* 59794 */     GIR_RootConstrainSelectedInstOperands,
     /* 59795 */     // GIR_Coverage, 2543,
     /* 59795 */     GIR_Done,
     /* 59796 */   // Label 1657: @59796
     /* 59796 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(59823), // Rule ID 2545 //
     /* 59801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 59804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59816 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 59816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDSBrr),
     /* 59821 */     GIR_RootConstrainSelectedInstOperands,
     /* 59822 */     // GIR_Coverage, 2545,
     /* 59822 */     GIR_Done,
     /* 59823 */   // Label 1658: @59823
     /* 59823 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(59850), // Rule ID 4840 //
     /* 59828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59843 */     // (saddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 59843 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rr),
     /* 59848 */     GIR_RootConstrainSelectedInstOperands,
     /* 59849 */     // GIR_Coverage, 4840,
     /* 59849 */     GIR_Done,
     /* 59850 */   // Label 1659: @59850
     /* 59850 */   GIM_Reject,
     /* 59851 */ // Label 1656: @59851
     /* 59851 */ GIM_Reject,
     /* 59852 */ // Label 1647: @59852
     /* 59852 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(59918),
     /* 59857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 59860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 59863 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(59890), // Rule ID 2553 //
     /* 59868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 59871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59883 */     // (saddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 59883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrr),
     /* 59888 */     GIR_RootConstrainSelectedInstOperands,
     /* 59889 */     // GIR_Coverage, 2553,
     /* 59889 */     GIR_Done,
     /* 59890 */   // Label 1661: @59890
     /* 59890 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(59917), // Rule ID 4816 //
     /* 59895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59910 */     // (saddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 59910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rr),
     /* 59915 */     GIR_RootConstrainSelectedInstOperands,
     /* 59916 */     // GIR_Coverage, 4816,
     /* 59916 */     GIR_Done,
     /* 59917 */   // Label 1662: @59917
     /* 59917 */   GIM_Reject,
     /* 59918 */ // Label 1660: @59918
     /* 59918 */ GIM_Reject,
     /* 59919 */ // Label 1648: @59919
     /* 59919 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(59985),
     /* 59924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 59927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 59930 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(59957), // Rule ID 2547 //
     /* 59935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 59938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59950 */     // (saddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 59950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrr),
     /* 59955 */     GIR_RootConstrainSelectedInstOperands,
     /* 59956 */     // GIR_Coverage, 2547,
     /* 59956 */     GIR_Done,
     /* 59957 */   // Label 1664: @59957
     /* 59957 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(59984), // Rule ID 4834 //
     /* 59962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59977 */     // (saddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 59977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rr),
     /* 59982 */     GIR_RootConstrainSelectedInstOperands,
     /* 59983 */     // GIR_Coverage, 4834,
     /* 59983 */     GIR_Done,
     /* 59984 */   // Label 1665: @59984
     /* 59984 */   GIM_Reject,
     /* 59985 */ // Label 1663: @59985
     /* 59985 */ GIM_Reject,
     /* 59986 */ // Label 1649: @59986
     /* 59986 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(60019), // Rule ID 4810 //
     /* 59991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 59994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 59997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 60000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60012 */   // (saddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 60012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrr),
     /* 60017 */   GIR_RootConstrainSelectedInstOperands,
     /* 60018 */   // GIR_Coverage, 4810,
     /* 60018 */   GIR_Done,
     /* 60019 */ // Label 1666: @60019
     /* 60019 */ GIM_Reject,
     /* 60020 */ // Label 1650: @60020
     /* 60020 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(60053), // Rule ID 4828 //
     /* 60025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 60028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 60031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 60034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60046 */   // (saddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 60046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrr),
     /* 60051 */   GIR_RootConstrainSelectedInstOperands,
     /* 60052 */   // GIR_Coverage, 4828,
     /* 60052 */   GIR_Done,
     /* 60053 */ // Label 1667: @60053
     /* 60053 */ GIM_Reject,
     /* 60054 */ // Label 1651: @60054
     /* 60054 */ GIM_Reject,
     /* 60055 */ // Label 32: @60055
     /* 60055 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 1674*/ GIMT_Encode4(60504),
     /* 60066 */ /*GILLT_v8s16*//*Label 1668*/ GIMT_Encode4(60114), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 60082 */ /*GILLT_v16s8*//*Label 1669*/ GIMT_Encode4(60208),
     /* 60086 */ /*GILLT_v16s16*//*Label 1670*/ GIMT_Encode4(60302), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 60098 */ /*GILLT_v32s8*//*Label 1671*/ GIMT_Encode4(60369),
     /* 60102 */ /*GILLT_v32s16*//*Label 1672*/ GIMT_Encode4(60436), GIMT_Encode4(0),
     /* 60110 */ /*GILLT_v64s8*//*Label 1673*/ GIMT_Encode4(60470),
     /* 60114 */ // Label 1668: @60114
     /* 60114 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(60207),
     /* 60119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 60122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 60125 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(60152), // Rule ID 2627 //
     /* 60130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 60133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60145 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 60145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWrr),
     /* 60150 */     GIR_RootConstrainSelectedInstOperands,
     /* 60151 */     // GIR_Coverage, 2627,
     /* 60151 */     GIR_Done,
     /* 60152 */   // Label 1676: @60152
     /* 60152 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(60179), // Rule ID 2629 //
     /* 60157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 60160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60172 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 60172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBUSWrr),
     /* 60177 */     GIR_RootConstrainSelectedInstOperands,
     /* 60178 */     // GIR_Coverage, 2629,
     /* 60178 */     GIR_Done,
     /* 60179 */   // Label 1677: @60179
     /* 60179 */   GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(60206), // Rule ID 4930 //
     /* 60184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 60187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60199 */     // (usubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBUSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 60199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ128rr),
     /* 60204 */     GIR_RootConstrainSelectedInstOperands,
     /* 60205 */     // GIR_Coverage, 4930,
     /* 60205 */     GIR_Done,
     /* 60206 */   // Label 1678: @60206
     /* 60206 */   GIM_Reject,
     /* 60207 */ // Label 1675: @60207
     /* 60207 */ GIM_Reject,
     /* 60208 */ // Label 1669: @60208
     /* 60208 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(60301),
     /* 60213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 60216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 60219 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(60246), // Rule ID 2621 //
     /* 60224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 60227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60239 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 60239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBrr),
     /* 60244 */     GIR_RootConstrainSelectedInstOperands,
     /* 60245 */     // GIR_Coverage, 2621,
     /* 60245 */     GIR_Done,
     /* 60246 */   // Label 1680: @60246
     /* 60246 */   GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(60273), // Rule ID 2623 //
     /* 60251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 60254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60266 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 60266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBUSBrr),
     /* 60271 */     GIR_RootConstrainSelectedInstOperands,
     /* 60272 */     // GIR_Coverage, 2623,
     /* 60272 */     GIR_Done,
     /* 60273 */   // Label 1681: @60273
     /* 60273 */   GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(60300), // Rule ID 4948 //
     /* 60278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 60281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60293 */     // (usubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBUSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 60293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ128rr),
     /* 60298 */     GIR_RootConstrainSelectedInstOperands,
     /* 60299 */     // GIR_Coverage, 4948,
     /* 60299 */     GIR_Done,
     /* 60300 */   // Label 1682: @60300
     /* 60300 */   GIM_Reject,
     /* 60301 */ // Label 1679: @60301
     /* 60301 */ GIM_Reject,
     /* 60302 */ // Label 1670: @60302
     /* 60302 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(60368),
     /* 60307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 60310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 60313 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(60340), // Rule ID 2631 //
     /* 60318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 60321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60333 */     // (usubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBUSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 60333 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWYrr),
     /* 60338 */     GIR_RootConstrainSelectedInstOperands,
     /* 60339 */     // GIR_Coverage, 2631,
     /* 60339 */     GIR_Done,
     /* 60340 */   // Label 1684: @60340
     /* 60340 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(60367), // Rule ID 4924 //
     /* 60345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 60348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60360 */     // (usubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBUSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 60360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ256rr),
     /* 60365 */     GIR_RootConstrainSelectedInstOperands,
     /* 60366 */     // GIR_Coverage, 4924,
     /* 60366 */     GIR_Done,
     /* 60367 */   // Label 1685: @60367
     /* 60367 */   GIM_Reject,
     /* 60368 */ // Label 1683: @60368
     /* 60368 */ GIM_Reject,
     /* 60369 */ // Label 1671: @60369
     /* 60369 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(60435),
     /* 60374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 60377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 60380 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(60407), // Rule ID 2625 //
     /* 60385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 60388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60400 */     // (usubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBUSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 60400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBYrr),
     /* 60405 */     GIR_RootConstrainSelectedInstOperands,
     /* 60406 */     // GIR_Coverage, 2625,
     /* 60406 */     GIR_Done,
     /* 60407 */   // Label 1687: @60407
     /* 60407 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(60434), // Rule ID 4942 //
     /* 60412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 60415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60427 */     // (usubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBUSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 60427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ256rr),
     /* 60432 */     GIR_RootConstrainSelectedInstOperands,
     /* 60433 */     // GIR_Coverage, 4942,
     /* 60433 */     GIR_Done,
     /* 60434 */   // Label 1688: @60434
     /* 60434 */   GIM_Reject,
     /* 60435 */ // Label 1686: @60435
     /* 60435 */ GIM_Reject,
     /* 60436 */ // Label 1672: @60436
     /* 60436 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(60469), // Rule ID 4918 //
     /* 60441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 60444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 60447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 60450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60458 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60462 */   // (usubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBUSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 60462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZrr),
     /* 60467 */   GIR_RootConstrainSelectedInstOperands,
     /* 60468 */   // GIR_Coverage, 4918,
     /* 60468 */   GIR_Done,
     /* 60469 */ // Label 1689: @60469
     /* 60469 */ GIM_Reject,
     /* 60470 */ // Label 1673: @60470
     /* 60470 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(60503), // Rule ID 4936 //
     /* 60475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 60478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 60481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 60484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60496 */   // (usubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBUSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 60496 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZrr),
     /* 60501 */   GIR_RootConstrainSelectedInstOperands,
     /* 60502 */   // GIR_Coverage, 4936,
     /* 60502 */   GIR_Done,
     /* 60503 */ // Label 1690: @60503
     /* 60503 */ GIM_Reject,
     /* 60504 */ // Label 1674: @60504
     /* 60504 */ GIM_Reject,
     /* 60505 */ // Label 33: @60505
     /* 60505 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 1697*/ GIMT_Encode4(60954),
     /* 60516 */ /*GILLT_v8s16*//*Label 1691*/ GIMT_Encode4(60564), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 60532 */ /*GILLT_v16s8*//*Label 1692*/ GIMT_Encode4(60658),
     /* 60536 */ /*GILLT_v16s16*//*Label 1693*/ GIMT_Encode4(60752), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 60548 */ /*GILLT_v32s8*//*Label 1694*/ GIMT_Encode4(60819),
     /* 60552 */ /*GILLT_v32s16*//*Label 1695*/ GIMT_Encode4(60886), GIMT_Encode4(0),
     /* 60560 */ /*GILLT_v64s8*//*Label 1696*/ GIMT_Encode4(60920),
     /* 60564 */ // Label 1691: @60564
     /* 60564 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(60657),
     /* 60569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 60572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 60575 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(60602), // Rule ID 2615 //
     /* 60580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 60583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60595 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 60595 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWrr),
     /* 60600 */     GIR_RootConstrainSelectedInstOperands,
     /* 60601 */     // GIR_Coverage, 2615,
     /* 60601 */     GIR_Done,
     /* 60602 */   // Label 1699: @60602
     /* 60602 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(60629), // Rule ID 2617 //
     /* 60607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 60610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60622 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 60622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBSWrr),
     /* 60627 */     GIR_RootConstrainSelectedInstOperands,
     /* 60628 */     // GIR_Coverage, 2617,
     /* 60628 */     GIR_Done,
     /* 60629 */   // Label 1700: @60629
     /* 60629 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(60656), // Rule ID 4858 //
     /* 60634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 60637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60649 */     // (ssubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 60649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ128rr),
     /* 60654 */     GIR_RootConstrainSelectedInstOperands,
     /* 60655 */     // GIR_Coverage, 4858,
     /* 60655 */     GIR_Done,
     /* 60656 */   // Label 1701: @60656
     /* 60656 */   GIM_Reject,
     /* 60657 */ // Label 1698: @60657
     /* 60657 */ GIM_Reject,
     /* 60658 */ // Label 1692: @60658
     /* 60658 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(60751),
     /* 60663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 60666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 60669 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(60696), // Rule ID 2609 //
     /* 60674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 60677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60689 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 60689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBrr),
     /* 60694 */     GIR_RootConstrainSelectedInstOperands,
     /* 60695 */     // GIR_Coverage, 2609,
     /* 60695 */     GIR_Done,
     /* 60696 */   // Label 1703: @60696
     /* 60696 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(60723), // Rule ID 2611 //
     /* 60701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 60704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60716 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 60716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBSBrr),
     /* 60721 */     GIR_RootConstrainSelectedInstOperands,
     /* 60722 */     // GIR_Coverage, 2611,
     /* 60722 */     GIR_Done,
     /* 60723 */   // Label 1704: @60723
     /* 60723 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(60750), // Rule ID 4876 //
     /* 60728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 60731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60743 */     // (ssubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 60743 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ128rr),
     /* 60748 */     GIR_RootConstrainSelectedInstOperands,
     /* 60749 */     // GIR_Coverage, 4876,
     /* 60749 */     GIR_Done,
     /* 60750 */   // Label 1705: @60750
     /* 60750 */   GIM_Reject,
     /* 60751 */ // Label 1702: @60751
     /* 60751 */ GIM_Reject,
     /* 60752 */ // Label 1693: @60752
     /* 60752 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(60818),
     /* 60757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 60760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 60763 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(60790), // Rule ID 2619 //
     /* 60768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 60771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60783 */     // (ssubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 60783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWYrr),
     /* 60788 */     GIR_RootConstrainSelectedInstOperands,
     /* 60789 */     // GIR_Coverage, 2619,
     /* 60789 */     GIR_Done,
     /* 60790 */   // Label 1707: @60790
     /* 60790 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(60817), // Rule ID 4852 //
     /* 60795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 60798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60810 */     // (ssubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 60810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ256rr),
     /* 60815 */     GIR_RootConstrainSelectedInstOperands,
     /* 60816 */     // GIR_Coverage, 4852,
     /* 60816 */     GIR_Done,
     /* 60817 */   // Label 1708: @60817
     /* 60817 */   GIM_Reject,
     /* 60818 */ // Label 1706: @60818
     /* 60818 */ GIM_Reject,
     /* 60819 */ // Label 1694: @60819
     /* 60819 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(60885),
     /* 60824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 60827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 60830 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(60857), // Rule ID 2613 //
     /* 60835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 60838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60850 */     // (ssubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 60850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBYrr),
     /* 60855 */     GIR_RootConstrainSelectedInstOperands,
     /* 60856 */     // GIR_Coverage, 2613,
     /* 60856 */     GIR_Done,
     /* 60857 */   // Label 1710: @60857
     /* 60857 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(60884), // Rule ID 4870 //
     /* 60862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 60865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60877 */     // (ssubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 60877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ256rr),
     /* 60882 */     GIR_RootConstrainSelectedInstOperands,
     /* 60883 */     // GIR_Coverage, 4870,
     /* 60883 */     GIR_Done,
     /* 60884 */   // Label 1711: @60884
     /* 60884 */   GIM_Reject,
     /* 60885 */ // Label 1709: @60885
     /* 60885 */ GIM_Reject,
     /* 60886 */ // Label 1695: @60886
     /* 60886 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(60919), // Rule ID 4846 //
     /* 60891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 60894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 60897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 60900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60912 */   // (ssubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 60912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZrr),
     /* 60917 */   GIR_RootConstrainSelectedInstOperands,
     /* 60918 */   // GIR_Coverage, 4846,
     /* 60918 */   GIR_Done,
     /* 60919 */ // Label 1712: @60919
     /* 60919 */ GIM_Reject,
     /* 60920 */ // Label 1696: @60920
     /* 60920 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(60953), // Rule ID 4864 //
     /* 60925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 60928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 60931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 60934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60942 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60946 */   // (ssubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 60946 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZrr),
     /* 60951 */   GIR_RootConstrainSelectedInstOperands,
     /* 60952 */   // GIR_Coverage, 4864,
     /* 60952 */   GIR_Done,
     /* 60953 */ // Label 1713: @60953
     /* 60953 */ GIM_Reject,
     /* 60954 */ // Label 1697: @60954
     /* 60954 */ GIM_Reject,
     /* 60955 */ // Label 34: @60955
     /* 60955 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1727*/ GIMT_Encode4(61970),
     /* 60966 */ /*GILLT_s16*//*Label 1714*/ GIMT_Encode4(61050),
     /* 60970 */ /*GILLT_s32*//*Label 1715*/ GIMT_Encode4(61088),
     /* 60974 */ /*GILLT_s64*//*Label 1716*/ GIMT_Encode4(61231),
     /* 60978 */ /*GILLT_s80*//*Label 1717*/ GIMT_Encode4(61374), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 60990 */ /*GILLT_v2s64*//*Label 1718*/ GIMT_Encode4(61418), GIMT_Encode4(0),
     /* 60998 */ /*GILLT_v4s32*//*Label 1719*/ GIMT_Encode4(61524),
     /* 61002 */ /*GILLT_v4s64*//*Label 1720*/ GIMT_Encode4(61630), GIMT_Encode4(0),
     /* 61010 */ /*GILLT_v8s16*//*Label 1721*/ GIMT_Encode4(61705),
     /* 61014 */ /*GILLT_v8s32*//*Label 1722*/ GIMT_Encode4(61743),
     /* 61018 */ /*GILLT_v8s64*//*Label 1723*/ GIMT_Encode4(61818), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 61030 */ /*GILLT_v16s16*//*Label 1724*/ GIMT_Encode4(61856),
     /* 61034 */ /*GILLT_v16s32*//*Label 1725*/ GIMT_Encode4(61894), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 61046 */ /*GILLT_v32s16*//*Label 1726*/ GIMT_Encode4(61932),
     /* 61050 */ // Label 1714: @61050
     /* 61050 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(61087), // Rule ID 5950 //
     /* 61055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 61058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 61061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 61064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 61068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 61072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 61076 */   // (fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VADDSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 61076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSHZrr),
     /* 61081 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61085 */   GIR_RootConstrainSelectedInstOperands,
     /* 61086 */   // GIR_Coverage, 5950,
     /* 61086 */   GIR_Done,
     /* 61087 */ // Label 1728: @61087
     /* 61087 */ GIM_Reject,
     /* 61088 */ // Label 1715: @61088
     /* 61088 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(61230),
     /* 61093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 61099 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(61136), // Rule ID 884 //
     /* 61104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 61107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 61111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 61115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 61119 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (ADD_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 61119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32),
     /* 61124 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 61130 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 61134 */     GIR_RootConstrainSelectedInstOperands,
     /* 61135 */     // GIR_Coverage, 884,
     /* 61135 */     GIR_Done,
     /* 61136 */   // Label 1730: @61136
     /* 61136 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(61167), // Rule ID 2156 //
     /* 61141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 61144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 61148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 61152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 61156 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 61156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSrr),
     /* 61161 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61165 */     GIR_RootConstrainSelectedInstOperands,
     /* 61166 */     // GIR_Coverage, 2156,
     /* 61166 */     GIR_Done,
     /* 61167 */   // Label 1731: @61167
     /* 61167 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(61198), // Rule ID 2164 //
     /* 61172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 61175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 61179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 61183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 61187 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (ADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 61187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSSrr),
     /* 61192 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61196 */     GIR_RootConstrainSelectedInstOperands,
     /* 61197 */     // GIR_Coverage, 2164,
     /* 61197 */     GIR_Done,
     /* 61198 */   // Label 1732: @61198
     /* 61198 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(61229), // Rule ID 5912 //
     /* 61203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 61206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 61210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 61214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 61218 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VADDSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 61218 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSZrr),
     /* 61223 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61227 */     GIR_RootConstrainSelectedInstOperands,
     /* 61228 */     // GIR_Coverage, 5912,
     /* 61228 */     GIR_Done,
     /* 61229 */   // Label 1733: @61229
     /* 61229 */   GIM_Reject,
     /* 61230 */ // Label 1729: @61230
     /* 61230 */ GIM_Reject,
     /* 61231 */ // Label 1716: @61231
     /* 61231 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(61373),
     /* 61236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 61239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61242 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(61279), // Rule ID 886 //
     /* 61247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 61250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 61254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 61258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 61262 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (ADD_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 61262 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64),
     /* 61267 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 61273 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 61277 */     GIR_RootConstrainSelectedInstOperands,
     /* 61278 */     // GIR_Coverage, 886,
     /* 61278 */     GIR_Done,
     /* 61279 */   // Label 1735: @61279
     /* 61279 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(61310), // Rule ID 2160 //
     /* 61284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 61287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 61291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 61295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 61299 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 61299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDrr),
     /* 61304 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61308 */     GIR_RootConstrainSelectedInstOperands,
     /* 61309 */     // GIR_Coverage, 2160,
     /* 61309 */     GIR_Done,
     /* 61310 */   // Label 1736: @61310
     /* 61310 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(61341), // Rule ID 2168 //
     /* 61315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 61318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 61322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 61326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 61330 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (ADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 61330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSDrr),
     /* 61335 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61339 */     GIR_RootConstrainSelectedInstOperands,
     /* 61340 */     // GIR_Coverage, 2168,
     /* 61340 */     GIR_Done,
     /* 61341 */   // Label 1737: @61341
     /* 61341 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(61372), // Rule ID 5931 //
     /* 61346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 61349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 61353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 61357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 61361 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VADDSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 61361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDZrr),
     /* 61366 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61370 */     GIR_RootConstrainSelectedInstOperands,
     /* 61371 */     // GIR_Coverage, 5931,
     /* 61371 */     GIR_Done,
     /* 61372 */   // Label 1738: @61372
     /* 61372 */   GIM_Reject,
     /* 61373 */ // Label 1734: @61373
     /* 61373 */ GIM_Reject,
     /* 61374 */ // Label 1717: @61374
     /* 61374 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(61417), // Rule ID 888 //
     /* 61379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 61382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 61385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 61388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 61392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 61396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 61400 */   // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (ADD_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 61400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80),
     /* 61405 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 61411 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 61415 */   GIR_RootConstrainSelectedInstOperands,
     /* 61416 */   // GIR_Coverage, 888,
     /* 61416 */   GIR_Done,
     /* 61417 */ // Label 1739: @61417
     /* 61417 */ GIM_Reject,
     /* 61418 */ // Label 1718: @61418
     /* 61418 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(61523),
     /* 61423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 61426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 61429 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(61460), // Rule ID 2136 //
     /* 61434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 61437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61449 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 61449 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDrr),
     /* 61454 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61458 */     GIR_RootConstrainSelectedInstOperands,
     /* 61459 */     // GIR_Coverage, 2136,
     /* 61459 */     GIR_Done,
     /* 61460 */   // Label 1741: @61460
     /* 61460 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(61491), // Rule ID 2152 //
     /* 61465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 61468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61480 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (ADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 61480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPDrr),
     /* 61485 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61489 */     GIR_RootConstrainSelectedInstOperands,
     /* 61490 */     // GIR_Coverage, 2152,
     /* 61490 */     GIR_Done,
     /* 61491 */   // Label 1742: @61491
     /* 61491 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(61522), // Rule ID 6302 //
     /* 61496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 61499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61511 */     // (fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VADDPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 61511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rr),
     /* 61516 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61520 */     GIR_RootConstrainSelectedInstOperands,
     /* 61521 */     // GIR_Coverage, 6302,
     /* 61521 */     GIR_Done,
     /* 61522 */   // Label 1743: @61522
     /* 61522 */   GIM_Reject,
     /* 61523 */ // Label 1740: @61523
     /* 61523 */ GIM_Reject,
     /* 61524 */ // Label 1719: @61524
     /* 61524 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(61629),
     /* 61529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 61532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 61535 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(61566), // Rule ID 2132 //
     /* 61540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 61543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61555 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 61555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSrr),
     /* 61560 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61564 */     GIR_RootConstrainSelectedInstOperands,
     /* 61565 */     // GIR_Coverage, 2132,
     /* 61565 */     GIR_Done,
     /* 61566 */   // Label 1745: @61566
     /* 61566 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(61597), // Rule ID 2148 //
     /* 61571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 61574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61586 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (ADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 61586 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPSrr),
     /* 61591 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61595 */     GIR_RootConstrainSelectedInstOperands,
     /* 61596 */     // GIR_Coverage, 2148,
     /* 61596 */     GIR_Done,
     /* 61597 */   // Label 1746: @61597
     /* 61597 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(61628), // Rule ID 6278 //
     /* 61602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 61605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61617 */     // (fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VADDPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 61617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rr),
     /* 61622 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61626 */     GIR_RootConstrainSelectedInstOperands,
     /* 61627 */     // GIR_Coverage, 6278,
     /* 61627 */     GIR_Done,
     /* 61628 */   // Label 1747: @61628
     /* 61628 */   GIM_Reject,
     /* 61629 */ // Label 1744: @61629
     /* 61629 */ GIM_Reject,
     /* 61630 */ // Label 1720: @61630
     /* 61630 */ GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(61704),
     /* 61635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 61638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 61641 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(61672), // Rule ID 2144 //
     /* 61646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 61649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 61653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 61657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 61661 */     // (fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VADDPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 61661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDYrr),
     /* 61666 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61670 */     GIR_RootConstrainSelectedInstOperands,
     /* 61671 */     // GIR_Coverage, 2144,
     /* 61671 */     GIR_Done,
     /* 61672 */   // Label 1749: @61672
     /* 61672 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(61703), // Rule ID 6314 //
     /* 61677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 61680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 61684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 61688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 61692 */     // (fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VADDPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 61692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rr),
     /* 61697 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61701 */     GIR_RootConstrainSelectedInstOperands,
     /* 61702 */     // GIR_Coverage, 6314,
     /* 61702 */     GIR_Done,
     /* 61703 */   // Label 1750: @61703
     /* 61703 */   GIM_Reject,
     /* 61704 */ // Label 1748: @61704
     /* 61704 */ GIM_Reject,
     /* 61705 */ // Label 1721: @61705
     /* 61705 */ GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(61742), // Rule ID 6338 //
     /* 61710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 61713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 61716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 61719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61731 */   // (fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VADDPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 61731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rr),
     /* 61736 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61740 */   GIR_RootConstrainSelectedInstOperands,
     /* 61741 */   // GIR_Coverage, 6338,
     /* 61741 */   GIR_Done,
     /* 61742 */ // Label 1751: @61742
     /* 61742 */ GIM_Reject,
     /* 61743 */ // Label 1722: @61743
     /* 61743 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(61817),
     /* 61748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 61751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 61754 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(61785), // Rule ID 2140 //
     /* 61759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 61762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 61766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 61770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 61774 */     // (fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VADDPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 61774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSYrr),
     /* 61779 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61783 */     GIR_RootConstrainSelectedInstOperands,
     /* 61784 */     // GIR_Coverage, 2140,
     /* 61784 */     GIR_Done,
     /* 61785 */   // Label 1753: @61785
     /* 61785 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(61816), // Rule ID 6290 //
     /* 61790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 61793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 61797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 61801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 61805 */     // (fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VADDPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 61805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rr),
     /* 61810 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61814 */     GIR_RootConstrainSelectedInstOperands,
     /* 61815 */     // GIR_Coverage, 6290,
     /* 61815 */     GIR_Done,
     /* 61816 */   // Label 1754: @61816
     /* 61816 */   GIM_Reject,
     /* 61817 */ // Label 1752: @61817
     /* 61817 */ GIM_Reject,
     /* 61818 */ // Label 1723: @61818
     /* 61818 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(61855), // Rule ID 6266 //
     /* 61823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 61826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 61829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 61832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 61836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 61840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 61844 */   // (fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VADDPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 61844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZrr),
     /* 61849 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61853 */   GIR_RootConstrainSelectedInstOperands,
     /* 61854 */   // GIR_Coverage, 6266,
     /* 61854 */   GIR_Done,
     /* 61855 */ // Label 1755: @61855
     /* 61855 */ GIM_Reject,
     /* 61856 */ // Label 1724: @61856
     /* 61856 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(61893), // Rule ID 6350 //
     /* 61861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 61864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 61867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 61870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 61874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 61878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 61882 */   // (fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VADDPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 61882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rr),
     /* 61887 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61891 */   GIR_RootConstrainSelectedInstOperands,
     /* 61892 */   // GIR_Coverage, 6350,
     /* 61892 */   GIR_Done,
     /* 61893 */ // Label 1756: @61893
     /* 61893 */ GIM_Reject,
     /* 61894 */ // Label 1725: @61894
     /* 61894 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(61931), // Rule ID 6254 //
     /* 61899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 61902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 61905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 61908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 61912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 61916 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 61920 */   // (fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VADDPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 61920 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZrr),
     /* 61925 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61929 */   GIR_RootConstrainSelectedInstOperands,
     /* 61930 */   // GIR_Coverage, 6254,
     /* 61930 */   GIR_Done,
     /* 61931 */ // Label 1757: @61931
     /* 61931 */ GIM_Reject,
     /* 61932 */ // Label 1726: @61932
     /* 61932 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(61969), // Rule ID 6326 //
     /* 61937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 61940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 61943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 61946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 61950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 61954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 61958 */   // (fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VADDPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 61958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZrr),
     /* 61963 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61967 */   GIR_RootConstrainSelectedInstOperands,
     /* 61968 */   // GIR_Coverage, 6326,
     /* 61968 */   GIR_Done,
     /* 61969 */ // Label 1758: @61969
     /* 61969 */ GIM_Reject,
     /* 61970 */ // Label 1727: @61970
     /* 61970 */ GIM_Reject,
     /* 61971 */ // Label 35: @61971
     /* 61971 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1772*/ GIMT_Encode4(62986),
     /* 61982 */ /*GILLT_s16*//*Label 1759*/ GIMT_Encode4(62066),
     /* 61986 */ /*GILLT_s32*//*Label 1760*/ GIMT_Encode4(62104),
     /* 61990 */ /*GILLT_s64*//*Label 1761*/ GIMT_Encode4(62247),
     /* 61994 */ /*GILLT_s80*//*Label 1762*/ GIMT_Encode4(62390), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 62006 */ /*GILLT_v2s64*//*Label 1763*/ GIMT_Encode4(62434), GIMT_Encode4(0),
     /* 62014 */ /*GILLT_v4s32*//*Label 1764*/ GIMT_Encode4(62540),
     /* 62018 */ /*GILLT_v4s64*//*Label 1765*/ GIMT_Encode4(62646), GIMT_Encode4(0),
     /* 62026 */ /*GILLT_v8s16*//*Label 1766*/ GIMT_Encode4(62721),
     /* 62030 */ /*GILLT_v8s32*//*Label 1767*/ GIMT_Encode4(62759),
     /* 62034 */ /*GILLT_v8s64*//*Label 1768*/ GIMT_Encode4(62834), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 62046 */ /*GILLT_v16s16*//*Label 1769*/ GIMT_Encode4(62872),
     /* 62050 */ /*GILLT_v16s32*//*Label 1770*/ GIMT_Encode4(62910), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 62062 */ /*GILLT_v32s16*//*Label 1771*/ GIMT_Encode4(62948),
     /* 62066 */ // Label 1759: @62066
     /* 62066 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(62103), // Rule ID 6064 //
     /* 62071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 62074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 62077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 62080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 62084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 62088 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 62092 */   // (fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VSUBSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 62092 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrr),
     /* 62097 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62101 */   GIR_RootConstrainSelectedInstOperands,
     /* 62102 */   // GIR_Coverage, 6064,
     /* 62102 */   GIR_Done,
     /* 62103 */ // Label 1773: @62103
     /* 62103 */ GIM_Reject,
     /* 62104 */ // Label 1760: @62104
     /* 62104 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(62246),
     /* 62109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 62112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 62115 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(62152), // Rule ID 890 //
     /* 62120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 62123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 62127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 62131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 62135 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (SUB_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 62135 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32),
     /* 62140 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 62146 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 62150 */     GIR_RootConstrainSelectedInstOperands,
     /* 62151 */     // GIR_Coverage, 890,
     /* 62151 */     GIR_Done,
     /* 62152 */   // Label 1775: @62152
     /* 62152 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(62183), // Rule ID 2236 //
     /* 62157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 62160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 62164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 62168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 62172 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VSUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 62172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSrr),
     /* 62177 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62181 */     GIR_RootConstrainSelectedInstOperands,
     /* 62182 */     // GIR_Coverage, 2236,
     /* 62182 */     GIR_Done,
     /* 62183 */   // Label 1776: @62183
     /* 62183 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(62214), // Rule ID 2244 //
     /* 62188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 62191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 62195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 62199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 62203 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (SUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 62203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSSrr),
     /* 62208 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62212 */     GIR_RootConstrainSelectedInstOperands,
     /* 62213 */     // GIR_Coverage, 2244,
     /* 62213 */     GIR_Done,
     /* 62214 */   // Label 1777: @62214
     /* 62214 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(62245), // Rule ID 6026 //
     /* 62219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 62222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 62226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 62230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 62234 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VSUBSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 62234 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrr),
     /* 62239 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62243 */     GIR_RootConstrainSelectedInstOperands,
     /* 62244 */     // GIR_Coverage, 6026,
     /* 62244 */     GIR_Done,
     /* 62245 */   // Label 1778: @62245
     /* 62245 */   GIM_Reject,
     /* 62246 */ // Label 1774: @62246
     /* 62246 */ GIM_Reject,
     /* 62247 */ // Label 1761: @62247
     /* 62247 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(62389),
     /* 62252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 62255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 62258 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(62295), // Rule ID 892 //
     /* 62263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 62266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 62270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 62274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 62278 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (SUB_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 62278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64),
     /* 62283 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 62289 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 62293 */     GIR_RootConstrainSelectedInstOperands,
     /* 62294 */     // GIR_Coverage, 892,
     /* 62294 */     GIR_Done,
     /* 62295 */   // Label 1780: @62295
     /* 62295 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(62326), // Rule ID 2240 //
     /* 62300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 62303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 62307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 62311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 62315 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VSUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 62315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDrr),
     /* 62320 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62324 */     GIR_RootConstrainSelectedInstOperands,
     /* 62325 */     // GIR_Coverage, 2240,
     /* 62325 */     GIR_Done,
     /* 62326 */   // Label 1781: @62326
     /* 62326 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(62357), // Rule ID 2248 //
     /* 62331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 62334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 62338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 62342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 62346 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (SUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 62346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSDrr),
     /* 62351 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62355 */     GIR_RootConstrainSelectedInstOperands,
     /* 62356 */     // GIR_Coverage, 2248,
     /* 62356 */     GIR_Done,
     /* 62357 */   // Label 1782: @62357
     /* 62357 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(62388), // Rule ID 6045 //
     /* 62362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 62365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 62369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 62373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 62377 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VSUBSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 62377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrr),
     /* 62382 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62386 */     GIR_RootConstrainSelectedInstOperands,
     /* 62387 */     // GIR_Coverage, 6045,
     /* 62387 */     GIR_Done,
     /* 62388 */   // Label 1783: @62388
     /* 62388 */   GIM_Reject,
     /* 62389 */ // Label 1779: @62389
     /* 62389 */ GIM_Reject,
     /* 62390 */ // Label 1762: @62390
     /* 62390 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(62433), // Rule ID 894 //
     /* 62395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 62398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 62401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 62404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 62408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 62412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 62416 */   // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (SUB_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 62416 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80),
     /* 62421 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 62427 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 62431 */   GIR_RootConstrainSelectedInstOperands,
     /* 62432 */   // GIR_Coverage, 894,
     /* 62432 */   GIR_Done,
     /* 62433 */ // Label 1784: @62433
     /* 62433 */ GIM_Reject,
     /* 62434 */ // Label 1763: @62434
     /* 62434 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(62539),
     /* 62439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 62442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 62445 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(62476), // Rule ID 2216 //
     /* 62450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 62453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62465 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VSUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 62465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDrr),
     /* 62470 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62474 */     GIR_RootConstrainSelectedInstOperands,
     /* 62475 */     // GIR_Coverage, 2216,
     /* 62475 */     GIR_Done,
     /* 62476 */   // Label 1786: @62476
     /* 62476 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(62507), // Rule ID 2232 //
     /* 62481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 62484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62496 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (SUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 62496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPDrr),
     /* 62501 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62505 */     GIR_RootConstrainSelectedInstOperands,
     /* 62506 */     // GIR_Coverage, 2232,
     /* 62506 */     GIR_Done,
     /* 62507 */   // Label 1787: @62507
     /* 62507 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(62538), // Rule ID 6536 //
     /* 62512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 62515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 62519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 62523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 62527 */     // (fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VSUBPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 62527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rr),
     /* 62532 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62536 */     GIR_RootConstrainSelectedInstOperands,
     /* 62537 */     // GIR_Coverage, 6536,
     /* 62537 */     GIR_Done,
     /* 62538 */   // Label 1788: @62538
     /* 62538 */   GIM_Reject,
     /* 62539 */ // Label 1785: @62539
     /* 62539 */ GIM_Reject,
     /* 62540 */ // Label 1764: @62540
     /* 62540 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(62645),
     /* 62545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 62548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 62551 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(62582), // Rule ID 2212 //
     /* 62556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 62559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62571 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VSUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 62571 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSrr),
     /* 62576 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62580 */     GIR_RootConstrainSelectedInstOperands,
     /* 62581 */     // GIR_Coverage, 2212,
     /* 62581 */     GIR_Done,
     /* 62582 */   // Label 1790: @62582
     /* 62582 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(62613), // Rule ID 2228 //
     /* 62587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 62590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62602 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (SUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 62602 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPSrr),
     /* 62607 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62611 */     GIR_RootConstrainSelectedInstOperands,
     /* 62612 */     // GIR_Coverage, 2228,
     /* 62612 */     GIR_Done,
     /* 62613 */   // Label 1791: @62613
     /* 62613 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(62644), // Rule ID 6512 //
     /* 62618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 62621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 62625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 62629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 62633 */     // (fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VSUBPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 62633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rr),
     /* 62638 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62642 */     GIR_RootConstrainSelectedInstOperands,
     /* 62643 */     // GIR_Coverage, 6512,
     /* 62643 */     GIR_Done,
     /* 62644 */   // Label 1792: @62644
     /* 62644 */   GIM_Reject,
     /* 62645 */ // Label 1789: @62645
     /* 62645 */ GIM_Reject,
     /* 62646 */ // Label 1765: @62646
     /* 62646 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(62720),
     /* 62651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 62654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 62657 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(62688), // Rule ID 2224 //
     /* 62662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 62665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 62669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 62673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 62677 */     // (fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VSUBPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 62677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrr),
     /* 62682 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62686 */     GIR_RootConstrainSelectedInstOperands,
     /* 62687 */     // GIR_Coverage, 2224,
     /* 62687 */     GIR_Done,
     /* 62688 */   // Label 1794: @62688
     /* 62688 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(62719), // Rule ID 6548 //
     /* 62693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 62696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62708 */     // (fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VSUBPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 62708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rr),
     /* 62713 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62717 */     GIR_RootConstrainSelectedInstOperands,
     /* 62718 */     // GIR_Coverage, 6548,
     /* 62718 */     GIR_Done,
     /* 62719 */   // Label 1795: @62719
     /* 62719 */   GIM_Reject,
     /* 62720 */ // Label 1793: @62720
     /* 62720 */ GIM_Reject,
     /* 62721 */ // Label 1766: @62721
     /* 62721 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(62758), // Rule ID 6572 //
     /* 62726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 62729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 62732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 62735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 62739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 62743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 62747 */   // (fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VSUBPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 62747 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rr),
     /* 62752 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62756 */   GIR_RootConstrainSelectedInstOperands,
     /* 62757 */   // GIR_Coverage, 6572,
     /* 62757 */   GIR_Done,
     /* 62758 */ // Label 1796: @62758
     /* 62758 */ GIM_Reject,
     /* 62759 */ // Label 1767: @62759
     /* 62759 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(62833),
     /* 62764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 62767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 62770 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(62801), // Rule ID 2220 //
     /* 62775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 62778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 62782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 62786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 62790 */     // (fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VSUBPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 62790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrr),
     /* 62795 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62799 */     GIR_RootConstrainSelectedInstOperands,
     /* 62800 */     // GIR_Coverage, 2220,
     /* 62800 */     GIR_Done,
     /* 62801 */   // Label 1798: @62801
     /* 62801 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(62832), // Rule ID 6524 //
     /* 62806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 62809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62821 */     // (fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VSUBPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 62821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rr),
     /* 62826 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62830 */     GIR_RootConstrainSelectedInstOperands,
     /* 62831 */     // GIR_Coverage, 6524,
     /* 62831 */     GIR_Done,
     /* 62832 */   // Label 1799: @62832
     /* 62832 */   GIM_Reject,
     /* 62833 */ // Label 1797: @62833
     /* 62833 */ GIM_Reject,
     /* 62834 */ // Label 1768: @62834
     /* 62834 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(62871), // Rule ID 6500 //
     /* 62839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 62842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 62845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 62848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62860 */   // (fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VSUBPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 62860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrr),
     /* 62865 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62869 */   GIR_RootConstrainSelectedInstOperands,
     /* 62870 */   // GIR_Coverage, 6500,
     /* 62870 */   GIR_Done,
     /* 62871 */ // Label 1800: @62871
     /* 62871 */ GIM_Reject,
     /* 62872 */ // Label 1769: @62872
     /* 62872 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(62909), // Rule ID 6584 //
     /* 62877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 62880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 62883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 62886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62898 */   // (fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VSUBPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 62898 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rr),
     /* 62903 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62907 */   GIR_RootConstrainSelectedInstOperands,
     /* 62908 */   // GIR_Coverage, 6584,
     /* 62908 */   GIR_Done,
     /* 62909 */ // Label 1801: @62909
     /* 62909 */ GIM_Reject,
     /* 62910 */ // Label 1770: @62910
     /* 62910 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(62947), // Rule ID 6488 //
     /* 62915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 62918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 62921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 62924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62932 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62936 */   // (fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VSUBPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 62936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrr),
     /* 62941 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62945 */   GIR_RootConstrainSelectedInstOperands,
     /* 62946 */   // GIR_Coverage, 6488,
     /* 62946 */   GIR_Done,
     /* 62947 */ // Label 1802: @62947
     /* 62947 */ GIM_Reject,
     /* 62948 */ // Label 1771: @62948
     /* 62948 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(62985), // Rule ID 6560 //
     /* 62953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 62956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 62959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 62962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62974 */   // (fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VSUBPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 62974 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrr),
     /* 62979 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62983 */   GIR_RootConstrainSelectedInstOperands,
     /* 62984 */   // GIR_Coverage, 6560,
     /* 62984 */   GIR_Done,
     /* 62985 */ // Label 1803: @62985
     /* 62985 */ GIM_Reject,
     /* 62986 */ // Label 1772: @62986
     /* 62986 */ GIM_Reject,
     /* 62987 */ // Label 36: @62987
     /* 62987 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1817*/ GIMT_Encode4(64002),
     /* 62998 */ /*GILLT_s16*//*Label 1804*/ GIMT_Encode4(63082),
     /* 63002 */ /*GILLT_s32*//*Label 1805*/ GIMT_Encode4(63120),
     /* 63006 */ /*GILLT_s64*//*Label 1806*/ GIMT_Encode4(63263),
     /* 63010 */ /*GILLT_s80*//*Label 1807*/ GIMT_Encode4(63406), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 63022 */ /*GILLT_v2s64*//*Label 1808*/ GIMT_Encode4(63450), GIMT_Encode4(0),
     /* 63030 */ /*GILLT_v4s32*//*Label 1809*/ GIMT_Encode4(63556),
     /* 63034 */ /*GILLT_v4s64*//*Label 1810*/ GIMT_Encode4(63662), GIMT_Encode4(0),
     /* 63042 */ /*GILLT_v8s16*//*Label 1811*/ GIMT_Encode4(63737),
     /* 63046 */ /*GILLT_v8s32*//*Label 1812*/ GIMT_Encode4(63775),
     /* 63050 */ /*GILLT_v8s64*//*Label 1813*/ GIMT_Encode4(63850), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 63062 */ /*GILLT_v16s16*//*Label 1814*/ GIMT_Encode4(63888),
     /* 63066 */ /*GILLT_v16s32*//*Label 1815*/ GIMT_Encode4(63926), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 63078 */ /*GILLT_v32s16*//*Label 1816*/ GIMT_Encode4(63964),
     /* 63082 */ // Label 1804: @63082
     /* 63082 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(63119), // Rule ID 6007 //
     /* 63087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 63090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 63093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 63096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 63100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 63104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 63108 */   // (fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VMULSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 63108 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSHZrr),
     /* 63113 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63117 */   GIR_RootConstrainSelectedInstOperands,
     /* 63118 */   // GIR_Coverage, 6007,
     /* 63118 */   GIR_Done,
     /* 63119 */ // Label 1818: @63119
     /* 63119 */ GIM_Reject,
     /* 63120 */ // Label 1805: @63120
     /* 63120 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(63262),
     /* 63125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 63128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 63131 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(63168), // Rule ID 896 //
     /* 63136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 63139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 63143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 63147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 63151 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (MUL_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 63151 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32),
     /* 63156 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 63162 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 63166 */     GIR_RootConstrainSelectedInstOperands,
     /* 63167 */     // GIR_Coverage, 896,
     /* 63167 */     GIR_Done,
     /* 63168 */   // Label 1820: @63168
     /* 63168 */   GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(63199), // Rule ID 2196 //
     /* 63173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 63176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 63180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 63184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 63188 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VMULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 63188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSrr),
     /* 63193 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63197 */     GIR_RootConstrainSelectedInstOperands,
     /* 63198 */     // GIR_Coverage, 2196,
     /* 63198 */     GIR_Done,
     /* 63199 */   // Label 1821: @63199
     /* 63199 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(63230), // Rule ID 2204 //
     /* 63204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 63207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 63211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 63215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 63219 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (MULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 63219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSSrr),
     /* 63224 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63228 */     GIR_RootConstrainSelectedInstOperands,
     /* 63229 */     // GIR_Coverage, 2204,
     /* 63229 */     GIR_Done,
     /* 63230 */   // Label 1822: @63230
     /* 63230 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(63261), // Rule ID 5969 //
     /* 63235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 63238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 63242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 63246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 63250 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VMULSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 63250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSZrr),
     /* 63255 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63259 */     GIR_RootConstrainSelectedInstOperands,
     /* 63260 */     // GIR_Coverage, 5969,
     /* 63260 */     GIR_Done,
     /* 63261 */   // Label 1823: @63261
     /* 63261 */   GIM_Reject,
     /* 63262 */ // Label 1819: @63262
     /* 63262 */ GIM_Reject,
     /* 63263 */ // Label 1806: @63263
     /* 63263 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(63405),
     /* 63268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 63271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 63274 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(63311), // Rule ID 898 //
     /* 63279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 63282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 63286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 63290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 63294 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (MUL_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 63294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64),
     /* 63299 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 63305 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 63309 */     GIR_RootConstrainSelectedInstOperands,
     /* 63310 */     // GIR_Coverage, 898,
     /* 63310 */     GIR_Done,
     /* 63311 */   // Label 1825: @63311
     /* 63311 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(63342), // Rule ID 2200 //
     /* 63316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 63319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 63323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 63327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 63331 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VMULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 63331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDrr),
     /* 63336 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63340 */     GIR_RootConstrainSelectedInstOperands,
     /* 63341 */     // GIR_Coverage, 2200,
     /* 63341 */     GIR_Done,
     /* 63342 */   // Label 1826: @63342
     /* 63342 */   GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(63373), // Rule ID 2208 //
     /* 63347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 63350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 63354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 63358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 63362 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (MULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 63362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSDrr),
     /* 63367 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63371 */     GIR_RootConstrainSelectedInstOperands,
     /* 63372 */     // GIR_Coverage, 2208,
     /* 63372 */     GIR_Done,
     /* 63373 */   // Label 1827: @63373
     /* 63373 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(63404), // Rule ID 5988 //
     /* 63378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 63381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 63385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 63389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 63393 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VMULSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 63393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDZrr),
     /* 63398 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63402 */     GIR_RootConstrainSelectedInstOperands,
     /* 63403 */     // GIR_Coverage, 5988,
     /* 63403 */     GIR_Done,
     /* 63404 */   // Label 1828: @63404
     /* 63404 */   GIM_Reject,
     /* 63405 */ // Label 1824: @63405
     /* 63405 */ GIM_Reject,
     /* 63406 */ // Label 1807: @63406
     /* 63406 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(63449), // Rule ID 900 //
     /* 63411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 63414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 63417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 63420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 63424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 63428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 63432 */   // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (MUL_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 63432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80),
     /* 63437 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 63443 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 63447 */   GIR_RootConstrainSelectedInstOperands,
     /* 63448 */   // GIR_Coverage, 900,
     /* 63448 */   GIR_Done,
     /* 63449 */ // Label 1829: @63449
     /* 63449 */ GIM_Reject,
     /* 63450 */ // Label 1808: @63450
     /* 63450 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(63555),
     /* 63455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63461 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(63492), // Rule ID 2176 //
     /* 63466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 63469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63481 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 63481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDrr),
     /* 63486 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63490 */     GIR_RootConstrainSelectedInstOperands,
     /* 63491 */     // GIR_Coverage, 2176,
     /* 63491 */     GIR_Done,
     /* 63492 */   // Label 1831: @63492
     /* 63492 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(63523), // Rule ID 2192 //
     /* 63497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 63500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63512 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (MULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 63512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPDrr),
     /* 63517 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63521 */     GIR_RootConstrainSelectedInstOperands,
     /* 63522 */     // GIR_Coverage, 2192,
     /* 63522 */     GIR_Done,
     /* 63523 */   // Label 1832: @63523
     /* 63523 */   GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(63554), // Rule ID 6419 //
     /* 63528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 63531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63543 */     // (fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VMULPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 63543 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rr),
     /* 63548 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63552 */     GIR_RootConstrainSelectedInstOperands,
     /* 63553 */     // GIR_Coverage, 6419,
     /* 63553 */     GIR_Done,
     /* 63554 */   // Label 1833: @63554
     /* 63554 */   GIM_Reject,
     /* 63555 */ // Label 1830: @63555
     /* 63555 */ GIM_Reject,
     /* 63556 */ // Label 1809: @63556
     /* 63556 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(63661),
     /* 63561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63567 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(63598), // Rule ID 2172 //
     /* 63572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 63575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63587 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 63587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSrr),
     /* 63592 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63596 */     GIR_RootConstrainSelectedInstOperands,
     /* 63597 */     // GIR_Coverage, 2172,
     /* 63597 */     GIR_Done,
     /* 63598 */   // Label 1835: @63598
     /* 63598 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(63629), // Rule ID 2188 //
     /* 63603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 63606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63618 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (MULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 63618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPSrr),
     /* 63623 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63627 */     GIR_RootConstrainSelectedInstOperands,
     /* 63628 */     // GIR_Coverage, 2188,
     /* 63628 */     GIR_Done,
     /* 63629 */   // Label 1836: @63629
     /* 63629 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(63660), // Rule ID 6395 //
     /* 63634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 63637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63649 */     // (fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VMULPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 63649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rr),
     /* 63654 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63658 */     GIR_RootConstrainSelectedInstOperands,
     /* 63659 */     // GIR_Coverage, 6395,
     /* 63659 */     GIR_Done,
     /* 63660 */   // Label 1837: @63660
     /* 63660 */   GIM_Reject,
     /* 63661 */ // Label 1834: @63661
     /* 63661 */ GIM_Reject,
     /* 63662 */ // Label 1810: @63662
     /* 63662 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(63736),
     /* 63667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 63670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 63673 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(63704), // Rule ID 2184 //
     /* 63678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 63681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 63685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 63689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 63693 */     // (fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMULPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 63693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDYrr),
     /* 63698 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63702 */     GIR_RootConstrainSelectedInstOperands,
     /* 63703 */     // GIR_Coverage, 2184,
     /* 63703 */     GIR_Done,
     /* 63704 */   // Label 1839: @63704
     /* 63704 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(63735), // Rule ID 6431 //
     /* 63709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 63712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63724 */     // (fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VMULPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 63724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rr),
     /* 63729 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63733 */     GIR_RootConstrainSelectedInstOperands,
     /* 63734 */     // GIR_Coverage, 6431,
     /* 63734 */     GIR_Done,
     /* 63735 */   // Label 1840: @63735
     /* 63735 */   GIM_Reject,
     /* 63736 */ // Label 1838: @63736
     /* 63736 */ GIM_Reject,
     /* 63737 */ // Label 1811: @63737
     /* 63737 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(63774), // Rule ID 6455 //
     /* 63742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 63745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 63748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 63751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63763 */   // (fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VMULPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 63763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rr),
     /* 63768 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63772 */   GIR_RootConstrainSelectedInstOperands,
     /* 63773 */   // GIR_Coverage, 6455,
     /* 63773 */   GIR_Done,
     /* 63774 */ // Label 1841: @63774
     /* 63774 */ GIM_Reject,
     /* 63775 */ // Label 1812: @63775
     /* 63775 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(63849),
     /* 63780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 63783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 63786 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(63817), // Rule ID 2180 //
     /* 63791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 63794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 63798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 63802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 63806 */     // (fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMULPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 63806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSYrr),
     /* 63811 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63815 */     GIR_RootConstrainSelectedInstOperands,
     /* 63816 */     // GIR_Coverage, 2180,
     /* 63816 */     GIR_Done,
     /* 63817 */   // Label 1843: @63817
     /* 63817 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(63848), // Rule ID 6407 //
     /* 63822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 63825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63837 */     // (fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VMULPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 63837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rr),
     /* 63842 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63846 */     GIR_RootConstrainSelectedInstOperands,
     /* 63847 */     // GIR_Coverage, 6407,
     /* 63847 */     GIR_Done,
     /* 63848 */   // Label 1844: @63848
     /* 63848 */   GIM_Reject,
     /* 63849 */ // Label 1842: @63849
     /* 63849 */ GIM_Reject,
     /* 63850 */ // Label 1813: @63850
     /* 63850 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(63887), // Rule ID 6383 //
     /* 63855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 63858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 63861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 63864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63876 */   // (fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VMULPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 63876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZrr),
     /* 63881 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63885 */   GIR_RootConstrainSelectedInstOperands,
     /* 63886 */   // GIR_Coverage, 6383,
     /* 63886 */   GIR_Done,
     /* 63887 */ // Label 1845: @63887
     /* 63887 */ GIM_Reject,
     /* 63888 */ // Label 1814: @63888
     /* 63888 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(63925), // Rule ID 6467 //
     /* 63893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 63896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 63899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 63902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63914 */   // (fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VMULPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 63914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rr),
     /* 63919 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63923 */   GIR_RootConstrainSelectedInstOperands,
     /* 63924 */   // GIR_Coverage, 6467,
     /* 63924 */   GIR_Done,
     /* 63925 */ // Label 1846: @63925
     /* 63925 */ GIM_Reject,
     /* 63926 */ // Label 1815: @63926
     /* 63926 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(63963), // Rule ID 6371 //
     /* 63931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 63934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 63937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 63940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63952 */   // (fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VMULPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 63952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZrr),
     /* 63957 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63961 */   GIR_RootConstrainSelectedInstOperands,
     /* 63962 */   // GIR_Coverage, 6371,
     /* 63962 */   GIR_Done,
     /* 63963 */ // Label 1847: @63963
     /* 63963 */ GIM_Reject,
     /* 63964 */ // Label 1816: @63964
     /* 63964 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(64001), // Rule ID 6443 //
     /* 63969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 63972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 63975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 63978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63986 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63990 */   // (fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VMULPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 63990 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZrr),
     /* 63995 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63999 */   GIR_RootConstrainSelectedInstOperands,
     /* 64000 */   // GIR_Coverage, 6443,
     /* 64000 */   GIR_Done,
     /* 64001 */ // Label 1848: @64001
     /* 64001 */ GIM_Reject,
     /* 64002 */ // Label 1817: @64002
     /* 64002 */ GIM_Reject,
     /* 64003 */ // Label 37: @64003
     /* 64003 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1861*/ GIMT_Encode4(65130),
     /* 64014 */ /*GILLT_s16*//*Label 1849*/ GIMT_Encode4(64098),
     /* 64018 */ /*GILLT_s32*//*Label 1850*/ GIMT_Encode4(64145),
     /* 64022 */ /*GILLT_s64*//*Label 1851*/ GIMT_Encode4(64270), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 64038 */ /*GILLT_v2s64*//*Label 1852*/ GIMT_Encode4(64395), GIMT_Encode4(0),
     /* 64046 */ /*GILLT_v4s32*//*Label 1853*/ GIMT_Encode4(64520),
     /* 64050 */ /*GILLT_v4s64*//*Label 1854*/ GIMT_Encode4(64645), GIMT_Encode4(0),
     /* 64058 */ /*GILLT_v8s16*//*Label 1855*/ GIMT_Encode4(64770),
     /* 64062 */ /*GILLT_v8s32*//*Label 1856*/ GIMT_Encode4(64817),
     /* 64066 */ /*GILLT_v8s64*//*Label 1857*/ GIMT_Encode4(64942), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 64078 */ /*GILLT_v16s16*//*Label 1858*/ GIMT_Encode4(64989),
     /* 64082 */ /*GILLT_v16s32*//*Label 1859*/ GIMT_Encode4(65036), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 64094 */ /*GILLT_v32s16*//*Label 1860*/ GIMT_Encode4(65083),
     /* 64098 */ // Label 1849: @64098
     /* 64098 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(64144), // Rule ID 10148 //
     /* 64103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 64106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 64109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 64112 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 64115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 64119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 64123 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 64127 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 64131 */   // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src3)  =>  (VFMADD213SHZr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src3)
     /* 64131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZr),
     /* 64134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64136 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64138 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64140 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64142 */   GIR_RootConstrainSelectedInstOperands,
     /* 64143 */   // GIR_Coverage, 10148,
     /* 64143 */   GIR_EraseRootFromParent_Done,
     /* 64144 */ // Label 1862: @64144
     /* 64144 */ GIM_Reject,
     /* 64145 */ // Label 1850: @64145
     /* 64145 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(64269),
     /* 64150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 64153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 64156 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 64159 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(64196), // Rule ID 1295 //
     /* 64164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 64167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 64171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 64175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 64179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 64183 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADD213SSr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 64183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSr),
     /* 64186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64188 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64190 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64192 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64194 */     GIR_RootConstrainSelectedInstOperands,
     /* 64195 */     // GIR_Coverage, 1295,
     /* 64195 */     GIR_EraseRootFromParent_Done,
     /* 64196 */   // Label 1864: @64196
     /* 64196 */   GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(64231), // Rule ID 1359 //
     /* 64201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 64204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 64208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 64212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 64216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 64220 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4rr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 64220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rr),
     /* 64225 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64229 */     GIR_RootConstrainSelectedInstOperands,
     /* 64230 */     // GIR_Coverage, 1359,
     /* 64230 */     GIR_Done,
     /* 64231 */   // Label 1865: @64231
     /* 64231 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(64268), // Rule ID 10130 //
     /* 64236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 64239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 64243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 64247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 64251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 64255 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src3)  =>  (VFMADD213SSZr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src3)
     /* 64255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZr),
     /* 64258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64260 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64262 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64264 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64266 */     GIR_RootConstrainSelectedInstOperands,
     /* 64267 */     // GIR_Coverage, 10130,
     /* 64267 */     GIR_EraseRootFromParent_Done,
     /* 64268 */   // Label 1866: @64268
     /* 64268 */   GIM_Reject,
     /* 64269 */ // Label 1863: @64269
     /* 64269 */ GIM_Reject,
     /* 64270 */ // Label 1851: @64270
     /* 64270 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(64394),
     /* 64275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 64278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 64281 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 64284 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(64321), // Rule ID 1303 //
     /* 64289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 64292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 64296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 64300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 64304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 64308 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADD213SDr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 64308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDr),
     /* 64311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64313 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64315 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64317 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64319 */     GIR_RootConstrainSelectedInstOperands,
     /* 64320 */     // GIR_Coverage, 1303,
     /* 64320 */     GIR_EraseRootFromParent_Done,
     /* 64321 */   // Label 1868: @64321
     /* 64321 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(64356), // Rule ID 1443 //
     /* 64326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 64329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 64333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 64337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 64341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 64345 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4rr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 64345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rr),
     /* 64350 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64354 */     GIR_RootConstrainSelectedInstOperands,
     /* 64355 */     // GIR_Coverage, 1443,
     /* 64355 */     GIR_Done,
     /* 64356 */   // Label 1869: @64356
     /* 64356 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(64393), // Rule ID 10139 //
     /* 64361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 64364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 64368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 64372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 64376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 64380 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src3)  =>  (VFMADD213SDZr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src3)
     /* 64380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZr),
     /* 64383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64385 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64387 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64389 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64391 */     GIR_RootConstrainSelectedInstOperands,
     /* 64392 */     // GIR_Coverage, 10139,
     /* 64392 */     GIR_EraseRootFromParent_Done,
     /* 64393 */   // Label 1870: @64393
     /* 64393 */   GIM_Reject,
     /* 64394 */ // Label 1867: @64394
     /* 64394 */ GIM_Reject,
     /* 64395 */ // Label 1852: @64395
     /* 64395 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(64519),
     /* 64400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 64403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 64406 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 64409 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(64446), // Rule ID 1183 //
     /* 64414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 64417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64433 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 64433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDr),
     /* 64436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64438 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64440 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64442 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64444 */     GIR_RootConstrainSelectedInstOperands,
     /* 64445 */     // GIR_Coverage, 1183,
     /* 64445 */     GIR_EraseRootFromParent_Done,
     /* 64446 */   // Label 1872: @64446
     /* 64446 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(64481), // Rule ID 1467 //
     /* 64451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 64454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64470 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4rr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 64470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rr),
     /* 64475 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64479 */     GIR_RootConstrainSelectedInstOperands,
     /* 64480 */     // GIR_Coverage, 1467,
     /* 64480 */     GIR_Done,
     /* 64481 */   // Label 1873: @64481
     /* 64481 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(64518), // Rule ID 8507 //
     /* 64486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 64489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64505 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src3)
     /* 64505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128r),
     /* 64508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64510 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64512 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64514 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64516 */     GIR_RootConstrainSelectedInstOperands,
     /* 64517 */     // GIR_Coverage, 8507,
     /* 64517 */     GIR_EraseRootFromParent_Done,
     /* 64518 */   // Label 1874: @64518
     /* 64518 */   GIM_Reject,
     /* 64519 */ // Label 1871: @64519
     /* 64519 */ GIM_Reject,
     /* 64520 */ // Label 1853: @64520
     /* 64520 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(64644),
     /* 64525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 64528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 64531 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 64534 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(64571), // Rule ID 1135 //
     /* 64539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 64542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64558 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 64558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSr),
     /* 64561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64563 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64565 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64567 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64569 */     GIR_RootConstrainSelectedInstOperands,
     /* 64570 */     // GIR_Coverage, 1135,
     /* 64570 */     GIR_EraseRootFromParent_Done,
     /* 64571 */   // Label 1876: @64571
     /* 64571 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(64606), // Rule ID 1383 //
     /* 64576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 64579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64595 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4rr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 64595 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rr),
     /* 64600 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64604 */     GIR_RootConstrainSelectedInstOperands,
     /* 64605 */     // GIR_Coverage, 1383,
     /* 64605 */     GIR_Done,
     /* 64606 */   // Label 1877: @64606
     /* 64606 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(64643), // Rule ID 8468 //
     /* 64611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 64614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64630 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src3)
     /* 64630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128r),
     /* 64633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64635 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64637 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64639 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64641 */     GIR_RootConstrainSelectedInstOperands,
     /* 64642 */     // GIR_Coverage, 8468,
     /* 64642 */     GIR_EraseRootFromParent_Done,
     /* 64643 */   // Label 1878: @64643
     /* 64643 */   GIM_Reject,
     /* 64644 */ // Label 1875: @64644
     /* 64644 */ GIM_Reject,
     /* 64645 */ // Label 1854: @64645
     /* 64645 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(64769),
     /* 64650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 64653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 64656 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 64659 */   GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(64696), // Rule ID 1191 //
     /* 64664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 64667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64683 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 64683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYr),
     /* 64686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64688 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64690 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64692 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64694 */     GIR_RootConstrainSelectedInstOperands,
     /* 64695 */     // GIR_Coverage, 1191,
     /* 64695 */     GIR_EraseRootFromParent_Done,
     /* 64696 */   // Label 1880: @64696
     /* 64696 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(64731), // Rule ID 1473 //
     /* 64701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 64704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64720 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Yrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 64720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrr),
     /* 64725 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64729 */     GIR_RootConstrainSelectedInstOperands,
     /* 64730 */     // GIR_Coverage, 1473,
     /* 64730 */     GIR_Done,
     /* 64731 */   // Label 1881: @64731
     /* 64731 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(64768), // Rule ID 8495 //
     /* 64736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 64739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64755 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src3)
     /* 64755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256r),
     /* 64758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64760 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64762 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64764 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64766 */     GIR_RootConstrainSelectedInstOperands,
     /* 64767 */     // GIR_Coverage, 8495,
     /* 64767 */     GIR_EraseRootFromParent_Done,
     /* 64768 */   // Label 1882: @64768
     /* 64768 */   GIM_Reject,
     /* 64769 */ // Label 1879: @64769
     /* 64769 */ GIM_Reject,
     /* 64770 */ // Label 1855: @64770
     /* 64770 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(64816), // Rule ID 8429 //
     /* 64775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 64778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 64781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 64784 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 64787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64795 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64799 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64803 */   // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src3)  =>  (VFMADD213PHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src3)
     /* 64803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128r),
     /* 64806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64808 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64810 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64812 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64814 */   GIR_RootConstrainSelectedInstOperands,
     /* 64815 */   // GIR_Coverage, 8429,
     /* 64815 */   GIR_EraseRootFromParent_Done,
     /* 64816 */ // Label 1883: @64816
     /* 64816 */ GIM_Reject,
     /* 64817 */ // Label 1856: @64817
     /* 64817 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(64941),
     /* 64822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 64825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 64828 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 64831 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(64868), // Rule ID 1143 //
     /* 64836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 64839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64855 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 64855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYr),
     /* 64858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64860 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64862 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64864 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64866 */     GIR_RootConstrainSelectedInstOperands,
     /* 64867 */     // GIR_Coverage, 1143,
     /* 64867 */     GIR_EraseRootFromParent_Done,
     /* 64868 */   // Label 1885: @64868
     /* 64868 */   GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(64903), // Rule ID 1389 //
     /* 64873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 64876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64892 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Yrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 64892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrr),
     /* 64897 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64901 */     GIR_RootConstrainSelectedInstOperands,
     /* 64902 */     // GIR_Coverage, 1389,
     /* 64902 */     GIR_Done,
     /* 64903 */   // Label 1886: @64903
     /* 64903 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(64940), // Rule ID 8456 //
     /* 64908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 64911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64927 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src3)
     /* 64927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256r),
     /* 64930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64932 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64934 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64936 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64938 */     GIR_RootConstrainSelectedInstOperands,
     /* 64939 */     // GIR_Coverage, 8456,
     /* 64939 */     GIR_EraseRootFromParent_Done,
     /* 64940 */   // Label 1887: @64940
     /* 64940 */   GIM_Reject,
     /* 64941 */ // Label 1884: @64941
     /* 64941 */ GIM_Reject,
     /* 64942 */ // Label 1857: @64942
     /* 64942 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(64988), // Rule ID 8480 //
     /* 64947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 64950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 64953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 64956 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 64959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 64963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 64967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 64971 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 64975 */   // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src3)  =>  (VFMADD213PDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src3)
     /* 64975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZr),
     /* 64978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64980 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64982 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64984 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64986 */   GIR_RootConstrainSelectedInstOperands,
     /* 64987 */   // GIR_Coverage, 8480,
     /* 64987 */   GIR_EraseRootFromParent_Done,
     /* 64988 */ // Label 1888: @64988
     /* 64988 */ GIM_Reject,
     /* 64989 */ // Label 1858: @64989
     /* 64989 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(65035), // Rule ID 8417 //
     /* 64994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 64997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 65000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 65003 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 65006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65018 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65022 */   // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src3)  =>  (VFMADD213PHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src3)
     /* 65022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256r),
     /* 65025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 65027 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 65029 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 65031 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 65033 */   GIR_RootConstrainSelectedInstOperands,
     /* 65034 */   // GIR_Coverage, 8417,
     /* 65034 */   GIR_EraseRootFromParent_Done,
     /* 65035 */ // Label 1889: @65035
     /* 65035 */ GIM_Reject,
     /* 65036 */ // Label 1859: @65036
     /* 65036 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(65082), // Rule ID 8441 //
     /* 65041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 65044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 65047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 65050 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 65053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65061 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65065 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65069 */   // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src3)  =>  (VFMADD213PSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src3)
     /* 65069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZr),
     /* 65072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 65074 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 65076 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 65078 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 65080 */   GIR_RootConstrainSelectedInstOperands,
     /* 65081 */   // GIR_Coverage, 8441,
     /* 65081 */   GIR_EraseRootFromParent_Done,
     /* 65082 */ // Label 1890: @65082
     /* 65082 */ GIM_Reject,
     /* 65083 */ // Label 1860: @65083
     /* 65083 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(65129), // Rule ID 8402 //
     /* 65088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 65091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 65094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 65097 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 65100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65112 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65116 */   // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src3)  =>  (VFMADD213PHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src3)
     /* 65116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZr),
     /* 65119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 65121 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 65123 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 65125 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 65127 */   GIR_RootConstrainSelectedInstOperands,
     /* 65128 */   // GIR_Coverage, 8402,
     /* 65128 */   GIR_EraseRootFromParent_Done,
     /* 65129 */ // Label 1891: @65129
     /* 65129 */ GIM_Reject,
     /* 65130 */ // Label 1861: @65130
     /* 65130 */ GIM_Reject,
     /* 65131 */ // Label 38: @65131
     /* 65131 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1905*/ GIMT_Encode4(66146),
     /* 65142 */ /*GILLT_s16*//*Label 1892*/ GIMT_Encode4(65226),
     /* 65146 */ /*GILLT_s32*//*Label 1893*/ GIMT_Encode4(65264),
     /* 65150 */ /*GILLT_s64*//*Label 1894*/ GIMT_Encode4(65407),
     /* 65154 */ /*GILLT_s80*//*Label 1895*/ GIMT_Encode4(65550), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 65166 */ /*GILLT_v2s64*//*Label 1896*/ GIMT_Encode4(65594), GIMT_Encode4(0),
     /* 65174 */ /*GILLT_v4s32*//*Label 1897*/ GIMT_Encode4(65700),
     /* 65178 */ /*GILLT_v4s64*//*Label 1898*/ GIMT_Encode4(65806), GIMT_Encode4(0),
     /* 65186 */ /*GILLT_v8s16*//*Label 1899*/ GIMT_Encode4(65881),
     /* 65190 */ /*GILLT_v8s32*//*Label 1900*/ GIMT_Encode4(65919),
     /* 65194 */ /*GILLT_v8s64*//*Label 1901*/ GIMT_Encode4(65994), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 65206 */ /*GILLT_v16s16*//*Label 1902*/ GIMT_Encode4(66032),
     /* 65210 */ /*GILLT_v16s32*//*Label 1903*/ GIMT_Encode4(66070), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 65222 */ /*GILLT_v32s16*//*Label 1904*/ GIMT_Encode4(66108),
     /* 65226 */ // Label 1892: @65226
     /* 65226 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(65263), // Rule ID 6121 //
     /* 65231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 65234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 65237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 65240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 65244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 65248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 65252 */   // (fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VDIVSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 65252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrr),
     /* 65257 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65261 */   GIR_RootConstrainSelectedInstOperands,
     /* 65262 */   // GIR_Coverage, 6121,
     /* 65262 */   GIR_Done,
     /* 65263 */ // Label 1906: @65263
     /* 65263 */ GIM_Reject,
     /* 65264 */ // Label 1893: @65264
     /* 65264 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(65406),
     /* 65269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 65275 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(65312), // Rule ID 902 //
     /* 65280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 65283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 65287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 65291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 65295 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (DIV_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 65295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32),
     /* 65300 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 65306 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 65310 */     GIR_RootConstrainSelectedInstOperands,
     /* 65311 */     // GIR_Coverage, 902,
     /* 65311 */     GIR_Done,
     /* 65312 */   // Label 1908: @65312
     /* 65312 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(65343), // Rule ID 2276 //
     /* 65317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 65320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 65324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 65328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 65332 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VDIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 65332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSrr),
     /* 65337 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65341 */     GIR_RootConstrainSelectedInstOperands,
     /* 65342 */     // GIR_Coverage, 2276,
     /* 65342 */     GIR_Done,
     /* 65343 */   // Label 1909: @65343
     /* 65343 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(65374), // Rule ID 2284 //
     /* 65348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 65351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 65355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 65359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 65363 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (DIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 65363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSSrr),
     /* 65368 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65372 */     GIR_RootConstrainSelectedInstOperands,
     /* 65373 */     // GIR_Coverage, 2284,
     /* 65373 */     GIR_Done,
     /* 65374 */   // Label 1910: @65374
     /* 65374 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(65405), // Rule ID 6083 //
     /* 65379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 65382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 65386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 65390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 65394 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VDIVSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 65394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrr),
     /* 65399 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65403 */     GIR_RootConstrainSelectedInstOperands,
     /* 65404 */     // GIR_Coverage, 6083,
     /* 65404 */     GIR_Done,
     /* 65405 */   // Label 1911: @65405
     /* 65405 */   GIM_Reject,
     /* 65406 */ // Label 1907: @65406
     /* 65406 */ GIM_Reject,
     /* 65407 */ // Label 1894: @65407
     /* 65407 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(65549),
     /* 65412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 65415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 65418 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(65455), // Rule ID 904 //
     /* 65423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 65426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 65430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 65434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 65438 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (DIV_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 65438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64),
     /* 65443 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 65449 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 65453 */     GIR_RootConstrainSelectedInstOperands,
     /* 65454 */     // GIR_Coverage, 904,
     /* 65454 */     GIR_Done,
     /* 65455 */   // Label 1913: @65455
     /* 65455 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(65486), // Rule ID 2280 //
     /* 65460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 65463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 65467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 65471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 65475 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VDIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 65475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDrr),
     /* 65480 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65484 */     GIR_RootConstrainSelectedInstOperands,
     /* 65485 */     // GIR_Coverage, 2280,
     /* 65485 */     GIR_Done,
     /* 65486 */   // Label 1914: @65486
     /* 65486 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(65517), // Rule ID 2288 //
     /* 65491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 65494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 65498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 65502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 65506 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (DIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 65506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSDrr),
     /* 65511 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65515 */     GIR_RootConstrainSelectedInstOperands,
     /* 65516 */     // GIR_Coverage, 2288,
     /* 65516 */     GIR_Done,
     /* 65517 */   // Label 1915: @65517
     /* 65517 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(65548), // Rule ID 6102 //
     /* 65522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 65525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 65529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 65533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 65537 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VDIVSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 65537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrr),
     /* 65542 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65546 */     GIR_RootConstrainSelectedInstOperands,
     /* 65547 */     // GIR_Coverage, 6102,
     /* 65547 */     GIR_Done,
     /* 65548 */   // Label 1916: @65548
     /* 65548 */   GIM_Reject,
     /* 65549 */ // Label 1912: @65549
     /* 65549 */ GIM_Reject,
     /* 65550 */ // Label 1895: @65550
     /* 65550 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(65593), // Rule ID 906 //
     /* 65555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 65558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 65561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 65564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 65568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 65572 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 65576 */   // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (DIV_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 65576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80),
     /* 65581 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 65587 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 65591 */   GIR_RootConstrainSelectedInstOperands,
     /* 65592 */   // GIR_Coverage, 906,
     /* 65592 */   GIR_Done,
     /* 65593 */ // Label 1917: @65593
     /* 65593 */ GIM_Reject,
     /* 65594 */ // Label 1896: @65594
     /* 65594 */ GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(65699),
     /* 65599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 65602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 65605 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(65636), // Rule ID 2256 //
     /* 65610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 65613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 65617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 65621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 65625 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VDIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 65625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDrr),
     /* 65630 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65634 */     GIR_RootConstrainSelectedInstOperands,
     /* 65635 */     // GIR_Coverage, 2256,
     /* 65635 */     GIR_Done,
     /* 65636 */   // Label 1919: @65636
     /* 65636 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(65667), // Rule ID 2272 //
     /* 65641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 65644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 65648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 65652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 65656 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (DIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 65656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPDrr),
     /* 65661 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65665 */     GIR_RootConstrainSelectedInstOperands,
     /* 65666 */     // GIR_Coverage, 2272,
     /* 65666 */     GIR_Done,
     /* 65667 */   // Label 1920: @65667
     /* 65667 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(65698), // Rule ID 6653 //
     /* 65672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 65675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 65679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 65683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 65687 */     // (fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VDIVPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 65687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rr),
     /* 65692 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65696 */     GIR_RootConstrainSelectedInstOperands,
     /* 65697 */     // GIR_Coverage, 6653,
     /* 65697 */     GIR_Done,
     /* 65698 */   // Label 1921: @65698
     /* 65698 */   GIM_Reject,
     /* 65699 */ // Label 1918: @65699
     /* 65699 */ GIM_Reject,
     /* 65700 */ // Label 1897: @65700
     /* 65700 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(65805),
     /* 65705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 65708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 65711 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(65742), // Rule ID 2252 //
     /* 65716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 65719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 65723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 65727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 65731 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VDIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 65731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSrr),
     /* 65736 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65740 */     GIR_RootConstrainSelectedInstOperands,
     /* 65741 */     // GIR_Coverage, 2252,
     /* 65741 */     GIR_Done,
     /* 65742 */   // Label 1923: @65742
     /* 65742 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(65773), // Rule ID 2268 //
     /* 65747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 65750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 65754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 65758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 65762 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (DIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 65762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPSrr),
     /* 65767 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65771 */     GIR_RootConstrainSelectedInstOperands,
     /* 65772 */     // GIR_Coverage, 2268,
     /* 65772 */     GIR_Done,
     /* 65773 */   // Label 1924: @65773
     /* 65773 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(65804), // Rule ID 6629 //
     /* 65778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 65781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 65785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 65789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 65793 */     // (fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VDIVPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 65793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rr),
     /* 65798 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65802 */     GIR_RootConstrainSelectedInstOperands,
     /* 65803 */     // GIR_Coverage, 6629,
     /* 65803 */     GIR_Done,
     /* 65804 */   // Label 1925: @65804
     /* 65804 */   GIM_Reject,
     /* 65805 */ // Label 1922: @65805
     /* 65805 */ GIM_Reject,
     /* 65806 */ // Label 1898: @65806
     /* 65806 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(65880),
     /* 65811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 65814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 65817 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(65848), // Rule ID 2264 //
     /* 65822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 65825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65837 */     // (fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VDIVPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 65837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrr),
     /* 65842 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65846 */     GIR_RootConstrainSelectedInstOperands,
     /* 65847 */     // GIR_Coverage, 2264,
     /* 65847 */     GIR_Done,
     /* 65848 */   // Label 1927: @65848
     /* 65848 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(65879), // Rule ID 6665 //
     /* 65853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 65856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65868 */     // (fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VDIVPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 65868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rr),
     /* 65873 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65877 */     GIR_RootConstrainSelectedInstOperands,
     /* 65878 */     // GIR_Coverage, 6665,
     /* 65878 */     GIR_Done,
     /* 65879 */   // Label 1928: @65879
     /* 65879 */   GIM_Reject,
     /* 65880 */ // Label 1926: @65880
     /* 65880 */ GIM_Reject,
     /* 65881 */ // Label 1899: @65881
     /* 65881 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(65918), // Rule ID 6689 //
     /* 65886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 65889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 65892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 65895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 65899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 65903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 65907 */   // (fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VDIVPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 65907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rr),
     /* 65912 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65916 */   GIR_RootConstrainSelectedInstOperands,
     /* 65917 */   // GIR_Coverage, 6689,
     /* 65917 */   GIR_Done,
     /* 65918 */ // Label 1929: @65918
     /* 65918 */ GIM_Reject,
     /* 65919 */ // Label 1900: @65919
     /* 65919 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(65993),
     /* 65924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 65927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 65930 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(65961), // Rule ID 2260 //
     /* 65935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 65938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65950 */     // (fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VDIVPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 65950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrr),
     /* 65955 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65959 */     GIR_RootConstrainSelectedInstOperands,
     /* 65960 */     // GIR_Coverage, 2260,
     /* 65960 */     GIR_Done,
     /* 65961 */   // Label 1931: @65961
     /* 65961 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(65992), // Rule ID 6641 //
     /* 65966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 65969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65981 */     // (fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VDIVPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 65981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rr),
     /* 65986 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65990 */     GIR_RootConstrainSelectedInstOperands,
     /* 65991 */     // GIR_Coverage, 6641,
     /* 65991 */     GIR_Done,
     /* 65992 */   // Label 1932: @65992
     /* 65992 */   GIM_Reject,
     /* 65993 */ // Label 1930: @65993
     /* 65993 */ GIM_Reject,
     /* 65994 */ // Label 1901: @65994
     /* 65994 */ GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(66031), // Rule ID 6617 //
     /* 65999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 66002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 66005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 66008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66020 */   // (fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VDIVPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 66020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrr),
     /* 66025 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66029 */   GIR_RootConstrainSelectedInstOperands,
     /* 66030 */   // GIR_Coverage, 6617,
     /* 66030 */   GIR_Done,
     /* 66031 */ // Label 1933: @66031
     /* 66031 */ GIM_Reject,
     /* 66032 */ // Label 1902: @66032
     /* 66032 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(66069), // Rule ID 6701 //
     /* 66037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 66040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 66043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 66046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 66050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 66054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 66058 */   // (fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VDIVPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 66058 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rr),
     /* 66063 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66067 */   GIR_RootConstrainSelectedInstOperands,
     /* 66068 */   // GIR_Coverage, 6701,
     /* 66068 */   GIR_Done,
     /* 66069 */ // Label 1934: @66069
     /* 66069 */ GIM_Reject,
     /* 66070 */ // Label 1903: @66070
     /* 66070 */ GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(66107), // Rule ID 6605 //
     /* 66075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 66078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 66081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 66084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66096 */   // (fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VDIVPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 66096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrr),
     /* 66101 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66105 */   GIR_RootConstrainSelectedInstOperands,
     /* 66106 */   // GIR_Coverage, 6605,
     /* 66106 */   GIR_Done,
     /* 66107 */ // Label 1935: @66107
     /* 66107 */ GIM_Reject,
     /* 66108 */ // Label 1904: @66108
     /* 66108 */ GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(66145), // Rule ID 6677 //
     /* 66113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 66116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 66119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 66122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66134 */   // (fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VDIVPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 66134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrr),
     /* 66139 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66143 */   GIR_RootConstrainSelectedInstOperands,
     /* 66144 */   // GIR_Coverage, 6677,
     /* 66144 */   GIR_Done,
     /* 66145 */ // Label 1936: @66145
     /* 66145 */ GIM_Reject,
     /* 66146 */ // Label 1905: @66146
     /* 66146 */ GIM_Reject,
     /* 66147 */ // Label 39: @66147
     /* 66147 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 1940*/ GIMT_Encode4(66269),
     /* 66158 */ /*GILLT_s32*//*Label 1937*/ GIMT_Encode4(66170),
     /* 66162 */ /*GILLT_s64*//*Label 1938*/ GIMT_Encode4(66203),
     /* 66166 */ /*GILLT_s80*//*Label 1939*/ GIMT_Encode4(66236),
     /* 66170 */ // Label 1937: @66170
     /* 66170 */ GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(66202), // Rule ID 1039 //
     /* 66175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 66178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 66185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 66189 */   // (fneg:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 66189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 66194 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 66200 */   GIR_RootConstrainSelectedInstOperands,
     /* 66201 */   // GIR_Coverage, 1039,
     /* 66201 */   GIR_Done,
     /* 66202 */ // Label 1941: @66202
     /* 66202 */ GIM_Reject,
     /* 66203 */ // Label 1938: @66203
     /* 66203 */ GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(66235), // Rule ID 1040 //
     /* 66208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 66211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 66218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 66222 */   // (fneg:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 66222 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 66227 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 66233 */   GIR_RootConstrainSelectedInstOperands,
     /* 66234 */   // GIR_Coverage, 1040,
     /* 66234 */   GIR_Done,
     /* 66235 */ // Label 1942: @66235
     /* 66235 */ GIM_Reject,
     /* 66236 */ // Label 1939: @66236
     /* 66236 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(66268), // Rule ID 1041 //
     /* 66241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 66244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 66247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 66251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 66255 */   // (fneg:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 66255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 66260 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 66266 */   GIR_RootConstrainSelectedInstOperands,
     /* 66267 */   // GIR_Coverage, 1041,
     /* 66267 */   GIR_Done,
     /* 66268 */ // Label 1943: @66268
     /* 66268 */ GIM_Reject,
     /* 66269 */ // Label 1940: @66269
     /* 66269 */ GIM_Reject,
     /* 66270 */ // Label 40: @66270
     /* 66270 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(20), /*)*//*default:*//*Label 1951*/ GIMT_Encode4(66839),
     /* 66281 */ /*GILLT_s32*//*Label 1944*/ GIMT_Encode4(66349),
     /* 66285 */ /*GILLT_s64*//*Label 1945*/ GIMT_Encode4(66395),
     /* 66289 */ /*GILLT_s80*//*Label 1946*/ GIMT_Encode4(66591), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 66313 */ /*GILLT_v4s64*//*Label 1947*/ GIMT_Encode4(66652), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 66325 */ /*GILLT_v8s32*//*Label 1948*/ GIMT_Encode4(66716),
     /* 66329 */ /*GILLT_v8s64*//*Label 1949*/ GIMT_Encode4(66747), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 66345 */ /*GILLT_v16s32*//*Label 1950*/ GIMT_Encode4(66808),
     /* 66349 */ // Label 1944: @66349
     /* 66349 */ GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(66394), // Rule ID 21649 //
     /* 66354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 66357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 66360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 66364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 66368 */   // (fpextend:{ *:[f32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTSH2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR16X:{ *:[f16] }:$src)
     /* 66368 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 66371 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 66375 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 66380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 66382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SSZrr),
     /* 66385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 66387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 66390 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66392 */   GIR_RootConstrainSelectedInstOperands,
     /* 66393 */   // GIR_Coverage, 21649,
     /* 66393 */   GIR_EraseRootFromParent_Done,
     /* 66394 */ // Label 1952: @66394
     /* 66394 */ GIM_Reject,
     /* 66395 */ // Label 1945: @66395
     /* 66395 */ GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(66425), // Rule ID 1889 //
     /* 66400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 66403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 66410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 66414 */   // (fpextend:{ *:[f64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SDrr:{ *:[f64] } FR32:{ *:[f32] }:$src)
     /* 66414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SDrr),
     /* 66419 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66423 */   GIR_RootConstrainSelectedInstOperands,
     /* 66424 */   // GIR_Coverage, 1889,
     /* 66424 */   GIR_Done,
     /* 66425 */ // Label 1953: @66425
     /* 66425 */ GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(66455), // Rule ID 18174 //
     /* 66430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 66433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 66440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 66444 */   // (fpextend:{ *:[f64] } RFP32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } RFP32:{ *:[f32] }:$src, RFP64:{ *:[i32] })
     /* 66444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 66449 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP64RegClassID),
     /* 66454 */   // GIR_Coverage, 18174,
     /* 66454 */   GIR_Done,
     /* 66455 */ // Label 1954: @66455
     /* 66455 */ GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(66500), // Rule ID 18447 //
     /* 66460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 66463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 66470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 66474 */   // (fpextend:{ *:[f64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR32:{ *:[f32] }:$src)
     /* 66474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 66477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 66481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 66486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 66488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDrr),
     /* 66491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 66493 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 66496 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66498 */   GIR_RootConstrainSelectedInstOperands,
     /* 66499 */   // GIR_Coverage, 18447,
     /* 66499 */   GIR_EraseRootFromParent_Done,
     /* 66500 */ // Label 1955: @66500
     /* 66500 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(66545), // Rule ID 21643 //
     /* 66505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 66508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 66515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 66519 */   // (fpextend:{ *:[f64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR32X:{ *:[f32] }:$src)
     /* 66519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 66522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 66526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 66531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 66533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDZrr),
     /* 66536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 66538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 66541 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66543 */   GIR_RootConstrainSelectedInstOperands,
     /* 66544 */   // GIR_Coverage, 21643,
     /* 66544 */   GIR_EraseRootFromParent_Done,
     /* 66545 */ // Label 1956: @66545
     /* 66545 */ GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(66590), // Rule ID 21653 //
     /* 66550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 66553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 66556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 66560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 66564 */   // (fpextend:{ *:[f64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTSH2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR16X:{ *:[f16] }:$src)
     /* 66564 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 66567 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 66571 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 66576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 66578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SDZrr),
     /* 66581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 66583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 66586 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66588 */   GIR_RootConstrainSelectedInstOperands,
     /* 66589 */   // GIR_Coverage, 21653,
     /* 66589 */   GIR_EraseRootFromParent_Done,
     /* 66590 */ // Label 1957: @66590
     /* 66590 */ GIM_Reject,
     /* 66591 */ // Label 1946: @66591
     /* 66591 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(66621), // Rule ID 18176 //
     /* 66596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 66599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 66606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 66610 */   // (fpextend:{ *:[f80] } RFP32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f80] } RFP32:{ *:[f32] }:$src, RFP80:{ *:[i32] })
     /* 66610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 66615 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP80RegClassID),
     /* 66620 */   // GIR_Coverage, 18176,
     /* 66620 */   GIR_Done,
     /* 66621 */ // Label 1958: @66621
     /* 66621 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(66651), // Rule ID 18178 //
     /* 66626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 66629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 66636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 66640 */   // (fpextend:{ *:[f80] } RFP64:{ *:[f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f80] } RFP64:{ *:[f64] }:$src, RFP80:{ *:[i32] })
     /* 66640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 66645 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP80RegClassID),
     /* 66650 */   // GIR_Coverage, 18178,
     /* 66650 */   GIR_Done,
     /* 66651 */ // Label 1959: @66651
     /* 66651 */ GIM_Reject,
     /* 66652 */ // Label 1947: @66652
     /* 66652 */ GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(66715),
     /* 66657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66660 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(66687), // Rule ID 1932 //
     /* 66665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 66668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 66672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 66676 */     // (fpextend:{ *:[v4f64] } VR128:{ *:[v4f32] }:$src)  =>  (VCVTPS2PDYrr:{ *:[v4f64] } VR128:{ *:[v4f32] }:$src)
     /* 66676 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDYrr),
     /* 66681 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66685 */     GIR_RootConstrainSelectedInstOperands,
     /* 66686 */     // GIR_Coverage, 1932,
     /* 66686 */     GIR_Done,
     /* 66687 */   // Label 1961: @66687
     /* 66687 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(66714), // Rule ID 10572 //
     /* 66692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 66695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 66699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 66703 */     // (fpextend:{ *:[v4f64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4f32] }:$src)
     /* 66703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDZ256rr),
     /* 66708 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66712 */     GIR_RootConstrainSelectedInstOperands,
     /* 66713 */     // GIR_Coverage, 10572,
     /* 66713 */     GIR_Done,
     /* 66714 */   // Label 1962: @66714
     /* 66714 */   GIM_Reject,
     /* 66715 */ // Label 1960: @66715
     /* 66715 */ GIM_Reject,
     /* 66716 */ // Label 1948: @66716
     /* 66716 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(66746), // Rule ID 10635 //
     /* 66721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 66724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 66727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 66731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 66735 */   // (fpextend:{ *:[v8f32] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2PSXZ256rr:{ *:[v8f32] } VR128X:{ *:[v8f16] }:$src)
     /* 66735 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PSXZ256rr),
     /* 66740 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66744 */   GIR_RootConstrainSelectedInstOperands,
     /* 66745 */   // GIR_Coverage, 10635,
     /* 66745 */   GIR_Done,
     /* 66746 */ // Label 1963: @66746
     /* 66746 */ GIM_Reject,
     /* 66747 */ // Label 1949: @66747
     /* 66747 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(66777), // Rule ID 10547 //
     /* 66752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 66755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 66758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 66766 */   // (fpextend:{ *:[v8f64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8f32] }:$src)
     /* 66766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDZrr),
     /* 66771 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66775 */   GIR_RootConstrainSelectedInstOperands,
     /* 66776 */   // GIR_Coverage, 10547,
     /* 66776 */   GIR_Done,
     /* 66777 */ // Label 1964: @66777
     /* 66777 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(66807), // Rule ID 10661 //
     /* 66782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 66785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 66788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 66796 */   // (fpextend:{ *:[v8f64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2PDZrr:{ *:[v8f64] } VR128X:{ *:[v8f16] }:$src)
     /* 66796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PDZrr),
     /* 66801 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66805 */   GIR_RootConstrainSelectedInstOperands,
     /* 66806 */   // GIR_Coverage, 10661,
     /* 66806 */   GIR_Done,
     /* 66807 */ // Label 1965: @66807
     /* 66807 */ GIM_Reject,
     /* 66808 */ // Label 1950: @66808
     /* 66808 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(66838), // Rule ID 10610 //
     /* 66813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 66816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 66819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 66827 */   // (fpextend:{ *:[v16f32] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2PSXZrr:{ *:[v16f32] } VR256X:{ *:[v16f16] }:$src)
     /* 66827 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PSXZrr),
     /* 66832 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66836 */   GIR_RootConstrainSelectedInstOperands,
     /* 66837 */   // GIR_Coverage, 10610,
     /* 66837 */   GIR_Done,
     /* 66838 */ // Label 1966: @66838
     /* 66838 */ GIM_Reject,
     /* 66839 */ // Label 1951: @66839
     /* 66839 */ GIM_Reject,
     /* 66840 */ // Label 41: @66840
     /* 66840 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1970*/ GIMT_Encode4(67166),
     /* 66851 */ /*GILLT_s16*//*Label 1967*/ GIMT_Encode4(66863),
     /* 66855 */ /*GILLT_s32*//*Label 1968*/ GIMT_Encode4(66954),
     /* 66859 */ /*GILLT_s64*//*Label 1969*/ GIMT_Encode4(67135),
     /* 66863 */ // Label 1967: @66863
     /* 66863 */ GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(66908), // Rule ID 21657 //
     /* 66868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 66871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 66878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 66882 */   // (fpround:{ *:[f16] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR32X:{ *:[f32] }:$src)
     /* 66882 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 66885 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 66889 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 66894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 66896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SHZrr),
     /* 66899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 66901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 66904 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66906 */   GIR_RootConstrainSelectedInstOperands,
     /* 66907 */   // GIR_Coverage, 21657,
     /* 66907 */   GIR_EraseRootFromParent_Done,
     /* 66908 */ // Label 1971: @66908
     /* 66908 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(66953), // Rule ID 21659 //
     /* 66913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 66916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 66923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 66927 */   // (fpround:{ *:[f16] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR64X:{ *:[f64] }:$src)
     /* 66927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 66930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 66934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 66939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 66941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SHZrr),
     /* 66944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 66946 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 66949 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66951 */   GIR_RootConstrainSelectedInstOperands,
     /* 66952 */   // GIR_Coverage, 21659,
     /* 66952 */   GIR_EraseRootFromParent_Done,
     /* 66953 */ // Label 1972: @66953
     /* 66953 */ GIM_Reject,
     /* 66954 */ // Label 1968: @66954
     /* 66954 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(66984), // Rule ID 1877 //
     /* 66959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 66962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 66969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 66973 */   // (fpround:{ *:[f32] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SSrr:{ *:[f32] } FR64:{ *:[f64] }:$src)
     /* 66973 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SSrr),
     /* 66978 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66982 */   GIR_RootConstrainSelectedInstOperands,
     /* 66983 */   // GIR_Coverage, 1877,
     /* 66983 */   GIR_Done,
     /* 66984 */ // Label 1973: @66984
     /* 66984 */ GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(67014), // Rule ID 18180 //
     /* 66989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 66992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 66999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 67003 */   // (fpround:{ *:[f32] } RFP64:{ *:[f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } RFP64:{ *:[f64] }:$src, RFP32:{ *:[i32] })
     /* 67003 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 67008 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP32RegClassID),
     /* 67013 */   // GIR_Coverage, 18180,
     /* 67013 */   GIR_Done,
     /* 67014 */ // Label 1974: @67014
     /* 67014 */ GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(67044), // Rule ID 18182 //
     /* 67019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 67022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 67025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 67029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 67033 */   // (fpround:{ *:[f32] } RFP80:{ *:[f80] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } RFP80:{ *:[f80] }:$src, RFP32:{ *:[i32] })
     /* 67033 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 67038 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP32RegClassID),
     /* 67043 */   // GIR_Coverage, 18182,
     /* 67043 */   GIR_Done,
     /* 67044 */ // Label 1975: @67044
     /* 67044 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(67089), // Rule ID 18445 //
     /* 67049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 67052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 67059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 67063 */   // (fpround:{ *:[f32] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR64:{ *:[f64] }:$src)
     /* 67063 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 67066 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 67070 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 67075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 67077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SSrr),
     /* 67080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 67082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 67085 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 67087 */   GIR_RootConstrainSelectedInstOperands,
     /* 67088 */   // GIR_Coverage, 18445,
     /* 67088 */   GIR_EraseRootFromParent_Done,
     /* 67089 */ // Label 1976: @67089
     /* 67089 */ GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(67134), // Rule ID 21647 //
     /* 67094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 67097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 67104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 67108 */   // (fpround:{ *:[f32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR64X:{ *:[f64] }:$src)
     /* 67108 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 67111 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 67115 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 67120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 67122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SSZrr),
     /* 67125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 67127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 67130 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 67132 */   GIR_RootConstrainSelectedInstOperands,
     /* 67133 */   // GIR_Coverage, 21647,
     /* 67133 */   GIR_EraseRootFromParent_Done,
     /* 67134 */ // Label 1977: @67134
     /* 67134 */ GIM_Reject,
     /* 67135 */ // Label 1969: @67135
     /* 67135 */ GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(67165), // Rule ID 18184 //
     /* 67140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 67143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 67146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 67150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 67154 */   // (fpround:{ *:[f64] } RFP80:{ *:[f80] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } RFP80:{ *:[f80] }:$src, RFP64:{ *:[i32] })
     /* 67154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 67159 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP64RegClassID),
     /* 67164 */   // GIR_Coverage, 18184,
     /* 67164 */   GIR_Done,
     /* 67165 */ // Label 1978: @67165
     /* 67165 */ GIM_Reject,
     /* 67166 */ // Label 1970: @67166
     /* 67166 */ GIM_Reject,
     /* 67167 */ // Label 42: @67167
     /* 67167 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 1982*/ GIMT_Encode4(67663),
     /* 67178 */ /*GILLT_s32*//*Label 1979*/ GIMT_Encode4(67210),
     /* 67182 */ /*GILLT_s64*//*Label 1980*/ GIMT_Encode4(67421), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 67206 */ /*GILLT_v4s32*//*Label 1981*/ GIMT_Encode4(67632),
     /* 67210 */ // Label 1979: @67210
     /* 67210 */ GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(67240), // Rule ID 1737 //
     /* 67215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 67218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 67229 */   // (fp_to_sint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VCVTTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 67229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIrr),
     /* 67234 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67238 */   GIR_RootConstrainSelectedInstOperands,
     /* 67239 */   // GIR_Coverage, 1737,
     /* 67239 */   GIR_Done,
     /* 67240 */ // Label 1983: @67240
     /* 67240 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(67270), // Rule ID 1745 //
     /* 67245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 67248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 67259 */   // (fp_to_sint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (VCVTTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 67259 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIrr),
     /* 67264 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67268 */   GIR_RootConstrainSelectedInstOperands,
     /* 67269 */   // GIR_Coverage, 1745,
     /* 67269 */   GIR_Done,
     /* 67270 */ // Label 1984: @67270
     /* 67270 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(67300), // Rule ID 1761 //
     /* 67275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 67278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 67289 */   // (fp_to_sint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (CVTTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 67289 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SIrr),
     /* 67294 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67298 */   GIR_RootConstrainSelectedInstOperands,
     /* 67299 */   // GIR_Coverage, 1761,
     /* 67299 */   GIR_Done,
     /* 67300 */ // Label 1985: @67300
     /* 67300 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(67330), // Rule ID 1769 //
     /* 67305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 67308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 67319 */   // (fp_to_sint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (CVTTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 67319 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SIrr),
     /* 67324 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67328 */   GIR_RootConstrainSelectedInstOperands,
     /* 67329 */   // GIR_Coverage, 1769,
     /* 67329 */   GIR_Done,
     /* 67330 */ // Label 1986: @67330
     /* 67330 */ GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(67360), // Rule ID 10358 //
     /* 67335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 67338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 67349 */   // (fp_to_sint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2SIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 67349 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIZrr),
     /* 67354 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67358 */   GIR_RootConstrainSelectedInstOperands,
     /* 67359 */   // GIR_Coverage, 10358,
     /* 67359 */   GIR_Done,
     /* 67360 */ // Label 1987: @67360
     /* 67360 */ GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(67390), // Rule ID 10376 //
     /* 67365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 67368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 67379 */   // (fp_to_sint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2SIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 67379 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIZrr),
     /* 67384 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67388 */   GIR_RootConstrainSelectedInstOperands,
     /* 67389 */   // GIR_Coverage, 10376,
     /* 67389 */   GIR_Done,
     /* 67390 */ // Label 1988: @67390
     /* 67390 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(67420), // Rule ID 15166 //
     /* 67395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 67398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 67401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 67409 */   // (fp_to_sint:{ *:[i32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2SIZrr:{ *:[i32] } FR16X:{ *:[f16] }:$src)
     /* 67409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /* 67414 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67418 */   GIR_RootConstrainSelectedInstOperands,
     /* 67419 */   // GIR_Coverage, 15166,
     /* 67419 */   GIR_Done,
     /* 67420 */ // Label 1989: @67420
     /* 67420 */ GIM_Reject,
     /* 67421 */ // Label 1980: @67421
     /* 67421 */ GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(67451), // Rule ID 1741 //
     /* 67426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 67429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 67440 */   // (fp_to_sint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 67440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64rr),
     /* 67445 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67449 */   GIR_RootConstrainSelectedInstOperands,
     /* 67450 */   // GIR_Coverage, 1741,
     /* 67450 */   GIR_Done,
     /* 67451 */ // Label 1990: @67451
     /* 67451 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(67481), // Rule ID 1749 //
     /* 67456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 67459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 67470 */   // (fp_to_sint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 67470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64rr),
     /* 67475 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67479 */   GIR_RootConstrainSelectedInstOperands,
     /* 67480 */   // GIR_Coverage, 1749,
     /* 67480 */   GIR_Done,
     /* 67481 */ // Label 1991: @67481
     /* 67481 */ GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(67511), // Rule ID 1765 //
     /* 67486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 67489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 67500 */   // (fp_to_sint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 67500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SI64rr),
     /* 67505 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67509 */   GIR_RootConstrainSelectedInstOperands,
     /* 67510 */   // GIR_Coverage, 1765,
     /* 67510 */   GIR_Done,
     /* 67511 */ // Label 1992: @67511
     /* 67511 */ GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(67541), // Rule ID 1773 //
     /* 67516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 67519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 67530 */   // (fp_to_sint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 67530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SI64rr),
     /* 67535 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67539 */   GIR_RootConstrainSelectedInstOperands,
     /* 67540 */   // GIR_Coverage, 1773,
     /* 67540 */   GIR_Done,
     /* 67541 */ // Label 1993: @67541
     /* 67541 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(67571), // Rule ID 10367 //
     /* 67546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 67549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 67560 */   // (fp_to_sint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2SI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 67560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64Zrr),
     /* 67565 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67569 */   GIR_RootConstrainSelectedInstOperands,
     /* 67570 */   // GIR_Coverage, 10367,
     /* 67570 */   GIR_Done,
     /* 67571 */ // Label 1994: @67571
     /* 67571 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(67601), // Rule ID 10385 //
     /* 67576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 67579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 67590 */   // (fp_to_sint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2SI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 67590 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64Zrr),
     /* 67595 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67599 */   GIR_RootConstrainSelectedInstOperands,
     /* 67600 */   // GIR_Coverage, 10385,
     /* 67600 */   GIR_Done,
     /* 67601 */ // Label 1995: @67601
     /* 67601 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(67631), // Rule ID 15175 //
     /* 67606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 67609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 67612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 67620 */   // (fp_to_sint:{ *:[i64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16X:{ *:[f16] }:$src)
     /* 67620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /* 67625 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67629 */   GIR_RootConstrainSelectedInstOperands,
     /* 67630 */   // GIR_Coverage, 15175,
     /* 67630 */   GIR_Done,
     /* 67631 */ // Label 1996: @67631
     /* 67631 */ GIM_Reject,
     /* 67632 */ // Label 1981: @67632
     /* 67632 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(67662), // Rule ID 18499 //
     /* 67637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 67640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 67643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 67647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 67651 */   // (fp_to_sint:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)  =>  (VCVTTPD2DQYrr:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)
     /* 67651 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTPD2DQYrr),
     /* 67656 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67660 */   GIR_RootConstrainSelectedInstOperands,
     /* 67661 */   // GIR_Coverage, 18499,
     /* 67661 */   GIR_Done,
     /* 67662 */ // Label 1997: @67662
     /* 67662 */ GIM_Reject,
     /* 67663 */ // Label 1982: @67663
     /* 67663 */ GIM_Reject,
     /* 67664 */ // Label 43: @67664
     /* 67664 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2000*/ GIMT_Encode4(67865),
     /* 67675 */ /*GILLT_s32*//*Label 1998*/ GIMT_Encode4(67683),
     /* 67679 */ /*GILLT_s64*//*Label 1999*/ GIMT_Encode4(67774),
     /* 67683 */ // Label 1998: @67683
     /* 67683 */ GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(67713), // Rule ID 10394 //
     /* 67688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 67691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 67702 */   // (fp_to_uint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2USIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 67702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USIZrr),
     /* 67707 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67711 */   GIR_RootConstrainSelectedInstOperands,
     /* 67712 */   // GIR_Coverage, 10394,
     /* 67712 */   GIR_Done,
     /* 67713 */ // Label 2001: @67713
     /* 67713 */ GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(67743), // Rule ID 10412 //
     /* 67718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 67721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 67732 */   // (fp_to_uint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2USIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 67732 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USIZrr),
     /* 67737 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67741 */   GIR_RootConstrainSelectedInstOperands,
     /* 67742 */   // GIR_Coverage, 10412,
     /* 67742 */   GIR_Done,
     /* 67743 */ // Label 2002: @67743
     /* 67743 */ GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(67773), // Rule ID 15184 //
     /* 67748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 67751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 67754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 67762 */   // (fp_to_uint:{ *:[i32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2USIZrr:{ *:[i32] } FR16X:{ *:[f16] }:$src)
     /* 67762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USIZrr),
     /* 67767 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67771 */   GIR_RootConstrainSelectedInstOperands,
     /* 67772 */   // GIR_Coverage, 15184,
     /* 67772 */   GIR_Done,
     /* 67773 */ // Label 2003: @67773
     /* 67773 */ GIM_Reject,
     /* 67774 */ // Label 1999: @67774
     /* 67774 */ GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(67804), // Rule ID 10403 //
     /* 67779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 67782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 67793 */   // (fp_to_uint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2USI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 67793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USI64Zrr),
     /* 67798 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67802 */   GIR_RootConstrainSelectedInstOperands,
     /* 67803 */   // GIR_Coverage, 10403,
     /* 67803 */   GIR_Done,
     /* 67804 */ // Label 2004: @67804
     /* 67804 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(67834), // Rule ID 10421 //
     /* 67809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 67812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 67823 */   // (fp_to_uint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2USI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 67823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USI64Zrr),
     /* 67828 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67832 */   GIR_RootConstrainSelectedInstOperands,
     /* 67833 */   // GIR_Coverage, 10421,
     /* 67833 */   GIR_Done,
     /* 67834 */ // Label 2005: @67834
     /* 67834 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(67864), // Rule ID 15193 //
     /* 67839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 67842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 67845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 67853 */   // (fp_to_uint:{ *:[i64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2USI64Zrr:{ *:[i64] } FR16X:{ *:[f16] }:$src)
     /* 67853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USI64Zrr),
     /* 67858 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67862 */   GIR_RootConstrainSelectedInstOperands,
     /* 67863 */   // GIR_Coverage, 15193,
     /* 67863 */   GIR_Done,
     /* 67864 */ // Label 2006: @67864
     /* 67864 */ GIM_Reject,
     /* 67865 */ // Label 2000: @67865
     /* 67865 */ GIM_Reject,
     /* 67866 */ // Label 44: @67866
     /* 67866 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2019*/ GIMT_Encode4(69127),
     /* 67877 */ /*GILLT_s16*//*Label 2007*/ GIMT_Encode4(67961),
     /* 67881 */ /*GILLT_s32*//*Label 2008*/ GIMT_Encode4(68052),
     /* 67885 */ /*GILLT_s64*//*Label 2009*/ GIMT_Encode4(68293), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 67901 */ /*GILLT_v2s64*//*Label 2010*/ GIMT_Encode4(68530), GIMT_Encode4(0),
     /* 67909 */ /*GILLT_v4s32*//*Label 2011*/ GIMT_Encode4(68561),
     /* 67913 */ /*GILLT_v4s64*//*Label 2012*/ GIMT_Encode4(68682), GIMT_Encode4(0),
     /* 67921 */ /*GILLT_v8s16*//*Label 2013*/ GIMT_Encode4(68765),
     /* 67925 */ /*GILLT_v8s32*//*Label 2014*/ GIMT_Encode4(68856),
     /* 67929 */ /*GILLT_v8s64*//*Label 2015*/ GIMT_Encode4(68947), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 67941 */ /*GILLT_v16s16*//*Label 2016*/ GIMT_Encode4(69004),
     /* 67945 */ /*GILLT_v16s32*//*Label 2017*/ GIMT_Encode4(69065), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 67957 */ /*GILLT_v32s16*//*Label 2018*/ GIMT_Encode4(69096),
     /* 67961 */ // Label 2007: @67961
     /* 67961 */ GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(68006), // Rule ID 22607 //
     /* 67966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 67969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 67976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67980 */   // (sint_to_fp:{ *:[f16] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR32:{ *:[i32] }:$src)
     /* 67980 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 67983 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 67987 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 67992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 67994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SHZrr),
     /* 67997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 67999 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68002 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68004 */   GIR_RootConstrainSelectedInstOperands,
     /* 68005 */   // GIR_Coverage, 22607,
     /* 68005 */   GIR_EraseRootFromParent_Done,
     /* 68006 */ // Label 2020: @68006
     /* 68006 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(68051), // Rule ID 22609 //
     /* 68011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 68014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 68021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68025 */   // (sint_to_fp:{ *:[f16] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR64:{ *:[i64] }:$src)
     /* 68025 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 68028 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68032 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SHZrr),
     /* 68042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68047 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68049 */   GIR_RootConstrainSelectedInstOperands,
     /* 68050 */   // GIR_Coverage, 22609,
     /* 68050 */   GIR_EraseRootFromParent_Done,
     /* 68051 */ // Label 2021: @68051
     /* 68051 */ GIM_Reject,
     /* 68052 */ // Label 2008: @68052
     /* 68052 */ GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(68082), // Rule ID 1785 //
     /* 68057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 68060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 68067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 68071 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (CVTSI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /* 68071 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI2SSrr),
     /* 68076 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68080 */   GIR_RootConstrainSelectedInstOperands,
     /* 68081 */   // GIR_Coverage, 1785,
     /* 68081 */   GIR_Done,
     /* 68082 */ // Label 2022: @68082
     /* 68082 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(68112), // Rule ID 1789 //
     /* 68087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 68090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 68097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68101 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (CVTSI642SSrr:{ *:[f32] } GR64:{ *:[i64] }:$src)
     /* 68101 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI642SSrr),
     /* 68106 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68110 */   GIR_RootConstrainSelectedInstOperands,
     /* 68111 */   // GIR_Coverage, 1789,
     /* 68111 */   GIR_Done,
     /* 68112 */ // Label 2023: @68112
     /* 68112 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(68157), // Rule ID 18429 //
     /* 68117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 68120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 68127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 68131 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 68131 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 68134 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68138 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSrr),
     /* 68148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68153 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68155 */   GIR_RootConstrainSelectedInstOperands,
     /* 68156 */   // GIR_Coverage, 18429,
     /* 68156 */   GIR_EraseRootFromParent_Done,
     /* 68157 */ // Label 2024: @68157
     /* 68157 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(68202), // Rule ID 18431 //
     /* 68162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 68165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 68172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68176 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 68176 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 68179 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68183 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSrr),
     /* 68193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68195 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68198 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68200 */   GIR_RootConstrainSelectedInstOperands,
     /* 68201 */   // GIR_Coverage, 18431,
     /* 68201 */   GIR_EraseRootFromParent_Done,
     /* 68202 */ // Label 2025: @68202
     /* 68202 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(68247), // Rule ID 21583 //
     /* 68207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 68210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 68217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 68221 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 68221 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 68224 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68228 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSZrr),
     /* 68238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68240 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68243 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68245 */   GIR_RootConstrainSelectedInstOperands,
     /* 68246 */   // GIR_Coverage, 21583,
     /* 68246 */   GIR_EraseRootFromParent_Done,
     /* 68247 */ // Label 2026: @68247
     /* 68247 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(68292), // Rule ID 21585 //
     /* 68252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 68255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 68262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68266 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 68266 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 68269 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68273 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSZrr),
     /* 68283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68288 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68290 */   GIR_RootConstrainSelectedInstOperands,
     /* 68291 */   // GIR_Coverage, 21585,
     /* 68291 */   GIR_EraseRootFromParent_Done,
     /* 68292 */ // Label 2027: @68292
     /* 68292 */ GIM_Reject,
     /* 68293 */ // Label 2009: @68293
     /* 68293 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(68319), // Rule ID 1793 //
     /* 68298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 68301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 68308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 68312 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (CVTSI2SDrr:{ *:[f64] } GR32:{ *:[i32] }:$src)
     /* 68312 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI2SDrr),
     /* 68317 */   GIR_RootConstrainSelectedInstOperands,
     /* 68318 */   // GIR_Coverage, 1793,
     /* 68318 */   GIR_Done,
     /* 68319 */ // Label 2028: @68319
     /* 68319 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(68349), // Rule ID 1797 //
     /* 68324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 68327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 68334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68338 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (CVTSI642SDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /* 68338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI642SDrr),
     /* 68343 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68347 */   GIR_RootConstrainSelectedInstOperands,
     /* 68348 */   // GIR_Coverage, 1797,
     /* 68348 */   GIR_Done,
     /* 68349 */ // Label 2029: @68349
     /* 68349 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(68394), // Rule ID 18433 //
     /* 68354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 68357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 68364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 68368 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 68368 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 68371 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68375 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDrr),
     /* 68385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68390 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68392 */   GIR_RootConstrainSelectedInstOperands,
     /* 68393 */   // GIR_Coverage, 18433,
     /* 68393 */   GIR_EraseRootFromParent_Done,
     /* 68394 */ // Label 2030: @68394
     /* 68394 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(68439), // Rule ID 18435 //
     /* 68399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 68402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 68409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68413 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 68413 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 68416 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68420 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDrr),
     /* 68430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68432 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68435 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68437 */   GIR_RootConstrainSelectedInstOperands,
     /* 68438 */   // GIR_Coverage, 18435,
     /* 68438 */   GIR_EraseRootFromParent_Done,
     /* 68439 */ // Label 2031: @68439
     /* 68439 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(68484), // Rule ID 21587 //
     /* 68444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 68447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 68454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 68458 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 68458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 68461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68470 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDZrr),
     /* 68475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68477 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68480 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68482 */   GIR_RootConstrainSelectedInstOperands,
     /* 68483 */   // GIR_Coverage, 21587,
     /* 68483 */   GIR_EraseRootFromParent_Done,
     /* 68484 */ // Label 2032: @68484
     /* 68484 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(68529), // Rule ID 21589 //
     /* 68489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 68492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 68499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68503 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 68503 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 68506 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68510 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDZrr),
     /* 68520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68522 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68525 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68527 */   GIR_RootConstrainSelectedInstOperands,
     /* 68528 */   // GIR_Coverage, 21589,
     /* 68528 */   GIR_EraseRootFromParent_Done,
     /* 68529 */ // Label 2033: @68529
     /* 68529 */ GIM_Reject,
     /* 68530 */ // Label 2010: @68530
     /* 68530 */ GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(68560), // Rule ID 11372 //
     /* 68535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 68538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 68541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 68545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 68549 */   // (sint_to_fp:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)  =>  (VCVTQQ2PDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)
     /* 68549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ128rr),
     /* 68554 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68558 */   GIR_RootConstrainSelectedInstOperands,
     /* 68559 */   // GIR_Coverage, 11372,
     /* 68559 */   GIR_Done,
     /* 68560 */ // Label 2034: @68560
     /* 68560 */ GIM_Reject,
     /* 68561 */ // Label 2011: @68561
     /* 68561 */ GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(68591), // Rule ID 1865 //
     /* 68566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 68569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 68576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 68580 */   // (sint_to_fp:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PSrr:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)
     /* 68580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSrr),
     /* 68585 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68589 */   GIR_RootConstrainSelectedInstOperands,
     /* 68590 */   // GIR_Coverage, 1865,
     /* 68590 */   GIR_Done,
     /* 68591 */ // Label 2035: @68591
     /* 68591 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(68621), // Rule ID 1873 //
     /* 68596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 68599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 68606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 68610 */   // (sint_to_fp:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)  =>  (CVTDQ2PSrr:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)
     /* 68610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTDQ2PSrr),
     /* 68615 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68619 */   GIR_RootConstrainSelectedInstOperands,
     /* 68620 */   // GIR_Coverage, 1873,
     /* 68620 */   GIR_Done,
     /* 68621 */ // Label 2036: @68621
     /* 68621 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(68651), // Rule ID 10748 //
     /* 68626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 68629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 68636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 68640 */   // (sint_to_fp:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)
     /* 68640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ128rr),
     /* 68645 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68649 */   GIR_RootConstrainSelectedInstOperands,
     /* 68650 */   // GIR_Coverage, 10748,
     /* 68650 */   GIR_Done,
     /* 68651 */ // Label 2037: @68651
     /* 68651 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(68681), // Rule ID 11504 //
     /* 68656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 68659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 68662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 68666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 68670 */   // (sint_to_fp:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTQQ2PSZ256rr:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)
     /* 68670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZ256rr),
     /* 68675 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68679 */   GIR_RootConstrainSelectedInstOperands,
     /* 68680 */   // GIR_Coverage, 11504,
     /* 68680 */   GIR_Done,
     /* 68681 */ // Label 2038: @68681
     /* 68681 */ GIM_Reject,
     /* 68682 */ // Label 2012: @68682
     /* 68682 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(68708), // Rule ID 1944 //
     /* 68687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 68690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 68697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 68701 */   // (sint_to_fp:{ *:[v4f64] } VR128:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PDYrr:{ *:[v4f64] } VR128:{ *:[v4i32] }:$src)
     /* 68701 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDYrr),
     /* 68706 */   GIR_RootConstrainSelectedInstOperands,
     /* 68707 */   // GIR_Coverage, 1944,
     /* 68707 */   GIR_Done,
     /* 68708 */ // Label 2039: @68708
     /* 68708 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(68734), // Rule ID 10721 //
     /* 68713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 68716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 68723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 68727 */   // (sint_to_fp:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)
     /* 68727 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZ256rr),
     /* 68732 */   GIR_RootConstrainSelectedInstOperands,
     /* 68733 */   // GIR_Coverage, 10721,
     /* 68733 */   GIR_Done,
     /* 68734 */ // Label 2040: @68734
     /* 68734 */ GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(68764), // Rule ID 11384 //
     /* 68739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 68742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 68745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 68749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 68753 */   // (sint_to_fp:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTQQ2PDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)
     /* 68753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ256rr),
     /* 68758 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68762 */   GIR_RootConstrainSelectedInstOperands,
     /* 68763 */   // GIR_Coverage, 11384,
     /* 68763 */   GIR_Done,
     /* 68764 */ // Label 2041: @68764
     /* 68764 */ GIM_Reject,
     /* 68765 */ // Label 2013: @68765
     /* 68765 */ GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(68795), // Rule ID 11450 //
     /* 68770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 68773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 68776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 68780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 68784 */   // (sint_to_fp:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PHZ256rr:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)
     /* 68784 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZ256rr),
     /* 68789 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68793 */   GIR_RootConstrainSelectedInstOperands,
     /* 68794 */   // GIR_Coverage, 11450,
     /* 68794 */   GIR_Done,
     /* 68795 */ // Label 2042: @68795
     /* 68795 */ GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(68825), // Rule ID 14816 //
     /* 68800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 68803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 68806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 68810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 68814 */   // (sint_to_fp:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)  =>  (VCVTW2PHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)
     /* 68814 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ128rr),
     /* 68819 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68823 */   GIR_RootConstrainSelectedInstOperands,
     /* 68824 */   // GIR_Coverage, 14816,
     /* 68824 */   GIR_Done,
     /* 68825 */ // Label 2043: @68825
     /* 68825 */ GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(68855), // Rule ID 15116 //
     /* 68830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 68833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 68836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 68840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 68844 */   // (sint_to_fp:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PHZrr:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)
     /* 68844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PHZrr),
     /* 68849 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68853 */   GIR_RootConstrainSelectedInstOperands,
     /* 68854 */   // GIR_Coverage, 15116,
     /* 68854 */   GIR_Done,
     /* 68855 */ // Label 2044: @68855
     /* 68855 */ GIM_Reject,
     /* 68856 */ // Label 2014: @68856
     /* 68856 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(68886), // Rule ID 1869 //
     /* 68861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 68864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 68867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 68871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 68875 */   // (sint_to_fp:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PSYrr:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src)
     /* 68875 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSYrr),
     /* 68880 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68884 */   GIR_RootConstrainSelectedInstOperands,
     /* 68885 */   // GIR_Coverage, 1869,
     /* 68885 */   GIR_Done,
     /* 68886 */ // Label 2045: @68886
     /* 68886 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(68916), // Rule ID 10760 //
     /* 68891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 68894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 68897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 68901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 68905 */   // (sint_to_fp:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)
     /* 68905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ256rr),
     /* 68910 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68914 */   GIR_RootConstrainSelectedInstOperands,
     /* 68915 */   // GIR_Coverage, 10760,
     /* 68915 */   GIR_Done,
     /* 68916 */ // Label 2046: @68916
     /* 68916 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(68946), // Rule ID 11489 //
     /* 68921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 68924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 68927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 68931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 68935 */   // (sint_to_fp:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PSZrr:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)
     /* 68935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZrr),
     /* 68940 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68944 */   GIR_RootConstrainSelectedInstOperands,
     /* 68945 */   // GIR_Coverage, 11489,
     /* 68945 */   GIR_Done,
     /* 68946 */ // Label 2047: @68946
     /* 68946 */ GIM_Reject,
     /* 68947 */ // Label 2015: @68947
     /* 68947 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(68973), // Rule ID 10697 //
     /* 68952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 68955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 68958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 68962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 68966 */   // (sint_to_fp:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)
     /* 68966 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZrr),
     /* 68971 */   GIR_RootConstrainSelectedInstOperands,
     /* 68972 */   // GIR_Coverage, 10697,
     /* 68972 */   GIR_Done,
     /* 68973 */ // Label 2048: @68973
     /* 68973 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(69003), // Rule ID 11357 //
     /* 68978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 68981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 68984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 68988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 68992 */   // (sint_to_fp:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PDZrr:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)
     /* 68992 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZrr),
     /* 68997 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69001 */   GIR_RootConstrainSelectedInstOperands,
     /* 69002 */   // GIR_Coverage, 11357,
     /* 69002 */   GIR_Done,
     /* 69003 */ // Label 2049: @69003
     /* 69003 */ GIM_Reject,
     /* 69004 */ // Label 2016: @69004
     /* 69004 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(69034), // Rule ID 11435 //
     /* 69009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 69012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 69015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69023 */   // (sint_to_fp:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTDQ2PHZrr:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)
     /* 69023 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZrr),
     /* 69028 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69032 */   GIR_RootConstrainSelectedInstOperands,
     /* 69033 */   // GIR_Coverage, 11435,
     /* 69033 */   GIR_Done,
     /* 69034 */ // Label 2050: @69034
     /* 69034 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(69064), // Rule ID 14828 //
     /* 69039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 69042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 69045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69053 */   // (sint_to_fp:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)  =>  (VCVTW2PHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)
     /* 69053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ256rr),
     /* 69058 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69062 */   GIR_RootConstrainSelectedInstOperands,
     /* 69063 */   // GIR_Coverage, 14828,
     /* 69063 */   GIR_Done,
     /* 69064 */ // Label 2051: @69064
     /* 69064 */ GIM_Reject,
     /* 69065 */ // Label 2017: @69065
     /* 69065 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(69095), // Rule ID 10733 //
     /* 69070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 69073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 69076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69084 */   // (sint_to_fp:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTDQ2PSZrr:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)
     /* 69084 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZrr),
     /* 69089 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69093 */   GIR_RootConstrainSelectedInstOperands,
     /* 69094 */   // GIR_Coverage, 10733,
     /* 69094 */   GIR_Done,
     /* 69095 */ // Label 2052: @69095
     /* 69095 */ GIM_Reject,
     /* 69096 */ // Label 2018: @69096
     /* 69096 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(69126), // Rule ID 14801 //
     /* 69101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 69104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 69107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69115 */   // (sint_to_fp:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)  =>  (VCVTW2PHZrr:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)
     /* 69115 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZrr),
     /* 69120 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69124 */   GIR_RootConstrainSelectedInstOperands,
     /* 69125 */   // GIR_Coverage, 14801,
     /* 69125 */   GIR_Done,
     /* 69126 */ // Label 2053: @69126
     /* 69126 */ GIM_Reject,
     /* 69127 */ // Label 2019: @69127
     /* 69127 */ GIM_Reject,
     /* 69128 */ // Label 45: @69128
     /* 69128 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2066*/ GIMT_Encode4(69977),
     /* 69139 */ /*GILLT_s16*//*Label 2054*/ GIMT_Encode4(69223),
     /* 69143 */ /*GILLT_s32*//*Label 2055*/ GIMT_Encode4(69314),
     /* 69147 */ /*GILLT_s64*//*Label 2056*/ GIMT_Encode4(69405), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 69163 */ /*GILLT_v2s64*//*Label 2057*/ GIMT_Encode4(69496), GIMT_Encode4(0),
     /* 69171 */ /*GILLT_v4s32*//*Label 2058*/ GIMT_Encode4(69527),
     /* 69175 */ /*GILLT_v4s64*//*Label 2059*/ GIMT_Encode4(69588), GIMT_Encode4(0),
     /* 69183 */ /*GILLT_v8s16*//*Label 2060*/ GIMT_Encode4(69645),
     /* 69187 */ /*GILLT_v8s32*//*Label 2061*/ GIMT_Encode4(69736),
     /* 69191 */ /*GILLT_v8s64*//*Label 2062*/ GIMT_Encode4(69797), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 69203 */ /*GILLT_v16s16*//*Label 2063*/ GIMT_Encode4(69854),
     /* 69207 */ /*GILLT_v16s32*//*Label 2064*/ GIMT_Encode4(69915), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 69219 */ /*GILLT_v32s16*//*Label 2065*/ GIMT_Encode4(69946),
     /* 69223 */ // Label 2054: @69223
     /* 69223 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(69268), // Rule ID 22615 //
     /* 69228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 69231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 69234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 69238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 69242 */   // (uint_to_fp:{ *:[f16] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR32:{ *:[i32] }:$src)
     /* 69242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 69245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 69249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69254 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SHZrr),
     /* 69259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 69261 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69264 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 69266 */   GIR_RootConstrainSelectedInstOperands,
     /* 69267 */   // GIR_Coverage, 22615,
     /* 69267 */   GIR_EraseRootFromParent_Done,
     /* 69268 */ // Label 2067: @69268
     /* 69268 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(69313), // Rule ID 22617 //
     /* 69273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 69276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 69279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 69283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 69287 */   // (uint_to_fp:{ *:[f16] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR64:{ *:[i64] }:$src)
     /* 69287 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 69290 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 69294 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SHZrr),
     /* 69304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 69306 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69309 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 69311 */   GIR_RootConstrainSelectedInstOperands,
     /* 69312 */   // GIR_Coverage, 22617,
     /* 69312 */   GIR_EraseRootFromParent_Done,
     /* 69313 */ // Label 2068: @69313
     /* 69313 */ GIM_Reject,
     /* 69314 */ // Label 2055: @69314
     /* 69314 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(69359), // Rule ID 21599 //
     /* 69319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 69322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 69325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 69329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 69333 */   // (uint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 69333 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 69336 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 69340 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SSZrr),
     /* 69350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 69352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69355 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 69357 */   GIR_RootConstrainSelectedInstOperands,
     /* 69358 */   // GIR_Coverage, 21599,
     /* 69358 */   GIR_EraseRootFromParent_Done,
     /* 69359 */ // Label 2069: @69359
     /* 69359 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(69404), // Rule ID 21601 //
     /* 69364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 69367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 69370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 69374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 69378 */   // (uint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 69378 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 69381 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 69385 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SSZrr),
     /* 69395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 69397 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69400 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 69402 */   GIR_RootConstrainSelectedInstOperands,
     /* 69403 */   // GIR_Coverage, 21601,
     /* 69403 */   GIR_EraseRootFromParent_Done,
     /* 69404 */ // Label 2070: @69404
     /* 69404 */ GIM_Reject,
     /* 69405 */ // Label 2056: @69405
     /* 69405 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(69450), // Rule ID 21603 //
     /* 69410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 69413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 69416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 69420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 69424 */   // (uint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 69424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 69427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 69431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SDZrr),
     /* 69441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 69443 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69446 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 69448 */   GIR_RootConstrainSelectedInstOperands,
     /* 69449 */   // GIR_Coverage, 21603,
     /* 69449 */   GIR_EraseRootFromParent_Done,
     /* 69450 */ // Label 2071: @69450
     /* 69450 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(69495), // Rule ID 21605 //
     /* 69455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 69458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 69461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 69465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 69469 */   // (uint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 69469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 69472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 69476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SDZrr),
     /* 69486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 69488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69491 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 69493 */   GIR_RootConstrainSelectedInstOperands,
     /* 69494 */   // GIR_Coverage, 21605,
     /* 69494 */   GIR_EraseRootFromParent_Done,
     /* 69495 */ // Label 2072: @69495
     /* 69495 */ GIM_Reject,
     /* 69496 */ // Label 2057: @69496
     /* 69496 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(69526), // Rule ID 11411 //
     /* 69501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 69504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 69507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69515 */   // (uint_to_fp:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)  =>  (VCVTUQQ2PDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)
     /* 69515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ128rr),
     /* 69520 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69524 */   GIR_RootConstrainSelectedInstOperands,
     /* 69525 */   // GIR_Coverage, 11411,
     /* 69525 */   GIR_Done,
     /* 69526 */ // Label 2073: @69526
     /* 69526 */ GIM_Reject,
     /* 69527 */ // Label 2058: @69527
     /* 69527 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(69557), // Rule ID 10955 //
     /* 69532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 69535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69546 */   // (uint_to_fp:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTUDQ2PSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)
     /* 69546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ128rr),
     /* 69551 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69555 */   GIR_RootConstrainSelectedInstOperands,
     /* 69556 */   // GIR_Coverage, 10955,
     /* 69556 */   GIR_Done,
     /* 69557 */ // Label 2074: @69557
     /* 69557 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(69587), // Rule ID 11531 //
     /* 69562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 69565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 69568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69576 */   // (uint_to_fp:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTUQQ2PSZ256rr:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)
     /* 69576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZ256rr),
     /* 69581 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69585 */   GIR_RootConstrainSelectedInstOperands,
     /* 69586 */   // GIR_Coverage, 11531,
     /* 69586 */   GIR_Done,
     /* 69587 */ // Label 2075: @69587
     /* 69587 */ GIM_Reject,
     /* 69588 */ // Label 2059: @69588
     /* 69588 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(69614), // Rule ID 10928 //
     /* 69593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 69596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69607 */   // (uint_to_fp:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTUDQ2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)
     /* 69607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZ256rr),
     /* 69612 */   GIR_RootConstrainSelectedInstOperands,
     /* 69613 */   // GIR_Coverage, 10928,
     /* 69613 */   GIR_Done,
     /* 69614 */ // Label 2076: @69614
     /* 69614 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(69644), // Rule ID 11423 //
     /* 69619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 69622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 69625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69633 */   // (uint_to_fp:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTUQQ2PDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)
     /* 69633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ256rr),
     /* 69638 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69642 */   GIR_RootConstrainSelectedInstOperands,
     /* 69643 */   // GIR_Coverage, 11423,
     /* 69643 */   GIR_Done,
     /* 69644 */ // Label 2077: @69644
     /* 69644 */ GIM_Reject,
     /* 69645 */ // Label 2060: @69645
     /* 69645 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(69675), // Rule ID 11477 //
     /* 69650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 69653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 69656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69664 */   // (uint_to_fp:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PHZ256rr:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)
     /* 69664 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZ256rr),
     /* 69669 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69673 */   GIR_RootConstrainSelectedInstOperands,
     /* 69674 */   // GIR_Coverage, 11477,
     /* 69674 */   GIR_Done,
     /* 69675 */ // Label 2078: @69675
     /* 69675 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(69705), // Rule ID 14669 //
     /* 69680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 69683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 69686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69694 */   // (uint_to_fp:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)  =>  (VCVTUW2PHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)
     /* 69694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ128rr),
     /* 69699 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69703 */   GIR_RootConstrainSelectedInstOperands,
     /* 69704 */   // GIR_Coverage, 14669,
     /* 69704 */   GIR_Done,
     /* 69705 */ // Label 2079: @69705
     /* 69705 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(69735), // Rule ID 15131 //
     /* 69710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 69713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 69716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69724 */   // (uint_to_fp:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PHZrr:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)
     /* 69724 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PHZrr),
     /* 69729 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69733 */   GIR_RootConstrainSelectedInstOperands,
     /* 69734 */   // GIR_Coverage, 15131,
     /* 69734 */   GIR_Done,
     /* 69735 */ // Label 2080: @69735
     /* 69735 */ GIM_Reject,
     /* 69736 */ // Label 2061: @69736
     /* 69736 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(69766), // Rule ID 10967 //
     /* 69741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 69744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 69747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69755 */   // (uint_to_fp:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)
     /* 69755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ256rr),
     /* 69760 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69764 */   GIR_RootConstrainSelectedInstOperands,
     /* 69765 */   // GIR_Coverage, 10967,
     /* 69765 */   GIR_Done,
     /* 69766 */ // Label 2081: @69766
     /* 69766 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(69796), // Rule ID 11516 //
     /* 69771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 69774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 69777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69785 */   // (uint_to_fp:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PSZrr:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)
     /* 69785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZrr),
     /* 69790 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69794 */   GIR_RootConstrainSelectedInstOperands,
     /* 69795 */   // GIR_Coverage, 11516,
     /* 69795 */   GIR_Done,
     /* 69796 */ // Label 2082: @69796
     /* 69796 */ GIM_Reject,
     /* 69797 */ // Label 2062: @69797
     /* 69797 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(69823), // Rule ID 10904 //
     /* 69802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 69805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 69808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69816 */   // (uint_to_fp:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)
     /* 69816 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZrr),
     /* 69821 */   GIR_RootConstrainSelectedInstOperands,
     /* 69822 */   // GIR_Coverage, 10904,
     /* 69822 */   GIR_Done,
     /* 69823 */ // Label 2083: @69823
     /* 69823 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(69853), // Rule ID 11396 //
     /* 69828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 69831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 69834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69842 */   // (uint_to_fp:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PDZrr:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)
     /* 69842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZrr),
     /* 69847 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69851 */   GIR_RootConstrainSelectedInstOperands,
     /* 69852 */   // GIR_Coverage, 11396,
     /* 69852 */   GIR_Done,
     /* 69853 */ // Label 2084: @69853
     /* 69853 */ GIM_Reject,
     /* 69854 */ // Label 2063: @69854
     /* 69854 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(69884), // Rule ID 11462 //
     /* 69859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 69862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 69865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69873 */   // (uint_to_fp:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTUDQ2PHZrr:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)
     /* 69873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZrr),
     /* 69878 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69882 */   GIR_RootConstrainSelectedInstOperands,
     /* 69883 */   // GIR_Coverage, 11462,
     /* 69883 */   GIR_Done,
     /* 69884 */ // Label 2085: @69884
     /* 69884 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(69914), // Rule ID 14681 //
     /* 69889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 69892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 69895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69903 */   // (uint_to_fp:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)  =>  (VCVTUW2PHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)
     /* 69903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ256rr),
     /* 69908 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69912 */   GIR_RootConstrainSelectedInstOperands,
     /* 69913 */   // GIR_Coverage, 14681,
     /* 69913 */   GIR_Done,
     /* 69914 */ // Label 2086: @69914
     /* 69914 */ GIM_Reject,
     /* 69915 */ // Label 2064: @69915
     /* 69915 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(69945), // Rule ID 10940 //
     /* 69920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 69923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 69926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69934 */   // (uint_to_fp:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTUDQ2PSZrr:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)
     /* 69934 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZrr),
     /* 69939 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69943 */   GIR_RootConstrainSelectedInstOperands,
     /* 69944 */   // GIR_Coverage, 10940,
     /* 69944 */   GIR_Done,
     /* 69945 */ // Label 2087: @69945
     /* 69945 */ GIM_Reject,
     /* 69946 */ // Label 2065: @69946
     /* 69946 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(69976), // Rule ID 14654 //
     /* 69951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 69954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 69957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69965 */   // (uint_to_fp:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)  =>  (VCVTUW2PHZrr:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)
     /* 69965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZrr),
     /* 69970 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69974 */   GIR_RootConstrainSelectedInstOperands,
     /* 69975 */   // GIR_Coverage, 14654,
     /* 69975 */   GIR_Done,
     /* 69976 */ // Label 2088: @69976
     /* 69976 */ GIM_Reject,
     /* 69977 */ // Label 2066: @69977
     /* 69977 */ GIM_Reject,
     /* 69978 */ // Label 46: @69978
     /* 69978 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 2092*/ GIMT_Encode4(70100),
     /* 69989 */ /*GILLT_s32*//*Label 2089*/ GIMT_Encode4(70001),
     /* 69993 */ /*GILLT_s64*//*Label 2090*/ GIMT_Encode4(70034),
     /* 69997 */ /*GILLT_s80*//*Label 2091*/ GIMT_Encode4(70067),
     /* 70001 */ // Label 2089: @70001
     /* 70001 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(70033), // Rule ID 1042 //
     /* 70006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 70009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 70012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 70016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 70020 */   // (fabs:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (ABS_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 70020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp32),
     /* 70025 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 70031 */   GIR_RootConstrainSelectedInstOperands,
     /* 70032 */   // GIR_Coverage, 1042,
     /* 70032 */   GIR_Done,
     /* 70033 */ // Label 2093: @70033
     /* 70033 */ GIM_Reject,
     /* 70034 */ // Label 2090: @70034
     /* 70034 */ GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(70066), // Rule ID 1043 //
     /* 70039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 70042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 70045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 70049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 70053 */   // (fabs:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (ABS_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 70053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp64),
     /* 70058 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 70064 */   GIR_RootConstrainSelectedInstOperands,
     /* 70065 */   // GIR_Coverage, 1043,
     /* 70065 */   GIR_Done,
     /* 70066 */ // Label 2094: @70066
     /* 70066 */ GIM_Reject,
     /* 70067 */ // Label 2091: @70067
     /* 70067 */ GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(70099), // Rule ID 1044 //
     /* 70072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 70075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 70078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 70082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 70086 */   // (fabs:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (ABS_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 70086 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp80),
     /* 70091 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 70097 */   GIR_RootConstrainSelectedInstOperands,
     /* 70098 */   // GIR_Coverage, 1044,
     /* 70098 */   GIR_Done,
     /* 70099 */ // Label 2095: @70099
     /* 70099 */ GIM_Reject,
     /* 70100 */ // Label 2092: @70100
     /* 70100 */ GIM_Reject,
     /* 70101 */ // Label 47: @70101
     /* 70101 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2108*/ GIMT_Encode4(71197),
     /* 70112 */ /*GILLT_v2s64*//*Label 2096*/ GIMT_Encode4(70180), GIMT_Encode4(0),
     /* 70120 */ /*GILLT_v4s32*//*Label 2097*/ GIMT_Encode4(70385),
     /* 70124 */ /*GILLT_v4s64*//*Label 2098*/ GIMT_Encode4(70479), GIMT_Encode4(0),
     /* 70132 */ /*GILLT_v8s16*//*Label 2099*/ GIMT_Encode4(70672),
     /* 70136 */ /*GILLT_v8s32*//*Label 2100*/ GIMT_Encode4(70766),
     /* 70140 */ /*GILLT_v8s64*//*Label 2101*/ GIMT_Encode4(70833), GIMT_Encode4(0),
     /* 70148 */ /*GILLT_v16s8*//*Label 2102*/ GIMT_Encode4(70867),
     /* 70152 */ /*GILLT_v16s16*//*Label 2103*/ GIMT_Encode4(70961),
     /* 70156 */ /*GILLT_v16s32*//*Label 2104*/ GIMT_Encode4(71028), GIMT_Encode4(0),
     /* 70164 */ /*GILLT_v32s8*//*Label 2105*/ GIMT_Encode4(71062),
     /* 70168 */ /*GILLT_v32s16*//*Label 2106*/ GIMT_Encode4(71129), GIMT_Encode4(0),
     /* 70176 */ /*GILLT_v64s8*//*Label 2107*/ GIMT_Encode4(71163),
     /* 70180 */ // Label 2096: @70180
     /* 70180 */ GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(70384),
     /* 70185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 70188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 70191 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(70218), // Rule ID 5584 //
     /* 70196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 70199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70211 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMINSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 70211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rr),
     /* 70216 */     GIR_RootConstrainSelectedInstOperands,
     /* 70217 */     // GIR_Coverage, 5584,
     /* 70217 */     GIR_Done,
     /* 70218 */   // Label 2110: @70218
     /* 70218 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(70383), // Rule ID 20461 //
     /* 70223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 70226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 70230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70238 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMINSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 70238 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 70241 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 70245 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 70252 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 70255 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 70259 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70264 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 70267 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 70271 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 70274 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 70279 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 70284 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 70289 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 70292 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 70296 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 70303 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 70306 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 70310 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70315 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 70318 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 70322 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 70325 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 70330 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 70335 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 70340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 70343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 70347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70352 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 70355 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 70358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 70360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 70363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 70365 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 70372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 70377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 70382 */     // GIR_Coverage, 20461,
     /* 70382 */     GIR_EraseRootFromParent_Done,
     /* 70383 */   // Label 2111: @70383
     /* 70383 */   GIM_Reject,
     /* 70384 */ // Label 2109: @70384
     /* 70384 */ GIM_Reject,
     /* 70385 */ // Label 2097: @70385
     /* 70385 */ GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(70478),
     /* 70390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 70393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 70396 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(70423), // Rule ID 3182 //
     /* 70401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 70404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70416 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMINSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 70416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDrr),
     /* 70421 */     GIR_RootConstrainSelectedInstOperands,
     /* 70422 */     // GIR_Coverage, 3182,
     /* 70422 */     GIR_Done,
     /* 70423 */   // Label 2113: @70423
     /* 70423 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(70450), // Rule ID 3220 //
     /* 70428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 70431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70443 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMINSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 70443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSDrr),
     /* 70448 */     GIR_RootConstrainSelectedInstOperands,
     /* 70449 */     // GIR_Coverage, 3220,
     /* 70449 */     GIR_Done,
     /* 70450 */   // Label 2114: @70450
     /* 70450 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(70477), // Rule ID 5557 //
     /* 70455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 70458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70470 */     // (smin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMINSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 70470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rr),
     /* 70475 */     GIR_RootConstrainSelectedInstOperands,
     /* 70476 */     // GIR_Coverage, 5557,
     /* 70476 */     GIR_Done,
     /* 70477 */   // Label 2115: @70477
     /* 70477 */   GIM_Reject,
     /* 70478 */ // Label 2112: @70478
     /* 70478 */ GIM_Reject,
     /* 70479 */ // Label 2098: @70479
     /* 70479 */ GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(70671),
     /* 70484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 70487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 70490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70502 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(70517), // Rule ID 5575 //
     /* 70507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 70510 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMINSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 70510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rr),
     /* 70515 */     GIR_RootConstrainSelectedInstOperands,
     /* 70516 */     // GIR_Coverage, 5575,
     /* 70516 */     GIR_Done,
     /* 70517 */   // Label 2117: @70517
     /* 70517 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(70670), // Rule ID 20459 //
     /* 70522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 70525 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMINSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 70525 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 70528 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 70532 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 70539 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 70542 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 70546 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70551 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 70554 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 70558 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 70561 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 70566 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 70571 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 70576 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 70579 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 70583 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 70590 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 70593 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 70597 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70602 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 70605 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 70609 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 70612 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 70617 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 70622 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 70627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 70630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 70634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70639 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 70642 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 70645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 70647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 70650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 70652 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 70659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 70664 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 70669 */     // GIR_Coverage, 20459,
     /* 70669 */     GIR_EraseRootFromParent_Done,
     /* 70670 */   // Label 2118: @70670
     /* 70670 */   GIM_Reject,
     /* 70671 */ // Label 2116: @70671
     /* 70671 */ GIM_Reject,
     /* 70672 */ // Label 2099: @70672
     /* 70672 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(70765),
     /* 70677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 70680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 70683 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(70710), // Rule ID 2639 //
     /* 70688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 70691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70703 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMINSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 70703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWrr),
     /* 70708 */     GIR_RootConstrainSelectedInstOperands,
     /* 70709 */     // GIR_Coverage, 2639,
     /* 70709 */     GIR_Done,
     /* 70710 */   // Label 2120: @70710
     /* 70710 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(70737), // Rule ID 2641 //
     /* 70715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 70718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70730 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMINSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 70730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSWrr),
     /* 70735 */     GIR_RootConstrainSelectedInstOperands,
     /* 70736 */     // GIR_Coverage, 2641,
     /* 70736 */     GIR_Done,
     /* 70737 */   // Label 2121: @70737
     /* 70737 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(70764), // Rule ID 5533 //
     /* 70742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 70745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70757 */     // (smin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMINSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 70757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rr),
     /* 70762 */     GIR_RootConstrainSelectedInstOperands,
     /* 70763 */     // GIR_Coverage, 5533,
     /* 70763 */     GIR_Done,
     /* 70764 */   // Label 2122: @70764
     /* 70764 */   GIM_Reject,
     /* 70765 */ // Label 2119: @70765
     /* 70765 */ GIM_Reject,
     /* 70766 */ // Label 2100: @70766
     /* 70766 */ GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(70832),
     /* 70771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 70774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 70777 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(70804), // Rule ID 3200 //
     /* 70782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 70785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 70789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 70793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 70797 */     // (smin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMINSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 70797 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrr),
     /* 70802 */     GIR_RootConstrainSelectedInstOperands,
     /* 70803 */     // GIR_Coverage, 3200,
     /* 70803 */     GIR_Done,
     /* 70804 */   // Label 2124: @70804
     /* 70804 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(70831), // Rule ID 5548 //
     /* 70809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 70812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70824 */     // (smin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMINSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 70824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rr),
     /* 70829 */     GIR_RootConstrainSelectedInstOperands,
     /* 70830 */     // GIR_Coverage, 5548,
     /* 70830 */     GIR_Done,
     /* 70831 */   // Label 2125: @70831
     /* 70831 */   GIM_Reject,
     /* 70832 */ // Label 2123: @70832
     /* 70832 */ GIM_Reject,
     /* 70833 */ // Label 2101: @70833
     /* 70833 */ GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(70866), // Rule ID 5566 //
     /* 70838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 70841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 70844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 70847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 70851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 70855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 70859 */   // (smin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMINSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 70859 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 70864 */   GIR_RootConstrainSelectedInstOperands,
     /* 70865 */   // GIR_Coverage, 5566,
     /* 70865 */   GIR_Done,
     /* 70866 */ // Label 2126: @70866
     /* 70866 */ GIM_Reject,
     /* 70867 */ // Label 2102: @70867
     /* 70867 */ GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(70960),
     /* 70872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 70875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 70878 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(70905), // Rule ID 3192 //
     /* 70883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 70886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70898 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMINSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 70898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBrr),
     /* 70903 */     GIR_RootConstrainSelectedInstOperands,
     /* 70904 */     // GIR_Coverage, 3192,
     /* 70904 */     GIR_Done,
     /* 70905 */   // Label 2128: @70905
     /* 70905 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(70932), // Rule ID 3218 //
     /* 70910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 70913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70925 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMINSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 70925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSBrr),
     /* 70930 */     GIR_RootConstrainSelectedInstOperands,
     /* 70931 */     // GIR_Coverage, 3218,
     /* 70931 */     GIR_Done,
     /* 70932 */   // Label 2129: @70932
     /* 70932 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(70959), // Rule ID 5515 //
     /* 70937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 70940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70952 */     // (smin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMINSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 70952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rr),
     /* 70957 */     GIR_RootConstrainSelectedInstOperands,
     /* 70958 */     // GIR_Coverage, 5515,
     /* 70958 */     GIR_Done,
     /* 70959 */   // Label 2130: @70959
     /* 70959 */   GIM_Reject,
     /* 70960 */ // Label 2127: @70960
     /* 70960 */ GIM_Reject,
     /* 70961 */ // Label 2103: @70961
     /* 70961 */ GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(71027),
     /* 70966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 70969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 70972 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(70999), // Rule ID 2643 //
     /* 70977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 70980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 70984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 70988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 70992 */     // (smin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMINSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 70992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrr),
     /* 70997 */     GIR_RootConstrainSelectedInstOperands,
     /* 70998 */     // GIR_Coverage, 2643,
     /* 70998 */     GIR_Done,
     /* 70999 */   // Label 2132: @70999
     /* 70999 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(71026), // Rule ID 5527 //
     /* 71004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 71007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71019 */     // (smin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMINSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 71019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rr),
     /* 71024 */     GIR_RootConstrainSelectedInstOperands,
     /* 71025 */     // GIR_Coverage, 5527,
     /* 71025 */     GIR_Done,
     /* 71026 */   // Label 2133: @71026
     /* 71026 */   GIM_Reject,
     /* 71027 */ // Label 2131: @71027
     /* 71027 */ GIM_Reject,
     /* 71028 */ // Label 2104: @71028
     /* 71028 */ GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(71061), // Rule ID 5539 //
     /* 71033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 71036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 71039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 71042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71050 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71054 */   // (smin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMINSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 71054 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrr),
     /* 71059 */   GIR_RootConstrainSelectedInstOperands,
     /* 71060 */   // GIR_Coverage, 5539,
     /* 71060 */   GIR_Done,
     /* 71061 */ // Label 2134: @71061
     /* 71061 */ GIM_Reject,
     /* 71062 */ // Label 2105: @71062
     /* 71062 */ GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(71128),
     /* 71067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 71070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 71073 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(71100), // Rule ID 3210 //
     /* 71078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 71081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 71085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 71089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 71093 */     // (smin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMINSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 71093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrr),
     /* 71098 */     GIR_RootConstrainSelectedInstOperands,
     /* 71099 */     // GIR_Coverage, 3210,
     /* 71099 */     GIR_Done,
     /* 71100 */   // Label 2136: @71100
     /* 71100 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(71127), // Rule ID 5509 //
     /* 71105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 71108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71120 */     // (smin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMINSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 71120 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rr),
     /* 71125 */     GIR_RootConstrainSelectedInstOperands,
     /* 71126 */     // GIR_Coverage, 5509,
     /* 71126 */     GIR_Done,
     /* 71127 */   // Label 2137: @71127
     /* 71127 */   GIM_Reject,
     /* 71128 */ // Label 2135: @71128
     /* 71128 */ GIM_Reject,
     /* 71129 */ // Label 2106: @71129
     /* 71129 */ GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(71162), // Rule ID 5521 //
     /* 71134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 71137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 71140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 71143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71155 */   // (smin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMINSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 71155 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrr),
     /* 71160 */   GIR_RootConstrainSelectedInstOperands,
     /* 71161 */   // GIR_Coverage, 5521,
     /* 71161 */   GIR_Done,
     /* 71162 */ // Label 2138: @71162
     /* 71162 */ GIM_Reject,
     /* 71163 */ // Label 2107: @71163
     /* 71163 */ GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(71196), // Rule ID 5503 //
     /* 71168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 71171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 71174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 71177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71189 */   // (smin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMINSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 71189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrr),
     /* 71194 */   GIR_RootConstrainSelectedInstOperands,
     /* 71195 */   // GIR_Coverage, 5503,
     /* 71195 */   GIR_Done,
     /* 71196 */ // Label 2139: @71196
     /* 71196 */ GIM_Reject,
     /* 71197 */ // Label 2108: @71197
     /* 71197 */ GIM_Reject,
     /* 71198 */ // Label 48: @71198
     /* 71198 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2152*/ GIMT_Encode4(72294),
     /* 71209 */ /*GILLT_v2s64*//*Label 2140*/ GIMT_Encode4(71277), GIMT_Encode4(0),
     /* 71217 */ /*GILLT_v4s32*//*Label 2141*/ GIMT_Encode4(71482),
     /* 71221 */ /*GILLT_v4s64*//*Label 2142*/ GIMT_Encode4(71576), GIMT_Encode4(0),
     /* 71229 */ /*GILLT_v8s16*//*Label 2143*/ GIMT_Encode4(71769),
     /* 71233 */ /*GILLT_v8s32*//*Label 2144*/ GIMT_Encode4(71863),
     /* 71237 */ /*GILLT_v8s64*//*Label 2145*/ GIMT_Encode4(71930), GIMT_Encode4(0),
     /* 71245 */ /*GILLT_v16s8*//*Label 2146*/ GIMT_Encode4(71964),
     /* 71249 */ /*GILLT_v16s16*//*Label 2147*/ GIMT_Encode4(72058),
     /* 71253 */ /*GILLT_v16s32*//*Label 2148*/ GIMT_Encode4(72125), GIMT_Encode4(0),
     /* 71261 */ /*GILLT_v32s8*//*Label 2149*/ GIMT_Encode4(72159),
     /* 71265 */ /*GILLT_v32s16*//*Label 2150*/ GIMT_Encode4(72226), GIMT_Encode4(0),
     /* 71273 */ /*GILLT_v64s8*//*Label 2151*/ GIMT_Encode4(72260),
     /* 71277 */ // Label 2140: @71277
     /* 71277 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(71481),
     /* 71282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 71285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 71288 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(71315), // Rule ID 5404 //
     /* 71293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 71296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71308 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMAXSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 71308 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rr),
     /* 71313 */     GIR_RootConstrainSelectedInstOperands,
     /* 71314 */     // GIR_Coverage, 5404,
     /* 71314 */     GIR_Done,
     /* 71315 */   // Label 2154: @71315
     /* 71315 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(71480), // Rule ID 20457 //
     /* 71320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 71323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 71327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71335 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMAXSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 71335 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 71338 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 71342 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 71347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 71349 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 71352 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 71356 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 71361 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 71364 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 71368 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 71371 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 71376 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 71381 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 71386 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 71389 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 71393 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 71398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 71400 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 71403 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 71407 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 71412 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 71415 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 71419 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 71422 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 71427 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 71432 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 71437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 71440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 71444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 71449 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 71452 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 71455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 71457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 71460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 71462 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 71469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 71474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 71479 */     // GIR_Coverage, 20457,
     /* 71479 */     GIR_EraseRootFromParent_Done,
     /* 71480 */   // Label 2155: @71480
     /* 71480 */   GIM_Reject,
     /* 71481 */ // Label 2153: @71481
     /* 71481 */ GIM_Reject,
     /* 71482 */ // Label 2141: @71482
     /* 71482 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(71575),
     /* 71487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 71490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 71493 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(71520), // Rule ID 3186 //
     /* 71498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 71501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71513 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMAXSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 71513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrr),
     /* 71518 */     GIR_RootConstrainSelectedInstOperands,
     /* 71519 */     // GIR_Coverage, 3186,
     /* 71519 */     GIR_Done,
     /* 71520 */   // Label 2157: @71520
     /* 71520 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(71547), // Rule ID 3228 //
     /* 71525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 71528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71540 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMAXSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 71540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSDrr),
     /* 71545 */     GIR_RootConstrainSelectedInstOperands,
     /* 71546 */     // GIR_Coverage, 3228,
     /* 71546 */     GIR_Done,
     /* 71547 */   // Label 2158: @71547
     /* 71547 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(71574), // Rule ID 5377 //
     /* 71552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 71555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71567 */     // (smax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMAXSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 71567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rr),
     /* 71572 */     GIR_RootConstrainSelectedInstOperands,
     /* 71573 */     // GIR_Coverage, 5377,
     /* 71573 */     GIR_Done,
     /* 71574 */   // Label 2159: @71574
     /* 71574 */   GIM_Reject,
     /* 71575 */ // Label 2156: @71575
     /* 71575 */ GIM_Reject,
     /* 71576 */ // Label 2142: @71576
     /* 71576 */ GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(71768),
     /* 71581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 71584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 71587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71595 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71599 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(71614), // Rule ID 5395 //
     /* 71604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 71607 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMAXSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 71607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rr),
     /* 71612 */     GIR_RootConstrainSelectedInstOperands,
     /* 71613 */     // GIR_Coverage, 5395,
     /* 71613 */     GIR_Done,
     /* 71614 */   // Label 2161: @71614
     /* 71614 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(71767), // Rule ID 20455 //
     /* 71619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 71622 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMAXSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 71622 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 71625 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 71629 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 71634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 71636 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 71639 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 71643 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 71648 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 71651 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 71655 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 71658 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 71663 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 71668 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 71673 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 71676 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 71680 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 71685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 71687 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 71690 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 71694 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 71699 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 71702 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 71706 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 71709 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 71714 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 71719 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 71724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 71727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 71731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 71736 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 71739 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 71742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 71744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 71747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 71749 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 71756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 71761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 71766 */     // GIR_Coverage, 20455,
     /* 71766 */     GIR_EraseRootFromParent_Done,
     /* 71767 */   // Label 2162: @71767
     /* 71767 */   GIM_Reject,
     /* 71768 */ // Label 2160: @71768
     /* 71768 */ GIM_Reject,
     /* 71769 */ // Label 2143: @71769
     /* 71769 */ GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(71862),
     /* 71774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 71777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 71780 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(71807), // Rule ID 2651 //
     /* 71785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 71788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71800 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMAXSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 71800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrr),
     /* 71805 */     GIR_RootConstrainSelectedInstOperands,
     /* 71806 */     // GIR_Coverage, 2651,
     /* 71806 */     GIR_Done,
     /* 71807 */   // Label 2164: @71807
     /* 71807 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(71834), // Rule ID 2653 //
     /* 71812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 71815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71827 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMAXSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 71827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSWrr),
     /* 71832 */     GIR_RootConstrainSelectedInstOperands,
     /* 71833 */     // GIR_Coverage, 2653,
     /* 71833 */     GIR_Done,
     /* 71834 */   // Label 2165: @71834
     /* 71834 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(71861), // Rule ID 5353 //
     /* 71839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 71842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71854 */     // (smax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMAXSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 71854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rr),
     /* 71859 */     GIR_RootConstrainSelectedInstOperands,
     /* 71860 */     // GIR_Coverage, 5353,
     /* 71860 */     GIR_Done,
     /* 71861 */   // Label 2166: @71861
     /* 71861 */   GIM_Reject,
     /* 71862 */ // Label 2163: @71862
     /* 71862 */ GIM_Reject,
     /* 71863 */ // Label 2144: @71863
     /* 71863 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(71929),
     /* 71868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 71871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 71874 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(71901), // Rule ID 3204 //
     /* 71879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 71882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 71886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 71890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 71894 */     // (smax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMAXSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 71894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrr),
     /* 71899 */     GIR_RootConstrainSelectedInstOperands,
     /* 71900 */     // GIR_Coverage, 3204,
     /* 71900 */     GIR_Done,
     /* 71901 */   // Label 2168: @71901
     /* 71901 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(71928), // Rule ID 5368 //
     /* 71906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 71909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71921 */     // (smax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMAXSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 71921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rr),
     /* 71926 */     GIR_RootConstrainSelectedInstOperands,
     /* 71927 */     // GIR_Coverage, 5368,
     /* 71927 */     GIR_Done,
     /* 71928 */   // Label 2169: @71928
     /* 71928 */   GIM_Reject,
     /* 71929 */ // Label 2167: @71929
     /* 71929 */ GIM_Reject,
     /* 71930 */ // Label 2145: @71930
     /* 71930 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(71963), // Rule ID 5386 //
     /* 71935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 71938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 71941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 71944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71952 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71956 */   // (smax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMAXSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 71956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 71961 */   GIR_RootConstrainSelectedInstOperands,
     /* 71962 */   // GIR_Coverage, 5386,
     /* 71962 */   GIR_Done,
     /* 71963 */ // Label 2170: @71963
     /* 71963 */ GIM_Reject,
     /* 71964 */ // Label 2146: @71964
     /* 71964 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(72057),
     /* 71969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 71972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 71975 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(72002), // Rule ID 3196 //
     /* 71980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 71983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71995 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMAXSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 71995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrr),
     /* 72000 */     GIR_RootConstrainSelectedInstOperands,
     /* 72001 */     // GIR_Coverage, 3196,
     /* 72001 */     GIR_Done,
     /* 72002 */   // Label 2172: @72002
     /* 72002 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(72029), // Rule ID 3226 //
     /* 72007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 72010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72022 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMAXSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 72022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSBrr),
     /* 72027 */     GIR_RootConstrainSelectedInstOperands,
     /* 72028 */     // GIR_Coverage, 3226,
     /* 72028 */     GIR_Done,
     /* 72029 */   // Label 2173: @72029
     /* 72029 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(72056), // Rule ID 5335 //
     /* 72034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 72037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72049 */     // (smax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMAXSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 72049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rr),
     /* 72054 */     GIR_RootConstrainSelectedInstOperands,
     /* 72055 */     // GIR_Coverage, 5335,
     /* 72055 */     GIR_Done,
     /* 72056 */   // Label 2174: @72056
     /* 72056 */   GIM_Reject,
     /* 72057 */ // Label 2171: @72057
     /* 72057 */ GIM_Reject,
     /* 72058 */ // Label 2147: @72058
     /* 72058 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(72124),
     /* 72063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 72066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 72069 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(72096), // Rule ID 2655 //
     /* 72074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 72077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72089 */     // (smax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMAXSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 72089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrr),
     /* 72094 */     GIR_RootConstrainSelectedInstOperands,
     /* 72095 */     // GIR_Coverage, 2655,
     /* 72095 */     GIR_Done,
     /* 72096 */   // Label 2176: @72096
     /* 72096 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(72123), // Rule ID 5347 //
     /* 72101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 72104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72116 */     // (smax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMAXSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 72116 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rr),
     /* 72121 */     GIR_RootConstrainSelectedInstOperands,
     /* 72122 */     // GIR_Coverage, 5347,
     /* 72122 */     GIR_Done,
     /* 72123 */   // Label 2177: @72123
     /* 72123 */   GIM_Reject,
     /* 72124 */ // Label 2175: @72124
     /* 72124 */ GIM_Reject,
     /* 72125 */ // Label 2148: @72125
     /* 72125 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(72158), // Rule ID 5359 //
     /* 72130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 72133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 72136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 72139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72147 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72151 */   // (smax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMAXSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 72151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrr),
     /* 72156 */   GIR_RootConstrainSelectedInstOperands,
     /* 72157 */   // GIR_Coverage, 5359,
     /* 72157 */   GIR_Done,
     /* 72158 */ // Label 2178: @72158
     /* 72158 */ GIM_Reject,
     /* 72159 */ // Label 2149: @72159
     /* 72159 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(72225),
     /* 72164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 72167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 72170 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(72197), // Rule ID 3214 //
     /* 72175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 72178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72190 */     // (smax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMAXSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 72190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrr),
     /* 72195 */     GIR_RootConstrainSelectedInstOperands,
     /* 72196 */     // GIR_Coverage, 3214,
     /* 72196 */     GIR_Done,
     /* 72197 */   // Label 2180: @72197
     /* 72197 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(72224), // Rule ID 5329 //
     /* 72202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 72205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72217 */     // (smax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMAXSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 72217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rr),
     /* 72222 */     GIR_RootConstrainSelectedInstOperands,
     /* 72223 */     // GIR_Coverage, 5329,
     /* 72223 */     GIR_Done,
     /* 72224 */   // Label 2181: @72224
     /* 72224 */   GIM_Reject,
     /* 72225 */ // Label 2179: @72225
     /* 72225 */ GIM_Reject,
     /* 72226 */ // Label 2150: @72226
     /* 72226 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(72259), // Rule ID 5341 //
     /* 72231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 72234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 72237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 72240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72252 */   // (smax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMAXSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 72252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrr),
     /* 72257 */   GIR_RootConstrainSelectedInstOperands,
     /* 72258 */   // GIR_Coverage, 5341,
     /* 72258 */   GIR_Done,
     /* 72259 */ // Label 2182: @72259
     /* 72259 */ GIM_Reject,
     /* 72260 */ // Label 2151: @72260
     /* 72260 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(72293), // Rule ID 5323 //
     /* 72265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 72268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 72271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 72274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72282 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72286 */   // (smax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMAXSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 72286 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrr),
     /* 72291 */   GIR_RootConstrainSelectedInstOperands,
     /* 72292 */   // GIR_Coverage, 5323,
     /* 72292 */   GIR_Done,
     /* 72293 */ // Label 2183: @72293
     /* 72293 */ GIM_Reject,
     /* 72294 */ // Label 2152: @72294
     /* 72294 */ GIM_Reject,
     /* 72295 */ // Label 49: @72295
     /* 72295 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2196*/ GIMT_Encode4(73391),
     /* 72306 */ /*GILLT_v2s64*//*Label 2184*/ GIMT_Encode4(72374), GIMT_Encode4(0),
     /* 72314 */ /*GILLT_v4s32*//*Label 2185*/ GIMT_Encode4(72579),
     /* 72318 */ /*GILLT_v4s64*//*Label 2186*/ GIMT_Encode4(72673), GIMT_Encode4(0),
     /* 72326 */ /*GILLT_v8s16*//*Label 2187*/ GIMT_Encode4(72866),
     /* 72330 */ /*GILLT_v8s32*//*Label 2188*/ GIMT_Encode4(72960),
     /* 72334 */ /*GILLT_v8s64*//*Label 2189*/ GIMT_Encode4(73027), GIMT_Encode4(0),
     /* 72342 */ /*GILLT_v16s8*//*Label 2190*/ GIMT_Encode4(73061),
     /* 72346 */ /*GILLT_v16s16*//*Label 2191*/ GIMT_Encode4(73155),
     /* 72350 */ /*GILLT_v16s32*//*Label 2192*/ GIMT_Encode4(73222), GIMT_Encode4(0),
     /* 72358 */ /*GILLT_v32s8*//*Label 2193*/ GIMT_Encode4(73256),
     /* 72362 */ /*GILLT_v32s16*//*Label 2194*/ GIMT_Encode4(73323), GIMT_Encode4(0),
     /* 72370 */ /*GILLT_v64s8*//*Label 2195*/ GIMT_Encode4(73357),
     /* 72374 */ // Label 2184: @72374
     /* 72374 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(72578),
     /* 72379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 72382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 72385 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(72412), // Rule ID 5674 //
     /* 72390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 72393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72405 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMINUQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 72405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rr),
     /* 72410 */     GIR_RootConstrainSelectedInstOperands,
     /* 72411 */     // GIR_Coverage, 5674,
     /* 72411 */     GIR_Done,
     /* 72412 */   // Label 2198: @72412
     /* 72412 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(72577), // Rule ID 20453 //
     /* 72417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 72420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 72424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72432 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMINUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 72432 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 72435 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 72439 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 72446 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 72449 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 72453 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72458 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 72461 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 72465 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 72468 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 72473 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 72478 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 72483 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 72486 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 72490 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 72497 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 72500 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 72504 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72509 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 72512 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 72516 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 72519 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 72524 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 72529 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 72534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 72537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 72541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72546 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 72549 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 72552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 72554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 72557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 72559 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 72566 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 72571 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 72576 */     // GIR_Coverage, 20453,
     /* 72576 */     GIR_EraseRootFromParent_Done,
     /* 72577 */   // Label 2199: @72577
     /* 72577 */   GIM_Reject,
     /* 72578 */ // Label 2197: @72578
     /* 72578 */ GIM_Reject,
     /* 72579 */ // Label 2185: @72579
     /* 72579 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(72672),
     /* 72584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 72587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 72590 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(72617), // Rule ID 3184 //
     /* 72595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 72598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72610 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMINUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 72610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDrr),
     /* 72615 */     GIR_RootConstrainSelectedInstOperands,
     /* 72616 */     // GIR_Coverage, 3184,
     /* 72616 */     GIR_Done,
     /* 72617 */   // Label 2201: @72617
     /* 72617 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(72644), // Rule ID 3222 //
     /* 72622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 72625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72637 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMINUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 72637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUDrr),
     /* 72642 */     GIR_RootConstrainSelectedInstOperands,
     /* 72643 */     // GIR_Coverage, 3222,
     /* 72643 */     GIR_Done,
     /* 72644 */   // Label 2202: @72644
     /* 72644 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(72671), // Rule ID 5647 //
     /* 72649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 72652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72664 */     // (umin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMINUDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 72664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rr),
     /* 72669 */     GIR_RootConstrainSelectedInstOperands,
     /* 72670 */     // GIR_Coverage, 5647,
     /* 72670 */     GIR_Done,
     /* 72671 */   // Label 2203: @72671
     /* 72671 */   GIM_Reject,
     /* 72672 */ // Label 2200: @72672
     /* 72672 */ GIM_Reject,
     /* 72673 */ // Label 2186: @72673
     /* 72673 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(72865),
     /* 72678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 72681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 72684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72692 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72696 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(72711), // Rule ID 5665 //
     /* 72701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 72704 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMINUQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 72704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rr),
     /* 72709 */     GIR_RootConstrainSelectedInstOperands,
     /* 72710 */     // GIR_Coverage, 5665,
     /* 72710 */     GIR_Done,
     /* 72711 */   // Label 2205: @72711
     /* 72711 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(72864), // Rule ID 20451 //
     /* 72716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 72719 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMINUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 72719 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 72722 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 72726 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 72733 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 72736 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 72740 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72745 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 72748 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 72752 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 72755 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 72760 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 72765 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 72770 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 72773 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 72777 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 72784 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 72787 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 72791 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72796 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 72799 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 72803 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 72806 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 72811 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 72816 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 72821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 72824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 72828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72833 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 72836 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 72839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 72841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 72844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 72846 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 72853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 72858 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 72863 */     // GIR_Coverage, 20451,
     /* 72863 */     GIR_EraseRootFromParent_Done,
     /* 72864 */   // Label 2206: @72864
     /* 72864 */   GIM_Reject,
     /* 72865 */ // Label 2204: @72865
     /* 72865 */ GIM_Reject,
     /* 72866 */ // Label 2187: @72866
     /* 72866 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(72959),
     /* 72871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 72874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 72877 */   GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(72904), // Rule ID 3194 //
     /* 72882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 72885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72897 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMINUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 72897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWrr),
     /* 72902 */     GIR_RootConstrainSelectedInstOperands,
     /* 72903 */     // GIR_Coverage, 3194,
     /* 72903 */     GIR_Done,
     /* 72904 */   // Label 2208: @72904
     /* 72904 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(72931), // Rule ID 3224 //
     /* 72909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 72912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72924 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMINUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 72924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUWrr),
     /* 72929 */     GIR_RootConstrainSelectedInstOperands,
     /* 72930 */     // GIR_Coverage, 3224,
     /* 72930 */     GIR_Done,
     /* 72931 */   // Label 2209: @72931
     /* 72931 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(72958), // Rule ID 5623 //
     /* 72936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 72939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72951 */     // (umin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMINUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 72951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rr),
     /* 72956 */     GIR_RootConstrainSelectedInstOperands,
     /* 72957 */     // GIR_Coverage, 5623,
     /* 72957 */     GIR_Done,
     /* 72958 */   // Label 2210: @72958
     /* 72958 */   GIM_Reject,
     /* 72959 */ // Label 2207: @72959
     /* 72959 */ GIM_Reject,
     /* 72960 */ // Label 2188: @72960
     /* 72960 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(73026),
     /* 72965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 72968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 72971 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(72998), // Rule ID 3202 //
     /* 72976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 72979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72991 */     // (umin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMINUDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 72991 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrr),
     /* 72996 */     GIR_RootConstrainSelectedInstOperands,
     /* 72997 */     // GIR_Coverage, 3202,
     /* 72997 */     GIR_Done,
     /* 72998 */   // Label 2212: @72998
     /* 72998 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(73025), // Rule ID 5638 //
     /* 73003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 73006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73018 */     // (umin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMINUDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 73018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rr),
     /* 73023 */     GIR_RootConstrainSelectedInstOperands,
     /* 73024 */     // GIR_Coverage, 5638,
     /* 73024 */     GIR_Done,
     /* 73025 */   // Label 2213: @73025
     /* 73025 */   GIM_Reject,
     /* 73026 */ // Label 2211: @73026
     /* 73026 */ GIM_Reject,
     /* 73027 */ // Label 2189: @73027
     /* 73027 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(73060), // Rule ID 5656 //
     /* 73032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 73035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 73038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 73041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73053 */   // (umin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMINUQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 73053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 73058 */   GIR_RootConstrainSelectedInstOperands,
     /* 73059 */   // GIR_Coverage, 5656,
     /* 73059 */   GIR_Done,
     /* 73060 */ // Label 2214: @73060
     /* 73060 */ GIM_Reject,
     /* 73061 */ // Label 2190: @73061
     /* 73061 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(73154),
     /* 73066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 73069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 73072 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(73099), // Rule ID 2633 //
     /* 73077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 73080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73092 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMINUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 73092 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBrr),
     /* 73097 */     GIR_RootConstrainSelectedInstOperands,
     /* 73098 */     // GIR_Coverage, 2633,
     /* 73098 */     GIR_Done,
     /* 73099 */   // Label 2216: @73099
     /* 73099 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(73126), // Rule ID 2635 //
     /* 73104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 73107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73119 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMINUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 73119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUBrr),
     /* 73124 */     GIR_RootConstrainSelectedInstOperands,
     /* 73125 */     // GIR_Coverage, 2635,
     /* 73125 */     GIR_Done,
     /* 73126 */   // Label 2217: @73126
     /* 73126 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(73153), // Rule ID 5605 //
     /* 73131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 73134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73146 */     // (umin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMINUBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 73146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rr),
     /* 73151 */     GIR_RootConstrainSelectedInstOperands,
     /* 73152 */     // GIR_Coverage, 5605,
     /* 73152 */     GIR_Done,
     /* 73153 */   // Label 2218: @73153
     /* 73153 */   GIM_Reject,
     /* 73154 */ // Label 2215: @73154
     /* 73154 */ GIM_Reject,
     /* 73155 */ // Label 2191: @73155
     /* 73155 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(73221),
     /* 73160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 73163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 73166 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(73193), // Rule ID 3212 //
     /* 73171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 73174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 73178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 73182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 73186 */     // (umin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMINUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 73186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrr),
     /* 73191 */     GIR_RootConstrainSelectedInstOperands,
     /* 73192 */     // GIR_Coverage, 3212,
     /* 73192 */     GIR_Done,
     /* 73193 */   // Label 2220: @73193
     /* 73193 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(73220), // Rule ID 5617 //
     /* 73198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 73201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73213 */     // (umin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMINUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 73213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rr),
     /* 73218 */     GIR_RootConstrainSelectedInstOperands,
     /* 73219 */     // GIR_Coverage, 5617,
     /* 73219 */     GIR_Done,
     /* 73220 */   // Label 2221: @73220
     /* 73220 */   GIM_Reject,
     /* 73221 */ // Label 2219: @73221
     /* 73221 */ GIM_Reject,
     /* 73222 */ // Label 2192: @73222
     /* 73222 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(73255), // Rule ID 5629 //
     /* 73227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 73230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 73233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 73236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73244 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73248 */   // (umin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMINUDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 73248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrr),
     /* 73253 */   GIR_RootConstrainSelectedInstOperands,
     /* 73254 */   // GIR_Coverage, 5629,
     /* 73254 */   GIR_Done,
     /* 73255 */ // Label 2222: @73255
     /* 73255 */ GIM_Reject,
     /* 73256 */ // Label 2193: @73256
     /* 73256 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(73322),
     /* 73261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 73264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 73267 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(73294), // Rule ID 2637 //
     /* 73272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 73275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 73279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 73283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 73287 */     // (umin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMINUBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 73287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrr),
     /* 73292 */     GIR_RootConstrainSelectedInstOperands,
     /* 73293 */     // GIR_Coverage, 2637,
     /* 73293 */     GIR_Done,
     /* 73294 */   // Label 2224: @73294
     /* 73294 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(73321), // Rule ID 5599 //
     /* 73299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 73302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73314 */     // (umin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMINUBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 73314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rr),
     /* 73319 */     GIR_RootConstrainSelectedInstOperands,
     /* 73320 */     // GIR_Coverage, 5599,
     /* 73320 */     GIR_Done,
     /* 73321 */   // Label 2225: @73321
     /* 73321 */   GIM_Reject,
     /* 73322 */ // Label 2223: @73322
     /* 73322 */ GIM_Reject,
     /* 73323 */ // Label 2194: @73323
     /* 73323 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(73356), // Rule ID 5611 //
     /* 73328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 73331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 73334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 73337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73349 */   // (umin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMINUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 73349 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrr),
     /* 73354 */   GIR_RootConstrainSelectedInstOperands,
     /* 73355 */   // GIR_Coverage, 5611,
     /* 73355 */   GIR_Done,
     /* 73356 */ // Label 2226: @73356
     /* 73356 */ GIM_Reject,
     /* 73357 */ // Label 2195: @73357
     /* 73357 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(73390), // Rule ID 5593 //
     /* 73362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 73365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 73368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 73371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73383 */   // (umin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMINUBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 73383 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrr),
     /* 73388 */   GIR_RootConstrainSelectedInstOperands,
     /* 73389 */   // GIR_Coverage, 5593,
     /* 73389 */   GIR_Done,
     /* 73390 */ // Label 2227: @73390
     /* 73390 */ GIM_Reject,
     /* 73391 */ // Label 2196: @73391
     /* 73391 */ GIM_Reject,
     /* 73392 */ // Label 50: @73392
     /* 73392 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2240*/ GIMT_Encode4(74488),
     /* 73403 */ /*GILLT_v2s64*//*Label 2228*/ GIMT_Encode4(73471), GIMT_Encode4(0),
     /* 73411 */ /*GILLT_v4s32*//*Label 2229*/ GIMT_Encode4(73676),
     /* 73415 */ /*GILLT_v4s64*//*Label 2230*/ GIMT_Encode4(73770), GIMT_Encode4(0),
     /* 73423 */ /*GILLT_v8s16*//*Label 2231*/ GIMT_Encode4(73963),
     /* 73427 */ /*GILLT_v8s32*//*Label 2232*/ GIMT_Encode4(74057),
     /* 73431 */ /*GILLT_v8s64*//*Label 2233*/ GIMT_Encode4(74124), GIMT_Encode4(0),
     /* 73439 */ /*GILLT_v16s8*//*Label 2234*/ GIMT_Encode4(74158),
     /* 73443 */ /*GILLT_v16s16*//*Label 2235*/ GIMT_Encode4(74252),
     /* 73447 */ /*GILLT_v16s32*//*Label 2236*/ GIMT_Encode4(74319), GIMT_Encode4(0),
     /* 73455 */ /*GILLT_v32s8*//*Label 2237*/ GIMT_Encode4(74353),
     /* 73459 */ /*GILLT_v32s16*//*Label 2238*/ GIMT_Encode4(74420), GIMT_Encode4(0),
     /* 73467 */ /*GILLT_v64s8*//*Label 2239*/ GIMT_Encode4(74454),
     /* 73471 */ // Label 2228: @73471
     /* 73471 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(73675),
     /* 73476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 73479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 73482 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(73509), // Rule ID 5494 //
     /* 73487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 73490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73502 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMAXUQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 73502 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rr),
     /* 73507 */     GIR_RootConstrainSelectedInstOperands,
     /* 73508 */     // GIR_Coverage, 5494,
     /* 73508 */     GIR_Done,
     /* 73509 */   // Label 2242: @73509
     /* 73509 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(73674), // Rule ID 20449 //
     /* 73514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 73517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 73521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73529 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMAXUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 73529 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 73532 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 73536 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 73543 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 73546 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 73550 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73555 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 73558 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 73562 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 73565 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 73570 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 73575 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 73580 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 73583 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 73587 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 73594 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 73597 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 73601 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73606 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 73609 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 73613 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 73616 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 73621 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 73626 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 73631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 73634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 73638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73643 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 73646 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 73649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 73651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 73654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 73656 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 73663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 73668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 73673 */     // GIR_Coverage, 20449,
     /* 73673 */     GIR_EraseRootFromParent_Done,
     /* 73674 */   // Label 2243: @73674
     /* 73674 */   GIM_Reject,
     /* 73675 */ // Label 2241: @73675
     /* 73675 */ GIM_Reject,
     /* 73676 */ // Label 2229: @73676
     /* 73676 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(73769),
     /* 73681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 73684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 73687 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(73714), // Rule ID 3188 //
     /* 73692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 73695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73707 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMAXUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 73707 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrr),
     /* 73712 */     GIR_RootConstrainSelectedInstOperands,
     /* 73713 */     // GIR_Coverage, 3188,
     /* 73713 */     GIR_Done,
     /* 73714 */   // Label 2245: @73714
     /* 73714 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(73741), // Rule ID 3230 //
     /* 73719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 73722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73734 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMAXUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 73734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUDrr),
     /* 73739 */     GIR_RootConstrainSelectedInstOperands,
     /* 73740 */     // GIR_Coverage, 3230,
     /* 73740 */     GIR_Done,
     /* 73741 */   // Label 2246: @73741
     /* 73741 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(73768), // Rule ID 5467 //
     /* 73746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 73749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73761 */     // (umax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMAXUDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 73761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rr),
     /* 73766 */     GIR_RootConstrainSelectedInstOperands,
     /* 73767 */     // GIR_Coverage, 5467,
     /* 73767 */     GIR_Done,
     /* 73768 */   // Label 2247: @73768
     /* 73768 */   GIM_Reject,
     /* 73769 */ // Label 2244: @73769
     /* 73769 */ GIM_Reject,
     /* 73770 */ // Label 2230: @73770
     /* 73770 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(73962),
     /* 73775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 73778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 73781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73793 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(73808), // Rule ID 5485 //
     /* 73798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 73801 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMAXUQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 73801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rr),
     /* 73806 */     GIR_RootConstrainSelectedInstOperands,
     /* 73807 */     // GIR_Coverage, 5485,
     /* 73807 */     GIR_Done,
     /* 73808 */   // Label 2249: @73808
     /* 73808 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(73961), // Rule ID 20447 //
     /* 73813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 73816 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMAXUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 73816 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 73819 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 73823 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 73830 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 73833 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 73837 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73842 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 73845 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 73849 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 73852 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 73857 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 73862 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 73867 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 73870 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 73874 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 73881 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 73884 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 73888 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73893 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 73896 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 73900 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 73903 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 73908 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 73913 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 73918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 73921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 73925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73930 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 73933 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 73936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 73938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 73941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 73943 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 73950 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 73955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 73960 */     // GIR_Coverage, 20447,
     /* 73960 */     GIR_EraseRootFromParent_Done,
     /* 73961 */   // Label 2250: @73961
     /* 73961 */   GIM_Reject,
     /* 73962 */ // Label 2248: @73962
     /* 73962 */ GIM_Reject,
     /* 73963 */ // Label 2231: @73963
     /* 73963 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(74056),
     /* 73968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 73971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 73974 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(74001), // Rule ID 3198 //
     /* 73979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 73982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73994 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMAXUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 73994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrr),
     /* 73999 */     GIR_RootConstrainSelectedInstOperands,
     /* 74000 */     // GIR_Coverage, 3198,
     /* 74000 */     GIR_Done,
     /* 74001 */   // Label 2252: @74001
     /* 74001 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(74028), // Rule ID 3232 //
     /* 74006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 74009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74021 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMAXUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 74021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUWrr),
     /* 74026 */     GIR_RootConstrainSelectedInstOperands,
     /* 74027 */     // GIR_Coverage, 3232,
     /* 74027 */     GIR_Done,
     /* 74028 */   // Label 2253: @74028
     /* 74028 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(74055), // Rule ID 5443 //
     /* 74033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 74036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74048 */     // (umax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMAXUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 74048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rr),
     /* 74053 */     GIR_RootConstrainSelectedInstOperands,
     /* 74054 */     // GIR_Coverage, 5443,
     /* 74054 */     GIR_Done,
     /* 74055 */   // Label 2254: @74055
     /* 74055 */   GIM_Reject,
     /* 74056 */ // Label 2251: @74056
     /* 74056 */ GIM_Reject,
     /* 74057 */ // Label 2232: @74057
     /* 74057 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(74123),
     /* 74062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 74065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 74068 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(74095), // Rule ID 3206 //
     /* 74073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 74076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74088 */     // (umax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMAXUDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 74088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrr),
     /* 74093 */     GIR_RootConstrainSelectedInstOperands,
     /* 74094 */     // GIR_Coverage, 3206,
     /* 74094 */     GIR_Done,
     /* 74095 */   // Label 2256: @74095
     /* 74095 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(74122), // Rule ID 5458 //
     /* 74100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 74103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74115 */     // (umax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMAXUDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 74115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rr),
     /* 74120 */     GIR_RootConstrainSelectedInstOperands,
     /* 74121 */     // GIR_Coverage, 5458,
     /* 74121 */     GIR_Done,
     /* 74122 */   // Label 2257: @74122
     /* 74122 */   GIM_Reject,
     /* 74123 */ // Label 2255: @74123
     /* 74123 */ GIM_Reject,
     /* 74124 */ // Label 2233: @74124
     /* 74124 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(74157), // Rule ID 5476 //
     /* 74129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 74132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 74135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 74138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74146 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74150 */   // (umax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMAXUQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 74150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 74155 */   GIR_RootConstrainSelectedInstOperands,
     /* 74156 */   // GIR_Coverage, 5476,
     /* 74156 */   GIR_Done,
     /* 74157 */ // Label 2258: @74157
     /* 74157 */ GIM_Reject,
     /* 74158 */ // Label 2234: @74158
     /* 74158 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(74251),
     /* 74163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 74166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 74169 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(74196), // Rule ID 2645 //
     /* 74174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 74177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74189 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMAXUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 74189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrr),
     /* 74194 */     GIR_RootConstrainSelectedInstOperands,
     /* 74195 */     // GIR_Coverage, 2645,
     /* 74195 */     GIR_Done,
     /* 74196 */   // Label 2260: @74196
     /* 74196 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(74223), // Rule ID 2647 //
     /* 74201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 74204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74216 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMAXUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 74216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUBrr),
     /* 74221 */     GIR_RootConstrainSelectedInstOperands,
     /* 74222 */     // GIR_Coverage, 2647,
     /* 74222 */     GIR_Done,
     /* 74223 */   // Label 2261: @74223
     /* 74223 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(74250), // Rule ID 5425 //
     /* 74228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 74231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74243 */     // (umax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMAXUBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 74243 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rr),
     /* 74248 */     GIR_RootConstrainSelectedInstOperands,
     /* 74249 */     // GIR_Coverage, 5425,
     /* 74249 */     GIR_Done,
     /* 74250 */   // Label 2262: @74250
     /* 74250 */   GIM_Reject,
     /* 74251 */ // Label 2259: @74251
     /* 74251 */ GIM_Reject,
     /* 74252 */ // Label 2235: @74252
     /* 74252 */ GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(74318),
     /* 74257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 74260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 74263 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(74290), // Rule ID 3216 //
     /* 74268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 74271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74283 */     // (umax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMAXUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 74283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrr),
     /* 74288 */     GIR_RootConstrainSelectedInstOperands,
     /* 74289 */     // GIR_Coverage, 3216,
     /* 74289 */     GIR_Done,
     /* 74290 */   // Label 2264: @74290
     /* 74290 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(74317), // Rule ID 5437 //
     /* 74295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 74298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74310 */     // (umax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMAXUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 74310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rr),
     /* 74315 */     GIR_RootConstrainSelectedInstOperands,
     /* 74316 */     // GIR_Coverage, 5437,
     /* 74316 */     GIR_Done,
     /* 74317 */   // Label 2265: @74317
     /* 74317 */   GIM_Reject,
     /* 74318 */ // Label 2263: @74318
     /* 74318 */ GIM_Reject,
     /* 74319 */ // Label 2236: @74319
     /* 74319 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(74352), // Rule ID 5449 //
     /* 74324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 74327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 74330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 74333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74341 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74345 */   // (umax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMAXUDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 74345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrr),
     /* 74350 */   GIR_RootConstrainSelectedInstOperands,
     /* 74351 */   // GIR_Coverage, 5449,
     /* 74351 */   GIR_Done,
     /* 74352 */ // Label 2266: @74352
     /* 74352 */ GIM_Reject,
     /* 74353 */ // Label 2237: @74353
     /* 74353 */ GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(74419),
     /* 74358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 74361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 74364 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(74391), // Rule ID 2649 //
     /* 74369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 74372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74384 */     // (umax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMAXUBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 74384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrr),
     /* 74389 */     GIR_RootConstrainSelectedInstOperands,
     /* 74390 */     // GIR_Coverage, 2649,
     /* 74390 */     GIR_Done,
     /* 74391 */   // Label 2268: @74391
     /* 74391 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(74418), // Rule ID 5419 //
     /* 74396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 74399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74411 */     // (umax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMAXUBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 74411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rr),
     /* 74416 */     GIR_RootConstrainSelectedInstOperands,
     /* 74417 */     // GIR_Coverage, 5419,
     /* 74417 */     GIR_Done,
     /* 74418 */   // Label 2269: @74418
     /* 74418 */   GIM_Reject,
     /* 74419 */ // Label 2267: @74419
     /* 74419 */ GIM_Reject,
     /* 74420 */ // Label 2238: @74420
     /* 74420 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(74453), // Rule ID 5431 //
     /* 74425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 74428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 74431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 74434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74442 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74446 */   // (umax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMAXUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 74446 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrr),
     /* 74451 */   GIR_RootConstrainSelectedInstOperands,
     /* 74452 */   // GIR_Coverage, 5431,
     /* 74452 */   GIR_Done,
     /* 74453 */ // Label 2270: @74453
     /* 74453 */ GIM_Reject,
     /* 74454 */ // Label 2239: @74454
     /* 74454 */ GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(74487), // Rule ID 5413 //
     /* 74459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 74462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 74465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 74468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74480 */   // (umax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMAXUBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 74480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrr),
     /* 74485 */   GIR_RootConstrainSelectedInstOperands,
     /* 74486 */   // GIR_Coverage, 5413,
     /* 74486 */   GIR_Done,
     /* 74487 */ // Label 2271: @74487
     /* 74487 */ GIM_Reject,
     /* 74488 */ // Label 2240: @74488
     /* 74488 */ GIM_Reject,
     /* 74489 */ // Label 51: @74489
     /* 74489 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2284*/ GIMT_Encode4(75353),
     /* 74500 */ /*GILLT_v2s64*//*Label 2272*/ GIMT_Encode4(74568), GIMT_Encode4(0),
     /* 74508 */ /*GILLT_v4s32*//*Label 2273*/ GIMT_Encode4(74708),
     /* 74512 */ /*GILLT_v4s64*//*Label 2274*/ GIMT_Encode4(74787), GIMT_Encode4(0),
     /* 74520 */ /*GILLT_v8s16*//*Label 2275*/ GIMT_Encode4(74919),
     /* 74524 */ /*GILLT_v8s32*//*Label 2276*/ GIMT_Encode4(74998),
     /* 74528 */ /*GILLT_v8s64*//*Label 2277*/ GIMT_Encode4(75054), GIMT_Encode4(0),
     /* 74536 */ /*GILLT_v16s8*//*Label 2278*/ GIMT_Encode4(75081),
     /* 74540 */ /*GILLT_v16s16*//*Label 2279*/ GIMT_Encode4(75160),
     /* 74544 */ /*GILLT_v16s32*//*Label 2280*/ GIMT_Encode4(75216), GIMT_Encode4(0),
     /* 74552 */ /*GILLT_v32s8*//*Label 2281*/ GIMT_Encode4(75243),
     /* 74556 */ /*GILLT_v32s16*//*Label 2282*/ GIMT_Encode4(75299), GIMT_Encode4(0),
     /* 74564 */ /*GILLT_v64s8*//*Label 2283*/ GIMT_Encode4(75326),
     /* 74568 */ // Label 2272: @74568
     /* 74568 */ GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(74707),
     /* 74573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 74576 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(74599), // Rule ID 13261 //
     /* 74581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 74584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74592 */     // (abs:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPABSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 74592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZ128rr),
     /* 74597 */     GIR_RootConstrainSelectedInstOperands,
     /* 74598 */     // GIR_Coverage, 13261,
     /* 74598 */     GIR_Done,
     /* 74599 */   // Label 2286: @74599
     /* 74599 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(74706), // Rule ID 22271 //
     /* 74604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 74607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 74611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74615 */     // (abs:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPABSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 74615 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 74618 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 74622 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 74627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 74629 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 74632 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 74636 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 74641 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 74644 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 74648 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 74651 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 74656 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 74661 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 74666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 74669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 74673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 74678 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 74681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 74683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 74686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 74688 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 74695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 74700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 74705 */     // GIR_Coverage, 22271,
     /* 74705 */     GIR_EraseRootFromParent_Done,
     /* 74706 */   // Label 2287: @74706
     /* 74706 */   GIM_Reject,
     /* 74707 */ // Label 2285: @74707
     /* 74707 */ GIM_Reject,
     /* 74708 */ // Label 2273: @74708
     /* 74708 */ GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(74786),
     /* 74713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 74716 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(74739), // Rule ID 2991 //
     /* 74721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 74724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74732 */     // (abs:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)  =>  (VPABSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)
     /* 74732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDrr),
     /* 74737 */     GIR_RootConstrainSelectedInstOperands,
     /* 74738 */     // GIR_Coverage, 2991,
     /* 74738 */     GIR_Done,
     /* 74739 */   // Label 2289: @74739
     /* 74739 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(74762), // Rule ID 3003 //
     /* 74744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 74747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74755 */     // (abs:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)  =>  (PABSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)
     /* 74755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSDrr),
     /* 74760 */     GIR_RootConstrainSelectedInstOperands,
     /* 74761 */     // GIR_Coverage, 3003,
     /* 74761 */     GIR_Done,
     /* 74762 */   // Label 2290: @74762
     /* 74762 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(74785), // Rule ID 13288 //
     /* 74767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 74770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74778 */     // (abs:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPABSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 74778 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZ128rr),
     /* 74783 */     GIR_RootConstrainSelectedInstOperands,
     /* 74784 */     // GIR_Coverage, 13288,
     /* 74784 */     GIR_Done,
     /* 74785 */   // Label 2291: @74785
     /* 74785 */   GIM_Reject,
     /* 74786 */ // Label 2288: @74786
     /* 74786 */ GIM_Reject,
     /* 74787 */ // Label 2274: @74787
     /* 74787 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(74918),
     /* 74792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 74795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74803 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(74818), // Rule ID 13252 //
     /* 74808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 74811 */     // (abs:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPABSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 74811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZ256rr),
     /* 74816 */     GIR_RootConstrainSelectedInstOperands,
     /* 74817 */     // GIR_Coverage, 13252,
     /* 74817 */     GIR_Done,
     /* 74818 */   // Label 2293: @74818
     /* 74818 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(74917), // Rule ID 22270 //
     /* 74823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 74826 */     // (abs:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPABSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 74826 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 74829 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 74833 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 74838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 74840 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 74843 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 74847 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 74852 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 74855 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 74859 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 74862 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 74867 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 74872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 74877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 74880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 74884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 74889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 74892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 74894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 74897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 74899 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 74906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 74911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 74916 */     // GIR_Coverage, 22270,
     /* 74916 */     GIR_EraseRootFromParent_Done,
     /* 74917 */   // Label 2294: @74917
     /* 74917 */   GIM_Reject,
     /* 74918 */ // Label 2292: @74918
     /* 74918 */ GIM_Reject,
     /* 74919 */ // Label 2275: @74919
     /* 74919 */ GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(74997),
     /* 74924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 74927 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(74950), // Rule ID 2989 //
     /* 74932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 74935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74943 */     // (abs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)  =>  (VPABSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)
     /* 74943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWrr),
     /* 74948 */     GIR_RootConstrainSelectedInstOperands,
     /* 74949 */     // GIR_Coverage, 2989,
     /* 74949 */     GIR_Done,
     /* 74950 */   // Label 2296: @74950
     /* 74950 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(74973), // Rule ID 3001 //
     /* 74955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 74958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74966 */     // (abs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)  =>  (PABSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)
     /* 74966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSWrr),
     /* 74971 */     GIR_RootConstrainSelectedInstOperands,
     /* 74972 */     // GIR_Coverage, 3001,
     /* 74972 */     GIR_Done,
     /* 74973 */   // Label 2297: @74973
     /* 74973 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(74996), // Rule ID 13309 //
     /* 74978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 74981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74989 */     // (abs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (VPABSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)
     /* 74989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZ128rr),
     /* 74994 */     GIR_RootConstrainSelectedInstOperands,
     /* 74995 */     // GIR_Coverage, 13309,
     /* 74995 */     GIR_Done,
     /* 74996 */   // Label 2298: @74996
     /* 74996 */   GIM_Reject,
     /* 74997 */ // Label 2295: @74997
     /* 74997 */ GIM_Reject,
     /* 74998 */ // Label 2276: @74998
     /* 74998 */ GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(75053),
     /* 75003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 75006 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(75029), // Rule ID 2997 //
     /* 75011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 75014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 75018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 75022 */     // (abs:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src)  =>  (VPABSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src)
     /* 75022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDYrr),
     /* 75027 */     GIR_RootConstrainSelectedInstOperands,
     /* 75028 */     // GIR_Coverage, 2997,
     /* 75028 */     GIR_Done,
     /* 75029 */   // Label 2300: @75029
     /* 75029 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(75052), // Rule ID 13279 //
     /* 75034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 75037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 75041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 75045 */     // (abs:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPABSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 75045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZ256rr),
     /* 75050 */     GIR_RootConstrainSelectedInstOperands,
     /* 75051 */     // GIR_Coverage, 13279,
     /* 75051 */     GIR_Done,
     /* 75052 */   // Label 2301: @75052
     /* 75052 */   GIM_Reject,
     /* 75053 */ // Label 2299: @75053
     /* 75053 */ GIM_Reject,
     /* 75054 */ // Label 2277: @75054
     /* 75054 */ GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(75080), // Rule ID 13243 //
     /* 75059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 75062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 75065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75073 */   // (abs:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPABSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 75073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 75078 */   GIR_RootConstrainSelectedInstOperands,
     /* 75079 */   // GIR_Coverage, 13243,
     /* 75079 */   GIR_Done,
     /* 75080 */ // Label 2302: @75080
     /* 75080 */ GIM_Reject,
     /* 75081 */ // Label 2278: @75081
     /* 75081 */ GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(75159),
     /* 75086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 75089 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(75112), // Rule ID 2987 //
     /* 75094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 75097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75105 */     // (abs:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)  =>  (VPABSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)
     /* 75105 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBrr),
     /* 75110 */     GIR_RootConstrainSelectedInstOperands,
     /* 75111 */     // GIR_Coverage, 2987,
     /* 75111 */     GIR_Done,
     /* 75112 */   // Label 2304: @75112
     /* 75112 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(75135), // Rule ID 2999 //
     /* 75117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 75120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75128 */     // (abs:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)  =>  (PABSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)
     /* 75128 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSBrr),
     /* 75133 */     GIR_RootConstrainSelectedInstOperands,
     /* 75134 */     // GIR_Coverage, 2999,
     /* 75134 */     GIR_Done,
     /* 75135 */   // Label 2305: @75135
     /* 75135 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(75158), // Rule ID 13327 //
     /* 75140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 75143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 75147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 75151 */     // (abs:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (VPABSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)
     /* 75151 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZ128rr),
     /* 75156 */     GIR_RootConstrainSelectedInstOperands,
     /* 75157 */     // GIR_Coverage, 13327,
     /* 75157 */     GIR_Done,
     /* 75158 */   // Label 2306: @75158
     /* 75158 */   GIM_Reject,
     /* 75159 */ // Label 2303: @75159
     /* 75159 */ GIM_Reject,
     /* 75160 */ // Label 2279: @75160
     /* 75160 */ GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(75215),
     /* 75165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 75168 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(75191), // Rule ID 2995 //
     /* 75173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 75176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 75180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 75184 */     // (abs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src)  =>  (VPABSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src)
     /* 75184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWYrr),
     /* 75189 */     GIR_RootConstrainSelectedInstOperands,
     /* 75190 */     // GIR_Coverage, 2995,
     /* 75190 */     GIR_Done,
     /* 75191 */   // Label 2308: @75191
     /* 75191 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(75214), // Rule ID 13303 //
     /* 75196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 75199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 75203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 75207 */     // (abs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (VPABSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)
     /* 75207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZ256rr),
     /* 75212 */     GIR_RootConstrainSelectedInstOperands,
     /* 75213 */     // GIR_Coverage, 13303,
     /* 75213 */     GIR_Done,
     /* 75214 */   // Label 2309: @75214
     /* 75214 */   GIM_Reject,
     /* 75215 */ // Label 2307: @75215
     /* 75215 */ GIM_Reject,
     /* 75216 */ // Label 2280: @75216
     /* 75216 */ GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(75242), // Rule ID 13270 //
     /* 75221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 75224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 75227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75235 */   // (abs:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPABSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 75235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZrr),
     /* 75240 */   GIR_RootConstrainSelectedInstOperands,
     /* 75241 */   // GIR_Coverage, 13270,
     /* 75241 */   GIR_Done,
     /* 75242 */ // Label 2310: @75242
     /* 75242 */ GIM_Reject,
     /* 75243 */ // Label 2281: @75243
     /* 75243 */ GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(75298),
     /* 75248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 75251 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(75274), // Rule ID 2993 //
     /* 75256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 75259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 75263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 75267 */     // (abs:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src)  =>  (VPABSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src)
     /* 75267 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBYrr),
     /* 75272 */     GIR_RootConstrainSelectedInstOperands,
     /* 75273 */     // GIR_Coverage, 2993,
     /* 75273 */     GIR_Done,
     /* 75274 */   // Label 2312: @75274
     /* 75274 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(75297), // Rule ID 13321 //
     /* 75279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 75282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 75286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 75290 */     // (abs:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (VPABSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)
     /* 75290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZ256rr),
     /* 75295 */     GIR_RootConstrainSelectedInstOperands,
     /* 75296 */     // GIR_Coverage, 13321,
     /* 75296 */     GIR_Done,
     /* 75297 */   // Label 2313: @75297
     /* 75297 */   GIM_Reject,
     /* 75298 */ // Label 2311: @75298
     /* 75298 */ GIM_Reject,
     /* 75299 */ // Label 2282: @75299
     /* 75299 */ GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(75325), // Rule ID 13297 //
     /* 75304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 75307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 75310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75318 */   // (abs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)  =>  (VPABSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)
     /* 75318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZrr),
     /* 75323 */   GIR_RootConstrainSelectedInstOperands,
     /* 75324 */   // GIR_Coverage, 13297,
     /* 75324 */   GIR_Done,
     /* 75325 */ // Label 2314: @75325
     /* 75325 */ GIM_Reject,
     /* 75326 */ // Label 2283: @75326
     /* 75326 */ GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(75352), // Rule ID 13315 //
     /* 75331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 75334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 75337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75345 */   // (abs:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)  =>  (VPABSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)
     /* 75345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZrr),
     /* 75350 */   GIR_RootConstrainSelectedInstOperands,
     /* 75351 */   // GIR_Coverage, 13315,
     /* 75351 */   GIR_Done,
     /* 75352 */ // Label 2315: @75352
     /* 75352 */ GIM_Reject,
     /* 75353 */ // Label 2284: @75353
     /* 75353 */ GIM_Reject,
     /* 75354 */ // Label 52: @75354
     /* 75354 */ GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(75369), // Rule ID 628 //
     /* 75359 */   // MIs[0] dst
     /* 75359 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 75362 */   // (br (bb:{ *:[Other] }):$dst)  =>  (JMP_1 (bb:{ *:[Other] }):$dst)
     /* 75362 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::JMP_1),
     /* 75367 */   GIR_RootConstrainSelectedInstOperands,
     /* 75368 */   // GIR_Coverage, 628,
     /* 75368 */   GIR_Done,
     /* 75369 */ // Label 2316: @75369
     /* 75369 */ GIM_Reject,
     /* 75370 */ // Label 53: @75370
     /* 75370 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(22), /*)*//*default:*//*Label 2331*/ GIMT_Encode4(78298),
     /* 75381 */ /*GILLT_s1*//*Label 2317*/ GIMT_Encode4(75469), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 75409 */ /*GILLT_v2s1*//*Label 2318*/ GIMT_Encode4(75710),
     /* 75413 */ /*GILLT_v2s64*//*Label 2319*/ GIMT_Encode4(75911),
     /* 75417 */ /*GILLT_v4s1*//*Label 2320*/ GIMT_Encode4(76392),
     /* 75421 */ /*GILLT_v4s32*//*Label 2321*/ GIMT_Encode4(76553),
     /* 75425 */ /*GILLT_v4s64*//*Label 2322*/ GIMT_Encode4(77034),
     /* 75429 */ /*GILLT_v8s1*//*Label 2323*/ GIMT_Encode4(77117),
     /* 75433 */ /*GILLT_v8s16*//*Label 2324*/ GIMT_Encode4(77238),
     /* 75437 */ /*GILLT_v8s32*//*Label 2325*/ GIMT_Encode4(77719), GIMT_Encode4(0),
     /* 75445 */ /*GILLT_v16s1*//*Label 2326*/ GIMT_Encode4(77802),
     /* 75449 */ /*GILLT_v16s8*//*Label 2327*/ GIMT_Encode4(77883),
     /* 75453 */ /*GILLT_v16s16*//*Label 2328*/ GIMT_Encode4(78124), GIMT_Encode4(0),
     /* 75461 */ /*GILLT_v32s1*//*Label 2329*/ GIMT_Encode4(78207),
     /* 75465 */ /*GILLT_v32s8*//*Label 2330*/ GIMT_Encode4(78248),
     /* 75469 */ // Label 2317: @75469
     /* 75469 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(75509), // Rule ID 20049 //
     /* 75474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 75477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 75481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 75485 */   // MIs[0] Operand 2
     /* 75485 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 75496 */   // (extract_subvector:{ *:[v1i1] } VK2:{ *:[v2i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK2:{ *:[v2i1] }:$src, VK1:{ *:[i32] })
     /* 75496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75501 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 75503 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 75508 */   // GIR_Coverage, 20049,
     /* 75508 */   GIR_EraseRootFromParent_Done,
     /* 75509 */ // Label 2332: @75509
     /* 75509 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(75549), // Rule ID 20051 //
     /* 75514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 75517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 75521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 75525 */   // MIs[0] Operand 2
     /* 75525 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 75536 */   // (extract_subvector:{ *:[v1i1] } VK4:{ *:[v4i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK4:{ *:[v4i1] }:$src, VK1:{ *:[i32] })
     /* 75536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75541 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 75543 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 75548 */   // GIR_Coverage, 20051,
     /* 75548 */   GIR_EraseRootFromParent_Done,
     /* 75549 */ // Label 2333: @75549
     /* 75549 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(75589), // Rule ID 20053 //
     /* 75554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 75557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 75561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 75565 */   // MIs[0] Operand 2
     /* 75565 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 75576 */   // (extract_subvector:{ *:[v1i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK8:{ *:[v8i1] }:$src, VK1:{ *:[i32] })
     /* 75576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 75583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 75588 */   // GIR_Coverage, 20053,
     /* 75588 */   GIR_EraseRootFromParent_Done,
     /* 75589 */ // Label 2334: @75589
     /* 75589 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(75629), // Rule ID 20055 //
     /* 75594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 75597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 75601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 75605 */   // MIs[0] Operand 2
     /* 75605 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 75616 */   // (extract_subvector:{ *:[v1i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK16:{ *:[v16i1] }:$src, VK1:{ *:[i32] })
     /* 75616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75621 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 75623 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 75628 */   // GIR_Coverage, 20055,
     /* 75628 */   GIR_EraseRootFromParent_Done,
     /* 75629 */ // Label 2335: @75629
     /* 75629 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(75669), // Rule ID 20057 //
     /* 75634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 75637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 75641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 75645 */   // MIs[0] Operand 2
     /* 75645 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 75656 */   // (extract_subvector:{ *:[v1i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK32:{ *:[v32i1] }:$src, VK1:{ *:[i32] })
     /* 75656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75661 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 75663 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 75668 */   // GIR_Coverage, 20057,
     /* 75668 */   GIR_EraseRootFromParent_Done,
     /* 75669 */ // Label 2336: @75669
     /* 75669 */ GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(75709), // Rule ID 20059 //
     /* 75674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 75677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 75681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 75685 */   // MIs[0] Operand 2
     /* 75685 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 75696 */   // (extract_subvector:{ *:[v1i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK64:{ *:[v64i1] }:$src, VK1:{ *:[i32] })
     /* 75696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75701 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 75703 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 75708 */   // GIR_Coverage, 20059,
     /* 75708 */   GIR_EraseRootFromParent_Done,
     /* 75709 */ // Label 2337: @75709
     /* 75709 */ GIM_Reject,
     /* 75710 */ // Label 2318: @75710
     /* 75710 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(75750), // Rule ID 20061 //
     /* 75715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 75718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 75722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 75726 */   // MIs[0] Operand 2
     /* 75726 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 75737 */   // (extract_subvector:{ *:[v2i1] } VK4:{ *:[v4i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK4:{ *:[v4i1] }:$src, VK2:{ *:[i32] })
     /* 75737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75742 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 75744 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 75749 */   // GIR_Coverage, 20061,
     /* 75749 */   GIR_EraseRootFromParent_Done,
     /* 75750 */ // Label 2338: @75750
     /* 75750 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(75790), // Rule ID 20063 //
     /* 75755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 75758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 75762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 75766 */   // MIs[0] Operand 2
     /* 75766 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 75777 */   // (extract_subvector:{ *:[v2i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK8:{ *:[v8i1] }:$src, VK2:{ *:[i32] })
     /* 75777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75782 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 75784 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 75789 */   // GIR_Coverage, 20063,
     /* 75789 */   GIR_EraseRootFromParent_Done,
     /* 75790 */ // Label 2339: @75790
     /* 75790 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(75830), // Rule ID 20065 //
     /* 75795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 75798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 75802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 75806 */   // MIs[0] Operand 2
     /* 75806 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 75817 */   // (extract_subvector:{ *:[v2i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK16:{ *:[v16i1] }:$src, VK2:{ *:[i32] })
     /* 75817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75822 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 75824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 75829 */   // GIR_Coverage, 20065,
     /* 75829 */   GIR_EraseRootFromParent_Done,
     /* 75830 */ // Label 2340: @75830
     /* 75830 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(75870), // Rule ID 20067 //
     /* 75835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 75838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 75842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 75846 */   // MIs[0] Operand 2
     /* 75846 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 75857 */   // (extract_subvector:{ *:[v2i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK32:{ *:[v32i1] }:$src, VK2:{ *:[i32] })
     /* 75857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75862 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 75864 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 75869 */   // GIR_Coverage, 20067,
     /* 75869 */   GIR_EraseRootFromParent_Done,
     /* 75870 */ // Label 2341: @75870
     /* 75870 */ GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(75910), // Rule ID 20069 //
     /* 75875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 75878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 75882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 75886 */   // MIs[0] Operand 2
     /* 75886 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 75897 */   // (extract_subvector:{ *:[v2i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK64:{ *:[v64i1] }:$src, VK2:{ *:[i32] })
     /* 75897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75902 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 75904 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 75909 */   // GIR_Coverage, 20069,
     /* 75909 */   GIR_EraseRootFromParent_Done,
     /* 75910 */ // Label 2342: @75910
     /* 75910 */ GIM_Reject,
     /* 75911 */ // Label 2319: @75911
     /* 75911 */ GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(75982), // Rule ID 19500 //
     /* 75916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 75919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 75922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75930 */   // MIs[0] Operand 2
     /* 75930 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 75941 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v2i64] } (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 75941 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 75944 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75948 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 75953 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 75959 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 75964 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 75969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 75972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75974 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 75977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 75980 */   GIR_RootConstrainSelectedInstOperands,
     /* 75981 */   // GIR_Coverage, 19500,
     /* 75981 */   GIR_EraseRootFromParent_Done,
     /* 75982 */ // Label 2343: @75982
     /* 75982 */ GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(76053), // Rule ID 19501 //
     /* 75987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 75990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 75993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76001 */   // MIs[0] Operand 2
     /* 76001 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 76012 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v2f64] } (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 76012 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 76015 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76019 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 76024 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 76030 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 76035 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 76043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 76048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 76051 */   GIR_RootConstrainSelectedInstOperands,
     /* 76052 */   // GIR_Coverage, 19501,
     /* 76052 */   GIR_EraseRootFromParent_Done,
     /* 76053 */ // Label 2344: @76053
     /* 76053 */ GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(76124), // Rule ID 19507 //
     /* 76058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 76061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 76064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 76068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76072 */   // MIs[0] Operand 2
     /* 76072 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 76083 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v2i64] } (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 76083 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 76086 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76090 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 76095 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 76101 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 76106 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 76114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76116 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 76119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 76122 */   GIR_RootConstrainSelectedInstOperands,
     /* 76123 */   // GIR_Coverage, 19507,
     /* 76123 */   GIR_EraseRootFromParent_Done,
     /* 76124 */ // Label 2345: @76124
     /* 76124 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(76195), // Rule ID 19508 //
     /* 76129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 76132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 76135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 76139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76143 */   // MIs[0] Operand 2
     /* 76143 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 76154 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v2f64] } (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 76154 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 76157 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76161 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 76166 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 76172 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 76177 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 76185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76187 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 76190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 76193 */   GIR_RootConstrainSelectedInstOperands,
     /* 76194 */   // GIR_Coverage, 19508,
     /* 76194 */   GIR_EraseRootFromParent_Done,
     /* 76195 */ // Label 2346: @76195
     /* 76195 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(76244), // Rule ID 23431 //
     /* 76200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 76203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 76207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 76211 */   // MIs[0] Operand 2
     /* 76211 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76222 */   // (extract_subvector:{ *:[v2i64] } VR256:{ *:[v4i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } VR256:{ *:[v4i64] }:$src, sub_xmm:{ *:[i32] })
     /* 76222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76227 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 76233 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 76238 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 76243 */   // GIR_Coverage, 23431,
     /* 76243 */   GIR_EraseRootFromParent_Done,
     /* 76244 */ // Label 2347: @76244
     /* 76244 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(76293), // Rule ID 23434 //
     /* 76249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 76252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 76256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 76260 */   // MIs[0] Operand 2
     /* 76260 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76271 */   // (extract_subvector:{ *:[v2f64] } VR256:{ *:[v4f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } VR256:{ *:[v4f64] }:$src, sub_xmm:{ *:[i32] })
     /* 76271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76276 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 76282 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 76287 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 76292 */   // GIR_Coverage, 23434,
     /* 76292 */   GIR_EraseRootFromParent_Done,
     /* 76293 */ // Label 2348: @76293
     /* 76293 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(76342), // Rule ID 23452 //
     /* 76298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 76301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 76305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76309 */   // MIs[0] Operand 2
     /* 76309 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76320 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, sub_xmm:{ *:[i32] })
     /* 76320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76325 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 76331 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 76336 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76341 */   // GIR_Coverage, 23452,
     /* 76341 */   GIR_EraseRootFromParent_Done,
     /* 76342 */ // Label 2349: @76342
     /* 76342 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(76391), // Rule ID 23455 //
     /* 76347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 76350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 76354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76358 */   // MIs[0] Operand 2
     /* 76358 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76369 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, sub_xmm:{ *:[i32] })
     /* 76369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76374 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 76380 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 76385 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76390 */   // GIR_Coverage, 23455,
     /* 76390 */   GIR_EraseRootFromParent_Done,
     /* 76391 */ // Label 2350: @76391
     /* 76391 */ GIM_Reject,
     /* 76392 */ // Label 2320: @76392
     /* 76392 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(76432), // Rule ID 20071 //
     /* 76397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 76400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 76404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 76408 */   // MIs[0] Operand 2
     /* 76408 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76419 */   // (extract_subvector:{ *:[v4i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK8:{ *:[v8i1] }:$src, VK4:{ *:[i32] })
     /* 76419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 76426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 76431 */   // GIR_Coverage, 20071,
     /* 76431 */   GIR_EraseRootFromParent_Done,
     /* 76432 */ // Label 2351: @76432
     /* 76432 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(76472), // Rule ID 20073 //
     /* 76437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 76440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 76444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 76448 */   // MIs[0] Operand 2
     /* 76448 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76459 */   // (extract_subvector:{ *:[v4i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK16:{ *:[v16i1] }:$src, VK4:{ *:[i32] })
     /* 76459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76464 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 76466 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 76471 */   // GIR_Coverage, 20073,
     /* 76471 */   GIR_EraseRootFromParent_Done,
     /* 76472 */ // Label 2352: @76472
     /* 76472 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(76512), // Rule ID 20075 //
     /* 76477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 76480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 76484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 76488 */   // MIs[0] Operand 2
     /* 76488 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76499 */   // (extract_subvector:{ *:[v4i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK32:{ *:[v32i1] }:$src, VK4:{ *:[i32] })
     /* 76499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76504 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 76506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 76511 */   // GIR_Coverage, 20075,
     /* 76511 */   GIR_EraseRootFromParent_Done,
     /* 76512 */ // Label 2353: @76512
     /* 76512 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(76552), // Rule ID 20077 //
     /* 76517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 76520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 76524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 76528 */   // MIs[0] Operand 2
     /* 76528 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76539 */   // (extract_subvector:{ *:[v4i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK64:{ *:[v64i1] }:$src, VK4:{ *:[i32] })
     /* 76539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76544 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 76546 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 76551 */   // GIR_Coverage, 20077,
     /* 76551 */   GIR_EraseRootFromParent_Done,
     /* 76552 */ // Label 2354: @76552
     /* 76552 */ GIM_Reject,
     /* 76553 */ // Label 2321: @76553
     /* 76553 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(76624), // Rule ID 19502 //
     /* 76558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 76561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 76564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 76568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76572 */   // MIs[0] Operand 2
     /* 76572 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 76583 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v4i32] } (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 76583 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 76586 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76590 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 76595 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 76601 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 76606 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 76614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 76619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 76622 */   GIR_RootConstrainSelectedInstOperands,
     /* 76623 */   // GIR_Coverage, 19502,
     /* 76623 */   GIR_EraseRootFromParent_Done,
     /* 76624 */ // Label 2355: @76624
     /* 76624 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(76695), // Rule ID 19503 //
     /* 76629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 76632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 76635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 76639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76643 */   // MIs[0] Operand 2
     /* 76643 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 76654 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 76654 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 76657 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76661 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 76666 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 76672 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 76677 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 76685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76687 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 76690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 76693 */   GIR_RootConstrainSelectedInstOperands,
     /* 76694 */   // GIR_Coverage, 19503,
     /* 76694 */   GIR_EraseRootFromParent_Done,
     /* 76695 */ // Label 2356: @76695
     /* 76695 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(76766), // Rule ID 19509 //
     /* 76700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 76703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 76706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 76710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76714 */   // MIs[0] Operand 2
     /* 76714 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 76725 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v4i32] } (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 76725 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 76728 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76732 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 76737 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 76743 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 76748 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 76756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76758 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 76761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 76764 */   GIR_RootConstrainSelectedInstOperands,
     /* 76765 */   // GIR_Coverage, 19509,
     /* 76765 */   GIR_EraseRootFromParent_Done,
     /* 76766 */ // Label 2357: @76766
     /* 76766 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(76837), // Rule ID 19510 //
     /* 76771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 76774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 76777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 76781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76785 */   // MIs[0] Operand 2
     /* 76785 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 76796 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 76796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 76799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 76808 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 76814 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 76819 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 76827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76829 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 76832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 76835 */   GIR_RootConstrainSelectedInstOperands,
     /* 76836 */   // GIR_Coverage, 19510,
     /* 76836 */   GIR_EraseRootFromParent_Done,
     /* 76837 */ // Label 2358: @76837
     /* 76837 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(76886), // Rule ID 23425 //
     /* 76842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 76845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 76849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 76853 */   // MIs[0] Operand 2
     /* 76853 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76864 */   // (extract_subvector:{ *:[v4i32] } VR256:{ *:[v8i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } VR256:{ *:[v8i32] }:$src, sub_xmm:{ *:[i32] })
     /* 76864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76869 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 76875 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 76880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 76885 */   // GIR_Coverage, 23425,
     /* 76885 */   GIR_EraseRootFromParent_Done,
     /* 76886 */ // Label 2359: @76886
     /* 76886 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(76935), // Rule ID 23428 //
     /* 76891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 76894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 76898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 76902 */   // MIs[0] Operand 2
     /* 76902 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76913 */   // (extract_subvector:{ *:[v4f32] } VR256:{ *:[v8f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } VR256:{ *:[v8f32] }:$src, sub_xmm:{ *:[i32] })
     /* 76913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76918 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 76924 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 76929 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 76934 */   // GIR_Coverage, 23428,
     /* 76934 */   GIR_EraseRootFromParent_Done,
     /* 76935 */ // Label 2360: @76935
     /* 76935 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(76984), // Rule ID 23446 //
     /* 76940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 76943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 76947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76951 */   // MIs[0] Operand 2
     /* 76951 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76962 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, sub_xmm:{ *:[i32] })
     /* 76962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76967 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 76973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 76978 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76983 */   // GIR_Coverage, 23446,
     /* 76983 */   GIR_EraseRootFromParent_Done,
     /* 76984 */ // Label 2361: @76984
     /* 76984 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(77033), // Rule ID 23449 //
     /* 76989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 76992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 76996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77000 */   // MIs[0] Operand 2
     /* 77000 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77011 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, sub_xmm:{ *:[i32] })
     /* 77011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77016 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 77022 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 77027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77032 */   // GIR_Coverage, 23449,
     /* 77032 */   GIR_EraseRootFromParent_Done,
     /* 77033 */ // Label 2362: @77033
     /* 77033 */ GIM_Reject,
     /* 77034 */ // Label 2322: @77034
     /* 77034 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(77116),
     /* 77039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 77042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 77046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77050 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77061 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(77088), // Rule ID 23473 //
     /* 77066 */     // (extract_subvector:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] })
     /* 77066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77071 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77082 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77087 */     // GIR_Coverage, 23473,
     /* 77087 */     GIR_EraseRootFromParent_Done,
     /* 77088 */   // Label 2364: @77088
     /* 77088 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(77115), // Rule ID 23476 //
     /* 77093 */     // (extract_subvector:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] })
     /* 77093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77098 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77114 */     // GIR_Coverage, 23476,
     /* 77114 */     GIR_EraseRootFromParent_Done,
     /* 77115 */   // Label 2365: @77115
     /* 77115 */   GIM_Reject,
     /* 77116 */ // Label 2363: @77116
     /* 77116 */ GIM_Reject,
     /* 77117 */ // Label 2323: @77117
     /* 77117 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(77157), // Rule ID 20079 //
     /* 77122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 77125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 77129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 77133 */   // MIs[0] Operand 2
     /* 77133 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77144 */   // (extract_subvector:{ *:[v8i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK16:{ *:[v16i1] }:$src, VK8:{ *:[i32] })
     /* 77144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77149 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 77151 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 77156 */   // GIR_Coverage, 20079,
     /* 77156 */   GIR_EraseRootFromParent_Done,
     /* 77157 */ // Label 2366: @77157
     /* 77157 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(77197), // Rule ID 20081 //
     /* 77162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 77165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 77169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 77173 */   // MIs[0] Operand 2
     /* 77173 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77184 */   // (extract_subvector:{ *:[v8i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK32:{ *:[v32i1] }:$src, VK8:{ *:[i32] })
     /* 77184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77189 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 77191 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 77196 */   // GIR_Coverage, 20081,
     /* 77196 */   GIR_EraseRootFromParent_Done,
     /* 77197 */ // Label 2367: @77197
     /* 77197 */ GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(77237), // Rule ID 20083 //
     /* 77202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 77205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 77209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 77213 */   // MIs[0] Operand 2
     /* 77213 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77224 */   // (extract_subvector:{ *:[v8i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK64:{ *:[v64i1] }:$src, VK8:{ *:[i32] })
     /* 77224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77229 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 77231 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 77236 */   // GIR_Coverage, 20083,
     /* 77236 */   GIR_EraseRootFromParent_Done,
     /* 77237 */ // Label 2368: @77237
     /* 77237 */ GIM_Reject,
     /* 77238 */ // Label 2324: @77238
     /* 77238 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(77309), // Rule ID 19504 //
     /* 77243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 77246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 77249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 77253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77257 */   // MIs[0] Operand 2
     /* 77257 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 77268 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v8i16] } (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 77268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 77271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 77280 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77286 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77291 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 77299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77301 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 77304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 77307 */   GIR_RootConstrainSelectedInstOperands,
     /* 77308 */   // GIR_Coverage, 19504,
     /* 77308 */   GIR_EraseRootFromParent_Done,
     /* 77309 */ // Label 2369: @77309
     /* 77309 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(77380), // Rule ID 19505 //
     /* 77314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 77317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 77320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 77324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77328 */   // MIs[0] Operand 2
     /* 77328 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 77339 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v8f16] } (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 77339 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 77342 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77346 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 77351 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77357 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77362 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 77370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 77375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 77378 */   GIR_RootConstrainSelectedInstOperands,
     /* 77379 */   // GIR_Coverage, 19505,
     /* 77379 */   GIR_EraseRootFromParent_Done,
     /* 77380 */ // Label 2370: @77380
     /* 77380 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(77451), // Rule ID 19511 //
     /* 77385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 77388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 77391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 77395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77399 */   // MIs[0] Operand 2
     /* 77399 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 77410 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v8i16] } (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 77410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 77413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 77422 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77428 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77433 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 77441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77443 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 77446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 77449 */   GIR_RootConstrainSelectedInstOperands,
     /* 77450 */   // GIR_Coverage, 19511,
     /* 77450 */   GIR_EraseRootFromParent_Done,
     /* 77451 */ // Label 2371: @77451
     /* 77451 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(77522), // Rule ID 19512 //
     /* 77456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 77459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 77462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 77466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77470 */   // MIs[0] Operand 2
     /* 77470 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 77481 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v8f16] } (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 77481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 77484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 77493 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77499 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77504 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 77512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77514 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 77517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 77520 */   GIR_RootConstrainSelectedInstOperands,
     /* 77521 */   // GIR_Coverage, 19512,
     /* 77521 */   GIR_EraseRootFromParent_Done,
     /* 77522 */ // Label 2372: @77522
     /* 77522 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(77571), // Rule ID 23437 //
     /* 77527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 77530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 77534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 77538 */   // MIs[0] Operand 2
     /* 77538 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77549 */   // (extract_subvector:{ *:[v8i16] } VR256:{ *:[v16i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } VR256:{ *:[v16i16] }:$src, sub_xmm:{ *:[i32] })
     /* 77549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77554 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 77560 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 77565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 77570 */   // GIR_Coverage, 23437,
     /* 77570 */   GIR_EraseRootFromParent_Done,
     /* 77571 */ // Label 2373: @77571
     /* 77571 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(77620), // Rule ID 23443 //
     /* 77576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 77579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 77583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 77587 */   // MIs[0] Operand 2
     /* 77587 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77598 */   // (extract_subvector:{ *:[v8f16] } VR256:{ *:[v16f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } VR256:{ *:[v16f16] }:$src, sub_xmm:{ *:[i32] })
     /* 77598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77603 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 77609 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 77614 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 77619 */   // GIR_Coverage, 23443,
     /* 77619 */   GIR_EraseRootFromParent_Done,
     /* 77620 */ // Label 2374: @77620
     /* 77620 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(77669), // Rule ID 23458 //
     /* 77625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 77628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 77632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77636 */   // MIs[0] Operand 2
     /* 77636 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77647 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, sub_xmm:{ *:[i32] })
     /* 77647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77652 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 77658 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 77663 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77668 */   // GIR_Coverage, 23458,
     /* 77668 */   GIR_EraseRootFromParent_Done,
     /* 77669 */ // Label 2375: @77669
     /* 77669 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(77718), // Rule ID 23464 //
     /* 77674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 77677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 77681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77685 */   // MIs[0] Operand 2
     /* 77685 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77696 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, sub_xmm:{ *:[i32] })
     /* 77696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77701 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 77707 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 77712 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77717 */   // GIR_Coverage, 23464,
     /* 77717 */   GIR_EraseRootFromParent_Done,
     /* 77718 */ // Label 2376: @77718
     /* 77718 */ GIM_Reject,
     /* 77719 */ // Label 2325: @77719
     /* 77719 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(77801),
     /* 77724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 77727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 77731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77735 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77746 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(77773), // Rule ID 23467 //
     /* 77751 */     // (extract_subvector:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] })
     /* 77751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77756 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77762 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77767 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77772 */     // GIR_Coverage, 23467,
     /* 77772 */     GIR_EraseRootFromParent_Done,
     /* 77773 */   // Label 2378: @77773
     /* 77773 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(77800), // Rule ID 23470 //
     /* 77778 */     // (extract_subvector:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] })
     /* 77778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77783 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77789 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77799 */     // GIR_Coverage, 23470,
     /* 77799 */     GIR_EraseRootFromParent_Done,
     /* 77800 */   // Label 2379: @77800
     /* 77800 */   GIM_Reject,
     /* 77801 */ // Label 2377: @77801
     /* 77801 */ GIM_Reject,
     /* 77802 */ // Label 2326: @77802
     /* 77802 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(77842), // Rule ID 20085 //
     /* 77807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 77810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 77814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 77818 */   // MIs[0] Operand 2
     /* 77818 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77829 */   // (extract_subvector:{ *:[v16i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } VK32:{ *:[v32i1] }:$src, VK16:{ *:[i32] })
     /* 77829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77834 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 77836 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 77841 */   // GIR_Coverage, 20085,
     /* 77841 */   GIR_EraseRootFromParent_Done,
     /* 77842 */ // Label 2380: @77842
     /* 77842 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(77882), // Rule ID 20087 //
     /* 77847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 77850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 77854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 77858 */   // MIs[0] Operand 2
     /* 77858 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77869 */   // (extract_subvector:{ *:[v16i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } VK64:{ *:[v64i1] }:$src, VK16:{ *:[i32] })
     /* 77869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77874 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 77876 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 77881 */   // GIR_Coverage, 20087,
     /* 77881 */   GIR_EraseRootFromParent_Done,
     /* 77882 */ // Label 2381: @77882
     /* 77882 */ GIM_Reject,
     /* 77883 */ // Label 2327: @77883
     /* 77883 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(77954), // Rule ID 19506 //
     /* 77888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 77891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 77894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 77898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77902 */   // MIs[0] Operand 2
     /* 77902 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 77913 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 16:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v16i8] } (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 77913 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 77916 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77920 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 77925 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77931 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77936 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 77944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77946 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 77949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 77952 */   GIR_RootConstrainSelectedInstOperands,
     /* 77953 */   // GIR_Coverage, 19506,
     /* 77953 */   GIR_EraseRootFromParent_Done,
     /* 77954 */ // Label 2382: @77954
     /* 77954 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(78025), // Rule ID 19513 //
     /* 77959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 77962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 77965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 77969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77973 */   // MIs[0] Operand 2
     /* 77973 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 77984 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 16:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v16i8] } (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 77984 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 77987 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77991 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 77996 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 78002 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 78007 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 78012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 78015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78017 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 78020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 78023 */   GIR_RootConstrainSelectedInstOperands,
     /* 78024 */   // GIR_Coverage, 19513,
     /* 78024 */   GIR_EraseRootFromParent_Done,
     /* 78025 */ // Label 2383: @78025
     /* 78025 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(78074), // Rule ID 23440 //
     /* 78030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 78033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 78037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 78041 */   // MIs[0] Operand 2
     /* 78041 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 78052 */   // (extract_subvector:{ *:[v16i8] } VR256:{ *:[v32i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } VR256:{ *:[v32i8] }:$src, sub_xmm:{ *:[i32] })
     /* 78052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78057 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 78063 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 78068 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 78073 */   // GIR_Coverage, 23440,
     /* 78073 */   GIR_EraseRootFromParent_Done,
     /* 78074 */ // Label 2384: @78074
     /* 78074 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(78123), // Rule ID 23461 //
     /* 78079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 78082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 78086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 78090 */   // MIs[0] Operand 2
     /* 78090 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 78101 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, sub_xmm:{ *:[i32] })
     /* 78101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78106 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 78112 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 78117 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 78122 */   // GIR_Coverage, 23461,
     /* 78122 */   GIR_EraseRootFromParent_Done,
     /* 78123 */ // Label 2385: @78123
     /* 78123 */ GIM_Reject,
     /* 78124 */ // Label 2328: @78124
     /* 78124 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(78206),
     /* 78129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 78132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 78136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 78140 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 78151 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(78178), // Rule ID 23479 //
     /* 78156 */     // (extract_subvector:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] })
     /* 78156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78161 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 78167 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 78172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 78177 */     // GIR_Coverage, 23479,
     /* 78177 */     GIR_EraseRootFromParent_Done,
     /* 78178 */   // Label 2387: @78178
     /* 78178 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(78205), // Rule ID 23485 //
     /* 78183 */     // (extract_subvector:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] })
     /* 78183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78188 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 78194 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 78199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 78204 */     // GIR_Coverage, 23485,
     /* 78204 */     GIR_EraseRootFromParent_Done,
     /* 78205 */   // Label 2388: @78205
     /* 78205 */   GIM_Reject,
     /* 78206 */ // Label 2386: @78206
     /* 78206 */ GIM_Reject,
     /* 78207 */ // Label 2329: @78207
     /* 78207 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(78247), // Rule ID 20089 //
     /* 78212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 78215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 78219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 78223 */   // MIs[0] Operand 2
     /* 78223 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 78234 */   // (extract_subvector:{ *:[v32i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } VK64:{ *:[v64i1] }:$src, VK32:{ *:[i32] })
     /* 78234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78239 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78241 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 78246 */   // GIR_Coverage, 20089,
     /* 78246 */   GIR_EraseRootFromParent_Done,
     /* 78247 */ // Label 2389: @78247
     /* 78247 */ GIM_Reject,
     /* 78248 */ // Label 2330: @78248
     /* 78248 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(78297), // Rule ID 23482 //
     /* 78253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 78256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 78260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 78264 */   // MIs[0] Operand 2
     /* 78264 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 78275 */   // (extract_subvector:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] })
     /* 78275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78280 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 78286 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 78291 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 78296 */   // GIR_Coverage, 23482,
     /* 78296 */   GIR_EraseRootFromParent_Done,
     /* 78297 */ // Label 2390: @78297
     /* 78297 */ GIM_Reject,
     /* 78298 */ // Label 2331: @78298
     /* 78298 */ GIM_Reject,
     /* 78299 */ // Label 54: @78299
     /* 78299 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2403*/ GIMT_Encode4(80280),
     /* 78310 */ /*GILLT_v2s64*//*Label 2391*/ GIMT_Encode4(78378), GIMT_Encode4(0),
     /* 78318 */ /*GILLT_v4s32*//*Label 2392*/ GIMT_Encode4(78580),
     /* 78322 */ /*GILLT_v4s64*//*Label 2393*/ GIMT_Encode4(78782), GIMT_Encode4(0),
     /* 78330 */ /*GILLT_v8s16*//*Label 2394*/ GIMT_Encode4(78984),
     /* 78334 */ /*GILLT_v8s32*//*Label 2395*/ GIMT_Encode4(79099),
     /* 78338 */ /*GILLT_v8s64*//*Label 2396*/ GIMT_Encode4(79301), GIMT_Encode4(0),
     /* 78346 */ /*GILLT_v16s8*//*Label 2397*/ GIMT_Encode4(79503),
     /* 78350 */ /*GILLT_v16s16*//*Label 2398*/ GIMT_Encode4(79618),
     /* 78354 */ /*GILLT_v16s32*//*Label 2399*/ GIMT_Encode4(79733), GIMT_Encode4(0),
     /* 78362 */ /*GILLT_v32s8*//*Label 2400*/ GIMT_Encode4(79935),
     /* 78366 */ /*GILLT_v32s16*//*Label 2401*/ GIMT_Encode4(80050), GIMT_Encode4(0),
     /* 78374 */ /*GILLT_v64s8*//*Label 2402*/ GIMT_Encode4(80165),
     /* 78378 */ // Label 2391: @78378
     /* 78378 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(78579),
     /* 78383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 78386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 78389 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 78392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 78396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 78400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 78404 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(78437), // Rule ID 22143 //
     /* 78409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78416 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 78422 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 78424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 78426 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, immAllZerosV:{ *:[v2i64] })  =>  (VPCOMPRESSQZ128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 78426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrkz),
     /* 78429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78431 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78433 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78435 */     GIR_RootConstrainSelectedInstOperands,
     /* 78436 */     // GIR_Coverage, 22143,
     /* 78436 */     GIR_EraseRootFromParent_Done,
     /* 78437 */   // Label 2405: @78437
     /* 78437 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(78470), // Rule ID 22179 //
     /* 78442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78449 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 78455 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 78457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 78459 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, immAllZerosV:{ *:[v2f64] })  =>  (VCOMPRESSPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 78459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrkz),
     /* 78462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78464 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78466 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78468 */     GIR_RootConstrainSelectedInstOperands,
     /* 78469 */     // GIR_Coverage, 22179,
     /* 78469 */     GIR_EraseRootFromParent_Done,
     /* 78470 */   // Label 2406: @78470
     /* 78470 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(78499), // Rule ID 22142 //
     /* 78475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 78486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 78488 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, (undef:{ *:[v2i64] }))  =>  (VPCOMPRESSQZ128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 78488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrkz),
     /* 78491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78493 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78495 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78497 */     GIR_RootConstrainSelectedInstOperands,
     /* 78498 */     // GIR_Coverage, 22142,
     /* 78498 */     GIR_EraseRootFromParent_Done,
     /* 78499 */   // Label 2407: @78499
     /* 78499 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(78528), // Rule ID 22178 //
     /* 78504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 78515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 78517 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, (undef:{ *:[v2f64] }))  =>  (VCOMPRESSPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 78517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrkz),
     /* 78520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78522 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78524 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78526 */     GIR_RootConstrainSelectedInstOperands,
     /* 78527 */     // GIR_Coverage, 22178,
     /* 78527 */     GIR_EraseRootFromParent_Done,
     /* 78528 */   // Label 2408: @78528
     /* 78528 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(78553), // Rule ID 22144 //
     /* 78533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 78540 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$passthru)  =>  (VPCOMPRESSQZ128rrk:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$passthru, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 78540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrk),
     /* 78543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78545 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 78547 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78549 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78551 */     GIR_RootConstrainSelectedInstOperands,
     /* 78552 */     // GIR_Coverage, 22144,
     /* 78552 */     GIR_EraseRootFromParent_Done,
     /* 78553 */   // Label 2409: @78553
     /* 78553 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(78578), // Rule ID 22180 //
     /* 78558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 78565 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$passthru)  =>  (VCOMPRESSPDZ128rrk:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$passthru, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 78565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrk),
     /* 78568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78570 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 78572 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78574 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78576 */     GIR_RootConstrainSelectedInstOperands,
     /* 78577 */     // GIR_Coverage, 22180,
     /* 78577 */     GIR_EraseRootFromParent_Done,
     /* 78578 */   // Label 2410: @78578
     /* 78578 */   GIM_Reject,
     /* 78579 */ // Label 2404: @78579
     /* 78579 */ GIM_Reject,
     /* 78580 */ // Label 2392: @78580
     /* 78580 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(78781),
     /* 78585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 78588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 78591 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 78594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 78598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 78602 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 78606 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(78639), // Rule ID 22125 //
     /* 78611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78618 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 78624 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 78626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 78628 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4i32] })  =>  (VPCOMPRESSDZ128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 78628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrkz),
     /* 78631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78633 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78635 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78637 */     GIR_RootConstrainSelectedInstOperands,
     /* 78638 */     // GIR_Coverage, 22125,
     /* 78638 */     GIR_EraseRootFromParent_Done,
     /* 78639 */   // Label 2412: @78639
     /* 78639 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(78672), // Rule ID 22161 //
     /* 78644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78651 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 78657 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 78659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 78661 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4f32] })  =>  (VCOMPRESSPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 78661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrkz),
     /* 78664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78666 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78668 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78670 */     GIR_RootConstrainSelectedInstOperands,
     /* 78671 */     // GIR_Coverage, 22161,
     /* 78671 */     GIR_EraseRootFromParent_Done,
     /* 78672 */   // Label 2413: @78672
     /* 78672 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(78701), // Rule ID 22124 //
     /* 78677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 78688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 78690 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4i32] }))  =>  (VPCOMPRESSDZ128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 78690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrkz),
     /* 78693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78695 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78697 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78699 */     GIR_RootConstrainSelectedInstOperands,
     /* 78700 */     // GIR_Coverage, 22124,
     /* 78700 */     GIR_EraseRootFromParent_Done,
     /* 78701 */   // Label 2414: @78701
     /* 78701 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(78730), // Rule ID 22160 //
     /* 78706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 78717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 78719 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4f32] }))  =>  (VCOMPRESSPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 78719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrkz),
     /* 78722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78724 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78726 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78728 */     GIR_RootConstrainSelectedInstOperands,
     /* 78729 */     // GIR_Coverage, 22160,
     /* 78729 */     GIR_EraseRootFromParent_Done,
     /* 78730 */   // Label 2415: @78730
     /* 78730 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(78755), // Rule ID 22126 //
     /* 78735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 78742 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$passthru)  =>  (VPCOMPRESSDZ128rrk:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 78742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrk),
     /* 78745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78747 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 78749 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78751 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78753 */     GIR_RootConstrainSelectedInstOperands,
     /* 78754 */     // GIR_Coverage, 22126,
     /* 78754 */     GIR_EraseRootFromParent_Done,
     /* 78755 */   // Label 2416: @78755
     /* 78755 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(78780), // Rule ID 22162 //
     /* 78760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 78767 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$passthru)  =>  (VCOMPRESSPSZ128rrk:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 78767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrk),
     /* 78770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78772 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 78774 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78776 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78778 */     GIR_RootConstrainSelectedInstOperands,
     /* 78779 */     // GIR_Coverage, 22162,
     /* 78779 */     GIR_EraseRootFromParent_Done,
     /* 78780 */   // Label 2417: @78780
     /* 78780 */   GIM_Reject,
     /* 78781 */ // Label 2411: @78781
     /* 78781 */ GIM_Reject,
     /* 78782 */ // Label 2393: @78782
     /* 78782 */ GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(78983),
     /* 78787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 78790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 78793 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 78796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 78800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 78804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 78808 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(78841), // Rule ID 22137 //
     /* 78813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78820 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 78826 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 78828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 78830 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4i64] })  =>  (VPCOMPRESSQZ256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 78830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrkz),
     /* 78833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78835 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78837 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78839 */     GIR_RootConstrainSelectedInstOperands,
     /* 78840 */     // GIR_Coverage, 22137,
     /* 78840 */     GIR_EraseRootFromParent_Done,
     /* 78841 */   // Label 2419: @78841
     /* 78841 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(78874), // Rule ID 22173 //
     /* 78846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78853 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 78859 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 78861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 78863 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4f64] })  =>  (VCOMPRESSPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 78863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrkz),
     /* 78866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78868 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78870 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78872 */     GIR_RootConstrainSelectedInstOperands,
     /* 78873 */     // GIR_Coverage, 22173,
     /* 78873 */     GIR_EraseRootFromParent_Done,
     /* 78874 */   // Label 2420: @78874
     /* 78874 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(78903), // Rule ID 22136 //
     /* 78879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 78890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 78892 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4i64] }))  =>  (VPCOMPRESSQZ256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 78892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrkz),
     /* 78895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78897 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78899 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78901 */     GIR_RootConstrainSelectedInstOperands,
     /* 78902 */     // GIR_Coverage, 22136,
     /* 78902 */     GIR_EraseRootFromParent_Done,
     /* 78903 */   // Label 2421: @78903
     /* 78903 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(78932), // Rule ID 22172 //
     /* 78908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 78919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 78921 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4f64] }))  =>  (VCOMPRESSPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 78921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrkz),
     /* 78924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78926 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78928 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78930 */     GIR_RootConstrainSelectedInstOperands,
     /* 78931 */     // GIR_Coverage, 22172,
     /* 78931 */     GIR_EraseRootFromParent_Done,
     /* 78932 */   // Label 2422: @78932
     /* 78932 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(78957), // Rule ID 22138 //
     /* 78937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 78944 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$passthru)  =>  (VPCOMPRESSQZ256rrk:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 78944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrk),
     /* 78947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78949 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 78951 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78953 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78955 */     GIR_RootConstrainSelectedInstOperands,
     /* 78956 */     // GIR_Coverage, 22138,
     /* 78956 */     GIR_EraseRootFromParent_Done,
     /* 78957 */   // Label 2423: @78957
     /* 78957 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(78982), // Rule ID 22174 //
     /* 78962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 78969 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$passthru)  =>  (VCOMPRESSPDZ256rrk:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 78969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrk),
     /* 78972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78974 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 78976 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78978 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78980 */     GIR_RootConstrainSelectedInstOperands,
     /* 78981 */     // GIR_Coverage, 22174,
     /* 78981 */     GIR_EraseRootFromParent_Done,
     /* 78982 */   // Label 2424: @78982
     /* 78982 */   GIM_Reject,
     /* 78983 */ // Label 2418: @78983
     /* 78983 */ GIM_Reject,
     /* 78984 */ // Label 2394: @78984
     /* 78984 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(79098),
     /* 78989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 78992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 78995 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 78998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 79002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 79006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 79010 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(79043), // Rule ID 22545 //
     /* 79015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 79018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79022 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79028 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79032 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i16] })  =>  (VPCOMPRESSWZ128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 79032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrkz),
     /* 79035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79037 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79039 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79041 */     GIR_RootConstrainSelectedInstOperands,
     /* 79042 */     // GIR_Coverage, 22545,
     /* 79042 */     GIR_EraseRootFromParent_Done,
     /* 79043 */   // Label 2426: @79043
     /* 79043 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(79072), // Rule ID 22544 //
     /* 79048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 79051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79061 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i16] }))  =>  (VPCOMPRESSWZ128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 79061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrkz),
     /* 79064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79066 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79068 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79070 */     GIR_RootConstrainSelectedInstOperands,
     /* 79071 */     // GIR_Coverage, 22544,
     /* 79071 */     GIR_EraseRootFromParent_Done,
     /* 79072 */   // Label 2427: @79072
     /* 79072 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(79097), // Rule ID 22546 //
     /* 79077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 79080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 79084 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$passthru)  =>  (VPCOMPRESSWZ128rrk:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 79084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrk),
     /* 79087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79089 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79091 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79093 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79095 */     GIR_RootConstrainSelectedInstOperands,
     /* 79096 */     // GIR_Coverage, 22546,
     /* 79096 */     GIR_EraseRootFromParent_Done,
     /* 79097 */   // Label 2428: @79097
     /* 79097 */   GIM_Reject,
     /* 79098 */ // Label 2425: @79098
     /* 79098 */ GIM_Reject,
     /* 79099 */ // Label 2395: @79099
     /* 79099 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(79300),
     /* 79104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 79107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 79110 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 79113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 79125 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(79158), // Rule ID 22119 //
     /* 79130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79137 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79143 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79147 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i32] })  =>  (VPCOMPRESSDZ256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 79147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrkz),
     /* 79150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79152 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79154 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79156 */     GIR_RootConstrainSelectedInstOperands,
     /* 79157 */     // GIR_Coverage, 22119,
     /* 79157 */     GIR_EraseRootFromParent_Done,
     /* 79158 */   // Label 2430: @79158
     /* 79158 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(79191), // Rule ID 22155 //
     /* 79163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79170 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79176 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79180 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8f32] })  =>  (VCOMPRESSPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 79180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrkz),
     /* 79183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79185 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79187 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79189 */     GIR_RootConstrainSelectedInstOperands,
     /* 79190 */     // GIR_Coverage, 22155,
     /* 79190 */     GIR_EraseRootFromParent_Done,
     /* 79191 */   // Label 2431: @79191
     /* 79191 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(79220), // Rule ID 22118 //
     /* 79196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79209 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i32] }))  =>  (VPCOMPRESSDZ256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 79209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrkz),
     /* 79212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79214 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79216 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79218 */     GIR_RootConstrainSelectedInstOperands,
     /* 79219 */     // GIR_Coverage, 22118,
     /* 79219 */     GIR_EraseRootFromParent_Done,
     /* 79220 */   // Label 2432: @79220
     /* 79220 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(79249), // Rule ID 22154 //
     /* 79225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79238 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8f32] }))  =>  (VCOMPRESSPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 79238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrkz),
     /* 79241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79243 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79245 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79247 */     GIR_RootConstrainSelectedInstOperands,
     /* 79248 */     // GIR_Coverage, 22154,
     /* 79248 */     GIR_EraseRootFromParent_Done,
     /* 79249 */   // Label 2433: @79249
     /* 79249 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(79274), // Rule ID 22120 //
     /* 79254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79261 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$passthru)  =>  (VPCOMPRESSDZ256rrk:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 79261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrk),
     /* 79264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79266 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79268 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79270 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79272 */     GIR_RootConstrainSelectedInstOperands,
     /* 79273 */     // GIR_Coverage, 22120,
     /* 79273 */     GIR_EraseRootFromParent_Done,
     /* 79274 */   // Label 2434: @79274
     /* 79274 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(79299), // Rule ID 22156 //
     /* 79279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79286 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$passthru)  =>  (VCOMPRESSPSZ256rrk:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 79286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrk),
     /* 79289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79291 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79293 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79295 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79297 */     GIR_RootConstrainSelectedInstOperands,
     /* 79298 */     // GIR_Coverage, 22156,
     /* 79298 */     GIR_EraseRootFromParent_Done,
     /* 79299 */   // Label 2435: @79299
     /* 79299 */   GIM_Reject,
     /* 79300 */ // Label 2429: @79300
     /* 79300 */ GIM_Reject,
     /* 79301 */ // Label 2396: @79301
     /* 79301 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(79502),
     /* 79306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 79309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 79312 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 79315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 79319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 79323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 79327 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(79360), // Rule ID 22131 //
     /* 79332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79339 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79345 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79349 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i64] })  =>  (VPCOMPRESSQZrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 79349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrkz),
     /* 79352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79354 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79356 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79358 */     GIR_RootConstrainSelectedInstOperands,
     /* 79359 */     // GIR_Coverage, 22131,
     /* 79359 */     GIR_EraseRootFromParent_Done,
     /* 79360 */   // Label 2437: @79360
     /* 79360 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(79393), // Rule ID 22167 //
     /* 79365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79372 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79378 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79382 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8f64] })  =>  (VCOMPRESSPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 79382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrkz),
     /* 79385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79387 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79389 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79391 */     GIR_RootConstrainSelectedInstOperands,
     /* 79392 */     // GIR_Coverage, 22167,
     /* 79392 */     GIR_EraseRootFromParent_Done,
     /* 79393 */   // Label 2438: @79393
     /* 79393 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(79422), // Rule ID 22130 //
     /* 79398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79411 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i64] }))  =>  (VPCOMPRESSQZrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 79411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrkz),
     /* 79414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79416 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79418 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79420 */     GIR_RootConstrainSelectedInstOperands,
     /* 79421 */     // GIR_Coverage, 22130,
     /* 79421 */     GIR_EraseRootFromParent_Done,
     /* 79422 */   // Label 2439: @79422
     /* 79422 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(79451), // Rule ID 22166 //
     /* 79427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79440 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8f64] }))  =>  (VCOMPRESSPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 79440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrkz),
     /* 79443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79445 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79447 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79449 */     GIR_RootConstrainSelectedInstOperands,
     /* 79450 */     // GIR_Coverage, 22166,
     /* 79450 */     GIR_EraseRootFromParent_Done,
     /* 79451 */   // Label 2440: @79451
     /* 79451 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(79476), // Rule ID 22132 //
     /* 79456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 79463 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$passthru)  =>  (VPCOMPRESSQZrrk:{ *:[v8i64] } VR512:{ *:[v8i64] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 79463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrk),
     /* 79466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79468 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79470 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79472 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79474 */     GIR_RootConstrainSelectedInstOperands,
     /* 79475 */     // GIR_Coverage, 22132,
     /* 79475 */     GIR_EraseRootFromParent_Done,
     /* 79476 */   // Label 2441: @79476
     /* 79476 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(79501), // Rule ID 22168 //
     /* 79481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 79488 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$passthru)  =>  (VCOMPRESSPDZrrk:{ *:[v8f64] } VR512:{ *:[v8f64] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 79488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrk),
     /* 79491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79493 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79495 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79497 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79499 */     GIR_RootConstrainSelectedInstOperands,
     /* 79500 */     // GIR_Coverage, 22168,
     /* 79500 */     GIR_EraseRootFromParent_Done,
     /* 79501 */   // Label 2442: @79501
     /* 79501 */   GIM_Reject,
     /* 79502 */ // Label 2436: @79502
     /* 79502 */ GIM_Reject,
     /* 79503 */ // Label 2397: @79503
     /* 79503 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(79617),
     /* 79508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 79511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 79514 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 79517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 79521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 79525 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 79529 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(79562), // Rule ID 22527 //
     /* 79534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 79537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79541 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79547 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79551 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i8] })  =>  (VPCOMPRESSBZ128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 79551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrkz),
     /* 79554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79556 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79558 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79560 */     GIR_RootConstrainSelectedInstOperands,
     /* 79561 */     // GIR_Coverage, 22527,
     /* 79561 */     GIR_EraseRootFromParent_Done,
     /* 79562 */   // Label 2444: @79562
     /* 79562 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(79591), // Rule ID 22526 //
     /* 79567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 79570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79580 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i8] }))  =>  (VPCOMPRESSBZ128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 79580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrkz),
     /* 79583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79585 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79587 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79589 */     GIR_RootConstrainSelectedInstOperands,
     /* 79590 */     // GIR_Coverage, 22526,
     /* 79590 */     GIR_EraseRootFromParent_Done,
     /* 79591 */   // Label 2445: @79591
     /* 79591 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(79616), // Rule ID 22528 //
     /* 79596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 79599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 79603 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$passthru)  =>  (VPCOMPRESSBZ128rrk:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 79603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrk),
     /* 79606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79608 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79610 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79612 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79614 */     GIR_RootConstrainSelectedInstOperands,
     /* 79615 */     // GIR_Coverage, 22528,
     /* 79615 */     GIR_EraseRootFromParent_Done,
     /* 79616 */   // Label 2446: @79616
     /* 79616 */   GIM_Reject,
     /* 79617 */ // Label 2443: @79617
     /* 79617 */ GIM_Reject,
     /* 79618 */ // Label 2398: @79618
     /* 79618 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(79732),
     /* 79623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 79626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 79629 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 79632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 79644 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(79677), // Rule ID 22539 //
     /* 79649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 79652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79656 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79662 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79666 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i16] })  =>  (VPCOMPRESSWZ256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 79666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrkz),
     /* 79669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79671 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79673 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79675 */     GIR_RootConstrainSelectedInstOperands,
     /* 79676 */     // GIR_Coverage, 22539,
     /* 79676 */     GIR_EraseRootFromParent_Done,
     /* 79677 */   // Label 2448: @79677
     /* 79677 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(79706), // Rule ID 22538 //
     /* 79682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 79685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79695 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i16] }))  =>  (VPCOMPRESSWZ256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 79695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrkz),
     /* 79698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79700 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79702 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79704 */     GIR_RootConstrainSelectedInstOperands,
     /* 79705 */     // GIR_Coverage, 22538,
     /* 79705 */     GIR_EraseRootFromParent_Done,
     /* 79706 */   // Label 2449: @79706
     /* 79706 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(79731), // Rule ID 22540 //
     /* 79711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 79714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79718 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$passthru)  =>  (VPCOMPRESSWZ256rrk:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 79718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrk),
     /* 79721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79723 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79725 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79727 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79729 */     GIR_RootConstrainSelectedInstOperands,
     /* 79730 */     // GIR_Coverage, 22540,
     /* 79730 */     GIR_EraseRootFromParent_Done,
     /* 79731 */   // Label 2450: @79731
     /* 79731 */   GIM_Reject,
     /* 79732 */ // Label 2447: @79732
     /* 79732 */ GIM_Reject,
     /* 79733 */ // Label 2399: @79733
     /* 79733 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(79934),
     /* 79738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 79741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 79744 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 79747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 79751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 79755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 79759 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(79792), // Rule ID 22113 //
     /* 79764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79771 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79777 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79781 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i32] })  =>  (VPCOMPRESSDZrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 79781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrkz),
     /* 79784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79786 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79788 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79790 */     GIR_RootConstrainSelectedInstOperands,
     /* 79791 */     // GIR_Coverage, 22113,
     /* 79791 */     GIR_EraseRootFromParent_Done,
     /* 79792 */   // Label 2452: @79792
     /* 79792 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(79825), // Rule ID 22149 //
     /* 79797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79804 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79810 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79814 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16f32] })  =>  (VCOMPRESSPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 79814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrkz),
     /* 79817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79819 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79821 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79823 */     GIR_RootConstrainSelectedInstOperands,
     /* 79824 */     // GIR_Coverage, 22149,
     /* 79824 */     GIR_EraseRootFromParent_Done,
     /* 79825 */   // Label 2453: @79825
     /* 79825 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(79854), // Rule ID 22112 //
     /* 79830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79843 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i32] }))  =>  (VPCOMPRESSDZrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 79843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrkz),
     /* 79846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79848 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79850 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79852 */     GIR_RootConstrainSelectedInstOperands,
     /* 79853 */     // GIR_Coverage, 22112,
     /* 79853 */     GIR_EraseRootFromParent_Done,
     /* 79854 */   // Label 2454: @79854
     /* 79854 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(79883), // Rule ID 22148 //
     /* 79859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79872 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16f32] }))  =>  (VCOMPRESSPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 79872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrkz),
     /* 79875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79877 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79879 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79881 */     GIR_RootConstrainSelectedInstOperands,
     /* 79882 */     // GIR_Coverage, 22148,
     /* 79882 */     GIR_EraseRootFromParent_Done,
     /* 79883 */   // Label 2455: @79883
     /* 79883 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(79908), // Rule ID 22114 //
     /* 79888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 79895 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$passthru)  =>  (VPCOMPRESSDZrrk:{ *:[v16i32] } VR512:{ *:[v16i32] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 79895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrk),
     /* 79898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79900 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79902 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79904 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79906 */     GIR_RootConstrainSelectedInstOperands,
     /* 79907 */     // GIR_Coverage, 22114,
     /* 79907 */     GIR_EraseRootFromParent_Done,
     /* 79908 */   // Label 2456: @79908
     /* 79908 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(79933), // Rule ID 22150 //
     /* 79913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 79920 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$passthru)  =>  (VCOMPRESSPSZrrk:{ *:[v16f32] } VR512:{ *:[v16f32] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 79920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrk),
     /* 79923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79925 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79927 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79929 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79931 */     GIR_RootConstrainSelectedInstOperands,
     /* 79932 */     // GIR_Coverage, 22150,
     /* 79932 */     GIR_EraseRootFromParent_Done,
     /* 79933 */   // Label 2457: @79933
     /* 79933 */   GIM_Reject,
     /* 79934 */ // Label 2451: @79934
     /* 79934 */ GIM_Reject,
     /* 79935 */ // Label 2400: @79935
     /* 79935 */ GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(80049),
     /* 79940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 79943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 79946 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 79949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 79961 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(79994), // Rule ID 22521 //
     /* 79966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 79969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79973 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79979 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79983 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, immAllZerosV:{ *:[v32i8] })  =>  (VPCOMPRESSBZ256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 79983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrkz),
     /* 79986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79988 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79990 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79992 */     GIR_RootConstrainSelectedInstOperands,
     /* 79993 */     // GIR_Coverage, 22521,
     /* 79993 */     GIR_EraseRootFromParent_Done,
     /* 79994 */   // Label 2459: @79994
     /* 79994 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(80023), // Rule ID 22520 //
     /* 79999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 80002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 80010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80012 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, (undef:{ *:[v32i8] }))  =>  (VPCOMPRESSBZ256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 80012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrkz),
     /* 80015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80017 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80019 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80021 */     GIR_RootConstrainSelectedInstOperands,
     /* 80022 */     // GIR_Coverage, 22520,
     /* 80022 */     GIR_EraseRootFromParent_Done,
     /* 80023 */   // Label 2460: @80023
     /* 80023 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(80048), // Rule ID 22522 //
     /* 80028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 80031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 80035 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$passthru)  =>  (VPCOMPRESSBZ256rrk:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$passthru, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 80035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrk),
     /* 80038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80040 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 80042 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80044 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80046 */     GIR_RootConstrainSelectedInstOperands,
     /* 80047 */     // GIR_Coverage, 22522,
     /* 80047 */     GIR_EraseRootFromParent_Done,
     /* 80048 */   // Label 2461: @80048
     /* 80048 */   GIM_Reject,
     /* 80049 */ // Label 2458: @80049
     /* 80049 */ GIM_Reject,
     /* 80050 */ // Label 2401: @80050
     /* 80050 */ GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(80164),
     /* 80055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 80058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 80061 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 80064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 80068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 80072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 80076 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(80109), // Rule ID 22533 //
     /* 80081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 80084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80088 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 80094 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 80096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80098 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, immAllZerosV:{ *:[v32i16] })  =>  (VPCOMPRESSWZrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 80098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrkz),
     /* 80101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80103 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80105 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80107 */     GIR_RootConstrainSelectedInstOperands,
     /* 80108 */     // GIR_Coverage, 22533,
     /* 80108 */     GIR_EraseRootFromParent_Done,
     /* 80109 */   // Label 2463: @80109
     /* 80109 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(80138), // Rule ID 22532 //
     /* 80114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 80117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 80125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80127 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, (undef:{ *:[v32i16] }))  =>  (VPCOMPRESSWZrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 80127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrkz),
     /* 80130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80132 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80134 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80136 */     GIR_RootConstrainSelectedInstOperands,
     /* 80137 */     // GIR_Coverage, 22532,
     /* 80137 */     GIR_EraseRootFromParent_Done,
     /* 80138 */   // Label 2464: @80138
     /* 80138 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(80163), // Rule ID 22534 //
     /* 80143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 80146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 80150 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$passthru)  =>  (VPCOMPRESSWZrrk:{ *:[v32i16] } VR512:{ *:[v32i16] }:$passthru, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 80150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrk),
     /* 80153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80155 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 80157 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80159 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80161 */     GIR_RootConstrainSelectedInstOperands,
     /* 80162 */     // GIR_Coverage, 22534,
     /* 80162 */     GIR_EraseRootFromParent_Done,
     /* 80163 */   // Label 2465: @80163
     /* 80163 */   GIM_Reject,
     /* 80164 */ // Label 2462: @80164
     /* 80164 */ GIM_Reject,
     /* 80165 */ // Label 2402: @80165
     /* 80165 */ GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(80279),
     /* 80170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 80173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 80176 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 80179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 80183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 80187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64WMRegClassID),
     /* 80191 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(80224), // Rule ID 22515 //
     /* 80196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 80199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80203 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 80209 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 80211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80213 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, immAllZerosV:{ *:[v64i8] })  =>  (VPCOMPRESSBZrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 80213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrkz),
     /* 80216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80218 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80220 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80222 */     GIR_RootConstrainSelectedInstOperands,
     /* 80223 */     // GIR_Coverage, 22515,
     /* 80223 */     GIR_EraseRootFromParent_Done,
     /* 80224 */   // Label 2467: @80224
     /* 80224 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(80253), // Rule ID 22514 //
     /* 80229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 80232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 80240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80242 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, (undef:{ *:[v64i8] }))  =>  (VPCOMPRESSBZrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 80242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrkz),
     /* 80245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80247 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80249 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80251 */     GIR_RootConstrainSelectedInstOperands,
     /* 80252 */     // GIR_Coverage, 22514,
     /* 80252 */     GIR_EraseRootFromParent_Done,
     /* 80253 */   // Label 2468: @80253
     /* 80253 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(80278), // Rule ID 22516 //
     /* 80258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 80261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 80265 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$passthru)  =>  (VPCOMPRESSBZrrk:{ *:[v64i8] } VR512:{ *:[v64i8] }:$passthru, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 80265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrk),
     /* 80268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80270 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 80272 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80274 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80276 */     GIR_RootConstrainSelectedInstOperands,
     /* 80277 */     // GIR_Coverage, 22516,
     /* 80277 */     GIR_EraseRootFromParent_Done,
     /* 80278 */   // Label 2469: @80278
     /* 80278 */   GIM_Reject,
     /* 80279 */ // Label 2466: @80279
     /* 80279 */ GIM_Reject,
     /* 80280 */ // Label 2403: @80280
     /* 80280 */ GIM_Reject,
     /* 80281 */ // Label 55: @80281
     /* 80281 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2473*/ GIMT_Encode4(80403),
     /* 80292 */ /*GILLT_s16*//*Label 2470*/ GIMT_Encode4(80304),
     /* 80296 */ /*GILLT_s32*//*Label 2471*/ GIMT_Encode4(80337),
     /* 80300 */ /*GILLT_s64*//*Label 2472*/ GIMT_Encode4(80370),
     /* 80304 */ // Label 2470: @80304
     /* 80304 */ GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(80336), // Rule ID 76 //
     /* 80309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 80312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 80315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 80319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 80323 */   // (cttz:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (TZCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 80323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT16rr),
     /* 80328 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 80334 */   GIR_RootConstrainSelectedInstOperands,
     /* 80335 */   // GIR_Coverage, 76,
     /* 80335 */   GIR_Done,
     /* 80336 */ // Label 2474: @80336
     /* 80336 */ GIM_Reject,
     /* 80337 */ // Label 2471: @80337
     /* 80337 */ GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(80369), // Rule ID 78 //
     /* 80342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 80345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 80348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 80352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 80356 */   // (cttz:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (TZCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 80356 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT32rr),
     /* 80361 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 80367 */   GIR_RootConstrainSelectedInstOperands,
     /* 80368 */   // GIR_Coverage, 78,
     /* 80368 */   GIR_Done,
     /* 80369 */ // Label 2475: @80369
     /* 80369 */ GIM_Reject,
     /* 80370 */ // Label 2472: @80370
     /* 80370 */ GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(80402), // Rule ID 80 //
     /* 80375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 80378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 80381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 80385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 80389 */   // (cttz:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (TZCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 80389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT64rr),
     /* 80394 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 80400 */   GIR_RootConstrainSelectedInstOperands,
     /* 80401 */   // GIR_Coverage, 80,
     /* 80401 */   GIR_Done,
     /* 80402 */ // Label 2476: @80402
     /* 80402 */ GIM_Reject,
     /* 80403 */ // Label 2473: @80403
     /* 80403 */ GIM_Reject,
     /* 80404 */ // Label 56: @80404
     /* 80404 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2480*/ GIMT_Encode4(80565),
     /* 80415 */ /*GILLT_s16*//*Label 2477*/ GIMT_Encode4(80427),
     /* 80419 */ /*GILLT_s32*//*Label 2478*/ GIMT_Encode4(80473),
     /* 80423 */ /*GILLT_s64*//*Label 2479*/ GIMT_Encode4(80519),
     /* 80427 */ // Label 2477: @80427
     /* 80427 */ GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(80472), // Rule ID 23406 //
     /* 80432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 80435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 80439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 80443 */   // (cttz_zero_undef:{ *:[i16] } GR16:{ *:[i16] }:$src)  =>  (BSF16rr:{ *:[i16] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i16] }), GR16:{ *:[i16] }:$src)
     /* 80443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 80446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 80450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 80455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 80457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF16rr),
     /* 80460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80462 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 80465 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80467 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 80470 */   GIR_RootConstrainSelectedInstOperands,
     /* 80471 */   // GIR_Coverage, 23406,
     /* 80471 */   GIR_EraseRootFromParent_Done,
     /* 80472 */ // Label 2481: @80472
     /* 80472 */ GIM_Reject,
     /* 80473 */ // Label 2478: @80473
     /* 80473 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(80518), // Rule ID 23407 //
     /* 80478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 80481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 80485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 80489 */   // (cttz_zero_undef:{ *:[i32] } GR32:{ *:[i32] }:$src)  =>  (BSF32rr:{ *:[i32] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR32:{ *:[i32] }:$src)
     /* 80489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 80492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 80496 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 80501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 80503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF32rr),
     /* 80506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80508 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 80511 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80513 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 80516 */   GIR_RootConstrainSelectedInstOperands,
     /* 80517 */   // GIR_Coverage, 23407,
     /* 80517 */   GIR_EraseRootFromParent_Done,
     /* 80518 */ // Label 2482: @80518
     /* 80518 */ GIM_Reject,
     /* 80519 */ // Label 2479: @80519
     /* 80519 */ GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(80564), // Rule ID 23408 //
     /* 80524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 80527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 80531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 80535 */   // (cttz_zero_undef:{ *:[i64] } GR64:{ *:[i64] }:$src)  =>  (BSF64rr:{ *:[i64] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i64] }), GR64:{ *:[i64] }:$src)
     /* 80535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 80538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 80542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 80547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 80549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF64rr),
     /* 80552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80554 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 80557 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80559 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 80562 */   GIR_RootConstrainSelectedInstOperands,
     /* 80563 */   // GIR_Coverage, 23408,
     /* 80563 */   GIR_EraseRootFromParent_Done,
     /* 80564 */ // Label 2483: @80564
     /* 80564 */ GIM_Reject,
     /* 80565 */ // Label 2480: @80565
     /* 80565 */ GIM_Reject,
     /* 80566 */ // Label 57: @80566
     /* 80566 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(20), /*)*//*default:*//*Label 2493*/ GIMT_Encode4(81346),
     /* 80577 */ /*GILLT_s16*//*Label 2484*/ GIMT_Encode4(80649),
     /* 80581 */ /*GILLT_s32*//*Label 2485*/ GIMT_Encode4(80682),
     /* 80585 */ /*GILLT_s64*//*Label 2486*/ GIMT_Encode4(80715), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 80601 */ /*GILLT_v2s64*//*Label 2487*/ GIMT_Encode4(80748), GIMT_Encode4(0),
     /* 80609 */ /*GILLT_v4s32*//*Label 2488*/ GIMT_Encode4(80888),
     /* 80613 */ /*GILLT_v4s64*//*Label 2489*/ GIMT_Encode4(81028), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 80625 */ /*GILLT_v8s32*//*Label 2490*/ GIMT_Encode4(81160),
     /* 80629 */ /*GILLT_v8s64*//*Label 2491*/ GIMT_Encode4(81292), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 80645 */ /*GILLT_v16s32*//*Label 2492*/ GIMT_Encode4(81319),
     /* 80649 */ // Label 2484: @80649
     /* 80649 */ GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(80681), // Rule ID 70 //
     /* 80654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 80657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 80660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 80664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 80668 */   // (ctlz:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (LZCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 80668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT16rr),
     /* 80673 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 80679 */   GIR_RootConstrainSelectedInstOperands,
     /* 80680 */   // GIR_Coverage, 70,
     /* 80680 */   GIR_Done,
     /* 80681 */ // Label 2494: @80681
     /* 80681 */ GIM_Reject,
     /* 80682 */ // Label 2485: @80682
     /* 80682 */ GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(80714), // Rule ID 72 //
     /* 80687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 80690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 80693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 80697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 80701 */   // (ctlz:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (LZCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 80701 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT32rr),
     /* 80706 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 80712 */   GIR_RootConstrainSelectedInstOperands,
     /* 80713 */   // GIR_Coverage, 72,
     /* 80713 */   GIR_Done,
     /* 80714 */ // Label 2495: @80714
     /* 80714 */ GIM_Reject,
     /* 80715 */ // Label 2486: @80715
     /* 80715 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(80747), // Rule ID 74 //
     /* 80720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 80723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 80726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 80730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 80734 */   // (ctlz:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (LZCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 80734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT64rr),
     /* 80739 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 80745 */   GIR_RootConstrainSelectedInstOperands,
     /* 80746 */   // GIR_Coverage, 74,
     /* 80746 */   GIR_Done,
     /* 80747 */ // Label 2496: @80747
     /* 80747 */ GIM_Reject,
     /* 80748 */ // Label 2487: @80748
     /* 80748 */ GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(80887),
     /* 80753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 80756 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(80779), // Rule ID 13351 //
     /* 80761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 80764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 80768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 80772 */     // (ctlz:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPLZCNTQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 80772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ128rr),
     /* 80777 */     GIR_RootConstrainSelectedInstOperands,
     /* 80778 */     // GIR_Coverage, 13351,
     /* 80778 */     GIR_Done,
     /* 80779 */   // Label 2498: @80779
     /* 80779 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(80886), // Rule ID 22273 //
     /* 80784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 80787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 80791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 80795 */     // (ctlz:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPLZCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 80795 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 80798 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 80802 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 80807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 80809 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 80812 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 80816 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 80821 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 80824 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 80828 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 80831 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 80836 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 80841 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 80846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 80849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 80853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 80858 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 80861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 80863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 80866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80868 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 80875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 80880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 80885 */     // GIR_Coverage, 22273,
     /* 80885 */     GIR_EraseRootFromParent_Done,
     /* 80886 */   // Label 2499: @80886
     /* 80886 */   GIM_Reject,
     /* 80887 */ // Label 2497: @80887
     /* 80887 */ GIM_Reject,
     /* 80888 */ // Label 2488: @80888
     /* 80888 */ GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(81027),
     /* 80893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 80896 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(80919), // Rule ID 13378 //
     /* 80901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 80904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 80908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 80912 */     // (ctlz:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPLZCNTDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 80912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ128rr),
     /* 80917 */     GIR_RootConstrainSelectedInstOperands,
     /* 80918 */     // GIR_Coverage, 13378,
     /* 80918 */     GIR_Done,
     /* 80919 */   // Label 2501: @80919
     /* 80919 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(81026), // Rule ID 22275 //
     /* 80924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 80927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 80931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 80935 */     // (ctlz:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPLZCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 80935 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 80938 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 80942 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 80947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 80949 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 80952 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 80956 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 80961 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 80964 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 80968 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 80971 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 80976 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 80981 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 80986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 80989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 80993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 80998 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 81001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 81003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 81006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 81008 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 81015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 81020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81025 */     // GIR_Coverage, 22275,
     /* 81025 */     GIR_EraseRootFromParent_Done,
     /* 81026 */   // Label 2502: @81026
     /* 81026 */   GIM_Reject,
     /* 81027 */ // Label 2500: @81027
     /* 81027 */ GIM_Reject,
     /* 81028 */ // Label 2489: @81028
     /* 81028 */ GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(81159),
     /* 81033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 81036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 81040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 81044 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(81059), // Rule ID 13342 //
     /* 81049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 81052 */     // (ctlz:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPLZCNTQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 81052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ256rr),
     /* 81057 */     GIR_RootConstrainSelectedInstOperands,
     /* 81058 */     // GIR_Coverage, 13342,
     /* 81058 */     GIR_Done,
     /* 81059 */   // Label 2504: @81059
     /* 81059 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(81158), // Rule ID 22272 //
     /* 81064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 81067 */     // (ctlz:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPLZCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 81067 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 81070 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 81074 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 81081 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 81084 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 81088 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81093 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 81096 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 81100 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 81103 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 81108 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81113 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 81118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 81121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 81125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81130 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 81133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 81135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 81138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 81140 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 81147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 81152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81157 */     // GIR_Coverage, 22272,
     /* 81157 */     GIR_EraseRootFromParent_Done,
     /* 81158 */   // Label 2505: @81158
     /* 81158 */   GIM_Reject,
     /* 81159 */ // Label 2503: @81159
     /* 81159 */ GIM_Reject,
     /* 81160 */ // Label 2490: @81160
     /* 81160 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(81291),
     /* 81165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 81168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 81172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 81176 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(81191), // Rule ID 13369 //
     /* 81181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 81184 */     // (ctlz:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPLZCNTDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 81184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ256rr),
     /* 81189 */     GIR_RootConstrainSelectedInstOperands,
     /* 81190 */     // GIR_Coverage, 13369,
     /* 81190 */     GIR_Done,
     /* 81191 */   // Label 2507: @81191
     /* 81191 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(81290), // Rule ID 22274 //
     /* 81196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 81199 */     // (ctlz:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPLZCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 81199 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 81202 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 81206 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 81213 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 81216 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 81220 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81225 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 81228 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 81232 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 81235 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 81240 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81245 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 81250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 81253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 81257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81262 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 81265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 81267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 81270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 81272 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 81279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 81284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81289 */     // GIR_Coverage, 22274,
     /* 81289 */     GIR_EraseRootFromParent_Done,
     /* 81290 */   // Label 2508: @81290
     /* 81290 */   GIM_Reject,
     /* 81291 */ // Label 2506: @81291
     /* 81291 */ GIM_Reject,
     /* 81292 */ // Label 2491: @81292
     /* 81292 */ GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(81318), // Rule ID 13333 //
     /* 81297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 81300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 81303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 81307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 81311 */   // (ctlz:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPLZCNTQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 81311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 81316 */   GIR_RootConstrainSelectedInstOperands,
     /* 81317 */   // GIR_Coverage, 13333,
     /* 81317 */   GIR_Done,
     /* 81318 */ // Label 2509: @81318
     /* 81318 */ GIM_Reject,
     /* 81319 */ // Label 2492: @81319
     /* 81319 */ GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(81345), // Rule ID 13360 //
     /* 81324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 81327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 81330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 81334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 81338 */   // (ctlz:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPLZCNTDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 81338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 81343 */   GIR_RootConstrainSelectedInstOperands,
     /* 81344 */   // GIR_Coverage, 13360,
     /* 81344 */   GIR_Done,
     /* 81345 */ // Label 2510: @81345
     /* 81345 */ GIM_Reject,
     /* 81346 */ // Label 2493: @81346
     /* 81346 */ GIM_Reject,
     /* 81347 */ // Label 58: @81347
     /* 81347 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(25), /*)*//*default:*//*Label 2526*/ GIMT_Encode4(82745),
     /* 81358 */ /*GILLT_s16*//*Label 2511*/ GIMT_Encode4(81450),
     /* 81362 */ /*GILLT_s32*//*Label 2512*/ GIMT_Encode4(81483),
     /* 81366 */ /*GILLT_s64*//*Label 2513*/ GIMT_Encode4(81516), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 81382 */ /*GILLT_v2s64*//*Label 2514*/ GIMT_Encode4(81549), GIMT_Encode4(0),
     /* 81390 */ /*GILLT_v4s32*//*Label 2515*/ GIMT_Encode4(81689),
     /* 81394 */ /*GILLT_v4s64*//*Label 2516*/ GIMT_Encode4(81829), GIMT_Encode4(0),
     /* 81402 */ /*GILLT_v8s16*//*Label 2517*/ GIMT_Encode4(81961),
     /* 81406 */ /*GILLT_v8s32*//*Label 2518*/ GIMT_Encode4(82101),
     /* 81410 */ /*GILLT_v8s64*//*Label 2519*/ GIMT_Encode4(82233), GIMT_Encode4(0),
     /* 81418 */ /*GILLT_v16s8*//*Label 2520*/ GIMT_Encode4(82260),
     /* 81422 */ /*GILLT_v16s16*//*Label 2521*/ GIMT_Encode4(82400),
     /* 81426 */ /*GILLT_v16s32*//*Label 2522*/ GIMT_Encode4(82532), GIMT_Encode4(0),
     /* 81434 */ /*GILLT_v32s8*//*Label 2523*/ GIMT_Encode4(82559),
     /* 81438 */ /*GILLT_v32s16*//*Label 2524*/ GIMT_Encode4(82691), GIMT_Encode4(0),
     /* 81446 */ /*GILLT_v64s8*//*Label 2525*/ GIMT_Encode4(82718),
     /* 81450 */ // Label 2511: @81450
     /* 81450 */ GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(81482), // Rule ID 3172 //
     /* 81455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 81458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 81461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 81465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 81469 */   // (ctpop:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (POPCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 81469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT16rr),
     /* 81474 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 81480 */   GIR_RootConstrainSelectedInstOperands,
     /* 81481 */   // GIR_Coverage, 3172,
     /* 81481 */   GIR_Done,
     /* 81482 */ // Label 2527: @81482
     /* 81482 */ GIM_Reject,
     /* 81483 */ // Label 2512: @81483
     /* 81483 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(81515), // Rule ID 3174 //
     /* 81488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 81491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 81494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 81498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 81502 */   // (ctpop:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (POPCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 81502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT32rr),
     /* 81507 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 81513 */   GIR_RootConstrainSelectedInstOperands,
     /* 81514 */   // GIR_Coverage, 3174,
     /* 81514 */   GIR_Done,
     /* 81515 */ // Label 2528: @81515
     /* 81515 */ GIM_Reject,
     /* 81516 */ // Label 2513: @81516
     /* 81516 */ GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(81548), // Rule ID 3176 //
     /* 81521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 81524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 81527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 81531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 81535 */   // (ctpop:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (POPCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 81535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT64rr),
     /* 81540 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 81546 */   GIR_RootConstrainSelectedInstOperands,
     /* 81547 */   // GIR_Coverage, 3176,
     /* 81547 */   GIR_Done,
     /* 81548 */ // Label 2529: @81548
     /* 81548 */ GIM_Reject,
     /* 81549 */ // Label 2514: @81549
     /* 81549 */ GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(81688),
     /* 81554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 81557 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(81580), // Rule ID 13459 //
     /* 81562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 81565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81573 */     // (ctpop:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPOPCNTQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 81573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ128rr),
     /* 81578 */     GIR_RootConstrainSelectedInstOperands,
     /* 81579 */     // GIR_Coverage, 13459,
     /* 81579 */     GIR_Done,
     /* 81580 */   // Label 2531: @81580
     /* 81580 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(81687), // Rule ID 22277 //
     /* 81585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 81588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 81592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81596 */     // (ctpop:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPOPCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 81596 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 81599 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 81603 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 81610 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 81613 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 81617 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81622 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 81625 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 81629 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 81632 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 81637 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 81647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 81650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 81654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81659 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 81662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 81664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 81667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 81669 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 81676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 81681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81686 */     // GIR_Coverage, 22277,
     /* 81686 */     GIR_EraseRootFromParent_Done,
     /* 81687 */   // Label 2532: @81687
     /* 81687 */   GIM_Reject,
     /* 81688 */ // Label 2530: @81688
     /* 81688 */ GIM_Reject,
     /* 81689 */ // Label 2515: @81689
     /* 81689 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(81828),
     /* 81694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 81697 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(81720), // Rule ID 13486 //
     /* 81702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 81705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81713 */     // (ctpop:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPOPCNTDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 81713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ128rr),
     /* 81718 */     GIR_RootConstrainSelectedInstOperands,
     /* 81719 */     // GIR_Coverage, 13486,
     /* 81719 */     GIR_Done,
     /* 81720 */   // Label 2534: @81720
     /* 81720 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(81827), // Rule ID 22279 //
     /* 81725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 81728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 81732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81736 */     // (ctpop:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPOPCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 81736 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 81739 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 81743 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 81750 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 81753 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 81757 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81762 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 81765 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 81769 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 81772 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 81777 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81782 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 81787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 81790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 81794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81799 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 81802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 81804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 81807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 81809 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 81816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 81821 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81826 */     // GIR_Coverage, 22279,
     /* 81826 */     GIR_EraseRootFromParent_Done,
     /* 81827 */   // Label 2535: @81827
     /* 81827 */   GIM_Reject,
     /* 81828 */ // Label 2533: @81828
     /* 81828 */ GIM_Reject,
     /* 81829 */ // Label 2516: @81829
     /* 81829 */ GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(81960),
     /* 81834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 81837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 81841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 81845 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(81860), // Rule ID 13450 //
     /* 81850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 81853 */     // (ctpop:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPOPCNTQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 81853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ256rr),
     /* 81858 */     GIR_RootConstrainSelectedInstOperands,
     /* 81859 */     // GIR_Coverage, 13450,
     /* 81859 */     GIR_Done,
     /* 81860 */   // Label 2537: @81860
     /* 81860 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(81959), // Rule ID 22276 //
     /* 81865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 81868 */     // (ctpop:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPOPCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 81868 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 81871 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 81875 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 81882 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 81885 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 81889 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81894 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 81897 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 81901 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 81904 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 81909 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81914 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 81919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 81922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 81926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 81934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 81936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 81939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 81941 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 81948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 81953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81958 */     // GIR_Coverage, 22276,
     /* 81958 */     GIR_EraseRootFromParent_Done,
     /* 81959 */   // Label 2538: @81959
     /* 81959 */   GIM_Reject,
     /* 81960 */ // Label 2536: @81960
     /* 81960 */ GIM_Reject,
     /* 81961 */ // Label 2517: @81961
     /* 81961 */ GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(82100),
     /* 81966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 81969 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(81992), // Rule ID 14513 //
     /* 81974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 81977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81985 */     // (ctpop:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (VPOPCNTWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)
     /* 81985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ128rr),
     /* 81990 */     GIR_RootConstrainSelectedInstOperands,
     /* 81991 */     // GIR_Coverage, 14513,
     /* 81991 */     GIR_Done,
     /* 81992 */   // Label 2540: @81992
     /* 81992 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(82099), // Rule ID 22586 //
     /* 81997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 82000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 82004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 82008 */     // (ctpop:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPOPCNTWZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 82008 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 82011 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 82015 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 82022 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 82025 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 82029 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82034 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 82037 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 82041 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 82044 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 82049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82054 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 82059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 82062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 82066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82071 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 82074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 82076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 82079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 82081 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 82088 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 82093 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82098 */     // GIR_Coverage, 22586,
     /* 82098 */     GIR_EraseRootFromParent_Done,
     /* 82099 */   // Label 2541: @82099
     /* 82099 */   GIM_Reject,
     /* 82100 */ // Label 2539: @82100
     /* 82100 */ GIM_Reject,
     /* 82101 */ // Label 2518: @82101
     /* 82101 */ GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(82232),
     /* 82106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 82109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 82113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 82117 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(82132), // Rule ID 13477 //
     /* 82122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 82125 */     // (ctpop:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPOPCNTDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 82125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ256rr),
     /* 82130 */     GIR_RootConstrainSelectedInstOperands,
     /* 82131 */     // GIR_Coverage, 13477,
     /* 82131 */     GIR_Done,
     /* 82132 */   // Label 2543: @82132
     /* 82132 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(82231), // Rule ID 22278 //
     /* 82137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 82140 */     // (ctpop:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPOPCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 82140 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 82143 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 82147 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 82154 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 82157 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 82161 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82166 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 82169 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 82173 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 82176 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 82181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 82191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 82194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 82198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82203 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 82206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 82208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 82211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 82213 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 82220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 82225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82230 */     // GIR_Coverage, 22278,
     /* 82230 */     GIR_EraseRootFromParent_Done,
     /* 82231 */   // Label 2544: @82231
     /* 82231 */   GIM_Reject,
     /* 82232 */ // Label 2542: @82232
     /* 82232 */ GIM_Reject,
     /* 82233 */ // Label 2519: @82233
     /* 82233 */ GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(82259), // Rule ID 13441 //
     /* 82238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 82241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 82244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 82248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 82252 */   // (ctpop:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPOPCNTQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 82252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 82257 */   GIR_RootConstrainSelectedInstOperands,
     /* 82258 */   // GIR_Coverage, 13441,
     /* 82258 */   GIR_Done,
     /* 82259 */ // Label 2545: @82259
     /* 82259 */ GIM_Reject,
     /* 82260 */ // Label 2520: @82260
     /* 82260 */ GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(82399),
     /* 82265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 82268 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(82291), // Rule ID 14495 //
     /* 82273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 82276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 82280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 82284 */     // (ctpop:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (VPOPCNTBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)
     /* 82284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ128rr),
     /* 82289 */     GIR_RootConstrainSelectedInstOperands,
     /* 82290 */     // GIR_Coverage, 14495,
     /* 82290 */     GIR_Done,
     /* 82291 */   // Label 2547: @82291
     /* 82291 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(82398), // Rule ID 22584 //
     /* 82296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 82299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 82303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 82307 */     // (ctpop:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPOPCNTBZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 82307 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 82310 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 82314 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 82321 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 82324 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 82328 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82333 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 82336 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 82340 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 82343 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 82348 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82353 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 82358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 82361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 82365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82370 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 82373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 82375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 82378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 82380 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 82387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 82392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82397 */     // GIR_Coverage, 22584,
     /* 82397 */     GIR_EraseRootFromParent_Done,
     /* 82398 */   // Label 2548: @82398
     /* 82398 */   GIM_Reject,
     /* 82399 */ // Label 2546: @82399
     /* 82399 */ GIM_Reject,
     /* 82400 */ // Label 2521: @82400
     /* 82400 */ GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(82531),
     /* 82405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 82408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 82412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 82416 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(82431), // Rule ID 14507 //
     /* 82421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 82424 */     // (ctpop:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (VPOPCNTWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)
     /* 82424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ256rr),
     /* 82429 */     GIR_RootConstrainSelectedInstOperands,
     /* 82430 */     // GIR_Coverage, 14507,
     /* 82430 */     GIR_Done,
     /* 82431 */   // Label 2550: @82431
     /* 82431 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(82530), // Rule ID 22585 //
     /* 82436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 82439 */     // (ctpop:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VPOPCNTWZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 82439 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 82442 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 82446 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 82453 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 82456 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 82460 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82465 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 82468 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 82472 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 82475 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 82480 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82485 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 82490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 82493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 82497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82502 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 82505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 82507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 82510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 82512 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 82519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 82524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82529 */     // GIR_Coverage, 22585,
     /* 82529 */     GIR_EraseRootFromParent_Done,
     /* 82530 */   // Label 2551: @82530
     /* 82530 */   GIM_Reject,
     /* 82531 */ // Label 2549: @82531
     /* 82531 */ GIM_Reject,
     /* 82532 */ // Label 2522: @82532
     /* 82532 */ GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(82558), // Rule ID 13468 //
     /* 82537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 82540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 82543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 82547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 82551 */   // (ctpop:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPOPCNTDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 82551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 82556 */   GIR_RootConstrainSelectedInstOperands,
     /* 82557 */   // GIR_Coverage, 13468,
     /* 82557 */   GIR_Done,
     /* 82558 */ // Label 2552: @82558
     /* 82558 */ GIM_Reject,
     /* 82559 */ // Label 2523: @82559
     /* 82559 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(82690),
     /* 82564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 82567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 82571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 82575 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(82590), // Rule ID 14489 //
     /* 82580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 82583 */     // (ctpop:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (VPOPCNTBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)
     /* 82583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ256rr),
     /* 82588 */     GIR_RootConstrainSelectedInstOperands,
     /* 82589 */     // GIR_Coverage, 14489,
     /* 82589 */     GIR_Done,
     /* 82590 */   // Label 2554: @82590
     /* 82590 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(82689), // Rule ID 22583 //
     /* 82595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 82598 */     // (ctpop:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VPOPCNTBZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 82598 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 82601 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 82605 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 82612 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 82615 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 82619 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82624 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 82627 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 82631 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 82634 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 82639 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82644 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 82649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 82652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 82656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82661 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 82664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 82666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 82669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 82671 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 82678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 82683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82688 */     // GIR_Coverage, 22583,
     /* 82688 */     GIR_EraseRootFromParent_Done,
     /* 82689 */   // Label 2555: @82689
     /* 82689 */   GIM_Reject,
     /* 82690 */ // Label 2553: @82690
     /* 82690 */ GIM_Reject,
     /* 82691 */ // Label 2524: @82691
     /* 82691 */ GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(82717), // Rule ID 14501 //
     /* 82696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 82699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 82702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 82706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 82710 */   // (ctpop:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)  =>  (VPOPCNTWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)
     /* 82710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 82715 */   GIR_RootConstrainSelectedInstOperands,
     /* 82716 */   // GIR_Coverage, 14501,
     /* 82716 */   GIR_Done,
     /* 82717 */ // Label 2556: @82717
     /* 82717 */ GIM_Reject,
     /* 82718 */ // Label 2525: @82718
     /* 82718 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(82744), // Rule ID 14483 //
     /* 82723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 82726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 82729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 82733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 82737 */   // (ctpop:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)  =>  (VPOPCNTBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)
     /* 82737 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 82742 */   GIR_RootConstrainSelectedInstOperands,
     /* 82743 */   // GIR_Coverage, 14483,
     /* 82743 */   GIR_Done,
     /* 82744 */ // Label 2557: @82744
     /* 82744 */ GIM_Reject,
     /* 82745 */ // Label 2526: @82745
     /* 82745 */ GIM_Reject,
     /* 82746 */ // Label 59: @82746
     /* 82746 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2561*/ GIMT_Encode4(82921),
     /* 82757 */ /*GILLT_s16*//*Label 2558*/ GIMT_Encode4(82769),
     /* 82761 */ /*GILLT_s32*//*Label 2559*/ GIMT_Encode4(82825),
     /* 82765 */ /*GILLT_s64*//*Label 2560*/ GIMT_Encode4(82873),
     /* 82769 */ // Label 2558: @82769
     /* 82769 */ GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(82824),
     /* 82774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 82777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 82781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 82785 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(82800), // Rule ID 61 //
     /* 82790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 82793 */     // (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (MOVBE16rr:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /* 82793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE16rr),
     /* 82798 */     GIR_RootConstrainSelectedInstOperands,
     /* 82799 */     // GIR_Coverage, 61,
     /* 82799 */     GIR_Done,
     /* 82800 */   // Label 2563: @82800
     /* 82800 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(82823), // Rule ID 23412 //
     /* 82805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE),
     /* 82808 */     // (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src)  =>  (ROL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src, 8:{ *:[i8] })
     /* 82808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri),
     /* 82811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 82813 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 82815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 82818 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 82821 */     GIR_RootConstrainSelectedInstOperands,
     /* 82822 */     // GIR_Coverage, 23412,
     /* 82822 */     GIR_EraseRootFromParent_Done,
     /* 82823 */   // Label 2564: @82823
     /* 82823 */   GIM_Reject,
     /* 82824 */ // Label 2562: @82824
     /* 82824 */ GIM_Reject,
     /* 82825 */ // Label 2559: @82825
     /* 82825 */ GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(82872),
     /* 82830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 82833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 82837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 82841 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(82856), // Rule ID 5 //
     /* 82846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_Or_NoMOVBE),
     /* 82849 */     // (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src)  =>  (BSWAP32r:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 82849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::BSWAP32r),
     /* 82854 */     GIR_RootConstrainSelectedInstOperands,
     /* 82855 */     // GIR_Coverage, 5,
     /* 82855 */     GIR_Done,
     /* 82856 */   // Label 2566: @82856
     /* 82856 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(82871), // Rule ID 62 //
     /* 82861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 82864 */     // (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (MOVBE32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 82864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE32rr),
     /* 82869 */     GIR_RootConstrainSelectedInstOperands,
     /* 82870 */     // GIR_Coverage, 62,
     /* 82870 */     GIR_Done,
     /* 82871 */   // Label 2567: @82871
     /* 82871 */   GIM_Reject,
     /* 82872 */ // Label 2565: @82872
     /* 82872 */ GIM_Reject,
     /* 82873 */ // Label 2560: @82873
     /* 82873 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(82920),
     /* 82878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 82881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 82885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 82889 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(82904), // Rule ID 6 //
     /* 82894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_Or_NoMOVBE),
     /* 82897 */     // (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src)  =>  (BSWAP64r:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 82897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::BSWAP64r),
     /* 82902 */     GIR_RootConstrainSelectedInstOperands,
     /* 82903 */     // GIR_Coverage, 6,
     /* 82903 */     GIR_Done,
     /* 82904 */   // Label 2569: @82904
     /* 82904 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(82919), // Rule ID 63 //
     /* 82909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 82912 */     // (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (MOVBE64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /* 82912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE64rr),
     /* 82917 */     GIR_RootConstrainSelectedInstOperands,
     /* 82918 */     // GIR_Coverage, 63,
     /* 82918 */     GIR_Done,
     /* 82919 */   // Label 2570: @82919
     /* 82919 */   GIM_Reject,
     /* 82920 */ // Label 2568: @82920
     /* 82920 */ GIM_Reject,
     /* 82921 */ // Label 2561: @82921
     /* 82921 */ GIM_Reject,
     /* 82922 */ // Label 60: @82922
     /* 82922 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2584*/ GIMT_Encode4(83873),
     /* 82933 */ /*GILLT_s16*//*Label 2571*/ GIMT_Encode4(83017),
     /* 82937 */ /*GILLT_s32*//*Label 2572*/ GIMT_Encode4(83063),
     /* 82941 */ /*GILLT_s64*//*Label 2573*/ GIMT_Encode4(83217),
     /* 82945 */ /*GILLT_s80*//*Label 2574*/ GIMT_Encode4(83371), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 82957 */ /*GILLT_v2s64*//*Label 2575*/ GIMT_Encode4(83408), GIMT_Encode4(0),
     /* 82965 */ /*GILLT_v4s32*//*Label 2576*/ GIMT_Encode4(83499),
     /* 82969 */ /*GILLT_v4s64*//*Label 2577*/ GIMT_Encode4(83590), GIMT_Encode4(0),
     /* 82977 */ /*GILLT_v8s16*//*Label 2578*/ GIMT_Encode4(83654),
     /* 82981 */ /*GILLT_v8s32*//*Label 2579*/ GIMT_Encode4(83685),
     /* 82985 */ /*GILLT_v8s64*//*Label 2580*/ GIMT_Encode4(83749), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 82997 */ /*GILLT_v16s16*//*Label 2581*/ GIMT_Encode4(83780),
     /* 83001 */ /*GILLT_v16s32*//*Label 2582*/ GIMT_Encode4(83811), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 83013 */ /*GILLT_v32s16*//*Label 2583*/ GIMT_Encode4(83842),
     /* 83017 */ // Label 2571: @83017
     /* 83017 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(83062), // Rule ID 21866 //
     /* 83022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 83025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 83028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 83032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 83036 */   // (fsqrt:{ *:[f16] } FR16X:{ *:[f16] }:$src)  =>  (VSQRTSHZr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR16X:{ *:[f16] }:$src)
     /* 83036 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 83039 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 83043 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 83048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 83050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZr),
     /* 83053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 83055 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 83058 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 83060 */   GIR_RootConstrainSelectedInstOperands,
     /* 83061 */   // GIR_Coverage, 21866,
     /* 83061 */   GIR_EraseRootFromParent_Done,
     /* 83062 */ // Label 2585: @83062
     /* 83062 */ GIM_Reject,
     /* 83063 */ // Label 2572: @83063
     /* 83063 */ GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(83216),
     /* 83068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 83071 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(83104), // Rule ID 1046 //
     /* 83076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 83079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 83083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 83087 */     // (fsqrt:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (SQRT_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 83087 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp32),
     /* 83092 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 83098 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 83102 */     GIR_RootConstrainSelectedInstOperands,
     /* 83103 */     // GIR_Coverage, 1046,
     /* 83103 */     GIR_Done,
     /* 83104 */   // Label 2587: @83104
     /* 83104 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(83131), // Rule ID 2444 //
     /* 83109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 83112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 83116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 83120 */     // (fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src1)  =>  (SQRTSSr:{ *:[f32] } FR32:{ *:[f32] }:$src1)
     /* 83120 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSSr),
     /* 83125 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83129 */     GIR_RootConstrainSelectedInstOperands,
     /* 83130 */     // GIR_Coverage, 2444,
     /* 83130 */     GIR_Done,
     /* 83131 */   // Label 2588: @83131
     /* 83131 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(83173), // Rule ID 18722 //
     /* 83136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 83139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 83143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 83147 */     // (fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src)  =>  (VSQRTSSr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32:{ *:[f32] }:$src)
     /* 83147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 83150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 83154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 83159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 83161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSr),
     /* 83164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 83166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 83169 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 83171 */     GIR_RootConstrainSelectedInstOperands,
     /* 83172 */     // GIR_Coverage, 18722,
     /* 83172 */     GIR_EraseRootFromParent_Done,
     /* 83173 */   // Label 2589: @83173
     /* 83173 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(83215), // Rule ID 21870 //
     /* 83178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 83181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 83185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 83189 */     // (fsqrt:{ *:[f32] } FR32X:{ *:[f32] }:$src)  =>  (VSQRTSSZr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32X:{ *:[f32] }:$src)
     /* 83189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 83192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 83196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 83201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 83203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZr),
     /* 83206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 83208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 83211 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 83213 */     GIR_RootConstrainSelectedInstOperands,
     /* 83214 */     // GIR_Coverage, 21870,
     /* 83214 */     GIR_EraseRootFromParent_Done,
     /* 83215 */   // Label 2590: @83215
     /* 83215 */   GIM_Reject,
     /* 83216 */ // Label 2586: @83216
     /* 83216 */ GIM_Reject,
     /* 83217 */ // Label 2573: @83217
     /* 83217 */ GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(83370),
     /* 83222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 83225 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(83258), // Rule ID 1048 //
     /* 83230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 83233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 83237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 83241 */     // (fsqrt:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (SQRT_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 83241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp64),
     /* 83246 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 83252 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 83256 */     GIR_RootConstrainSelectedInstOperands,
     /* 83257 */     // GIR_Coverage, 1048,
     /* 83257 */     GIR_Done,
     /* 83258 */   // Label 2592: @83258
     /* 83258 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(83285), // Rule ID 2460 //
     /* 83263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 83266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 83270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 83274 */     // (fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src1)  =>  (SQRTSDr:{ *:[f64] } FR64:{ *:[f64] }:$src1)
     /* 83274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSDr),
     /* 83279 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83283 */     GIR_RootConstrainSelectedInstOperands,
     /* 83284 */     // GIR_Coverage, 2460,
     /* 83284 */     GIR_Done,
     /* 83285 */   // Label 2593: @83285
     /* 83285 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(83327), // Rule ID 18726 //
     /* 83290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 83293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 83297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 83301 */     // (fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src)  =>  (VSQRTSDr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64:{ *:[f64] }:$src)
     /* 83301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 83304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 83308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 83313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 83315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDr),
     /* 83318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 83320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 83323 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 83325 */     GIR_RootConstrainSelectedInstOperands,
     /* 83326 */     // GIR_Coverage, 18726,
     /* 83326 */     GIR_EraseRootFromParent_Done,
     /* 83327 */   // Label 2594: @83327
     /* 83327 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(83369), // Rule ID 21874 //
     /* 83332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 83335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 83339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 83343 */     // (fsqrt:{ *:[f64] } FR64X:{ *:[f64] }:$src)  =>  (VSQRTSDZr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64X:{ *:[f64] }:$src)
     /* 83343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 83346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 83350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 83355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 83357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZr),
     /* 83360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 83362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 83365 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 83367 */     GIR_RootConstrainSelectedInstOperands,
     /* 83368 */     // GIR_Coverage, 21874,
     /* 83368 */     GIR_EraseRootFromParent_Done,
     /* 83369 */   // Label 2595: @83369
     /* 83369 */   GIM_Reject,
     /* 83370 */ // Label 2591: @83370
     /* 83370 */ GIM_Reject,
     /* 83371 */ // Label 2574: @83371
     /* 83371 */ GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(83407), // Rule ID 1050 //
     /* 83376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 83379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 83382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 83386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 83390 */   // (fsqrt:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (SQRT_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 83390 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp80),
     /* 83395 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 83401 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 83405 */   GIR_RootConstrainSelectedInstOperands,
     /* 83406 */   // GIR_Coverage, 1050,
     /* 83406 */   GIR_Done,
     /* 83407 */ // Label 2596: @83407
     /* 83407 */ GIM_Reject,
     /* 83408 */ // Label 2575: @83408
     /* 83408 */ GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(83498),
     /* 83413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 83416 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(83443), // Rule ID 2464 //
     /* 83421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 83424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 83428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 83432 */     // (fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (VSQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 83432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDr),
     /* 83437 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83441 */     GIR_RootConstrainSelectedInstOperands,
     /* 83442 */     // GIR_Coverage, 2464,
     /* 83442 */     GIR_Done,
     /* 83443 */   // Label 2598: @83443
     /* 83443 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(83470), // Rule ID 2472 //
     /* 83448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 83451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 83455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 83459 */     // (fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (SQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 83459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPDr),
     /* 83464 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83468 */     GIR_RootConstrainSelectedInstOperands,
     /* 83469 */     // GIR_Coverage, 2472,
     /* 83469 */     GIR_Done,
     /* 83470 */   // Label 2599: @83470
     /* 83470 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(83497), // Rule ID 12080 //
     /* 83475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 83478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 83482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 83486 */     // (fsqrt:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)  =>  (VSQRTPDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)
     /* 83486 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128r),
     /* 83491 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83495 */     GIR_RootConstrainSelectedInstOperands,
     /* 83496 */     // GIR_Coverage, 12080,
     /* 83496 */     GIR_Done,
     /* 83497 */   // Label 2600: @83497
     /* 83497 */   GIM_Reject,
     /* 83498 */ // Label 2597: @83498
     /* 83498 */ GIM_Reject,
     /* 83499 */ // Label 2576: @83499
     /* 83499 */ GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(83589),
     /* 83504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 83507 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(83534), // Rule ID 2448 //
     /* 83512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 83515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 83519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 83523 */     // (fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (VSQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 83523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSr),
     /* 83528 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83532 */     GIR_RootConstrainSelectedInstOperands,
     /* 83533 */     // GIR_Coverage, 2448,
     /* 83533 */     GIR_Done,
     /* 83534 */   // Label 2602: @83534
     /* 83534 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(83561), // Rule ID 2456 //
     /* 83539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 83542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 83546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 83550 */     // (fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (SQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 83550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPSr),
     /* 83555 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83559 */     GIR_RootConstrainSelectedInstOperands,
     /* 83560 */     // GIR_Coverage, 2456,
     /* 83560 */     GIR_Done,
     /* 83561 */   // Label 2603: @83561
     /* 83561 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(83588), // Rule ID 12056 //
     /* 83566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 83569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 83573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 83577 */     // (fsqrt:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)  =>  (VSQRTPSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)
     /* 83577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128r),
     /* 83582 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83586 */     GIR_RootConstrainSelectedInstOperands,
     /* 83587 */     // GIR_Coverage, 12056,
     /* 83587 */     GIR_Done,
     /* 83588 */   // Label 2604: @83588
     /* 83588 */   GIM_Reject,
     /* 83589 */ // Label 2601: @83589
     /* 83589 */ GIM_Reject,
     /* 83590 */ // Label 2577: @83590
     /* 83590 */ GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(83653),
     /* 83595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 83598 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(83625), // Rule ID 2468 //
     /* 83603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 83606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 83610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 83614 */     // (fsqrt:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)  =>  (VSQRTPDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 83614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYr),
     /* 83619 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83623 */     GIR_RootConstrainSelectedInstOperands,
     /* 83624 */     // GIR_Coverage, 2468,
     /* 83624 */     GIR_Done,
     /* 83625 */   // Label 2606: @83625
     /* 83625 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(83652), // Rule ID 12092 //
     /* 83630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 83633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 83637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 83641 */     // (fsqrt:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)  =>  (VSQRTPDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)
     /* 83641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256r),
     /* 83646 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83650 */     GIR_RootConstrainSelectedInstOperands,
     /* 83651 */     // GIR_Coverage, 12092,
     /* 83651 */     GIR_Done,
     /* 83652 */   // Label 2607: @83652
     /* 83652 */   GIM_Reject,
     /* 83653 */ // Label 2605: @83653
     /* 83653 */ GIM_Reject,
     /* 83654 */ // Label 2578: @83654
     /* 83654 */ GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(83684), // Rule ID 12008 //
     /* 83659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 83662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 83665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 83669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 83673 */   // (fsqrt:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)  =>  (VSQRTPHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)
     /* 83673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128r),
     /* 83678 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83682 */   GIR_RootConstrainSelectedInstOperands,
     /* 83683 */   // GIR_Coverage, 12008,
     /* 83683 */   GIR_Done,
     /* 83684 */ // Label 2608: @83684
     /* 83684 */ GIM_Reject,
     /* 83685 */ // Label 2579: @83685
     /* 83685 */ GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(83748),
     /* 83690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 83693 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(83720), // Rule ID 2452 //
     /* 83698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 83701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 83705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 83709 */     // (fsqrt:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)  =>  (VSQRTPSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 83709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYr),
     /* 83714 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83718 */     GIR_RootConstrainSelectedInstOperands,
     /* 83719 */     // GIR_Coverage, 2452,
     /* 83719 */     GIR_Done,
     /* 83720 */   // Label 2610: @83720
     /* 83720 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(83747), // Rule ID 12068 //
     /* 83725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 83728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 83732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 83736 */     // (fsqrt:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)  =>  (VSQRTPSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)
     /* 83736 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256r),
     /* 83741 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83745 */     GIR_RootConstrainSelectedInstOperands,
     /* 83746 */     // GIR_Coverage, 12068,
     /* 83746 */     GIR_Done,
     /* 83747 */   // Label 2611: @83747
     /* 83747 */   GIM_Reject,
     /* 83748 */ // Label 2609: @83748
     /* 83748 */ GIM_Reject,
     /* 83749 */ // Label 2580: @83749
     /* 83749 */ GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(83779), // Rule ID 12044 //
     /* 83754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 83757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 83760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 83764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 83768 */   // (fsqrt:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)  =>  (VSQRTPDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)
     /* 83768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZr),
     /* 83773 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83777 */   GIR_RootConstrainSelectedInstOperands,
     /* 83778 */   // GIR_Coverage, 12044,
     /* 83778 */   GIR_Done,
     /* 83779 */ // Label 2612: @83779
     /* 83779 */ GIM_Reject,
     /* 83780 */ // Label 2581: @83780
     /* 83780 */ GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(83810), // Rule ID 12020 //
     /* 83785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 83788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 83791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 83795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 83799 */   // (fsqrt:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)  =>  (VSQRTPHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)
     /* 83799 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256r),
     /* 83804 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83808 */   GIR_RootConstrainSelectedInstOperands,
     /* 83809 */   // GIR_Coverage, 12020,
     /* 83809 */   GIR_Done,
     /* 83810 */ // Label 2613: @83810
     /* 83810 */ GIM_Reject,
     /* 83811 */ // Label 2582: @83811
     /* 83811 */ GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(83841), // Rule ID 12032 //
     /* 83816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 83819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 83822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 83826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 83830 */   // (fsqrt:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)  =>  (VSQRTPSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)
     /* 83830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZr),
     /* 83835 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83839 */   GIR_RootConstrainSelectedInstOperands,
     /* 83840 */   // GIR_Coverage, 12032,
     /* 83840 */   GIR_Done,
     /* 83841 */ // Label 2614: @83841
     /* 83841 */ GIM_Reject,
     /* 83842 */ // Label 2583: @83842
     /* 83842 */ GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(83872), // Rule ID 11996 //
     /* 83847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 83850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 83853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 83857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 83861 */   // (fsqrt:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)  =>  (VSQRTPHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)
     /* 83861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZr),
     /* 83866 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83870 */   GIR_RootConstrainSelectedInstOperands,
     /* 83871 */   // GIR_Coverage, 11996,
     /* 83871 */   GIR_Done,
     /* 83872 */ // Label 2615: @83872
     /* 83872 */ GIM_Reject,
     /* 83873 */ // Label 2584: @83873
     /* 83873 */ GIM_Reject,
     /* 83874 */ // Label 61: @83874
     /* 83874 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2629*/ GIMT_Encode4(84889),
     /* 83885 */ /*GILLT_s16*//*Label 2616*/ GIMT_Encode4(83969),
     /* 83889 */ /*GILLT_s32*//*Label 2617*/ GIMT_Encode4(84007),
     /* 83893 */ /*GILLT_s64*//*Label 2618*/ GIMT_Encode4(84150),
     /* 83897 */ /*GILLT_s80*//*Label 2619*/ GIMT_Encode4(84293), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 83909 */ /*GILLT_v2s64*//*Label 2620*/ GIMT_Encode4(84337), GIMT_Encode4(0),
     /* 83917 */ /*GILLT_v4s32*//*Label 2621*/ GIMT_Encode4(84443),
     /* 83921 */ /*GILLT_v4s64*//*Label 2622*/ GIMT_Encode4(84549), GIMT_Encode4(0),
     /* 83929 */ /*GILLT_v8s16*//*Label 2623*/ GIMT_Encode4(84624),
     /* 83933 */ /*GILLT_v8s32*//*Label 2624*/ GIMT_Encode4(84662),
     /* 83937 */ /*GILLT_v8s64*//*Label 2625*/ GIMT_Encode4(84737), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 83949 */ /*GILLT_v16s16*//*Label 2626*/ GIMT_Encode4(84775),
     /* 83953 */ /*GILLT_v16s32*//*Label 2627*/ GIMT_Encode4(84813), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 83965 */ /*GILLT_v32s16*//*Label 2628*/ GIMT_Encode4(84851),
     /* 83969 */ // Label 2616: @83969
     /* 83969 */ GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(84006), // Rule ID 5949 //
     /* 83974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 83977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 83980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 83983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 83987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 83991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 83995 */   // (strict_fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VADDSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 83995 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSHZrr),
     /* 84000 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84004 */   GIR_RootConstrainSelectedInstOperands,
     /* 84005 */   // GIR_Coverage, 5949,
     /* 84005 */   GIR_Done,
     /* 84006 */ // Label 2630: @84006
     /* 84006 */ GIM_Reject,
     /* 84007 */ // Label 2617: @84007
     /* 84007 */ GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(84149),
     /* 84012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 84015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 84018 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(84055), // Rule ID 883 //
     /* 84023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 84026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 84030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 84034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 84038 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (ADD_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 84038 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32),
     /* 84043 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 84049 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 84053 */     GIR_RootConstrainSelectedInstOperands,
     /* 84054 */     // GIR_Coverage, 883,
     /* 84054 */     GIR_Done,
     /* 84055 */   // Label 2632: @84055
     /* 84055 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(84086), // Rule ID 2155 //
     /* 84060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 84063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 84067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 84071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 84075 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 84075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSrr),
     /* 84080 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84084 */     GIR_RootConstrainSelectedInstOperands,
     /* 84085 */     // GIR_Coverage, 2155,
     /* 84085 */     GIR_Done,
     /* 84086 */   // Label 2633: @84086
     /* 84086 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(84117), // Rule ID 2163 //
     /* 84091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 84094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 84098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 84102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 84106 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (ADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 84106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSSrr),
     /* 84111 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84115 */     GIR_RootConstrainSelectedInstOperands,
     /* 84116 */     // GIR_Coverage, 2163,
     /* 84116 */     GIR_Done,
     /* 84117 */   // Label 2634: @84117
     /* 84117 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(84148), // Rule ID 5911 //
     /* 84122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 84125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 84129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 84133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 84137 */     // (strict_fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VADDSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 84137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSZrr),
     /* 84142 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84146 */     GIR_RootConstrainSelectedInstOperands,
     /* 84147 */     // GIR_Coverage, 5911,
     /* 84147 */     GIR_Done,
     /* 84148 */   // Label 2635: @84148
     /* 84148 */   GIM_Reject,
     /* 84149 */ // Label 2631: @84149
     /* 84149 */ GIM_Reject,
     /* 84150 */ // Label 2618: @84150
     /* 84150 */ GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(84292),
     /* 84155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 84158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 84161 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(84198), // Rule ID 885 //
     /* 84166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 84169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 84173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 84177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 84181 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (ADD_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 84181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64),
     /* 84186 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 84192 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 84196 */     GIR_RootConstrainSelectedInstOperands,
     /* 84197 */     // GIR_Coverage, 885,
     /* 84197 */     GIR_Done,
     /* 84198 */   // Label 2637: @84198
     /* 84198 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(84229), // Rule ID 2159 //
     /* 84203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 84206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 84210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 84214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 84218 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 84218 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDrr),
     /* 84223 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84227 */     GIR_RootConstrainSelectedInstOperands,
     /* 84228 */     // GIR_Coverage, 2159,
     /* 84228 */     GIR_Done,
     /* 84229 */   // Label 2638: @84229
     /* 84229 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(84260), // Rule ID 2167 //
     /* 84234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 84237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 84241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 84245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 84249 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (ADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 84249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSDrr),
     /* 84254 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84258 */     GIR_RootConstrainSelectedInstOperands,
     /* 84259 */     // GIR_Coverage, 2167,
     /* 84259 */     GIR_Done,
     /* 84260 */   // Label 2639: @84260
     /* 84260 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(84291), // Rule ID 5930 //
     /* 84265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 84268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 84272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 84276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 84280 */     // (strict_fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VADDSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 84280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDZrr),
     /* 84285 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84289 */     GIR_RootConstrainSelectedInstOperands,
     /* 84290 */     // GIR_Coverage, 5930,
     /* 84290 */     GIR_Done,
     /* 84291 */   // Label 2640: @84291
     /* 84291 */   GIM_Reject,
     /* 84292 */ // Label 2636: @84292
     /* 84292 */ GIM_Reject,
     /* 84293 */ // Label 2619: @84293
     /* 84293 */ GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(84336), // Rule ID 887 //
     /* 84298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 84301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 84304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 84307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 84311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 84315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 84319 */   // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (ADD_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 84319 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80),
     /* 84324 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 84330 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 84334 */   GIR_RootConstrainSelectedInstOperands,
     /* 84335 */   // GIR_Coverage, 887,
     /* 84335 */   GIR_Done,
     /* 84336 */ // Label 2641: @84336
     /* 84336 */ GIM_Reject,
     /* 84337 */ // Label 2620: @84337
     /* 84337 */ GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(84442),
     /* 84342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 84345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 84348 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(84379), // Rule ID 2135 //
     /* 84353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 84356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84368 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 84368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDrr),
     /* 84373 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84377 */     GIR_RootConstrainSelectedInstOperands,
     /* 84378 */     // GIR_Coverage, 2135,
     /* 84378 */     GIR_Done,
     /* 84379 */   // Label 2643: @84379
     /* 84379 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(84410), // Rule ID 2151 //
     /* 84384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 84387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84399 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (ADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 84399 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPDrr),
     /* 84404 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84408 */     GIR_RootConstrainSelectedInstOperands,
     /* 84409 */     // GIR_Coverage, 2151,
     /* 84409 */     GIR_Done,
     /* 84410 */   // Label 2644: @84410
     /* 84410 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(84441), // Rule ID 6301 //
     /* 84415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 84418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84430 */     // (strict_fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VADDPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 84430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rr),
     /* 84435 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84439 */     GIR_RootConstrainSelectedInstOperands,
     /* 84440 */     // GIR_Coverage, 6301,
     /* 84440 */     GIR_Done,
     /* 84441 */   // Label 2645: @84441
     /* 84441 */   GIM_Reject,
     /* 84442 */ // Label 2642: @84442
     /* 84442 */ GIM_Reject,
     /* 84443 */ // Label 2621: @84443
     /* 84443 */ GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(84548),
     /* 84448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 84451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 84454 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(84485), // Rule ID 2131 //
     /* 84459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 84462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84474 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 84474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSrr),
     /* 84479 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84483 */     GIR_RootConstrainSelectedInstOperands,
     /* 84484 */     // GIR_Coverage, 2131,
     /* 84484 */     GIR_Done,
     /* 84485 */   // Label 2647: @84485
     /* 84485 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(84516), // Rule ID 2147 //
     /* 84490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 84493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84505 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (ADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 84505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPSrr),
     /* 84510 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84514 */     GIR_RootConstrainSelectedInstOperands,
     /* 84515 */     // GIR_Coverage, 2147,
     /* 84515 */     GIR_Done,
     /* 84516 */   // Label 2648: @84516
     /* 84516 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(84547), // Rule ID 6277 //
     /* 84521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 84524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84536 */     // (strict_fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VADDPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 84536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rr),
     /* 84541 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84545 */     GIR_RootConstrainSelectedInstOperands,
     /* 84546 */     // GIR_Coverage, 6277,
     /* 84546 */     GIR_Done,
     /* 84547 */   // Label 2649: @84547
     /* 84547 */   GIM_Reject,
     /* 84548 */ // Label 2646: @84548
     /* 84548 */ GIM_Reject,
     /* 84549 */ // Label 2622: @84549
     /* 84549 */ GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(84623),
     /* 84554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 84557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 84560 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(84591), // Rule ID 2143 //
     /* 84565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 84568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 84572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 84576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 84580 */     // (strict_fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VADDPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 84580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDYrr),
     /* 84585 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84589 */     GIR_RootConstrainSelectedInstOperands,
     /* 84590 */     // GIR_Coverage, 2143,
     /* 84590 */     GIR_Done,
     /* 84591 */   // Label 2651: @84591
     /* 84591 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(84622), // Rule ID 6313 //
     /* 84596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 84599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84611 */     // (strict_fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VADDPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 84611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rr),
     /* 84616 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84620 */     GIR_RootConstrainSelectedInstOperands,
     /* 84621 */     // GIR_Coverage, 6313,
     /* 84621 */     GIR_Done,
     /* 84622 */   // Label 2652: @84622
     /* 84622 */   GIM_Reject,
     /* 84623 */ // Label 2650: @84623
     /* 84623 */ GIM_Reject,
     /* 84624 */ // Label 2623: @84624
     /* 84624 */ GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(84661), // Rule ID 6337 //
     /* 84629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 84632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 84635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 84638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84646 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84650 */   // (strict_fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VADDPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 84650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rr),
     /* 84655 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84659 */   GIR_RootConstrainSelectedInstOperands,
     /* 84660 */   // GIR_Coverage, 6337,
     /* 84660 */   GIR_Done,
     /* 84661 */ // Label 2653: @84661
     /* 84661 */ GIM_Reject,
     /* 84662 */ // Label 2624: @84662
     /* 84662 */ GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(84736),
     /* 84667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 84670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 84673 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(84704), // Rule ID 2139 //
     /* 84678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 84681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 84685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 84689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 84693 */     // (strict_fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VADDPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 84693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSYrr),
     /* 84698 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84702 */     GIR_RootConstrainSelectedInstOperands,
     /* 84703 */     // GIR_Coverage, 2139,
     /* 84703 */     GIR_Done,
     /* 84704 */   // Label 2655: @84704
     /* 84704 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(84735), // Rule ID 6289 //
     /* 84709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 84712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84724 */     // (strict_fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VADDPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 84724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rr),
     /* 84729 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84733 */     GIR_RootConstrainSelectedInstOperands,
     /* 84734 */     // GIR_Coverage, 6289,
     /* 84734 */     GIR_Done,
     /* 84735 */   // Label 2656: @84735
     /* 84735 */   GIM_Reject,
     /* 84736 */ // Label 2654: @84736
     /* 84736 */ GIM_Reject,
     /* 84737 */ // Label 2625: @84737
     /* 84737 */ GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(84774), // Rule ID 6265 //
     /* 84742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 84745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 84748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 84751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 84755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 84759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 84763 */   // (strict_fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VADDPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 84763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZrr),
     /* 84768 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84772 */   GIR_RootConstrainSelectedInstOperands,
     /* 84773 */   // GIR_Coverage, 6265,
     /* 84773 */   GIR_Done,
     /* 84774 */ // Label 2657: @84774
     /* 84774 */ GIM_Reject,
     /* 84775 */ // Label 2626: @84775
     /* 84775 */ GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(84812), // Rule ID 6349 //
     /* 84780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 84783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 84786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 84789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84801 */   // (strict_fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VADDPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 84801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rr),
     /* 84806 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84810 */   GIR_RootConstrainSelectedInstOperands,
     /* 84811 */   // GIR_Coverage, 6349,
     /* 84811 */   GIR_Done,
     /* 84812 */ // Label 2658: @84812
     /* 84812 */ GIM_Reject,
     /* 84813 */ // Label 2627: @84813
     /* 84813 */ GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(84850), // Rule ID 6253 //
     /* 84818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 84821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 84824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 84827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 84831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 84835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 84839 */   // (strict_fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VADDPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 84839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZrr),
     /* 84844 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84848 */   GIR_RootConstrainSelectedInstOperands,
     /* 84849 */   // GIR_Coverage, 6253,
     /* 84849 */   GIR_Done,
     /* 84850 */ // Label 2659: @84850
     /* 84850 */ GIM_Reject,
     /* 84851 */ // Label 2628: @84851
     /* 84851 */ GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(84888), // Rule ID 6325 //
     /* 84856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 84859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 84862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 84865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 84869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 84873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 84877 */   // (strict_fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VADDPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 84877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZrr),
     /* 84882 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84886 */   GIR_RootConstrainSelectedInstOperands,
     /* 84887 */   // GIR_Coverage, 6325,
     /* 84887 */   GIR_Done,
     /* 84888 */ // Label 2660: @84888
     /* 84888 */ GIM_Reject,
     /* 84889 */ // Label 2629: @84889
     /* 84889 */ GIM_Reject,
     /* 84890 */ // Label 62: @84890
     /* 84890 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2674*/ GIMT_Encode4(85905),
     /* 84901 */ /*GILLT_s16*//*Label 2661*/ GIMT_Encode4(84985),
     /* 84905 */ /*GILLT_s32*//*Label 2662*/ GIMT_Encode4(85023),
     /* 84909 */ /*GILLT_s64*//*Label 2663*/ GIMT_Encode4(85166),
     /* 84913 */ /*GILLT_s80*//*Label 2664*/ GIMT_Encode4(85309), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 84925 */ /*GILLT_v2s64*//*Label 2665*/ GIMT_Encode4(85353), GIMT_Encode4(0),
     /* 84933 */ /*GILLT_v4s32*//*Label 2666*/ GIMT_Encode4(85459),
     /* 84937 */ /*GILLT_v4s64*//*Label 2667*/ GIMT_Encode4(85565), GIMT_Encode4(0),
     /* 84945 */ /*GILLT_v8s16*//*Label 2668*/ GIMT_Encode4(85640),
     /* 84949 */ /*GILLT_v8s32*//*Label 2669*/ GIMT_Encode4(85678),
     /* 84953 */ /*GILLT_v8s64*//*Label 2670*/ GIMT_Encode4(85753), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 84965 */ /*GILLT_v16s16*//*Label 2671*/ GIMT_Encode4(85791),
     /* 84969 */ /*GILLT_v16s32*//*Label 2672*/ GIMT_Encode4(85829), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 84981 */ /*GILLT_v32s16*//*Label 2673*/ GIMT_Encode4(85867),
     /* 84985 */ // Label 2661: @84985
     /* 84985 */ GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(85022), // Rule ID 6063 //
     /* 84990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 84993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 84996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 84999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 85003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 85007 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 85011 */   // (strict_fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VSUBSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 85011 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrr),
     /* 85016 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85020 */   GIR_RootConstrainSelectedInstOperands,
     /* 85021 */   // GIR_Coverage, 6063,
     /* 85021 */   GIR_Done,
     /* 85022 */ // Label 2675: @85022
     /* 85022 */ GIM_Reject,
     /* 85023 */ // Label 2662: @85023
     /* 85023 */ GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(85165),
     /* 85028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 85031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 85034 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(85071), // Rule ID 889 //
     /* 85039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 85042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 85046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 85050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 85054 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (SUB_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 85054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32),
     /* 85059 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 85065 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 85069 */     GIR_RootConstrainSelectedInstOperands,
     /* 85070 */     // GIR_Coverage, 889,
     /* 85070 */     GIR_Done,
     /* 85071 */   // Label 2677: @85071
     /* 85071 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(85102), // Rule ID 2235 //
     /* 85076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 85079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 85083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 85087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 85091 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VSUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 85091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSrr),
     /* 85096 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85100 */     GIR_RootConstrainSelectedInstOperands,
     /* 85101 */     // GIR_Coverage, 2235,
     /* 85101 */     GIR_Done,
     /* 85102 */   // Label 2678: @85102
     /* 85102 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(85133), // Rule ID 2243 //
     /* 85107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 85110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 85114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 85118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 85122 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (SUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 85122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSSrr),
     /* 85127 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85131 */     GIR_RootConstrainSelectedInstOperands,
     /* 85132 */     // GIR_Coverage, 2243,
     /* 85132 */     GIR_Done,
     /* 85133 */   // Label 2679: @85133
     /* 85133 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(85164), // Rule ID 6025 //
     /* 85138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 85141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 85145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 85149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 85153 */     // (strict_fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VSUBSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 85153 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrr),
     /* 85158 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85162 */     GIR_RootConstrainSelectedInstOperands,
     /* 85163 */     // GIR_Coverage, 6025,
     /* 85163 */     GIR_Done,
     /* 85164 */   // Label 2680: @85164
     /* 85164 */   GIM_Reject,
     /* 85165 */ // Label 2676: @85165
     /* 85165 */ GIM_Reject,
     /* 85166 */ // Label 2663: @85166
     /* 85166 */ GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(85308),
     /* 85171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 85174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 85177 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(85214), // Rule ID 891 //
     /* 85182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 85185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 85189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 85193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 85197 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (SUB_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 85197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64),
     /* 85202 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 85208 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 85212 */     GIR_RootConstrainSelectedInstOperands,
     /* 85213 */     // GIR_Coverage, 891,
     /* 85213 */     GIR_Done,
     /* 85214 */   // Label 2682: @85214
     /* 85214 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(85245), // Rule ID 2239 //
     /* 85219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 85222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 85226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 85230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 85234 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VSUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 85234 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDrr),
     /* 85239 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85243 */     GIR_RootConstrainSelectedInstOperands,
     /* 85244 */     // GIR_Coverage, 2239,
     /* 85244 */     GIR_Done,
     /* 85245 */   // Label 2683: @85245
     /* 85245 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(85276), // Rule ID 2247 //
     /* 85250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 85253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 85257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 85261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 85265 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (SUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 85265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSDrr),
     /* 85270 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85274 */     GIR_RootConstrainSelectedInstOperands,
     /* 85275 */     // GIR_Coverage, 2247,
     /* 85275 */     GIR_Done,
     /* 85276 */   // Label 2684: @85276
     /* 85276 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(85307), // Rule ID 6044 //
     /* 85281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 85284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 85288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 85292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 85296 */     // (strict_fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VSUBSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 85296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrr),
     /* 85301 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85305 */     GIR_RootConstrainSelectedInstOperands,
     /* 85306 */     // GIR_Coverage, 6044,
     /* 85306 */     GIR_Done,
     /* 85307 */   // Label 2685: @85307
     /* 85307 */   GIM_Reject,
     /* 85308 */ // Label 2681: @85308
     /* 85308 */ GIM_Reject,
     /* 85309 */ // Label 2664: @85309
     /* 85309 */ GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(85352), // Rule ID 893 //
     /* 85314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 85317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 85320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 85323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 85327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 85331 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 85335 */   // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (SUB_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 85335 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80),
     /* 85340 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 85346 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 85350 */   GIR_RootConstrainSelectedInstOperands,
     /* 85351 */   // GIR_Coverage, 893,
     /* 85351 */   GIR_Done,
     /* 85352 */ // Label 2686: @85352
     /* 85352 */ GIM_Reject,
     /* 85353 */ // Label 2665: @85353
     /* 85353 */ GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(85458),
     /* 85358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 85361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 85364 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(85395), // Rule ID 2215 //
     /* 85369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 85372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85384 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VSUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 85384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDrr),
     /* 85389 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85393 */     GIR_RootConstrainSelectedInstOperands,
     /* 85394 */     // GIR_Coverage, 2215,
     /* 85394 */     GIR_Done,
     /* 85395 */   // Label 2688: @85395
     /* 85395 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(85426), // Rule ID 2231 //
     /* 85400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 85403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85415 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (SUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 85415 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPDrr),
     /* 85420 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85424 */     GIR_RootConstrainSelectedInstOperands,
     /* 85425 */     // GIR_Coverage, 2231,
     /* 85425 */     GIR_Done,
     /* 85426 */   // Label 2689: @85426
     /* 85426 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(85457), // Rule ID 6535 //
     /* 85431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 85434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85446 */     // (strict_fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VSUBPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 85446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rr),
     /* 85451 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85455 */     GIR_RootConstrainSelectedInstOperands,
     /* 85456 */     // GIR_Coverage, 6535,
     /* 85456 */     GIR_Done,
     /* 85457 */   // Label 2690: @85457
     /* 85457 */   GIM_Reject,
     /* 85458 */ // Label 2687: @85458
     /* 85458 */ GIM_Reject,
     /* 85459 */ // Label 2666: @85459
     /* 85459 */ GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(85564),
     /* 85464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 85467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 85470 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(85501), // Rule ID 2211 //
     /* 85475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 85478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85490 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VSUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 85490 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSrr),
     /* 85495 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85499 */     GIR_RootConstrainSelectedInstOperands,
     /* 85500 */     // GIR_Coverage, 2211,
     /* 85500 */     GIR_Done,
     /* 85501 */   // Label 2692: @85501
     /* 85501 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(85532), // Rule ID 2227 //
     /* 85506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 85509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85521 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (SUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 85521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPSrr),
     /* 85526 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85530 */     GIR_RootConstrainSelectedInstOperands,
     /* 85531 */     // GIR_Coverage, 2227,
     /* 85531 */     GIR_Done,
     /* 85532 */   // Label 2693: @85532
     /* 85532 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(85563), // Rule ID 6511 //
     /* 85537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 85540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85552 */     // (strict_fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VSUBPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 85552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rr),
     /* 85557 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85561 */     GIR_RootConstrainSelectedInstOperands,
     /* 85562 */     // GIR_Coverage, 6511,
     /* 85562 */     GIR_Done,
     /* 85563 */   // Label 2694: @85563
     /* 85563 */   GIM_Reject,
     /* 85564 */ // Label 2691: @85564
     /* 85564 */ GIM_Reject,
     /* 85565 */ // Label 2667: @85565
     /* 85565 */ GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(85639),
     /* 85570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 85573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 85576 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(85607), // Rule ID 2223 //
     /* 85581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 85584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 85588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 85592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 85596 */     // (strict_fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VSUBPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 85596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrr),
     /* 85601 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85605 */     GIR_RootConstrainSelectedInstOperands,
     /* 85606 */     // GIR_Coverage, 2223,
     /* 85606 */     GIR_Done,
     /* 85607 */   // Label 2696: @85607
     /* 85607 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(85638), // Rule ID 6547 //
     /* 85612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 85615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 85619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 85623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 85627 */     // (strict_fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VSUBPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 85627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rr),
     /* 85632 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85636 */     GIR_RootConstrainSelectedInstOperands,
     /* 85637 */     // GIR_Coverage, 6547,
     /* 85637 */     GIR_Done,
     /* 85638 */   // Label 2697: @85638
     /* 85638 */   GIM_Reject,
     /* 85639 */ // Label 2695: @85639
     /* 85639 */ GIM_Reject,
     /* 85640 */ // Label 2668: @85640
     /* 85640 */ GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(85677), // Rule ID 6571 //
     /* 85645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 85648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 85651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 85654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85666 */   // (strict_fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VSUBPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 85666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rr),
     /* 85671 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85675 */   GIR_RootConstrainSelectedInstOperands,
     /* 85676 */   // GIR_Coverage, 6571,
     /* 85676 */   GIR_Done,
     /* 85677 */ // Label 2698: @85677
     /* 85677 */ GIM_Reject,
     /* 85678 */ // Label 2669: @85678
     /* 85678 */ GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(85752),
     /* 85683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 85686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 85689 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(85720), // Rule ID 2219 //
     /* 85694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 85697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 85701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 85705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 85709 */     // (strict_fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VSUBPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 85709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrr),
     /* 85714 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85718 */     GIR_RootConstrainSelectedInstOperands,
     /* 85719 */     // GIR_Coverage, 2219,
     /* 85719 */     GIR_Done,
     /* 85720 */   // Label 2700: @85720
     /* 85720 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(85751), // Rule ID 6523 //
     /* 85725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 85728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 85732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 85736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 85740 */     // (strict_fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VSUBPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 85740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rr),
     /* 85745 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85749 */     GIR_RootConstrainSelectedInstOperands,
     /* 85750 */     // GIR_Coverage, 6523,
     /* 85750 */     GIR_Done,
     /* 85751 */   // Label 2701: @85751
     /* 85751 */   GIM_Reject,
     /* 85752 */ // Label 2699: @85752
     /* 85752 */ GIM_Reject,
     /* 85753 */ // Label 2670: @85753
     /* 85753 */ GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(85790), // Rule ID 6499 //
     /* 85758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 85761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 85764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 85767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85779 */   // (strict_fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VSUBPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 85779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrr),
     /* 85784 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85788 */   GIR_RootConstrainSelectedInstOperands,
     /* 85789 */   // GIR_Coverage, 6499,
     /* 85789 */   GIR_Done,
     /* 85790 */ // Label 2702: @85790
     /* 85790 */ GIM_Reject,
     /* 85791 */ // Label 2671: @85791
     /* 85791 */ GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(85828), // Rule ID 6583 //
     /* 85796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 85799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 85802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 85805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 85809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 85813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 85817 */   // (strict_fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VSUBPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 85817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rr),
     /* 85822 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85826 */   GIR_RootConstrainSelectedInstOperands,
     /* 85827 */   // GIR_Coverage, 6583,
     /* 85827 */   GIR_Done,
     /* 85828 */ // Label 2703: @85828
     /* 85828 */ GIM_Reject,
     /* 85829 */ // Label 2672: @85829
     /* 85829 */ GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(85866), // Rule ID 6487 //
     /* 85834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 85837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 85840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 85843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85851 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85855 */   // (strict_fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VSUBPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 85855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrr),
     /* 85860 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85864 */   GIR_RootConstrainSelectedInstOperands,
     /* 85865 */   // GIR_Coverage, 6487,
     /* 85865 */   GIR_Done,
     /* 85866 */ // Label 2704: @85866
     /* 85866 */ GIM_Reject,
     /* 85867 */ // Label 2673: @85867
     /* 85867 */ GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(85904), // Rule ID 6559 //
     /* 85872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 85875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 85878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 85881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85893 */   // (strict_fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VSUBPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 85893 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrr),
     /* 85898 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85902 */   GIR_RootConstrainSelectedInstOperands,
     /* 85903 */   // GIR_Coverage, 6559,
     /* 85903 */   GIR_Done,
     /* 85904 */ // Label 2705: @85904
     /* 85904 */ GIM_Reject,
     /* 85905 */ // Label 2674: @85905
     /* 85905 */ GIM_Reject,
     /* 85906 */ // Label 63: @85906
     /* 85906 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2719*/ GIMT_Encode4(86921),
     /* 85917 */ /*GILLT_s16*//*Label 2706*/ GIMT_Encode4(86001),
     /* 85921 */ /*GILLT_s32*//*Label 2707*/ GIMT_Encode4(86039),
     /* 85925 */ /*GILLT_s64*//*Label 2708*/ GIMT_Encode4(86182),
     /* 85929 */ /*GILLT_s80*//*Label 2709*/ GIMT_Encode4(86325), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 85941 */ /*GILLT_v2s64*//*Label 2710*/ GIMT_Encode4(86369), GIMT_Encode4(0),
     /* 85949 */ /*GILLT_v4s32*//*Label 2711*/ GIMT_Encode4(86475),
     /* 85953 */ /*GILLT_v4s64*//*Label 2712*/ GIMT_Encode4(86581), GIMT_Encode4(0),
     /* 85961 */ /*GILLT_v8s16*//*Label 2713*/ GIMT_Encode4(86656),
     /* 85965 */ /*GILLT_v8s32*//*Label 2714*/ GIMT_Encode4(86694),
     /* 85969 */ /*GILLT_v8s64*//*Label 2715*/ GIMT_Encode4(86769), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 85981 */ /*GILLT_v16s16*//*Label 2716*/ GIMT_Encode4(86807),
     /* 85985 */ /*GILLT_v16s32*//*Label 2717*/ GIMT_Encode4(86845), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 85997 */ /*GILLT_v32s16*//*Label 2718*/ GIMT_Encode4(86883),
     /* 86001 */ // Label 2706: @86001
     /* 86001 */ GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(86038), // Rule ID 6006 //
     /* 86006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 86009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 86012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 86015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 86019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 86023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 86027 */   // (strict_fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VMULSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 86027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSHZrr),
     /* 86032 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86036 */   GIR_RootConstrainSelectedInstOperands,
     /* 86037 */   // GIR_Coverage, 6006,
     /* 86037 */   GIR_Done,
     /* 86038 */ // Label 2720: @86038
     /* 86038 */ GIM_Reject,
     /* 86039 */ // Label 2707: @86039
     /* 86039 */ GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(86181),
     /* 86044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 86047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 86050 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(86087), // Rule ID 895 //
     /* 86055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 86058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 86062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 86066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 86070 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (MUL_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 86070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32),
     /* 86075 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 86081 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 86085 */     GIR_RootConstrainSelectedInstOperands,
     /* 86086 */     // GIR_Coverage, 895,
     /* 86086 */     GIR_Done,
     /* 86087 */   // Label 2722: @86087
     /* 86087 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(86118), // Rule ID 2195 //
     /* 86092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 86095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 86099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 86103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 86107 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VMULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 86107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSrr),
     /* 86112 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86116 */     GIR_RootConstrainSelectedInstOperands,
     /* 86117 */     // GIR_Coverage, 2195,
     /* 86117 */     GIR_Done,
     /* 86118 */   // Label 2723: @86118
     /* 86118 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(86149), // Rule ID 2203 //
     /* 86123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 86126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 86130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 86134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 86138 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (MULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 86138 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSSrr),
     /* 86143 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86147 */     GIR_RootConstrainSelectedInstOperands,
     /* 86148 */     // GIR_Coverage, 2203,
     /* 86148 */     GIR_Done,
     /* 86149 */   // Label 2724: @86149
     /* 86149 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(86180), // Rule ID 5968 //
     /* 86154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 86157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 86161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 86165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 86169 */     // (strict_fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VMULSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 86169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSZrr),
     /* 86174 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86178 */     GIR_RootConstrainSelectedInstOperands,
     /* 86179 */     // GIR_Coverage, 5968,
     /* 86179 */     GIR_Done,
     /* 86180 */   // Label 2725: @86180
     /* 86180 */   GIM_Reject,
     /* 86181 */ // Label 2721: @86181
     /* 86181 */ GIM_Reject,
     /* 86182 */ // Label 2708: @86182
     /* 86182 */ GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(86324),
     /* 86187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 86190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 86193 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(86230), // Rule ID 897 //
     /* 86198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 86201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 86205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 86209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 86213 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (MUL_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 86213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64),
     /* 86218 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 86224 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 86228 */     GIR_RootConstrainSelectedInstOperands,
     /* 86229 */     // GIR_Coverage, 897,
     /* 86229 */     GIR_Done,
     /* 86230 */   // Label 2727: @86230
     /* 86230 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(86261), // Rule ID 2199 //
     /* 86235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 86238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 86242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 86246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 86250 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VMULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 86250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDrr),
     /* 86255 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86259 */     GIR_RootConstrainSelectedInstOperands,
     /* 86260 */     // GIR_Coverage, 2199,
     /* 86260 */     GIR_Done,
     /* 86261 */   // Label 2728: @86261
     /* 86261 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(86292), // Rule ID 2207 //
     /* 86266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 86269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 86273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 86277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 86281 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (MULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 86281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSDrr),
     /* 86286 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86290 */     GIR_RootConstrainSelectedInstOperands,
     /* 86291 */     // GIR_Coverage, 2207,
     /* 86291 */     GIR_Done,
     /* 86292 */   // Label 2729: @86292
     /* 86292 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(86323), // Rule ID 5987 //
     /* 86297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 86300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 86304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 86308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 86312 */     // (strict_fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VMULSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 86312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDZrr),
     /* 86317 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86321 */     GIR_RootConstrainSelectedInstOperands,
     /* 86322 */     // GIR_Coverage, 5987,
     /* 86322 */     GIR_Done,
     /* 86323 */   // Label 2730: @86323
     /* 86323 */   GIM_Reject,
     /* 86324 */ // Label 2726: @86324
     /* 86324 */ GIM_Reject,
     /* 86325 */ // Label 2709: @86325
     /* 86325 */ GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(86368), // Rule ID 899 //
     /* 86330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 86333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 86336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 86339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 86343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 86347 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 86351 */   // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (MUL_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 86351 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80),
     /* 86356 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 86362 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 86366 */   GIR_RootConstrainSelectedInstOperands,
     /* 86367 */   // GIR_Coverage, 899,
     /* 86367 */   GIR_Done,
     /* 86368 */ // Label 2731: @86368
     /* 86368 */ GIM_Reject,
     /* 86369 */ // Label 2710: @86369
     /* 86369 */ GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(86474),
     /* 86374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 86377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 86380 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(86411), // Rule ID 2175 //
     /* 86385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 86388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86400 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 86400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDrr),
     /* 86405 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86409 */     GIR_RootConstrainSelectedInstOperands,
     /* 86410 */     // GIR_Coverage, 2175,
     /* 86410 */     GIR_Done,
     /* 86411 */   // Label 2733: @86411
     /* 86411 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(86442), // Rule ID 2191 //
     /* 86416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 86419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86431 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (MULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 86431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPDrr),
     /* 86436 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86440 */     GIR_RootConstrainSelectedInstOperands,
     /* 86441 */     // GIR_Coverage, 2191,
     /* 86441 */     GIR_Done,
     /* 86442 */   // Label 2734: @86442
     /* 86442 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(86473), // Rule ID 6418 //
     /* 86447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 86450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86462 */     // (strict_fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VMULPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 86462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rr),
     /* 86467 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86471 */     GIR_RootConstrainSelectedInstOperands,
     /* 86472 */     // GIR_Coverage, 6418,
     /* 86472 */     GIR_Done,
     /* 86473 */   // Label 2735: @86473
     /* 86473 */   GIM_Reject,
     /* 86474 */ // Label 2732: @86474
     /* 86474 */ GIM_Reject,
     /* 86475 */ // Label 2711: @86475
     /* 86475 */ GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(86580),
     /* 86480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 86483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 86486 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(86517), // Rule ID 2171 //
     /* 86491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 86494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86506 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 86506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSrr),
     /* 86511 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86515 */     GIR_RootConstrainSelectedInstOperands,
     /* 86516 */     // GIR_Coverage, 2171,
     /* 86516 */     GIR_Done,
     /* 86517 */   // Label 2737: @86517
     /* 86517 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(86548), // Rule ID 2187 //
     /* 86522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 86525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86537 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (MULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 86537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPSrr),
     /* 86542 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86546 */     GIR_RootConstrainSelectedInstOperands,
     /* 86547 */     // GIR_Coverage, 2187,
     /* 86547 */     GIR_Done,
     /* 86548 */   // Label 2738: @86548
     /* 86548 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(86579), // Rule ID 6394 //
     /* 86553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 86556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86568 */     // (strict_fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VMULPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 86568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rr),
     /* 86573 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86577 */     GIR_RootConstrainSelectedInstOperands,
     /* 86578 */     // GIR_Coverage, 6394,
     /* 86578 */     GIR_Done,
     /* 86579 */   // Label 2739: @86579
     /* 86579 */   GIM_Reject,
     /* 86580 */ // Label 2736: @86580
     /* 86580 */ GIM_Reject,
     /* 86581 */ // Label 2712: @86581
     /* 86581 */ GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(86655),
     /* 86586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 86589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 86592 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(86623), // Rule ID 2183 //
     /* 86597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 86600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 86604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 86608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 86612 */     // (strict_fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMULPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 86612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDYrr),
     /* 86617 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86621 */     GIR_RootConstrainSelectedInstOperands,
     /* 86622 */     // GIR_Coverage, 2183,
     /* 86622 */     GIR_Done,
     /* 86623 */   // Label 2741: @86623
     /* 86623 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(86654), // Rule ID 6430 //
     /* 86628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 86631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86643 */     // (strict_fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VMULPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 86643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rr),
     /* 86648 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86652 */     GIR_RootConstrainSelectedInstOperands,
     /* 86653 */     // GIR_Coverage, 6430,
     /* 86653 */     GIR_Done,
     /* 86654 */   // Label 2742: @86654
     /* 86654 */   GIM_Reject,
     /* 86655 */ // Label 2740: @86655
     /* 86655 */ GIM_Reject,
     /* 86656 */ // Label 2713: @86656
     /* 86656 */ GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(86693), // Rule ID 6454 //
     /* 86661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 86664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 86667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 86670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86682 */   // (strict_fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VMULPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 86682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rr),
     /* 86687 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86691 */   GIR_RootConstrainSelectedInstOperands,
     /* 86692 */   // GIR_Coverage, 6454,
     /* 86692 */   GIR_Done,
     /* 86693 */ // Label 2743: @86693
     /* 86693 */ GIM_Reject,
     /* 86694 */ // Label 2714: @86694
     /* 86694 */ GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(86768),
     /* 86699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 86702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 86705 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(86736), // Rule ID 2179 //
     /* 86710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 86713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 86717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 86721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 86725 */     // (strict_fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMULPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 86725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSYrr),
     /* 86730 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86734 */     GIR_RootConstrainSelectedInstOperands,
     /* 86735 */     // GIR_Coverage, 2179,
     /* 86735 */     GIR_Done,
     /* 86736 */   // Label 2745: @86736
     /* 86736 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(86767), // Rule ID 6406 //
     /* 86741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 86744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86756 */     // (strict_fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VMULPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 86756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rr),
     /* 86761 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86765 */     GIR_RootConstrainSelectedInstOperands,
     /* 86766 */     // GIR_Coverage, 6406,
     /* 86766 */     GIR_Done,
     /* 86767 */   // Label 2746: @86767
     /* 86767 */   GIM_Reject,
     /* 86768 */ // Label 2744: @86768
     /* 86768 */ GIM_Reject,
     /* 86769 */ // Label 2715: @86769
     /* 86769 */ GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(86806), // Rule ID 6382 //
     /* 86774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 86777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 86780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 86783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86791 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86795 */   // (strict_fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VMULPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 86795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZrr),
     /* 86800 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86804 */   GIR_RootConstrainSelectedInstOperands,
     /* 86805 */   // GIR_Coverage, 6382,
     /* 86805 */   GIR_Done,
     /* 86806 */ // Label 2747: @86806
     /* 86806 */ GIM_Reject,
     /* 86807 */ // Label 2716: @86807
     /* 86807 */ GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(86844), // Rule ID 6466 //
     /* 86812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 86815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 86818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 86821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86833 */   // (strict_fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VMULPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 86833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rr),
     /* 86838 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86842 */   GIR_RootConstrainSelectedInstOperands,
     /* 86843 */   // GIR_Coverage, 6466,
     /* 86843 */   GIR_Done,
     /* 86844 */ // Label 2748: @86844
     /* 86844 */ GIM_Reject,
     /* 86845 */ // Label 2717: @86845
     /* 86845 */ GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(86882), // Rule ID 6370 //
     /* 86850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 86853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 86856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 86859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86871 */   // (strict_fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VMULPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 86871 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZrr),
     /* 86876 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86880 */   GIR_RootConstrainSelectedInstOperands,
     /* 86881 */   // GIR_Coverage, 6370,
     /* 86881 */   GIR_Done,
     /* 86882 */ // Label 2749: @86882
     /* 86882 */ GIM_Reject,
     /* 86883 */ // Label 2718: @86883
     /* 86883 */ GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(86920), // Rule ID 6442 //
     /* 86888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 86891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 86894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 86897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86905 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86909 */   // (strict_fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VMULPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 86909 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZrr),
     /* 86914 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86918 */   GIR_RootConstrainSelectedInstOperands,
     /* 86919 */   // GIR_Coverage, 6442,
     /* 86919 */   GIR_Done,
     /* 86920 */ // Label 2750: @86920
     /* 86920 */ GIM_Reject,
     /* 86921 */ // Label 2719: @86921
     /* 86921 */ GIM_Reject,
     /* 86922 */ // Label 64: @86922
     /* 86922 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2764*/ GIMT_Encode4(87937),
     /* 86933 */ /*GILLT_s16*//*Label 2751*/ GIMT_Encode4(87017),
     /* 86937 */ /*GILLT_s32*//*Label 2752*/ GIMT_Encode4(87055),
     /* 86941 */ /*GILLT_s64*//*Label 2753*/ GIMT_Encode4(87198),
     /* 86945 */ /*GILLT_s80*//*Label 2754*/ GIMT_Encode4(87341), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 86957 */ /*GILLT_v2s64*//*Label 2755*/ GIMT_Encode4(87385), GIMT_Encode4(0),
     /* 86965 */ /*GILLT_v4s32*//*Label 2756*/ GIMT_Encode4(87491),
     /* 86969 */ /*GILLT_v4s64*//*Label 2757*/ GIMT_Encode4(87597), GIMT_Encode4(0),
     /* 86977 */ /*GILLT_v8s16*//*Label 2758*/ GIMT_Encode4(87672),
     /* 86981 */ /*GILLT_v8s32*//*Label 2759*/ GIMT_Encode4(87710),
     /* 86985 */ /*GILLT_v8s64*//*Label 2760*/ GIMT_Encode4(87785), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 86997 */ /*GILLT_v16s16*//*Label 2761*/ GIMT_Encode4(87823),
     /* 87001 */ /*GILLT_v16s32*//*Label 2762*/ GIMT_Encode4(87861), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 87013 */ /*GILLT_v32s16*//*Label 2763*/ GIMT_Encode4(87899),
     /* 87017 */ // Label 2751: @87017
     /* 87017 */ GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(87054), // Rule ID 6120 //
     /* 87022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 87025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 87028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 87031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 87035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 87039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 87043 */   // (strict_fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VDIVSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 87043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrr),
     /* 87048 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87052 */   GIR_RootConstrainSelectedInstOperands,
     /* 87053 */   // GIR_Coverage, 6120,
     /* 87053 */   GIR_Done,
     /* 87054 */ // Label 2765: @87054
     /* 87054 */ GIM_Reject,
     /* 87055 */ // Label 2752: @87055
     /* 87055 */ GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(87197),
     /* 87060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 87063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 87066 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(87103), // Rule ID 901 //
     /* 87071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 87074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 87078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 87082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 87086 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (DIV_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 87086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32),
     /* 87091 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 87097 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 87101 */     GIR_RootConstrainSelectedInstOperands,
     /* 87102 */     // GIR_Coverage, 901,
     /* 87102 */     GIR_Done,
     /* 87103 */   // Label 2767: @87103
     /* 87103 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(87134), // Rule ID 2275 //
     /* 87108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 87111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 87115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 87119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 87123 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VDIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 87123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSrr),
     /* 87128 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87132 */     GIR_RootConstrainSelectedInstOperands,
     /* 87133 */     // GIR_Coverage, 2275,
     /* 87133 */     GIR_Done,
     /* 87134 */   // Label 2768: @87134
     /* 87134 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(87165), // Rule ID 2283 //
     /* 87139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 87142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 87146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 87150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 87154 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (DIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 87154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSSrr),
     /* 87159 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87163 */     GIR_RootConstrainSelectedInstOperands,
     /* 87164 */     // GIR_Coverage, 2283,
     /* 87164 */     GIR_Done,
     /* 87165 */   // Label 2769: @87165
     /* 87165 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(87196), // Rule ID 6082 //
     /* 87170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 87173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 87177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 87181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 87185 */     // (strict_fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VDIVSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 87185 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrr),
     /* 87190 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87194 */     GIR_RootConstrainSelectedInstOperands,
     /* 87195 */     // GIR_Coverage, 6082,
     /* 87195 */     GIR_Done,
     /* 87196 */   // Label 2770: @87196
     /* 87196 */   GIM_Reject,
     /* 87197 */ // Label 2766: @87197
     /* 87197 */ GIM_Reject,
     /* 87198 */ // Label 2753: @87198
     /* 87198 */ GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(87340),
     /* 87203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 87206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 87209 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(87246), // Rule ID 903 //
     /* 87214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 87217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 87221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 87225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 87229 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (DIV_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 87229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64),
     /* 87234 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 87240 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 87244 */     GIR_RootConstrainSelectedInstOperands,
     /* 87245 */     // GIR_Coverage, 903,
     /* 87245 */     GIR_Done,
     /* 87246 */   // Label 2772: @87246
     /* 87246 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(87277), // Rule ID 2279 //
     /* 87251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 87254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 87258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 87262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 87266 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VDIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 87266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDrr),
     /* 87271 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87275 */     GIR_RootConstrainSelectedInstOperands,
     /* 87276 */     // GIR_Coverage, 2279,
     /* 87276 */     GIR_Done,
     /* 87277 */   // Label 2773: @87277
     /* 87277 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(87308), // Rule ID 2287 //
     /* 87282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 87285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 87289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 87293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 87297 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (DIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 87297 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSDrr),
     /* 87302 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87306 */     GIR_RootConstrainSelectedInstOperands,
     /* 87307 */     // GIR_Coverage, 2287,
     /* 87307 */     GIR_Done,
     /* 87308 */   // Label 2774: @87308
     /* 87308 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(87339), // Rule ID 6101 //
     /* 87313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 87316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 87320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 87324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 87328 */     // (strict_fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VDIVSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 87328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrr),
     /* 87333 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87337 */     GIR_RootConstrainSelectedInstOperands,
     /* 87338 */     // GIR_Coverage, 6101,
     /* 87338 */     GIR_Done,
     /* 87339 */   // Label 2775: @87339
     /* 87339 */   GIM_Reject,
     /* 87340 */ // Label 2771: @87340
     /* 87340 */ GIM_Reject,
     /* 87341 */ // Label 2754: @87341
     /* 87341 */ GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(87384), // Rule ID 905 //
     /* 87346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 87349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 87352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 87355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 87359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 87363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 87367 */   // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (DIV_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 87367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80),
     /* 87372 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 87378 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 87382 */   GIR_RootConstrainSelectedInstOperands,
     /* 87383 */   // GIR_Coverage, 905,
     /* 87383 */   GIR_Done,
     /* 87384 */ // Label 2776: @87384
     /* 87384 */ GIM_Reject,
     /* 87385 */ // Label 2755: @87385
     /* 87385 */ GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(87490),
     /* 87390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 87393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 87396 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(87427), // Rule ID 2255 //
     /* 87401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 87404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87416 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VDIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 87416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDrr),
     /* 87421 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87425 */     GIR_RootConstrainSelectedInstOperands,
     /* 87426 */     // GIR_Coverage, 2255,
     /* 87426 */     GIR_Done,
     /* 87427 */   // Label 2778: @87427
     /* 87427 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(87458), // Rule ID 2271 //
     /* 87432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 87435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87447 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (DIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 87447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPDrr),
     /* 87452 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87456 */     GIR_RootConstrainSelectedInstOperands,
     /* 87457 */     // GIR_Coverage, 2271,
     /* 87457 */     GIR_Done,
     /* 87458 */   // Label 2779: @87458
     /* 87458 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(87489), // Rule ID 6652 //
     /* 87463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 87466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87478 */     // (strict_fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VDIVPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 87478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rr),
     /* 87483 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87487 */     GIR_RootConstrainSelectedInstOperands,
     /* 87488 */     // GIR_Coverage, 6652,
     /* 87488 */     GIR_Done,
     /* 87489 */   // Label 2780: @87489
     /* 87489 */   GIM_Reject,
     /* 87490 */ // Label 2777: @87490
     /* 87490 */ GIM_Reject,
     /* 87491 */ // Label 2756: @87491
     /* 87491 */ GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(87596),
     /* 87496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 87499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 87502 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(87533), // Rule ID 2251 //
     /* 87507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 87510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87522 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VDIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 87522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSrr),
     /* 87527 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87531 */     GIR_RootConstrainSelectedInstOperands,
     /* 87532 */     // GIR_Coverage, 2251,
     /* 87532 */     GIR_Done,
     /* 87533 */   // Label 2782: @87533
     /* 87533 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(87564), // Rule ID 2267 //
     /* 87538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 87541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87553 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (DIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 87553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPSrr),
     /* 87558 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87562 */     GIR_RootConstrainSelectedInstOperands,
     /* 87563 */     // GIR_Coverage, 2267,
     /* 87563 */     GIR_Done,
     /* 87564 */   // Label 2783: @87564
     /* 87564 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(87595), // Rule ID 6628 //
     /* 87569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 87572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87584 */     // (strict_fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VDIVPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 87584 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rr),
     /* 87589 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87593 */     GIR_RootConstrainSelectedInstOperands,
     /* 87594 */     // GIR_Coverage, 6628,
     /* 87594 */     GIR_Done,
     /* 87595 */   // Label 2784: @87595
     /* 87595 */   GIM_Reject,
     /* 87596 */ // Label 2781: @87596
     /* 87596 */ GIM_Reject,
     /* 87597 */ // Label 2757: @87597
     /* 87597 */ GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(87671),
     /* 87602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 87605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 87608 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(87639), // Rule ID 2263 //
     /* 87613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 87616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 87620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 87624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 87628 */     // (strict_fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VDIVPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 87628 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrr),
     /* 87633 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87637 */     GIR_RootConstrainSelectedInstOperands,
     /* 87638 */     // GIR_Coverage, 2263,
     /* 87638 */     GIR_Done,
     /* 87639 */   // Label 2786: @87639
     /* 87639 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(87670), // Rule ID 6664 //
     /* 87644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 87647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87659 */     // (strict_fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VDIVPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 87659 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rr),
     /* 87664 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87668 */     GIR_RootConstrainSelectedInstOperands,
     /* 87669 */     // GIR_Coverage, 6664,
     /* 87669 */     GIR_Done,
     /* 87670 */   // Label 2787: @87670
     /* 87670 */   GIM_Reject,
     /* 87671 */ // Label 2785: @87671
     /* 87671 */ GIM_Reject,
     /* 87672 */ // Label 2758: @87672
     /* 87672 */ GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(87709), // Rule ID 6688 //
     /* 87677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 87680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 87683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 87686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87698 */   // (strict_fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VDIVPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 87698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rr),
     /* 87703 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87707 */   GIR_RootConstrainSelectedInstOperands,
     /* 87708 */   // GIR_Coverage, 6688,
     /* 87708 */   GIR_Done,
     /* 87709 */ // Label 2788: @87709
     /* 87709 */ GIM_Reject,
     /* 87710 */ // Label 2759: @87710
     /* 87710 */ GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(87784),
     /* 87715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 87718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 87721 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(87752), // Rule ID 2259 //
     /* 87726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 87729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 87733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 87737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 87741 */     // (strict_fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VDIVPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 87741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrr),
     /* 87746 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87750 */     GIR_RootConstrainSelectedInstOperands,
     /* 87751 */     // GIR_Coverage, 2259,
     /* 87751 */     GIR_Done,
     /* 87752 */   // Label 2790: @87752
     /* 87752 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(87783), // Rule ID 6640 //
     /* 87757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 87760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87772 */     // (strict_fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VDIVPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 87772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rr),
     /* 87777 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87781 */     GIR_RootConstrainSelectedInstOperands,
     /* 87782 */     // GIR_Coverage, 6640,
     /* 87782 */     GIR_Done,
     /* 87783 */   // Label 2791: @87783
     /* 87783 */   GIM_Reject,
     /* 87784 */ // Label 2789: @87784
     /* 87784 */ GIM_Reject,
     /* 87785 */ // Label 2760: @87785
     /* 87785 */ GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(87822), // Rule ID 6616 //
     /* 87790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 87793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 87796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 87799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87807 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87811 */   // (strict_fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VDIVPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 87811 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrr),
     /* 87816 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87820 */   GIR_RootConstrainSelectedInstOperands,
     /* 87821 */   // GIR_Coverage, 6616,
     /* 87821 */   GIR_Done,
     /* 87822 */ // Label 2792: @87822
     /* 87822 */ GIM_Reject,
     /* 87823 */ // Label 2761: @87823
     /* 87823 */ GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(87860), // Rule ID 6700 //
     /* 87828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 87831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 87834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 87837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87849 */   // (strict_fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VDIVPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 87849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rr),
     /* 87854 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87858 */   GIR_RootConstrainSelectedInstOperands,
     /* 87859 */   // GIR_Coverage, 6700,
     /* 87859 */   GIR_Done,
     /* 87860 */ // Label 2793: @87860
     /* 87860 */ GIM_Reject,
     /* 87861 */ // Label 2762: @87861
     /* 87861 */ GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(87898), // Rule ID 6604 //
     /* 87866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 87869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 87872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 87875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87883 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87887 */   // (strict_fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VDIVPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 87887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrr),
     /* 87892 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87896 */   GIR_RootConstrainSelectedInstOperands,
     /* 87897 */   // GIR_Coverage, 6604,
     /* 87897 */   GIR_Done,
     /* 87898 */ // Label 2794: @87898
     /* 87898 */ GIM_Reject,
     /* 87899 */ // Label 2763: @87899
     /* 87899 */ GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(87936), // Rule ID 6676 //
     /* 87904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 87907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 87910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 87913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87925 */   // (strict_fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VDIVPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 87925 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrr),
     /* 87930 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87934 */   GIR_RootConstrainSelectedInstOperands,
     /* 87935 */   // GIR_Coverage, 6676,
     /* 87935 */   GIR_Done,
     /* 87936 */ // Label 2795: @87936
     /* 87936 */ GIM_Reject,
     /* 87937 */ // Label 2764: @87937
     /* 87937 */ GIM_Reject,
     /* 87938 */ // Label 65: @87938
     /* 87938 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2808*/ GIMT_Encode4(89065),
     /* 87949 */ /*GILLT_s16*//*Label 2796*/ GIMT_Encode4(88033),
     /* 87953 */ /*GILLT_s32*//*Label 2797*/ GIMT_Encode4(88080),
     /* 87957 */ /*GILLT_s64*//*Label 2798*/ GIMT_Encode4(88205), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 87973 */ /*GILLT_v2s64*//*Label 2799*/ GIMT_Encode4(88330), GIMT_Encode4(0),
     /* 87981 */ /*GILLT_v4s32*//*Label 2800*/ GIMT_Encode4(88455),
     /* 87985 */ /*GILLT_v4s64*//*Label 2801*/ GIMT_Encode4(88580), GIMT_Encode4(0),
     /* 87993 */ /*GILLT_v8s16*//*Label 2802*/ GIMT_Encode4(88705),
     /* 87997 */ /*GILLT_v8s32*//*Label 2803*/ GIMT_Encode4(88752),
     /* 88001 */ /*GILLT_v8s64*//*Label 2804*/ GIMT_Encode4(88877), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 88013 */ /*GILLT_v16s16*//*Label 2805*/ GIMT_Encode4(88924),
     /* 88017 */ /*GILLT_v16s32*//*Label 2806*/ GIMT_Encode4(88971), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 88029 */ /*GILLT_v32s16*//*Label 2807*/ GIMT_Encode4(89018),
     /* 88033 */ // Label 2796: @88033
     /* 88033 */ GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(88079), // Rule ID 10147 //
     /* 88038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 88041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 88044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 88047 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 88050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 88054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 88058 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 88062 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 88066 */   // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src3)  =>  (VFMADD213SHZr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src3)
     /* 88066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZr),
     /* 88069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88071 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88073 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88075 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88077 */   GIR_RootConstrainSelectedInstOperands,
     /* 88078 */   // GIR_Coverage, 10147,
     /* 88078 */   GIR_EraseRootFromParent_Done,
     /* 88079 */ // Label 2809: @88079
     /* 88079 */ GIM_Reject,
     /* 88080 */ // Label 2797: @88080
     /* 88080 */ GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(88204),
     /* 88085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 88088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 88091 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 88094 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(88131), // Rule ID 1294 //
     /* 88099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 88102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 88106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 88110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 88114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 88118 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADD213SSr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 88118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSr),
     /* 88121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88123 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88125 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88127 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88129 */     GIR_RootConstrainSelectedInstOperands,
     /* 88130 */     // GIR_Coverage, 1294,
     /* 88130 */     GIR_EraseRootFromParent_Done,
     /* 88131 */   // Label 2811: @88131
     /* 88131 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(88166), // Rule ID 1358 //
     /* 88136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 88139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 88143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 88147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 88151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 88155 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4rr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 88155 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rr),
     /* 88160 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88164 */     GIR_RootConstrainSelectedInstOperands,
     /* 88165 */     // GIR_Coverage, 1358,
     /* 88165 */     GIR_Done,
     /* 88166 */   // Label 2812: @88166
     /* 88166 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(88203), // Rule ID 10129 //
     /* 88171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 88174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 88178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 88182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 88186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 88190 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src3)  =>  (VFMADD213SSZr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src3)
     /* 88190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZr),
     /* 88193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88195 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88197 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88199 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88201 */     GIR_RootConstrainSelectedInstOperands,
     /* 88202 */     // GIR_Coverage, 10129,
     /* 88202 */     GIR_EraseRootFromParent_Done,
     /* 88203 */   // Label 2813: @88203
     /* 88203 */   GIM_Reject,
     /* 88204 */ // Label 2810: @88204
     /* 88204 */ GIM_Reject,
     /* 88205 */ // Label 2798: @88205
     /* 88205 */ GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(88329),
     /* 88210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 88213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 88216 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 88219 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(88256), // Rule ID 1302 //
     /* 88224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 88227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 88231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 88235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 88239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 88243 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADD213SDr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 88243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDr),
     /* 88246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88248 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88250 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88252 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88254 */     GIR_RootConstrainSelectedInstOperands,
     /* 88255 */     // GIR_Coverage, 1302,
     /* 88255 */     GIR_EraseRootFromParent_Done,
     /* 88256 */   // Label 2815: @88256
     /* 88256 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(88291), // Rule ID 1442 //
     /* 88261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 88264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 88268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 88272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 88276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 88280 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4rr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 88280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rr),
     /* 88285 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88289 */     GIR_RootConstrainSelectedInstOperands,
     /* 88290 */     // GIR_Coverage, 1442,
     /* 88290 */     GIR_Done,
     /* 88291 */   // Label 2816: @88291
     /* 88291 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(88328), // Rule ID 10138 //
     /* 88296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 88299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 88303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 88307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 88311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 88315 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src3)  =>  (VFMADD213SDZr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src3)
     /* 88315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZr),
     /* 88318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88320 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88322 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88324 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88326 */     GIR_RootConstrainSelectedInstOperands,
     /* 88327 */     // GIR_Coverage, 10138,
     /* 88327 */     GIR_EraseRootFromParent_Done,
     /* 88328 */   // Label 2817: @88328
     /* 88328 */   GIM_Reject,
     /* 88329 */ // Label 2814: @88329
     /* 88329 */ GIM_Reject,
     /* 88330 */ // Label 2799: @88330
     /* 88330 */ GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(88454),
     /* 88335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 88338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 88341 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 88344 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(88381), // Rule ID 1182 //
     /* 88349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 88352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88368 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 88368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDr),
     /* 88371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88373 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88375 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88377 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88379 */     GIR_RootConstrainSelectedInstOperands,
     /* 88380 */     // GIR_Coverage, 1182,
     /* 88380 */     GIR_EraseRootFromParent_Done,
     /* 88381 */   // Label 2819: @88381
     /* 88381 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(88416), // Rule ID 1466 //
     /* 88386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 88389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88405 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4rr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 88405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rr),
     /* 88410 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88414 */     GIR_RootConstrainSelectedInstOperands,
     /* 88415 */     // GIR_Coverage, 1466,
     /* 88415 */     GIR_Done,
     /* 88416 */   // Label 2820: @88416
     /* 88416 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(88453), // Rule ID 8506 //
     /* 88421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 88424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88440 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src3)
     /* 88440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128r),
     /* 88443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88445 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88447 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88449 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88451 */     GIR_RootConstrainSelectedInstOperands,
     /* 88452 */     // GIR_Coverage, 8506,
     /* 88452 */     GIR_EraseRootFromParent_Done,
     /* 88453 */   // Label 2821: @88453
     /* 88453 */   GIM_Reject,
     /* 88454 */ // Label 2818: @88454
     /* 88454 */ GIM_Reject,
     /* 88455 */ // Label 2800: @88455
     /* 88455 */ GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(88579),
     /* 88460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 88463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 88466 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 88469 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(88506), // Rule ID 1134 //
     /* 88474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 88477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88493 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 88493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSr),
     /* 88496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88498 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88500 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88502 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88504 */     GIR_RootConstrainSelectedInstOperands,
     /* 88505 */     // GIR_Coverage, 1134,
     /* 88505 */     GIR_EraseRootFromParent_Done,
     /* 88506 */   // Label 2823: @88506
     /* 88506 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(88541), // Rule ID 1382 //
     /* 88511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 88514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88530 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4rr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 88530 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rr),
     /* 88535 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88539 */     GIR_RootConstrainSelectedInstOperands,
     /* 88540 */     // GIR_Coverage, 1382,
     /* 88540 */     GIR_Done,
     /* 88541 */   // Label 2824: @88541
     /* 88541 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(88578), // Rule ID 8467 //
     /* 88546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 88549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88565 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src3)
     /* 88565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128r),
     /* 88568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88570 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88572 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88574 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88576 */     GIR_RootConstrainSelectedInstOperands,
     /* 88577 */     // GIR_Coverage, 8467,
     /* 88577 */     GIR_EraseRootFromParent_Done,
     /* 88578 */   // Label 2825: @88578
     /* 88578 */   GIM_Reject,
     /* 88579 */ // Label 2822: @88579
     /* 88579 */ GIM_Reject,
     /* 88580 */ // Label 2801: @88580
     /* 88580 */ GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(88704),
     /* 88585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 88588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 88591 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 88594 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(88631), // Rule ID 1190 //
     /* 88599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 88602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88618 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 88618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYr),
     /* 88621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88623 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88625 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88627 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88629 */     GIR_RootConstrainSelectedInstOperands,
     /* 88630 */     // GIR_Coverage, 1190,
     /* 88630 */     GIR_EraseRootFromParent_Done,
     /* 88631 */   // Label 2827: @88631
     /* 88631 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(88666), // Rule ID 1472 //
     /* 88636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 88639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88655 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Yrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 88655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrr),
     /* 88660 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88664 */     GIR_RootConstrainSelectedInstOperands,
     /* 88665 */     // GIR_Coverage, 1472,
     /* 88665 */     GIR_Done,
     /* 88666 */   // Label 2828: @88666
     /* 88666 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(88703), // Rule ID 8494 //
     /* 88671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 88674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88690 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src3)
     /* 88690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256r),
     /* 88693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88695 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88697 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88699 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88701 */     GIR_RootConstrainSelectedInstOperands,
     /* 88702 */     // GIR_Coverage, 8494,
     /* 88702 */     GIR_EraseRootFromParent_Done,
     /* 88703 */   // Label 2829: @88703
     /* 88703 */   GIM_Reject,
     /* 88704 */ // Label 2826: @88704
     /* 88704 */ GIM_Reject,
     /* 88705 */ // Label 2802: @88705
     /* 88705 */ GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(88751), // Rule ID 8428 //
     /* 88710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 88713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 88716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 88719 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 88722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88734 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88738 */   // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src3)  =>  (VFMADD213PHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src3)
     /* 88738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128r),
     /* 88741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88743 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88745 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88747 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88749 */   GIR_RootConstrainSelectedInstOperands,
     /* 88750 */   // GIR_Coverage, 8428,
     /* 88750 */   GIR_EraseRootFromParent_Done,
     /* 88751 */ // Label 2830: @88751
     /* 88751 */ GIM_Reject,
     /* 88752 */ // Label 2803: @88752
     /* 88752 */ GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(88876),
     /* 88757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 88760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 88763 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 88766 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(88803), // Rule ID 1142 //
     /* 88771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 88774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88790 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 88790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYr),
     /* 88793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88795 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88797 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88799 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88801 */     GIR_RootConstrainSelectedInstOperands,
     /* 88802 */     // GIR_Coverage, 1142,
     /* 88802 */     GIR_EraseRootFromParent_Done,
     /* 88803 */   // Label 2832: @88803
     /* 88803 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(88838), // Rule ID 1388 //
     /* 88808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 88811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88827 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Yrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 88827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrr),
     /* 88832 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88836 */     GIR_RootConstrainSelectedInstOperands,
     /* 88837 */     // GIR_Coverage, 1388,
     /* 88837 */     GIR_Done,
     /* 88838 */   // Label 2833: @88838
     /* 88838 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(88875), // Rule ID 8455 //
     /* 88843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 88846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88862 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src3)
     /* 88862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256r),
     /* 88865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88867 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88869 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88871 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88873 */     GIR_RootConstrainSelectedInstOperands,
     /* 88874 */     // GIR_Coverage, 8455,
     /* 88874 */     GIR_EraseRootFromParent_Done,
     /* 88875 */   // Label 2834: @88875
     /* 88875 */   GIM_Reject,
     /* 88876 */ // Label 2831: @88876
     /* 88876 */ GIM_Reject,
     /* 88877 */ // Label 2804: @88877
     /* 88877 */ GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(88923), // Rule ID 8479 //
     /* 88882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 88885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 88888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 88891 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 88894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 88898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 88902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 88906 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 88910 */   // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src3)  =>  (VFMADD213PDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src3)
     /* 88910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZr),
     /* 88913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88915 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88917 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88919 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88921 */   GIR_RootConstrainSelectedInstOperands,
     /* 88922 */   // GIR_Coverage, 8479,
     /* 88922 */   GIR_EraseRootFromParent_Done,
     /* 88923 */ // Label 2835: @88923
     /* 88923 */ GIM_Reject,
     /* 88924 */ // Label 2805: @88924
     /* 88924 */ GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(88970), // Rule ID 8416 //
     /* 88929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 88932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 88935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 88938 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 88941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88953 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88957 */   // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src3)  =>  (VFMADD213PHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src3)
     /* 88957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256r),
     /* 88960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88962 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88964 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88966 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88968 */   GIR_RootConstrainSelectedInstOperands,
     /* 88969 */   // GIR_Coverage, 8416,
     /* 88969 */   GIR_EraseRootFromParent_Done,
     /* 88970 */ // Label 2836: @88970
     /* 88970 */ GIM_Reject,
     /* 88971 */ // Label 2806: @88971
     /* 88971 */ GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(89017), // Rule ID 8440 //
     /* 88976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 88979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 88982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 88985 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 88988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 88992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 88996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89000 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89004 */   // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src3)  =>  (VFMADD213PSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src3)
     /* 89004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZr),
     /* 89007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89009 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 89011 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 89013 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 89015 */   GIR_RootConstrainSelectedInstOperands,
     /* 89016 */   // GIR_Coverage, 8440,
     /* 89016 */   GIR_EraseRootFromParent_Done,
     /* 89017 */ // Label 2837: @89017
     /* 89017 */ GIM_Reject,
     /* 89018 */ // Label 2807: @89018
     /* 89018 */ GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(89064), // Rule ID 8401 //
     /* 89023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 89026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 89029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 89032 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 89035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89047 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89051 */   // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src3)  =>  (VFMADD213PHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src3)
     /* 89051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZr),
     /* 89054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89056 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 89058 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 89060 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 89062 */   GIR_RootConstrainSelectedInstOperands,
     /* 89063 */   // GIR_Coverage, 8401,
     /* 89063 */   GIR_EraseRootFromParent_Done,
     /* 89064 */ // Label 2838: @89064
     /* 89064 */ GIM_Reject,
     /* 89065 */ // Label 2808: @89065
     /* 89065 */ GIM_Reject,
     /* 89066 */ // Label 66: @89066
     /* 89066 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2852*/ GIMT_Encode4(90017),
     /* 89077 */ /*GILLT_s16*//*Label 2839*/ GIMT_Encode4(89161),
     /* 89081 */ /*GILLT_s32*//*Label 2840*/ GIMT_Encode4(89207),
     /* 89085 */ /*GILLT_s64*//*Label 2841*/ GIMT_Encode4(89361),
     /* 89089 */ /*GILLT_s80*//*Label 2842*/ GIMT_Encode4(89515), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 89101 */ /*GILLT_v2s64*//*Label 2843*/ GIMT_Encode4(89552), GIMT_Encode4(0),
     /* 89109 */ /*GILLT_v4s32*//*Label 2844*/ GIMT_Encode4(89643),
     /* 89113 */ /*GILLT_v4s64*//*Label 2845*/ GIMT_Encode4(89734), GIMT_Encode4(0),
     /* 89121 */ /*GILLT_v8s16*//*Label 2846*/ GIMT_Encode4(89798),
     /* 89125 */ /*GILLT_v8s32*//*Label 2847*/ GIMT_Encode4(89829),
     /* 89129 */ /*GILLT_v8s64*//*Label 2848*/ GIMT_Encode4(89893), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 89141 */ /*GILLT_v16s16*//*Label 2849*/ GIMT_Encode4(89924),
     /* 89145 */ /*GILLT_v16s32*//*Label 2850*/ GIMT_Encode4(89955), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 89157 */ /*GILLT_v32s16*//*Label 2851*/ GIMT_Encode4(89986),
     /* 89161 */ // Label 2839: @89161
     /* 89161 */ GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(89206), // Rule ID 21865 //
     /* 89166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 89169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 89172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 89176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 89180 */   // (strict_fsqrt:{ *:[f16] } FR16X:{ *:[f16] }:$src)  =>  (VSQRTSHZr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR16X:{ *:[f16] }:$src)
     /* 89180 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 89183 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 89187 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 89192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 89194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZr),
     /* 89197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89199 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 89202 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 89204 */   GIR_RootConstrainSelectedInstOperands,
     /* 89205 */   // GIR_Coverage, 21865,
     /* 89205 */   GIR_EraseRootFromParent_Done,
     /* 89206 */ // Label 2853: @89206
     /* 89206 */ GIM_Reject,
     /* 89207 */ // Label 2840: @89207
     /* 89207 */ GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(89360),
     /* 89212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 89215 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(89248), // Rule ID 1045 //
     /* 89220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 89223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 89227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 89231 */     // (strict_fsqrt:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (SQRT_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 89231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp32),
     /* 89236 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 89242 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 89246 */     GIR_RootConstrainSelectedInstOperands,
     /* 89247 */     // GIR_Coverage, 1045,
     /* 89247 */     GIR_Done,
     /* 89248 */   // Label 2855: @89248
     /* 89248 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(89275), // Rule ID 2443 //
     /* 89253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 89256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 89260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 89264 */     // (strict_fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src1)  =>  (SQRTSSr:{ *:[f32] } FR32:{ *:[f32] }:$src1)
     /* 89264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSSr),
     /* 89269 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89273 */     GIR_RootConstrainSelectedInstOperands,
     /* 89274 */     // GIR_Coverage, 2443,
     /* 89274 */     GIR_Done,
     /* 89275 */   // Label 2856: @89275
     /* 89275 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(89317), // Rule ID 18721 //
     /* 89280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 89283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 89287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 89291 */     // (strict_fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src)  =>  (VSQRTSSr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32:{ *:[f32] }:$src)
     /* 89291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 89294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 89298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 89303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 89305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSr),
     /* 89308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 89313 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 89315 */     GIR_RootConstrainSelectedInstOperands,
     /* 89316 */     // GIR_Coverage, 18721,
     /* 89316 */     GIR_EraseRootFromParent_Done,
     /* 89317 */   // Label 2857: @89317
     /* 89317 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(89359), // Rule ID 21869 //
     /* 89322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 89325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 89329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 89333 */     // (strict_fsqrt:{ *:[f32] } FR32X:{ *:[f32] }:$src)  =>  (VSQRTSSZr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32X:{ *:[f32] }:$src)
     /* 89333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 89336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 89340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 89345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 89347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZr),
     /* 89350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 89355 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 89357 */     GIR_RootConstrainSelectedInstOperands,
     /* 89358 */     // GIR_Coverage, 21869,
     /* 89358 */     GIR_EraseRootFromParent_Done,
     /* 89359 */   // Label 2858: @89359
     /* 89359 */   GIM_Reject,
     /* 89360 */ // Label 2854: @89360
     /* 89360 */ GIM_Reject,
     /* 89361 */ // Label 2841: @89361
     /* 89361 */ GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(89514),
     /* 89366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 89369 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(89402), // Rule ID 1047 //
     /* 89374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 89377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 89381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 89385 */     // (strict_fsqrt:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (SQRT_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 89385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp64),
     /* 89390 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 89396 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 89400 */     GIR_RootConstrainSelectedInstOperands,
     /* 89401 */     // GIR_Coverage, 1047,
     /* 89401 */     GIR_Done,
     /* 89402 */   // Label 2860: @89402
     /* 89402 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(89429), // Rule ID 2459 //
     /* 89407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 89410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 89414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 89418 */     // (strict_fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src1)  =>  (SQRTSDr:{ *:[f64] } FR64:{ *:[f64] }:$src1)
     /* 89418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSDr),
     /* 89423 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89427 */     GIR_RootConstrainSelectedInstOperands,
     /* 89428 */     // GIR_Coverage, 2459,
     /* 89428 */     GIR_Done,
     /* 89429 */   // Label 2861: @89429
     /* 89429 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(89471), // Rule ID 18725 //
     /* 89434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 89437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 89441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 89445 */     // (strict_fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src)  =>  (VSQRTSDr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64:{ *:[f64] }:$src)
     /* 89445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 89448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 89452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 89457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 89459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDr),
     /* 89462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 89467 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 89469 */     GIR_RootConstrainSelectedInstOperands,
     /* 89470 */     // GIR_Coverage, 18725,
     /* 89470 */     GIR_EraseRootFromParent_Done,
     /* 89471 */   // Label 2862: @89471
     /* 89471 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(89513), // Rule ID 21873 //
     /* 89476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 89479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 89483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 89487 */     // (strict_fsqrt:{ *:[f64] } FR64X:{ *:[f64] }:$src)  =>  (VSQRTSDZr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64X:{ *:[f64] }:$src)
     /* 89487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 89490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 89494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 89499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 89501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZr),
     /* 89504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 89509 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 89511 */     GIR_RootConstrainSelectedInstOperands,
     /* 89512 */     // GIR_Coverage, 21873,
     /* 89512 */     GIR_EraseRootFromParent_Done,
     /* 89513 */   // Label 2863: @89513
     /* 89513 */   GIM_Reject,
     /* 89514 */ // Label 2859: @89514
     /* 89514 */ GIM_Reject,
     /* 89515 */ // Label 2842: @89515
     /* 89515 */ GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(89551), // Rule ID 1049 //
     /* 89520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 89523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 89526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 89530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 89534 */   // (strict_fsqrt:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (SQRT_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 89534 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp80),
     /* 89539 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 89545 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 89549 */   GIR_RootConstrainSelectedInstOperands,
     /* 89550 */   // GIR_Coverage, 1049,
     /* 89550 */   GIR_Done,
     /* 89551 */ // Label 2864: @89551
     /* 89551 */ GIM_Reject,
     /* 89552 */ // Label 2843: @89552
     /* 89552 */ GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(89642),
     /* 89557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 89560 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(89587), // Rule ID 2463 //
     /* 89565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 89568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 89572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 89576 */     // (strict_fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (VSQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 89576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDr),
     /* 89581 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89585 */     GIR_RootConstrainSelectedInstOperands,
     /* 89586 */     // GIR_Coverage, 2463,
     /* 89586 */     GIR_Done,
     /* 89587 */   // Label 2866: @89587
     /* 89587 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(89614), // Rule ID 2471 //
     /* 89592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 89595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 89599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 89603 */     // (strict_fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (SQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 89603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPDr),
     /* 89608 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89612 */     GIR_RootConstrainSelectedInstOperands,
     /* 89613 */     // GIR_Coverage, 2471,
     /* 89613 */     GIR_Done,
     /* 89614 */   // Label 2867: @89614
     /* 89614 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(89641), // Rule ID 12079 //
     /* 89619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 89622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 89626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 89630 */     // (strict_fsqrt:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)  =>  (VSQRTPDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)
     /* 89630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128r),
     /* 89635 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89639 */     GIR_RootConstrainSelectedInstOperands,
     /* 89640 */     // GIR_Coverage, 12079,
     /* 89640 */     GIR_Done,
     /* 89641 */   // Label 2868: @89641
     /* 89641 */   GIM_Reject,
     /* 89642 */ // Label 2865: @89642
     /* 89642 */ GIM_Reject,
     /* 89643 */ // Label 2844: @89643
     /* 89643 */ GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(89733),
     /* 89648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 89651 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(89678), // Rule ID 2447 //
     /* 89656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 89659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 89663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 89667 */     // (strict_fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (VSQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 89667 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSr),
     /* 89672 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89676 */     GIR_RootConstrainSelectedInstOperands,
     /* 89677 */     // GIR_Coverage, 2447,
     /* 89677 */     GIR_Done,
     /* 89678 */   // Label 2870: @89678
     /* 89678 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(89705), // Rule ID 2455 //
     /* 89683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 89686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 89690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 89694 */     // (strict_fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (SQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 89694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPSr),
     /* 89699 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89703 */     GIR_RootConstrainSelectedInstOperands,
     /* 89704 */     // GIR_Coverage, 2455,
     /* 89704 */     GIR_Done,
     /* 89705 */   // Label 2871: @89705
     /* 89705 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(89732), // Rule ID 12055 //
     /* 89710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 89713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 89717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 89721 */     // (strict_fsqrt:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)  =>  (VSQRTPSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)
     /* 89721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128r),
     /* 89726 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89730 */     GIR_RootConstrainSelectedInstOperands,
     /* 89731 */     // GIR_Coverage, 12055,
     /* 89731 */     GIR_Done,
     /* 89732 */   // Label 2872: @89732
     /* 89732 */   GIM_Reject,
     /* 89733 */ // Label 2869: @89733
     /* 89733 */ GIM_Reject,
     /* 89734 */ // Label 2845: @89734
     /* 89734 */ GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(89797),
     /* 89739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 89742 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(89769), // Rule ID 2467 //
     /* 89747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 89750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 89754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 89758 */     // (strict_fsqrt:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)  =>  (VSQRTPDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 89758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYr),
     /* 89763 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89767 */     GIR_RootConstrainSelectedInstOperands,
     /* 89768 */     // GIR_Coverage, 2467,
     /* 89768 */     GIR_Done,
     /* 89769 */   // Label 2874: @89769
     /* 89769 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(89796), // Rule ID 12091 //
     /* 89774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 89777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89785 */     // (strict_fsqrt:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)  =>  (VSQRTPDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)
     /* 89785 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256r),
     /* 89790 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89794 */     GIR_RootConstrainSelectedInstOperands,
     /* 89795 */     // GIR_Coverage, 12091,
     /* 89795 */     GIR_Done,
     /* 89796 */   // Label 2875: @89796
     /* 89796 */   GIM_Reject,
     /* 89797 */ // Label 2873: @89797
     /* 89797 */ GIM_Reject,
     /* 89798 */ // Label 2846: @89798
     /* 89798 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(89828), // Rule ID 12007 //
     /* 89803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 89806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 89809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 89813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 89817 */   // (strict_fsqrt:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)  =>  (VSQRTPHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)
     /* 89817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128r),
     /* 89822 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89826 */   GIR_RootConstrainSelectedInstOperands,
     /* 89827 */   // GIR_Coverage, 12007,
     /* 89827 */   GIR_Done,
     /* 89828 */ // Label 2876: @89828
     /* 89828 */ GIM_Reject,
     /* 89829 */ // Label 2847: @89829
     /* 89829 */ GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(89892),
     /* 89834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 89837 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(89864), // Rule ID 2451 //
     /* 89842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 89845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 89849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 89853 */     // (strict_fsqrt:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)  =>  (VSQRTPSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 89853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYr),
     /* 89858 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89862 */     GIR_RootConstrainSelectedInstOperands,
     /* 89863 */     // GIR_Coverage, 2451,
     /* 89863 */     GIR_Done,
     /* 89864 */   // Label 2878: @89864
     /* 89864 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(89891), // Rule ID 12067 //
     /* 89869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 89872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89880 */     // (strict_fsqrt:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)  =>  (VSQRTPSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)
     /* 89880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256r),
     /* 89885 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89889 */     GIR_RootConstrainSelectedInstOperands,
     /* 89890 */     // GIR_Coverage, 12067,
     /* 89890 */     GIR_Done,
     /* 89891 */   // Label 2879: @89891
     /* 89891 */   GIM_Reject,
     /* 89892 */ // Label 2877: @89892
     /* 89892 */ GIM_Reject,
     /* 89893 */ // Label 2848: @89893
     /* 89893 */ GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(89923), // Rule ID 12043 //
     /* 89898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 89901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 89904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89912 */   // (strict_fsqrt:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)  =>  (VSQRTPDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)
     /* 89912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZr),
     /* 89917 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89921 */   GIR_RootConstrainSelectedInstOperands,
     /* 89922 */   // GIR_Coverage, 12043,
     /* 89922 */   GIR_Done,
     /* 89923 */ // Label 2880: @89923
     /* 89923 */ GIM_Reject,
     /* 89924 */ // Label 2849: @89924
     /* 89924 */ GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(89954), // Rule ID 12019 //
     /* 89929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 89932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 89935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89943 */   // (strict_fsqrt:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)  =>  (VSQRTPHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)
     /* 89943 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256r),
     /* 89948 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89952 */   GIR_RootConstrainSelectedInstOperands,
     /* 89953 */   // GIR_Coverage, 12019,
     /* 89953 */   GIR_Done,
     /* 89954 */ // Label 2881: @89954
     /* 89954 */ GIM_Reject,
     /* 89955 */ // Label 2850: @89955
     /* 89955 */ GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(89985), // Rule ID 12031 //
     /* 89960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 89963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 89966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89974 */   // (strict_fsqrt:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)  =>  (VSQRTPSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)
     /* 89974 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZr),
     /* 89979 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89983 */   GIR_RootConstrainSelectedInstOperands,
     /* 89984 */   // GIR_Coverage, 12031,
     /* 89984 */   GIR_Done,
     /* 89985 */ // Label 2882: @89985
     /* 89985 */ GIM_Reject,
     /* 89986 */ // Label 2851: @89986
     /* 89986 */ GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(90016), // Rule ID 11995 //
     /* 89991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 89994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 89997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 90001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 90005 */   // (strict_fsqrt:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)  =>  (VSQRTPHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)
     /* 90005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZr),
     /* 90010 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 90014 */   GIR_RootConstrainSelectedInstOperands,
     /* 90015 */   // GIR_Coverage, 11995,
     /* 90015 */   GIR_Done,
     /* 90016 */ // Label 2883: @90016
     /* 90016 */ GIM_Reject,
     /* 90017 */ // Label 2852: @90017
     /* 90017 */ GIM_Reject,
     /* 90018 */ // Label 67: @90018
     /* 90018 */ GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(90030), // Rule ID 17521 //
     /* 90023 */   // (trap)  =>  (TRAP)
     /* 90023 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TRAP),
     /* 90028 */   GIR_RootConstrainSelectedInstOperands,
     /* 90029 */   // GIR_Coverage, 17521,
     /* 90029 */   GIR_Done,
     /* 90030 */ // Label 2884: @90030
     /* 90030 */ GIM_Reject,
     /* 90031 */ // Label 68: @90031
     /* 90031 */ GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(90046), // Rule ID 22803 //
     /* 90036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotPS),
     /* 90039 */   // (debugtrap)  =>  (INT3)
     /* 90039 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::INT3),
     /* 90044 */   GIR_RootConstrainSelectedInstOperands,
     /* 90045 */   // GIR_Coverage, 22803,
     /* 90045 */   GIR_Done,
     /* 90046 */ // Label 2885: @90046
     /* 90046 */ GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(90066), // Rule ID 22804 //
     /* 90051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsPS),
     /* 90054 */   // (debugtrap)  =>  (INT 65:{ *:[i8] })
     /* 90054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT),
     /* 90057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/65,
     /* 90060 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 90064 */   GIR_RootConstrainSelectedInstOperands,
     /* 90065 */   // GIR_Coverage, 22804,
     /* 90065 */   GIR_EraseRootFromParent_Done,
     /* 90066 */ // Label 2886: @90066
     /* 90066 */ GIM_Reject,
     /* 90067 */ // Label 69: @90067
     /* 90067 */ GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(90082), // Rule ID 17523 //
     /* 90072 */   // MIs[0] kind
     /* 90072 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 90075 */   // (ubsantrap (timm:{ *:[i32] }):$kind)  =>  (UBSAN_UD1 (timm:{ *:[i32] }):$kind)
     /* 90075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::UBSAN_UD1),
     /* 90080 */   GIR_RootConstrainSelectedInstOperands,
     /* 90081 */   // GIR_Coverage, 17523,
     /* 90081 */   GIR_Done,
     /* 90082 */ // Label 2887: @90082
     /* 90082 */ GIM_Reject,
     /* 90083 */ // Label 70: @90083
     /* 90083 */ GIM_Reject,
     /* 90084 */ }; // Size: 90084 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const X86Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const X86Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
